BagWindow = class(Turbine.UI.Lotro.Window)
function BagWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor(self)

	self.ListBoxes = {}
	self.ItemCounts = {}
	self.items = {}

	self.callbacks = {}

	self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
	self.backpack = self.player:GetBackpack()

	-- Armour swapping
	self.equipment = self.player:GetEquipment()
	self.allArmourIndices = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15}
	self.armourIndices = {1, 2, 3, 4, 5, 6, 7}
	self.jewelleryIndices = {8, 9, 10, 11, 12, 13, 14, 15}
	self.weaponIndices = {16, 17, 18, 20}

	self.UserCategories = Settings.UserCategories

	self.UserCategoriesLUT = {} 

	for key, value in pairs(self.UserCategories) do
		self.UserCategoriesLUT[value.CategoryName] = true
	end

	self.setAmount = Settings.MiscAmount

	for key, value in pairs(ItemGroups) do
		if not(self.setAmount[key]) then self.setAmount[key] = 5 end
	end

	for key, value in pairs(self.UserCategoriesLUT) do
		self.setAmount[key] = 1
	end


	self:SetPosition(Settings.BagX, Settings.BagY)
	self:SetSize( Settings.BagWidth, Settings.BagHeight)
	self:SetText("Prime Bag")
    --self:SetOpacity(1)
	self:SetVisible(false)
	self:SetResizable(true)

	self.SizeChanged = function()
		self:PerformLayout()
	end

	
	self.resizer = Resizer(self)

	-- Handle bag shortcut
	self:SetWantsKeyEvents( true )
	self.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			self:SetVisible( false ) 
		end

		if ( args.Action == Turbine.UI.Lotro.Action.ToggleBags or
		     args.Action == Turbine.UI.Lotro.Action.ToggleBag1 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag2 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag3 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag4 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag5 )
		then
			self:SetVisible( not self:IsVisible() ) 
			if self:IsVisible() then 
				self:Focus() 
				--self:SetZOrder(100)
			end
		end
	end

	self.itemListBoxScrollBar = Turbine.UI.Lotro.ScrollBar()
	self.itemListBoxScrollBar:SetOrientation(Turbine.UI.Orientation.Vertical)
	self.itemListBoxScrollBar:SetParent(self)

	self.itemListBox = Turbine.UI.ListBox()
	self.itemListBox:SetParent(self)
	self.itemListBox:SetOrientation(Turbine.UI.Orientation.Horizontal)
	self.itemListBox:SetVerticalScrollBar(self.itemListBoxScrollBar)
	self.itemListBox:SetAllowDrop(true)

	self.itemListBox.DragDrop = function(sender, args)
		self:PerformDragDrop(args)
	end

	self.Walletbar = WalletBar(self)

	-- Refresh button

	--0x4100024F
	--0x41000250
	--0x41000251
	--0x41000252
	self.SettingsButton = Turbine.UI.Control()
	self.SettingsButton:SetParent(self)
	self.SettingsButton:SetSize(25, 25)
	self.SettingsButton:SetPosition(self:GetWidth() - 50, 20)
	self.SettingsButton:SetBlendMode(Turbine.UI.BlendMode.Overlay)
	--self.SettingsButton:SetBackground(0x41000250)
	self.SettingsButton:SetBackground(0x410DA93B)

	self.searchBar = Turbine.UI.Lotro.TextBox()
	self.searchBar:SetParent(self)
	self.searchBar:SetSize(150, 20)
	self.searchBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.searchBar:SetPosition(self:GetWidth() - 200, 20)

	self.ReloadPluginButton = Turbine.UI.Control()
	self.ReloadPluginButton:SetParent(self)
	self.ReloadPluginButton:SetSize(20, 20)
	self.ReloadPluginButton:SetPosition(self:GetWidth() - 230, 20)
	self.ReloadPluginButton:SetBlendMode(Turbine.UI.BlendMode.Overlay)
	self.ReloadPluginButton:SetBackground(0x41000250)

	self.StackButton = Turbine.UI.Control()
	self.StackButton:SetParent(self)
	self.StackButton:SetSize(20, 20)
	self.StackButton:SetPosition(self:GetWidth() - 260, 20)
	self.StackButton:SetBlendMode(Turbine.UI.BlendMode.Overlay)
	--self.StackButton:SetBackground(0x41007F7B)
	self.StackButton:SetBackground(0x4114B0F0)
	

	self.ArmourButton = Turbine.UI.Control()
	self.ArmourButton:SetParent(self)
	self.ArmourButton:SetSize(20, 20)
	self.ArmourButton:SetPosition(self:GetWidth() - 290, 20)
	self.ArmourButton:SetBlendMode(Turbine.UI.BlendMode.Overlay)
	--self.ArmourButton:SetBackground(0x41140FA6)
	self.ArmourButton:SetBackground(0x41142C8A)

	self.searchBar.TextChanged = function()
		local text = tostring(self.searchBar:GetText())
			if text then
				if string.len(text) > 0 then
				for _, value in pairs(self.items) do
					local match = string.find(string.lower(value:GetName()), string.lower(text) )
					value:Toggle(match)
					if string.len(text) > 1 then
						value:Highlight(match)
					else
						value:Highlight(false)
					end
				end
			else
				for _, value in pairs(self.items) do
					value:Toggle(true)
					value:Highlight(false)
				end
			end
		end
	end

	self:BuildBag()

	self.callbacks["SizeChanged"] = AddCallback(self.backpack, "SizeChanged", function(sender, args) ReloadPlugin() end)

	self.callbacks["ItemAdded"] = AddCallback(self.backpack, "ItemAdded", function(sender, args) 
		local item = self.backpack:GetItem(args.Index)
		local category = self.UserCategories[item:GetName()] and self.UserCategories[item:GetName()].CategoryName or ItemLUT[item:GetItemInfo():GetCategory()]
		local iCategory = category

		if category == nil then
			category = "Undefined"
			iCategory = "Undefined"
		end

		if self.ListBoxes[category] == nil then 
			category = "Miscellaneous"
			if self.ListBoxes["Miscellaneous"] == nil then self:AddNewCategory("Miscellaneous") end
		end

		local prevCategory = self.items[args.Index]:GetCategory()

		if prevCategory == nil then
			prevCategory = "Undefined"
		end

		if prevCategory ~= "Empty Slot" and not(self.UserCategories[self.items[args.Index]:GetName()]) and self.ItemCounts[prevCategory] < self.setAmount[prevCategory] then
			prevCategory = "Miscellaneous"
		end

		if self.ListBoxes[category] and self.ListBoxes[category]:ContainsItem(item) then
			return
		elseif self.ListBoxes[prevCategory]:ContainsItem(self.items[args.Index]) then
			self.ListBoxes[prevCategory]:RemoveItem(self.items[args.Index])
		end

		if not(self.ListBoxes[category]:ContainsItem(self.items[args.Index])) and not(self.ListBoxes[prevCategory]:ContainsItem(self.items[args.Index])) then
			self.ListBoxes[category]:AddItem(self.items[args.Index])
		end

		self.items[args.Index]:SetCategory(iCategory)
		self.items[args.Index]:SetItem(item) 

		-- Update the count of this category
		if iCategory then 
			if not(self.ItemCounts[iCategory]) then self.ItemCounts[iCategory] = 1 else self.ItemCounts[iCategory] = self.ItemCounts[iCategory] + 1 end
			if (self.UserCategoriesLUT[iCategory] or self.ItemCounts[iCategory] >= self.setAmount[iCategory]) and not(self.ListBoxes[iCategory]) then
				self:AddNewCategory(iCategory)
			end
		end

		if category ~= "Empty Slot" and self.ItemCounts[iCategory] < 1 then self:EmptyCategory(iCategory) end
		if prevCategory ~= "Empty Slot" and self.ItemCounts[prevCategory] < 1 then self:EmptyCategory(prevCategory) end
		if self.ListBoxes[category] then self.ListBoxes[category]:Sort() end
	end)

	self.callbacks["ItemRemoved"] = AddCallback(self.backpack, "ItemRemoved", function(sender, args) 
		local category = self.items[args.Index]:GetCategory()
		local removeCategory = category

		if category == nil then
			category = "Undefined"
		end

		if removeCategory == nil then
			removeCategory = "Undefined"
		end

		if category ~= "Empty Slot" and self.ItemCounts[category] < self.setAmount[category]  then
			removeCategory = "Miscellaneous"
		end

		
		if not(self.ListBoxes[removeCategory]:ContainsItem(self.items[args.Index])) then
			return
		end

		self.ListBoxes[removeCategory]:RemoveItem(self.items[args.Index])

		-- Update the category of this slot and the count of the category
		if category then 
			self.ItemCounts[category] = self.ItemCounts[category] - 1
			--self.ItemCounts["Empty Slot"] = self.ItemCounts["Empty Slot"] + 1
			if category ~= "Empty Slot" and self.ItemCounts[category] < self.setAmount[category] and self.ListBoxes[category] then
				self:EmptyCategory(category)
			end
		end
		
		self.items[args.Index]:SetItem(nil) 
		self.items[args.Index]:SetCategory("Empty Slot")
		self.ListBoxes["Empty Slot"]:AddItem(self.items[args.Index])
	end)

	self.callbacks["ItemMoved"] = AddCallback(self.backpack, "ItemMoved", function(sender, args)
		local categoryOrigin = self.items[args.OldIndex]:GetCategory()
		local categoryDestination = self.items[args.NewIndex]:GetCategory()

		if self.items[args.OldIndex]:GetName() == self.items[args.NewIndex]:GetName() then
			self.ItemCounts[categoryDestination] = self.ItemCounts[categoryDestination] - 1 
			if categoryDestination ~= "Empty Slot" and self.ItemCounts[categoryDestination] < self.setAmount[categoryDestination] and self.ListBoxes[categoryDestination] then 
				self:EmptyCategory(categoryDestination) 
			end
		end

		if not(self.ListBoxes[categoryOrigin]) then categoryOrigin = "Miscellaneous" end
		if not(self.ListBoxes[categoryDestination]) then categoryDestination = "Miscellaneous" end

		self.ListBoxes[categoryOrigin]:RemoveItem(self.items[args.OldIndex])
		self.ListBoxes[categoryDestination]:RemoveItem(self.items[args.NewIndex])

		local oldItem = self.backpack:GetItem(args.OldIndex)
		local newItem = self.backpack:GetItem(args.NewIndex)

		local oldCategory
		local iOldCategory
		if oldItem then
			oldCategory = self.UserCategories[oldItem:GetName()] and self.UserCategories[oldItem:GetName()].CategoryName or ItemLUT[oldItem:GetItemInfo():GetCategory()]
			iOldCategory = oldCategory
			if self.ListBoxes[oldCategory] == nil then 
				oldCategory = "Miscellaneous" 
			end
		else
			oldCategory = "Empty Slot"
			iOldCategory = "Empty Slot"
		end

		local newCategory
		local iNewCategory
		if newItem then
			newCategory	= self.UserCategories[newItem:GetName()] and self.UserCategories[newItem:GetName()].CategoryName or ItemLUT[newItem:GetItemInfo():GetCategory()]
			iNewCategory = newCategory
			if self.ListBoxes[newCategory] == nil then 
				newCategory = "Miscellaneous" 
			end
		else
			newCategory = "Empty Slot"
			iNewCategory = "Empty Slot"
		end

		--if not(self.ListBoxes[oldCategory]) then oldCategory = "Miscellaneous" end
		--if not(self.ListBoxes[newCategory]) then newCategory = "Miscellaneous" end


		self.items[args.OldIndex]:SetCategory(iOldCategory)
		self.items[args.OldIndex]:SetItem(oldItem) 

		self.items[args.NewIndex]:SetCategory(iNewCategory)
		self.items[args.NewIndex]:SetItem(newItem) 

		self.ListBoxes[oldCategory]:AddItem(self.items[args.OldIndex])
		self.ListBoxes[newCategory]:AddItem(self.items[args.NewIndex])
	end)

	self.sortBag = function()
		self.itemListBox:Sort(function(a, b) return a:GetItemCount() > b:GetItemCount() end)
	end

	-- [[
	self.VisibleChanged = function()
		if self:IsVisible() then self:Activate() else self.sortBag() end
		for category, listbox in pairs(self.ListBoxes) do
			if category ~= "Empty Slot" and listbox:GetItemCount() < self.setAmount[category] and self.ListBoxes[category] then
				self:EmptyCategory(category)
			end
		end
	end
	--]]
	
	self.ReloadPluginButton.MouseEnter = function()
		self.ReloadPluginButton:SetBackground(0x4100024F)
	end
	
	self.ReloadPluginButton.MouseLeave = function()
		self.ReloadPluginButton:SetBackground(0x41000250)
	end

	self.ReloadPluginButton.MouseClick = function()
		self:BuildBag()
		self.Walletbar:Refresh()
	end

	self.ReloadPluginButton.MouseClick = function()
		ReloadPlugin()
	end

	self.SettingsButton.MouseClick = function()
		if Options == nil then
            Options = OptionOptions()
        else
            Options:SetVisible(not(Options:IsVisible()))
        end
	end

	self.StackButton.MouseClick = function()
		local currentIndex = 0
		local iterations = 0
		for i = currentIndex, self.backpack:GetSize() do
			local item = self.backpack:GetItem(i)	
			if item and item:GetItemInfo():GetMaxStackSize() > 1 then
				local itemName = item:GetName()
				for j = currentIndex + 1, self.backpack:GetSize() do
					local compareItem = self.backpack:GetItem(j)
					if compareItem and compareItem:GetName() == itemName then
						ChatOutput(string.format("Attempting to combine %s at %i and %i.", itemName, i, j))
						self.backpack:PerformItemDrop(item, j, false)
					end
					iterations = iterations + 1
					
				end
			end
			currentIndex = currentIndex + 1
		end
		ChatOutput(string.format("%i item comparisons made!", iterations))
	end

	self.ArmourButton.MouseClick = function()
		local indices, freeSlots = self.ListBoxes["Empty Slot"]:GetAllSlots()
		if freeSlots == 0 then 
			ChatOutput("No inventory slots available!") 
			return
		end

		local index = 1
		for key, value in pairs(self.allArmourIndices) do
			local item = self.equipment:GetItem(value)
			if item then
				self.backpack:PerformItemDrop(item, indices[index], false)
				index = index + 1
			end
			if index > freeSlots then break end
		end

		--self:BuildBag()
		--self.Walletbar:Refresh()
		self.itemListBox:Sort(function(a, b) return a:GetItemCount() > b:GetItemCount() end)
	end

	self.sortBag()
end

function BagWindow:BuildBag()
	local backpackSize = self.backpack:GetSize()

	-- Sum itemcategories
	self.ItemCounts = {}
	for i = 1, backpackSize, 1 do
		if self.backpack:GetItem(i) then
			if self.UserCategories[self.backpack:GetItem(i):GetName()] then
				self.ItemCounts[self.UserCategories[self.backpack:GetItem(i):GetName()].CategoryName] = (self.ItemCounts[self.UserCategories[self.backpack:GetItem(i):GetName()].CategoryName] or 0) + 1
			elseif ItemLUT[self.backpack:GetItem(i):GetItemInfo():GetCategory()] then
				if self.ItemCounts[ItemLUT[self.backpack:GetItem(i):GetItemInfo():GetCategory()]] then 
					self.ItemCounts[ItemLUT[self.backpack:GetItem(i):GetItemInfo():GetCategory()]] = self.ItemCounts[ItemLUT[self.backpack:GetItem(i):GetItemInfo():GetCategory()]] + 1
				else
					self.ItemCounts[ItemLUT[self.backpack:GetItem(i):GetItemInfo():GetCategory()]] = 1
				end
			else
				if self.ItemCounts["Undefined"] then 
					self.ItemCounts["Undefined"] = self.ItemCounts["Undefined"] + 1
				else
					self.ItemCounts["Undefined"] = 1
				end
			end
		else
			if self.ItemCounts["Empty Slot"] then
				self.ItemCounts["Empty Slot"] = self.ItemCounts["Empty Slot"] + 1
			else
				self.ItemCounts["Empty Slot"] = 1
			end
		end
	end	

	-- Handle undefined items
	--[[
	self.ItemCounts["Miscellaneous"] = 0
	for key, value in pairs(self.ItemCounts) do
		if not(self.UserCategoriesLUT[key]) then
			if key ~= "Empty Slot" and value < self.setAmount[key] then 
				self.ItemCounts["Miscellaneous"] = self.ItemCounts["Miscellaneous"] + value 
			end
		end
	end
	--]]

	if not self.ItemCounts["Undefined"] then
		self.ItemCounts["Undefined"] = 0
	end

	for key, value in pairs(self.ListBoxes) do 
		value:ClearItems()
	end

	self.itemListBox:ClearItems() 

	-- Setup category list boxes
	--[[
	local MiscCat = false
	for key, value in spairs(self.ItemCounts, function(t,a,b) return t[a] > t[b] end) do
		ChatOutput(key .. value)
		if value > 4 then
			self.ListBoxes[key] = CategoryListBox(value, key, self)
		else
			MiscCat = true
		end
	end
	--]]
	
	-- [[
	for key, _ in pairs(self.ItemCounts) do
		if key ~= "Empty Slot" and self.ItemCounts[key] and self.ItemCounts[key] > 0 then 
			if self.UserCategoriesLUT[key] then
				self.ListBoxes[key] = CategoryListBox(self.ItemCounts[key], key, self)
			elseif key ~= "Miscellaneous" and self.ItemCounts[key] < self.setAmount[key] then
				MiscCat = true
			else
				self.ListBoxes[key] = CategoryListBox(self.ItemCounts[key], key, self)
			end
		
		end
	end
	--]]

	-- Handle outlier categories
	self.ListBoxes["Miscellaneous"] = CategoryListBox(self.ItemCounts[-1] or 0, "Miscellaneous", self)
	--if self.ItemCounts[0] and self.ItemCounts[0] > 0 then self.ListBoxes["Undefined"] = CategoryListBox(self.ItemCounts[0], "Undefined", self) end
	self.ListBoxes["Empty Slot"] = EmptyListBox(self.ItemCounts["Empty Slot"], "Empty Slot", self)

	-- Setup the bag
	for i = 1, backpackSize, 1 do

		-- Delete old data if there is some
		if self.items[i] then self.items[i] = nil --[[self.items[i]:SetParent(nil)]] end
		
		-- Create the bag slot
		local bagSlot = BagItem( self.backpack:GetItem(i), i)
			
		-- Handle addition to correct category
		if self.backpack:GetItem(i) then 

			local Cat = self.UserCategories[self.backpack:GetItem(i):GetName()] and self.UserCategories[self.backpack:GetItem(i):GetName()].CategoryName or ItemLUT[self.backpack:GetItem(i):GetItemInfo():GetCategory()]
			local count = self.ItemCounts[ItemLUT[self.backpack:GetItem(i):GetItemInfo():GetCategory()]]
			if not(Cat) then
				Cat = "Undefined"
				ChatOutput(self.backpack:GetItem(i):GetItemInfo():GetName() .. self.backpack:GetItem(i):GetItemInfo():GetCategory())
				if not(self.ListBoxes[Cat]) then self.ListBoxes[Cat] = CategoryListBox(self.ItemCounts[Cat] or 0, Cat, self) end
			elseif (count and count < self.setAmount[ItemLUT[self.backpack:GetItem(i):GetItemInfo():GetCategory()]]) and not(self.UserCategories[self.backpack:GetItem(i):GetName()]) then 
				Cat = "Miscellaneous" 
				if not(self.ListBoxes[Cat]) then self.ListBoxes["Miscellaneous"] = CategoryListBox(self.ItemCounts[-1] or 0, "Miscellaneous", self) end
			end

			bagSlot:SetCategory(self.UserCategories[self.backpack:GetItem(i):GetName()] and self.UserCategories[self.backpack:GetItem(i):GetName()].CategoryName or ItemLUT[self.backpack:GetItem(i):GetItemInfo():GetCategory()] or "Undefined")
			self.ListBoxes[Cat]:AddItem(bagSlot)
		else
			bagSlot:SetCategory("Empty Slot")
			self.ListBoxes["Empty Slot"]:AddItem(bagSlot)
		end
		self.items[i] = bagSlot
	end

	for key, value in spairs(self.ListBoxes, function(t,a,b) return t[a]:GetItemCount() > t[b]:GetItemCount() end) do
		value:Sort()
		self.itemListBox:AddItem(value)
	end

	self:PerformLayout()
end

function BagWindow:PerformLayout()
	self:Layout( { } )
end

function BagWindow:Layout( args )
	local width, height = self:GetSize()
	local listWidth = width - 40
	local listHeight = height - 50
	local itemsPerRow = math.floor(width / (35 * 5))

	self.itemListBox:SetPosition(15, 35)
	self.itemListBox:SetSize(listWidth, listHeight - 20)
	self.itemListBox:SetMaxItemsPerLine(itemsPerRow)
	--self.itemListBox:SetBackColor(Turbine.UI.Color(0,0,1))
	
	self.itemListBoxScrollBar:SetPosition( width - 25, 35)
	self.itemListBoxScrollBar:SetSize(10, listHeight)

	self.Walletbar:SetPosition(15, 35 + listHeight - 20)

	self.SettingsButton:SetPosition(self:GetWidth() - 50, 20)
	self.searchBar:SetPosition(self:GetWidth() - 200, 20)
	self.ReloadPluginButton:SetPosition(self:GetWidth() - 230, 20)
	self.StackButton:SetPosition(self:GetWidth() - 260, 20)
	self.ArmourButton:SetPosition(self:GetWidth() - 290, 20)

	self.resizer:Reposition()
end

function BagWindow:GetBackpack()
	return self.backpack
end

function BagWindow:RemoveCallbacks()
	for key, value in pairs(self.callbacks) do
		RemoveCallback(self.backpack, key, value)
	end

	self.Walletbar:RemoveCallbacks()
end

function BagWindow:EmptyCategory(name)

	-- Never empty the catch all
	if name == "Miscellaneous" and self.ListBoxes["Miscellaneous"]:GetItemCount() > 0 then return end
	if not(self.ListBoxes[name]) then return end

	for key, value in pairs(self.ListBoxes[name]:GetItemIDs()) do
		self.ListBoxes[name]:RemoveItem(self.items[key])

		local category = self.items[key]:GetCategory() or "Undefined"
		if self.ItemCounts[category] < Settings.MiscAmount[category] then
			if self.ListBoxes["Miscellaneous"] == nil then self:AddNewCategory("Miscellaneous") end
			self.ListBoxes["Miscellaneous"]:AddItem(self.items[key])
		else
			self.ListBoxes[self.items[key]:GetCategory()]:AddItem(self.items[key])
		end	
	end
	
	self.itemListBox:RemoveItem(self.ListBoxes[name])
	self.ListBoxes[name]:SetParent(nil)
	self.ListBoxes[name] = nil
	
	--self.itemListBox:Sort(function(a, b) return a:GetItemCount() > b:GetItemCount() end)

end

function BagWindow:AddNewCategory(name)

	if not(self.ListBoxes[name]) then 
		self.ListBoxes[name] = CategoryListBox(self.ItemCounts[name], name, self) 
		self.itemListBox:AddItem(self.ListBoxes[name])
	end

	if self.ListBoxes["Miscellaneous"] then
		for key, value in pairs(self.ListBoxes["Miscellaneous"]:GetItemIDs()) do
			if self.items[key]:GetCategory() == name then
				self.ListBoxes["Miscellaneous"]:RemoveItem(self.items[key])
				self.ListBoxes[name]:AddItem(self.items[key])
			end
		end
	end

	--self.itemListBox:Sort(function(a, b) return a:GetItemCount() > b:GetItemCount() end)
end

function BagWindow:PerformDragDrop(args)
	local shortcut = args.DragDropInfo:GetShortcut()

	if (shortcut ~= nil) then
		if not(self.ListBoxes["Empty Slot"]) then return end
		local index = self.ListBoxes["Empty Slot"]:GetTopSlotID()
		if index then
			self.backpack:PerformShortcutDrop(shortcut, index, Turbine.UI.Control.IsShiftKeyDown())
		end
	end
end