CurrencyOptionsWindow = class(Turbine.UI.Control)
function CurrencyOptionsWindow:Constructor(parent)
    local width = 750
    local height = 500
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height)
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10 - 2, 40 - 2)
    SingleBackground:SetSize(720 + 4, 400 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10, 40)
    SingleBackground:SetSize(720, 400)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    self.currencyDropdown = PrimePlugins.RaidTools.UI.DropDownMenuControl(nil, 500, "Currencies")
    local player = Turbine.Gameplay.LocalPlayer.GetInstance()
    local wallet = player:GetWallet()
    self.currencyItems = {}
    for i = 1, wallet:GetSize(), 1 do
        local walletItem = wallet:GetItem(i)
        self.currencyItems[walletItem:GetName()] = walletItem:GetSmallImage()
    end

    for name, icon in spairs(self.currencyItems, function (t, a, b) return a < b end) do
        self.currencyDropdown:AddItem(name, 
        function()
            if not(Settings.TrackedCurrencies[name]) then
                Settings.TrackedCurrencies[name] = true
                Settings.CurrencyOrder[name] = tablelength(Settings.TrackedCurrencies)
            end
            self.currencyDropdown:ToggleVisible()
        end, nil, nil, icon)
    end

    self.addButton = Turbine.UI.Lotro.Button()
    self.addButton:SetParent(SingleBackground)
	self.addButton:SetSize(115, 40)
	self.addButton:SetPosition(310, 0)
    self.addButton:SetText("Add Currency")

    self.addButton.Click = function()
        self.currencyDropdown:ToggleVisible()
    end

    self.listbox = Turbine.UI.ListBox()
    self.listbox:SetParent(SingleBackground)
    self.listbox:SetSize(300, 400)
    self.listbox:SetPosition(0, 0)
    self.listbox:SetBackColor(Turbine.UI.Color.DarkSlateGray)

    self.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    self.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.Scrollbar:SetParent(SingleBackground)
    self.Scrollbar:SetPosition(300, 0)
    self.Scrollbar:SetSize(10, 400)
    self.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    self.listbox:SetVerticalScrollBar(self.Scrollbar)

    self.moveItem = function(index, up)
        ChatOutput(index)
        local item = self.listbox:GetItem(index)
        self.listbox:RemoveItemAt(index)
        self.listbox:InsertItem(index + (up and -1 or 1), item)

        for i = 1, self.listbox:GetItemCount() do
            Settings.CurrencyOrder[self.listbox:GetItem(i).effectLabel:GetText()] = i
        end
    end

    self.AddListboxItem = function(effectName)
        local listBoxItem = Turbine.UI.Control()
        listBoxItem:SetSize(300, 20)
        listBoxItem:SetBackColor(Turbine.UI.Color.Black)

        listBoxItem.innerBox = Turbine.UI.Control()
        listBoxItem.innerBox:SetParent(listBoxItem)
        listBoxItem.innerBox:SetSize(300 - 2, 20 - 2)
        listBoxItem.innerBox:SetPosition(1, 1)
        listBoxItem.innerBox:SetBackColor(Turbine.UI.Color.DarkSlateGray)

        listBoxItem.effectLabel = Turbine.UI.Label()
        listBoxItem.effectLabel:SetParent(listBoxItem.innerBox)
        listBoxItem.effectLabel:SetSize(300 - 2 - 50, 20 - 2)
        listBoxItem.effectLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
        listBoxItem.effectLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        listBoxItem.effectLabel:SetOutlineColor(Turbine.UI.Color.Black)
        listBoxItem.effectLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        listBoxItem.effectLabel:SetText(effectName)

        listBoxItem.moveUpButton = Turbine.UI.Control()
        listBoxItem.moveUpButton:SetParent(listBoxItem.innerBox)
        listBoxItem.moveUpButton:SetSize(16, 16)
        listBoxItem.moveUpButton:SetPosition(300 - 1 - 14 - 32 - 10, 1)
        listBoxItem.moveUpButton:SetBackground(BackgroundHandler:GetBackground(0x4101DB45))
        listBoxItem.moveUpButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        listBoxItem.moveUpButton.MouseClick = function()
            self.moveItem(self.listbox:IndexOfItem(listBoxItem), true)
            --self.listbox:RemoveItem(listBoxItem)
            --Settings.NewTargetWindowEffects[effectName] = nil
        end

        listBoxItem.moveDownButton = Turbine.UI.Control()
        listBoxItem.moveDownButton:SetParent(listBoxItem.innerBox)
        listBoxItem.moveDownButton:SetSize(14, 14)
        listBoxItem.moveDownButton:SetPosition(300 - 1 - 14 - 16 - 10 , 1)
        listBoxItem.moveDownButton:SetBackground(BackgroundHandler:GetBackground(0x41007E18))
        listBoxItem.moveDownButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        listBoxItem.moveDownButton.MouseClick = function()
            self.moveItem(self.listbox:IndexOfItem(listBoxItem), false)
            --self.listbox:RemoveItem(listBoxItem)
            --Settings.NewTargetWindowEffects[effectName] = nil
        end

        listBoxItem.removeButton = Turbine.UI.Control()
        listBoxItem.removeButton:SetParent(listBoxItem.innerBox)
        listBoxItem.removeButton:SetSize(14, 14)
        listBoxItem.removeButton:SetPosition(300 - 1 - 14, 3)
        listBoxItem.removeButton:SetBackground(BackgroundHandler:GetBackground(0x41005F0A))
        listBoxItem.removeButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        listBoxItem.removeButton.MouseClick = function()
            self.listbox:RemoveItem(listBoxItem)
            Settings.TrackedCurrencies[effectName] = false
            --Settings.NewTargetWindowEffects[effectName] = nil
        end
        self.listbox:AddItem(listBoxItem)
    end
--0x4101DB45
--0x41007E18
    for key, value in spairs(Settings.TrackedCurrencies, function(t, a, b) return Settings.CurrencyOrder[a] < Settings.CurrencyOrder[b] end) do
        if Settings.TrackedCurrencies[key] then
            self.AddListboxItem(key)
        end
    end
end