function ConvertEntry(entry)
    if type(entry) == "number" then return ("<num>" .. tostring(entry)) end
    if type(entry) == "table" then return ConvertTable(entry) end
    return entry
end

function RecoverEntry(entry)
    if type(entry) == "string" then 
        if string.find(entry, "<num>") then
            return tonumber(string.sub(entry, string.find(entry, ">") + 1, string.len(entry)))
        else
            return entry
        end
    elseif type(entry) == "table" then
        return RecoverTable(entry)
    end
    return entry
end

function ConvertTable(T)
    if T == nil then return nil end
    local Copy = {}
    for key, value in pairs(T) do 
        Copy[ConvertEntry(key)] = ConvertEntry(value)
    end
    return Copy
end

function RecoverTable(T)
    if T == nil then return nil end
    local Copy = {}
    for key, value in pairs(T) do 
        Copy[RecoverEntry(key)] = RecoverEntry(value)
    end
    return Copy
end

function SaveTable(Scope, FileName, Table)
    Turbine.PluginData.Save(Scope, FileName, ConvertTable(Table))
end

function LoadTable(Scope, FileName)
    return RecoverTable(Turbine.PluginData.Load(Scope, FileName))
end
