Resizer = class(Turbine.UI.Control)
function Resizer:Constructor(parent)
    Turbine.UI.Control.Constructor( self )

    self:SetParent( parent )
    self:SetZOrder( 100 )
    self:SetSize( 45, 45 )
    self:SetPosition( parent:GetWidth() - self:GetWidth(), parent:GetHeight() - self:GetHeight() )
    self:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    self:SetBackground("PrimePlugins/Bags/Images/panel_resize_icon.tga")

    self.parent = parent
    
    self.MouseDown = function( sender, args )
        sender.dragStartX = args.X
        sender.dragStartY = args.Y
        sender.dragging = true
    end
    
    self.MouseMove = function( sender, args )
        local width, height = parent:GetSize()
    
        if ( sender.dragging ) then
            parent:SetSize( width + ( args.X - sender.dragStartX ), height + ( args.Y - sender.dragStartY ) )
            self:SetPosition( parent:GetWidth() - self:GetWidth(), parent:GetHeight() - self:GetHeight() )
            parent:PerformLayout()
        end
    end
    
    self.MouseUp = function( sender, args )
        sender.dragging = false
    end
end

function Resizer:Reposition()
    self:SetPosition( self.parent:GetWidth() - self:GetWidth(), self.parent:GetHeight() - self:GetHeight() )
end