LoadTable = PrimePlugins.RaidTools.LoadTable
SaveTable = PrimePlugins.RaidTools.SaveTable
Settings = LoadTable(Turbine.DataScope.Character, "PrimeBagSettings")

function GetDefaultSettings()
    Settings = {}

    Settings.BagX = Turbine.UI.Display.GetWidth() - 250
    Settings.BagY = Turbine.UI.Display.GetHeight() - 225
    Settings.BagWidth = 300
    Settings.BagHeight = 300

    Settings.MiscAmount = {
        ["Crafting Scrolls"] = 5,
        ["Travel"] = 5,
        ["Jewelry"] = 5,
        ["Skirmish"] = 5,
        ["Class Items"] = 5,
        ["Crafting"] = 5,
        ["Fishing"] = 5,
        ["Healing"] = 5,
        ["Instruments"] = 5,
        ["Armour"] = 5,
        ["Legendary Items"] = 5,
        ["Quest Items"] = 5,
        ["Trophy"] = 5,
        ["Weapons"] = 5,
        ["Cosmetics"] = 5,
        ["Consumables"] = 5,
        ["Decorations"] = 5,
        ["Festival"] = 5,
        ["Kinship"] = 5,
        ["Reputation"] = 5,
        ["Barter"] = 5,
        ["Class"] = 5,
        ["Essences"] = 5,
        ["Deconstructable"] = 5,
        ["Miscellaneous"] = 9999999,
        ["Lootbox"] = 5,
        ["Social"] = 5,
        ["Useables"] = 5,
        ["Task"] = 5,
        ["Battle-gauntlets"] = 5,
        ["Undefined"] = 5,
    }

    Settings.TrackedCurrencies = {
        ["Commendation"] = true,
        ["Ancient Ithil-coin"] = true,
        ["Embers of Enchantment"] = true,
        ["Mark"] = true,
        ["Medallion"] = true,
        ["Seal"] = true,
        ["Mithril Coin"] = true,
    }

    Settings.CurrencyOrder = {
        ["Commendation"] = 6,
        ["Ancient Ithil-coin"] = 5,
        ["Embers of Enchantment"] = 1,
        ["Mark"] = 2,
        ["Medallion"] = 3,
        ["Seal"] = 4,
        ["Mithril Coin"] = 7,
    }

    Settings.UserCategories = {
        
    }

    Settings.Reload = false
    Settings.Version = PluginVersion
end

if Settings == nil or Settings.Reload == true then
    GetDefaultSettings()
end

function UpdateSettings()
    local tempSettings = Settings
    GetDefaultSettings()
    for key, value in pairs(Settings) do
        if not(tempSettings[key]) then
            tempSettings[key] = value
        end
    end

    Settings = tempSettings

    Settings.Version = plugin:GetVersion()
end

UpdateSettings()

PluginString = "<rgb=#FF9900><Prime Bags></rgb> "

function SaveData()
    
    Settings.BagX, Settings.BagY = Bag:GetPosition()
    Settings.BagWidth, Settings.BagHeight = Bag:GetSize()

    SaveTable(Turbine.DataScope.Character, "PrimeBagSettings", Settings)
end