WalletBar = class( Turbine.UI.Control )
function WalletBar:Constructor(parent)
	Turbine.UI.Control.Constructor( self )

	self.width = 2000
	self.height = 20
    --ChatOutput(name .. " " .. items .. " " .. self.height)
    self:SetParent(parent)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(Turbine.UI.Color(1, 0, 0))

    local player = Turbine.Gameplay.LocalPlayer.GetInstance()
    local wallet = player:GetWallet()

    self.CurrentCurrencies = {}
    self.CurrencyLabels = {}

    self.callbacks = {}

    local maxNumber = tablelength(Settings.TrackedCurrencies)

    --[[
    self.callbacks["Received"] = AddCallback( Turbine.Chat, "Received", function(sender, args)
        ChatOutput(Turbine.ChatType.Standard)
        if args.ChatType == Turbine.ChatType.Standard then
            --self.ChatFunctions[args.ChatType](args.Message)
            ChatOutput(args.Message)
            local item, silver, copper = string.match(args.Message, "You purchased: (.*) for (.*) silver pieces and (.*) copper coins.")
            ChatOutput(item)
            ChatOutput(silver)
            ChatOutput(copper)
        end
    end)
    --]]

    for i = 1, wallet:GetSize(), 1 do
        
        local walletItem = wallet:GetItem(i)

        if Settings.TrackedCurrencies[walletItem:GetName()] then
            self.CurrentCurrencies[walletItem:GetName()] = {walletItem:GetQuantity(), walletItem:GetSmallImage(), walletItem:GetName()}

            self.callbacks[walletItem] = {}
            self.callbacks[walletItem]["QuantityChanged"] = AddCallback(walletItem, "QuantityChanged", function(sender, args) self:Refresh() end)
        else
            Settings.TrackedCurrencies[walletItem:GetName()] = false
            Settings.CurrencyOrder[walletItem:GetName()] = maxNumber

            maxNumber = maxNumber + 1

        end

        --ChatOutput(walletItem:GetName())
    end 

    local copper, silver, gold = player:GetAttributes():GetMoneyComponents()

    --0x41007E28
    --0x41005E76
    self.CurrencyLabels["Durability"] = CurrencyLabel(self, 0, 80, 20,  0x41007E28, self:HandleDurability(), 30, 16, false)

    self.CurrencyLabels["Gold"] = CurrencyLabel(self, 80, 60, 20, 0x41007E7B, gold, 30, 20, false)
    self.CurrencyLabels["Silver"] = CurrencyLabel(self, 140, 60, 20, 0x41007E7C, silver, 30, 20, false)
    self.CurrencyLabels["Copper"] = CurrencyLabel(self, 200, 60, 20, 0x41007E7D, copper, 30, 20, false)
    local counter = 0
    for key,value in spairs(Settings.CurrencyOrder, function(t,a,b) return t[a] < t[b] end) do
        if self.CurrentCurrencies[key] then 
            Settings.CurrencyOrder[key] = counter
            self.CurrencyLabels[self.CurrentCurrencies[key][3]] = CurrencyLabel(self, 260 + counter * 60, 60, 20, self.CurrentCurrencies[key][2], self.CurrentCurrencies[key][1], 16, 16, true)
            counter = counter + 1
        end
    end   
    
    self:Refresh()
end

function WalletBar:Refresh()
    local wallet = Turbine.Gameplay.LocalPlayer.GetInstance():GetWallet()
    for i = 1, wallet:GetSize(), 1 do
        local walletItem = wallet:GetItem(i)

        if self.CurrencyLabels[walletItem:GetName()] then
            self.CurrencyLabels[walletItem:GetName()]:ChangeCurrency(walletItem:GetQuantity())
        end
    end

    local copper, silver, gold = Turbine.Gameplay.LocalPlayer.GetInstance():GetAttributes():GetMoneyComponents()
    self.CurrencyLabels["Gold"] = gold
    self.CurrencyLabels["Silver"] = silver
    self.CurrencyLabels["Copper"] = copper

    self:HandleDurability()
end

function WalletBar:HandleDurability()

    local equipment = Turbine.Gameplay.LocalPlayer.GetInstance():GetEquipment()

    local count = 0
    local total = 0
    for i = 1, equipment:GetSize(), 1 do
        local equippedItem = equipment:GetItem(i)
        if equippedItem then 
            count = count + 1
            total = total + GetWearValue(equippedItem:GetWearState())
        end
    end

    local percentage = total / count

    if percentage < 20 then
        percentage = "<rgb=#FF0000>" .. Round(percentage, 2) .. "%</rgb>"
    elseif percentage < 50 then
        percentage = "<rgb=#FF6600>" .. Round(percentage, 2) .. "%</rgb>"
    else
        --percentage = "<rgb=#00FF00>" .. percentage .. "%</rgb>"
        percentage = "<rgb=#FFFFFF>" .. Round(percentage, 2) .. "%</rgb>"
    end

    return(percentage)
end

function WalletBar:RemoveCallbacks()
    for walletitem, callbacks in pairs(self.callbacks) do
        for key, value in pairs(self.callbacks) do
            RemoveCallback(walletitem, key, value)
        end
    end
end

function GetWearValue(value)
    if value == 0 or value == 3 then return 0 end
    if value == 1 then return 20 end
    if value == 4 then return 100 end
    return 100
end

CurrencyLabel = class( Turbine.UI.Control )
function CurrencyLabel:Constructor(parent, x, width, height, icon, text, iconWidth, iconHeight, shorten)
    Turbine.UI.Control.Constructor( self )

    self:SetPosition(x, 0)
    self:SetSize(width, height)
    self:SetParent(parent)

    self.shorten = shorten

    self.iconLabel = Turbine.UI.Label()
    self.iconLabel:SetParent(self)
    self.iconLabel:SetSize(iconWidth, iconHeight)
    self.iconLabel:SetPosition(0, (height - iconHeight) / 2)
    self.iconLabel:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    self.iconLabel:SetBackground(icon)

    self.currency = Turbine.UI.Label()
    self.currency:SetPosition(iconWidth, 0)
    self.currency:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.currency:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.currency:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.currency:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.currency:SetParent(self)
    self.currency:SetMarkupEnabled(true)
    self.currency:SetSize(width - iconWidth, height)
    if self.shorten then
        self.currency:SetText(FormatBigNumber(text))
    else
        self.currency:SetText(text)
    end
end

function CurrencyLabel:ChangeCurrency(newValue)
    if self.shorten then
        self.currency:SetText(FormatBigNumber(newValue))
    else
        self.currency:SetText(newValue)
    end
end

TrackedCurrencies = {
    ["Commendation"] = true,
    ["Ancient Ithil-coin"] = true,
    ["Embers of Enchantment"] = true,
    ["Mark"] = true,
    ["Medallion"] = true,
    ["Seal"] = true,
    ["Mithril Coin"] = true,
}

CurrencyOrder = {
    [1] = "Embers of Enchantment",
    [2] = "Mark",
    [3] = "Medallion",
    [4] = "Seal",
    [5] = "Ancient Ithil-coin",
    [6] = "Commendation",
    [7] = "Mithril Coin",
}

-- Gold coins - 0x41004641
-- Vault -  0x41005E9D
-- Leader Icon - 0x41007DCE
-- Raid assistant icon - 0x41007DE3
-- Mouse - 0x41007DC7
-- Plus - 0x41007E27
-- Minus - 0x41007E26
-- Gold - 0x41007E7B
-- Silver - 0x41007E7C
-- Copper - 0x41007E7D
-- Silver coins - 0x41007E7D
-- Copper coins - 0x41007E80
-- Triple gold - 0x41007F7C
-- Overlord - 0x410080B5
-- Tyrant - 0x410080B6
-- CG -  0x410080A7
-- 1 Freep star - 0x410080BF
-- 5 Freep star - 0x410080C8
-- 5 Creep opponent star - 0x410080E6
-- 1 bag - 0x4100810D
-- end bag - 0x4100811E
