TargetFrame = class(Turbine.UI.Control)
function TargetFrame:Constructor(parent, x, y, width, height, colour)
    
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width, height)
    self:SetPosition(x, y)
    self:SetParent(parent)
    self:SetOpacity(1)

    self.TargetSelections = nil

    self.deaths = 0
    self.kills = 0
    self.rezzed = 0

    self.colour = colour

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    --self:SetZOrder(1)

    self:SetMouseVisible(false)
    self:SetVisible(true)
    self:SetWantsUpdates(false)
    self:SetWantsKeyEvents(false)

    self.background = Turbine.UI.Window()
    self.background:SetParent(self)
    self.background:SetSize(width-4, height-4)
    self.background:SetPosition(2,2)
    self.background:SetVisible(true)
    self.background:SetMouseVisible(false)
    self.background:SetBackColor(colour)
    self.background:SetOpacity(0.3)

    self.foreground = Turbine.UI.Window()
    self.foreground:SetParent(self)
    self.foreground:SetSize(width-4, height-4)
    self.foreground:SetPosition(2,2)
    self.foreground:SetVisible(true)
    self.foreground:SetMouseVisible(false)
    --self.foreground:SetBackColor(Turbine.UI.Color(0.7,0,0))
    self.foreground:SetOpacity(1)

    self.icon = Turbine.UI.Label()
    self.icon:SetParent(self.foreground)
    self.icon:SetSize(20, 20)
    self.icon:SetMouseVisible(false)
    --self.icon:SetBlendMode(Turbine.UI.BlendMode.Overlay )
    self.icon:SetPosition(0, 7)

    self.name = Turbine.UI.Label()
    self.name:SetParent(self.foreground)
    self.name:SetFont(Turbine.UI.Lotro.Font.TrajanProBold22)
    self.name:SetMouseVisible(false)
    self.name:SetSize(115, 30)
    self.name:SetMultiline(false)
    self.name:SetPosition(22, 6)

    self.killIcon = Turbine.UI.Label()
    self.killIcon:SetParent(self.foreground)
    self.killIcon:SetSize(32, 32)
    self.killIcon:SetMouseVisible(false)
    self.killIcon:SetPosition(5, 35)
    self.killIcon:SetBackground("PrimePlugins/RaidTools/Images/DPS.tga")
    --self.killIcon:SetStretchmode(1)
    --self.killIcon:SetSize(20,20)
    --self.killIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay )
    --self.killIcon:SetPosition(0, 7)

    self.killLabel = Turbine.UI.Label()
    self.killLabel:SetMouseVisible(false)
    self.killLabel:SetParent(self.foreground)
    self.killLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold30)
    self.killLabel:SetSize(30, 30)
    self.killLabel:SetPosition(42, 38)
    self.killLabel:SetText("0")

    self.deathIcon = Turbine.UI.Label()
    self.deathIcon:SetParent(self.foreground)
    self.deathIcon:SetSize(64, 64)
    self.deathIcon:SetMouseVisible(false)
    self.deathIcon:SetBackground("PrimePlugins/RaidTools/Images/SkullIcon.tga")
    self.deathIcon:SetStretchMode(1)
    self.deathIcon:SetSize(32,32)
    --self.deathIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay )
    self.deathIcon:SetPosition(70, 33)

    self.deathLabel = Turbine.UI.Label()
    self.deathLabel:SetMouseVisible(false)
    self.deathLabel:SetParent(self.foreground)
    self.deathLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold30)
    self.deathLabel:SetSize(20, 30)
    self.deathLabel:SetPosition(110, 38)
    self.deathLabel:SetText("0")
    
    self.E = Turbine.UI.Lotro.EntityControl()
    self.E:SetParent(self.foreground)
    self.E:SetVisible(true)
    self.E:SetSize(width, height)
    --self.E:SetBackColor(Turbine.UI.Color(0.7,0,0))
    --self.E:SetEntity(target)
end

function TargetFrame:SetTarget(target)
    self:TotalReset()
    self.E:SetEntity(target)
    self.TargetSelections = self.player:GetTarget()
    self:RefreshScore()
end

function TargetFrame:RefreshScore()
    self.killLabel:SetText(self.kills)
    self.deathLabel:SetText(self.deaths)
end

function TargetFrame:AddKill()
    self.kills = self.kills + 1
    self.killLabel:SetText(self.kills)
end

function TargetFrame:AddDeath()
    self.deaths = self.deaths + 1
    self.deathLabel:SetText(self.deaths)
    self.background:SetBackColor(Turbine.UI.Color(0,0,0))
end

function TargetFrame:Revive()
    self.background:SetBackColor(self.colour)
end

function TargetFrame:TotalReset()
    self.E:SetEntity(nil)
    self.TargetSelections = nil
    self.name:SetText(nil)
    self.icon:SetBackground(nil)
    collectgarbage()
end

function TargetFrame:ResetScore()
    self.deaths = 0
    self.kills = 0
    self:RefreshScore()
end

function TargetFrame:SetName(name)
    self.name:SetText(name)
end

function TargetFrame:SetIcon(image)
    self.icon:SetBackground(image)
end

function TargetFrame:ChangeState(selected)
    if selected then
        self.background:SetOpacity(0.6)
    else
        self.background:SetOpacity(0.3)
    end
end

