ScoreBoard = class(Turbine.UI.Window)
function ScoreBoard:Constructor()
    Turbine.UI.Window.Constructor(self)
    local width, height = 700, 100
    self:SetSize(width, height)
    self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - (width / 2), -3)
    self:SetVisible(true)

    self.kills1 = 0
    self.kills2 = 0

    self.background = Turbine.UI.Window()
    self.background:SetParent(self)
    self.background:SetSize(width-4, height-4)
    self.background:SetPosition(2,2)
    self.background:SetVisible(true)
    self.background:SetMouseVisible(false)
    self.background:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    self.background:SetOpacity(0.6)

    self.foreground = Turbine.UI.Window()
    self.foreground:SetParent(self)
    self.foreground:SetSize(width-4, height-4)
    self.foreground:SetPosition(2,2)
    self.foreground:SetVisible(true)
    self.foreground:SetMouseVisible(false)
    --self.foreground:SetBackColor(Turbine.UI.Color(0.7,0,0))
    self.foreground:SetOpacity(1)

    self.TeamBackground1 = Turbine.UI.Control()
    self.TeamBackground1:SetParent(self.background)
    self.TeamBackground1:SetPosition(20, 30)
    self.TeamBackground1:SetSize(250, 40)
    self.TeamBackground1:SetBackColor(Turbine.UI.Color(0,0,0.7))

    self.TeamBackground1 = Turbine.UI.Control()
    self.TeamBackground1:SetParent(self.background)
    self.TeamBackground1:SetPosition(width - 270, 30)
    self.TeamBackground1:SetSize(250, 40)
    self.TeamBackground1:SetBackColor(Turbine.UI.Color(0.7,0,0))

    self.TeamLabel1 = Turbine.UI.Label()
    self.TeamLabel1:SetParent(self.foreground)
    self.TeamLabel1:SetPosition(20, 30)
    self.TeamLabel1:SetSize(250, 40)
    --self.TeamLabel1:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))
    self.TeamLabel1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.TeamLabel1:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.TeamLabel1:SetText("")
    
    self.TeamLabel2 = Turbine.UI.Label()
    self.TeamLabel2:SetParent(self.foreground)
    self.TeamLabel2:SetPosition(width - 270, 30)
    self.TeamLabel2:SetSize(250, 40)
    --self.TeamLabel2:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))
    self.TeamLabel2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.TeamLabel2:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.TeamLabel2:SetText("")
    
    self.TeamBackground1 = Turbine.UI.Control()
    self.TeamBackground1:SetParent(self.background)
    self.TeamBackground1:SetPosition(width / 2 - 60, 30)
    self.TeamBackground1:SetSize(120, 40)
    self.TeamBackground1:SetBackColor(Turbine.UI.Color(0,0.2,0))

    self.KillsLabel = Turbine.UI.Label()
    self.KillsLabel:SetParent(self.foreground)
    self.KillsLabel:SetPosition(width / 2 - 50, 30)
    self.KillsLabel:SetSize(100, 40)
    --self.KillsLabel:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))
    self.KillsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.KillsLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.KillsLabel:SetText("0 - 0")

end

function ScoreBoard:ResetKills()
    self.kills1 = 0
    self.kills2 = 0
    self:RefreshLabels()
end

function ScoreBoard:RefreshLabels()
    self.KillsLabel:SetText(self.kills1 .. " - " .. self.kills2)
end

function ScoreBoard:AddKills(team)
    if team == 1 then 
        self.kills1 = self.kills1 + 1 
    elseif team == 2 then 
        self.kills2 = self.kills2 + 1 
    end
    self:RefreshLabels()
end

function ScoreBoard:SetTeamNames(name, i)
    if i == 1 then 
        self.TeamLabel1:SetText(name)
    elseif i == 2 then
        self.TeamLabel2:SetText(name)
    end
end