Settings = LoadTable(Turbine.DataScope.Character, "PrimeVitalsSettings")


function GetDefaultSettings()
    Settings = {}

    Settings.Version = PluginVersion

    -- Vitals
    Settings.FrameX = 500
    Settings.FrameY = 500
    Settings.EffectVersion = 1
    Settings.ShowPowerNumbers = true
    Settings.ShowName = true
    Settings.OnlyShowCurrent = false
    Settings.IconScale = 1.4
    Settings.ShowCountdown = false
    Settings.ColourMode = 1

    -- Target
    Settings.TargetEnabled = false
    Settings.TargetX = 1000
    Settings.TargetY = 500

    -- Global
    Settings.NumberMethod = 2
    Settings.PercentageShown = true

end

if Settings == nil or Settings.Reload == true then
    GetDefaultSettings()
end

function UpdateSettings()
    local tempSettings = Settings
    GetDefaultSettings()
    for key, value in pairs(tempSettings) do
        if Settings[key] ~=  nil then
            Settings[key] = value
        end
    end
    if plugin:GetVersion() ~= tempSettings.Version then
        Settings.FirstTime = true
    end
    Settings.Version = plugin:GetVersion()
end



function SaveData()
    Settings.FrameX, Settings.FrameY = Vital:GetPosition()

    if TargetVital then Settings.TargetX, Settings.TargetY = TargetVital:GetPosition() end

    SaveTable(Turbine.DataScope.Character, "PrimeVitalsSettings", Settings)
end

ClassColours = {
    [Turbine.Gameplay.Class.BlackArrow] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Beorning] = Turbine.UI.Color(77/255, 38/255, 0), --Yellow
    [Turbine.Gameplay.Class.Burglar] = Turbine.UI.Color(255/255, 255/255, 102/255), --Yellow
    [Turbine.Gameplay.Class.Captain] = Turbine.UI.Color(255/255, 179/255, 230/255), --Pink
    [Turbine.Gameplay.Class.Champion] = Turbine.UI.Color(204/255, 253/255, 102/255), --Brownrgb(204, 153, 102)
    --[Turbine.Gameplay.Class.Corsair] = Turbine.UI.Color(204/255, 253/255, 102/255), --Brownrgb(204, 153, 102)
    [Turbine.Gameplay.Class.Chicken] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Defiler] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Guardian] = Turbine.UI.Color(100/255, 0, 0), --Red
    [Turbine.Gameplay.Class.Hunter] = Turbine.UI.Color(51/255, 153/255, 51/255), --{Turbine.UI.Color(51/255, 102/255, 0)
    [Turbine.Gameplay.Class.LoreMaster] = Turbine.UI.Color(163/255, 26/255, 255/255), --Purple
    [Turbine.Gameplay.Class.Minstrel] = Turbine.UI.Color(51/255, 255/255, 153/255), --Light green
    [Turbine.Gameplay.Class.Ranger] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Reaver] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.RuneKeeper] = Turbine.UI.Color(0, 191/255, 1), --Red--Turbine.UI.Color(0, 191/255, 1), --{Turbine.UI.Color(0, 115/255, 153/255),
    [Turbine.Gameplay.Class.Stalker] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Troll] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Warden] = Turbine.UI.Color(255/255, 102/255, 0/255), --Orange
    [Turbine.Gameplay.Class.WarLeader] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Weaver] = Turbine.UI.Color(102/255, 0, 0),
}
