WindowManager = class(Turbine.UI.Lotro.Window)
function WindowManager:Constructor()

    self.F = FrameGroup(0, 200, 150, 80)
    self.S = ScoreBoard()

    self.Teams = {}

    self.callback = {}

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(600, 600)
    self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - 300, Turbine.UI.Display.GetHeight() / 2 - 300)
    --self:SetPosition(400, 400)
    self:SetVisible(true)
    self:SetText("Prime 6v6 Cast")

    self.teamLabel1 = Turbine.UI.Label()
    self.teamLabel1:SetParent(self)
    self.teamLabel1:SetPosition(50, 80)
    self.teamLabel1:SetSize(200, 20)
    self.teamLabel1:SetText("Team name 1")

    self.teamLabel2 = Turbine.UI.Label()
    self.teamLabel2:SetParent(self)
    self.teamLabel2:SetPosition(350, 80)
    self.teamLabel2:SetSize(200, 20)
    self.teamLabel2:SetText("Team name 2")

    self.teambox1 = Turbine.UI.Lotro.TextBox()
    self.teambox1:SetParent(self)
    self.teambox1:SetPosition(50, 100)
    self.teambox1:SetSize(200, 20)
    self.teambox1:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    self.button1 = Turbine.UI.Lotro.Button()
    self.button1:SetParent(self)
    self.button1:SetPosition(50, 125)
    self.button1:SetSize(200, 20)
    self.button1:SetText("Set Team Name")

    self.button1.Click = function()
        self.S:SetTeamNames(self.teambox1:GetText(), 1)
    end

    self.teambox2 = Turbine.UI.Lotro.TextBox()
    self.teambox2:SetParent(self)
    self.teambox2:SetPosition(350, 100)
    self.teambox2:SetSize(200, 20)
    self.teambox2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    --self.teambox1:

    self.button2 = Turbine.UI.Lotro.Button()
    self.button2:SetParent(self)
    self.button2:SetPosition(350, 125)
    self.button2:SetSize(200, 20)
    self.button2:SetText("Set Team Name")

    self.button2.Click = function()
        self.S:SetTeamNames(self.teambox2:GetText(), 2)
    end

    self.targetSetupBoxes = {}

    for i = 0, 5, 1 do
        self.targetSetupBoxes[i] = TargetSetupBox(self, 50, 150 + 50 * i, i)
    end

    for i = 6, 11, 1 do
        self.targetSetupBoxes[i] = TargetSetupBox(self, 350, 150 + 50 * (i - 6), i)
    end

    self.HandleTarget = function()
        self.target = nil

        collectgarbage()

        self.target = self.player:GetTarget()

        local target = ""
        if self.target then
            target = self.target:GetName() 
        end

        for key, value in pairs(self.targetSetupBoxes) do
            value:SetTarget(target)
        end
    end


    self.handleVisiblity = function()
        if self:IsVisible() then
            self.HandleTarget()

            if not(self.targetCallback) then
                self.targetCallback = AddCallback(self.player, "TargetChanged", function()
                    self.HandleTarget()
                end)
            end
        else
            if self.targetCallback then
                RemoveCallback(self.player, "TargetChanged", self.targetCallback)
                self.targetCallback = nil
                collectgarbage()
            end
        end
    end

    self.handleVisiblity()

    self.visibleCallback = AddCallback(self, "VisibleChanged", function()
        self.handleVisiblity()
    end)

    self.ChatCallback = AddCallback(Turbine.Chat, "Received", function(sender, args)
        if args.ChatType == Turbine.ChatType.Death then
            if string.find(args.Message, "defeated") then
                local name1, name2 = string.match(args.Message, "(.*) defeated (.*)")
                if name1 and name2 then
                    name2 = string.sub(name2, 1, string.len(name2)-2)
                    self.F:AddKill(name1)
                    self.F:AddDeath(name2)

                    self.S:AddKills(self.Teams[name1])
                end
            end

            if string.find(args.Message, "has been revived.") then
                self.F:Revive(string.match(args.Message, "(.*) has been revived."))
            elseif string.find(args.Message, "has succumbed to his wounds.") then
                self.F:Revive(string.match(args.Message, "(.*) has succumbed to his wounds."))
            elseif string.find(args.Message, "has succumbed to her wounds.") then
                self.F:Revive(string.match(args.Message, "(.*) has succumbed to her wounds."))
            end
        end
    end)


    self.resetButton = Turbine.UI.Lotro.Button()
    self.resetButton:SetParent(self)
    self.resetButton:SetPosition(200, 480)
    self.resetButton:SetSize(200, 20)
    self.resetButton:SetText("Reset")

    self.resetButton.Click = function()
        self.F:ResetScore()
        self.S:ResetKills()
    end

    self.resetButton = Turbine.UI.Lotro.Button()
    self.resetButton:SetParent(self)
    self.resetButton:SetPosition(200, 520)
    self.resetButton:SetSize(200, 20)
    self.resetButton:SetText("Reset Teams")

    self.resetButton.Click = function()

        self.F:TotalReset()

        self.S:ResetKills()
        self.S:SetTeamNames("", 1)
        self.S:SetTeamNames("", 2)

        self.Teams = {}
    end
end

function WindowManager:SetTarget(class, i)
    if self.target then
        self.F:SetPlayer(self.target, class, i)

        local team = nil
        if i < 6 then team = 1 else team = 2 end
        self.Teams[self.target:GetName()] = team
    end
end

function WindowManager:RemoveCallbacks()
    for key, value in pairs(self.callback) do
        RemoveCallback(self.player, key, value)
    end

    RemoveCallback(self.player, "TargetChanged", self.targetCallback)
    self.targetCallback = nil

    self.F:RemoveCallbacks()

    RemoveCallback(Turbine.Chat, "Received", self.ChatCallback)
end

TargetSetupBox = class(Turbine.UI.Control)
function TargetSetupBox:Constructor(parent, x, y, i)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(200, 50)
    self:SetPosition(x, y)
    self:SetVisible(true)
    self:SetParent(parent)
    self:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.class = nil
    self.i = i
    self.parent = parent

    self.BoxLabel = Turbine.UI.Label()
    self.BoxLabel:SetParent(self)
    self.BoxLabel:SetSize(200, 20)
    self.BoxLabel:SetText("Label " .. i)

    self.NameLabel = Turbine.UI.Label()
    self.NameLabel:SetParent(self)
    self.NameLabel:SetPosition(20, 20)
    self.NameLabel:SetSize(200, 20)

    self.button = Turbine.UI.Lotro.Button()
    self.button:SetParent(self)
    self.button:SetPosition(100, 20)
    self.button:SetSize(100, 20)
    self.button:SetText("Set Member")

    self.button.Click = function()
        self.parent:SetTarget(self.class, self.i)
    end

    local ClassButton = Turbine.UI.Lotro.Button()
    ClassButton:SetParent(self)
    ClassButton:SetSize(100, 15)
    ClassButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ClassButton:SetMouseVisible(true)
    ClassButton:SetPosition(100, 0)
    ClassButton:SetText("Class")
    
    local menu = Turbine.UI.ContextMenu()
    local menuItems = menu:GetItems()

    local sortedKeys2 = {}
    for key, value in pairs(Icons) do table.insert( sortedKeys2, key ) end
    table.sort( sortedKeys2 )
    
    for key, name in pairs(sortedKeys2) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            self.class = name
            ClassButton:SetText(name)
        end
        
        menuItems:Add(menuItem)
    end

    ClassButton.Click = function()
        menu:ShowMenu()
    end
end

function TargetSetupBox:SetTarget(name)
    self.NameLabel:SetText(name)
end

OptionsButton=class(Turbine.UI.Window) 
function OptionsButton:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(120, 20)
    self:SetPosition(0, 0)
    self:SetVisible(true)
    
    self.toggleButton = Turbine.UI.Lotro.Button()
    self.toggleButton:SetParent(self)
    self.toggleButton:SetText("Cast Options")
    self.toggleButton:SetVisible(true)
    self.toggleButton:SetSize(120, 20)

    self.toggleButton.Click = function()
        W:SetVisible(true)
    end

    self.Moving = false

    self.toggleButton.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.toggleButton.MouseUp = function()
        self.Moving = false
    end

    self.toggleButton.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          if newLeft < 0 then newLeft = 0 end
          if newTop < 0 then newTop = 0 end
          if newLeft > (Turbine.UI.Display.GetWidth() - self:GetWidth()) then
            newLeft = Turbine.UI.Display.GetWidth() - self:GetWidth() end
          if newTop > (Turbine.UI.Display.GetHeight() - self:GetHeight()) then
            newTop = Turbine.UI.Display.GetHeight() - self:GetHeight() end
          self:SetPosition(newLeft,newTop)
        end
    end
end

Icons = {
    ["Burglar"] = 0x41007deb,
    ["Captain"] = 0x41007de7,
    ["Champion"] = 0x41007dec,
    ["Guardian"] = 0x41007de8,
    ["Hunter"] = 0x41007dea,
    ["LoreMaster"] = 0x41007de9,
    ["Minstrel"] = 0x41007de6,
    ["RuneKeeper"] = 0x410ea238,
    ["Warden"] = 0x410ea239,
    ["Beorning"] = 0x4115370d,

    ["BlackArrow"] = 0x41007def,
    ["Defiler"] = 0x410e6bf4,
    ["Reaver"] = 0x41007ded,
    ["Stalker"] = 0x41007df1, 
    ["WarLeader"] = 0x41007df0, 
    ["Weaver"] = 0x41007dee, 
} 
