Encounter = class(Turbine.UI.Control)
function Encounter:Constructor()
    Turbine.UI.Control.Constructor(self)

    self.MoralePower = {
        ["Morale"] = 1,
        ["Power"] = 2,
        ["Wrath"] = 3, --?
    }

    self.CombatStartTime = Turbine.Engine.GetGameTime()
    self.oldGameTime = Turbine.Engine.GetGameTime()
    self.date = Turbine.Engine.GetDate()
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self:SetWantsUpdates(true)

    self.UpdateDelay = 1
    self.decimalPlaces = 1
    --self.StartTimesLUT[self.CombatStartTime] = Turbine.Engine.GetGameTime()

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    -- Per seconds
    self.DPSMapped = {}

    -- Skill Data
    self.SkillsMapped = {}
    self.ItemsMapped = {}
    self.SkillIcons = {}
    self.SkillDamage = {}
    self.SkillHits = {}
    self.SkillDamageTypes = {}
    self.SkillMaxDamage = {}
    self.SkillTotalHits = {}

    -- Target Skill Data
    self.TargetSkillsMapped = {}
    self.TargetItemsMapped = {}
    self.TargetSkillIcons = {}
    self.TargetSkillDamage = {}
    self.TargetSkillHits = {}
    self.TargetSkillDamageTypes = {}
    self.TargetSkillMaxDamage = {}
    self.TargetSkillTotalHits = {}

    -- Target Data
    self.TargetDamage = {}
    self.TargetHits = {}
    self.TargetDamageTypes = {}

    -- Misc tracking
    self.TargetBreakdown = {}
    self.PowerMapped = {}
    self.MoraleMapped = {}
    self.DamageMapped = {}
    self.DamageTakenMapped = {}

    -- Corruptions
    self.CorruptionTotal = 0
    self.CorruptionBreakdown = {}
    self.CorruptionsTargetTotal = {}
    self.CorruptionTargetBreakdown = {}
    self.TargetCorruptionBreakdown = {}

    -- KBs
    self.KillingBlows = {}
    self.TotalKillingBlows = {}
    self.Kills = {}

    -- Damage taken
    self.TotalTakenHits = 0
    self.MaxDamageTaken = 0
    self.DamageTaken = 0
    self.PreviousDamageTaken = 0
    self.DamageTakenSkillMaxDamage = {}
    self.DamageTakenSkillTotalHits = {}
    self.DamageTakenSkills = {}
    self.DamageTakenTargets = {}
    self.DamageTakenTargetsSkillDamage = {}
    self.DamageTakenTargetsTotalHits = {}
    self.DamageTakenTargetsMaxDamage = {}

    self.DamageTakenType = {
        -- True damage - reflect 
        [""] = 0,

        -- Physical damages
        ["Common"] = 0,
        ["Ancient Dwarf-make"] = 0,
        ["Beleriand"] = 0,
        ["Fell-wrought"] = 0,
        ["Orc-craft"] = 0,
        ["Westernesse"] = 0,

        -- Tactical types
        ["Acid"] = 0,
        ["Fire"] = 0,
        ["Frost"] = 0,
        ["Light"] = 0,
        ["Lightning"] = 0,
        ["Shadow"] = 0,
    }
    self.DamageTakenSkillsType = {}
    self.DamageTakenTargetSkillsType = {}
    self.DamageTakenTargetType = {}

    self.DamageTakenHitType = {
        [""] = 0,
        ["critical "] = 0,
        ["devastating "] = 0,
        ["partially blocked "] = 0,
        ["partially parried "] = 0,
        ["partially evaded "] = 0,
        ["blocked"] = 0,
        ["parried"] = 0,
        ["evaded"] = 0,
        ["resisted"] = 0,
        ["immune"] = 0,
        ["missed"] = 0,
    }
    self.DamageTakenSkillsHitType = {}
    self.DamageTakenTargetSkillsHitType = {}
    self.DamageTakenTargetHitType = {}

    -- Buffs
    self.Buffs = {}
    self.BuffsSource = {}
    self.BuffsTarget = {}
    self.BuffsApplied = {}

    -- Healing
    self.TemporaryMorale = 0
    self.TotalHealing = 0
    self.HealingHits = 0
    self.HealingReceived = {}
    self.HealingReceivedHitType = {
        [""] = 0,
        ["critical "] = 0,
    }
    self.HealingReceivedSkillHitType = {}
    self.HealingRecievedSkillHits = {}

    self.HealingReceivedTotalTarget = {}
    self.HealingRecievedTargetHits = {}
    self.HealingRecievedTargetSkillHits = {}
    self.HealingReceivedSkillsTarget = {}
    self.HealingReceivedHitTypeTarget = {}
    self.HealingReceivedSkillsHitTypeTarget = {}


    self.PowerTotalHealing = 0
    self.PowerHealingHits = 0
    self.PowerHealingReceived = {}
    self.PowerHealingReceivedHitType = {
        [""] = 0,
        ["critical "] = 0,
    }
    self.PowerHealingReceivedSkillHitType = {}
    self.PowerHealingRecievedSkillHits = {}

    self.PowerHealingReceivedTotalTarget = {}
    self.PowerHealingRecievedTargetHits = {}
    self.PowerHealingRecievedTargetSkillHits = {}
    self.PowerHealingReceivedSkillsTarget = {}
    self.PowerHealingReceivedHitTypeTarget = {}
    self.PowerHealingReceivedSkillsHitTypeTarget = {}

    -- Healing applied
    self.TotalHealingApplied = 0
    self.HealingHitsApplied = 0
    self.HealingReceivedApplied = {}
    self.HealingReceivedHitTypeApplied = {
        [""] = 0,
        ["critical "] = 0,
    }
    self.HealingReceivedSkillHitTypeApplied = {}
    self.HealingRecievedSkillHitsApplied = {}

    self.HealingReceivedTotalTargetApplied = {}
    self.HealingRecievedTargetHitsApplied = {}
    self.HealingRecievedTargetSkillHitsApplied = {}
    self.HealingReceivedSkillsTargetApplied = {}
    self.HealingReceivedHitTypeTargetApplied = {}
    self.HealingReceivedSkillsHitTypeTargetApplied = {}

    
    self.PowerTotalHealingApplied = 0
    self.PowerHealingHitsApplied = 0
    self.PowerHealingReceivedApplied = {}
    self.PowerHealingReceivedHitTypeApplied = {
        [""] = 0,
        ["critical "] = 0,
    }
    self.PowerHealingReceivedSkillHitTypeApplied = {}
    self.PowerHealingRecievedSkillHitsApplied = {}

    self.PowerHealingReceivedTotalTargetApplied = {}
    self.PowerHealingRecievedTargetHitsApplied = {}
    self.PowerHealingRecievedTargetSkillHitsApplied = {}
    self.PowerHealingReceivedSkillsTargetApplied = {}
    self.PowerHealingReceivedHitTypeTargetApplied = {}
    self.PowerHealingReceivedSkillsHitTypeTargetApplied = {}


    -- Damage types totals
    self.DamagetTypeData = {
        -- True damage - reflect 
        [""] = 0,

        -- Physical damages
        ["Common"] = 0,
        ["Ancient Dwarf-make"] = 0,
        ["Beleriand"] = 0,
        ["Fell-wrought"] = 0,
        ["Orc-craft"] = 0,
        ["Westernesse"] = 0,

        -- Tactical types
        ["Acid"] = 0,
        ["Fire"] = 0,
        ["Frost"] = 0,
        ["Light"] = 0,
        ["Lightning"] = 0,
        ["Shadow"] = 0,
    }

    self.HitTypeData = {
        [""] = 0,
        ["critical "] = 0,
        ["devastating "] = 0,
        ["partially blocked "] = 0,
        ["partially parried "] = 0,
        ["partially evaded "] = 0,
        ["blocked"] = 0,
        ["parried"] = 0,
        ["evaded"] = 0,
        ["resisted"] = 0,
        ["immune"] = 0,
        ["missed"] = 0,

    }

    -- Totals
    self.CurrentTotalDamage = 0
    self.PreviousTotalDamage = 0
    self.Actions = 0
    self.ItemActions = 0
    self.MaxDamage = 0
    self.TotalHits = 0

    -- Contain all times when stack number of effects are added
    self.EffectStartTimes = {}

    -- Track stacks of effects
    self.EffectCounts = {}

    -- Encounterdata table
    self.EffectData = {}

    -- The same but for debuffs
    self.DebuffEffectData = {}
    self.DebuffTable = {}

    self:Start()
end

function Encounter:UpdateDamage(damage, damageType, hitType, skillName, target)

    -- Update total
    self.CurrentTotalDamage = self.CurrentTotalDamage + damage

    -- Add to type totals
    self.DamagetTypeData[damageType] = self.DamagetTypeData[damageType] + damage

    -- Add to type totals
    self.TotalHits = self.TotalHits + 1
    self.HitTypeData[hitType] = self.HitTypeData[hitType] + 1

    -- Max damage
    if damage > self.MaxDamage then self.MaxDamage = damage end

    -- Skill damage saving
    self:AddSkillDamage(damage, skillName, damageType, hitType)

    -- Target damage saving
    self:AddTargetDamage(damage, skillName, damageType, hitType, target)

end

function Encounter:AddTargetDamage(damage, skillName, damageType, hitType, targetName)
    if not(self.TargetDamage[targetName]) then
        self.TargetDamage[targetName] = 0
        self.TargetHits[targetName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.TargetDamageTypes[targetName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
        }
        self.TargetSkillDamage[targetName] = {}
        self.TargetSkillHits[targetName]= {}
        self.TargetSkillDamageTypes[targetName] = {}
    end

    self.TargetDamage[targetName] = self.TargetDamage[targetName] + damage
    self.TargetHits[targetName][hitType] = self.TargetHits[targetName][hitType] + 1
    self.TargetDamageTypes[targetName][damageType] = self.TargetDamageTypes[targetName][damageType] + damage

    self:AddTargetSkillDamage(damage, skillName, damageType, hitType, targetName)
end

function Encounter:AddSkillDamage(damage, skillName, damageType, hitType)
    if not(self.SkillDamage[skillName]) then
        self.SkillDamage[skillName] = 0
        self.SkillHits[skillName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.SkillDamageTypes[skillName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
        }
        self.SkillMaxDamage[skillName] = 0
        self.SkillTotalHits[skillName] = 0
    end
    if damage > self.SkillMaxDamage[skillName] then self.SkillMaxDamage[skillName] = damage end
    self.SkillTotalHits[skillName] = self.SkillTotalHits[skillName] + 1
    self.SkillDamage[skillName] = self.SkillDamage[skillName] + damage
    self.SkillHits[skillName][hitType] = self.SkillHits[skillName][hitType] + 1
    self.SkillDamageTypes[skillName][damageType] = self.SkillDamageTypes[skillName][damageType] + damage
end

function Encounter:AddTargetSkillDamage(damage, skillName, damageType, hitType, targetName)
    if not(self.TargetSkillDamage[targetName][skillName]) then
        self.TargetSkillDamage[targetName][skillName] = 0
        self.TargetSkillHits[targetName][skillName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.TargetSkillDamageTypes[targetName][skillName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
        }
    end

    self.TargetSkillDamage[targetName][skillName] = self.TargetSkillDamage[targetName][skillName] + damage
    self.TargetSkillHits[targetName][skillName][hitType] = self.TargetSkillHits[targetName][skillName][hitType] + 1
    self.TargetSkillDamageTypes[targetName][skillName][damageType] = self.TargetSkillDamageTypes[targetName][skillName][damageType] + damage
end

function Encounter:HandleCorruption(name, target)
    if not(self.CorruptionBreakdown[name]) then
        self.CorruptionBreakdown[name] = 0
    end

    self.CorruptionTotal = self.CorruptionTotal + 1

    self.CorruptionBreakdown[name] = self.CorruptionBreakdown[name] + 1

    -- Corruptoin -> target
    if not(self.CorruptionTargetBreakdown[name]) then
        self.CorruptionTargetBreakdown[name] = {}
    end

    if not(self.CorruptionsTargetTotal[target]) then
        self.CorruptionsTargetTotal[target] = 0
    end

    self.CorruptionsTargetTotal[target] = self.CorruptionsTargetTotal[target] + 1

    if not(self.CorruptionTargetBreakdown[name][target]) then
        self.CorruptionTargetBreakdown[name][target] = 0
    end

    self.CorruptionTargetBreakdown[name][target] = self.CorruptionTargetBreakdown[name][target] + 1


    -- Target -> corrutpion
    if not(self.TargetCorruptionBreakdown[target]) then
        self.TargetCorruptionBreakdown[target] = {}
    end

    if not(self.TargetCorruptionBreakdown[target][name]) then
        self.TargetCorruptionBreakdown[target][name] = 0
    end

    self.TargetCorruptionBreakdown[target][name] = self.TargetCorruptionBreakdown[target][name] + 1
end

function Encounter:UpdateKB(Source, Target)
    if not(self.KillingBlows[Source]) then
        self.KillingBlows[Source] = {}
        self.TotalKillingBlows[Source] = 0
    end

    self.TotalKillingBlows[Source] = self.TotalKillingBlows[Source] + 1

    if not(self.KillingBlows[Source][Target]) then
        self.KillingBlows[Source][Target] = 0
    end

    self.KillingBlows[Source][Target] = self.KillingBlows[Source][Target] + 1

    if not(self.Kills[Target]) then
        self.Kills[Target] = 0
    end

    self.Kills[Target] = self.Kills[Target] + 1

end

function Encounter:UpdateTakenDamage(damage, damageType, hitType, skillName, target)

    -- Update total
    self.DamageTaken = self.DamageTaken + damage

    -- Add to type totals
    self.DamageTakenType[damageType] = self.DamageTakenType[damageType] + damage

    -- Add to type totals
    self.TotalTakenHits = self.TotalTakenHits + 1
    self.DamageTakenHitType[hitType] = self.DamageTakenHitType[hitType] + 1

    -- Max damage
    if damage > self.MaxDamageTaken then self.MaxDamageTaken = damage end

    -- Skill damage saving
    self:AddSkillDamageTaken(damage, skillName, damageType, hitType)

    -- Target damage saving
    self:AddTargetDamageTaken(damage, skillName, damageType, hitType, target)

end

function Encounter:AddSkillDamageTaken(damage, skillName, damageType, hitType)
    if not(self.DamageTakenSkills[skillName]) then
        self.DamageTakenSkills[skillName] = 0
        self.DamageTakenSkillsHitType[skillName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.DamageTakenSkillsType[skillName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
        }
        self.DamageTakenSkillMaxDamage[skillName] = 0
        self.DamageTakenSkillTotalHits[skillName] = 0
    end
    if damage > self.DamageTakenSkillMaxDamage[skillName] then self.DamageTakenSkillMaxDamage[skillName] = damage end
    self.DamageTakenSkillTotalHits[skillName] = self.DamageTakenSkillTotalHits[skillName] + 1
    self.DamageTakenSkills[skillName] = self.DamageTakenSkills[skillName] + damage
    self.DamageTakenSkillsHitType[skillName][hitType] = self.DamageTakenSkillsHitType[skillName][hitType] + 1
    self.DamageTakenSkillsType[skillName][damageType] = self.DamageTakenSkillsType[skillName][damageType] + damage
end

function Encounter:AddTargetDamageTaken(damage, skillName, damageType, hitType, targetName)
    if not(self.DamageTakenTargets[targetName]) then
        self.DamageTakenTargets[targetName] = 0
        self.DamageTakenTargetHitType[targetName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.DamageTakenTargetType[targetName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
        }
        self.DamageTakenTargetsSkillDamage[targetName] = {}
        self.DamageTakenTargetSkillsHitType[targetName]= {}
        self.DamageTakenTargetSkillsType[targetName] = {}
        self.DamageTakenTargetsTotalHits[targetName] = 0
        self.DamageTakenTargetsMaxDamage[targetName] = 0
    end

    if damage > self.DamageTakenTargetsMaxDamage[targetName] then self.DamageTakenTargetsMaxDamage[targetName] = damage end
    self.DamageTakenTargetsTotalHits[targetName] = self.DamageTakenTargetsTotalHits[targetName] + 1
    self.DamageTakenTargets[targetName] = self.DamageTakenTargets[targetName] + damage
    self.DamageTakenTargetHitType[targetName][hitType] = self.DamageTakenTargetHitType[targetName][hitType] + 1
    self.DamageTakenTargetType[targetName][damageType] = self.DamageTakenTargetType[targetName][damageType] + damage

    self:AddTargetSkillDamageTaken(damage, skillName, damageType, hitType, targetName)
end

function Encounter:AddTargetSkillDamageTaken(damage, skillName, damageType, hitType, targetName)
    if not(self.DamageTakenTargetsSkillDamage[targetName][skillName]) then
        self.DamageTakenTargetsSkillDamage[targetName][skillName] = 0
        self.DamageTakenTargetSkillsHitType[targetName][skillName] = {
            [""] = 0,
            ["critical "] = 0,
            ["devastating "] = 0,
            ["partially blocked "] = 0,
            ["partially parried "] = 0,
            ["partially evaded "] = 0,
            ["blocked"] = 0,
            ["parried"] = 0,
            ["evaded"] = 0,
            ["resisted"] = 0,
            ["immune"] = 0,
            ["missed"] = 0,
        }
        self.DamageTakenTargetSkillsType[targetName][skillName] = {
            -- True damage - reflect 
            [""] = 0,

            -- Physical damages
            ["Common"] = 0,
            ["Ancient Dwarf-make"] = 0,
            ["Beleriand"] = 0,
            ["Fell-wrought"] = 0,
            ["Orc-craft"] = 0,
            ["Westernesse"] = 0,

            -- Tactical types
            ["Acid"] = 0,
            ["Fire"] = 0,
            ["Frost"] = 0,
            ["Light"] = 0,
            ["Lightning"] = 0,
            ["Shadow"] = 0,
        }
    end

    self.DamageTakenTargetsSkillDamage[targetName][skillName] = self.DamageTakenTargetsSkillDamage[targetName][skillName] + damage
    self.DamageTakenTargetSkillsHitType[targetName][skillName][hitType] = self.DamageTakenTargetSkillsHitType[targetName][skillName][hitType] + 1
    self.DamageTakenTargetSkillsType[targetName][skillName][damageType] = self.DamageTakenTargetSkillsType[targetName][skillName][damageType] + damage
end

function Encounter:HandleBuffsSource(Source, SkillName, Target)
    if not(self.Buffs[SkillName]) then
        self.Buffs[SkillName] = 0
    end

    self.Buffs[SkillName] = self.Buffs[SkillName] + 1

    if not(self.BuffsSource[SkillName]) then
        self.BuffsSource[SkillName] = {}
    end

    if not(self.BuffsSource[SkillName][Source]) then
        self.BuffsSource[SkillName][Source] = 0
    end

    self.BuffsSource[SkillName][Source] = self.BuffsSource[SkillName][Source] + 1
end

function Encounter:HandleBuffsTarget(Source, SkillName, Target)
    if not(self.BuffsApplied[SkillName]) then
        self.BuffsApplied[SkillName] = 0
    end

    self.BuffsApplied[SkillName] = self.BuffsApplied[SkillName] + 1

    if not(self.BuffsTarget[SkillName]) then
        self.BuffsTarget[SkillName] = {}
    end

    if not(self.BuffsTarget[SkillName][Target]) then
        self.BuffsTarget[SkillName][Target] = 0
    end

    self.BuffsTarget[SkillName][Target] = self.BuffsTarget[SkillName][Target] + 1
end

function Encounter:HandleHealingReceived(HitType, SkillName, Healing, Type, Source)
    if Type == "Morale" then
        self.TotalHealing = self.TotalHealing + Healing
        self.HealingHits = self.HealingHits + 1

        self.HealingReceivedHitType[HitType] = self.HealingReceivedHitType[HitType] + 1

        if not(self.HealingReceived[SkillName]) then
            self.HealingReceived[SkillName] = 0
            self.HealingRecievedSkillHits[SkillName] = 0
            self.HealingReceivedSkillHitType[SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
        end

        self.HealingRecievedSkillHits[SkillName] = self.HealingRecievedSkillHits[SkillName] + 1
        self.HealingReceived[SkillName] = self.HealingReceived[SkillName] + Healing
        self.HealingReceivedSkillHitType[SkillName][HitType] = self.HealingReceivedSkillHitType[SkillName][HitType] + 1


        -- Target
        if not(self.HealingReceivedTotalTarget[Source]) then
            self.HealingReceivedTotalTarget[Source] = 0
            self.HealingRecievedTargetHits[Source] = 0
            self.HealingReceivedHitTypeTarget[Source] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.HealingReceivedSkillsTarget[Source] = {}
            self.HealingReceivedSkillsHitTypeTarget[Source] = {}
            self.HealingRecievedTargetSkillHits[Source] = {}
        end
        self.HealingRecievedTargetHits[Source] = self.HealingRecievedTargetHits[Source] + 1
        self.HealingReceivedTotalTarget[Source] = self.HealingReceivedTotalTarget[Source] + Healing
        self.HealingReceivedHitTypeTarget[Source][HitType] = self.HealingReceivedHitTypeTarget[Source][HitType] + 1

        if not(self.HealingReceivedSkillsTarget[Source][SkillName]) then
            self.HealingReceivedSkillsTarget[Source][SkillName] = 0
            self.HealingReceivedSkillsHitTypeTarget[Source][SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.HealingRecievedTargetSkillHits[Source][SkillName] = 0
        end

        self.HealingRecievedTargetSkillHits[Source][SkillName] = self.HealingRecievedTargetSkillHits[Source][SkillName] + 1
        self.HealingReceivedSkillsTarget[Source][SkillName] = self.HealingReceivedSkillsTarget[Source][SkillName] + Healing
        self.HealingReceivedSkillsHitTypeTarget[Source][SkillName][HitType] = self.HealingReceivedSkillsHitTypeTarget[Source][SkillName][HitType] + 1    

    elseif Type == "Power" then
        self.PowerTotalHealing = self.PowerTotalHealing + Healing
        self.PowerHealingHits = self.PowerHealingHits + 1

        self.PowerHealingReceivedHitType[HitType] = self.PowerHealingReceivedHitType[HitType] + 1

        if not(self.PowerHealingReceived[SkillName]) then
            self.PowerHealingReceived[SkillName] = 0
            self.PowerHealingRecievedSkillHits[SkillName] = 0
            self.PowerHealingReceivedSkillHitType[SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
        end

        self.PowerHealingRecievedSkillHits[SkillName] = self.PowerHealingRecievedSkillHits[SkillName] + 1
        self.PowerHealingReceived[SkillName] = self.PowerHealingReceived[SkillName] + Healing
        self.PowerHealingReceivedSkillHitType[SkillName][HitType] = self.PowerHealingReceivedSkillHitType[SkillName][HitType] + 1


        -- Target
        if not(self.PowerHealingReceivedTotalTarget[Source]) then
            self.PowerHealingReceivedTotalTarget[Source] = 0
            self.PowerHealingRecievedTargetHits[Source] = 0
            self.PowerHealingReceivedHitTypeTarget[Source] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.PowerHealingReceivedSkillsTarget[Source] = {}
            self.PowerHealingReceivedSkillsHitTypeTarget[Source] = {}
            self.PowerHealingRecievedTargetSkillHits[Source] = {}
        end
        self.PowerHealingRecievedTargetHits[Source] = self.PowerHealingRecievedTargetHits[Source] + 1
        self.PowerHealingReceivedTotalTarget[Source] = self.PowerHealingReceivedTotalTarget[Source] + Healing
        self.PowerHealingReceivedHitTypeTarget[Source][HitType] = self.PowerHealingReceivedHitTypeTarget[Source][HitType] + 1

        if not(self.PowerHealingReceivedSkillsTarget[Source][SkillName]) then
            self.PowerHealingReceivedSkillsTarget[Source][SkillName] = 0
            self.PowerHealingReceivedSkillsHitTypeTarget[Source][SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.PowerHealingRecievedTargetSkillHits[Source][SkillName] = 0
        end

        self.PowerHealingRecievedTargetSkillHits[Source][SkillName] = self.PowerHealingRecievedTargetSkillHits[Source][SkillName] + 1
        self.PowerHealingReceivedSkillsTarget[Source][SkillName] = self.PowerHealingReceivedSkillsTarget[Source][SkillName] + Healing
        self.PowerHealingReceivedSkillsHitTypeTarget[Source][SkillName][HitType] = self.PowerHealingReceivedSkillsHitTypeTarget[Source][SkillName][HitType] + 1    
    end
end

function Encounter:HandleHealingApplied(HitType, SkillName, Healing, Type, Target)
    if Type == "Morale" then

        self.TotalHealingApplied = self.TotalHealingApplied + Healing
        self.HealingHitsApplied = self.HealingHitsApplied + 1

        self.HealingReceivedHitTypeApplied[HitType] = self.HealingReceivedHitTypeApplied[HitType] + 1

        if not(self.HealingReceivedApplied[SkillName]) then
            self.HealingReceivedApplied[SkillName] = 0
            self.HealingRecievedSkillHitsApplied[SkillName] = 0
            self.HealingReceivedSkillHitTypeApplied[SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
        end

        self.HealingRecievedSkillHitsApplied[SkillName] = self.HealingRecievedSkillHitsApplied[SkillName] + 1
        self.HealingReceivedApplied[SkillName] = self.HealingReceivedApplied[SkillName] + Healing
        self.HealingReceivedSkillHitTypeApplied[SkillName][HitType] = self.HealingReceivedSkillHitTypeApplied[SkillName][HitType] + 1


        -- Target
        if not(self.HealingReceivedTotalTargetApplied[Target]) then
            self.HealingReceivedTotalTargetApplied[Target] = 0
            self.HealingRecievedTargetHitsApplied[Target] = 0
            self.HealingReceivedHitTypeTargetApplied[Target] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.HealingReceivedSkillsTargetApplied[Target] = {}
            self.HealingReceivedSkillsHitTypeTargetApplied[Target] = {}
            self.HealingRecievedTargetSkillHitsApplied[Target] = {}
        end
        self.HealingRecievedTargetHitsApplied[Target] = self.HealingRecievedTargetHitsApplied[Target] + 1
        self.HealingReceivedTotalTargetApplied[Target] = self.HealingReceivedTotalTargetApplied[Target] + Healing
        self.HealingReceivedHitTypeTargetApplied[Target][HitType] = self.HealingReceivedHitTypeTargetApplied[Target][HitType] + 1

        if not(self.HealingReceivedSkillsTargetApplied[Target][SkillName]) then
            self.HealingReceivedSkillsTargetApplied[Target][SkillName] = 0
            self.HealingReceivedSkillsHitTypeTargetApplied[Target][SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.HealingRecievedTargetSkillHitsApplied[Target][SkillName] = 0
        end

        self.HealingRecievedTargetSkillHitsApplied[Target][SkillName] = self.HealingRecievedTargetSkillHitsApplied[Target][SkillName] + 1
        self.HealingReceivedSkillsTargetApplied[Target][SkillName] = self.HealingReceivedSkillsTargetApplied[Target][SkillName] + Healing
        self.HealingReceivedSkillsHitTypeTargetApplied[Target][SkillName][HitType] = self.HealingReceivedSkillsHitTypeTargetApplied[Target][SkillName][HitType] + 1    

    elseif Type == "Power" then
        self.PowerTotalHealingApplied = self.PowerTotalHealingApplied + Healing
        self.PowerHealingHitsApplied = self.PowerHealingHitsApplied + 1

        self.PowerHealingReceivedHitTypeApplied[HitType] = self.PowerHealingReceivedHitTypeApplied[HitType] + 1

        if not(self.PowerHealingReceivedApplied[SkillName]) then
            self.PowerHealingReceivedApplied[SkillName] = 0
            self.PowerHealingRecievedSkillHitsApplied[SkillName] = 0
            self.PowerHealingReceivedSkillHitTypeApplied[SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
        end

        self.PowerHealingRecievedSkillHitsApplied[SkillName] = self.PowerHealingRecievedSkillHitsApplied[SkillName] + 1
        self.PowerHealingReceivedApplied[SkillName] = self.PowerHealingReceivedApplied[SkillName] + Healing
        self.PowerHealingReceivedSkillHitTypeApplied[SkillName][HitType] = self.PowerHealingReceivedSkillHitTypeApplied[SkillName][HitType] + 1


        -- Target
        if not(self.PowerHealingReceivedTotalTargetApplied[Target]) then
            self.PowerHealingReceivedTotalTargetApplied[Target] = 0
            self.PowerHealingRecievedTargetHitsApplied[Target] = 0
            self.PowerHealingReceivedHitTypeTargetApplied[Target] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.PowerHealingReceivedSkillsTargetApplied[Target] = {}
            self.PowerHealingReceivedSkillsHitTypeTargetApplied[Target] = {}
            self.PowerHealingRecievedTargetSkillHitsApplied[Target] = {}
        end
        self.PowerHealingRecievedTargetHitsApplied[Target] = self.PowerHealingRecievedTargetHitsApplied[Target] + 1
        self.PowerHealingReceivedTotalTargetApplied[Target] = self.PowerHealingReceivedTotalTargetApplied[Target] + Healing
        self.PowerHealingReceivedHitTypeTargetApplied[Target][HitType] = self.PowerHealingReceivedHitTypeTargetApplied[Target][HitType] + 1

        if not(self.PowerHealingReceivedSkillsTargetApplied[Target][SkillName]) then
            self.PowerHealingReceivedSkillsTargetApplied[Target][SkillName] = 0
            self.PowerHealingReceivedSkillsHitTypeTargetApplied[Target][SkillName] = {
                [""] = 0,
                ["critical "] = 0,
            }
            self.PowerHealingRecievedTargetSkillHitsApplied[Target][SkillName] = 0
        end

        self.PowerHealingRecievedTargetSkillHitsApplied[Target][SkillName] = self.PowerHealingRecievedTargetSkillHitsApplied[Target][SkillName] + 1
        self.PowerHealingReceivedSkillsTargetApplied[Target][SkillName] = self.PowerHealingReceivedSkillsTargetApplied[Target][SkillName] + Healing
        self.PowerHealingReceivedSkillsHitTypeTargetApplied[Target][SkillName][HitType] = self.PowerHealingReceivedSkillsHitTypeTargetApplied[Target][SkillName][HitType] + 1    
    end
end

function Encounter:EffectAdded(effect)
    -- Combine name and icon to avoid name conflicts
    local name = string.format("%s@@%s", effect:GetName(), effect:GetIcon())

    -- Create tables on first encounter
    if not(self.EffectStartTimes[name]) then
        self.EffectStartTimes[name] = {}
        self.EffectCounts[name] = 0
    end

    -- Add stack
    self.EffectCounts[name] = self.EffectCounts[name] + 1

    -- Create uptime table
    if not(self.EffectStartTimes[name][self.EffectCounts[name]]) then
        self.EffectStartTimes[name][self.EffectCounts[name]] = 0
    end

    -- Set the start time of an effect for a specific stack
    self.EffectStartTimes[name][self.EffectCounts[name]] = Turbine.Engine.GetGameTime()

    if effect:IsDebuff() then
        self.DebuffTable[name] = true
    end
end

function Encounter:EffectRemoved(effect)
    local name = string.format("%s@@%s", effect:GetName(), effect:GetIcon())

    -- Add uptime to total (Application time till removal time)
    local newName = string.format("%s@@%s", name, self.EffectCounts[name])

    -- Debuff tracking
    if self.DebuffTable[name] then
        if not(self.DebuffEffectData[newName])  then
            self.DebuffEffectData[newName] = 0
        end
        self.DebuffEffectData[newName] = self.DebuffEffectData[newName] + (Turbine.Engine.GetGameTime() - self.EffectStartTimes[name][self.EffectCounts[name]])
    else
        if not(self.EffectData[newName])  then
            self.EffectData[newName] = 0
        end
        self.EffectData[newName] = self.EffectData[newName] + (Turbine.Engine.GetGameTime() - self.EffectStartTimes[name][self.EffectCounts[name]])
    end

    -- Reduce stack after completing bookkeeping
    self.EffectCounts[name] = self.EffectCounts[name] - 1
end

function Encounter:AddTemporaryMorale(Amount)
    self.TemporaryMorale = self.TemporaryMorale + Amount
end

function Encounter:GetTargetInfo()
    return self.TargetDamage, self.TargetHits, self.TargetDamageTypes
end

function Encounter:GetSkillInfo()
    return self.SkillDamage, self.SkillHits, self.SkillDamageTypes
end

function Encounter:Update()
    self.currentGameTime = Turbine.Engine.GetGameTime()
    if self.currentGameTime == self.oldGameTime then
        return(true)
    end
    local delta = self.currentGameTime - self.oldGameTime
    if delta < self.UpdateDelay then return end

    self.oldGameTime = numberRound(self.currentGameTime, self.decimalPlaces)

    if self.player:IsInCombat() then
        --self.CurrentItem = self.CurrentItem + 1

        local combatTime = string.format("%ds", self.currentGameTime - self.CombatStartTime)
        table.insert(self.DPSMapped, {combatTime, self.CurrentTotalDamage / (Turbine.Engine.GetGameTime() - self.CombatStartTime)})
        table.insert(self.PowerMapped, {combatTime, self.player:GetPower()})
        table.insert(self.MoraleMapped, {combatTime, self.player:GetMorale()})
        table.insert(self.DamageMapped, {combatTime, self.CurrentTotalDamage - self.PreviousTotalDamage})
        table.insert(self.DamageTakenMapped, {combatTime, self.DamageTaken - self.PreviousDamageTaken})

        self.PreviousTotalDamage = self.CurrentTotalDamage
        self.PreviousDamageTaken = self.DamageTaken
        --self.AdddamageContainerItem(self.DPSMapped[self.CurrentTimeStamp], currentGameTime)

        --smallPP:SetDPS(self.DPSMapped[self.oldGameTime])
        --ChatOutput(self.CurrentTotalDamage / (Turbine.Engine.GetGameTime() - self.CombatStartTime) / 50000 * 200)
    end
end

function Encounter:Start()
    self:SetWantsUpdates(true)

    self.playerEffects = self.player:GetEffects()
    for i = 1, self.playerEffects:GetCount() do
        self:EffectAdded(self.playerEffects:Get(i))
    end

    self.effectAddedCallback = AddCallback(self.playerEffects, "EffectAdded", function(sender, args)
        self:EffectAdded(self.playerEffects:Get(args.Index))
    end)

    self.effectRemovedCallback = AddCallback(self.playerEffects, "EffectRemoved", function(sender, args)
        if args.Effect then
            self:EffectRemoved(args.Effect)
        end
    end)
end

function Encounter:Stop()
    self:SetWantsUpdates(false)

    self.CombatEndTime = Turbine.Engine.GetGameTime()

    RemoveCallback(self.playerEffects, "EffectAdded", self.effectAddedCallback)
    RemoveCallback(self.playerEffects, "EffectRemoved", self.effectRemovedCallback)

    for effectName, effectCount in pairs(self.EffectCounts) do
        if effectCount > 0 then
            for i = 1, effectCount do
                local longName = string.format("%s@@%s", effectName, i)
                if self.EffectStartTimes[effectName] and self.EffectStartTimes[effectName][self.EffectCounts[effectName]] then
                    if self.DebuffTable[effectName] then
                        if not(self.DebuffEffectData[longName]) then
                            self.DebuffEffectData[longName] = 0
                        end
                        self.DebuffEffectData[longName] = self.DebuffEffectData[longName] + (Turbine.Engine.GetGameTime() - self.EffectStartTimes[effectName][self.EffectCounts[effectName]])
                    else
                        if not(self.EffectData[longName]) then
                            self.EffectData[longName] = 0
                        end
                        self.EffectData[longName] = self.EffectData[longName] + (Turbine.Engine.GetGameTime() - self.EffectStartTimes[effectName][self.EffectCounts[effectName]])
                    end
                end
            end
        end
    end
end

function Encounter:GetTotalDamage()
    return self.CurrentTotalDamage
end

function Encounter:GetTotalCrit()
    return self.HitTypeData["critical "]
end

function Encounter:GetTotalCritPercentage()
    return self.HitTypeData["critical "] / self.TotalHits * 100
end

function Encounter:GetDPS()
    return self.DPSMapped[self.oldGameTime]
end

function Encounter:GetInformation()
    return self:GetData()
end

function Encounter:GetData()
    return {
        ["DPSMapped"] = self.DPSMapped,

        -- Skill Data
        ["SkillsMapped"] = self.SkillsMapped,
        ["ItemsMapped"] = self.ItemsMapped,
        ["SkillIcons"] = self.SkillIcons,
        ["SkillDamage"] = self.SkillDamage,
        ["SkillHits"] = self.SkillHits,
        ["SkillDamageTypes"] = self.SkillDamageTypes,
        ["SkillMaxDamage"] = self.SkillMaxDamage,
        ["SkillTotalHits"] = self.SkillTotalHits,

        -- Target Skill Data
        ["TargetSkillsMapped"] = self.TargetSkillsMapped,
        ["TargetItemsMapped"] = self.TargetItemsMapped,
        ["TargetSkillIcons"] = self.TargetSkillIcons,
        ["TargetSkillDamage"] = self.TargetSkillDamage,
        ["TargetSkillHits"] = self.TargetSkillHits,
        ["TargetSkillDamageTypes"] = self.TargetSkillDamageTypes,
        ["TargetSkillMaxDamage"] = self.SkillMaxDamage,
        ["TargetSkillTotalHits"] = self.SkillTotalHits,
    
        -- Target Data
        ["TargetDamage"] = self.TargetDamage,
        ["TargetHits"] = self.TargetHits,
        ["TargetDamageTypes"] = self.TargetDamageTypes,
    
        -- Misc tracking
        ["TargetBreakdown"] = self.TargetBreakdown,
        ["PowerMapped"] = self.PowerMapped,
        ["MoraleMapped"] = self.MoraleMapped,
        ["DamageMapped"] = self.DamageMapped,
    
        -- Damage types totals
        ["DamagetTypeData"] = self.DamagetTypeData,
    
        ["HitTypeData"] = self.HitTypeData,
    
        -- Totals
        ["CurrentTotalDamage"] = self.CurrentTotalDamage,
        ["Actions"] = self.Actions,
        ["ItemActions"] = self.ItemActions,
        ["MaxDamage"] = self.MaxDamage,
        ["TotalHits"] = self.TotalHits,

        ["CombatStartTime"] = self.CombatStartTime,
        ["Date"] = self.date,
    }
end

function Encounter:Unload()
    self:SetParent(nil)
    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    for key, _ in pairs(self) do
        self[key] = nil
    end
    collectgarbage()
end