function ConvertEntry(entry)
    if type(entry) == "number" then return ("<num>" .. tostring(entry)) end
    if type(entry) == "table" then return ConvertTable(entry) end
    return entry
end

function RecoverEntry(entry)
    if type(entry) == "string" then 
        if string.find(entry, "<num>") then
            return tonumber(string.sub(entry, string.find(entry, ">") + 1, string.len(entry)))
        else
            return entry
        end
    elseif type(entry) == "table" then
        return RecoverTable(entry)
    end
    return entry
end

function ConvertTable(T)
    if T == nil then return nil end
    local Copy = {}
    for key, value in pairs(T) do 
        Copy[ConvertEntry(key)] = ConvertEntry(value)
    end
    return Copy
end

function RecoverTable(T)
    if T == nil then return nil end
    local Copy = {}
    for key, value in pairs(T) do 
        Copy[RecoverEntry(key)] = RecoverEntry(value)
    end
    return Copy
end

function SaveTable(Scope, FileName, Table)
    Turbine.PluginData.Save(Scope, FileName, ConvertTable(Table))
end

function LoadTable(Scope, FileName)
    return RecoverTable(Turbine.PluginData.Load(Scope, FileName))
end



--[[
function TableToString(Table, TableName, Indent)

    local OutputString = string.rep( " ", Indent * 4 ) .. "[" .. HandleValueType(TableName) .. "] = \n" .. string.rep( " ", Indent * 4 )  .."{\n"

    for key, value in pairs(Table) do
        if type(value) == "table" then
            OutputString = OutputString .. string.rep( " ", (Indent) * 4) .. TableToString(value, key, Indent + 1)
        else            
            OutputString = OutputString .. string.rep( " ", (Indent + 1) * 4) .. "[" .. HandleValueType(key) .. "] = " .. HandleValueType(value) .. ",\n"
        end
    end

    OutputString = OutputString .. string.rep( " ", (Indent) * 4)  .. "},\n"

    return OutputString
end

--]]
function HandleValueType(Value)
    local ValueType = type(Value)

    if ValueType == "number" then
        return Value
    elseif Value == nil then
        return ""
    end

    return Value
end

function tablelength(T)
    local count = 0
    if T ~= nil and type(T) == "table" then
        for _ in pairs(T) do count = count + 1 end
    end
    return count
end



-- [[
function TableToString(T, TableName)
    --local OutputString = "Table start: " .. TableName .. "-;"
    bigPP:AddText("Table start: " .. TableName .. "-;")

    --ChatOutput(TableName)
    for key, value in pairs(T) do
        --ChatOutput(key)
        --ChatOutput(value)
        --OutputString = OutputString .. HandleValueType(key) .. "=" .. HandleValueType(value) .. ";"
        bigPP:AddText(HandleValueType(key) .. "=" .. HandleValueType(value) .. ";")
    end

    --OutputString = OutputString .. "Table End: " .. TableName .. "|"
    bigPP:AddText("Table End: " .. TableName .. "|")

    --ChatOutput(OutputString)
    --return OutputString
end
--]]

function StringToTable(InputString)

    local OutputTable = {}
    for TableString in string.gmatch(InputString, "([^|]+)") do
        local TableName = string.match(TableString, "Table start: (.+)-")
        ChatOutput(TableName)

        OutputTable[TableName] = {}
        for string in string.gmatch(TableString, "([^;]+)") do
            if string.find(string, "Table End") then break end
            if not(string.find(string, "Table start:")) then
                local key, value = string.match(string, "(.*)=(.*)")
                --ChatOutput(key)
                --ChatOutput(value)
                OutputTable[TableName][key] = value
            end
        end
    end

    return OutputTable
end

--Table start: DPSMapped-;426119855.23086=11172.406157685;426119849.62709=12304.791486413Table End: DPSMapped|

--local test = StringToTable("Table start: DPSMapped-;426119855.23086=11172.406157685;426119849.62709=12304.791486413;Table End: DPSMapped|")
--local test = StringToTable([[Table start: Misc data-;"EndingDPS"=1426.7445533397;"ItemActions"=0;"Total Hits"=7;"Start Time"=426120998.44168;"Total Crits"=0;"Total Devs"=0;"Total Damage"=25925;"Actions"=6;"End Time"=426121016.6206;Table End: Misc data|]])


--[[
    NestTestTable = {
    [7] = 9,
    [10] = "11",

}

TestTable = {
    [5] = "Testing", 
    [6] = 7,
    --["Test"] = NestTestTable
}

--Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Target, false )
--ChatOutput(type(TestTable))
--ChatOutput("\n" .. TableToString(TestTable, "DPSMapped", 0) .. TableToString(TestTable, "DPSMapped", 0))
--StringToTable(TableToString(TestTable, "DPSMapped"))

for key, value in pairs( StringToTable(TableToString(TestTable, "DPSMapped", 0) .. TableToString(TestTable, "Test", 0))) do
    ChatOutput(key)
    for key2, value2 in pairs(value) do
        ChatOutput(key2)
        ChatOutput(value2)
    end
end
--]]