ChatHandler = class(Turbine.Object)
function ChatHandler:Constructor(combatHandler)
    Turbine.Object.Constructor(self)

    self.combatHandler = combatHandler
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.playerName = self.player:GetName()

    self.DamageEvent = function(sender, event, args)
        if type(event)=="function" then
            event(args)
        else
            if type(event)=="table" then
                for i=1,#event do
                    if type(event[i])=="function" then
                        event[i](args)
                    end
                end
            end
        end
    end

    Turbine.Chat.Received = function(sender, args)
        if args.ChatType == Turbine.ChatType.PlayerCombat then

            -- Remove all colour 
            local removedColours = string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1")

            -- Damage case
            if string.find(removedColours, "hit with") then
                local Source, HitType, SkillName, Target, Damage, damageType = string.match(removedColours,"^(.*) scored a (.*)hit with (.*) on (.*) for (.-) (.*)%.$")
                --Rolorion reflected 1,106 Fire damage to the Morale of the Training Snowman.
                --Rolorion scored a hit with Defiant Challenge Retaliation on the Training Snowman for 10,249 damage to Morale.
                --Snorpel scored a hit with Fist of the Valar on the Training Snowman for 126,779 (68,461 from 3 Mettle) Beleriand damage to Morale.
                -- MrMits scored a hit with Benediction of the Raven on the Training Snowman. buff/debuff
                -- Rotorin applied a benefit with Writ of Health on Rotorin.

        
                if Damage then
                    if string.find(damageType, "%(") then
                        
                        local Extra, Type, MP = string.match(damageType, "%((.*)%) (.*)%sdamage to (.*)$")

                        if MP ~= "Morale" and Type then return end

                        self.combatHandler:HandleDamage(tonumber(Damage:gsub(",", ""), 10), Type or "", HitType, SkillName, string.gsub(Target,"^[Tt]he ",""))
                        return
                    else
                        
                        local Type, MP = string.match(damageType, "(.*)%sdamage to (.*)$")

                        if MP ~= "Morale" and Type then return end

                        self.combatHandler:HandleDamage(tonumber(Damage:gsub(",", ""), 10), Type or "", HitType, SkillName, string.gsub(Target,"^[Tt]he ",""))
                        return
                    end

                end

                local Source, HitType, SkillName, Target = string.match(removedColours,"^(.*) scored a (.*)hit with (.*) on (.*)%.$")

                if SkillName then
                    self.combatHandler:HandleDamage(0, "", HitType, SkillName, string.gsub(Target,"^[Tt]he ",""))
                end
                return
            elseif string.find(removedColours, "heal with ") then

                -- Rotorin applied a critical heal with Writ of Health - Tier 1 to Testobject restoring 23,187 points to Morale. other
                local Source, HitType, SkillName, Target, Healing, MPType = string.match(removedColours,"^(.*) applied a (.*)heal with (.*) to (.*) restoring (.*) points to (.*)%.$")

                if Target == self.playerName then
                    self.combatHandler:HandleHealingReceived(HitType, SkillName, tonumber(Healing:gsub(",", ""), 10), MPType, string.gsub(Source,"^[Tt]he ",""))
                end

                if Source == self.playerName then
                    self.combatHandler:HandleHealingApplied(HitType, SkillName, tonumber(Healing:gsub(",", ""), 10), MPType, string.gsub(Target,"^[Tt]he ",""))
                    return
                end

                --The Training-dummy reflected 794 points restored to the Morale of Bazaquezufegs.
            elseif string.find(removedColours, "points restored to the") then

                local Source, Amount, Target = string.match(removedColours,"^(.*) reflected (.*) points restored to the Morale of (.*)%.$")

                if Source and Target == self.playerName then
                    self.combatHandler:HandleHealingReceived("", "Reflect", tonumber(Amount:gsub(",", ""), 10), "Morale", string.gsub(Source,"^[Tt]he ",""))
                    return
                end

            elseif string.find(removedColours, "heal to ") then

                -- Writ of Health - Tier 1 applied a critical heal to Rotorin restoring 22,990 points to Morale. self
                local SkillName, HitType, Target, Healing, MPType = string.match(removedColours,"^(.*) applied a (.*)heal to (.*) restoring (.*) points to (.*)%.$")

                if Target == self.playerName then
                    self.combatHandler:HandleHealingReceived(HitType, SkillName, tonumber(Healing:gsub(",", ""), 10), MPType, self.playerName)

                    self.combatHandler:HandleHealingApplied(HitType, SkillName, tonumber(Healing:gsub(",", ""), 10), MPType, self.playerName)
                    return
                else
                end
                return
            elseif string.find(removedColours, "points of temporary Morale!") then

                local Amount = string.match(removedColours,"^You have lost (.*) points of temporary Morale!$")

                --You have lost 32 points of temporary Morale!
                self.combatHandler:AddTemporaryMorale(tonumber(Amount:gsub(",", ""), 10))

            elseif string.find(removedColours, "applied a benefit with") then
                             -- Rotorin applied a benefit with Writ of Health on Rotorin.
                local Source, SkillName, Target = string.match(removedColours,"^(.*) applied a benefit with (.*) on (.*)%.$")

                if Target == self.playerName then
                    self.combatHandler:HandleBuffSource(string.gsub(Source,"^[Tt]he ",""), SkillName, string.gsub(Target,"^[Tt]he ",""))
                end
                if Source == self.playerName then
                    self.combatHandler:HandleBuffTarget(string.gsub(Source,"^[Tt]he ",""), SkillName, string.gsub(Target,"^[Tt]he ",""))
                    return
                end
                return
            elseif string.find(removedColours, "reflected") then
                local Source, Damage, Type, Target = string.match(removedColours,"^(.*) reflected (.*) (.*) damage to the Morale of (.*)%.$")

                if Damage then
                    self.combatHandler:HandleDamage(tonumber(Damage:gsub(",", ""), 10), Type, "", "Reflect", string.gsub(Target,"^[Tt]he ",""))
                end
                return
            elseif string.find(removedColours, "dispelled") then
                local effectName, target = string.match(removedColours, "You have dispelled (.*) from (.*).")
                if effectName then
                    self.combatHandler:HandleCorruption(effectName, target)
                    return
                end
                return
            elseif string.find(removedColours, "tried to") then
                --Rolorion tried to use Warden's Taunt on the High Sorceress but she resisted the attempt.
                --The Angmarim tried to use a melee double attack on Rolorion but he parried the attempt.

                if string.find(removedColours, " but it ") then
                    local Source, SkillName, Target, FailType = string.match(removedColours,"^(.*) tried to use (.*) on (.*) but it (.*) the attempt.$")

                    if string.find(FailType, "was immune to") then
                        FailType = "immune"
                    end

                    if Source then
                        self.combatHandler:HandleDamage(0, "", FailType, SkillName, string.gsub(Target,"^[Tt]he ",""))
                        return
                    end
                else
                    local Source, SkillName, Target, FailType = string.match(removedColours,"^(.*) tried to use (.*) on (.*) but s?he (.*) the attempt.$")

                    if string.find(FailType, "was immune to") then
                        FailType = "immune"
                    end
                    
                    if Source then
                        self.combatHandler:HandleDamage(0, "", FailType, SkillName, string.gsub(Target,"^[Tt]he ",""))
                        return
                    end
                end
                return
            elseif string.find(removedColours, "missed trying to use") then
                local Source, SkillName, Target = string.match(removedColours, "^(.*) missed trying to use (.*) on (.*).$")

                if Source and Source == self.playerName then
                    self.combatHandler:HandleDamageTaken(0, "", "missed", SkillName, string.gsub(Target,"^[Tt]he ",""))
                    return
                end
            end
        elseif args.ChatType == Turbine.ChatType.Death then
            local removedColours = string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1")
            if string.find(removedColours, "defeated") then
                local Source, Target = string.match(removedColours,"^(.*) defeated (.*)%.$")

                if Source then
                    if Source == "Your mighty blow" then
                        Source = self.playerName
                    end

                    self.combatHandler:HandleKB(string.gsub(Source,"^[Tt]he ",""), string.gsub(Target,"^[Tt]he ",""))
                    return
                end
            end
        elseif args.ChatType == Turbine.ChatType.EnemyCombat then
            local removedColours = string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1")
            -- Damage case
            if string.find(removedColours, "hit with") then
                local Source, HitType, SkillName, Target, Damage, damageType = string.match(removedColours,"^(.*) scored a (.*)hit with (.*) on (.*) for (.-) (.*)%.$")
                --Rolorion reflected 1,106 Fire damage to the Morale of the Training Snowman.
                --Rolorion scored a hit with Defiant Challenge Retaliation on the Training Snowman for 10,249 damage to Morale.
                --Snorpel scored a hit with Fist of the Valar on the Training Snowman for 126,779 (68,461 from 3 Mettle) Beleriand damage to Morale.

        
                if Damage and self.playerName == Target then
                    if string.find(damageType, "%(") then
                        
                        local Extra, Type, MP = string.match(damageType, "%((.*)%) (.*)%sdamage to (.*)$")

                        if MP ~= "Morale" and Type then return end

                        self.combatHandler:HandleDamageTaken(tonumber(Damage:gsub(",", ""), 10), Type or "", HitType, SkillName, string.gsub(Source,"^[Tt]he ",""))
                    else
                        
                        local Type, MP = string.match(damageType, "(.*)%sdamage to (.*)$")

                        if MP ~= "Morale" and Type then return end

                        self.combatHandler:HandleDamageTaken(tonumber(Damage:gsub(",", ""), 10), Type or "", HitType, SkillName, string.gsub(Source,"^[Tt]he ",""))
                    end

                end
                return
            elseif string.find(removedColours, "tried to") then
                --Rolorion tried to use Warden's Taunt on the High Sorceress but she resisted the attempt.
                --The Angmarim tried to use a melee double attack on Rolorion but he parried the attempt.

                if string.find(removedColours, " but it ") then
                    local Source, SkillName, Target, FailType = string.match(removedColours,"^(.*) tried to use (.*) on (.*) but it (.*) the attempt.$")

                    if string.find(FailType, "was immune to") then
                        FailType = "immune"
                    end

                    if Target and Target == self.playerName then
                        self.combatHandler:HandleDamageTaken(0, "", FailType, SkillName, string.gsub(Source,"^[Tt]he ",""))
                        return
                    end
                else
                    local Source, SkillName, Target, FailType = string.match(removedColours,"^(.*) tried to use (.*) on (.*) but s?he (.*) the attempt.$")

                    if string.find(FailType, "was immune to") then
                        FailType = "immune"
                    end
                    
                    if Target and Target == self.playerName then
                        self.combatHandler:HandleDamageTaken(0, "", FailType, SkillName, string.gsub(Source,"^[Tt]he ",""))
                        return
                    end
                end
            elseif string.find(removedColours, "missed trying to use") then
                local Source, SkillName, Target = string.match(removedColours, "^(.*) missed trying to use (.*) on (.*).$")

                if Target and Target == self.playerName then
                    self.combatHandler:HandleDamageTaken(0, "", "missed", SkillName, string.gsub(Source,"^[Tt]he ",""))
                    return
                end
            elseif string.find(removedColours, "reflected") then
                local Source, Damage, Type, Target = string.match(removedColours,"^(.*) reflected (.*) (.*) damage to the Morale of (.*)%.$")

                if Damage then
                    if Source == self.playerName then
                        self.combatHandler:HandleDamage(tonumber(Damage:gsub(",", ""), 10), Type, "", "Reflect", string.gsub(Target,"^[Tt]he ",""))
                    else
                        self.combatHandler:HandleDamageTaken(tonumber(Damage:gsub(",", ""), 10), Type, "", "Reflect", string.gsub(Target,"^[Tt]he ",""))
                    end
                    return
                end
                
            end
            --ChatOutput(removedColours)
        end
    end
end


