OptionsButton=class(Turbine.UI.Window) 
function OptionsButton:Constructor(dataWindow)
    Turbine.UI.Window.Constructor(self)
    self:SetPosition(Settings.OptionsButtonX, Settings.OptionsButtonY)
    self:SetSize(32,32)
    self:SetVisible(true)
    self:SetBackground("PrimePlugins/RaidTools/Images/ParseLogo.tga")
    self:SetZOrder(100)
    self:SetWantsKeyEvents(true)

    self.dataWindow = dataWindow

    self.menu = Turbine.UI.ContextMenu()
    self.menuItems = self.menu:GetItems()

    local menuItem = Turbine.UI.MenuItem("Add window")

    menuItem.Click = function()
        CombatWindowHandler:AddWindow()
    end
    
    self.menuItems:Add(menuItem)

    -- Move logic
    self.Moving = false

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
    
    self.MouseUp = function()
        self.Moving = false
    end
    
    self.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    self.MouseClick = function(sender, args)
        --[[
        if self.dataWindow and args.Button == Turbine.UI.MouseButton.Left then
            self.dataWindow:SetVisible(not(self.dataWindow:IsVisible()))
        elseif args.Button == Turbine.UI.MouseButton.Left then
            
        end
        --]]
        self.menu:ShowMenu()
    end

    self.KeyDown = function(sender, args)
        if args.Action == 268435635 then
            self:SetVisible(not(self:IsVisible()))
        end
    end
end

function OptionsButton:Unload()
    Settings.OptionsButtonX, Settings.OptionsButtonY = self:GetPosition()
end