local baseImageID = 0x41007E35

EffectBox = class(Turbine.UI.Control)
function EffectBox:Constructor(parent, effect, size)
    Turbine.UI.Control.Constructor( self )
    self:SetSize(size, size)
    self:SetParent(parent)
    self:SetMouseVisible(false)

    self.duration = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
    self.overlaydDuration = effect:GetDuration()
    self.name = effect:GetName()
    self.startTime = effect:GetStartTime()
    self.size = size

    self.lastDuration = self.duration + 1

    local iconLabel = Turbine.UI.Lotro.EffectDisplay()
    iconLabel:SetEffect(effect)
    iconLabel:SetParent(self)
    --iconLabel:SetPosition(1,1)
    iconLabel:SetSize(size, size)
    iconLabel:SetVisible(true)
    iconLabel:SetMouseVisible(false)

    self.CountDownLabel = Turbine.UI.Label()
    self.CountDownLabel:SetParent(self)
    self.CountDownLabel:SetSize(size, size)
    self.CountDownLabel:SetVisible(true)
    self.CountDownLabel:SetStretchMode(1)
    self.CountDownLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.CountDownLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.CountDownLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.CountDownLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.CountDownLabel:SetMultiline(false)
    self.CountDownLabel:SetMouseVisible(false)
    self.CountDownLabel:SetZOrder(100)

    if self.duration < 999999 then self.CountDownLabel:SetText(math.floor(self.duration + 0.5)) end
    --self.CountDownLabel:SetZOrder(100)

    self.elapsedOverlay = Turbine.UI.Control()
	self.elapsedOverlay:SetStretchMode( 1 )
	self.elapsedOverlay:SetMouseVisible( false )
	self.elapsedOverlay:SetZOrder( 99 )
	self.elapsedOverlay:SetOpacity( 0.7 )
	self.elapsedOverlay:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
	self.elapsedOverlay:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.elapsedOverlay:SetParent( self )
    self.elapsedOverlay:SetSize(size, size)

end

function EffectBox:UpdateText(delta)
    if self.duration > 999999 then return end
    self.duration = self.duration - delta

    local percentComplete = (Turbine.Engine.GetGameTime() - self.startTime) / self.overlaydDuration

	local imageId = baseImageID + math.floor( 60 * percentComplete )

	self.elapsedOverlay:SetStretchMode( 3 )
	self.elapsedOverlay:SetPosition( 1, 1 )
	self.elapsedOverlay:SetSize( 32, 32 )
	self.elapsedOverlay:SetBackground( imageId )

	--local width, height = self:GetSize()
	self.elapsedOverlay:SetStretchMode( 1 )
    self.elapsedOverlay:SetSize( self.size - 2, self.size - 2 )
    
    if self.lastDuration <= self.duration then return end

    self.lastDuration = math.floor(self.duration)

    self.CountDownLabel:SetStretchMode(nil)
    self.CountDownLabel:SetStretchMode(1)

    if self.duration > 3600 then
        self.CountDownLabel:SetText(math.floor(self.duration /3600) .. "h")
    elseif self.duration > 120 then
        self.CountDownLabel:SetText(math.floor(self.duration / 60) .. "m")
    elseif self.duration >= 0 then
        self.CountDownLabel:SetText(math.floor(self.duration))
    elseif self.duration < 0 then
        self.CountDownLabel:SetText("")
    end
end

function EffectBox:GetValue()
    return self.duration
end

function EffectBox:GetName()
    return self.name
end