import "PrimePlugins.PartyVitals"

PluginString = "<rgb=#FF9900><Prime Party Vitals></rgb> "

Reloader = class(Turbine.UI.Control)
function Reloader:Constructor()
    Turbine.UI.Control.Constructor(self)
    self:SetWantsUpdates(true)
    self.reloaded = false
    self.Update = function()
        if self.reloaded then
            self:SetWantsUpdates(false)    
        elseif not(self.reloaded) then 
            Turbine.PluginManager.UnloadScriptState("~PrimePartyVitalsReloader")
            self.reloaded = true
            self:SetParent(nil)
        end
    end
end

function ReloadPlugin()
    Turbine.PluginManager.LoadPlugin("~PrimePartyVitalsReloader")
end

local r = Reloader()

UpdateSettings()
SetCommands()

Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Party, false )

PartyVitals = PartyWindow()

Options = nil --OptionOptions()

PrimePlugins.RaidTools.ChatOutput("<rgb=#FF9900>"..plugin:GetName() .. " Version " .. plugin:GetVersion() .." loaded.</rgb>") 

plugin.Unload = function() 
    PartyVitals:RemoveCallbacks()
    SaveData()
    Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Party, true )
end