PartyWindow = class( Turbine.UI.Window)
function PartyWindow:Constructor()
    Turbine.UI.Window.Constructor( self )

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.Party = self.player:GetParty()

    self.VitalWindows = {}
    self.callbacks = {}

    self:SetPosition(Settings.VX, Settings.VY)
    self:SetVisible(true)
    self:SetOpacity(0.8)
    --self:SetBackColor(Turbine.UI.Color(0,0,0))

    self.Setup = Settings.FrameVersion

    self.UpdateTicket = 1
    self.PartyNames = {}
    self.Names = {}

    self.UpdateMethod = 1

    if self.Party == nil then return end 

    for i = 1, self.Party:GetMemberCount(), 1 do
        self.PartyNames[i] = self.Party:GetMember(i):GetName()
        self.Names[self.Party:GetMember(i):GetName()] = true
    end

    if self.Setup == 1 then
        -- Big setup vertical
        self:SetSize(154 * math.ceil(self.Party:GetMemberCount() / 6), math.min(self.Party:GetMemberCount(), 6) * 94 )

        for i = 1, self.Party:GetMemberCount(), 1 do
            self.VitalWindows[self.Party:GetMember(i):GetName()] = VitalWindow(self, self.Party:GetMember(i), math.floor((i - 1) / 6), (i - 1) % 6, 150, 70, 3, 28, 2, 6, self.Party:GetMember(i):GetName() == self.Party:GetLeader():GetName(), self.UpdateMethod)
        end

    elseif self.Setup == 2 then
        -- Big setup horizontal
        self:SetSize(154 * math.min(self.Party:GetMemberCount(), 4), math.ceil(self.Party:GetMemberCount() / 4) * 94 )

        for i = 1, self.Party:GetMemberCount(), 1 do
            self.VitalWindows[self.Party:GetMember(i):GetName()] = VitalWindow(self, self.Party:GetMember(i), (i - 1) % 4, math.floor((i - 1) / 4), 150, 70, 3, 28, 2, 6, self.Party:GetMember(i):GetName() == self.Party:GetLeader():GetName(), self.UpdateMethod)
        end

    elseif self.Setup == 3 then

        -- Minimalist Setup
        self:SetSize(254, self.Party:GetMemberCount() * 32 )

        for i = 1, self.Party:GetMemberCount(), 1 do
            self.VitalWindows[self.Party:GetMember(i):GetName()] = VitalWindow(self, self.Party:GetMember(i), 0, i - 1, 150, 28, 152, 0, 1, 8, self.Party:GetMember(i):GetName() == self.Party:GetLeader():GetName(), self.UpdateMethod)
        end
    end

    self.moveBox = MoveBox(self, self:GetWidth(), self:GetHeight(), "Party Vitals")

    --[[
    self.callbacks["TargetChanged"] = AddCallback(self.player, "TargetChanged", function( sender, args ) 
        local target = sender:GetTarget()
        if target then 
            local targetName = target:GetName()
            if self.CurrentlySelected  then self.CurrentlySelected:Select(false) end 

            if self.Names[targetName] then 
                self.CurrentlySelected = self.VitalWindows[targetName]
                self.CurrentlySelected:Select(true)
            end
        end
    end)
    --]]

    
    self.oldGameTime = Turbine.Engine.GetGameTime()
    self.UpdateDelay = 0.03

    self.Update = function()
        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == self.oldGameTime then
            return(true)
        end
        local delta = currentGameTime - self.oldGameTime

        if delta < self.UpdateDelay then return end

        if self.PartyNames[self.UpdateTicket] then self.VitalWindows[self.PartyNames[self.UpdateTicket]]:UpdateValues() end

        --ChatOutput(self.UpdateTicket)

        self.UpdateTicket = (self.UpdateTicket + 1) % 12

        self.oldGameTime = currentGameTime
    end

    if self.UpdateMethod == 1 then
        self:SetWantsUpdates(false) 
    else
        self:SetWantsUpdates(true) 
    end
end

function PartyWindow:Move()
    self.moveBox:ToggleMove()
end

function PartyWindow:Select(name)
    if self.CurrentlySelected then self.CurrentlySelected:Select(false) end 

    if self.Names[name] then 
        self.CurrentlySelected = self.VitalWindows[name]
        self.CurrentlySelected:Select(true)
    end
end

function PartyWindow:RemoveCallbacks()
    for key, value in pairs(self.VitalWindows) do
        value:RemoveCallbacks()
    end

    --RemoveCallback(self.player, "TargetChanged", self.callbacks["TargetChanged"])
end