Settings = PrimePlugins.RaidTools.LoadTable(Turbine.DataScope.Character, "PrimePartyVitalsSettings")


function GetDefaultSettings()
    Settings = {}

    Settings.Version = PluginVersion

    -- Vitals
    Settings.VX = 0
    Settings.VY = 300

    -- Global
    Settings.FrameVersion = 1
    Settings.ColourMode = 1

end

if Settings == nil or Settings.Reload == true then
    GetDefaultSettings()
end

function UpdateSettings()
    local tempSettings = Settings
    GetDefaultSettings()
    for key, value in pairs(tempSettings) do
        if Settings[key] ~=  nil then
            Settings[key] = value
        end
    end
    Settings.Version = plugin:GetVersion()
end



function SaveData()
    Settings.VX, Settings.VY = PartyVitals:GetPosition()

    PrimePlugins.RaidTools.SaveTable(Turbine.DataScope.Character, "PrimePartyVitalsSettings", Settings)
end

ClassColours = {
    [Turbine.Gameplay.Class.BlackArrow] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Beorning] = Turbine.UI.Color(77/255, 38/255, 0), --Yellow
    [Turbine.Gameplay.Class.Brawler] = Turbine.UI.Color(0, 255/255, 152/255), 
    [Turbine.Gameplay.Class.Burglar] = Turbine.UI.Color(255/255, 244/255, 104/255), --Yellow
    [Turbine.Gameplay.Class.Captain] = Turbine.UI.Color(244/255, 140/255, 186/255), --Pink
    [Turbine.Gameplay.Class.Champion] = Turbine.UI.Color(198/255, 155/255, 109/255), --Brownrgb(204, 153, 102)
    --[Turbine.Gameplay.Class.Corsair] = Turbine.UI.Color(198/255, 155/255, 109/255), --Brownrgb(204, 153, 102)
    [Turbine.Gameplay.Class.Chicken] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Defiler] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Guardian] = Turbine.UI.Color(100/255, 0/255, 0/255), --Red
    [Turbine.Gameplay.Class.Hunter] = Turbine.UI.Color(170/255, 211/255, 114/255), --{Turbine.UI.Color(51/255, 102/255, 0)
    [Turbine.Gameplay.Class.LoreMaster] = Turbine.UI.Color(135/255, 136/255, 238/255), --Purple
    [Turbine.Gameplay.Class.Minstrel] = Turbine.UI.Color(0, 60/255, 200/255), --Light green
    [Turbine.Gameplay.Class.Ranger] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Reaver] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.RuneKeeper] = Turbine.UI.Color(63/255, 199/255, 235/255), --Red--Turbine.UI.Color(0, 191/255, 1), --{Turbine.UI.Color(0, 115/255, 153/255),
    [Turbine.Gameplay.Class.Stalker] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Troll] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Warden] = Turbine.UI.Color(255/255, 102/255, 0/255), --Orange
    [Turbine.Gameplay.Class.WarLeader] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Weaver] = Turbine.UI.Color(102/255, 0, 0),
}

Icons = {
    [Turbine.Gameplay.Class.Burglar] = 0x41007deb,
    [Turbine.Gameplay.Class.Brawler] = 0x411F516F,
    [Turbine.Gameplay.Class.Captain] = 0x41007de7,
    [Turbine.Gameplay.Class.Champion] = 0x41007dec,
    --[Turbine.Gameplay.Class.Corsair] = 0x41007dec,
    [Turbine.Gameplay.Class.Guardian] = 0x41007de8,
    [Turbine.Gameplay.Class.Hunter] = 0x41007dea,
    [Turbine.Gameplay.Class.LoreMaster] = 0x41007de9,
    [Turbine.Gameplay.Class.Minstrel] = 0x41007de6,
    [Turbine.Gameplay.Class.RuneKeeper] = 0x410ea238,
    [Turbine.Gameplay.Class.Warden] = 0x410ea239,
    [Turbine.Gameplay.Class.Beorning] = 0x4115370d,

    [Turbine.Gameplay.Class.BlackArrow] = 0x41007def,
    [Turbine.Gameplay.Class.Defiler] = 0x410e6bf4,
    [Turbine.Gameplay.Class.Reaver] = 0x41007ded,
    [Turbine.Gameplay.Class.Stalker] = 0x41007df1, 
    [Turbine.Gameplay.Class.WarLeader] = 0x41007df0, 
    [Turbine.Gameplay.Class.Weaver] = 0x41007dee, 
} 

function GetEffectFilter()
    EffectIcons = {
        ["Field Promotion"] = 1,
        ["Moving Target"] = 1,
        
        --["Warrior's Heart"] = true,

        --["Threshold Morale Bubble"] = true,

        -- Beorning
        ["Thickened Hide"] = 1,

        -- Burg
        ["Touch and Go"] = 1,
        ["Knives Out"] = 1,

        -- Captain
        ["Last Stand"] = 1,
        ["Fighting Withdrawal"] = 1,
        ["Shield of the Dúnedain"] =1,

        -- Champ
        ["Controlled Burn"] = 1,
        ["Continuous Blood Rage"] = 1,
        ["Adamant"] = 1,

        --Guardian
        ["Guardian's Pledge"] = 1,
        ["Juggernaut"] = 1,
        ["Bring on the Pain"] = 1,
        ["Litany of Defiance"] = 1,
        ["Break Ranks"] = 1,

        --Hunter
        ["Burn Hot"] = 1,

        --LoreMaster
        ["Temporary State Immunity"] = 1,
        ["The Ancient Master"] = 1,

        --Minstrel

        --RuneKeeper
        ["Do Not Fall This Day"] = 1,

        --Warden
        ["Recklessness"] = 1,

        --Reaver
        ["Charge!"] = 1,
        ["Relentless"] = 1,
        ["March!"] = 1,
        ["Tol Ascarnen"] = 1,
        ["Tirith Rhaw"] = 1,
        ["Arador's End Outpost"] = 1,
        ["Blood of Fire"] = 1,
        ["Daze and Stun Immunity"] = 1,
        ["Dwarf Endurance"] = 1,

        ["Water-lore"] = 6,
    }

    if Turbine.Gameplay.LocalPlayer.GetInstance():GetClass() == Turbine.Gameplay.Class.Minstrel then
        EffectIcons["Soliloquy of Spirit"] = 3
        EffectIcons["Inspire Fellows Buff"] = 1
    elseif  Turbine.Gameplay.LocalPlayer.GetInstance():GetClass() == Turbine.Gameplay.Class.LoreMaster then
        --EffectIcons["Water-lore"] = 6,
    elseif  Turbine.Gameplay.LocalPlayer.GetInstance():GetClass() == Turbine.Gameplay.Class.Beorning then
        EffectIcons["Encouraging Roar - Tier 3"] = 1
    elseif  Turbine.Gameplay.LocalPlayer.GetInstance():GetClass() == Turbine.Gameplay.Class.Captain then
        EffectIcons["Penetrating Cry Attack Speed Buff"] = 1
        EffectIcons["Courage"] = 1
        EffectIcons["Rousing Cry Damage Buff"] = 1
        EffectIcons["To Arms (Blade-brother)"] = 1
        EffectIcons["To Arms (Shield-brother)"] = 1
        EffectIcons["To Arms (Song-brother)"] = 1
        EffectIcons["Inspiriting Presence"] = 1
    end

    return EffectIcons
end

function SetCommands()
    Command = Turbine.ShellCommand()

    function Command:Execute( _, command )
        if command ~= nil or string.len( command ) ~= 0 then
            if command == "reload" then
                ReloadPlugin()
            elseif command == "move" then
                PartyVitals:Move()
            elseif command == "lock" then
                PartyVitals:Move()
            end
        end
    end
    
    Turbine.Shell.AddCommand( "primePartyVitals", Command )
end

