VitalBar = class( Turbine.UI.Control )
function VitalBar:Constructor(width, height, showText, name)
    Turbine.UI.Control.Constructor( self )
    
    self:SetSize(width, height)
    self:SetZOrder(99)
    self:SetMouseVisible(false)

    --self.MaxValue = 100
    --self.CurrentValue = 0
    self.TempValue = 0
    self.MaxTempValue = 0
    self.DreadValue = 0

    --self.NumberMethod = Settings.NumberMethod
    self.PercentageShown = true
    --self.OnlyShowCurrent = Settings.OnlyShowCurrent
    self.showText = showText

    self.CurrentImmediate = 0
    self.CurrentValue = Turbine.Animation.LerpValue()
	self.MaxValue = 0 --Turbine.Animation.LerpValue()
    self.baseMax = 0 --Turbine.Animation.LerpValue()
    
    local Background = "PrimePlugins/Vitals/Images/FittedSmooth.tga"

    --self:SetBackColor( Turbine.UI.Color( 1, 1, 0, 0 ) )
    
    -- The background bar that contains all other bars
    self.TotalBar = Turbine.UI.Control()
    self.TotalBar:SetParent(self)
    --self.TotalBar:SetSize(256, 32)
    --self.TotalBar:SetStretchMode(1)
    --self.TotalBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay )
    self.TotalBar:SetBackground(Background)
    self.TotalBar:SetSize(width, height)
    self.TotalBar:SetMouseVisible(false)

    -- The current value of the display
    self.CurrentBar = Turbine.UI.Control()
    self.CurrentBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay )
    self.CurrentBar:SetParent(self)
    self.CurrentBar:SetSize(0, height)
    self.CurrentBar:SetMouseVisible(false)

    -- Indicating morale loss/gain
    self.MoveBar = Turbine.UI.Control()
    --self.MoveBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.MoveBar:SetParent(self)
    self.MoveBar:SetSize(0, 0)
    self.MoveBar:SetMouseVisible(false)

    -- Bar to show temporary effects (bubbles)
    self.TemporaryBar = Turbine.UI.Control()
    --self.TemporaryBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.TemporaryBar:SetParent(self)
    self.TemporaryBar:SetSize(0, height)
    self.TemporaryBar:SetMouseVisible(false)

    -- Bar to show temporary effects negative (dread)
    self.DreadBar = Turbine.UI.Control()
    --self.DreadBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.DreadBar:SetParent(self)
    self.DreadBar:SetSize(0, 0)
    self.DreadBar:SetMouseVisible(false)


	-- The animation classes for smoothly moving the bars.


    if self.showText then
        -- The display text for the vitals bar.
        -- [[
        self.text = Turbine.UI.Label()
        self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1, 1 ) )
        self.text:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
        self.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
        self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold19 )
        self.text:SetTextAlignment( Turbine.UI.ContentAlignment.TopRight )
        self.text:SetZOrder( 100 )
        self.text:SetParent( self )
        self.text:SetSize(width, height)
        self.text:SetMouseVisible(false)
    end
    --]]

	--self.horizontalLayout = Turbine.UI.HorizontalLayout.LeftToRight
	self.showPercentage = false

    self:AdjustBars()
	self.lastUpdate = 0
end

function VitalBar:SetColours(BackColour, BarColour, TempColour, DreadColour)
    --self.TotalBar:SetBackColor(BackColour)
    self.CurrentBar:SetBackColor(BarColour)
    self.TemporaryBar:SetBackColor(TempColour)
    self.DreadBar:SetBackColor(DreadColour)
end

function VitalBar:SetMaxValue(value)
    self.MaxValue = value
end

function VitalBar:SetRate(value)
    self.CurrentValue:SetRate( value / self:GetWidth() * 200 )
end

function VitalBar:SetCurrentValue(value)
    self.CurrentValue:SetValue(value)
    --self.CurrentImmediate = value

    if ( self.CurrentValue:NeedsUpdate() ) then
		self:SetWantsUpdates( true )
	end
end

function VitalBar:SetCurrentValueImmediate(value)
    self.CurrentValue:SetValueImmediate(value)
    --self.CurrentImmediate = value

    --if ( self.CurrentValue:NeedsUpdate() ) then
		--self:SetWantsUpdates( true )
	--end
end

function VitalBar:SetTempValue(value)
    self.TempValue = value
    --self:AdjustBars()
end

function VitalBar:SetMaxTempValue(value)
    self.MaxTempValue = value
    --self:AdjustBars()
end

function VitalBar:SetDreadValue(value)
    self.DreadValue = value
end

function VitalBar:Update( args )

    -- [[
	local delta = 0
	local currentTime = Turbine.Engine.GetGameTime()

	if ( self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate
	end

	self.lastUpdate = currentTime

	self.CurrentValue:Update( delta )
	--self.MaxValue:Update( delta )
    --self.baseMax:Update( delta )
    
    --[[

	local current = math.floor( self.CurrentValue:GetValue() + 0.5 ) 
	local max = math.floor( self.MaxValue:GetValue() + 0.5 ) 
    local baseMax = math.floor( self.baseMax:GetValue() + 0.5 ) 
    
	if ( self.showPercentage ) then
		local percentage = math.floor( ( current / max * 100 ) + 0.5 )
		self.text:SetText( percentage .. "%" )
	else
		self.text:SetText( current .. "/" .. max )
    end
    

    self:PerformLayout()
    
        --]]

	if not(self.CurrentValue:NeedsUpdate())  then
		self:SetWantsUpdates( false )
		self.lastUpdate = 0
    end
    self:AdjustBars()
end

function VitalBar:AdjustBars()

    local value = self.CurrentValue:GetValue()
    local totalWidth, currentHeight = self.TotalBar:GetSize()
    local totalHealthValue = (self.MaxValue + self.TempValue) 
    local currentWidth = value / totalHealthValue * totalWidth

    self.CurrentBar:SetWidth(math.ceil(currentWidth))

    self.TemporaryBar:SetWidth(math.ceil(self.TempValue / totalHealthValue * totalWidth))
    self.TemporaryBar:SetPosition(currentWidth, 0)

    if self.showText then self.text:SetText(self:FormatPercentage(value)) end

end

function VitalBar:SetTextVisible(value)
    if self.text then self.text:SetVisible(value) end
end

function VitalBar:FormatNumber(number) 
    if self.NumberMethod == 1 then
        return number
    elseif self.NumberMethod == 2 then
        return FormatBigNumber(number)
    end
end

function VitalBar:GetHealthString(value)
    if self.OnlyShowCurrent then
        return self:FormatNumber(math.floor( value + 0.5 ))
    else
        return self:FormatNumber(math.floor( value + 0.5 ))  .. "/" .. self:FormatNumber(math.floor( self.MaxValue + 0.5 ))
    end
end




function VitalBar:FormatPercentage(value) 
    if self.PercentageShown then
        return math.floor(value / self.MaxValue * 100) .. "% "
    else
        return ""
    end
end
