VitalWindow = class( Turbine.UI.Control)
function VitalWindow:Constructor(parent, player, indexX, indexY, vitalWidth, vitalHeight, effectX, effectY, effectVersion, effectRow, leader, updateMode)
    Turbine.UI.Control.Constructor( self )
	
    --self.layout = Turbine.UI.HorizontalLayout.LeftToRight
    local width = 0
    if (effectX + 100) - vitalWidth > 0 then width = vitalWidth + ((effectX + 100) - vitalWidth) + 4 else width = vitalWidth + 4 end

    --ChatOutput(effectMarginX)

    --local width = vitalWidth + 4 + 100
    local height = vitalHeight + 4

    local effectMarginX = math.max(vitalWidth - (effectX + 100), width)

    --ChatOutput(indexX)
    --ChatOutput(indexY)
	
    self:SetParent(parent)
    self:SetPosition( indexX * (width - 2), indexY * height )
    self:SetSize( width, height)
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.callbacks = {}
    self.effectCallbacks = {}

    self.BuffBoxes = {}

    self.UpdateCountdown = Settings.ShowCountdown

    self.IconScale = Settings.IconScale
    self.IconSize = 24

    self.IconFilter = GetEffectFilter()
    self.EffectCounter = 0
    self.EffectRow = effectRow

    self.IconRow = 0
    self.IconRowHeight = 160 - self.IconSize

    self.player = player
    self.playerName = self.player:GetName()
    --self.ClassAttr = self.player:GetClassAttributes()
    --self.ClassType = self.player:GetClass()

    self.UpdateMaxMorale = true
    self.UpdateCurrentMorale = false -- Cool start
    self.UpdateTempMorale = true
    self.UpdateMaxTempMorale = true
    self.MoraleUpdate = true; 
    
    self.UpdatePower = true
    self.UpdateMaxPower = true
    self.PowerUpdate = true 

    self.CurrentMorale= self.player:GetMorale()
    self.MaxMorale = self.player:GetMaxMorale()
    self.CurrentPower = self.player:GetPower()
    self.MaxPower = self.player:GetMaxPower()
    self.CurrentTemp = self.player:GetTemporaryMorale()

    self.EffectPosition = Settings.EffectVersion

    self.EffectIDs = {}
    self.EffectCount = {}
    self.EffectBoxesByName = {}

    self.oldGameTime = Turbine.Engine.GetGameTime()

    self.PowerLessClass = self.player:GetClass() ~= Turbine.Gameplay.Class.Beorning
    
    --[[
	self.nameLabel = Turbine.UI.Label()
	self.nameLabel:SetParent( self )
	self.nameLabel:SetPosition( 60, 3 )
	self.nameLabel:SetSize( 160, 12 )
	self.nameLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
	self.nameLabel:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) )
	self.nameLabel:SetMouseVisible( false )
    --]]
    
	self.vitalsFrame = Turbine.UI.Control()
	self.vitalsFrame:SetParent( self )
	self.vitalsFrame:SetBackColor( Turbine.UI.Color(0, 0, 0 ) )
	self.vitalsFrame:SetPosition( 0, 0 )
	self.vitalsFrame:SetSize( vitalWidth + 4, vitalHeight + 4);	
    self.vitalsFrame:SetMouseVisible( true );	
    self.vitalsFrame:SetPosition(0, 0)
    --self.vitalsFrame:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125))

    self.E = Turbine.UI.Lotro.EntityControl()
    self.E:SetParent (self.vitalsFrame)
    self.E:SetVisible (true)
    self.E:SetSize(width, height)
    self.E:SetEntity(self.player)

    local moraleHeight = vitalHeight - 5

    if self.PowerLessClass  then moraleHeight = vitalHeight end
	
	-- Construct the morale bar.
	self.moraleBar = VitalBar(vitalWidth, moraleHeight, true, "")
    self.moraleBar:SetParent( self.vitalsFrame )
    self.moraleBar:SetPosition(2, 2)
    local colour = nil
    if Settings.ColourMode == 1 then 
        colour = ClassColours[self.player:GetClass()]
    elseif Settings.ColourMode == 2 then
        colour = Turbine.UI.Color(0, 102/255, 34/255)
    end
    self.moraleBar:SetColours(Turbine.UI.Color(0.375, 0.375, 0.375), colour, Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
	--self.moraleBar:SetColor( Turbine.UI.Color( 1, 0.1, 1, 0.1 ) )
	--self.moraleBar:SetBuffColor( Turbine.UI.Color( 1, 0.3, 0.7, 1 ) )
	--self.moraleBar:SetDebuffColor( Turbine.UI.Color( 1, 1.0, 0.4, 0 ) )
	--self.moraleBar:SetPosition( 60, 19 )
	self.moraleBar:SetMouseVisible( false )
	--self.moraleBar:SetShowPercentage( true )
    --self.moraleBar:SetHorizontalLayout( Turbine.UI.HorizontalLayout.RightToLeft )
	
    --self.SetText( self.moraleBar, "This is a really bad thing to be doing. I'm passing the wrong type of control..." )

	
    -- Construct the power bar.
    if self.player:GetClass() ~= Turbine.Gameplay.Class.Beorning then
        self.powerBar = VitalBar(vitalWidth, 5, false)
        self.powerBar:SetParent( self.vitalsFrame )
        self.powerBar:SetZOrder( 100 )
        if self.ClassType == Turbine.Gameplay.Class.Beorning then
            self.powerBar:SetColours(Turbine.UI.Color(40/255, 0, 0), Turbine.UI.Color(100/255, 0, 0), Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
        else
            self.powerBar:SetColours(Turbine.UI.Color(0.1, 0.4, 0.4), Turbine.UI.Color(0.1, 0.1, 0.7), Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
        end
        --self.powerBar:SetColor( Turbine.UI.Color( 1, 0.1, 0.5, 1 ) )
        self.powerBar:SetPosition( 2, vitalHeight - 5 + 2 )
        self.powerBar:SetMouseVisible( false )
    else
        self.UpdatePower = false
        self.UpdateMaxPower = false
        self.PowerUpdate = false 
    end

    self.icon = Turbine.UI.Control()
    self.icon:SetParent(self)
    self.icon:SetBlendMode(Turbine.UI.BlendMode.Overlay )
    self.icon:SetBackground(Icons[self.player:GetClass()])
    self.icon:SetSize(20, 20)
    self.icon:SetPosition(2, 2)
    self.icon:SetMouseVisible(false)

    --0x410080BF
    if leader then
        self.leaderIcon = Turbine.UI.Control()
        self.leaderIcon:SetParent(self)
        self.leaderIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay )
        self.leaderIcon:SetBackground(0x410080BF)
        self.leaderIcon:SetSize(20, 20)
        self.leaderIcon:SetPosition(-8, -10)
        self.leaderIcon:SetMouseVisible(false)
    end


    self.text = Turbine.UI.Label()
    self.text:SetParent( self )
    self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1, 1 ) )
    self.text:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
    self.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold19 )
    self.text:SetTextAlignment( Turbine.UI.ContentAlignment.LeftCenter )
    self.text:SetZOrder( 100 )
    self.text:SetSize(90, 20)
    self.text:SetMouseVisible(false)
    self.text:SetText(self.player:GetName())
    self.text:SetPosition(23, 3)
    self.text:SetMouseVisible(false)

    if UpdateMode == 1 then
        self.callbacks["MoraleChanged"] = AddCallback(self.player, "MoraleChanged", function( sender, args ) self.moraleBar:SetCurrentValueImmediate( sender:GetMorale()) end)
        self.callbacks["MaxMoraleChanged"] = AddCallback(self.player, "MaxMoraleChanged", function( sender, args ) self.moraleBar:SetMaxValue(sender:GetMaxMorale()) end)
        --self.callbacks["BaseMaxMoraleChanged"] = AddCallback(self.player, "BaseMaxMoraleChanged", function( sender, args ) self.UpdateMaxMorale = true; self.MoraleUpdate = true; self.AnyUpdate = true end)
        self.callbacks["TemporaryMoraleChanged"] = AddCallback(self.player, "TemporaryMoraleChanged", function( sender, args ) self.moraleBar:SetTempValue(sender:GetTemporaryMorale()) end)
        --self.callbacks["MaxTemporaryMoraleChanged"] = AddCallback(self.player, "MaxTemporaryMoraleChanged", function( sender, args ) self.UpdateMaxTempMorale = true; self.MoraleUpdate = true; self.AnyUpdate = true end)
        
        if self.player:GetClass() ~= Turbine.Gameplay.Class.Beorning then
            self.callbacks["PowerChanged"] = AddCallback(self.player, "PowerChanged", function( sender, args ) self.powerBar:SetCurrentValueImmediate(sender:GetPower()) end)
            self.callbacks["MaxPowerChanged"] = AddCallback(self.player, "MaxPowerChanged", function( sender, args ) self.powerBar:SetMaxValue(sender:GetMaxPower()) end)
            --self.callbacks["BaseMaxPowerChanged"] = AddCallback(self.player, "BaseMaxPowerChanged", function( sender, args ) self.UpdateMaxPower = true; self.PowerUpdate = true; self.AnyUpdate = true end)
        end
    end
    --[[
    self.moraleBar:SetCurrentValue( self.player:GetMorale() )
    self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
    self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
    self.moraleBar:SetTempValue(self.player:GetTemporaryMorale())
    self.moraleBar:SetMaxTempValue(self.player:GetMaxTemporaryMorale())

    self.powerBar:SetCurrentValue( self.player:GetPower() )
    self.powerBar:SetMaxValue( self.player:GetMaxPower() )
    self.powerBar:SetMaxValue( self.player:GetMaxPower() )

    if self.ClassType == Turbine.Gameplay.Class.Beorning then
        self.powerBar:SetCurrentValue( self.ClassAttr:GetWrath() )
        self.powerBar:SetMaxValue( 100 )
        self.powerBar:SetMaxValue( 100 )
    else

    end
    --]]
    self.moraleBar:SetCurrentValue( self.player:GetMorale() )
    self.moraleBar:SetRate( self.player:GetMaxMorale()) 
    if self.powerBar then self.powerBar:SetRate( self.player:GetMaxPower())  end

    self.Moving = false
  
    self.E.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    self.E.MouseClick = function()
        parent:Select(self.playerName)
    end

    self.buffBox = Turbine.UI.Control()
    self.buffBox:SetParent( self )
    --self.buffBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
    if effectVersion == 1 then 
        self.buffBox:SetSize( 100, 30 );	
    else
        self.buffBox:SetSize( 100, 60 );	
    end
    self.buffBox:SetMouseVisible( false );	
    self.buffBox:SetPosition(effectX, effectY)
    --self.buffBox:SetBackColor(Turbine.UI.Color(0,0,0))


    -- Effects
    -- [[
    self.effectList = self.player:GetEffects()

    for i = 1, self.effectList:GetCount(), 1 do
        local effect =  self.effectList:Get(i)
        local name = effect:GetName()
        local ID = effect:GetID()
        self.EffectIDs[ID] = true
        if self.IconFilter[name] then
            self.BuffBoxes[ID] = EffectBox(self.buffBox, effect, self.IconSize)

            if self.EffectCount[name] then
                self.EffectCount[name] = self.EffectCount[name] + 1
            else
                self.EffectCount[name] = 1
            end

            self.EffectCounter = self.EffectCounter + 1

            self.BuffResort = true
        end
    end 

    self.effectCallbacks["EffectAdded"] = PrimePlugins.RaidTools.AddCallback(self.effectList, "EffectAdded", function(sender, args)
        local effect = sender:Get(args.Index)
        --ChatOutput(self.player:GetName())
        local ID = effect:GetID()
        if not(self.EffectIDs[ID]) then
            self.EffectIDs[ID] = true
            if self.IconFilter[effect:GetName()] then
                local name = effect:GetName()
                self.BuffBoxes[ID] = EffectBox(self.buffBox, effect, self.IconSize)

                if self.EffectCount[name] then
                    self.EffectCount[name] = self.EffectCount[name] + 1
                else
                    self.EffectCount[name] = 1
                end
                
                if self.EffectCount[name] > self.IconFilter[name] then
                    local duration = 999999
                    local idToRemove = 0
                    for key, value in pairs(self.BuffBoxes) do
                        if value:GetName() == name then
                            if value:GetValue() < duration then 
                                duration = value:GetValue() 
                                idToRemove = key
                            end
                        end
                    end
    
                    if idToRemove > 0 then
                        self.BuffBoxes[idToRemove]:SetVisible(false) 
                        self.BuffBoxes[idToRemove]:SetParent(nil) 
                        self.BuffBoxes[idToRemove] = nil
                        self.EffectCount[name] = self.EffectCount[name] - 1
                    end

                else
                    if self.EffectCounter == 0 then
                        self.oldGameTime = Turbine.Engine.GetGameTime()
                    end
                    self.EffectCounter = self.EffectCounter + 1
                end

                self.BuffResort = true
            end
        end
    end)
    --]]

    self.UpdateDelay = 0.33

    self.Update = function()
        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == self.oldGameTime then
            return(true)
        end

        local delta = currentGameTime - self.oldGameTime

        if delta < self.UpdateDelay then return end
        
        for key, value in pairs(self.BuffBoxes) do
            value:UpdateText(delta)
            -- [[
            if value:GetValue() < 0 then
                local name = value:GetName()
                self.EffectCount[name] = self.EffectCount[name] - 1
                value:SetVisible(false) 
                value:SetParent(nil) 
                self.BuffBoxes[key] = nil
                self.BuffResort = true
                self.EffectCounter = self.EffectCounter - 1
            end
            --]]
        end

        self:UpdateValues()
        self:UpdateBars()

        if self.BuffResort then self.ResortList() end

        self.oldGameTime = currentGameTime
    end

    self.ResortList = function()

        if self.BuffResort then
            local counter = 0
            for _,v in PrimePlugins.RaidTools.spairs(self.BuffBoxes, function(t,a,b) return t[b]:GetValue() < t[a]:GetValue() end) do
                v:SetPosition((counter % self.EffectRow)  * self.IconSize, math.floor(counter / self.EffectRow) * self.IconSize)
                counter = counter + 1
            end
            self.BuffResort = false
        end
    end

    self:ResortList()
    self:SetWantsUpdates(true)
end

function VitalWindow:Select(selected) 
    if selected then 
        self.vitalsFrame:SetBackColor(Turbine.UI.Color(0.2,1,0.2)) 
        self:SetZOrder(100)
    else 
        self.vitalsFrame:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125)) 
        self:SetZOrder(99)
    end
end

function VitalWindow:UpdateBars()
    self.moraleBar:AdjustBars()
    if self.PowerLessClass then self.powerBar:AdjustBars() end
end

function VitalWindow:UpdateValues()
    self.moraleBar:SetCurrentValueImmediate(self.player:GetMorale())
    self.moraleBar:SetMaxValue(self.player:GetMaxMorale())
    self.moraleBar:SetTempValue(self.player:GetTemporaryMorale())
    
    if self.PowerLessClass then
        self.powerBar:SetCurrentValueImmediate(self.player:GetPower())
        self.powerBar:SetMaxValue(self.player:GetMaxPower())
    end
end

function VitalWindow:RemoveCallbacks()
    for key, value in pairs(self.callbacks) do
        PrimePlugins.RaidTools.RemoveCallback(self.player, key, value)
    end

    for key, value in pairs(self.effectCallbacks) do
        PrimePlugins.RaidTools.RemoveCallback(self.effectList, key, value)
    end
end