-- Alert options
AlertSettings = class(Turbine.UI.Control)
function AlertSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    local height = 0

    --GetOptionsBackground(height, 290, Turbine.UI.Color(1, 0.4, 0.4))

    -- Message Window
    local MessageWindowLabel = GetLabelUI(self, "Chat / Other effects Alert Settings:", height)

    local MessageTestButton = Turbine.UI.Lotro.Button()
    MessageTestButton:SetParent(self)
    MessageTestButton:SetPosition(370, height)
    MessageTestButton:SetSize(100,15)
    MessageTestButton:SetText("Test alert")
    MessageTestButton:SetVisible(true)
    
    MessageTestButton.Click = function()
        local messageWindow = EventWindows:GetAlertWindow()
        if messageWindow then
            messageWindow:Message(math.random(10, 20), "Test on: oooooooooooooooooo", "PrimePlugins/RaidTools/Images/Webs.tga", true)
        end
    end
    
    local MessageWindowCheckBox = GetCheckUI(self, height + 40, "Chat alerts enabled", Settings.AEnabled)
    MessageWindowCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.AEnabled = MessageWindowCheckBox.cBox:IsChecked()
        MasterOptions:ChangesMade()
    end
    
    local MessageWindowLabel2 = GetLabelUI(self, "Window size:", height + 60)
    MessageWindowOptions = GetWindowUI(self, "Width              Height", height + 80, Settings.AWidth, Settings.AHeight)
    MessageWindowOptions.button.Click = function()
        Settings.AWidth = MessageWindowOptions.windowX:GetText()
        Settings.AHeight = MessageWindowOptions.windowY:GetText()
        MasterOptions:ChangesMade()
    end

    local MessageWindowLabel2 = GetLabelUI(self, "Window Position:", height + 160)
    MessageWindowOptionsPos = GetWindowUI(self, "X              Y", height + 180, Settings.AX, Settings.AY)
    MessageWindowOptionsPos.button.Click = function()
        Settings.AX = MessageWindowOptionsPos.windowX:GetText()
        Settings.AY = MessageWindowOptionsPos.windowY:GetText()
        messageWindow:SetPosition(Settings.AX, Settings.AY)
        MasterOptions:ChangesMade()
    end
    
    local FontMenuMessage = GetFontMenu(self, height + 120, FontsLUTR[Settings.AFont]) 
    for i = 1, FontMenuMessage.menuItems:GetCount() do
        local menuItem = FontMenuMessage.menuItems:Get(i)
    
        menuItem.Click = function(sender, args)
            Settings.AFont = FontsLUT[sender:GetText()]
            MasterOptions:ChangesMade()
        end
    end
end
