LMAirLore = class(Turbine.UI.Window)
function LMAirLore:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    

    self.width = 50
    self.height = 50

    self.callbacks = nil
    self.skillItem = nil

    self.hasAirlore = false

    self.airloreActive = Settings.AirLoreAura

    if Settings["ItemPositions"]["LoreMasterAirLore"] == nil then
        Settings["ItemPositions"]["LoreMasterAirLore"] = {}
        Settings["ItemPositions"]["LoreMasterAirLore"].X = math.floor(Turbine.UI.Display.GetWidth() / 2 - self.width / 2) 
        Settings["ItemPositions"]["LoreMasterAirLore"].Y = 500
    end
    

    self:SetPosition(Settings["ItemPositions"]["LoreMasterAirLore"].X, Settings["ItemPositions"]["LoreMasterAirLore"].Y)
    self:SetSize(self.width, self.height)
    --self:SetBackground(ReviveIcon)
    self:SetVisible(true)

    self.banner = Turbine.UI.Control()
    self.banner:SetParent(self)
    self.banner:SetMouseVisible(false)
    self.banner:SetVisible(false)
    self.banner:SetSize(32, 32)
    self.banner:SetBackground(BackgroundHandler:GetBackground(1091873732))
    --self.banner:SetStretchMode(1)
    --self.banner:SetSize(50, 50)

    self.highlightFrame = ClassSpecificTools.HighlightFrame(self.banner)
    
    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(self.width, self.height)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end

    
    self.ExecuteUpdate = function(delta)
        self.timer = self.timer - delta
        if self.timer < 0 then
            if self.hasAirlore then self:Activate(true) end
            if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
            self.updateCallback = nil
        end
    end

    self.skills = self.player:GetTrainedSkills()
    self:SetCallbacks()
end

function LMAirLore:SetCallbacks()

    ChatEventHandler:Subscribe(self)
    ChatEventHandler:TogglePlayerCombat(true)

    for i = 1, self.skills:GetCount(), 1 do
        local item = self.skills:GetItem(i)--:GetSkillInfo()
        if item:GetSkillInfo():GetName() == "Air-lore" then
            self.skillItem = item
            self.hasAirlore = true
            self.callbacks = AddCallback(item, "ResetTimeChanged", 
            function(sender, args)
                self.airloreActive = false
                self.timer = 10
                if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
            end)

            if item:GetResetTime() == -1 and not(Settings.AirLoreAura) then self:Activate(true) end
        end
    end
    
    if not(self.hasAirlore) then
        self:Activate(false)
    end
end

function LMAirLore:Activate(value)
    self.banner:SetVisible(value)
    self.highlightFrame:Toggle(value)
    self:SetVisible(value)
end


function LMAirLore:ParseUpdate(message)
    if string.find(message, "Air%-lore") then
        self.airloreActive = true
        self:Activate(false)
    end
end


function LMAirLore:RemoveCallbacks()
    Settings.AirLoreAura = self.airloreActive
    ChatEventHandler:UnSubscribe(self)
    ChatEventHandler:TogglePlayerCombat(nil)
    if self.callbacks then RemoveCallback(self.skillItem, "ResetTimeChanged", self.callbacks) end
    self.hasAirlore = false
    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
    self.updateCallback = nil
    
end

function LMAirLore:Unload()
    Settings.AirLoreAura = self.airloreActive
    self:RemoveCallbacks()
    Settings["ItemPositions"]["LoreMasterAirLore"].X, Settings["ItemPositions"]["LoreMasterAirLore"].Y = self:GetPosition()
    self:SetVisible(false)
    self:SetParent(nil)
end