AuraOptions = class(Turbine.UI.Control)
function AuraOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10 - 2, 10 - 2)
    SingleBackground:SetSize(730 + 4, 450 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10, 10)
    SingleBackground:SetSize(730, 450)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    if not(Auras) then return end

    local data = Auras:GetData()
    local base = Auras:GetBase()

    local container = Turbine.UI.ListBox()
    container:SetParent(SingleBackground)
    container:SetSize(700, 400)
    container:SetPosition(10, 30)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)
    --container:SetBackColor(GetRandomColour())

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( SingleBackground )
    containerScrollbar:SetPosition( 710 - 10, 30 )
    containerScrollbar:SetSize( 10, 400 )
    container:SetVerticalScrollBar( containerScrollbar )

    for key, value in spairs(base,
    function(t,a,b)
        if a < b then return true end
    end) do container:AddItem(self:createSkillBar(key, data[key])) end

end


function AuraOptions:createSkillBar(name, load)
    local pluginBar = Turbine.UI.Control()
    pluginBar:SetSize(800, 40)
    pluginBar:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local backgroundBar = Turbine.UI.Control()
    backgroundBar:SetSize(800, 38)
    backgroundBar:SetPosition(0, 1)
    backgroundBar:SetParent(pluginBar)
    backgroundBar:SetMouseVisible(false)
    backgroundBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    --pluginBar:SetBackColor(GetRandomColour())

    local nameLabel = Turbine.UI.Label()
    nameLabel:SetParent(pluginBar)
    nameLabel:SetSize(150, 30)
    nameLabel:SetPosition(0, 5)
    nameLabel:SetMouseVisible(false)
    nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    nameLabel:SetMultiline(true)
    nameLabel:SetText(name)

    local EffectBox = Turbine.UI.Lotro.CheckBox()
    EffectBox:SetParent(pluginBar)
    EffectBox:SetPosition(160, 10)
    EffectBox:SetSize(120,20)
    EffectBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    EffectBox:SetChecked(load == 0)
    EffectBox:SetText("Never load")
    EffectBox:SetVisible(true)

    
    local EffectBox2 = Turbine.UI.Lotro.CheckBox()
    EffectBox2:SetParent(pluginBar)
    EffectBox2:SetPosition(260, 10)
    EffectBox2:SetSize(120,20)
    EffectBox2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    EffectBox2:SetChecked(load == 1)
    EffectBox2:SetText("Always load")
    EffectBox2:SetVisible(true)

    
    local EffectBox3 = Turbine.UI.Lotro.CheckBox()
    EffectBox3:SetParent(pluginBar)
    EffectBox3:SetPosition(370, 10)
    EffectBox3:SetSize(120,20)
    EffectBox3:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    EffectBox3:SetChecked(load == 2)
    EffectBox3:SetText("Instance load")
    EffectBox3:SetVisible(true)

    
    local EffectBox4 = Turbine.UI.Lotro.CheckBox()
    EffectBox4:SetParent(pluginBar)
    EffectBox4:SetPosition(490, 10)
    EffectBox4:SetSize(120,20)
    EffectBox4:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    EffectBox4:SetChecked(load == 3)
    EffectBox4:SetText("Pvp load")
    EffectBox4:SetVisible(true)

    local Button2 = Turbine.UI.Lotro.Button()
    Button2:SetParent(pluginBar)
    Button2:SetSize(80, 20)
    Button2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    Button2:SetMouseVisible(true)
    Button2:SetVisible(false)
    Button2:SetPosition(620, 10)
    Button2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    Button2:SetText("Save")

    EffectBox.CheckedChanged = function()
        if EffectBox:IsChecked() then
            EffectBox2:SetChecked(false)
            EffectBox3:SetChecked(false)
            EffectBox4:SetChecked(false)
            Auras:ChangeData(name, 0)
            ChatOutput("Changed loading of " .. name .. " to Never load")
        end
    end

    EffectBox2.CheckedChanged = function()
        if EffectBox2:IsChecked() then
            EffectBox:SetChecked(false)
            EffectBox3:SetChecked(false)
            EffectBox4:SetChecked(false)
            Auras:ChangeData(name, 1)
            ChatOutput("Changed loading of " .. name .. " to Always load")
        end
    end

    EffectBox3.CheckedChanged = function()
        if EffectBox3:IsChecked() then
            EffectBox:SetChecked(false)
            EffectBox2:SetChecked(false)
            EffectBox4:SetChecked(false)
            Auras:ChangeData(name, 2)
            ChatOutput("Changed loading of " .. name .. " to Instance load")
        end
    end

    EffectBox4.CheckedChanged = function()
        if EffectBox4:IsChecked() then
            EffectBox:SetChecked(false)
            EffectBox2:SetChecked(false)
            EffectBox3:SetChecked(false)
            Auras:ChangeData(name, 3)
            ChatOutput("Changed loading of " .. name .. " to Pvp load")
        end
    end

    Button2.Click = function()
    end

    return pluginBar
end