BearMarkBlueTracker = class(Turbine.UI.Window)
function BearMarkBlueTracker:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.width = 100
    self.height = 50

    self.callbacks = nil
    self.skillItem = nil

    self.active = false

    self.markActive = Settings.BearMarkBlue

    if Settings["ItemPositions"]["BearMarkBlue"] == nil then
        Settings["ItemPositions"]["BearMarkBlue"] = {}
        Settings["ItemPositions"]["BearMarkBlue"].X = math.floor(Turbine.UI.Display.GetWidth() / 3 - self.width / 2) 
        Settings["ItemPositions"]["BearMarkBlue"].Y = 700
    end
    

    self:SetPosition(Settings["ItemPositions"]["BearMarkBlue"].X, Settings["ItemPositions"]["BearMarkBlue"].Y)
    self:SetSize(self.width, self.height)
    --self:SetBackground(ReviveIcon)
    self:SetVisible(true)

    self.banner = Turbine.UI.Control()
    self.banner:SetParent(self)
    self.banner:SetMouseVisible(false)
    self.banner:SetVisible(true)
    self.banner:SetSize(32, 32)
    self.banner:SetPosition(34, 0)
    self.banner:SetBackground(1091940906)
    --self.banner:SetStretchMode(1)
    --self.banner:SetSize(50, 50)

    self.targetName = Turbine.UI.Label()
    self.targetName:SetParent(self)
    self.targetName:SetSize(self.width, 40)
    self.targetName:SetPosition(0, -5)
    self.targetName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.targetName:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    --self.targetName:SetBackColor(GetRandomColour())
    --self.targetName:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.targetName:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.targetName:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.targetName:SetMouseVisible(false)
    self.targetName:SetVisible(true)
    self.targetName:SetText(string.sub(Settings.BearMarkBlueName, 1, 5))

    self.highlightFrame = ClassSpecificTools.HighlightFrame(self.banner)
    
    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(self.width, self.height)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end

    self.ExecuteUpdate = function(delta)
        self.timer = self.timer - delta
        self.targetName:SetText(Round(self.timer, 1))
        if self.timer < 0 then
            if self.active then self:Activate(true) end
            self.targetName:SetText("")
            if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
            self.updateCallback = nil
        end
    end

    self.skills = self.player:GetTrainedSkills()
    self:SetCallbacks()
end

function BearMarkBlueTracker:SetCallbacks()
    ChatEventHandler:Subscribe(self)
    ChatEventHandler:TogglePlayerCombat(true)

    for i = 1, self.skills:GetCount(), 1 do
        local item = self.skills:GetItem(i)--:GetSkillInfo()
        if item:GetSkillInfo():GetName() == "Mark of Grimbeorn" then
            self.skillItem = item
            self.active = true
            self.callbacks = AddCallback(item, "ResetTimeChanged", 
            function(sender, args)
                self.markActive = false
                self.timer = 5
                self.targetName:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
                self.targetName:SetText("")
                if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
            end)

            if item:GetResetTime() == -1 and not(Settings.BearMarkBlue) then self:Activate(true) end
        end
    end
    
    if not(self.active) then
        self:Activate(false)
        self:SetVisible(false)
    else
        self:SetVisible(true)
    end
end

function BearMarkBlueTracker:Activate(value)
    --self.banner:SetVisible(value)
    self.highlightFrame:Toggle(value)
end

function BearMarkBlueTracker:ParseUpdate(message)
    local source, _, skillName,targetName = string.match(message,"^(.*) applied a (.*)benefit with (.*) on (.-)%.$")

    if string.find(message, "Mark of Grimbeorn")  then
        self.markActive = true
        self:Activate(false)
        self.targetName:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        self.targetName:SetText(string.sub(string.gsub(tostring(targetName),"^[Tt]he ",""), 1, 5))
    end
end


function BearMarkBlueTracker:RemoveCallbacks()
    Settings.BearMarkBlue = self.markActive
    ChatEventHandler:UnSubscribe(self)
    Settings.BearMarkBlueName = self.targetName:GetText()
    ChatEventHandler:TogglePlayerCombat(nil)
    if self.callbacks then RemoveCallback(self.skillItem, "ResetTimeChanged", self.callbacks) end
    self.active = false
    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
    self.updateCallback = nil
end

function BearMarkBlueTracker:Unload()
    Settings.BearMarkBlue = self.markActive
    self:RemoveCallbacks()
    Settings.BearMarkBlueName = self.targetName:GetText()
    Settings["ItemPositions"]["BearMarkBlue"].X, Settings["ItemPositions"]["BearMarkBlue"].Y = self:GetPosition()
    self:SetVisible(false)
    self:SetParent(nil)
end

--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------


BearMarkRedTracker = class(Turbine.UI.Window)
function BearMarkRedTracker:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.width = 100
    self.height = 50

    self.callbacks = nil
    self.skillItem = nil

    self.active = false

    self.markActive = Settings.BearMarkRed

    if Settings["ItemPositions"]["BearMarkRed"] == nil then
        Settings["ItemPositions"]["BearMarkRed"] = {}
        Settings["ItemPositions"]["BearMarkRed"].X = math.floor(Turbine.UI.Display.GetWidth() / 3 - self.width / 2) 
        Settings["ItemPositions"]["BearMarkRed"].Y = 750
    end
    

    self:SetPosition(Settings["ItemPositions"]["BearMarkRed"].X, Settings["ItemPositions"]["BearMarkRed"].Y)
    self:SetSize(self.width, self.height)
    --self:SetBackground(ReviveIcon)
    self:SetVisible(true)

    self.banner = Turbine.UI.Control()
    self.banner:SetParent(self)
    self.banner:SetMouseVisible(false)
    self.banner:SetVisible(true)
    self.banner:SetSize(32, 32)
    self.banner:SetPosition(34, 0)
    self.banner:SetBackground(BackgroundHandler:GetBackground(1091940894))

    self.targetName = Turbine.UI.Label()
    self.targetName:SetParent(self)
    self.targetName:SetSize(self.width, 40)
    self.targetName:SetPosition(0, -5)
    self.targetName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.targetName:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    --self.targetName:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.targetName:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.targetName:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.targetName:SetMouseVisible(false)
    self.targetName:SetVisible(true)
    self.targetName:SetText(string.sub(Settings.BearMarkRedName, 1, 5))

    --self.banner:SetStretchMode(1)
    --self.banner:SetSize(50, 50)

    self.highlightFrame = ClassSpecificTools.HighlightFrame(self.banner)
    
    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(self.width, self.height)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end

    self.ExecuteUpdate = function(delta)
        self.timer = self.timer - delta
        self.targetName:SetText(Round(self.timer, 1))
        if self.timer < 0 then
            if self.active then self:Activate(true) end
            if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
            self.updateCallback = nil
            self.targetName:SetText("")
        end
    end

    self.skills = self.player:GetTrainedSkills()
    self:SetCallbacks()
end

function BearMarkRedTracker:SetCallbacks()
    ChatEventHandler:Subscribe(self)
    ChatEventHandler:TogglePlayerCombat(true)

    for i = 1, self.skills:GetCount(), 1 do
        local item = self.skills:GetItem(i)--:GetSkillInfo()
        if item:GetSkillInfo():GetName() == "Mark of Beorn" then
            self.skillItem = item
            self.active = true
            self.callbacks = AddCallback(item, "ResetTimeChanged", 
            function(sender, args)
                self.markActive = false
                self.timer = 5
                self.targetName:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
                self.targetName:SetText("")
                if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
            end)

            if item:GetResetTime() == -1 and not(Settings.BearMarkRed) then self:Activate(true) end
        end
    end
    
    if not(self.active) then
        self:Activate(false)
        self:SetVisible(false)
    else
        self:SetVisible(true)
    end
end

function BearMarkRedTracker:Activate(value)
    --self.banner:SetVisible(value)
    self.highlightFrame:Toggle(value)
end


function BearMarkRedTracker:ParseUpdate(message)
    local source,_,skillName,targetName = string.match(message,"^(.*) scored a (.*)hit with (.*) on (.-)%.$")

    if string.find(message, "Mark of Beorn")  then
        self.markActive = true
        self:Activate(false)
        self.targetName:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        self.targetName:SetText(string.sub(string.gsub(targetName,"^[Tt]he ",""), 1, 10))
    end
end


function BearMarkRedTracker:RemoveCallbacks()
    Settings.BearMarkRed = self.markActive
    Settings.BearMarkRedName = self.targetName:GetText()
    ChatEventHandler:UnSubscribe(self)
    ChatEventHandler:TogglePlayerCombat(nil)
    if self.callbacks then RemoveCallback(self.skillItem, "ResetTimeChanged", self.callbacks) end
    self.active = false
    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
    self.updateCallback = nil
    
end

function BearMarkRedTracker:Unload()
    Settings.BearMarkRed = self.markActive
    Settings.BearMarkRedName = self.targetName:GetText()
    self:RemoveCallbacks()
    Settings["ItemPositions"]["BearMarkRed"].X, Settings["ItemPositions"]["BearMarkRed"].Y = self:GetPosition()
    self:SetVisible(false)
    self:SetParent(nil)
end