BurglarDebuffs = class(Turbine.UI.Window)
function BurglarDebuffs:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.skills = self.player:GetTrainedSkills()

    self.width = 150
    self.height = 50

    self.callbacks = nil

    if Settings["ItemPositions"]["BurglarDebuffs"] == nil then
        Settings["ItemPositions"]["BurglarDebuffs"] = {}
        Settings["ItemPositions"]["BurglarDebuffs"].X = math.floor(Turbine.UI.Display.GetWidth() / 3 - self.width / 2) 
        Settings["ItemPositions"]["BurglarDebuffs"].Y = 500
    end
    
    self.catmint = 0
    self:SetPosition(Settings["ItemPositions"]["BurglarDebuffs"].X, Settings["ItemPositions"]["BurglarDebuffs"].Y)
    self:SetSize(self.width, self.height)
    self:SetVisible(true)

    self.skillCallbacks = {}
    self.effectAddedCallbacks = {}
    self.effectRemovedCallbacks = {}

    self.colourScheme = {Turbine.UI.Color(0,0,0), Turbine.UI.Color(0, 0,0,0), Turbine.UI.Color(0,170/255,170/255), Turbine.UI.Color(1,1,1), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0, 0,0,0), nil, nil, 0.6, 0.6}
    
    self.Timers = {
        ["Trick: Enrage"] = EffectTimer(self, 50, 20, nil, "", Turbine.UI.Lotro.Font.VerdanaBold16, self.colourScheme, true, nil, 30, 1090522262),
        ["Trick: Disable"] = EffectTimer(self, 50, 20, nil, "", Turbine.UI.Lotro.Font.VerdanaBold16, self.colourScheme, true, nil, 30, 1090541269),
        ["Trickster"] = EffectTimer(self, 50, 20, nil, "", Turbine.UI.Lotro.Font.VerdanaBold16, self.colourScheme, true, nil, 30, 1091804882),
    }

    self.ActiveTimers = {
    }

    self.trickIcons = {

    }

    self.icons = {
        ["Trick: Enrage"] = 1090522262,
        ["Trick: Disable"] = 1090541269,
    }

    --1091804905

    local counter = 0
    for key, value in spairs(self.Timers, function(t,a,b) return a > b end) do
        value:SetPosition(20, 20 * counter)

        if self.icons[key] then
            self.trickIcons[key] = Turbine.UI.Control()
            self.trickIcons[key]:SetParent(self)
            self.trickIcons[key]:SetSize(32, 32)
            self.trickIcons[key]:SetMouseVisible(false)
            self.trickIcons[key]:SetPosition(0, 0)
            self.trickIcons[key]:SetBackground(BackgroundHandler:GetBackground(self.icons[key]))
            self.trickIcons[key]:SetStretchMode(1)
            self.trickIcons[key]:SetSize(20, 20)
            self.trickIcons[key]:SetVisible(false)
        end

        self.Timers[key]:HideText(false)
        self.Timers[key]:ChangeDuration(0)
        counter = counter + 1
    end
    
    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(self.width, self.height)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end


    self.ExecuteUpdate = function(delta)
        for key, value in pairs(self.ActiveTimers) do
            self.Timers[key]:UpdateText(delta)
            self.ActiveTimers[key] = value - delta
            if self.ActiveTimers[key] < 0 then
                self.ActiveTimers[key] = nil
                if key == "Trickster" then
                    self.trickIcons["Trick: Enrage"]:SetVisible(false)
                    self.trickIcons["Trick: Disable"]:SetVisible(false)
                end
                if tablelength(self.ActiveTimers) == 0 then
                    if self.updateCallback then 
                        RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) 
                        self.updateCallback = nil
                    end
                end
            end
        end
    end

    self:SetCallbacks()
end

function BurglarDebuffs:SetCallbacks()
    if not(self.skillCallbacks["Trick: Enrage"]) then self.skillCallbacks["Trick: Enrage"] = {} end
    if SkillEventHandler:SkillExists("Trick: Enrage") then
        if not(self.skillCallbacks["Trick: Enrage"]) then self.skillCallbacks["Trick: Enrage"] = {} end
        table.insert(self.skillCallbacks["Trick: Enrage"], AddCallback(SkillEventHandler, "Trick: Enrage", function(skill) 
            if skill:GetResetTime() - Turbine.Engine.GetGameTime() > 4.9 then
                if self.trickster then
                    self.Timers["Trickster"]:SetTimer(39, 39)
                    self.ActiveTimers["Trickster"] = 39

                    self.trickIcons["Trick: Enrage"]:SetVisible(true)
                    self.trickIcons["Trick: Disable"]:SetVisible(false)
                else
                    self.Timers["Trick: Enrage"]:SetTimer(39, 39)
                    self.ActiveTimers["Trick: Enrage"] = 39
                end
                if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
            end
        end))
    end

    if not(self.skillCallbacks["Trick: Disable"]) then self.skillCallbacks["Trick: Disable"] = {} end
    if SkillEventHandler:SkillExists("Trick: Disable") then
        if not(self.skillCallbacks["Trick: Disable"]) then self.skillCallbacks["Trick: Disable"] = {} end
        table.insert(self.skillCallbacks["Trick: Disable"], AddCallback(SkillEventHandler, "Trick: Disable", function(skill) 
            if skill:GetResetTime() - Turbine.Engine.GetGameTime() > 4.9 then
                if self.trickster then
                    self.Timers["Trickster"]:SetTimer(39, 39)
                    self.ActiveTimers["Trickster"] = 39

                    self.trickIcons["Trick: Enrage"]:SetVisible(false)
                    self.trickIcons["Trick: Disable"]:SetVisible(true)
                else
                    self.Timers["Trick: Disable"]:SetTimer(39, 39)
                    self.ActiveTimers["Trick: Disable"] = 39
                end
                if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
            end
        end))
    end

    table.insert(self.effectAddedCallbacks, AddCallback(PlayerEffectsHandler, "EffectAdded", 
        function(effect)
            local name = effect:GetName()
            if name == "Trickster" then
                self.trickster = true
            end
        end))

    table.insert(self.effectRemovedCallbacks, AddCallback(PlayerEffectsHandler, "EffectRemoved", 
        function(effect)
            local name = effect:GetName()
            if name == "Trickster" then
                self.trickster = false
            end
        end))
end


function BurglarDebuffs:RemoveCallbacks()
    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end

    for _, callbackTable in pairs(self.skillCallbacks) do
        for name, callback in pairs(callbackTable) do
            RemoveCallback(SkillEventHandler, name, callback)
        end
    end

    for _, callback in pairs(self.effectAddedCallbacks) do
        RemoveCallback(PlayerEffectsHandler, "EffectAdded", callback)
    end
    
    for _, callback in pairs(self.effectRemovedCallbacks) do
        RemoveCallback(PlayerEffectsHandler, "EffectRemoved", callback)
    end
end

function BurglarDebuffs:Unload()
    self:RemoveCallbacks()
    Settings["ItemPositions"]["BurglarDebuffs"].X, Settings["ItemPositions"]["BurglarDebuffs"].Y = self:GetPosition()
    self:SetVisible(false)
    self:SetParent(nil)
end