CappyPetBanner = class(Turbine.UI.Window)
function CappyPetBanner:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.width = 150
    self.height = 50

    self.callbacks = nil

    if Settings["ItemPositions"]["CaptainPetBanner"] == nil then
        Settings["ItemPositions"]["CaptainPetBanner"] = {}
        Settings["ItemPositions"]["CaptainPetBanner"].X = math.floor(Turbine.UI.Display.GetWidth() / 2 - self.width / 2) 
        Settings["ItemPositions"]["CaptainPetBanner"].Y = 300
    end


    self:SetPosition(Settings["ItemPositions"]["CaptainPetBanner"].X, Settings["ItemPositions"]["CaptainPetBanner"].Y)
    self:SetSize(self.width, self.height)
    --self:SetBackground(ReviveIcon)
    self:SetVisible(true)

    self.banner = Turbine.UI.Label()
    self.banner:SetParent(self)
    self.banner:SetSize(self.width, 30)
    self.banner:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.banner:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    --self.banner:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.banner:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.banner:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.banner:SetMouseVisible(false)
    self.banner:SetVisible(true)
    self.banner:SetText("NO PET")

    
    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(self.width, self.height)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end

    --Updater:Subscribe(self)
    --self:SetWantsUpdates(true)

    self.ExecuteUpdate = function()
        self.banner:SetTop(math.sin(4*Turbine.Engine.GetGameTime()) * 10 + 10)
    end

    self:Check()

    self:SetCallbacks()
end

function CappyPetBanner:SetCallbacks()
    self.callbacks = AddCallback(self.player, "PetChanged", 
    function(sender, args)     
        self:Check()
    end)
end

function CappyPetBanner:Check()
    if self.player:GetPet() then
        if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
        self.updateCallback = nil
        self:SetVisible(false)
    else
        if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
        self:SetVisible(true)
    end   
end


function CappyPetBanner:RemoveCallbacks()
    RemoveCallback(self.player, "PetChanged", self.callbacks)
    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
    self.updateCallback = nil
end

function CappyPetBanner:Unload()
    self:RemoveCallbacks()
    Settings["ItemPositions"]["CaptainPetBanner"].X, Settings["ItemPositions"]["CaptainPetBanner"].Y = self:GetPosition()
    self:SetVisible(false)
    self:SetParent(nil)
end