ItemToolHandler = class(Turbine.UI.Control)
function ItemToolHandler:Constructor()
    Turbine.UI.Control.Constructor(self)
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.equipment = self.player:GetEquipment()
    self.backpack = self.player:GetBackpack()

    self.tools = {}
    self.portentTools = {}

    self.threshold = false

    for i = 1, self.equipment:GetSize(), 1 do
        local item = self.equipment:GetItem(i)
        if item ~= nil then  
            --ChatOutput(item:GetName()) 
            local itemName = item:GetName()     
            if string.find(itemName, "Threshold") or string.find(itemName, "Emblem") then
                self.threshold = true
                break
            end
        end	          
    end

    if self.threshold then self.tools["Bubble"] = ThresholdBubbleTimer() end

    self.portent = {
        ["Extremely Subtle Portent of Strength"] = 1,
        ["Subtle Portent of Strength"] = 1,
        ["Portent of Strength"] = 1,
        ["Obvious Portent of Strength"] = 1,

        ["Extremely Subtle Portent of Vitality"] = 2,
        ["Subtle Portent of Vitality"] = 2,
        ["Portent of Vitality"] = 2,
        ["Obvious Portent of Vitality"] = 2,

        ["Extremely Subtle Portent of Deftness"] = 3,
        ["Subtle Portent of Deftness"] = 3,
        ["Portent of Deftness"] = 3,
        ["Obvious Portent of Deftness"] = 3,
    }

    local backpackSize = self.backpack:GetSize()

	-- Sum itemcategories
	self.ItemCounts = {}
	for i = 1, backpackSize, 1 do
		if self.backpack:GetItem(i) then
            local name = self.backpack:GetItem(i):GetName() --:GetItemInfo()

            if self.portent[name] then
                self.portentTools[name] = true
            end
		end
	end	

    for key, value in pairs(self.portentTools) do
        if Settings["ItemPositions"][key] == nil then
            Settings["ItemPositions"][key] = {}
            Settings["ItemPositions"][key].X = 500 + 50 * self.portent[key]
            Settings["ItemPositions"][key].Y = 500 + 50 * self.portent[key]
        end


        self.tools[key] = PortentTimer(key, self.portent[key])
    end
end

function ItemToolHandler:GetItems()
    local result = {}

    for key, value in pairs(self.portent) do
        result[key] = true
    end

    if self.threshold then
        result["Threshold Jewels"] = true
    end

    return result
end

function ItemToolHandler:LoadPortents(value)
    for key, value in pairs(self.portent) do
        if self.tools[key] then
            if value then
                self.tools[key]:SetCallbacks()
            else
                self.tools[key]:RemoveCallbacks()
            end
        end
    end
end

function ItemToolHandler:LoadThreshold(value)
    if self.threshold then
        if value then
            self.tools["Bubble"]:SetCallbacks()
        else
            self.tools["Bubble"]:RemoveCallbacks()
        end
    end
end

function ItemToolHandler:Close()
    for key, value in pairs(self.tools) do
        value:Close()
    end
end