InspiritingPresence = class(Turbine.UI.Window)
function InspiritingPresence:Constructor()
    Turbine.UI.Window.Constructor(self)

    self.width = 450
    self.height = 50

    if Settings["ItemPositions"]["InspiritingPresence"] == nil then
        Settings["ItemPositions"]["InspiritingPresence"] = {}
        Settings["ItemPositions"]["InspiritingPresence"].X = math.floor(Turbine.UI.Display.GetWidth() / 2 - self.width / 2)  
        Settings["ItemPositions"]["InspiritingPresence"].Y = 100
    end

    self.duration = 10
    self.currentDuration = 0

    self:SetPosition(Settings["ItemPositions"]["InspiritingPresence"].X, Settings["ItemPositions"]["InspiritingPresence"].Y)
    self:SetSize(self.width, self.height)
    --self:SetBackground(ReviveIcon)
    self:SetVisible(false)

   -- function ValueBar:Constructor(parent, width, height, x, y, barAlignment, barColour, backgroundColour, maxValue, barName, vertical, afterAnimation)

   self.bar = ClassSpecificTools.ValueBar(self, 400, 50, 50, 0, 3, Turbine.UI.Color(0, 0, 0.8), Turbine.UI.Color(0.6,0,0,0.4), 10, "bar3")

    self.icon = Turbine.UI.Control()
    self.icon:SetParent(self)
    self.icon:SetSize(32, 32)
    self.icon:SetBackground(BackgroundHandler:GetBackground(1091840414))
    self.icon:SetMouseVisible(false)
    self.icon:SetStretchMode(1)
    self.icon:SetSize(self.height, self.height)
    self.icon:SetVisible(true)

    self.backgroundViewBox = Turbine.UI.Window()
    self.backgroundViewBox:SetParent(self)
    self.backgroundViewBox:SetSize(42, 41)
    self.backgroundViewBox:SetSize(65, 65)
    --self.backgroundViewBox:SetPosition(100 - 10 + 7, 100 - 10 + 7)
    self.backgroundViewBox:SetPosition(- 18, - 18 )
    self.backgroundViewBox:SetVisible(true)
    self.backgroundViewBox:SetMouseVisible(false)

    self.backgroundBox = Turbine.UI.Control()
    self.backgroundBox:SetParent(self.backgroundViewBox)
    self.backgroundBox:SetSize(42, 41)
    --self.backgroundBox:SetSize(256 - 22, 256 - 22)
    self.backgroundBox:SetSize(256 - 22, 256 - 22)
    self.backgroundBox:SetPosition(-12 + 10, -81 + 10)
    self.backgroundBox:SetBlendMode(Turbine.UI.BlendMode.Normal)
    self.backgroundBox:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/IconAlert.tga"))
    self.backgroundBox:SetMouseVisible(false)

    self.backgroundViewBox:SetStretchMode(1)
    self.backgroundViewBox:SetSize(90, 90)



    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(400, self.height)
    self.textLabel:SetPosition(50, 0)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetVisible(true)

    self.callbacks = {}
    --1091668185
    -- Bauble icon 0x4110B67F
    -- Heal 0x4111D246
    -- Shield 0x4111D247
    -- DPS 0x4111D248
    -- Support 0x4111D245
    -- CHeckmark 0x4111D245

    --self:SetCallbacks()

    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(self.width, self.height)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end

    self.ExecuteUpdate = function(delta)
        self.currentDuration = self.currentDuration - delta
    
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText(Round(self.currentDuration, 1))
    
        if self.currentDuration <= 0 then
            if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
            self.updateCallback = nil
            self:SetVisible(false)
        end    
    end

    self:SetCallbacks()
end

function InspiritingPresence:StartTimer()
    self.currentDuration = self.duration
    self:SetVisible(true)
    self.bar:SetCurrentValue(10)
    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
end

function InspiritingPresence:SetCallbacks()
    self.callbacks["EffectAdded"] = AddCallback(PlayerEffectsHandler, "EffectAdded", 
    function(effect)
        local effectName = effect:GetName()

        if string.find(effectName, "Inspiriting Presence") then --Threshold Morale Bubble
            self:StartTimer()
        end
    end)
end

function InspiritingPresence:RemoveCallbacks()
    for key, value in pairs(self.callbacks) do
        RemoveCallback(PlayerEffectsHandler, key, value)
    end
    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
    self.updateCallback = nil
end

function InspiritingPresence:Unload()
    self:RemoveCallbacks()
    Settings["ItemPositions"]["InspiritingPresence"].X, Settings["ItemPositions"]["InspiritingPresence"].Y = self:GetPosition()
    self:SetVisible(false)
    self:SetParent(nil)
end