MouseWindow = class(Turbine.UI.Window)
function MouseWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/Ring_10px.tga"))

    self.scale = 0.25

    self.innerCircle = Turbine.UI.Window()
    self.innerCircle:SetParent(self)
    self.innerCircle:SetMouseVisible(false)
    self.innerCircle:SetVisible(true)
    self.innerCircle:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/Circle_Smooth_Border.tga"))
    self.innerCircle:SetStretchMode(2)
    --self.innerCircle:SetPosition(3,3)
    self.innerCircle:SetSize(self.innerCircle:GetWidth(), self.innerCircle:GetHeight())
    self.innerCircle.w, self.innerCircle.h = self.innerCircle:GetSize()
    self.innerCircle:SetStretchMode(1)
    self.innerCircle:SetSize(self.innerCircle.w * self.scale, self.innerCircle.h * self.scale)
    self.innerCircle:SetOpacity(0)

    self.outerCircle = Turbine.UI.Window()
    self.outerCircle:SetParent(self)
    self.outerCircle:SetMouseVisible(false)
    self.outerCircle:SetVisible(true)
    self.outerCircle:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/Ring_10px.tga"))
    self.outerCircle:SetStretchMode(2)
    --self.outerCircle:SetPosition(3,3)
    self.outerCircle:SetSize(self.outerCircle:GetWidth(), self.outerCircle:GetHeight())
    self.outerCircle.w, self.outerCircle.h = self.outerCircle:GetSize()
    self.outerCircle:SetStretchMode(1)
    self.outerCircle:SetOpacity(0.7)
    self.outerCircle:SetSize(self.outerCircle.w * self.scale, self.outerCircle.h * self.scale)
    self.scaledWidth = (self.outerCircle.w * self.scale) * 0.5
    self.scaledHeight = (self.outerCircle.h * self.scale) * 0.5

    self.clicked = false
    self.innerOpacity = 0


    self.ExecuteUpdate = function(delta)
        local mouseX, mouseY = Turbine.UI.Display:GetMousePosition()
        self:SetPosition(mouseX - self.scaledWidth, mouseY - self.scaledHeight)

        if self.clicked then
            self.innerOpacity = self.innerOpacity - delta
            self.innerCircle:SetOpacity(self.innerOpacity)
            if self.innerOpacity < 0 then
                self.clicked = false
            end
        end

    end

    self.KeyDown = function(sender, args)
        if args.Action == 92 or args.Action == 19 then
            self.clicked = true
            self.innerOpacity = 0.6
        end
    end

    self.callback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate)
end

function MouseWindow:RemoveCallbacks()
    RemoveCallback(Updater, "ExecuteUpdate", self.callback)
end

function MouseWindow:Unload()
    self:RemoveCallbacks()
    self:SetVisible(false)
    self:SetParent(nil)
end