LMPetDebuffs = class(Turbine.UI.Window)
function LMPetDebuffs:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.skills = self.player:GetTrainedSkills()

    self.width = 150
    self.height = 50

    self.callbacks = nil

    if Settings["ItemPositions"]["LoreMasterPetDebuffs"] == nil then
        Settings["ItemPositions"]["LoreMasterPetDebuffs"] = {}
        Settings["ItemPositions"]["LoreMasterPetDebuffs"].X = math.floor(Turbine.UI.Display.GetWidth() / 3 - self.width / 2) 
        Settings["ItemPositions"]["LoreMasterPetDebuffs"].Y = 500
    end
    
    self.catmint = 0
    self:SetPosition(Settings["ItemPositions"]["LoreMasterPetDebuffs"].X, Settings["ItemPositions"]["LoreMasterPetDebuffs"].Y)
    self:SetSize(self.width, self.height)
    --self:SetBackground(ReviveIcon)
    self:SetVisible(true)

    -- Bear 1090553875
    -- Bog 1091454478
    -- Spirit 1091671530
    -- Raven 1090553821
    self.colourScheme = {Turbine.UI.Color(0,0,0), Turbine.UI.Color(0, 0,0,0), Turbine.UI.Color(0,170/255,170/255), Turbine.UI.Color(1,1,1), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0, 0,0,0), nil, nil, 0.6, 0.6}
    
    self.Timers = {
        ["Bear"] = EffectTimer(self, 50, 20, nil, "", Turbine.UI.Lotro.Font.VerdanaBold16, self.colourScheme, true, nil, 30, 1090553875),
        ["Bog"] = EffectTimer(self, 50, 20, nil, "", Turbine.UI.Lotro.Font.VerdanaBold16, self.colourScheme, true, nil, 30, 1091454478),
        ["Spirit"] = EffectTimer(self, 50, 20, nil, "", Turbine.UI.Lotro.Font.VerdanaBold16, self.colourScheme, true, nil, 30, 1091671530),
        ["Raven"] = EffectTimer(self, 50, 20, nil, "", Turbine.UI.Lotro.Font.VerdanaBold16, self.colourScheme, true, nil, 60, 1090553821),
        ["Lynx"] = EffectTimer(self, 50, 20, nil, "", Turbine.UI.Lotro.Font.VerdanaBold16, self.colourScheme, true, nil, 60, 1091454475),
    }

    self.skillToTimer = {
        ["Shatter Arms"] = {"Bear", 30},
        ["Root Strike"] = {"Bog", 30},
        ["Nature's Light"] = {"Spirit", 30},
        ["Benediction of the Raven"] = {"Raven", 60},
        ["Frostbite"] = {"Lynx", 60},
        --[""]
    }

    self.ActiveTimers = {
        ["Bear"] = 0,
        ["Bog"] = 0,
        ["Spirit"] = 0,
        ["Raven"] = 0,
        ["Lynx"] = 0,
    }

    self.Catmintable = {
        ["Spirit"] = true,
        ["Raven"] = true,
    }

    self.catmintIcons = {}

    --1091804905

    local counter = 0
    for key, value in spairs(self.Timers, function(t,a,b) return a > b end) do
        value:SetPosition(20, 20 * counter)
        if self.Catmintable[key] then
            local catmint = Turbine.UI.Control()
            catmint:SetParent(self)
            catmint:SetSize(32, 32)
            catmint:SetMouseVisible(false)
            catmint:SetPosition(0, 20 * counter)
            catmint:SetBackground(BackgroundHandler:GetBackground(1091804905))
            catmint:SetStretchMode(1)
            catmint:SetSize(20, 20)
            catmint:SetVisible(false)

            self.catmintIcons[key] = catmint
        end
        self.Timers[key]:HideText(false)
        self.Timers[key]:ChangeDuration(0)
        counter = counter + 1
    end
    
    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(self.width, self.height)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end


    self.ExecuteUpdate = function(delta)
        for key, value in pairs(self.ActiveTimers) do
            self.Timers[key]:UpdateText(delta)
            self.ActiveTimers[key] = value - delta
    
            if self.ActiveTimers[key] < 0 then
                self.ActiveTimers[key] = nil
                self.Timers[key]:HideText(false)
                --self.Timers[key]:ChangeName("")
                if self.catmintIcons[key] then self.catmintIcons[key]:SetVisible(false) end
            end
        end
    end

    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
    --self:SetWantsUpdates(true)

    self:SetCallbacks()
end

function LMPetDebuffs:SetCallbacks()

    ChatEventHandler:Subscribe(self)
    ChatEventHandler:TogglePlayerCombat(true)

    for i = 1, self.skills:GetCount(), 1 do
        local item = self.skills:GetItem(i)--:GetSkillInfo()
        if item:GetSkillInfo():GetName() == "Catmint" then
            self.skillItem = item
            self.callbacks = AddCallback(item, "ResetTimeChanged", 
            function()
                self.catmint = Turbine.Engine.GetGameTime() 
            end)
        end
    end
end


function LMPetDebuffs:ParseUpdate(message)
    --local source,_,skillName,target,_ = string.match(string.gsub(string.gsub(message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"),"^(.*) scored a (.*)hit with (.*) on (.*) for (.-) (.*)%.$")
    --local skillName = string.match(cleanedString,"Your companion successfully performed (.*)%.$")
    local source,_,skillName,target = string.match(message,"^(.*) scored a (.*)hit with (.*) on (.-)%.$")
    --local skillName = string.match(string.gsub(string.gsub(message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"),"You release your (.*)%.$")
    if self.skillToTimer[skillName] then
        local info = self.skillToTimer[skillName]
        self.Timers[info[1]]:ChangeDuration(info[2])
        --self.Timers[info[1]]:ChangeName(string.gsub(target,"^[Tt]he ",""))
        self.Timers[info[1]]:HideText(true)
        self.ActiveTimers[info[1]] = info[2]

        if Turbine.Engine.GetGameTime() < self.catmint + 12 and self.Catmintable[info[1]] then 
            self.catmintIcons[info[1]]:SetVisible(true)
        elseif self.catmintIcons[info[1]] then
            self.catmintIcons[info[1]]:SetVisible(false)
        end
    end

    if message == "You release your companion." then self.catmint = 0 end
end


function LMPetDebuffs:RemoveCallbacks()
    ChatEventHandler:UnSubscribe(self)
    ChatEventHandler:TogglePlayerCombat(nil)
    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
    if self.callbacks then RemoveCallback(self.skillItem, "ResetTimeChanged", self.callbacks) end
    self.updateCallback = nil
end

function LMPetDebuffs:Unload()
    self:RemoveCallbacks()
    Settings["ItemPositions"]["LoreMasterPetDebuffs"].X, Settings["ItemPositions"]["LoreMasterPetDebuffs"].Y = self:GetPosition()
    self:SetVisible(false)
    self:SetParent(nil)
end