PortentTimer = class(Turbine.UI.Window)
function PortentTimer:Constructor(name, type)
    Turbine.UI.Window.Constructor(self)

    self.name = name

    self:SetPosition(Settings["ItemPositions"][self.name].X, Settings["ItemPositions"][self.name].Y)
    self:SetSize(32, 32)
    --self:SetBackground(1091668185)
    self:SetVisible(false)

    self.background = Turbine.UI.Window()
    self.background:SetParent(self)
    self.background:SetSize(32, 32)
    self.background:SetBackground(BackgroundHandler:GetBackground(0x4110B67F))
    self.background:SetVisible(true)
    self.background:SetOpacity(0.8)

    self.typeLabel = Turbine.UI.Control()
    self.typeLabel:SetParent(self)
    self.typeLabel:SetSize(32, 32)
    if type == 1 then -- DPS
        self.typeLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D248))
    elseif type == 2 then -- Heal
        self.typeLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D246))
    else -- Shield
        self.typeLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D247))
    end

    self.typeLabel:SetStretchMode(1)
    self.typeLabel:SetSize(24,24)
    self.typeLabel:SetPosition(4, 0)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(32, 32)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetVisible(true)

    self.activeLabel = Turbine.UI.Label()
    self.activeLabel:SetParent(self)
    self.activeLabel:SetSize(32, 32)
    self.activeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.activeLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.activeLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.activeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.activeLabel:SetMouseVisible(false)
    self.activeLabel:SetStretchMode(1)
    self.activeLabel:SetVisible(true)
    self.activeLabel:SetForeColor(Turbine.UI.Color(0.9, 0.1, 1, 0.1))

    self.duration = 0
    self.currentNumber = 0
    self.activeTime = 0
    self.callback = nil
    --1091668185
    -- Bauble icon 0x4110B67F
    -- Heal 0x4111D246
    -- Shield 0x4111D247
    -- DPS 0x4111D248
    -- Support 0x4111D245
    -- CHeckmark 0x4111D245

    --self:SetCallbacks()

    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(32, 32)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end

    self.ExecuteUpdate = function(delta)
        self.duration = self.duration - delta
        self.activeTime = self.activeTime - delta
    
        local newNumber = math.round(self.duration)
        if newNumber == self.currentNumber then return end
    
        self.currentNumber = newNumber
    
        if self.duration < 0 then
            self.textLabel:SetStretchMode(nil)
            self.textLabel:SetStretchMode(1)
            self.textLabel:SetText("")
            self:SetVisible(false)
            if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
            self.updateCallback = nil
            return true
        elseif self.duration < 60 then
            self.textLabel:SetStretchMode(nil)
            self.textLabel:SetStretchMode(1)
            self.textLabel:SetText(self.currentNumber)
            if not(self:IsVisible()) then
                self:SetVisible(true)
                self.textLabel:SetVisible(true)
            end
        end
    
        if self.activeTime < 0 and self.activeLabel:IsVisible() then
            self.activeLabel:SetStretchMode(nil)
            self.activeLabel:SetStretchMode(1)
            self.activeLabel:SetText("")
            self.activeLabel:SetVisible(false)
            self:SetVisible(false)
        else
            self.activeLabel:SetStretchMode(nil)
            self.activeLabel:SetStretchMode(1)
            self.activeLabel:SetText(math.round(self.activeTime))
        end
    end
end

function PortentTimer:SetCallbacks()
    self.callback = AddCallback(PlayerEffectsHandler, "EffectAdded", 
    function(effect)
        if effect:GetName() == self.name then --Threshold Morale Bubble
            self.duration = 600
            self.activeTime = effect:GetDuration()
            self:SetVisible(true)
            self.activeLabel:SetVisible(true)
            self.textLabel:SetVisible(true)
            if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
        end
    end)
end

function PortentTimer:RemoveCallbacks()
    RemoveCallback(PlayerEffectsHandler, "EffectAdded", self.callback)
    if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
    self.updateCallback = nil
end

function PortentTimer:Close()
    self:RemoveCallbacks()
    Settings["ItemPositions"][self.name].X, Settings["ItemPositions"][self.name].Y = self:GetPosition()
end