ReviveTracker = class(Turbine.UI.Window)
function ReviveTracker:Constructor()
    Turbine.UI.Window.Constructor(self)

    if Settings["ItemPositions"]["ReviveTracker"] == nil then
        Settings["ItemPositions"]["ReviveTracker"] = {}
        Settings["ItemPositions"]["ReviveTracker"].X = 500 
        Settings["ItemPositions"]["ReviveTracker"].Y = 500
    end

    self.size = 56

    self:SetPosition(Settings["ItemPositions"]["ReviveTracker"].X, Settings["ItemPositions"]["ReviveTracker"].Y)
    self:SetSize(self.size, self.size)
    self:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/ReviveIcon.jpg"))
    self:SetVisible(false)

    self.backgroundViewBox = Turbine.UI.Control()
    self.backgroundViewBox:SetParent(self)
    self.backgroundViewBox:SetSize(42, 41)
    self.backgroundViewBox:SetSize(65, 65)
    --self.backgroundViewBox:SetPosition(100 - 10 + 7, 100 - 10 + 7)
    self.backgroundViewBox:SetPosition(- 20, - 20 )
    self.backgroundViewBox:SetVisible(true)
    self.backgroundViewBox:SetMouseVisible(false)
    self.backgroundViewBox:SetOpacity(0)

    self.backgroundBox = Turbine.UI.Control()
    self.backgroundBox:SetParent(self.backgroundViewBox)
    self.backgroundBox:SetSize(42, 41)
    --self.backgroundBox:SetSize(256 - 22, 256 - 22)
    self.backgroundBox:SetSize(256 - 22, 256 - 22)
    self.backgroundBox:SetPosition(-12 + 10, -81 + 10)
    self.backgroundBox:SetBlendMode(Turbine.UI.BlendMode.Normal)
    self.backgroundBox:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/IconAlert.tga"))
    self.backgroundBox:SetMouseVisible(false)

    self.backgroundViewBox:SetStretchMode(1)
    self.backgroundViewBox:SetSize(98, 98)


    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(self.size, self.size)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    --self.textLabel:SetStretchMode(1)
    self.textLabel:SetVisible(true)

    self.activeLabel = Turbine.UI.Label()
    self.activeLabel:SetParent(self)
    self.activeLabel:SetSize(self.size, self.size)
    self.activeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.BottomRight)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.activeLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold22)
    self.activeLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.activeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.activeLabel:SetMouseVisible(false)
    --self.activeLabel:SetStretchMode(1)
    self.activeLabel:SetVisible(true)
    self.activeLabel:SetForeColor(Turbine.UI.Color(0.9, 0.1, 1, 0.1))
    --self.activeLabel:SetText(3 .. " ")

    self.duration = 0
    self.currentNumber = 0
    self.activeTime = 0
    self.callbacks = {}

    self.animateTimer = 0

    self.reviveID = nil

    self.totalRevives = -1

    self.effectList = Turbine.Gameplay.LocalPlayer.GetInstance():GetEffects()
    --1091668185
    -- Bauble icon 0x4110B67F
    -- Heal 0x4111D246
    -- Shield 0x4111D247
    -- DPS 0x4111D248
    -- Support 0x4111D245
    -- CHeckmark 0x4111D245

    --self:SetCallbacks()

    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(self.size, self.size)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end

    self.ExecuteUpdate = function(delta)
        self.duration = self.duration - delta
    
        local newNumber = math.round(self.duration)
        if newNumber == self.currentNumber then return end
    
        self.currentNumber = newNumber
    
        if self.duration < 0 then
            self.duration = self:GetTime()
        end

        self.textLabel:SetText(string.format("%d:%02.f", self.duration / 60, self.duration % 60))
    end

    self:SetCallbacks()
end

function ReviveTracker:Update()

    local delta = (Turbine.Engine.GetGameTime() - self.oldGameTime) / 80

    self.animateTimer = self.animateTimer - delta

    if self.animateTimer < -1 then
        self:SetWantsUpdates(false)
    else
        self.backgroundViewBox:SetOpacity(1 - math.abs(self.animateTimer))
    end



end

function ReviveTracker:Animate()
    self:SetWantsUpdates(true)
    self.animateTimer = 1
    self.oldGameTime = Turbine.Engine.GetGameTime()
end

function ReviveTracker:SetCallbacks()
    self.callbacks["EffectAdded"] = AddCallback(PlayerEffectsHandler, "EffectAdded", 
    function(effect)

        local effectName = effect:GetName()

        if string.find(effectName, "Revives") then
            if string.find(effectName, "Revives Available") then
                local number = tonumber(string.match(effectName, "(%d+)"))
                self.reviveID = effect:GetID()

                if number >= self.totalRevives then
                    self:SetVisible(true)
                    self:Animate()
                    self.duration = self:GetTime()
                    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
                    self.textLabel:SetVisible(true)
                end

                self.totalRevives = number

                if self.totalRevives == 1 then
                    self.activeLabel:SetForeColor(Turbine.UI.Color(0.9, 1, 1, 0.1))
                elseif self.totalRevives < 1 then
                    self.activeLabel:SetForeColor(Turbine.UI.Color(0.9, 1, 0.1, 0.1))
                else
                    self.activeLabel:SetForeColor(Turbine.UI.Color(0.9, 0.1, 1, 0.1))
                end
                self:ChangeLabel()
                

            elseif effectName == "Revives Exhausted" then
                self.reviveID = effect:GetID()
                self.totalRevives = 0
                --self.duration = self:GetTime()
                if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
                self.textLabel:SetVisible(true)
                self:ChangeLabel()
            end
        end
    end)

    self.callbacks["EffectRemoved"] = AddCallback(PlayerEffectsHandler, "EffectRemoved", function(effect)
        if effect then 
          if self.reviveID == effect:GetID() then
            self:SetVisible(false)
            self.totalRevives = -1
          end
        end
      end)
end

function ReviveTracker:ChangeLabel()
    self.activeLabel:SetText(self.totalRevives .. " ")
end

function ReviveTracker:GetTime()
    if Settings.InstanceTier and tonumber(Settings.InstanceTier) ~= nil then
        return (Settings.InstanceTier - 1) * 60
    end
    return 60
end

function ReviveTracker:RemoveCallbacks()
    for key, value in pairs(self.callbacks) do
        RemoveCallback(PlayerEffectsHandler, key, value)
    end
    if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
    self.updateCallback = nil
end

function ReviveTracker:Unload()
    self:RemoveCallbacks()
    Settings["ItemPositions"]["ReviveTracker"].X, Settings["ItemPositions"]["ReviveTracker"].Y = self:GetPosition()
    self:SetVisible(false)
    self:SetParent(nil)
end