ScropeStatus = class(Turbine.UI.Window)
function ScropeStatus:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    

    self.width = 120
    self.height = 32

    self.scropeCount = 0

    self.callbacks = {}

    if Settings["ItemPositions"]["ScropeStatus"] == nil then
        Settings["ItemPositions"]["ScropeStatus"] = {}
        Settings["ItemPositions"]["ScropeStatus"].X = math.floor(Turbine.UI.Display.GetWidth() / 2 - self.width / 2) 
        Settings["ItemPositions"]["ScropeStatus"].Y = 200
    end
    

    self:SetPosition(Settings["ItemPositions"]["ScropeStatus"].X, Settings["ItemPositions"]["ScropeStatus"].Y)
    self:SetSize(self.width, self.height)
    --self:SetBackground(ReviveIcon)
    self:SetVisible(true)

    self.fittingIcons = {
        [1090642112] = true,
        [1090642113] = true,
        [1091526109] = true,
    }
    
    self.battle = Turbine.UI.Control()
    self.battle:SetParent(self)
    self.battle:SetMouseVisible(false)
    self.battle:SetVisible(true)
    self.battle:SetSize(32, 32)
    self.battle:SetBackground(BackgroundHandler:GetBackground(1090642112))

    self.battleID = nil


    self.battlehighlightFrame = ClassSpecificTools.HighlightFrame(self.battle)
    self.battlehighlightFrame:Toggle(true)

    self.warding = Turbine.UI.Control()
    self.warding:SetParent(self)
    self.warding:SetMouseVisible(false)
    self.warding:SetVisible(true)
    self.warding:SetSize(32, 32)
    self.warding:SetBackground(BackgroundHandler:GetBackground(1090642113))
    self.warding:SetPosition(40, 0)

    self.wardingID = nil

    self.wardinghighlightFrame = ClassSpecificTools.HighlightFrame(self.warding)
    self.wardinghighlightFrame:Toggle(true)


    self.hope = Turbine.UI.Control()
    self.hope:SetParent(self)
    self.hope:SetMouseVisible(false)
    self.hope:SetVisible(true)
    self.hope:SetSize(32, 32)
    self.hope:SetBackground(BackgroundHandler:GetBackground(1091526109))
    self.hope:SetPosition(80, 0)

    self.hopeID = nil


    self.hopehighlightFrame = ClassSpecificTools.HighlightFrame(self.hope)
    self.hopehighlightFrame:Toggle(true)
    
    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(self.width, self.height)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end

    self.effectList = Turbine.Gameplay.LocalPlayer.GetInstance():GetEffects()

    for i = 1, self.effectList:GetCount(), 1 do
        local effect = self.effectList:Get(i)

        if self.fittingIcons[effect:GetIcon()] then 
            self:Toggle(effect, false) 
        end

    end 

    self:SetCallbacks()
    self:CombatUpdate()
end

function ScropeStatus:Toggle(effect, value)
    local effectName = effect:GetName()
    local effectID = effect:GetID()
    if string.find(effectName, "Battle Lore") and (not(value) or  effectID == self.battleID ) then
        self.battleID = effect:GetID()
        self.battle:SetVisible(value)
        self.battlehighlightFrame:Activate(value)

        self:AdjustCounter(value)

    elseif string.find(effectName, "Warding Lore") and (not(value) or  effectID == self.wardingID) then
        self.wardingID = effect:GetID()
        self.warding:SetVisible(value)
        self.wardinghighlightFrame:Activate(value)

        self:AdjustCounter(value)

    elseif string.find(effectName, "Token: Give Hope") and (not(value) or  effectID == self.hopeID ) then
        self.hopeID = effect:GetID()
        self.hope:SetVisible(value)
        self.hopehighlightFrame:Activate(value)

        self:AdjustCounter(value)

    end
end

function ScropeStatus:AdjustCounter(value)
    if value then 
        self.scropeCount = self.scropeCount + 1 
    else 
        self.scropeCount = self.scropeCount - 1 
    end

    if self.scropeCount == 3 then 
        self.MoveBox:SetVisible(false)
    else
        self.MoveBox:SetVisible(true)
    end
end

function ScropeStatus:SetCallbacks()
    self.callbacks["EffectAdded"] = AddCallback(PlayerEffectsHandler, "EffectAdded", 
    function(effect)
        if self.fittingIcons[effect:GetIcon()] then
            self:Toggle(effect, false)
        end
    end)

    self.callbacks["EffectRemoved"] = AddCallback(PlayerEffectsHandler, "EffectRemoved", function(effect)
        if effect then 
            if self.fittingIcons[effect:GetIcon()] then 
                self:Toggle(effect, true)
            end
        end
    end)

    self.playerCallback = AddCallback(self.player, "InCombatChanged", function(sender, args)
        self:CombatUpdate()
    end)
end

function ScropeStatus:CombatUpdate()
    if self.player:IsInCombat() then
        self:SetVisible(false)
    else
        self:SetVisible(true)
    end
end

function ScropeStatus:RemoveCallbacks()
    for key, value in pairs(self.callbacks) do
        RemoveCallback(PlayerEffectsHandler, key, value)
    end

    RemoveCallback(self.player, "InCombatChanged", self.playerCallback)
end

function ScropeStatus:Unload()
    self:RemoveCallbacks()
    Settings["ItemPositions"]["ScropeStatus"].X, Settings["ItemPositions"]["ScropeStatus"].Y = self:GetPosition()
    self:SetVisible(false)
    self:SetParent(nil)
end