ShadowPuddleTracker = class(Turbine.UI.Window)
function ShadowPuddleTracker:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.width = 150
    self.height = 50

    self.callbacks = {}
    self.effectID = 0

    if Settings["ItemPositions"]["ShadowPuddleTracker"] == nil then
        Settings["ItemPositions"]["ShadowPuddleTracker"] = {}
        Settings["ItemPositions"]["ShadowPuddleTracker"].X = math.floor(Turbine.UI.Display.GetWidth() / 2 - self.width / 2) 
        Settings["ItemPositions"]["ShadowPuddleTracker"].Y = 400
    end


    self:SetPosition(Settings["ItemPositions"]["ShadowPuddleTracker"].X, Settings["ItemPositions"]["ShadowPuddleTracker"].Y)
    self:SetSize(64, 64)
    --self:SetBackground(ReviveIcon)
    self:SetVisible(false)

    self.banner = Turbine.UI.Label()
    self.banner:SetParent(self)
    self.banner:SetSize(32, 32)
    self.banner:SetBackground(BackgroundHandler:GetBackground(1091400591))
    self.banner:SetStretchMode(1)
    self.banner:SetSize(128, 128)
    
    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(self.width, self.height)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end

    self:SetCallbacks()
end

function ShadowPuddleTracker:SetCallbacks()
    self.callbacks["EffectAdded"] = AddCallback(PlayerEffectsHandler, "EffectAdded", 
    function(effect)
        local effectName = effect:GetName()

        if effectName == "Shadow Zone" then
            self:SetVisible(true)
            self.effectID = effect:GetID()
        end

    end)

    self.callbacks["EffectRemoved"] = AddCallback(PlayerEffectsHandler, "EffectRemoved", function(effect)
        if effect then 
          if self.effectID == effect:GetID() then
            self:SetVisible(false)
          end
        end
      end)
end


function ShadowPuddleTracker:RemoveCallbacks()
    for key, value in pairs(self.callbacks) do
        RemoveCallback(PlayerEffectsHandler, key, value)
    end
end

function ShadowPuddleTracker:Unload()
    self:RemoveCallbacks()
    Settings["ItemPositions"]["ShadowPuddleTracker"].X, Settings["ItemPositions"]["ShadowPuddleTracker"].Y = self:GetPosition()
    self:SetVisible(false)
    self:SetParent(nil)
end