ThresholdBubbleTimer = class(Turbine.UI.Window)
function ThresholdBubbleTimer:Constructor()
    Turbine.UI.Window.Constructor(self)

    self:SetPosition(Settings.ThresX, Settings.ThresY)
    self:SetSize(32, 32)
    --self:SetBackground(1091668185)
    self:SetVisible(false)

    self.background = Turbine.UI.Window()
    self.background:SetParent(self)
    self.background:SetSize(32, 32)
    self.background:SetBackground(BackgroundHandler:GetBackground(1091668185))
    self.background:SetVisible(true)
    self.background:SetOpacity(0.8)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(32, 32)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetVisible(true)

    self.duration = 0
    self.currentNumber = 0
    self.callback = nil
    --1091668185

    --self:SetCallbacks()

    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(32, 32)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end

    self.ExecuteUpdate = function(delta)
        self.duration = self.duration - delta
    
        local newNumber = math.round(self.duration)
        if newNumber == self.currentNumber then return end
    
        self.currentNumber = newNumber
    
        if self.duration < 0 then
            self.textLabel:SetStretchMode(nil)
            self.textLabel:SetStretchMode(1)
            self.textLabel:SetText("")
            self:SetVisible(false)
            if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
            self.updateCallback = nil
            return true
        end
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText(self.currentNumber)
    end
end

function ThresholdBubbleTimer:SetCallbacks()
    self.callback = AddCallback(PlayerEffectsHandler, "EffectAdded", 
    function(effect)
        if effect:GetName() == "Threshold Morale Bubble" then --Threshold Morale Bubble
            self.duration = 30
            self:SetVisible(true)
            if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
        end
    end)
end

function ThresholdBubbleTimer:RemoveCallbacks()
    RemoveCallback(PlayerEffectsHandler, "EffectAdded", self.callback)
    if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
    self.updateCallback = nil
end

function ThresholdBubbleTimer:Close()
    self:RemoveCallbacks()
    Settings.ThresX, Settings.ThresY = self:GetPosition()
end
