TooltipDetachHandler = class(Turbine.UI.Window)
function TooltipDetachHandler:Constructor()
    Turbine.UI.Window.Constructor(self)

    local x = Settings.TBX
    local y = Settings.TBY
    local width = 100
    local height = 5000
    self:SetVisible(true)
    self:SetPosition(x, y)
    self:SetSize(width, height)
    --self:SetBackColor(GetRandomColour())
    self:SetMouseVisible(false)

    self.TargetSelectionsBoxes = {}
    self.TargetSelections = {}
    self.VisibleBox = {}

    self.targettingAllowed = false

    self.ViewingWindow = {}

    self.BoxCount = 0

    self.Shuffle = false

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.callback = {}

    --self.moveBox = MoveBox(self, width, 50, "TargetBox")    

    -- [[
    self.TargetChanged = function(sender)
        local PTarget = sender:GetTarget()
        local PTarget2 = sender:GetTarget()
        if PTarget then
            local TargetName = PTarget:GetName()
            self.TargetSelectionsBoxes[TargetName] = UITooltipBox(TargetName, self)

            self.TargetSelections[TargetName] = PTarget
            self.TargetSelectionsBoxes[TargetName]:SetEntity(PTarget)
            --
        end
    end

    self:SetWantsKeyEvents(true)
	self.KeyDown = function(sender, args)
		if (args.Action == Turbine.UI.Lotro.Action.Tooltip_Detach) then
			self.TargetChanged(Turbine.Gameplay.LocalPlayer.GetInstance())
		end
	end
    --]]
end

function TooltipDetachHandler:Unload()
end

UITooltipBox = class(Turbine.UI.Window)
function UITooltipBox:Constructor(name, handler)
    Turbine.UI.Window.Constructor(self)
    self.borderSize = 1
    self.height = 25 + 2 * self.borderSize
    self.width = string.len(name) * 10  + self.height + 2 * self.borderSize
    self:SetVisible(true)
    self:SetPosition(Turbine.UI.Display:GetMousePosition())
    self:SetSize(self.width, self.height)
    self:SetBackColor(Turbine.UI.Color.Black)
    self:SetMouseVisible(true)

    self.ViewingWindow = 15

    self.handler = handler

    self.E = Turbine.UI.Lotro.EntityControl()
    self.E:SetParent(self)
    self.E:SetVisible(true)
    self.E:SetMouseVisible(true)
    self.E:SetPosition(self.borderSize, self.borderSize)
    self.E:SetSize(self.width - 2 * self.borderSize, self.height - 2 * self.borderSize)
    self.E:SetBackColor(Turbine.UI.Color(0.4, 0, 0, 0))

    self.Moving = false

    self.E.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.E.MouseUp = function()
        self.Moving = false
    end

    self.E.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end



    self.opacityNameWindow = Turbine.UI.Window()
    self.opacityNameWindow:SetParent(self)
    self.opacityNameWindow:SetSize(self.height, self.height)
    self.opacityNameWindow:SetPosition(self.width - self.height, 0)
    self.opacityNameWindow:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.opacityNameWindow:SetOpacity(0.3)
    self.opacityNameWindow:SetVisible(true)
    self.opacityNameWindow:SetMouseVisible(true)
    self.opacityNameWindow:SetBackColor(Turbine.UI.Color(1, 0, 0))

    self.opacityNameWindow.MouseClick = function()
        self.E:SetEntity(nil)
        self.handler.TargetSelections[name] = nil
        self.handler.TargetSelectionsBoxes[name] = nil
        self:SetVisible(false)
        self:SetParent(nil)
        local controlList = self:GetControls()
        for i = 1, controlList:GetCount() do
            controlList:RemoveAt(1)
        end
        for key, _ in pairs(self) do
            self[key] = nil
        end
        collectgarbage()
    end

    self.NameLabel = Turbine.UI.Label()
    self.NameLabel:SetParent(self)
    self.NameLabel:SetSize(self.width - self.height, self.height)
    self.NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.NameLabel:SetMouseVisible(false)
    self.NameLabel:SetMarkupEnabled(true)
    self.NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.NameLabel:SetText(name)
end

function UITooltipBox:SetEntity(entity)
    self.E:SetEntity(entity)
end