BeorningTools = class(Turbine.UI.Window)
function BeorningTools:Constructor(data, buffData)
    Turbine.UI.Window.Constructor(self)
    self.width = 500
    self.height = 500
    self:SetPosition(Settings.ClassToolsX, Settings.ClassToolsY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.data = data
    self.buffData = buffData

    -- 0x411172A2 kisses
    -- 0x4115B59E broken armour
    -- 0x4115B58E crit roar
    -- 0x4115B58E knockdown
    -- 0x4115B586 blue buff
    -- 0x4115B59D blue recup
    -- 0x4115B5C1 blue green recup
    -- 0x4115B5BC red bear form icon
    -- 0x4115B5BA bash bleed + 
    -- 0x4115B59B free heal roar
    -- 0x4115B5AF slash bleed
    -- 0x41139EFF Blood rage
    -- 0x4113A06D Yellow break ranks
    -- 0x4115B59F Blue armour crush

    self.moveBox = MoveBox(self, self.width, self.height, "Beorning Tools")

    self.buffSkillBar = DynamicSkillBar(self, 0, 0, self.width, 32, 32, 2, true)
    self.normalSkillBar = DynamicSkillBar(self, 0, 52, self.width, 64, 32, 4, false)
    self.specialSkillBar = DynamicSkillBar(self, 0, 84, self.width, 64, 32, 4, false)
    self.markBar = DynamicSkillBar(self, self.width / 2 - 16 - 32, 116, 96, 64, 32, 4, false)

    self:LoadData()

    self.name = self.player:GetName()

    self.noSkills = Settings.ClassToolsNoSkills
    --self.noSkills = true

    self.playerCallbacks = {}
    self.effectCallbacks = {}
    self.attrCallbacks = nil

    self.skillCallbacks = {}
    self.skillsLUT = {}

    self.skillCount = 0 
    self.specialSkillCount = 0

    self.formSlots = {}
    
    self.skillSlots = {}
    self.specialSkillSlots = {}

    self.currentForm = "Man-form"
    self.ferocious = Settings.ClassToolsBeorningFerocious
    self.slashBleed = Settings.ClassToolsBeorningSlash

    self.skills = {
        ["Encouraging Roar"] = {1, "0x700412EE", 1}, -- 
        ["Rejuvenating Bellow"] = {2, "0x70041F62", 1}, -- 
        ["Recuperate"] = {3, "0x7004128D", 1},
        ["Relentless Maul"] = {4, "0x700403B9", 1}, -- 
        ["Rending Blow"] = {5, "0x7004128B", 1},
        ["Grisly Cry"] = {6, "0x700403B7", 1},
        ["Takedown"] = {7, "0x700412ED", 1},
        ["Thrash - Tier 1"] = {8, "0x70041E78", 1},

        ["Expose (Man)"] = {1, "0x70041258", 2},
        ["Expose (Bear)"] = {1, "0x70041258", 2},
        ["Bash"] = {2, "0x70041255", 2},
        ["Bee Swarm"] = {9, "0x700403BB", 2},
        ["Slash"] = {20, "0x7004038F", 2},
        ["Slam"] = {21, "0x70040391", 2},
        ["Biting Edge"] = {22, "0x70040390", 2},
        ["Ferocious Roar"] = {23, "0x7004039C", 2},
        ["Hearten"] = {24, "0x7004039B", 2},
        ["Nature's Mend"] = {25, "0x700412EA", 2},

        ["Vigilant Roar"] = {1, "0x700403B6", 3},
        ["Thunderous Roar"] = {2, "0x70042DD1", 3},
        ["Piercing Roar"] = {5, "0x70041253", 3},
        ["Sacrifice"] = {10, "0x700403B8", 3},
        ["Shake Free"] = {11, "0x7004039D", 3},
        ["Cleanse"] = {12, "0x7004039E", 3},
        ["Rush"] = {13, "0x7004039A", 3},
        ["Nature's Bond"] = {14, "0x70041F1B", 3},
        ["Vicious Claws"] = {20, "0x700403BA", 3},
        ["Nature's Vengeance"] = {21, "0x7004039F", 3},
        --["Bear Up"] = {22, "0x70042DB4", 2},
        ["Overbearing"] = {22, "0x70042DD0", 3},
        --["Overbearing"] = {, "0x70042DD0", 2},
    }

    if self.data == nil then
        self.data = {}
        for key, value in pairs(self.skills) do
            self.data[key] = {true, value[1], value[3]}
        end
    else
        for key, value in pairs(self.data) do
            --ChatOutput(value[1])
            if value[1] == false then
                self.skills[key] = nil
            else
                self.skills[key] = {value[2], self.skills[key][2], value[3]}
            end
        end
    end

    self.dynamicSkillTable = {
        ["Encouraging Roar"] = {15, 1091940904, 2},
        ["Rending Blow"] = {10, 0x4115B59F, 2},
        ["Bee Swarm"] = {12, 0x4115B220, 10}
        --1091940904
    }

        self.parseSkills = {
        ["Mark of Grimbeorn"] = true,
        ["Encouraging Roar"] = true,
        ["Slash"] = true,
    }

    self.dynamicEffectTable = {
        -- Yellow + Base
        ["Recuperate"] = {1091940911, 3},
        ["Aiding Strike - Tier 1"] = {1091945028, 1},
        ["Aiding Strike - Tier 2"] = {1091945017, 1},
        ["Aiding Strike - Tier 3"] = {1091945029, 1},
        ["Assertive Roar"] = {1091941769, 10},
        ["Rush"] = {1091940899, 50},
        ["Vicious Rage"] = {1091941770, 5},
        ["Ferocious Roar"] = {1091940918, 30},
        ["Hardened Heart"] = {1091941799, 30},
        ["Enduring Hide"] = {1091941829, 20},
        ["Honey Cleanse"] = {1091945026, 5}, -- 2 1091945041 -- 3

        -- Blue
        ["Thickened Hide"] = {1091940987, 1},
        ["Counter"] = {1091940905, 2},
        ["Guarded - Tier 1"] = {1091945024, 3},
        ["Guarded - Tier 2"] = {1091945020, 3},
        ["Guarded - Tier 3"] = {1091945022, 3},
        ["Guarded - Tier 4"] = {1091945035, 3},
        ["Guarded - Tier 5"] = {1091945040, 3},

        -- Red
        ["Sharpened Claws"] = {1091941774, 5},
        ["Expose Weakness - Man Form"] = {1091941790, 1},
        ["Expose Weakness - Bear Form"] = {1091940901, 1},
        ["Raining Blows - Tier 1"] = {1091945038, 10},
        ["Raining Blows - Tier 2"] = {1091945036, 10},
        ["Raining Blows - Tier 3"] = {1091945019, 10},
    }
    --        ["Honey Cleanse"] = {1091945026, 5}, -- 2 1091945041 -- 3

    self.removeEffectTable = {
        ["Aiding Strike - Tier 1"] = true,
        ["Aiding Strike - Tier 2"] = true,
        ["Aiding Strike - Tier 3"] = true,
        ["Assertive Roar"] = true,  
        ["Ferocious Roar"] = true,
        ["Raining Blows - Tier 1"] = true,
        ["Raining Blows - Tier 2"] = true,
        ["Raining Blows - Tier 3"] = true,
        ["Relentless Maul"] = true,
        ["Guarded - Tier 1"] = true,
        ["Guarded - Tier 2"] = true,
        ["Guarded - Tier 3"] = true,
        ["Guarded - Tier 4"] = true,
        ["Guarded - Tier 5"] = true,
        ["Honey Cleanse"] = true,
    }

    -- stacks
    self.specialEffectTable = {}

    if self.buffData == nil or tablelength(self.buffData) < 1  then
        self.buffData = {}
        for key, value in pairs(self.dynamicEffectTable) do
            self.buffData[key] = {value[1], value[2], nil, self.removeEffectTable[key] ~= nil, true}
        end
    else
        for key, value in pairs(self.buffData) do
            if value[5] == false then
                self.dynamicEffectTable[key] = nil
                self.specialEffectTable[key] = nil
                self.removeEffectTable[key] = nil
            elseif self.dynamicEffectTable[key] == nil then
                self.dynamicEffectTable[key] = {value[1], value[2]}

                if value[3] then
                    self.specialEffectTable[key] = {value[1], value[2], true}
                end

                if value[4] then
                    self.removeEffectTable[key] = true
                end
            end
        end
    end

    self.healSkills = {
        ["Encouraging Roar"] = true,
        ["Rejuvenating Bellow"] = true,
        ["Recuperate"] = true,
        ["Hearten"] = true,
        ["Nature's Mend"] = true,
    }

    self.exceptionEffects = {
        ["Expose Weakness - Man Form"] = true,
        ["Expose Weakness - Bear Form"] = true,
    }

    self.mountedGarbage = {
        [1091742735] = true,
        [1091742016] = true,
        [1091787642] = true,
        [1091787641] = true,
    }

    self:Load()
end

function BeorningTools:GetData()
    return self.data
end

function BeorningTools:ChangeData(key, value)
    self.data[key] = value
end


function BeorningTools:GetBuffData()
    return self.buffData
end

function BeorningTools:ChangeBuffData(key, stack, remove, enable)
    self.buffData[key] = {self.buffData[key][1], self.buffData[key][2], stack, remove, enable}
end

function BeorningTools:AddBuffData(key, icon, priority, stack, remove, enable)
    self.buffData[key] = {icon, priority, stack, remove, enable}
end

function BeorningTools:RemoveCallbacks()
    for key, value in pairs(self.effectCallbacks) do
        RemoveCallback(PlayerEffectsHandler, key, value)
    end

    RemoveCallback(self.ClassAttr, "WrathChanged", self.attrCallbacks)

    --player callbacks
    for key, value in pairs(self.playerCallbacks) do
        RemoveCallback(self.player, key, value)
    end

    for key, value in pairs(self.skillCallbacks) do
        for _, callback in pairs(value) do
            RemoveCallback(self.skillsLUT[key], "ResetTimeChanged", callback)
        end
    end

    collectgarbage()

end

function BeorningTools:SetCallbacks()

    self.effectCallbacks["EffectAdded"] = AddCallback(PlayerEffectsHandler, "EffectAdded", 
    function(effect)
        local effectName = effect:GetName()

        --ChatOutput(effectName .. effect:GetIcon())

        if self.formSlots[effectName] then
            self.formSlots[self.currentForm]:ToggleVisible(false)
            self.currentForm = effectName
            self.formSlots[effectName]:ToggleVisible(true)
        end

        if self.dynamicEffectTable[effectName] then 
            if effectName == "Honey Cleanse" then
                if effect:GetIcon() == 1091945026 then
                    self.buffSkillBar:ToggleLabel("Honey Cleanse", true)
                elseif effect:GetIcon() == 1091945041 then
                    self.buffSkillBar:ToggleLabel("Honey Cleanse 2", true)
                else
                    self.buffSkillBar:ToggleLabel("Honey Cleanse 3", true)
                end
            elseif not(self.exceptionEffects[effectName]) then
                self.buffSkillBar:ToggleLabel(effectName, true, effect:GetDuration(), self.dynamicEffectTable[effectName][1] == true and effect:GetIcon())
            elseif self.exceptionEffects[effectName] then
                if effectName == "Expose Weakness - Man Form" or effectName == "Expose Weakness - Bear Form" then
                    self.buffSkillBar:ToggleLabel(effectName, true, effect:GetDuration())
                    if effectName == "Expose Weakness - Man Form" then
                        self.buffSkillBar:ToggleLabel("Expose Weakness - Bear Form", nil)
                    else
                        self.buffSkillBar:ToggleLabel("Expose Weakness - Man Form", nil)
                    end
                end
            end
        end
    end)


    self.effectCallbacks["EffectRemoved"] = AddCallback(PlayerEffectsHandler, "EffectRemoved", 
    function(effect)

        if self.removeEffectTable[effect:GetName()] then
            if effect:GetName() == "Relentless Maul" and not(self.noSkills) then
                if self.skills[effect:GetName()][3] == 1 then
                        self.normalSkillBar:SetLabelTimer(effect:GetName(), 30)
                elseif self.skills[effect:GetName()][3] == 2 then
                        self.specialSkillBar:SetLabelTimer(effect:GetName(), 30)
                end
            elseif effect:GetName() == "Honey Cleanse" then
                                if effect:GetIcon() == 1091945026 then
                    self.buffSkillBar:ToggleLabel("Honey Cleanse", nil)
                elseif effect:GetIcon() == 1091945041 then
                    self.buffSkillBar:ToggleLabel("Honey Cleanse 2", nil)
                else
                    self.buffSkillBar:ToggleLabel("Honey Cleanse 3", nil)
                end
            else
                self.buffSkillBar:ToggleLabel(effect:GetName(), false)
            end
        end

        --[[
        if self.dynamicEffectTable[effect:GetName()] and 
        self.dynamicEffectTable[effect:GetName()][1] == effect:GetIcon() and 
        not(self.exceptionEffects[effectName]) then
            self.buffSkillBar:ToggleLabel(effect:GetName(), false)
        end
        --]]
    end)

    self.attrCallbacks = AddCallback(self.ClassAttr, "WrathChanged", function(sender, args) self.wrathBar:SetCurrentValue( self.ClassAttr:GetWrath() ) end)

    -- skill callbacks
    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()
        --ChatOutput(name .. item:GetSkillInfo():GetIconImageID())

        self.skillCallbacks[name] = {}

        if self.skills[name] and not(string.find(name, "Maul")) and not(self.noSkills) then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.normalSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
            end))
        end

        if name == "Ferocious Roar" and self.ferocious then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                local timer = nil
                if not(self.player:IsInCombat()) then timer = 9 end
                self.buffSkillBar:ToggleLabel("Ferocious Free Heal", true, timer)
            end))
        end

        if name == "Slash" and self.slashBleed then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                if self.currentForm == "Man-form" then
                    self.buffSkillBar:ToggleLabel("Slash Bleed", true, 10)
                end
            end))
        end

        if self.dynamicSkillTable[name] and name ~= "Encouraging Roar" then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.buffSkillBar:ToggleLabel(name, true, self.dynamicSkillTable[name][1])
            end))
        end

        if self.healSkills[name] and self.ferocious then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.buffSkillBar:ToggleLabel("Ferocious Free Heal", nil)
            end))
        end

        if name == "Mark of Grimbeorn" and not(self.skills) then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.markTarget = nil
                self.markBar:SetLabelTimer(name, 5)
            end))
        end

        if name == "Mark of Beorn" and not(self.skills) then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.markBar:SetLabelTimer(name, 5)
            end))
        end
    end

    self.playerCallbacks["InCombatChanged"] = AddCallback(self.player, "InCombatChanged",
    function(sender, args)
        if self.ferocious and not(self.player:IsInCombat()) then
            self.buffSkillBar:ToggleLabel("Ferocious Free Heal", true, 9)
        end
    end)

end

function BeorningTools:SetSkillObjects()

    ChatEventHandler:SubscribeTools(self)
    ChatEventHandler:TogglePlayerCombat(true)

    if not(self.noSkills) then
        self.formSlots["Man-form"] = ClassSkillSlot(self, self.width / 2 - 16, 116, 32, 32, "0x70052366", true)
        self.formSlots["Bear-form"] = ClassSkillSlot(self, self.width / 2 - 16, 116, 32, 32, "0x700422ED", true)
        self.formSlots["Wanderlust"] = ClassSkillSlot(self, self.width / 2 - 16, 116, 32, 32, "0x70051DFF", true)
    end
    
    -- Handle initial state
    for i = 1, self.effectList:GetCount(), 1 do
        local name = self.effectList:Get(i):GetName()

        if self.formSlots[name] then self.formSlots[name]:ToggleVisible(true); self.currentForm = name end
    end 


    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()

        if name == "Mark of Grimbeorn" and not(self.noSkills) then 
            self.blueMark = ClassSkillSlot(self, self.width / 2 - 48, 116, 32, 32, "0x700412EF", false) 
            self.markBar:AddLabel(name, self.blueMark, 1)
        end
        if name == "Mark of Beorn" and not(self.noSkills) then 
            self.redMark = ClassSkillSlot(self, self.width / 2 + 16, 116, 32, 32, "0x700412EB", false) 
            self.markBar:AddLabel(name, self.redMark, 3)
        end


        if self.skills[name] and not(self.mountedGarbage[item:GetSkillInfo():GetIconImageID()]) and not(self.noSkills) then
            self.skillSlots[name] = ClassSkillSlot(self.normalSkillBar, self.width / 2 - 16, 0, 32, 32, self.skills[name][2], false)
            self.normalSkillBar:AddLabel(name, self.skillSlots[name], self.skills[name][1], nil, self.skills[name][3])
            --[[
            if self.skills[name][3] == 1 then
                self.skillCount = self.skillCount + 1
            elseif self.skills[name][3] == 2 then
                self.specialSkillSlots[name] = ClassSkillSlot(self.normalSkillBar, self.width / 2 - 16, 0, 32, 32, self.skills[name][2], false)
                self.normalSkillBar:AddLabel(name, self.specialSkillSlots[name], self.skills[name][1], nil, self.skills[name][3])
                self.specialSkillCount = self.specialSkillCount + 1
            end
            --]]
        end

        if name == "Ferocious Roar" and 1091940918 == item:GetSkillInfo():GetIconImageID() then
            self.buffSkillBar:AddLabel("Ferocious Free Heal", ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, 0x4115B59B, false, false, nil, 1, 1, true, false, true), 2)
        end
    end

    --self.buffSkillBar:AddLabel("Honey Cleanse 1", ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, 1091945026, false, false, nil, 1, 1, true, false, true), 2)
    self.buffSkillBar:AddLabel("Honey Cleanse 2", ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, 1091945041, false, false, nil, 1, 1, true, false, true), 2)
    self.buffSkillBar:AddLabel("Honey Cleanse 3", ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, 1091945033, false, false, nil, 1, 1, true, false, true), 2)

    self.normalSkillBar:SetStaticPositions()

    local markHeight = self.normalSkillBar:MaxHeight() * 32 + 52

    if not(self.noSkills) then
        self.formSlots["Man-form"]:SetTop(markHeight)
        self.formSlots["Bear-form"]:SetTop(markHeight)
        self.formSlots["Wanderlust"]:SetTop(markHeight)
        if self.blueMark then self.blueMark:SetTop(markHeight) end
        if self.redMark then self.redMark:SetTop(markHeight) end
    end


    for key, value in pairs(self.dynamicSkillTable) do
        self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[2], false, false, nil, 1, 1, true, false, true), value[3])
    end

    for key, value in pairs(self.dynamicEffectTable) do
        self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[1], false, false, nil, 1, 1, true, false, true), value[2])
    end

    for key, value in pairs(self.specialEffectTable) do
        local stack = value[3]
        if value [3] == true then
            stack = string.match(key, "%d+")
            if stack == nil then stack = 1 end
        end
        self.buffSkillBar:AddLabel(key, StackingClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[1], false, false, nil, 1, 1, true, false, false, stack), value[2])
    end

    if self.slashBleed then
        self.buffSkillBar:AddLabel("Slash Bleed", ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, 0x4115B5AF, false, false, nil, 1, 1, true, false, true), 2)
    end

    local barWidth = (self.normalSkillBar:MaxWidth() * 32 )
    if barWidth == 0 then barWidth = 500 end

    -- Wrath bar
    self.wrathBar = VitalBar(barWidth - 1, 20, true, Turbine.UI.ContentAlignment.MiddleCenter, 1)
    self.wrathBar:SetParent(self)
    self.wrathBar:SetPosition(1 + (self.width - barWidth) / 2, 32)
    self.wrathBar:SetColours(nil, Turbine.UI.Color(0.6, 0.5, 0, 0), nil, nil)
    self.wrathBar:SetMaxValue(100)
    self.wrathBar:SetCurrentValue(self.ClassAttr:GetWrath())
end

function BeorningTools:ToggleMove()
    self.moveBox:ToggleMove()
end

function BeorningTools:GetOptions(parent, x, y)
    local container = Turbine.UI.Control()
    container:SetParent(parent)
    container:SetPosition(x, y)
    container:SetSize(530 + 4, 100 + 4)
    container:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(container)
    SingleBackground:SetPosition(2, 2)
    SingleBackground:SetSize(530, 100)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EffectBox = Turbine.UI.Lotro.CheckBox()
    EffectBox:SetParent(SingleBackground)
    EffectBox:SetPosition(10, 10)
    EffectBox:SetSize(200,20)
    EffectBox:SetChecked(Settings.ClassToolsBeorningSlash)
    EffectBox:SetText("Bleed on slash timer")
    EffectBox:SetVisible(true)

    EffectBox.CheckedChanged = function()
        Settings.ClassToolsBeorningSlash = EffectBox:IsChecked()
    end

    local EffectBox1 = Turbine.UI.Lotro.CheckBox()
    EffectBox1:SetParent(SingleBackground)
    EffectBox1:SetPosition(10, 30)
    EffectBox1:SetSize(200,20)
    EffectBox1:SetChecked(Settings.ClassToolsBeorningFerocious)
    EffectBox1:SetText("Free heal on ferocious")
    EffectBox1:SetVisible(true)

    EffectBox1.CheckedChanged = function()
        Settings.ClassToolsBeorningFerocious = EffectBox1:IsChecked()
    end

    local EffectBox2 = Turbine.UI.Lotro.CheckBox()
    EffectBox2:SetParent(SingleBackground)
    EffectBox2:SetPosition(10, 50)
    EffectBox2:SetSize(200,20)
    EffectBox2:SetChecked(Settings.ClassToolsNoSkills)
    EffectBox2:SetText("Disable skill bars")
    EffectBox2:SetVisible(true)

    EffectBox2.CheckedChanged = function()
        Settings.ClassToolsNoSkills = EffectBox2:IsChecked()
    end

    
end

function BeorningTools:RemoveSkillObjects()
    self.buffSkillBar:Unload(true)
    self.normalSkillBar:Unload(true)
    self.specialSkillBar:Unload(true)
    self.wrathBar:SetParent(nil)

    ChatEventHandler:SubscribeTools(nil)
    ChatEventHandler:TogglePlayerCombat(nil)

    for _, value in pairs(self.formSlots) do
        value:Unload()
    end

    self.formSlots = {}
    self.skillSlots = {}
    self.specialSkillSlots = {}

    self.skillCount = 0
    self.specialSkillCount = 0

    collectgarbage()
end

function BeorningTools:ParseUpdate(message)
    local source, _, skillName, target = string.match(message,"^(.*) applied a (.*) with (.*) on (.*)%.$")

    if source ~= self.name then return end
    if self.parseSkills[skillName] then
        if skillName == "Mark of Grimbeorn" then
            self.markTarget = target
        end

        if  skillName == "Encouraging Roar" and self.markTarget == target then
            self.buffSkillBar:ToggleLabel("Encouraging Roar", true, 15)
        end

        if skillName == "Slash" and target ~= self.name then
            self.buffSkillBar:ToggleLabel("Slash Bleed", true, 10)
        end
    end    
end

function BeorningTools:LoadData()
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.effectList = self.player:GetEffects()
    self.ClassAttr = self.player:GetClassAttributes()
    self.trainedSkills = self.player:GetTrainedSkills()
end

function BeorningTools:Load()
    self:SetSkillObjects()
    self:SetCallbacks()
end

function BeorningTools:Unload()
    self:RemoveCallbacks()
    self:RemoveSkillObjects()
end

function BeorningTools:Reload()
    self:Unload()
    self:LoadData()
    self:Load()
end
