CaptainTools = class(Turbine.UI.Window)
function CaptainTools:Constructor(data, buffData)
    Turbine.UI.Window.Constructor(self)
    self.width = 500
    self.height = 500
    self:SetPosition(Settings.ClassToolsX, Settings.ClassToolsY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.data = data
    self.buffData = buffData

    -- 0x411172A2 kisses
    -- 0x4115B59E broken armour
    -- 0x4115B58E crit roar
    -- 0x4115B58E knockdown
    -- 0x4115B586 blue buff
    -- 0x4115B59D blue recup
    -- 0x4115B5C1 blue green recup
    -- 0x4115B5BC red bear form icon
    -- 0x4115B5BA bash bleed + 
    -- 0x4115B59B free heal roar
    -- 0x4115B5AF slash bleed
    -- 0x41139EFF Blood rage
    -- 0x4113A06D Yellow break ranks
    -- 0x4115B59F Blue armour crush

    self.moveBox = MoveBox(self, self.width, self.height, "Captain Tools")

    self.buffSkillBar = DynamicSkillBar(self, 0, 0, self.width, 32, 32, 2, true)
    self.normalSkillBar = DynamicSkillBar(self, 0, 63, self.width, 64, 32, 4, false)
    --self.specialSkillBar = DynamicSkillBar(self, 0, 95, self.width, 64, 32, 4, false)
    self.markBar = DynamicSkillBar(self, self.width / 2 - 16 - 32, 116, 96, 64, 32, 4, false)

    self.barBackground = Turbine.UI.Control()
    self.barBackground:SetParent(self)
    --self.barBackground:SetBackColor(Turbine.UI.Color(1,1,1))
    self.barBackground:SetSize(0, 31)
    self.barBackground:SetPosition(0, 26)

    self.defeatEventActive = false

    self.barPosition = 32
    self.baroffset = 0

    self.defeatEventTimer = 0
    self.defeatEventActive = false

    self.offColour = Turbine.UI.Color(1, 0.7, 0, 0)
    self.onColour = Turbine.UI.Color(1, 0, 0.7, 0)

    self:LoadData()

    self.name = self.player:GetName()

    self.noSkills = Settings.ClassToolsNoSkills
    --self.noSkills = true

    self.barTable = {}
    self.barID = {}
    self.skillID = {}

    self.playerCallbacks = {}
    self.effectCallbacks = {}
    self.attrCallbacks = nil

    self.skillCallbacks = {}
    self.skillsLUT = {}

    self.skillCount = 0 
    self.specialSkillCount = 0

    self.formSlots = {}
    
    self.skillSlots = {}
    self.specialSkillSlots = {}

    self.skills = {
        ["Battle-shout"] = {1, "0x70002F67", 1}, -- 
        ["Improved Sure Strike"] = {2, "0x70028DB4", 1}, -- 
        ["Improved Cutting Attack"] = {3, "0x70028FA5", 1},
        ["Grave Wound"] = {4, "0x70028E4B", 1},
        ["Valiant Strike"] = {5, "0x7002F312", 1},
        ["Shadow's Lament"] = {5, "0x7000FF8B", 1},
        ["Inspire (Shield-brother)"] = {6, "0x7000A1D7", 1},
        ["Kick"] = {7, "0x7000AA0E", 1},
        ["Threatening Shout"] = {10, "0x70002FD5", 2},


        ["Gallant Display"] = {7, "0x70036FE2", 1},        
        ["Words of Courage"] = {8, "0x70003E51", 1},

 
        ["Devastating Blow"] = {1, "0x70002FCF", 2},
        ["Pressing Attack"] = {2, "0x70003E50", 2},
        ["Improved Blade of Elendil"] = {4, "0x70017D31", 2},
        ["Cleanse Corruption"] = {5, "0x7003A6A3", 2},
        ["Rallying Cry"] = {6, "0x70002F4F", 2},
        ["Routing Cry"] = {7, "0x70002F61", 2},
        ["Muster Courage"] = {8, "0x70002F99", 2},
        ["Strength in Numbers"] = {9, "0x70036A22", 2},
 
        
        ["Standard of Honour"] = {1, "0x700369B8", 3},
        ["Standard of Valour"] = {1, "0x700369B9", 3},
        ["Standard of War"] = {1, "0x700369B7", 3},
        ["Reform the Lines!"] = {2, "0x70036A39", 3},
        ["To Arms (Shield-brother)"] = {3, "0x7000AA0D", 3},
        ["Song-brother's Call"] = {4, "0x70037C5A", 3},
        ["Shield-brother's Call"] = {4, "0x70037C34", 3},
        ["Blade-brother's Call"] = {4, "0x70037C54", 3},
        ["Elendil's Roar"] = {11, "0x70029037", 3},
        ["Make Haste"] = {5, "0x70003E4E", 3},
        ["Time of Need"] = {5, "0x7000AA12", 3},
        ["Escape from Darkness"] = {6, "0x70002F45", 3},
        ["Fighting Withdrawal"] = {7, "0x7001F4C9", 3},
        ["Last Stand"] = {8, "0x70003E54", 3},
        ["Shield of the Dúnedain"] = {9, "0x700012F9", 3},
        ["In Harm's Way"] = {10, "0x70003E58", 3},
        ["Oathbreaker's Shame"] = {10, "0x70001306", 3},
 
        ["Telling Mark"] = {10, "0x70003E4D", 4},
        ["Noble Mark"] = {11, "0x70003E4F", 4},
        ["Revealing Mark"] = {12, "0x70003E56", 4},
        ["Improved Motivating Speech"] = {1, "0x700385EE", 4},
        ["Watchful Shield-brother"] = {20, "0x70020DF6", 4},

    }

    self.petskills = {
        ["Lend Courage"] = {Settings.ClassToolsCaptainPetX, "0x00000011", Settings.ClassToolsCaptainPetY},
    }

    if not(Settings.ClassToolsCaptainPetSkill) then self.petskills = {} end

    if self.data == nil then
        self.data = {}
        for key, value in pairs(self.skills) do
            self.data[key] = {true, value[1], value[3]}
        end
    else
        for key, value in pairs(self.data) do
            --ChatOutput(value[1])
            if value[1] == false then
                self.skills[key] = nil
            else
                self.skills[key] = {value[2], self.skills[key][2], value[3]}
            end
        end
    end

    self.dynamicSkillTable = {
    }

    self.parseSkills = {

    }

    self.dynamicEffectTable = {
        ["Battle-readied"] = {1090541076, 1},
        ["Battle-hardened"] = {1091232037, 2},
        ["Focus"] = {1090553787, 3},
        ["Rousing Cry Damage Buff"] = {1091831455, 4},
        ["Penetrating Cry Attack Speed Buff"] = {1091830273, 5},
        ["Inspiriting Presence"] = {1091840414, 6},
        ["In Harm's Way"] = {1090553786, 7},
        ["Shield of the Dúnedain"] = {1090533153, 8},
        ["Last Stand"] = {1090533270, 9},
        ["Master of War"] = {1091831459, 10},
        ["Enemy Defeat Response"] = {1090541069, 11},
        ["Cutting Edge"] = {1090553775, 12},
        ["To Arms (Shield-brother)"] = {1091659765, 13},
        ["To Arms (Blade-brother)"] = {1091037682, 13},
        ["To Arms (Fellowship Shield-brother)"] = {1091659766, 13},
        ["Blade-brother's Call"] = {1091840431, 14},
        ["Shield-brother's Call"] = {1091831458, 14},
        ["Song-brother's Call"] = {1091831453, 14},
        ["Relentless Attack"] = {1090553783, 15},
        ["On Guard"] = {1090553781, 15},
        ["Valour - Tier 1"] = {1091916299, 16, 1},
        ["Valour - Tier 2"] = {1091916299, 16, 2},
        ["Valour - Tier 3"] = {1091916299, 16, 3},
        ["Valour - Tier 4"] = {1091916299, 16, 4},
        ["Valour"] = {1091916299, 16, 5},
        ["Gallant Display Tier 1"] = {1091829784, 17},
        ["Gallant Display Tier 2"] = {1091829784, 17},
        ["Gallant Display Tier 3"] = {1091829784, 17},
        ["Elendil's Fortune"] = {true, 18},
    }

    self.superSpecialEffectTable = {
        ["Selflessness"] = true,
        ["Motivated"] = true,
        ["Enemy Defeat Response"] = true,
    }
    

    self.specialEffectTable = {
        ["Valour - Tier 1"] = {1091916299, 16, 1},
        ["Valour - Tier 2"] = {1091916299, 16, 2},
        ["Valour - Tier 3"] = {1091916299, 16, 3},
        ["Valour - Tier 4"] = {1091916299, 16, 4},
        ["Valour"] = {1091916299, 16, 5},
        ["Gallant Display Tier 1"] = {1091829784, 17, 1},
        ["Gallant Display Tier 2"] = {1091829784, 17, 2},
        ["Gallant Display Tier 3"] = {1091829784, 17, 3},
    }

    self.removeEffectTable = {
        ["Enemy Defeat Response"] = true,
        ["Master of War"] = true,
        ["Valour - Tier 1"] = true,
        ["Valour - Tier 2"] = true,
        ["Valour - Tier 3"] = true,
        ["Valour - Tier 4"] = true,
        ["Valour"] = true,
        ["Selflessness"] = true,
        ["Motivated"] = true,
        ["Battle-readied"] = true,
        ["Battle-hardened"] = true,
        ["Gallant Display Tier 1"] = true,
        ["Gallant Display Tier 2"] = true,
        ["Gallant Display Tier 3"] = true,
        ["Elendil's Fortune"] = true,
    }

    if self.buffData == nil or tablelength(self.buffData) < 1  then
        self.buffData = {}
        for key, value in pairs(self.dynamicEffectTable) do
            self.buffData[key] = {value[1], value[2], self.specialEffectTable[key] ~= nil, self.removeEffectTable[key] ~= nil, true}
        end
    else
        for key, value in pairs(self.buffData) do
            if value[5] == false then
                self.dynamicEffectTable[key] = nil
                self.specialEffectTable[key] = nil
                self.removeEffectTable[key] = nil
            elseif self.dynamicEffectTable[key] == nil then
                self.dynamicEffectTable[key] = {value[1], value[2]}

                if value[3] then
                    self.specialEffectTable[key] = {value[1], value[2], true}
                end

                if value[4] then
                    self.removeEffectTable[key] = true
                end
            end
        end
    end

    self.mountedGarbage = {
    }

    self.highlightSkills = {
        ["Rallying Cry"] = true,
        ["Routing Cry"] = true,
        ["Valiant Strike"] = true,
    }

    self.highlightEffects = {
        ["Enemy Defeat Response"] = {
            ["Rallying Cry"] = true,
            ["Routing Cry"] = true,
        },
        ["Valour"] = {
            ["Valiant Strike"] = true,
        },
    }

    
    self.SlotTimerSkills = {
        --["Improved Sure Strike"] = true,
        --["Devastating Blow"] = true,
        --["Pressing Attack"] = true,
    }

    self.SlotTimerEffects = {
    }

    self.ExecuteUpdate = function(delta)
        self.defeatEventTimer = self.defeatEventTimer - delta
    
        if self.defeatEventTimer < 0 then
            self:DisableDefeatEvent()
        end
    end

    self:Load()
end

function CaptainTools:GetData()
    return self.data
end

function CaptainTools:ChangeData(key, value)
    self.data[key] = value
end

function CaptainTools:GetBuffData()
    return self.buffData
end

function CaptainTools:ChangeBuffData(key, stack, remove, enable)
    self.buffData[key] = {self.buffData[key][1], self.buffData[key][2], stack, remove, enable}
end

function CaptainTools:AddBuffData(key, icon, priority, stack, remove, enable)
    self.buffData[key] = {icon, priority, stack, remove, enable}
end

function CaptainTools:RemoveCallbacks()
    for key, value in pairs(self.effectCallbacks) do
        RemoveCallback(PlayerEffectsHandler, key, value)
    end

    --player callbacks
    for key, value in pairs(self.playerCallbacks) do
        RemoveCallback(self.player, key, value)
    end

    for key, value in pairs(self.skillCallbacks) do
        for _, callback in pairs(value) do
            RemoveCallback(self.skillsLUT[key], "ResetTimeChanged", callback)
        end
    end

    collectgarbage()

end

function CaptainTools:SetCallbacks()

    self.effectCallbacks["EffectRemoved"] = AddCallback(PlayerEffectsHandler, "EffectRemoved", 
    function(effect)
        if effect then 
            local effectName = effect:GetName()
            if effectName == "Enemy Defeat Response" then return end
            if self.removeEffectTable[effectName] then
                if self.skillID[effectName] == effect:GetID() then
                    self.buffSkillBar:ToggleLabel(effectName, false)
                end
            end

            if self.highlightEffects[effectName] then
                for key, value in pairs(self.highlightEffects[effectName]) do
                    if self.skillSlots[key] then 
                        self.skillSlots[key]:ToggleHighlight(false)
                    end
                end
            end

            if self.barTable[effectName] and effect:GetID() == self.barID[effectName] then
                --ChatOutput(Turbine.Engine.GetGameTime() - effect:GetStartTime())
                self.barTable[effectName]:SetCurrentValue(0)
            end
        end
        --[[
        if self.dynamicEffectTable[effectName] and 
        self.dynamicEffectTable[effectName][1] == effect:GetIcon() and 
        not(self.exceptionEffects[effectName]) then
            self.buffSkillBar:ToggleLabel(effectName, false)
        end
        --]]
    end)

    self.effectCallbacks["EffectAdded"] = AddCallback(PlayerEffectsHandler, "EffectAdded", 
    function(effect)
        local effectName = effect:GetName()

        if self.superSpecialEffectTable[effectName] then
            if effectName == "Selflessness" then 
                self.normalSkillBar:SetLabelTimer("Lend Courage", 90)
            end
        end

        if self.highlightEffects[effectName] then
            for key, value in pairs(self.highlightEffects[effectName]) do
                if self.skillSlots[key] then
                    self.skillSlots[key]:ToggleHighlight(true)
                end
            end
        end

        if self.dynamicEffectTable[effectName] then 

            self.buffSkillBar:ToggleLabel(effectName, true, effect:GetDuration(), self.dynamicEffectTable[effectName][1] == true and effect:GetIcon())
            self.skillID[effectName] = effect:GetID()
        end

        if effectName == "Enemy Defeat Response" then
            self:ActivateDefeatEvent()
        end

        if self.SlotTimerEffects[effectName] and not(self.noSkills) then
            if self.SlotTimers[self.SlotTimerEffects[effectName]] then
                self.SlotTimers[self.SlotTimerEffects[effectName]]:SetValue(effect:GetDuration())
            end
        end

        if self.barTable[effectName] then
            self.barTable[effectName]:SetCurrentValue(effect:GetDuration())
            self.barID[effectName] = effect:GetID()
        end

    end)

    -- skill callbacks
    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()
        --ChatOutput(name .. item:GetSkillInfo():GetIconImageID())

        self.skillCallbacks[name] = {}

        if self.skills[name] and not(self.noSkills) then
            self.skillsLUT[name] = item
            if name == "Rallying Cry" or name == "Routing Cry" then
                table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                    if self.defeatEventActive then
                        self:DisableDefeatEvent()
                    end
                    self.normalSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
                end))
            else
                table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                    self.normalSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
                end))
            end
        end
    end

    self.playerCallbacks["InCombatChanged"] = AddCallback(self.player, "InCombatChanged",
    function(sender, args)

    end)
    self.playerCallbacks["PetChanged"] = AddCallback(self.player, "PetChanged",
    function(sender, args)
        self:UpdatePet()
    end)
    

end

function CaptainTools:UpdatePet()
    if self.player:GetPet() then
        self.petBar1:ToggleBar(true)
    else
        self.petBar1:ToggleBar(false)
    end
end

function CaptainTools:SetSkillObjects()

    ChatEventHandler:SubscribeTools(self)
    ChatEventHandler:TogglePlayerCombat(true)
    
    -- Handle initial state
    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()

        if self.skills[name] and not(self.mountedGarbage[item:GetSkillInfo():GetIconImageID()]) and not(self.noSkills) then
            self.skillSlots[name] = ClassSkillSlot(self.normalSkillBar, self.width / 2 - 16, 0, 32, 32, self.skills[name][2], false, false, self.highlightSkills[name])
            self.normalSkillBar:AddLabel(name, self.skillSlots[name], self.skills[name][1], nil, self.skills[name][3])
            if self.SlotTimerSkills[name] then
                self.SlotTimers[name] = SkillSlotTimer(self.skillSlots[name])
            end
        end
    end

    for key, value in pairs(self.petskills) do
        self.skillSlots[key] = ClassSkillSlot(self.normalSkillBar, self.width / 2 - 16, 0, 32, 32, value[2], false, true)
        self.normalSkillBar:AddLabel(key, self.skillSlots[key], value[1], nil, value[3])
    end


    self.normalSkillBar:SetStaticPositions()

    for key, value in pairs(self.dynamicSkillTable) do
        self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[2], false, false, nil, 1, 1, true, false, true), value[3])
    end

    for key, value in pairs(self.dynamicEffectTable) do
        self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[1], false, false, nil, 1, 1, true, false, true), value[2])
    end

    for key, value in pairs(self.specialEffectTable) do
        local stack = value[3]
        if value [3] == true then
            stack = string.match(key, "%d+")
            if stack == nil then stack = 1 end
        end
        self.buffSkillBar:AddLabel(key, StackingClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[1], false, false, nil, 1, 1, true, false, false, stack), value[2])
    end



    local barWidth = (self.normalSkillBar:MaxWidth() * 32 )
    if barWidth == 0 then barWidth = 500 end

    self.barBackground:SetWidth(barWidth + 4)
    self.barBackground:SetPosition((self.width - barWidth) / 2 - 2, 20)

    self.motivationBar1 = ValueBar(self, 7, 31, 1 + (self.width - barWidth) / 2, self.barPosition, 2, self.onColour, self.offColour, 300, "bar3v", true, true)
    self.barID["Motivated"] = 0
    self.barTable["Motivated"] = self.motivationBar1

    --self.barID["motivationBar1"] = 0
    --self.motivationBar1:ToggleBar(true)

    self.defeatEvent1 = ValueBar(self, 7, 9, 1 + (self.width - barWidth) / 2 + (barWidth - 2)/3, self.barPosition + 7, 2, self.onColour, self.offColour, 15, "bar3v", true)
    self.barID["defeatEvent1"] = 0
    --self.:ToggleBar(true)

    self.petBar1 = ValueBar(self, 7, 31, 1 + (self.width + barWidth) / 2 - 10, self.barPosition, nil, self.onColour, self.offColour, 15, "bar3v")
    self.barID["petBar1"] = 0

    self.defeatEvent2 = ValueBar(self, 7, 9, 1 + (self.width - barWidth) / 2 + (barWidth - 2)/3 * 2 - 6, self.barPosition + 7, 2, self.onColour, self.offColour, 15, "bar3v", true)
    self.barID["defeatEvent2"] = 0
    --self.motivationBar:ToggleBar(true)

    self.hardenedBar = ValueBar(self, barWidth - 2 - 14, 15, 1 + (self.width - barWidth) / 2 + 7, self.barPosition + 16, nil, Turbine.UI.Color(0.4, 0.75, 0.75, 0.75), Turbine.UI.Color(0.6, 0,0,0), 15, "bar11")
    self.barTable["Battle-hardened"] = self.hardenedBar
    self.barID["Battle-hardened"] = 0
    --self.hardenedBar:SetCurrentValue(15)

    self.readyBar = ValueBar(self, barWidth - 2 - 14, 7, 1 + (self.width - barWidth) / 2 + 7, self.barPosition, nil, Turbine.UI.Color(255, 153, 0), Turbine.UI.Color(0.6, 0,0,0), 15, "bar25")
    self.barTable["Battle-readied"] = self.readyBar
    self.barID["Battle-readied"] = 0
    --self.readyBar:SetCurrentValue(15)

    self.rallyBar = ValueBar(self, (barWidth - 2)/3 - 7, 9, 1 + (self.width - barWidth) / 2 + 7, self.barPosition + 7, 2, Turbine.UI.Color(1, 0.1, 0.6, 0), Turbine.UI.Color(0.8, 0,0,0), 60, "bar6", false, true)
    self.barTable["Rousing Cry Damage Buff"] = self.rallyBar
    self.barID["Rousing Cry Damage Buff"] = 0
    --self.rallyBar:SetCurrentValue(60)

    self.stanceBuffBar = ValueBar(self, (barWidth - 2)/3 + 2 - 14, 9, 1 + (self.width - barWidth) / 2 + (barWidth - 2)/3 + 7, self.barPosition + 7, 1, Turbine.UI.Color(0.9, 0, 75/255, 105/255), Turbine.UI.Color(0.9, 0,0,0), 45, "bar7", false, true)
    if Roles:GetLine() == 1 then
        self.barTable["Focus"] = self.stanceBuffBar
        self.barID["Focus"] = 0
    elseif Roles:GetLine() == 2 then
        self.barTable["Relentless Attack"] = self.stanceBuffBar
        self.barID["Relentless Attack"] = 0
    elseif Roles:GetLine() == 3 then
        self.barTable["On Guard"] = self.stanceBuffBar
        self.barID["On Guard"] = 0
    end
    --self.stanceBuffBar:SetCurrentValue(45)


    self.routingBar = ValueBar(self, (barWidth - 2)/3 - 7, 9, 2 + (self.width - barWidth) / 2 + (barWidth - 2)/3 + (barWidth - 2)/3, self.barPosition + 7, nil, Turbine.UI.Color(1, 0.7, 0, 0), Turbine.UI.Color(0.8, 0,0,0), 60, "bar6r", false, true)
    self.barTable["Penetrating Cry Attack Speed Buff"] = self.routingBar
    self.barID["Penetrating Cry Attack Speed Buff"] = 0
    --self.routingBar:SetCurrentValue(60)

    for i = 1, self.effectList:GetCount(), 1 do
        local effect = self.effectList:Get(i) 
        local effectName = effect:GetName()
        if self.barTable[effectName] then
            self.barTable[effectName]:SetCurrentValue(Turbine.Engine.GetGameTime() - effect:GetStartTime())
            self.barID[effectName] = effect:GetID()
        end
        
        if effectName == "Motivated" then
            self.motivationBar1:SetCurrentValue(effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime()))
            self.barID["motivationBar1"] = effect:GetID()
        end
    end
 
    self:UpdatePet()
end

function CaptainTools:DisableDefeatEvent()
    self.defeatEvent1:ToggleBar(false)
    self.defeatEvent2:ToggleBar(false)

    for key, value in pairs(self.highlightEffects["Enemy Defeat Response"]) do
        if self.skillSlots[key] then 
            self.skillSlots[key]:ToggleHighlight(false)
        end
    end

    self.buffSkillBar:ToggleLabel("Enemy Defeat Response", false)

    self.defeatEventActive = false
    if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
    self.updateCallback = nil
end

function CaptainTools:ActivateDefeatEvent()
    self.defeatEvent1:SetCurrentValue(15)
    self.defeatEvent2:SetCurrentValue(15)
    if not(self.noSkills) then
        if self.skillSlots["Rallying Cry"] then self.skillSlots["Rallying Cry"]:ToggleHighlight(true) end
        if self.skillSlots["Routing Cry"] then self.skillSlots["Routing Cry"]:ToggleHighlight(true) end
    end

    self.defeatEventActive = true
    self.defeatEventTimer = 15
    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
end

function CaptainTools:ToggleMove()
    self.moveBox:ToggleMove()
end

function CaptainTools:GetOptions(parent, x, y)
    local container = Turbine.UI.Control()
    container:SetParent(parent)
    container:SetPosition(x, y)
    container:SetSize(530 + 4, 100 + 4)
    container:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(container)
    SingleBackground:SetPosition(2, 2)
    SingleBackground:SetSize(530, 100)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EffectBox2 = Turbine.UI.Lotro.CheckBox()
    EffectBox2:SetParent(SingleBackground)
    EffectBox2:SetPosition(10, 50)
    EffectBox2:SetSize(200,20)
    EffectBox2:SetChecked(Settings.ClassToolsNoSkills)
    EffectBox2:SetText("Disable skill bars")
    EffectBox2:SetVisible(true)

    EffectBox2.CheckedChanged = function()
        Settings.ClassToolsNoSkills = EffectBox2:IsChecked()
    end

    local ScaleLabel = Turbine.UI.Label()
    ScaleLabel:SetParent(SingleBackground)
    ScaleLabel:SetSize(300, 30)
    ScaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    ScaleLabel:SetPosition(10, 10)
    ScaleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    ScaleLabel:SetText("Lend Courage: X-axis priority / Y bar") 

    local BarScaleBar = Turbine.UI.Lotro.TextBox()
    BarScaleBar:SetParent(SingleBackground)
    BarScaleBar:SetSize(50, 30)
    BarScaleBar:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BarScaleBar:SetPosition(280, 5)
    BarScaleBar:SetText(Settings.ClassToolsGuardianBreakRankXPrio)

    local BarScaleBar1 = Turbine.UI.Lotro.TextBox()
    BarScaleBar1:SetParent(SingleBackground)
    BarScaleBar1:SetSize(50, 30)
    BarScaleBar1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BarScaleBar1:SetPosition(340, 5)
    BarScaleBar1:SetText(Settings.ClassToolsGuardianBreakRankYBar)

    local Button2 = Turbine.UI.Lotro.Button()
    Button2:SetParent(SingleBackground)
    Button2:SetSize(80, 20)
    Button2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    Button2:SetMouseVisible(true)
    Button2:SetPosition(400, 10)
    Button2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    Button2:SetText("Save")

    Button2.Click = function()
        Settings.ClassToolsCaptainPetX = tonumber(BarScaleBar:GetText())
        Settings.ClassToolsCaptainPetY = tonumber(BarScaleBar1:GetText())
    end

    local EffectBox1 = Turbine.UI.Lotro.CheckBox()
    EffectBox1:SetParent(SingleBackground)
    EffectBox1:SetPosition(10, 30)
    EffectBox1:SetSize(200,20)
    EffectBox1:SetChecked(Settings.ClassToolsCaptainPetSkill)
    EffectBox1:SetText("Lend Courage skill box")
    EffectBox1:SetVisible(true)

    EffectBox1.CheckedChanged = function()
        Settings.ClassToolsCaptainPetSkill = EffectBox1:IsChecked()
    end
    
end

function CaptainTools:RemoveSkillObjects()
    self.buffSkillBar:Unload(true)
    self.normalSkillBar:Unload(true)
    --self.specialSkillBar:Unload()

    for key, value in pairs(self.barTable) do
        value:Unload()
        self.barTable[key] = nil
    end
    --[[
    self.readyBar:Unload()
    self.hardenedBar:Unload()
    self.stanceBuffBar:Unload()
    self.rallyBar:Unload()
    self.routingBar:Unload()
    --]]

    self.motivationBar1:Unload()
    self.defeatEvent1:Unload()
    self.petBar1:Unload()
    self.defeatEvent2:Unload()

    self.barTable = {}
    self.barID = {}

    self.skillID = {}

    ChatEventHandler:SubscribeTools(nil)
    ChatEventHandler:TogglePlayerCombat(nil)

    for _, value in pairs(self.formSlots) do
        value:Unload()
    end

    self.formSlots = {}
    self.skillSlots = {}
    self.specialSkillSlots = {}

    self.skillCount = 0
    self.specialSkillCount = 0

    collectgarbage()
end

function CaptainTools:ParseUpdate(message)
    
 
end

function CaptainTools:LoadData()
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.effectList = self.player:GetEffects()
    self.ClassAttr = self.player:GetClassAttributes()
    self.trainedSkills = self.player:GetTrainedSkills()
end

function CaptainTools:Load()
    self:SetSkillObjects()
    self:SetCallbacks()
end

function CaptainTools:Unload()
    self:RemoveCallbacks()
    self:RemoveSkillObjects()
end

function CaptainTools:Reload()
    self:Unload()
    self:LoadData()
    self:Load()
end
