ClassToolHandler = class(Turbine.UI.Control)
function ClassToolHandler:Constructor()
    Turbine.UI.Control.Constructor(self)
    if not(Settings.ClassToolsEnabled) then return end

    self.tool = nil
    self.result = true
    self.loadErrors = false

    self.playerClass = Turbine.Gameplay.LocalPlayer.GetInstance():GetClass()

    self.classSkillSettings = LoadTable(Turbine.DataScope.Account, "PrimeClassTools")
    self.classBuffSettings = LoadTable(Turbine.DataScope.Account, "PrimeClassToolsBuffs")

    if self.classSkillSettings == nil then self.classSkillSettings = {} end

    if self.classBuffSettings == nil then self.classBuffSettings = {} end

    if self.playerClass == Turbine.Gameplay.Class.Beorning then

        import "PrimePlugins.RaidTools.ClassSpecificTools.BeorningTool"
        self.result, self.tool = pcall(BeorningTools, self.classSkillSettings[self.playerClass], self.classBuffSettings[self.playerClass])

    elseif self.playerClass == Turbine.Gameplay.Class.Brawler then

    elseif self.playerClass == Turbine.Gameplay.Class.Burglar then 

    elseif self.playerClass == Turbine.Gameplay.Class.Champion then

    elseif self.playerClass == Turbine.Gameplay.Class.Captain then

        import "PrimePlugins.RaidTools.ClassSpecificTools.CaptainTool"
        self.result, self.tool = pcall(CaptainTools, self.classSkillSettings[self.playerClass], self.classBuffSettings[self.playerClass])

    --elseif self.playerClass == Turbine.Gameplay.Class.Corsair then

    elseif self.playerClass == Turbine.Gameplay.Class.Guardian then

        if Roles:GetLine() == 1 then 
            import "PrimePlugins.RaidTools.ClassSpecificTools.GuardianTool"
            self.result, self.tool = pcall(GuardianTools, self.classSkillSettings[self.playerClass], self.classBuffSettings[self.playerClass])
        end

    elseif self.playerClass == Turbine.Gameplay.Class.Hunter then

        import "PrimePlugins.RaidTools.ClassSpecificTools.HunterTool"
        self.result, self.tool = pcall(HunterTools, self.classSkillSettings[self.playerClass], self.classBuffSettings[self.playerClass])
        
    elseif self.playerClass == Turbine.Gameplay.Class.LoreMaster then

    elseif self.playerClass == Turbine.Gameplay.Class.Minstrel then

        import "PrimePlugins.RaidTools.ClassSpecificTools.MinstrelTool"
        self.result, self.tool = pcall(MinstrelTools, self.classSkillSettings[self.playerClass], self.classBuffSettings[self.playerClass])

    elseif self.playerClass == Turbine.Gameplay.Class.RuneKeeper then

    elseif self.playerClass == Turbine.Gameplay.Class.Warden then

        import "PrimePlugins.RaidTools.ClassSpecificTools.WardenTool"
        self.result, self.tool = pcall(WardenTools, self.classSkillSettings[self.playerClass], self.classBuffSettings[self.playerClass])
    end

    if not(self.result) then
        ChatOutput("<rgb=#FF0000>Errors detected while loading class tools and might not work properly!")
        ChatOutput("<rgb=#FF0000>We have turned off the class tools automatically, please report this bug!")
        Settings.ClassToolsEnabled = false
        self.loadErrors = true
    end

    self.Update = function()
        if Turbine.Engine.GetGameTime() > self.reloadTime then
            self:ReloadTool()
            self:SetWantsUpdates(false)
        end
    end
end

function ClassToolHandler:CheckForTools()
    if self.tool then return self.tool else return false end
end

function ClassToolHandler:Unload()

    if self.tool and not(self.loadErrors) then
        self.tool:RemoveCallbacks()
        Settings.ClassToolsX, Settings.ClassToolsY = self.tool:GetPosition()
        self.classSkillSettings[self.playerClass] = self.tool:GetData()
        self.classBuffSettings[self.playerClass] = self.tool:GetBuffData()
        SaveTable(Turbine.DataScope.Account, "PrimeClassTools", self.classSkillSettings)
        SaveTable(Turbine.DataScope.Account, "PrimeClassToolsBuffs", self.classBuffSettings)
    end
    
end

function ClassToolHandler:CheckClass()
    if self.playerClass == Turbine.Gameplay.Class.Beorning then

        return true

    elseif self.playerClass == Turbine.Gameplay.Class.Brawler then

    elseif self.playerClass == Turbine.Gameplay.Class.Burglar then 

    elseif self.playerClass == Turbine.Gameplay.Class.Champion then

    elseif self.playerClass == Turbine.Gameplay.Class.Captain then

        return true

    --elseif self.playerClass == Turbine.Gameplay.Class.Corsair then

    elseif self.playerClass == Turbine.Gameplay.Class.Guardian then

        if Roles:GetLine() == 1 then return true else return false end

    elseif self.playerClass == Turbine.Gameplay.Class.Hunter then

        return true
        
    elseif self.playerClass == Turbine.Gameplay.Class.LoreMaster then

    elseif self.playerClass == Turbine.Gameplay.Class.Minstrel then

        return true

    elseif self.playerClass == Turbine.Gameplay.Class.RuneKeeper then

    elseif self.playerClass == Turbine.Gameplay.Class.Warden then
        
        return true

    end

    return false
end

function ClassToolHandler:ReloadTool()
    if self.tool then
        if self:CheckClass() then
            self.tool:Reload()
        else
            self.tool:Unload()
        end
    end
end

function ClassToolHandler:ReloadToolWithDelay()
    self.reloadTime = Turbine.Engine.GetGameTime() + 5
    self:SetWantsUpdates(true)
end

function ClassToolHandler:ToggleMove()
    if self.tool then self.tool:ToggleMove() end
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------