
ClassToolsOptions = class(Turbine.UI.Control)
function ClassToolsOptions:Constructor(parent)
    local width = 750
    local height = 500
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10 - 2, 10 - 2)
    SingleBackground:SetSize(730 + 4, 450 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10, 10)
    SingleBackground:SetSize(730, 450)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EffectBox = Turbine.UI.Lotro.CheckBox()
    EffectBox:SetParent(SingleBackground)
    EffectBox:SetPosition(10, 10)
    EffectBox:SetSize(200,20)
    EffectBox:SetChecked(Settings.ClassToolsEnabled)
    EffectBox:SetText("Class Tools Enabled")
    EffectBox:SetVisible(true)

    EffectBox.CheckedChanged = function()
        Settings.ClassToolsEnabled = EffectBox:IsChecked()
        MasterOptions:ChangesMade()
    end

    self.moveButton = Turbine.UI.Lotro.Button()
    self.moveButton:SetParent(SingleBackground)
    self.moveButton:SetText("Move")
    self.moveButton:SetPosition(210, 10)
    self.moveButton.Click = function()
        ClassTools:ToggleMove()
    end

    local BaseWidthLabel = Turbine.UI.Label()
    BaseWidthLabel:SetParent(SingleBackground)
    BaseWidthLabel:SetSize(400, 40)
    BaseWidthLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    BaseWidthLabel:SetPosition(270, 10)
    BaseWidthLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    BaseWidthLabel:SetText("Base width of tools (When skills disabled)") 

    local BaseWidthBar = Turbine.UI.Lotro.TextBox()
    BaseWidthBar:SetParent(SingleBackground)
    BaseWidthBar:SetSize(50, 30)
    BaseWidthBar:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BaseWidthBar:SetPosition(590, 5)
    BaseWidthBar:SetText(Settings.ClassToolsBaseWidth)

    local BaseWidthButton = Turbine.UI.Lotro.Button()
    BaseWidthButton:SetParent(SingleBackground)
    BaseWidthButton:SetSize(80, 20)
    BaseWidthButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BaseWidthButton:SetMouseVisible(true)
    BaseWidthButton:SetPosition(640, 10)
    BaseWidthButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    BaseWidthButton:SetText("Change")

    BaseWidthButton.Click = function()
        if tonumber(BaseWidthBar:GetText()) then
            Settings.ClassToolsBaseWidth = tonumber(BaseWidthBar:GetText())
        end
    end

    self.skillContainer = Turbine.UI.Control()
    self.skillContainer:SetParent(SingleBackground)
    self.skillContainer:SetSize(730, 430)
    self.skillContainer:SetPosition(0, 40)

    local container = Turbine.UI.ListBox()
    container:SetParent(self.skillContainer)
    container:SetSize(700, 240)
    container:SetPosition(10, 30)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)
    --container:SetBackColor(GetRandomColour())

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( self.skillContainer )
    containerScrollbar:SetPosition( 780 - 10, 10 )
    containerScrollbar:SetSize( 10, 400 )
    container:SetVerticalScrollBar( containerScrollbar )

    self.buffControl = Turbine.UI.Control()
    self.buffControl:SetParent(SingleBackground)
    self.buffControl:SetSize(730, 430)
    self.buffControl:SetPosition(0, 40)
    self.buffControl:SetVisible(false)

    self.buffContainer = Turbine.UI.ListBox()
    self.buffContainer:SetParent(self.buffControl)
    self.buffContainer:SetSize(700, 160)
    self.buffContainer:SetPosition(10, 30)
    --self.buffContainer:SetBackColor(GoldColor)
    self.buffContainer:SetVisible(true)
    self.buffContainer:SetWantsKeyEvents(true)
    self.buffContainer:SetMouseVisible(true)
    --self.buffContainer:SetBackColor(GetRandomColour())

    self.buffContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.buffContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    self.buffContainerScrollbar:SetParent( self.skillContainer )
    self.buffContainerScrollbar:SetPosition( 780 - 10, 10 )
    self.buffContainerScrollbar:SetSize( 10, 400 )
    self.buffContainer:SetVerticalScrollBar( self.buffContainerScrollbar )

    self.skillButton = Turbine.UI.Label()
    self.skillButton:SetParent(SingleBackground)
    self.skillButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.skillButton:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    self.skillButton:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.skillButton:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.skillButton:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.skillButton:SetText("Skills")
    self.skillButton:SetPosition(10, 50)
    self.skillButton:SetSize(250, 20)
    self.skillButton:SetMouseVisible(true)
    self.skillButton:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.buffButton = Turbine.UI.Label()
    self.buffButton:SetParent(SingleBackground)
    self.buffButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.buffButton:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    self.buffButton:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.buffButton:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.buffButton:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.buffButton:SetText("Buffs")
    self.buffButton:SetPosition(260, 50)
    self.buffButton:SetSize(250, 20)
    self.buffButton:SetMouseVisible(true)
    self.buffButton:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    self.buffButton.MouseClick = function()
        self.skillButton:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
        self.buffButton:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
        self.buffControl:SetVisible(true)
        self.skillContainer:SetVisible(false)
    end
    
    self.skillButton.MouseClick = function()
        self.buffButton:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
        self.skillButton:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
        self.buffControl:SetVisible(false)
        self.skillContainer:SetVisible(true)
        if self.IconWindow then self.IconWindow:SetVisible(false) end
    end


    self.tool = ClassTools:CheckForTools()
    if not(self.tool) then return end

    for key, value in spairs(self.tool:GetData(), 
    function(t,a,b) 
        if t[a][3] < t[b][3] then
            return true
        elseif t[a][3] > t[b][3] then
            return false
        elseif t[a][3] == t[b][3] then
            return t[a][2] < t[b][2] 
        end
    end) do container:AddItem(self:createSkillBar(key, value[1], value[2], value[3])) end

    local buffData = self.tool:GetBuffData()
    for key, value in spairs(buffData,
    function(t,a,b)
        if a < b then return true end
    end) do self.buffContainer:AddItem(self:createBuffBar(key, buffData[key])) end

    if self.tool then self.specificOptions = self.tool:GetOptions(self, 110, 350) end

    local addLabel = Turbine.UI.Label()
    addLabel:SetParent(self.buffControl)
    addLabel:SetSize(210, 20)
    addLabel:SetPosition(10, 190)
    addLabel:SetMouseVisible(false)
    --addLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    addLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    addLabel:SetMultiline(true)
    addLabel:SetText("Add buff:")

    self.iconLabel = self:createBuffAddition(self.buffControl)
    self.IconWindow = self:iconOverview(self, self.iconLabel)
end


function ClassToolsOptions:createSkillBar(name, load, x, y)
    local pluginBar = Turbine.UI.Control()
    pluginBar:SetSize(800, 40)
    pluginBar:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local backgroundBar = Turbine.UI.Control()
    backgroundBar:SetSize(800, 38)
    backgroundBar:SetPosition(0, 1)
    backgroundBar:SetParent(pluginBar)
    backgroundBar:SetMouseVisible(false)
    backgroundBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    --pluginBar:SetBackColor(GetRandomColour())

    local nameLabel = Turbine.UI.Label()
    nameLabel:SetParent(pluginBar)
    nameLabel:SetSize(200, 20)
    nameLabel:SetPosition(0, 10)
    nameLabel:SetMouseVisible(false)
    nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    nameLabel:SetMultiline(false)
    nameLabel:SetText(name)

    local EffectBox = Turbine.UI.Lotro.CheckBox()
    EffectBox:SetParent(pluginBar)
    EffectBox:SetPosition(160, 10)
    EffectBox:SetSize(120,20)
    EffectBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    EffectBox:SetChecked(load)
    EffectBox:SetText("Load")
    EffectBox:SetVisible(true)

    local ScaleLabel = Turbine.UI.Label()
    ScaleLabel:SetParent(pluginBar)
    ScaleLabel:SetSize(200, 30)
    ScaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    ScaleLabel:SetPosition(230, 10)
    ScaleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    ScaleLabel:SetText("X-axis priority") 

    local BarScaleBar = Turbine.UI.Lotro.TextBox()
    BarScaleBar:SetParent(pluginBar)
    BarScaleBar:SetSize(50, 30)
    BarScaleBar:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BarScaleBar:SetPosition(340, 5)
    BarScaleBar:SetText(x)

    local ScaleLabel = Turbine.UI.Label()
    ScaleLabel:SetParent(pluginBar)
    ScaleLabel:SetSize(200, 30)
    ScaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    ScaleLabel:SetPosition(400, 10)
    ScaleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    ScaleLabel:SetText("Y-axis") 

    local BarScaleBar2 = Turbine.UI.Lotro.TextBox()
    BarScaleBar2:SetParent(pluginBar)
    BarScaleBar2:SetSize(50, 30)
    BarScaleBar2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BarScaleBar2:SetPosition(450, 5)
    BarScaleBar2:SetText(y)

    local Button2 = Turbine.UI.Lotro.Button()
    Button2:SetParent(pluginBar)
    Button2:SetSize(80, 20)
    Button2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    Button2:SetMouseVisible(true)
    Button2:SetPosition(620, 5)
    Button2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    Button2:SetText("Save")

    Button2.Click = function()
        self.tool:ChangeData(name, {EffectBox:IsChecked(), tonumber(BarScaleBar:GetText()), tonumber(BarScaleBar2:GetText())})
    end

    local RemoveButton = Turbine.UI.Lotro.Button()
    RemoveButton:SetParent(pluginBar)
    RemoveButton:SetSize(80, 20)
    RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    RemoveButton:SetMouseVisible(true)
    RemoveButton:SetPosition(620, 30)
    RemoveButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    RemoveButton:SetText("Remove")

    RemoveButton.Click = function()
        self.tool:ChangeData(name, nil)
        pluginBar:SetVisible(false)
    end

    return pluginBar
end

function ClassToolsOptions:createBuffBar(name, buffItem)
    local pluginBar = Turbine.UI.Control()
    pluginBar:SetSize(800, 40)
    pluginBar:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local backgroundBar = Turbine.UI.Control()
    backgroundBar:SetSize(800, 38)
    backgroundBar:SetPosition(0, 1)
    backgroundBar:SetParent(pluginBar)
    backgroundBar:SetMouseVisible(false)
    backgroundBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    --pluginBar:SetBackColor(GetRandomColour())

    local nameLabel = Turbine.UI.Label()
    nameLabel:SetParent(pluginBar)
    nameLabel:SetSize(210, 38)
    nameLabel:SetPosition(0, 10)
    nameLabel:SetMouseVisible(false)
    nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    nameLabel:SetMultiline(true)
    nameLabel:SetText(name)

    local LoadBox = Turbine.UI.Lotro.CheckBox()
    LoadBox:SetParent(pluginBar)
    LoadBox:SetPosition(210, 10)
    LoadBox:SetSize(120,20)
    LoadBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    LoadBox:SetChecked(buffItem[5])
    LoadBox:SetText("Load")
    LoadBox:SetMultiline(false)
    LoadBox:SetVisible(true)

    local StackBox = Turbine.UI.Lotro.CheckBox()
    StackBox:SetParent(pluginBar)
    StackBox:SetSize(200, 20)
    StackBox:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    StackBox:SetPosition(280, 10)
    StackBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    StackBox:SetChecked(buffItem[3])
    StackBox:SetMultiline(false)
    StackBox:SetText("Show stack count") 

    local RemoveBox = Turbine.UI.Lotro.CheckBox()
    RemoveBox:SetParent(pluginBar)
    RemoveBox:SetPosition(450, 10)
    RemoveBox:SetSize(200, 20)
    RemoveBox:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    RemoveBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    RemoveBox:SetChecked(buffItem[4])
    RemoveBox:SetMultiline(false)
    RemoveBox:SetText("Check if removed") 

    local Button2 = Turbine.UI.Lotro.Button()
    Button2:SetParent(pluginBar)
    Button2:SetSize(80, 20)
    Button2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    Button2:SetMouseVisible(true)
    Button2:SetPosition(620, 10)
    Button2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    Button2:SetText("Update")

    Button2.Click = function()
        self.tool:ChangeBuffData(name, StackBox:IsChecked(), RemoveBox:IsChecked(), LoadBox:IsChecked())
    end

    return pluginBar
end


function ClassToolsOptions:createBuffAddition(parent)
    local outLine = Turbine.UI.Control()
    outLine:SetPosition(10, 210)
    outLine:SetParent(parent)
    outLine:SetSize(710, 70)
    outLine:SetBackColor(Turbine.UI.Color(1, 1, 1))

    local background = Turbine.UI.Control()
    background:SetParent(outLine)
    background:SetPosition(1 ,1)
    background:SetSize(710 - 2, 70 - 2)
    background:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local backgroundBar = Turbine.UI.Control()
    backgroundBar:SetSize(710 - 4, 70 - 4)
    backgroundBar:SetPosition(1, 1)
    backgroundBar:SetParent(background)
    backgroundBar:SetMouseVisible(false)
    backgroundBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    --pluginBar:SetBackColor(GetRandomColour())

    local nameLabel = Turbine.UI.Lotro.TextBox()
    nameLabel:SetParent(backgroundBar)
    nameLabel:SetSize(210, 20)
    nameLabel:SetPosition(10, 10)
    nameLabel:SetMouseVisible(false)
    --nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    nameLabel:SetMultiline(true)
    nameLabel:SetText("<Effect name>")

    -- [[
    local IconBox = Turbine.UI.Control()
    IconBox:SetParent(backgroundBar)
    IconBox:SetPosition(230, 5)
    IconBox:SetSize(32,32)
    IconBox:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    IconBox:SetBackground(0x41007F41)
    IconBox:SetVisible(true)

    IconBox.MouseClick = function()
        if self.IconWindow then self.IconWindow:SetVisible(true) end
    end

    IconBox.MouseDoubleClick = function()
        IconBox:SetBackground(0x41007F41)
        self.iconID = 0x41007F41
    end

    local addLabel = Turbine.UI.Label()
    addLabel:SetParent(backgroundBar)
    addLabel:SetSize(410, 30)
    addLabel:SetPosition(10, 40)
    addLabel:SetMouseVisible(false)
    --addLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    --addLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    addLabel:SetMultiline(true)
    addLabel:SetText("*If no icon is selected the in-game icon will be taken when the effect is applied. (Double click to clear)")
    --]]

    local priotiyBox = Turbine.UI.Lotro.TextBox()
    priotiyBox:SetParent(backgroundBar)
    priotiyBox:SetSize(150, 20)
    priotiyBox:SetPosition(420, 40)
    priotiyBox:SetMouseVisible(false)
    --nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    priotiyBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    priotiyBox:SetMultiline(true)
    priotiyBox:SetText("<Priority> (1,2,..n)")

    local StackBox = Turbine.UI.Lotro.CheckBox()
    StackBox:SetParent(backgroundBar)
    StackBox:SetSize(200, 20)
    StackBox:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    StackBox:SetPosition(280, 10)
    StackBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    --StackBox:SetChecked(buffItem[3])
    StackBox:SetMultiline(false)
    StackBox:SetText("Show stack count") 

    local RemoveBox = Turbine.UI.Lotro.CheckBox()
    RemoveBox:SetParent(backgroundBar)
    RemoveBox:SetPosition(450, 10)
    RemoveBox:SetSize(200, 20)
    RemoveBox:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    RemoveBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    --RemoveBox:SetChecked(buffItem[4])
    RemoveBox:SetMultiline(false)
    RemoveBox:SetText("Check if removed") 

    local Button2 = Turbine.UI.Lotro.Button()
    Button2:SetParent(backgroundBar)
    Button2:SetSize(80, 20)
    Button2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    Button2:SetMouseVisible(true)
    Button2:SetPosition(620, 10)
    Button2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    Button2:SetText("Add")

    Button2.Click = function()

        local name = nameLabel:GetText()

        if name == nil then
            ChatOutput("No Name specified")
            return
        end

        local priority = tonumber(priotiyBox:GetText())

        if priority == nil then
            ChatOutput("No Priority specified")
            return
        end

        local icon = self.iconID

        if icon == 0x41007F41 then
            icon = nil
        end

        self.tool:AddBuffData(name, icon, priority, StackBox:IsChecked(), RemoveBox:IsChecked(), true)
        ChatOutput("Buff added with effect trigger: " .. name .. " Priority: " .. priority .. " Icon ID: " .. tostring(icon) .. " Check for stacks: " .. BoolToString(StackBox:IsChecked()) .. " Check for removal: " .. BoolToString(RemoveBox:IsChecked()))
        MasterOptions:ChangesMade()
    end

    return IconBox
end

function ClassToolsOptions:iconOverview(parent, iconLabel)

    local iconWindow = Turbine.UI.Window()
    iconWindow:SetParent(parent)
    iconWindow:SetSize(200, 200)
    iconWindow:SetPosition(300, 215)
    iconWindow:SetVisible(false)
    iconWindow:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local headerLabel = Turbine.UI.Label()
    headerLabel:SetParent(iconWindow)
    headerLabel:SetSize(200 - 2, 20 - 1)
    headerLabel:SetPosition(1, 1)
    headerLabel:SetMouseVisible(false)
    --headerLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    headerLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    headerLabel:SetMultiline(true)
    headerLabel:SetText("Icon selection")

    -- Close Button
    local CloseBackground = Turbine.UI.Control()
    CloseBackground:SetParent(iconWindow)
    CloseBackground:SetPosition(200 - 20, 0)
    CloseBackground:SetSize(20, 20)
    CloseBackground:SetMouseVisible(true)
    CloseBackground:SetBackColor(Turbine.UI.Color(153/255, 0, 0))


    CloseBackground.MouseClick = function()
        iconWindow:SetVisible(false)
    end

    local iconBox = Turbine.UI.ListBox()
    iconBox:SetSize(200 - 2, 180 - 2)
    iconBox:SetPosition(1, 21)
    iconBox:SetParent(iconWindow)
    iconBox:SetMouseVisible(false)
    iconBox:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    iconBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
    iconBox:SetMaxColumns(6)

    local iconBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    iconBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    iconBoxScrollbar:SetParent(iconWindow)
    iconBoxScrollbar:SetPosition(192, 21)
    iconBoxScrollbar:SetSize(8, 178)
    iconBox:SetVerticalScrollBar(iconBoxScrollbar)

    if DataGrabberTool then
        local duplicates = {}
        for key, value in spairs(DataGrabberTool:GetIcons(), function(t,a,b) return tostring(a) > tostring(b) end) do
            if duplicates[value] then
            else
                local icon = Turbine.UI.Control()
                icon:SetSize(32,32)
                icon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                icon:SetBackground(value)
                icon:SetMouseVisible(true)

                icon.MouseClick = function()
                    iconLabel:SetBackground(value)
                    self.iconID = value
                    iconWindow:SetVisible(false)

                end

                iconBox:AddItem(icon)
                duplicates[value] = true


            end
        end

        duplicates = nil
    end

    return iconWindow
end