FortificationIndicator = class(Turbine.UI.Window)
function FortificationIndicator:Constructor(parent, x, y, base, normal, visible)
    Turbine.UI.Window.Constructor(self)

    self.base = base
    self.normal = normal

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.normal, self.normal)
    self:SetStretchMode(1)
    self:SetVisible(visible)
    self:SetMouseVisible(false)
    --self:SetBackColor(GetRandomColour())

    self.background = Turbine.UI.Label()
    self.background:SetParent(self)
    self.background:SetSize(self.normal, self.normal)
    self.background:SetBackground("PrimePlugins/RaidTools/Images/FireShield2.tga")
    self.background:SetMouseVisible(false)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(self.normal, self.normal)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetForeColor(Turbine.UI.Color(0.2,0.2,0.2))
    self.textLabel:SetText("0")
    self.textLabel:SetMouseVisible(false)
end

function FortificationIndicator:ChangeStacks(number)
    self.textLabel:SetText(number)
end

function FortificationIndicator:ToggleVisible(value)
    self:SetVisible(value)
    self.IconLabel:SetVisible(value)
end

function FortificationIndicator:Unload()
    self.background:SetParent(nil)
    self.textLabel:SetParent(nil)
    self:SetParent(nil)
    self = nil
end
