HighlightFrame = class(Turbine.UI.Window)
function HighlightFrame:Constructor(parent, offset, scale, biggerHighlight)
    Turbine.UI.Window.Constructor(self)
    self:SetPosition(offset, offset)
    --self:SetSize(self.width, self.height)
    --self:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self:SetVisible(false)
    self:SetMouseVisible(false)
    --self:SetBackground(IconAlerts) --0x41000912 ice --0x411AE441 blood --0x41142E03  0x4114B070
    --self:SetStretchMode(1)
    self:SetSize(42, 41)
    self:SetOpacity(1)
    self:SetParent(parent)

    self.scale = scale
    self.biggerHighlight = biggerHighlight
    self.bighHighlightSizeScaling = 2.5
    self.bighHighlightDuration = 0.3

    self.backgroundViewBox = Turbine.UI.Window()
    self.backgroundViewBox:SetParent(self)
    self.backgroundViewBox:SetSize(42, 41)
    self.backgroundViewBox:SetSize(65, 65)
    --self.backgroundViewBox:SetPosition(100 - 10 + 7, 100 - 10 + 7)
    self.backgroundViewBox:SetPosition(- 10, - 10 )
    self.backgroundViewBox:SetVisible(true)
    self.backgroundViewBox:SetMouseVisible(false)

    self.backgroundBox = Turbine.UI.Control()
    self.backgroundBox:SetParent(self.backgroundViewBox)
    self.backgroundBox:SetSize(42, 41)
    --self.backgroundBox:SetSize(256 - 22, 256 - 22)
    self.backgroundBox:SetSize(256 - 22, 256 - 22)
    self.backgroundBox:SetPosition(-12 + 10, -81 + 10)
    self.backgroundBox:SetBlendMode(Turbine.UI.BlendMode.Normal)
    self.backgroundBox:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/IconAlert.tga"))
    self.backgroundBox:SetMouseVisible(false)

    self.viewBox = Turbine.UI.Control()
    self.viewBox:SetParent(self)
    self.viewBox:SetSize(42, 41)
    --self.viewBox:SetSize(256 - 22, 256 - 22)
    --self.viewBox:SetPosition(100, 100)
    self.viewBox:SetPosition(1, 1)
    self.viewBox:SetMouseVisible(false)
    --self.viewBox:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1))

    self.movingTexture = Turbine.UI.Control()
    self.movingTexture:SetParent(self.viewBox)
    self.movingTexture:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/IconAlertAnts.tga"))
    self.movingTexture:SetBlendMode(Turbine.UI.BlendMode.Normal)
    self.movingTexture:SetSize(256 - 20, 256 - 22)
    self.movingTexture:SetPosition(-2, -2)
    self.movingTexture:SetVisible(true)
    self.movingTexture:SetMouseVisible(false)

    --self:SetStretchMode(1)
    self.viewBox:SetStretchMode(1)
    --self.viewBox:SetSize(32, 32)
    self.viewBox:SetSize(30, 30)
    --self.viewBox:SetSize(46, 46)
    self.backgroundViewBox:SetStretchMode(1)
    self.backgroundViewBox:SetSize(54, 54)
    --self.backgroundViewBox:SetSize(40, 40)


    if self.biggerHighlight then
        self.outsideHighlightFrame = Turbine.UI.Window()
        self.outsideHighlightFrame:SetParent(self)
        self.outsideHighlightFrame:SetVisible(true)
        self.outsideHighlightFrame:SetSize(62, 62)
        self.outsideHighlightFrame:SetPosition((self:GetWidth() - self.outsideHighlightFrame:GetWidth()) / 2 -5, (self:GetHeight() - self.outsideHighlightFrame:GetHeight()) / 2 -5)
        self.outsideHighlightFrame:SetStretchMode(1)
        self.outsideHighlightFrame:SetSize(62 * 2, 62 * 2)
        self.outsideHighlightFrame:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/HighlightFrame.tga"))
        self.outsideHighlightFrame:SetMouseVisible(false)
    end


    self.lastUpdate = Turbine.Engine.GetGameTime()
    self.tick = 0
    self.bigHighlightDuration = 0
    self.bigHighlight = 0
    self.Update = function()
        local gameTime = Turbine.Engine.GetGameTime()
        if gameTime - self.lastUpdate < 0.02 then return end
        if self.maxTime then
            if self.timer < gameTime then 
                self:Toggle(false) 
            end
        end
        if self.biggerHighlight  then
            if gameTime < self.bigHighlight then
                self.outsideHighlightFrame:SetVisible(true)
                self.outsideHighlightFrame:SetSize(62, 62)
                self.outsideHighlightFrame:SetStretchMode(1)

                local newValue = ((((self.bigHighlight - gameTime) / self.bigHighlightDuration) * (self.bighHighlightSizeScaling - 1)) + 1) * 62

                self.outsideHighlightFrame:SetSize(newValue, newValue)
                self.outsideHighlightFrame:SetPosition((self:GetWidth() - newValue) / 2 -5, (self:GetHeight() - newValue) / 2 -5)
            else
                self.outsideHighlightFrame:SetVisible(false)
            end
        end
        self.lastUpdate = gameTime
        self.tick = (self.tick + 1) % 23
        self.movingTexture:SetPosition(-(self.tick % 5) * 48 - 2, -(math.floor(self.tick / 5)) * 48 -2)
    end
end

function HighlightFrame:Toggle(value, timer)
    if value then
        self:SetZOrder(100)
    else
        self:SetZOrder(1)
    end
    self:SetWantsUpdates(value)
    self:SetVisible(value)
    if timer then
        self.maxTime = true
        self.timer = Turbine.Engine.GetGameTime() + timer
        if self.biggerHighlight  then
            self.bigHighlightDuration = math.min(self.bighHighlightDuration, timer)
            self.bigHighlight = Turbine.Engine.GetGameTime() + self.bigHighlightDuration
        end
    else
        self.maxTime = false
    end
end


HighlightFrame2 = class(Turbine.UI.Window)
function HighlightFrame2:Constructor(parent, scale)
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetSize(32, 32)
    self:SetOpacity(1)
    self:SetParent(parent)

    self.background = 0x41007F0E

    self.box = Turbine.UI.Control()
    self.box:SetParent(self)
    self.box:SetSize(32, 32)
    self.box:SetBlendMode(Turbine.UI.BlendMode.Normal)
    self.box:SetBackground(BackgroundHandler:GetBackground(self.background))
    self.box:SetMouseVisible(false)
    self.box:SetVisible(true)

    self.scale = scale

    if not(self.scale) then self.scale = 1 end

    self:SetStretchMode(1)
    self:SetSize(32 * self.scale, 32 * self.scale)

    self.lastUpdate = Turbine.Engine.GetGameTime()

    self.Update = function()
        if Turbine.Engine.GetGameTime() - self.lastUpdate < 0.03 then return end

        self.box:SetBackground(BackgroundHandler:GetBackground(self.background))

        self.background = self.background + 1

        if self.background > 0x41007F0E + 7 then self.background = 0x41007F0E end

        self.lastUpdate = Turbine.Engine.GetGameTime()
    end
end

function HighlightFrame2:Toggle(value)
    self:SetWantsUpdates(value)
    self:SetVisible(value)
end

HighlightFrame3 = class(Turbine.UI.Window)
function HighlightFrame3:Constructor(parent, x, y, width, height, colour, highlightWidth)
    Turbine.UI.Window.Constructor(self)

    self.width = width
    self.height = height
    self:SetParent(parent)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetSize(self.width, self.height)
    self:SetOpacity(1)
    self:SetPosition(x, y)
    --self:SetBackColor(GetRandomColour())
    self:SetWantsUpdates(false)

    self.antWidth = highlightWidth or 2
    self.width = self.width - self.antWidth
    self.height = self.height - self.antWidth
    self.backgroundColour = Turbine.UI.Color(0,0,0)
    

    local boundaryColour = colour or Turbine.UI.Color(1, 1, 1)

    self.bottomBar = Turbine.UI.Control()
    self.bottomBar:SetParent(self)
    self.bottomBar:SetPosition(self.antWidth, self.height)
    self.bottomBar:SetSize(self.width, self.antWidth)
    self.bottomBar:SetBackColor(boundaryColour)

    self.topBar = Turbine.UI.Control()
    self.topBar:SetParent(self)
    self.topBar:SetPosition(0, 0)
    self.topBar:SetSize(self.width, self.antWidth)
    self.topBar:SetBackColor(boundaryColour)

    self.leftBar = Turbine.UI.Control()
    self.leftBar:SetParent(self)
    self.leftBar:SetPosition(0, self.antWidth)
    self.leftBar:SetSize(self.antWidth, self.height)
    self.leftBar:SetBackColor(boundaryColour)

    self.rightBar = Turbine.UI.Control()
    self.rightBar:SetParent(self)
    self.rightBar:SetPosition(self.width, 0)
    self.rightBar:SetSize(self.antWidth, self.height)
    self.rightBar:SetBackColor(boundaryColour)

    self.bottomAnt = {}
    self.topAnt = {}
    self.leftAnt = {}
    self.rightAnt = {}

    local blendMode = Turbine.UI.BlendMode.Normal

    for i = 0, 2 do
        self.bottomAnt[i] = Turbine.UI.Control()
        self.bottomAnt[i]:SetParent(self)
        self.bottomAnt[i]:SetPosition((i * 2) * (self.width / 4), self.height)
        self.bottomAnt[i]:SetSize(self.width/4, self.antWidth)
        self.bottomAnt[i]:SetBackColorBlendMode(blendMode)
        self.bottomAnt[i]:SetBackColor(self.backgroundColour)

        self.topAnt[i] = Turbine.UI.Control()
        self.topAnt[i]:SetParent(self)
        self.topAnt[i]:SetPosition((i * 2) * (self.width / 4), 0)
        self.topAnt[i]:SetSize(self.width/4, self.antWidth)
        self.topAnt[i]:SetBackColorBlendMode(blendMode)
        self.topAnt[i]:SetBackColor(self.backgroundColour)

        self.leftAnt[i] = Turbine.UI.Control()
        self.leftAnt[i]:SetParent(self)
        self.leftAnt[i]:SetPosition(0, (i * 2) * (self.height / 4))
        self.leftAnt[i]:SetSize(self.antWidth, self.height/4)
        self.leftAnt[i]:SetBackColorBlendMode(blendMode)
        self.leftAnt[i]:SetBackColor(self.backgroundColour)

        self.rightAnt[i] = Turbine.UI.Control()
        self.rightAnt[i]:SetParent(self)
        self.rightAnt[i]:SetPosition(self.width, (i * 2) * (self.height / 4))
        self.rightAnt[i]:SetSize(self.antWidth, self.height/4)
        self.rightAnt[i]:SetBackColorBlendMode(blendMode)
        self.rightAnt[i]:SetBackColor(self.backgroundColour)
    end

    self.stepCounter = 0
    self.stepWdith = self.width/4/30
    self.stepHeight = self.height/4/30
    self.stepCount = 60
    self.lastUpdate = Turbine.Engine.GetGameTime()

    self.Update = function()
        local gameTime = Turbine.Engine.GetGameTime()
        if gameTime - self.lastUpdate < 0.006 then
            return
        end
        if self.maxTime and self.timer < gameTime then
            self:Toggle(false)
            return
        end
        self:SetStretchMode(nil)
        local stepIncreaseX = self.stepWdith * self.stepCounter
        local stepIncreaseY = self.stepHeight * self.stepCounter
        local halfWidth = self.width / 2
        local halfHeight = self.height / 2
        for i = 0, 2 do
            self.topAnt[i]:SetPosition((i * 2) * (self.width / 4) + stepIncreaseX - halfWidth, 0)
            self.rightAnt[i]:SetPosition(self.width, (i * 2) * (self.height / 4) + stepIncreaseY - halfHeight)
    
            self.leftAnt[i]:SetPosition(0, -(self.height / 4) + (i * 2) * (self.height / 4) - stepIncreaseY + halfHeight)
            self.bottomAnt[i]:SetPosition(-(self.width / 4) + ((i * 2) * (self.width / 4) - stepIncreaseX + halfWidth), self.height)
        end
        self.stepCounter = self.stepCounter + 1
        if self.stepCounter > self.stepCount then
            self.stepCounter = 0
        end
        self:SetStretchMode(1)
        self.lastUpdate = gameTime
    end
end

function HighlightFrame3:Toggle(value, timer)
    self:SetVisible(value)
    self:SetZOrder(100)
    self:SetWantsUpdates(value)
    self.lastUpdate = Turbine.Engine.GetGameTime()
    if timer then
        self.maxTime = true
        self.timer = Turbine.Engine.GetGameTime() + timer
    else
        self.maxTime = false
    end
end

function HighlightFrame3:ToggleHighlight(value)
    self:SetVisible(value)
    if value then
        self:SetZOrder(100)
    else
        self:SetZOrder(1)
    end
    self:SetWantsUpdates(value)
    self.lastUpdate = Turbine.Engine.GetGameTime()
end