MinstrelTools = class(Turbine.UI.Window)
function MinstrelTools:Constructor(data, buffData)
    Turbine.UI.Window.Constructor(self)
    self.width = 500
    self.height = 500
    self:SetPosition(Settings.ClassToolsX, Settings.ClassToolsY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.data = data
    self.buffData = buffData

    -- 0x411172A2 kisses
    -- 0x4115B59E broken armour
    -- 0x4115B58E crit roar
    -- 0x4115B58E knockdown
    -- 0x4115B586 blue buff
    -- 0x4115B59D blue recup
    -- 0x4115B5C1 blue green recup
    -- 0x4115B5BC red bear form icon
    -- 0x4115B5BA bash bleed + 
    -- 0x4115B59B free heal roar
    -- 0x4115B5AF slash bleed
    -- 0x41139EFF Blood rage
    -- 0x4113A06D Yellow break ranks
    -- 0x4115B59F Blue armour crush

    self.moveBox = MoveBox(self, self.width, self.height, "Minstrel Tools")

    self.balladBars = BalladBarControl(self, 39, self.width)

    self.buffSkillBar = DynamicSkillBar(self, 0, 0, self.width, 32, 32, 2, true)
    self.normalSkillBar = DynamicSkillBar(self, 0, 52, self.width, 64, 32, 4, false)
    --self.specialSkillBar = DynamicSkillBar(self, 0, 84, self.width, 64, 32, 4, false)

    self:LoadData()

    self.AnthemBars = {}
    self.AnthemLabels = {}
    self.AnthermTimers = {}
    self.AnthemIDs = {}
    self.SlotTimers = {}

    self.AnthemLabelsEnabled = Settings.ClassToolsMinstrelAnthemLabels
    self.AnthermTimersEnabled = Settings.ClassToolsMinstrelAnthemTimers

    self.name = self.player:GetName()

    self.noSkills = Settings.ClassToolsNoSkills

    self.barTable = {}
    self.barID = {}

    self.playerCallbacks = {}
    self.effectCallbacks = {}
    self.attrCallbacks = nil

    self.skillCallbacks = {}
    self.skillsLUT = {}

    self.skillCount = 0 
    self.specialSkillCount = 0

    self.formSlots = {}
    
    self.skillSlots = {}
    self.specialSkillSlots = {}

    self.skills = {

		["Bolster Courage"] = {1, "0x70003E85", 1},
    	["Raise the Spirit"] = {2, "0x70003E7B", 1},
    	["Chord of Salvation"] = {3, "0x7000BC01", 1},
		["Soliloquy of Spirit"] = {4, "0x7000F1F4", 1},
		["Inspire Fellows"] = {5, "0x70003E81", 1},
        
        ["Triumphant Spirit"] = {6, "0x70003E8C", 1},
		
		["Fellowship's Heart"] = {9, "0x70006CEB", 1},
        ["Gift of the Hammerhand"] = {10, "0x7000B69E", 1},

        ["Call of the Second Age"] = {2, "0x7000B69B", 2},
        
        ["Call of Orom\195\171"] = {12, "0x7000B69A", 2},
        
        ["Call to Fate"] = {4, "0x7000F250", 2},

        ["Minor Ballad"] = {4, "0x700031A8", 2},
        ["Perfect Ballad"] = {6, "0x70003E7E", 2},
    	["Major Ballad"] = {5, "0x70003E7C", 2},
        
        
        
        ["Coda of Melody"] = {7, "0x700293C5", 2},
        ["Cry of the Chorus (Melody)"] = {8, "0x700031B2", 1},
        ["Cry of the Valar"] = {1, "0x70003184", 2},
        ["Cry of the Wizards"] = {1, "0x70001270", 2},

        ["Enlivening Grace"] = {1, "0x700031AD", 2},
        
        ["Hero's Strike"] = {1, "0x70036AF2", 2},
        
        
        ["Legend of Helm Hammerhand"] = {12, "0x70036AA5", 1},

        ["Perfect Ending"] = {13, "0x7003A682", 1},
        ["Piercing Cry"] = {1, "0x70003E7D", 2},
        
        ["Rally!"] = {1, "0x70001251", 3},
        ["Story of Courage"] = {2, "0x70003E8B", 3},
        
        ["Call to Greatness"] = {4, "0x7000B69C", 3},
        ["Improved Cry of the Chorus (Melody)"] = {11, "0x7000F260", 3},
        ["Song of the Hammerhand"] = {12, "0x70020DF9", 3},
        ["Call to Ioreth"] = {10, "0x70037D62", 3},

        ["Anthem of Composure"] = {5, "0x70003E80", 3},
        ["Anthem of Prowess"] = {8, "0x70003E7F", 3},
        ["Anthem of War"] = {7, "0x7000317F", 3},
        ["Anthem of the Third Age - Resonance"] = {9, "0x700264BA", 3},
        ["Anthem of the Third Age - Melody"] = {9, "0x700294CF", 3},
        ["Anthem of the Third Age - Dissonance"] = {9, "0x700264BA", 3},

        ["Resonance - Stance"] = {1, "0x700293C8", 4},
        ["Dissonance - Stance"] = {3, "0x7000B699", 4},
        ["Melody - Stance"] = {2, "0x700330CF", 4},
        ["The Melody of Battle"] = {4, "0x7000B697", 4}

    }

    self.SlotTimerSkills = {
        ["Inspire Fellows"] = true,
        ["Call to Greatness"] = true,
        ["Call of the Second Age"] = true,
        ["Improved Cry of the Chorus (Melody)"] = true,

        ["Anthem of Composure"] = true,
        ["Anthem of Prowess"] = true,
        ["Anthem of War"] = true,
        ["Anthem of the Third Age - Resonance"] = true,
        ["Anthem of the Third Age - Melody"] = true,
        ["Anthem of the Third Age - Dissonance"] = true,

        ["Fellowship's Heart"] = true,
        ["Piercing Cry"] = true,
    }

    self.SlotTimerEffects = {
        ["Inspire Fellows Buff"] = "Inspire Fellows",
        ["Call to Minstrels"] = "Call to Greatness",
        ["The Call of the Second Age"] = "Call of the Second Age",
        ["Cry of the Chorus"] = "Improved Cry of the Chorus (Melody)",

        ["Anthem of Composure"] = "Anthem of Composure",
        ["Anthem of Prowess"] = "Anthem of Prowess",
        ["Anthem of War"] = "Anthem of War",
        ["Anthem of the Third Age - Resonance"] = "Anthem of the Third Age - Resonance",
        ["Anthem of the Third Age - Melody"] = "Anthem of the Third Age - Melody",
        ["Anthem of the Third Age - Dissonance"] = "Anthem of the Third Age - Dissonance",

        ["Fellowship's Heart"] = "Fellowship's Heart",
        ["Piercing Cry"] = "Piercing Cry",
    }

    self.Anthems = {
        ["Anthem of Composure"] = {Turbine.UI.Color(1, 0, 0.4, 0), "Composure"},
        ["Anthem of Prowess"] = {Turbine.UI.Color(1, 0, 0.7, 0.3), "Prowess"},
        ["Anthem of War"] = {Turbine.UI.Color(1, 255, 153, 0), "War"},
        ["Anthem of the Third Age - Resonance"] = {Turbine.UI.Color(1, 0, 0.6, 0), "3rd Age - Resonance"},
        ["Anthem of the Third Age - Melody"] = {Turbine.UI.Color(1, 0, 0.3, 0.7), "3rd Age - Resonance"},
        ["Anthem of the Third Age - Dissonance"] = {Turbine.UI.Color(1, 0.6, 0, 0), "3rd Age - Resonance"},
    }
		

    if self.data == nil then
        self.data = {}
        for key, value in pairs(self.skills) do
            self.data[key] = {true, value[1], value[3]}
        end
    else
        for key, value in pairs(self.data) do
            --ChatOutput(value[1])
            if value[1] == false then
                self.skills[key] = nil
            else
                self.skills[key] = {value[2], self.skills[key][2], value[3]}
            end
        end
    end
--Emboldening Finish - Tier 21090519170
    self.dynamicSkillTable = {
        ["Call of Orom\195\171"] = {10, 0x41142A02, 2},
    }

    self.parseSkills = {

    }

    self.dynamicEffectTable = {
        ["Reduce Induction Times"] = {0x41142A1F, 1},
        ["Call to Ioreth"] = {1091830252, 2},
        ["Emboldening Finish - Tier 1"] = {0x41140207, 3},
        ["Emboldening Finish - Tier 2"] = {0x41140207, 3}, 
        ["Emboldening Finish - Tier 3"] = {0x41140207, 3},
        ["Emboldening Finish - Tier 4"] = {0x41140207, 3},
        ["Emboldening Finish - Tier 5"] = {0x41140207, 3},

        ["Inspiring Finish - Tier 1"] = {1091840545, 3},
        ["Inspiring Finish - Tier 2"] = {1091840545, 3}, 
        ["Inspiring Finish - Tier 3"] = {1091840545, 3},
        ["Inspiring Finish - Tier 4"] = {1091840545, 3},
        ["Inspiring Finish - Tier 5"] = {1091840545, 3},

        ["Change of Pace - Attack!"] = {1091830255, 10},
        
        ["Cry of the Chorus"] = {1090541249, 4},
        ["Cry of the Chorus Induction Buff"] = {1091611540, 5},
        ["Fellowship Coda - Resonance"] = {0x411401FA, 6},
        ["Fellowship Coda - Melody"] = {0x41108D07, 6},
        ["Fellowship Coda - Dissonance"] = {0x41116CA4, 6},

        ["Call to Minstrels"] = {1091400696, 7},

        ["The Show Must Go On"] = {1090553792, 8},

        ["Perfect Performance - Minor Ballad"] = {1090541245, 9},
        ["Perfect Performance - Minor Ballad Tier 2"] = {1090541245, 9},
        ["Perfect Performance - Minor Ballad Tier 3"] = {1090541245, 9},

        ["Perfect Performance - Major Ballad"] = {1090553794, 10, 1},
        ["Perfect Performance - Major Ballad Tier 2"] = {1090553794, 10, 2},
        ["Perfect Performance - Major Ballad Tier 3"] = {1090553794, 10, 3},
    }    

    self.specialEffectTable = {
        ["Emboldening Finish - Tier 1"] = {0x41140207, 3, 1},
        ["Emboldening Finish - Tier 2"] = {0x41140207, 3, 2}, 
        ["Emboldening Finish - Tier 3"] = {0x41140207, 3, 3},
        ["Emboldening Finish - Tier 4"] = {0x41140207, 3, 4},
        ["Emboldening Finish - Tier 5"] = {0x41140207, 3, 5},

        ["Inspiring Finish - Tier 1"] = {1091840545, 3, 1},
        ["Inspiring Finish - Tier 2"] = {1091840545, 3, 2}, 
        ["Inspiring Finish - Tier 3"] = {1091840545, 3, 3},
        ["Inspiring Finish - Tier 4"] = {1091840545, 3, 4},
        ["Inspiring Finish - Tier 5"] = {1091840545, 3, 5},

        ["Perfect Performance - Minor Ballad"] = {1090541245, 9, 1},
        ["Perfect Performance - Minor Ballad Tier 2"] = {1090541245, 9, 2},
        ["Perfect Performance - Minor Ballad Tier 3"] = {1090541245, 9, 3},

        ["Perfect Performance - Major Ballad"] = {1090553794, 10, 1},
        ["Perfect Performance - Major Ballad Tier 2"] = {1090553794, 10, 2},
        ["Perfect Performance - Major Ballad Tier 3"] = {1090553794, 10, 3},
    }
    
    self.removeEffectTable = {
        ["Emboldening Finish - Tier 1"] = true,
        ["Emboldening Finish - Tier 2"] = true,
        ["Emboldening Finish - Tier 3"] = true,
        ["Emboldening Finish - Tier 4"] = true,
        ["Emboldening Finish - Tier 5"] = true,

        ["Inspiring Finish - Tier 1"] = true,
        ["Inspiring Finish - Tier 2"] = true, 
        ["Inspiring Finish - Tier 3"] = true,
        ["Inspiring Finish - Tier 4"] = true,
        ["Inspiring Finish - Tier 5"] = true,

        ["Perfect Performance - Minor Ballad"] = true,
        ["Perfect Performance - Minor Ballad Tier 2"] = true,
        ["Perfect Performance - Minor Ballad Tier 3"] = true,

        ["Perfect Performance - Major Ballad"] = true,
        ["Perfect Performance - Major Ballad Tier 2"] = true,
        ["Perfect Performance - Major Ballad Tier 3"] = true,

        ["Change of Pace - Attack!"] = true,

        ["Call to Ioreth"] = true,
    }

    if self.buffData == nil or tablelength(self.buffData) < 1  then
        self.buffData = {}
        for key, value in pairs(self.dynamicEffectTable) do
            self.buffData[key] = {value[1], value[2], self.specialEffectTable[key] ~= nil, self.removeEffectTable[key] ~= nil, true}
        end
    else
        for key, value in pairs(self.buffData) do
            if value[5] == false then
                self.dynamicEffectTable[key] = nil
                self.specialEffectTable[key] = nil
                self.removeEffectTable[key] = nil
            elseif self.dynamicEffectTable[key] == nil then
                self.dynamicEffectTable[key] = {value[1], value[2]}

                if value[3] then
                    self.specialEffectTable[key] = {value[1], value[2], true}
                end

                if value[4] then
                    self.removeEffectTable[key] = true
                end
            end
        end
    end

    self.balladTypes = {
    	-- Red
    	["Ballad Damage Bonus"] = 1,

    	-- Green
    	["Ballad Healing Bonus"] = 2,

    	-- Blue
    	["Ballad Power Bonus"] = 3,
    }

    self.highlightSkills = {
        ["Perfect Ending"] = true,
        ["Bolster Courage"] = true,
        ["Hero's Strike"] = true,
        ["Raise the Spirit"] = true,
        ["Chord of Salvation"] = true,
    }

    self.highlightEffects = {
        ["Snowball - Tier 7"] = {
            ["Perfect Ending"] = true,
        },
        ["Bolster Courage Free"] = {
            ["Bolster Courage"] = true,
        },
        ["Prowess"] = {
            ["Hero's Strike"] = true,
        },
        ["Melodic Interlude"] = {
            ["Bolster Courage"] = true,
            ["Raise the Spirit"] = true,
            ["Chord of Salvation"] = true,
        }
    }

    self:Load()
end

function MinstrelTools:GetData()
    return self.data
end

function MinstrelTools:ChangeData(key, value)
    self.data[key] = value
end

function MinstrelTools:GetBuffData()
    return self.buffData
end

function MinstrelTools:ChangeBuffData(key, stack, remove, enable)
    self.buffData[key] = {self.buffData[key][1], self.buffData[key][2], stack, remove, enable}
end

function MinstrelTools:AddBuffData(key, icon, priority, stack, remove, enable)
    self.buffData[key] = {icon, priority, stack, remove, enable}
end

function MinstrelTools:RemoveCallbacks()
    for key, value in pairs(self.effectCallbacks) do
        RemoveCallback(PlayerEffectsHandler, key, value)
    end


    --player callbacks
    for key, value in pairs(self.playerCallbacks) do
        RemoveCallback(self.player, key, value)
    end

    for key, value in pairs(self.skillCallbacks) do
        for _, callback in pairs(value) do
            RemoveCallback(self.skillsLUT[key], "ResetTimeChanged", callback)
        end
    end

    collectgarbage()

end

function MinstrelTools:SetCallbacks()

    self.effectCallbacks["EffectRemoved"] = AddCallback(PlayerEffectsHandler, "EffectRemoved", 
    function(effect)

        if effect then 
            local effectName = effect:GetName()
            if self.removeEffectTable[effectName] and self.removeEffectTable[effectName] == effect:GetID() then
                self.buffSkillBar:ToggleLabel(effectName, false)
            end

            if self.balladTypes[effectName] then
            	self.balladBars:RemoveBallad(effect:GetID())
            end

            if self.barTable[effectName] and effect:GetID() == self.barID[effectName] then
                --ChatOutput(Turbine.Engine.GetGameTime() - effect:GetStartTime())
                self.barTable[effectName]:SetCurrentValue(0)
            end

            if self.Anthems[effectName] and self.AnthemIDs[effectName] == effect:GetID() then
                self.AnthemBars[effectName]:SetCurrentValue(0)
                if self.AnthermTimersEnabled then self.AnthermTimers[effectName]:SetTimer(0) end
            end

            if self.highlightEffects[effectName] then
                for key, value in pairs(self.highlightEffects[effectName]) do
                    if self.skillSlots[key] then
                        self.skillSlots[key]:ToggleHighlight(false)
                    end
                end
            end
        end
    end)

    self.effectCallbacks["EffectAdded"] = AddCallback(PlayerEffectsHandler, "EffectAdded", 
    function(effect)
        local effectName = effect:GetName()

        --ChatOutput(effectName .. effect:GetIcon())

        if self.dynamicEffectTable[effectName] then 
            if self.removeEffectTable[effectName] then self.removeEffectTable[effectName] = effect:GetID() end
            --if self.dynamicEffectTable[effectName][1] == effect:GetIcon() then
                self.buffSkillBar:ToggleLabel(effectName, true, effect:GetDuration(), self.dynamicEffectTable[effectName][1] == true and effect:GetIcon())
            --end
        end

        if self.balladTypes[effectName] then
           	self.balladBars:AddBallad(effect:GetID(), effectName)
        end

        if self.barTable[effectName] then
            self.barTable[effectName]:SetCurrentValue(effect:GetDuration())
            self.barID[effectName] = effect:GetID()
        end

        if self.Anthems[effectName] then
            local duration = effect:GetDuration()
            self.AnthemBars[effectName]:SetMaxValue(duration)
            self.AnthemBars[effectName]:SetCurrentValue(duration)
            if self.AnthermTimersEnabled and self.AnthermTimers[effectName] then self.AnthermTimers[effectName]:SetTimer(duration) end
            self.AnthemIDs[effectName] = effect:GetID()
        end

        if self.SlotTimerEffects[effectName] and not(self.noSkills) then
            if self.SlotTimers[self.SlotTimerEffects[effectName]] then
                self.SlotTimers[self.SlotTimerEffects[effectName]]:SetValue(effect:GetDuration())
            end
        end

        if self.highlightEffects[effectName] then
            for key, value in pairs(self.highlightEffects[effectName]) do
                if self.skillSlots[key] then
                    self.skillSlots[key]:ToggleHighlight(true)
                end
            end
        end


    end)

    -- skill callbacks
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()
        --ChatOutput(name .. item:GetSkillInfo():GetIconImageID())

        self.skillCallbacks[name] = {}

        if self.skills[name] and not(self.noSkills) then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.normalSkillBar:SetLabelTimer(name, math.max(0.1, item:GetResetTime() - Turbine.Engine.GetGameTime()), item:GetCooldown())
            end))
        end

        if self.dynamicSkillTable[name] then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.buffSkillBar:ToggleLabel(name, true, self.dynamicSkillTable[name][1])
            end))
        end
    end

end

function MinstrelTools:SetSkillObjects()

    --ChatEventHandler:SubscribeTools(self)
    --ChatEventHandler:TogglePlayerCombat(true)
    
    -- Handle initial state
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()

        if self.skills[name] and not(self.noSkills) then
            self.skillSlots[name] = ClassSkillSlot(self.normalSkillBar, self.width / 2 - 16, 0, 32, 32, self.skills[name][2], false, false, (self.highlightSkills[name] ~= nil))
            self.normalSkillBar:AddLabel(name, self.skillSlots[name], self.skills[name][1], nil, self.skills[name][3])
            if self.SlotTimerSkills[name] then
                self.SlotTimers[name] = SkillSlotTimer(self.skillSlots[name])
            end
        end
    end

    for i = 1, self.player:GetUntrainedSkills():GetCount(), 1 do
        local item = self.player:GetUntrainedSkills():GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()
    end

    self.normalSkillBar:SetStaticPositions()

    for key, value in pairs(self.dynamicSkillTable) do
        self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[2], false, false, nil, 1, 1, true, false, true), value[3])
    end

    for key, value in pairs(self.dynamicEffectTable) do
        self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[1], false, false, nil, 1, 1, true, false, true), value[2])
    end

    for key, value in pairs(self.specialEffectTable) do
        local stack = value[3]
        if value [3] == true then
            stack = string.match(key, "%d+")
            if stack == nil then stack = 1 end
        end
        self.buffSkillBar:AddLabel(key, StackingClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[1], false, false, nil, 1, 1, true, false, false, stack), value[2])
    end


    local barWidth = (self.normalSkillBar:MaxWidth() * 32 )
    if barWidth == 0 then barWidth = 150 end

    local index = 0
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()
        if self.Anthems[name] then
            self.AnthemBars[name] = ValueBar(self, barWidth - 2 - 7, 15, 1 + (self.width - barWidth) / 2 + 7, 38 + 15 * index, nil, self.Anthems[name][1], Turbine.UI.Color(0.6, 0,0,0), 300, "bar6r", false, true)
            if self.AnthemLabelsEnabled then
                self.AnthemLabels[name] = AnthemLabel(self, 1 + (self.width - barWidth) / 2 + 7, 38 + 15 * index, self.Anthems[name][2])
            end
            if self.AnthermTimersEnabled then
                self.AnthermTimers[name] = AnthemTimerLabel(self, 1 +  barWidth - 100, 40 + 15 * index)
            end
            index = index + 1
        end
    end
	self.balladBars:CalcWidth(barWidth)
    self:RepositionBars(index * 15)

end

function MinstrelTools:RepositionBars(newHeight)
    --self.balladBars:SetTop(40 - newHeight)
    self.buffSkillBar:SetTop(0 - newHeight)
    --self.normalSkillBar:SetTop(52 + newHeight)
    --self.specialSkillBar:SetTop(84 + newHeight)
    --self.markBar:SetTop(116 + newHeight)
    for key, value in pairs(self.AnthemBars) do
        value:SetTop(value:GetTop() - newHeight - 2) 
        if self.AnthemLabelsEnabled then
            self.AnthemLabels[key]:SetTop(self.AnthemLabels[key]:GetTop() - newHeight - 2)
        end
        if self.AnthermTimersEnabled then
            self.AnthermTimers[key]:SetTop(self.AnthermTimers[key]:GetTop() - newHeight - 2)
        end
    end
end

function MinstrelTools:ToggleMove()
    self.moveBox:ToggleMove()
end

function MinstrelTools:GetOptions(parent, x, y)
    local container = Turbine.UI.Control()
    container:SetParent(parent)
    container:SetPosition(x, y)
    container:SetSize(530 + 4, 100 + 4)
    container:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(container)
    SingleBackground:SetPosition(2, 2)
    SingleBackground:SetSize(530, 100)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EffectBox2 = Turbine.UI.Lotro.CheckBox()
    EffectBox2:SetParent(SingleBackground)
    EffectBox2:SetPosition(10, 50)
    EffectBox2:SetSize(200,20)
    EffectBox2:SetChecked(Settings.ClassToolsNoSkills)
    EffectBox2:SetText("Disable skill bars")
    EffectBox2:SetVisible(true)

    EffectBox2.CheckedChanged = function()
        Settings.ClassToolsNoSkills = EffectBox2:IsChecked()
    end

    local EffectBox3 = Turbine.UI.Lotro.CheckBox()
    EffectBox3:SetParent(SingleBackground)
    EffectBox3:SetPosition(210, 10)
    EffectBox3:SetSize(200,20)
    EffectBox3:SetChecked(Settings.ClassToolsMinstrelAnthemTimers)
    EffectBox3:SetText("Anthem Timers")
    EffectBox3:SetVisible(true)

    EffectBox3.CheckedChanged = function()
        Settings.ClassToolsMinstrelAnthemTimers = EffectBox3:IsChecked()
    end

    local EffectBox4 = Turbine.UI.Lotro.CheckBox()
    EffectBox4:SetParent(SingleBackground)
    EffectBox4:SetPosition(210, 30)
    EffectBox4:SetSize(200,20)
    EffectBox4:SetChecked(Settings.ClassToolsMinstrelAnthemLabels)
    EffectBox4:SetText("Anthem Names")
    EffectBox4:SetVisible(true)

    EffectBox4.CheckedChanged = function()
        Settings.ClassToolsMinstrelAnthemLabels = EffectBox4:IsChecked()
    end
    
end

function MinstrelTools:RemoveSkillObjects()
    self.buffSkillBar:Unload(true)
    self.normalSkillBar:Unload(true)
    --self.specialSkillBar:Unload()

    for key, value in pairs(self.AnthemBars) do
        value:Unload()
        self.AnthemBars[key] = nil
    end

    for key, value in pairs(self.AnthemLabels) do
        self.AnthemLabels[key]:SetVisible(false)
        self.AnthemLabels[key]:SetParent(nil)
    end

    for key, value in pairs(self.AnthermTimers) do
        self.AnthermTimers[key]:SetVisible(false)
        self.AnthermTimers[key]:SetParent(nil)
    end

    for key, value in pairs(self.SlotTimers) do
        value:Unload()
        self.SlotTimers[key] = nil
    end

    self.barTable = {}

    --ChatEventHandler:SubscribeTools(nil)
    --ChatEventHandler:TogglePlayerCombat(nil)

    for _, value in pairs(self.formSlots) do
        value:Unload()
    end

    self.formSlots = {}
    self.skillSlots = {}
    self.specialSkillSlots = {}
    self.AnthemLabels = {}
    self.AnthermTimers = {}
    self.SlotTimers = {}

    self.skillCount = 0
    self.specialSkillCount = 0

    collectgarbage()
end

function MinstrelTools:ParseUpdate(message)
    
 
end

function MinstrelTools:LoadData()
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.effectList = self.player:GetEffects()
    self.ClassAttr = self.player:GetClassAttributes()
    self.trainedSkills = self.player:GetTrainedSkills()
end

function MinstrelTools:Load()
    self:SetSkillObjects()
    self:SetCallbacks()
end

function MinstrelTools:Unload()
    self:RemoveCallbacks()
    self:RemoveSkillObjects()
end

function MinstrelTools:Reload()
    self:Unload()
    self:LoadData()
    self:Load()
end

BalladBar = class(Turbine.UI.Control)
function BalladBar:Constructor(parent, index)
    Turbine.UI.Control.Constructor(self)
    self.width = 100
    self.height = 10
    self:SetParent(parent)
    self:SetVisible(true)
    self:SetMouseVisible(false)
    --self:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self:SetSize(self.width, self.height)

    self.baseColour = Turbine.UI.Color(0.6, 0,0,0)

    self.backgroundImage = Turbine.UI.Window()
    self.backgroundImage:SetParent(self)
    self.backgroundImage:SetVisible(true)
    self.backgroundImage:SetMouseVisible(false)
    self.backgroundImage:SetSize(128, 16)
    self.backgroundImage:SetBackground("PrimePlugins/RaidTools/Images/bar4.tga")
    self.backgroundImage:SetStretchMode(1)
    self.backgroundImage:SetSize(self.width, self.height)

    self.backgroundColour = Turbine.UI.Window()
    self.backgroundColour:SetParent(self)
    self.backgroundColour:SetVisible(true)
    self.backgroundColour:SetMouseVisible(false)
    self.backgroundColour:SetBackColor(self.baseColour)
    --self.backgroundColour:SetOpacity(0.6)
	self.backgroundColour:SetSize(self.width, self.height)
    --self.backgroundImage:SetStretchMode(1)
    --self.backgroundImage:SetSize(width, height)
    --self.backgroundImage:SetOpacity(0.4)

    self.index = index
end

function BalladBar:CalcWidth(totalWidth)
	local newWidth = totalWidth / 3 -- 9
	self:SetSize(newWidth, self.height)

    self.backgroundImage:SetStretchMode(nil)
    self.backgroundImage:SetSize(128, 16)
    --self.backgroundImage:SetBackground("PrimePlugins/RaidTools/Images/bar3.tga")
    self.backgroundImage:SetStretchMode(1)
	self.backgroundImage:SetSize(newWidth, self.height)


	self.backgroundColour:SetSize(newWidth, self.height)
	self:SetPosition(newWidth * (self.index - 1) + (self.index - 1) * 3, 0)
end

function BalladBar:AdjustColour(type)
	if type == 1 then
		self.backgroundColour:SetBackColor(Turbine.UI.Color(0.8, 0.6,0,0))
	elseif type == 2 then
		self.backgroundColour:SetBackColor(Turbine.UI.Color(0.8, 1/259,100/259,0))
	elseif type == 3 then
		self.backgroundColour:SetBackColor(Turbine.UI.Color(0.8, 0,0, 0.6))
	end
end

function BalladBar:Reset()
	self.backgroundColour:SetBackColor(self.baseColour)
end

BalladBarControl = class(Turbine.UI.Control)
function BalladBarControl:Constructor(parent, y, totalSize)
    Turbine.UI.Control.Constructor(self)
    self.width = 0
    self.height = 7
    self:SetParent(parent)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)
    self:SetPosition(0, y)

    self.Y = y
    self.totalSize = totalSize

    self.balladBars = {}
    self.balladBars[1] = BalladBar(self, 1)
    self.balladBars[2] = BalladBar(self, 2)
    self.balladBars[3] = BalladBar(self, 3)

    self.balladID = {
   		[1] = 0,
   		[2] = 0,
   		[3] = 0,
    }

    self.balladTimes = {
    	[1] = -1,
    	[2] = -1,
    	[3] = -1,
    }

    self.balladCount = 0

    self.balladTypes = {
    	-- Red
    	["Ballad Damage Bonus"] = 1,

    	-- Green
    	["Ballad Healing Bonus"] = 2,

    	-- Blue
    	["Ballad Power Bonus"] = 3,
    }
end

function BalladBarControl:CalcWidth(totalWidth)
	self:SetSize(totalWidth, self.height)
	self:SetPosition((self.totalSize - totalWidth) / 2, self.Y)
	for key, value in pairs(self.balladBars) do
    	value:CalcWidth(totalWidth)
    end
end

function BalladBarControl:AddBallad(id, ballad)

	if self.balladCount == 3 then
		local smallestTime = -1
		local smallestKey = -1
		for key, value in pairs(self.balladTimes) do
			if smallestTime == -1 or smallestTime > value then
				smallestTime = value
				smallestKey = key
			end
		end

		self.balladBars[smallestKey]:Reset()
		self.balladID[smallestKey] = 0

		self.balladCount = self.balladCount - 1
	end

	for key, value in pairs(self.balladID) do
		if value == 0 then
			self.balladID[key] = id
			self.balladBars[key]:AdjustColour(self.balladTypes[ballad])
			self.balladCount = self.balladCount + 1
			self.balladTimes[key] = Turbine.Engine.GetGameTime()
			break
		end
	end
end

function BalladBarControl:RemoveBallad(id)
	for key, value in pairs(self.balladID) do
		if value == id then
			self.balladID[key] = 0
			self.balladBars[key]:Reset()
			self.balladCount = self.balladCount - 1
			break
		end
	end
end

AnthemLabel = class(Turbine.UI.Label)
function AnthemLabel:Constructor(parent, x, y, name)
    Turbine.UI.Label.Constructor(self)
    self:SetParent(parent)
    self:SetSize(200, 15)
    self:SetVisible(true)
    self:SetMouseVisible(false)
    self:SetPosition(x, y - 2)
    self:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    self:SetFont(Turbine.UI.Lotro.Font.BookAntiqua16)
    self:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self:SetText(name)
    self:SetStretchMode(1)
end

AnthemTimerLabel = class(Turbine.UI.Label)
function AnthemTimerLabel:Constructor(parent, x, y)
    Turbine.UI.Label.Constructor(self)
    self:SetParent(parent)
    self:SetSize(200, 15)
    self:SetVisible(true)
    self:SetMouseVisible(false)
    self:SetPosition(x, y - 2)
    self:SetTextAlignment(Turbine.UI.ContentAlignment.TopRight)
    self:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self:SetStretchMode(1)

    self.ExecuteUpdate = function(delta)
        self.timer = self.timer - delta
        if self.timer < 0 then
            if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
            self.updateCallback = nil
        end
        self:SetStretchMode(nil)
        self:SetStretchMode(1)
        self:SetText(math.round(self.timer))
    end
end

function AnthemTimerLabel:SetTimer(timer)
    self:SetText(math.ceil(timer))
    self.timer = timer
    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
end

--------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------