IconOverview = class(Turbine.UI.Window)
function IconOverview:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(490, 400)
    self:SetPosition(300, 215)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.2, 0.2, 0.2))

    self.VisibleChanged = function()
        if self:IsVisible() then
            self:SetZOrder(100)
            local x, y = self:GetMousePosition()
            local oldX, oldY = self:GetPosition()
            self:SetPosition((x + oldX) - 250, y + oldY + 5)
        end
    end

    self.IconWindowHeaderLabel = Turbine.UI.Label()
    self.IconWindowHeaderLabel:SetParent(self)
    self.IconWindowHeaderLabel:SetSize(490 - 2, 20 - 1)
    self.IconWindowHeaderLabel:SetPosition(1, 1)
    --self.IconWindowHeaderLabel:SetMouseVisible(false)
    --self.IconWindowHeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    self.IconWindowHeaderLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.IconWindowHeaderLabel:SetMultiline(true)
    self.IconWindowHeaderLabel:SetText("Icon selection")

    
    self.Moving = false

    self.IconWindowHeaderLabel.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.IconWindowHeaderLabel.MouseUp = function()
        self.Moving = false
    end

    self.IconWindowHeaderLabel.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    -- Close Button
    self.IconCloseBackground = Turbine.UI.Control()
    self.IconCloseBackground:SetParent(self)
    self.IconCloseBackground:SetPosition(490 - 20, 0)
    self.IconCloseBackground:SetSize(20, 20)
    self.IconCloseBackground:SetMouseVisible(true)
    self.IconCloseBackground:SetBackColor(Turbine.UI.Color(153/255, 0, 0))


    self.IconCloseBackground.MouseClick = function()
        self:SetVisible(false)
    end

    self.iconListBox = Turbine.UI.ListBox()
    self.iconListBox:SetSize(490 - 2, 380 - 2)
    self.iconListBox:SetPosition(1, 21)
    self.iconListBox:SetParent(self)
    self.iconListBox:SetMouseVisible(false)
    self.iconListBox:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    self.iconListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
    self.iconListBox:SetMaxColumns(15)

    self.iconListBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.iconListBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.iconListBoxScrollbar:SetParent(self)
    self.iconListBoxScrollbar:SetPosition(480, 21)
    self.iconListBoxScrollbar:SetSize(10, 378)
    self.iconListBox:SetVerticalScrollBar(self.iconListBoxScrollbar)

    self.searchBox = Turbine.UI.Lotro.TextBox()
    self.searchBox:SetParent(self)
    self.searchBox:SetSize(250, 19)
    self.searchBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.searchBox:SetPosition(250 - 30 - 1, 1)

    self.searchBox.TextChanged = function()
        self.filterKey = self.searchBox:GetText()
        self.allVisible = string.len(self.filterKey) < 1
        for i = 1, self.iconListBox:GetItemCount(), 1 do
            local object = self.iconListBox:GetItem(i)
            if self.allVisible then
                object:SetVisible(true)
            else
                object:SetVisible(string.find(string.lower(object.name), string.lower(self.filterKey)))
            end
        end
    end

    if DataGrabberTool then
        local duplicates = {}
        for key, value in spairs(DataGrabberTool:GetIcons(), function(t,a,b) return tostring(a) > tostring(b) end) do
            if duplicates[value] then
            else
                local icon = Turbine.UI.Control()
                icon:SetSize(32,32)
                icon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                icon:SetBackground(BackgroundHandler:GetBackground(value))
                icon:SetMouseVisible(true)
                icon.name = key

                icon.MouseClick = function()
                    if self.iconBox then
                        self.iconBox:SetBackground(BackgroundHandler:GetBackground(value))
                        self.icontext:SetText(value)
                        
                    end
                    self:SetVisible(false)

                end

                self.iconListBox:AddItem(icon)
                duplicates[value] = true


            end
        end

        duplicates = nil
    end
end

function IconOverview:Register(iconbox, icontext)
    self.iconBox = iconbox
    self.icontext = icontext
end

HistoricalEffectOverview = class(Turbine.UI.Window)
function HistoricalEffectOverview:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(500, 400)
    self:SetPosition(300, 215)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.2, 0.2, 0.2))

    self.VisibleChanged = function()
        if self:IsVisible() then
            self:SetZOrder(100)
            local x, y = self:GetMousePosition()
            local oldX, oldY = self:GetPosition()
            self:SetPosition((x + oldX) - 250, y + oldY + 5)
        end
    end

    self.HistoricalEffectsWindowHeaderLabel = Turbine.UI.Label()
    self.HistoricalEffectsWindowHeaderLabel:SetParent(self)
    self.HistoricalEffectsWindowHeaderLabel:SetSize(500 - 2, 20 - 1)
    self.HistoricalEffectsWindowHeaderLabel:SetPosition(1, 1)
    --self.HistoricalEffectsWindowHeaderLabel:SetMouseVisible(false)
    --self.HistoricalEffectsWindowHeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    self.HistoricalEffectsWindowHeaderLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.HistoricalEffectsWindowHeaderLabel:SetMultiline(true)
    self.HistoricalEffectsWindowHeaderLabel:SetText("HistoricalEffects selection")

    
    self.Moving = false

    self.HistoricalEffectsWindowHeaderLabel.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.HistoricalEffectsWindowHeaderLabel.MouseUp = function()
        self.Moving = false
    end

    self.HistoricalEffectsWindowHeaderLabel.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    -- Close Button
    self.HistoricalEffectsCloseBackground = Turbine.UI.Control()
    self.HistoricalEffectsCloseBackground:SetParent(self)
    self.HistoricalEffectsCloseBackground:SetPosition(500 - 20, 0)
    self.HistoricalEffectsCloseBackground:SetSize(20, 20)
    self.HistoricalEffectsCloseBackground:SetMouseVisible(true)
    self.HistoricalEffectsCloseBackground:SetBackColor(Turbine.UI.Color(153/255, 0, 0))


    self.HistoricalEffectsCloseBackground.MouseClick = function()
        self:SetVisible(false)
    end

    self.HistoricalEffectsListBox = Turbine.UI.TreeView()
    self.HistoricalEffectsListBox:SetSize(500 - 2, 380 - 2)
    self.HistoricalEffectsListBox:SetPosition(1, 21)
    self.HistoricalEffectsListBox:SetParent(self)
    self.HistoricalEffectsListBox:SetMouseVisible(false)
    self.HistoricalEffectsListBox:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    --self.HistoricalEffectsListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
    --self.HistoricalEffectsListBox:SetMaxColumns(1)

    self.HistoricalEffectsListBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.HistoricalEffectsListBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.HistoricalEffectsListBoxScrollbar:SetParent(self)
    self.HistoricalEffectsListBoxScrollbar:SetPosition(500 - 8, 21)
    self.HistoricalEffectsListBoxScrollbar:SetSize(8, 378)
    self.HistoricalEffectsListBox:SetVerticalScrollBar(self.HistoricalEffectsListBoxScrollbar)

    self.rootNodes = self.HistoricalEffectsListBox:GetNodes()

    self.infoLabel = Turbine.UI.Label()
    self.infoLabel:SetParent(self)
    self.infoLabel:SetPosition(0,30)
    self.infoLabel:SetSize(500, 60)
    self.infoLabel:SetText("The data collection option was disabled. Retrieving data from the plugindata file, this might take a bit due to API restrictions.")

    self.filtering = false

    self.filterFunction = function(object)
        if self.filtering then 
            return not(string.find(string.lower(object.name), string.lower(self.filterKey)))
        else
            return false
        end
    end

    self.sortFunction = function(object1, object2)
        if object1.name >= object2.name then 
            return 1
        else
            return -1
        end
    end

    self.HistoricalEffectsListBox:SetFilter(self.filterFunction)
    self.HistoricalEffectsListBox:SetSortMethod(self.sortFunction)

    self.searchBox = Turbine.UI.Lotro.TextBox()
    self.searchBox:SetParent(self)
    self.searchBox:SetSize(250, 19)
    self.searchBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.searchBox:SetPosition(250 - 20 - 1, 1)
    self.searchBox:SetMultiline(false)
    self.searchBox:GetWantsKeyEvents(true)

    self.filterTimer = 0

    self.updateCallback = function(delta)
        self.filterTimer = self.filterTimer - delta
        if self.filterTimer < 0 then
            if self.callback then 
                RemoveCallback(Updater, "ExecuteUpdate", self.callback) 
                self.callback = nil
            end 
            self.filterKey = self.searchBox:GetText()
            if string.len(self.filterKey) > 0 then
                self.filtering = true
                self.HistoricalEffectsListBox:Refresh()
            else
                self.filtering = false
                self.HistoricalEffectsListBox:Refresh()
            end
            self.searchBox.TextChanged = self.textChangedFunction
        end
    end

    self.textChangedFunction = function()
        self.filterTimer = 3
        if not(self.callback) then
            self.callback = AddCallback(Updater, "ExecuteUpdate", self.updateCallback)
        end
    end

    self.searchBox.TextChanged = self.textChangedFunction

    self.searchBox.KeyDown = function(sender, args)
        if args.Action == 162 and self.searchBox:HasFocus() then
           self.filterTimer = 0 
           self.searchBox.TextChanged = nil
        end
    end

    if DataGrabberTool then
        local callbackFunction = function(data)
            local duplicates = {}
            --PrintTable(data)
            for key, value in spairs(data, function(t,a,b) return a < b end) do
                if duplicates[value] then
                else

                    local node = MyTreeNode()
                    node:SetSize(492,32)
                    node.name = key

                    local HistoricalEffects = Turbine.UI.Control()
                    HistoricalEffects:SetParent(node)
                    HistoricalEffects:SetSize(492,32)
                    HistoricalEffects:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                    --HistoricalEffects:SetBackground(value[4])
                    HistoricalEffects:SetMouseVisible(true)

                    HistoricalEffects.MouseEnter = function()
                        HistoricalEffects:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
                    end

                    HistoricalEffects.MouseLeave = function()
                        HistoricalEffects:SetBackColor(nil)
                    end

                    local HistoricalEffectsIcon = Turbine.UI.Control()
                    HistoricalEffectsIcon:SetSize(32,32)
                    HistoricalEffectsIcon:SetParent(HistoricalEffects)
                    HistoricalEffectsIcon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                    HistoricalEffectsIcon:SetBackground(BackgroundHandler:GetBackground(value[4]))
                    HistoricalEffectsIcon:SetMouseVisible(false)

                    local HistoricalEffectsName = Turbine.UI.Label()
                    HistoricalEffectsName:SetSize(492 - 32,32)
                    HistoricalEffectsName:SetParent(HistoricalEffects)
                    HistoricalEffectsName:SetPosition(32, 0)
                    HistoricalEffectsName:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                    HistoricalEffectsName:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
                    HistoricalEffectsName:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
                    local duration = ""
                    if value[3] < 999999 then
                        duration = " Dur: " .. tostring(value[3]) .. "s"
                    end
                    HistoricalEffectsName:SetText(key .. duration)
                    HistoricalEffectsName:SetMouseVisible(false)


                    local HistoricalEffectsName = Turbine.UI.Label()
                    HistoricalEffectsName:SetSize(492 - 32,32)
                    HistoricalEffectsName:SetParent(HistoricalEffects)
                    HistoricalEffectsName:SetPosition(32, 0)
                    HistoricalEffectsName:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                    HistoricalEffectsName:SetTextAlignment(Turbine.UI.ContentAlignment.BottomLeft)
                    HistoricalEffectsName:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
                    HistoricalEffectsName:SetText(tostring(value[2]))
                    HistoricalEffectsName:SetMouseVisible(false)
                    HistoricalEffectsName:SetMultiline(false)

                    HistoricalEffects.MouseClick = function()
                        if self.icontext then
                            self.icontext:SetText(key)
                            
                        end
                        self:SetVisible(false)

                    end

                    --self.HistoricalEffectsListBox:AddItem(HistoricalEffects)
                    duplicates[value] = true

                    self.rootNodes:Add(node)


                end
            end
            self.infoLabel:SetVisible(false)
        end
        DataGrabberTool:GetEffects(callbackFunction)
    end
end

function HistoricalEffectOverview:Register(icontext)
    self.icontext = icontext
end

SkillOverview = class(Turbine.UI.Window)
function SkillOverview:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(500, 400)
    self:SetPosition(300, 215)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.VisibleChanged = function()
        if self:IsVisible() then
            self:SetZOrder(100)
            local x, y = self:GetMousePosition()
            local oldX, oldY = self:GetPosition()
            self:SetPosition((x + oldX) - 250, y + oldY + 5)
        end
    end

    self.HistoricalEffectsWindowHeaderLabel = Turbine.UI.Label()
    self.HistoricalEffectsWindowHeaderLabel:SetParent(self)
    self.HistoricalEffectsWindowHeaderLabel:SetSize(500 - 2, 20 - 1)
    self.HistoricalEffectsWindowHeaderLabel:SetPosition(1, 1)
    --self.HistoricalEffectsWindowHeaderLabel:SetMouseVisible(false)
    --self.HistoricalEffectsWindowHeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    self.HistoricalEffectsWindowHeaderLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.HistoricalEffectsWindowHeaderLabel:SetMultiline(true)
    self.HistoricalEffectsWindowHeaderLabel:SetText("Skill selection")

    
    self.Moving = false

    self.HistoricalEffectsWindowHeaderLabel.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.HistoricalEffectsWindowHeaderLabel.MouseUp = function()
        self.Moving = false
    end

    self.HistoricalEffectsWindowHeaderLabel.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    -- Close Button
    self.HistoricalEffectsCloseBackground = Turbine.UI.Control()
    self.HistoricalEffectsCloseBackground:SetParent(self)
    self.HistoricalEffectsCloseBackground:SetPosition(500 - 20, 0)
    self.HistoricalEffectsCloseBackground:SetSize(20, 20)
    self.HistoricalEffectsCloseBackground:SetMouseVisible(true)
    self.HistoricalEffectsCloseBackground:SetBackColor(Turbine.UI.Color(153/255, 0, 0))


    self.HistoricalEffectsCloseBackground.MouseClick = function()
        self:SetVisible(false)
    end

    self.HistoricalEffectsListBox = Turbine.UI.TreeView()
    self.HistoricalEffectsListBox:SetSize(500 - 2, 380 - 2)
    self.HistoricalEffectsListBox:SetPosition(1, 21)
    self.HistoricalEffectsListBox:SetParent(self)
    self.HistoricalEffectsListBox:SetMouseVisible(false)
    self.HistoricalEffectsListBox:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    --self.HistoricalEffectsListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
    --self.HistoricalEffectsListBox:SetMaxColumns(1)

    self.HistoricalEffectsListBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.HistoricalEffectsListBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.HistoricalEffectsListBoxScrollbar:SetParent(self)
    self.HistoricalEffectsListBoxScrollbar:SetPosition(500 - 8, 21)
    self.HistoricalEffectsListBoxScrollbar:SetSize(8, 378)
    self.HistoricalEffectsListBox:SetVerticalScrollBar(self.HistoricalEffectsListBoxScrollbar)

    self.rootNodes = self.HistoricalEffectsListBox:GetNodes()

    self.filtering = false

    self.filterFunction = function(object)
        if self.filtering then 
            return not(string.find(string.lower(object.name), string.lower(self.filterKey)))
        else
            return false
        end
    end

    self.sortFunction = function(object1, object2)
        if object1.name >= object2.name then 
            return 1
        else
            return -1
        end
    end

    self.searchBox = Turbine.UI.Lotro.TextBox()
    self.searchBox:SetParent(self)
    self.searchBox:SetSize(250, 19)
    self.searchBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.searchBox:SetPosition(250 - 20 - 1, 1)

    self.searchBox.TextChanged = function()
        self.filterKey = self.searchBox:GetText()
        if string.len(self.filterKey) > 0 then
            self.filtering = true
            self.HistoricalEffectsListBox:Refresh()
        else
            self.filtering = false
            self.HistoricalEffectsListBox:Refresh()
        end
    end

    self.HistoricalEffectsListBox:SetFilter(self.filterFunction)
    self.HistoricalEffectsListBox:SetSortMethod(self.sortFunction)

    if SkillEventHandler then
        local duplicates = {}
        for key, value in spairs(SkillEventHandler:GetSkills(), function(t,a,b) return a < b end) do
            if duplicates[value] then
            else
                local node = MyTreeNode()
                node:SetSize(492,32)
                node.name = key

                local HistoricalEffects = Turbine.UI.Control()
                HistoricalEffects:SetParent(node)
                HistoricalEffects:SetSize(492,32)
                HistoricalEffects:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                --HistoricalEffects:SetBackground(value[4])
                HistoricalEffects:SetMouseVisible(true)

                HistoricalEffects.MouseEnter = function()
                    HistoricalEffects:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
                end

                HistoricalEffects.MouseLeave = function()
                    HistoricalEffects:SetBackColor(nil)
                end

                local HistoricalEffectsIcon = Turbine.UI.Control()
                HistoricalEffectsIcon:SetSize(32,32)
                HistoricalEffectsIcon:SetParent(HistoricalEffects)
                HistoricalEffectsIcon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                HistoricalEffectsIcon:SetBackground(BackgroundHandler:GetBackground(value))
                HistoricalEffectsIcon:SetMouseVisible(false)

                local HistoricalEffectsName = Turbine.UI.Label()
                HistoricalEffectsName:SetSize(492 - 32,32)
                HistoricalEffectsName:SetParent(HistoricalEffects)
                HistoricalEffectsName:SetPosition(32, 0)
                HistoricalEffectsName:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                HistoricalEffectsName:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
                HistoricalEffectsName:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
                HistoricalEffectsName:SetText(key)
                HistoricalEffectsName:SetMouseVisible(false)

                HistoricalEffects.MouseClick = function()
                    if self.icontext then
                        self.icontext:SetText(key)
                        
                    end
                    self:SetVisible(false)

                end

                self.rootNodes:Add(node)


            end
        end

        duplicates = nil
    end
end

function SkillOverview:Register(icontext)
    self.icontext = icontext
end

SkillOverview2 = class(Turbine.UI.Window)
function SkillOverview2:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(500, 400)
    self:SetPosition(300, 215)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.VisibleChanged = function()
        if self:IsVisible() then
            self:SetZOrder(100)
            local x, y = self:GetMousePosition()
            local oldX, oldY = self:GetPosition()
            self:SetPosition((x + oldX) - 250, y + oldY + 5)
        end
    end

    self.HistoricalEffectsWindowHeaderLabel = Turbine.UI.Label()
    self.HistoricalEffectsWindowHeaderLabel:SetParent(self)
    self.HistoricalEffectsWindowHeaderLabel:SetSize(500 - 2, 20 - 1)
    self.HistoricalEffectsWindowHeaderLabel:SetPosition(1, 1)
    --self.HistoricalEffectsWindowHeaderLabel:SetMouseVisible(false)
    --self.HistoricalEffectsWindowHeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    self.HistoricalEffectsWindowHeaderLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.HistoricalEffectsWindowHeaderLabel:SetMultiline(true)
    self.HistoricalEffectsWindowHeaderLabel:SetText("Skill selection")

    
    self.Moving = false

    self.HistoricalEffectsWindowHeaderLabel.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.HistoricalEffectsWindowHeaderLabel.MouseUp = function()
        self.Moving = false
    end

    self.HistoricalEffectsWindowHeaderLabel.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    -- Close Button
    self.HistoricalEffectsCloseBackground = Turbine.UI.Control()
    self.HistoricalEffectsCloseBackground:SetParent(self)
    self.HistoricalEffectsCloseBackground:SetPosition(500 - 20, 0)
    self.HistoricalEffectsCloseBackground:SetSize(20, 20)
    self.HistoricalEffectsCloseBackground:SetMouseVisible(true)
    self.HistoricalEffectsCloseBackground:SetBackColor(Turbine.UI.Color(153/255, 0, 0))


    self.HistoricalEffectsCloseBackground.MouseClick = function()
        self:SetVisible(false)
    end

    self.HistoricalEffectsListBox = Turbine.UI.TreeView()
    self.HistoricalEffectsListBox:SetSize(500 - 2, 380 - 2)
    self.HistoricalEffectsListBox:SetPosition(1, 21)
    self.HistoricalEffectsListBox:SetParent(self)
    self.HistoricalEffectsListBox:SetMouseVisible(false)
    self.HistoricalEffectsListBox:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    --self.HistoricalEffectsListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
    --self.HistoricalEffectsListBox:SetMaxColumns(1)

    self.HistoricalEffectsListBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.HistoricalEffectsListBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.HistoricalEffectsListBoxScrollbar:SetParent(self)
    self.HistoricalEffectsListBoxScrollbar:SetPosition(500 - 8, 21)
    self.HistoricalEffectsListBoxScrollbar:SetSize(8, 378)
    self.HistoricalEffectsListBox:SetVerticalScrollBar(self.HistoricalEffectsListBoxScrollbar)

    self.rootNodes = self.HistoricalEffectsListBox:GetNodes()

    self.filtering = false

    self.filterFunction = function(object)
        if self.filtering then 
            return not(string.find(string.lower(object.name), string.lower(self.filterKey)))
        else
            return false
        end
    end

    self.sortFunction = function(object1, object2)
        if object1.name >= object2.name then 
            return 1
        else
            return -1
        end
    end

    self.searchBox = Turbine.UI.Lotro.TextBox()
    self.searchBox:SetParent(self)
    self.searchBox:SetSize(250, 19)
    self.searchBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.searchBox:SetPosition(250 - 20 - 1, 1)

    self.searchBox.TextChanged = function()
        self.filterKey = self.searchBox:GetText()
        if string.len(self.filterKey) > 0 then
            self.filtering = true
            self.HistoricalEffectsListBox:Refresh()
        else
            self.filtering = false
            self.HistoricalEffectsListBox:Refresh()
        end
    end

    self.HistoricalEffectsListBox:SetFilter(self.filterFunction)
    self.HistoricalEffectsListBox:SetSortMethod(self.sortFunction)


    if SkillEventHandler then
        local duplicates = {}
        for key, value in spairs(SkillEventHandler:GetSkillCodes()[Turbine.Gameplay.LocalPlayer.GetInstance():GetClass()], function(t,a,b) return t[a][1] < t[b][1] end) do
            local node = MyTreeNode()
            node:SetSize(492,32)
            node.name = value[1]

            local HistoricalEffects = Turbine.UI.Control()
            HistoricalEffects:SetParent(node)
            HistoricalEffects:SetSize(492,32)
            HistoricalEffects:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
            --HistoricalEffects:SetBackground(value[4])
            HistoricalEffects:SetMouseVisible(true)

            HistoricalEffects.MouseEnter = function()
                HistoricalEffects:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
            end

            HistoricalEffects.MouseLeave = function()
                HistoricalEffects:SetBackColor(nil)
            end

            local HistoricalEffectsIcon = Turbine.UI.Control()
            HistoricalEffectsIcon:SetSize(32,32)
            HistoricalEffectsIcon:SetParent(HistoricalEffects)
            HistoricalEffectsIcon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
            HistoricalEffectsIcon:SetBackground(BackgroundHandler:GetBackground(value[2]))
            HistoricalEffectsIcon:SetMouseVisible(false)

            local HistoricalEffectsName = Turbine.UI.Label()
            HistoricalEffectsName:SetSize(492 - 32,32)
            HistoricalEffectsName:SetParent(HistoricalEffects)
            HistoricalEffectsName:SetPosition(32, 0)
            HistoricalEffectsName:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
            HistoricalEffectsName:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
            HistoricalEffectsName:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            HistoricalEffectsName:SetText(value[1])
            HistoricalEffectsName:SetMouseVisible(false)

            HistoricalEffects.MouseClick = function()
                if self.icontext then
                    self.icontext:SetText(value[1])
                    self.skillCode:SetText(key)
                end
                self:SetVisible(false)

            end

            self.rootNodes:Add(node)


        end
    end
end

function SkillOverview2:Register(icontext, skillCode)
    self.icontext = icontext
    self.skillCode = skillCode
end

SimpleIconOverview = class(Turbine.UI.Window)
function SimpleIconOverview:Constructor(data)
    Turbine.UI.Window.Constructor(self)
    self:SetSize(890, 800)
    self:SetPosition(300, 215)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.2, 0.2, 0.2))

    self.VisibleChanged = function()
        if self:IsVisible() then
            self:SetZOrder(100)
            local x, y = self:GetMousePosition()
            local oldX, oldY = self:GetPosition()
            self:SetPosition((x + oldX) - 250, y + oldY + 5)
        end
    end

    self.IconWindowHeaderLabel = Turbine.UI.Label()
    self.IconWindowHeaderLabel:SetParent(self)
    self.IconWindowHeaderLabel:SetSize(490 - 2, 20 - 1)
    self.IconWindowHeaderLabel:SetPosition(1, 1)
    --self.IconWindowHeaderLabel:SetMouseVisible(false)
    --self.IconWindowHeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    self.IconWindowHeaderLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.IconWindowHeaderLabel:SetMultiline(true)
    self.IconWindowHeaderLabel:SetText("Icon selection")

    
    self.Moving = false

    self.IconWindowHeaderLabel.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.IconWindowHeaderLabel.MouseUp = function()
        self.Moving = false
    end

    self.IconWindowHeaderLabel.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    -- Close Button
    self.IconCloseBackground = Turbine.UI.Control()
    self.IconCloseBackground:SetParent(self)
    self.IconCloseBackground:SetPosition(490 - 20, 0)
    self.IconCloseBackground:SetSize(20, 20)
    self.IconCloseBackground:SetMouseVisible(true)
    self.IconCloseBackground:SetBackColor(Turbine.UI.Color(153/255, 0, 0))


    self.IconCloseBackground.MouseClick = function()
        self:SetVisible(false)
    end

    self.iconListBox = Turbine.UI.ListBox()
    self.iconListBox:SetSize(890 - 2, 780 - 2)
    self.iconListBox:SetPosition(1, 21)
    self.iconListBox:SetParent(self)
    self.iconListBox:SetMouseVisible(false)
    self.iconListBox:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    self.iconListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
    self.iconListBox:SetMaxColumns(27)

    self.iconListBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.iconListBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.iconListBoxScrollbar:SetParent(self)
    self.iconListBoxScrollbar:SetPosition(880, 21)
    self.iconListBoxScrollbar:SetSize(10, 778)
    self.iconListBox:SetVerticalScrollBar(self.iconListBoxScrollbar)

    self.searchBox = Turbine.UI.Lotro.TextBox()
    self.searchBox:SetParent(self)
    self.searchBox:SetSize(250, 19)
    self.searchBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.searchBox:SetPosition(250 - 30 - 1, 1)

    self.searchBox.TextChanged = function()
        self.filterKey = self.searchBox:GetText()
        self.allVisible = string.len(self.filterKey) < 1
        for i = 1, self.iconListBox:GetItemCount(), 1 do
            local object = self.iconListBox:GetItem(i)
            if self.allVisible then
                object:SetVisible(true)
            else
                object:SetVisible(string.find(string.lower(object.name), string.lower(self.filterKey)))
            end
        end
    end


    local duplicates = {}
    for key, value in spairs(data, function(t, a, b) return a < b end) do
        if duplicates[key] then
        else
            local icon = Turbine.UI.Control()
            icon:SetSize(32,32)
            icon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
            icon:SetBackground(BackgroundHandler:GetBackground(key))
            icon:SetMouseVisible(true)
            icon.MouseClick = function()
                ChatOutput(key)
            end
            self.iconListBox:AddItem(icon)
            duplicates[key] = true


        end
    end

    duplicates = nil
    
end