SkillSlotTimer = class(Turbine.UI.Window)
function SkillSlotTimer:Constructor(parent)
    Turbine.UI.Window.Constructor(self)


    self:SetParent(parent)
    self:SetPosition(0, 0)    
    self:SetSize(32, 32)
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.edgeLength = 29
    self.pathWidth = 3

    self.lineColour = Turbine.UI.Color(1,1,1)


    self.timerBar1 = Turbine.UI.Control()
    self.timerBar1:SetParent(self)
    self.timerBar1:SetSize(self.pathWidth, 0)
    self.timerBar1:SetPosition(self.edgeLength, self.pathWidth)
    self.timerBar1:SetBackColor(self.lineColour)

    self.timerBar2 = Turbine.UI.Control()
    self.timerBar2:SetParent(self)
    self.timerBar2:SetSize(0, self.pathWidth)
    self.timerBar2:SetPosition(0, self.edgeLength)
    self.timerBar2:SetBackColor(self.lineColour)

    self.timerBar3 = Turbine.UI.Control()
    self.timerBar3:SetParent(self)
    self.timerBar3:SetSize(self.pathWidth, 0)
    self.timerBar3:SetPosition(0,0)
    self.timerBar3:SetBackColor(self.lineColour)

    self.timerBar4 = Turbine.UI.Control()
    self.timerBar4:SetParent(self)
    self.timerBar4:SetSize(0, self.pathWidth)
    self.timerBar4:SetPosition(self.pathWidth,0)
    self.timerBar4:SetBackColor(self.lineColour)

    self.totalValue = 0
    self.totalValueFourth = 0
    self.currentValue = 0

    self.ExecuteUpdate = function(delta)
        self.currentValue = self.currentValue - delta
    
        local newColour = Turbine.UI.Color(math.abs(math.sin(self.currentValue)) * 0.4 + 0.6, 1, 0.84, 0)
    
        self.timerBar1:SetBackColor(newColour)
        self.timerBar2:SetBackColor(newColour)
        self.timerBar3:SetBackColor(newColour)
        self.timerBar4:SetBackColor(newColour)
    
        self.timerBar1:SetSize(self.pathWidth, math.max(0, (self.currentValue - (self.totalValueFourth * 3)) / self.totalValueFourth * self.edgeLength) )
        self.timerBar1:SetPosition(self.edgeLength, self.pathWidth + self.edgeLength - math.max(0, (self.currentValue - (self.totalValueFourth * 3)) / self.totalValueFourth * self.edgeLength))
    
        self.timerBar2:SetSize(math.min(self.edgeLength, math.max(0, (self.currentValue - (self.totalValueFourth * 2)) / self.totalValueFourth * self.edgeLength)), self.pathWidth)
    
        self.timerBar3:SetSize(self.pathWidth, math.min(self.edgeLength, math.max(0, (self.currentValue - (self.totalValueFourth)) / self.totalValueFourth * 30)))
    
        self.timerBar4:SetSize(math.min(self.edgeLength, math.max(0, (self.currentValue / self.totalValueFourth * self.edgeLength))), self.pathWidth)
        self.timerBar4:SetPosition(self.pathWidth + self.edgeLength - math.min(self.edgeLength, math.max(0, (self.currentValue / self.totalValueFourth * self.edgeLength))), 0)
    
        if self.currentValue < 0 then
            if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
            self.updateCallback = nil
        end
    end
end

function SkillSlotTimer:SetValue(value)
    self.totalValue = value
    self.totalValueFourth = self.totalValue / 4
    self.currentValue = value

    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
end

function SkillSlotTimer:Unload()
    self:SetVisible(false)
    self.timerBar1:SetParent(nil)
    self.timerBar2:SetParent(nil)
    self.timerBar3:SetParent(nil)
    self.timerBar4:SetParent(nil)
    self:SetParent(nil)
    self = nil
end




