SmashingStabSlot = class(Turbine.UI.Window)
function SmashingStabSlot:Constructor(parent, x, y, base, normal, skill)
    Turbine.UI.Window.Constructor(self)

    self.base = base
    self.normal = 35
    self.reverse = reverse

    self.smashingStabeState = 0

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.normal, self.normal)
    self:SetVisible(true)

    self.currentNumber = -1

    self.baseImageID = 0x41007E35

    self.IconLabel = Turbine.UI.Lotro.Quickslot()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(self.normal, self.normal)
    --self.IconLabel:SetBackColor(GetRandomColour())
    self.IconLabel:SetPosition(-3, -3)
    self.IconLabel:SetShortcut(Turbine.UI.Lotro.Shortcut(6, skill))

    self.fMLabel = ClassSkillLabel(self, 0, 0, base, 32, "PrimePlugins/RaidTools/Images/Logo.tga", false)
    self.stunLabel = ClassSkillLabel(self, 12, 0, 32, 20, 0x4100823F, false)
    self.bleedLabel = ClassSkillLabel(self, 0, 0, 32, 20, 0x41000083, false)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(self.normal, self.normal)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetStretchMode(1)

    --Bleed 0x41000083
    -- Color 0x41007E13
    -- Shield  0x41007E90
    -- Knockdown shield 0x4100823E
    -- Stun 0x4100823F
    -- Man line 0x410087B8
    -- Guard stance 0x410087B8
    -- Brown shield 0x410087B8
    -- SHield and sword 0x4112E312
    -- Yellow break ranks 0x411F5271

    self.duration = 0
    --self.textLabel:SetText("0")
end

function SmashingStabSlot:SetTimer(timer, maxTimer)
    self.duration = timer
end

function SmashingStabSlot:ExecuteUpdate(delta)
    self.duration = self.duration - delta

    local newNumber = math.round(self.duration)
    if newNumber == self.currentNumber then return end

    self.currentNumber = newNumber

    if self.duration < 0 then
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText("")
        return true
    end
    self.textLabel:SetStretchMode(nil)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetText(self.currentNumber)
    
end

function SmashingStabSlot:SetMode(action)

    if action == 0 then 
        self.smashingStabeState = 0 
        self.bleedLabel:SetVisible(false)
        self.stunLabel:SetVisible(false)
        self.fMLabel:SetVisible(false)
        return
    end

    if self.smashingStabeState == 3 then return end

    if action == 1 then
        --CJ
        if self.smashingStabeState == 2 then
            self.smashingStabeState = 3
        else
            -- Bleed
            self.smashingStabeState = 1
            self.bleedLabel:SetVisible(true)
        end
    elseif action == 2 then
        -- CJ
        if self.smashingStabeState == 1 then
            self.smashingStabeState = 3
        else
            -- Stun
            self.smashingStabeState = 2
            self.stunLabel:SetVisible(true)
        end
    end

    if self.smashingStabeState == 3 then
        self.bleedLabel:SetVisible(false)
        self.stunLabel:SetVisible(false)
        self.fMLabel:SetVisible(true)
    end
end

function SmashingStabSlot:ToggleVisible(value)
    self:SetVisible(value)
    self.IconLabel:SetVisible(value)
end

function SmashingStabSlot:Unload()
    self.fMLabel:Unload()
    self.stunLabel:Unload()
    self.bleedLabel:Unload()
    self.IconLabel:SetParent(nil)
    self.textLabel:SetParent(nil)
    self:SetParent(nil)
    self = nil
end
