VitalBar = class( Turbine.UI.Control )
function VitalBar:Constructor(width, height, showText, textAlignment, barAlignment)
    Turbine.UI.Control.Constructor( self )
    
    self:SetSize(width, height)
    self:SetZOrder(100)
    self:SetMouseVisible(false)

    --self.MaxValue = 100
    --self.CurrentValue = 0
    self.TempValue = 0
    self.MaxTempValue = 0
    self.DreadValue = 0

    self.NumberMethod = 1
    self.PercentageShown = false
    self.OnlyShowCurrent = true
    self.showText = showText


    self.CurrentImmediate = 0
    self.CurrentValue = Turbine.Animation.LerpValue()
	self.MaxValue = 0--Turbine.Animation.LerpValue()
    self.baseMax = 0--Turbine.Animation.LerpValue()

    self.barAlignment = barAlignment
    
    Background = "PrimePlugins/Vitals/Images/FittedSmooth.tga"

    --self:SetBackColor( Turbine.UI.Color( 1, 1, 0, 0 ) )
    
    -- The background bar that contains all other bars
    self.TotalBar = Turbine.UI.Control()
    self.TotalBar:SetParent(self)
    --self.TotalBar:SetSize(256, 32)
    --self.TotalBar:SetStretchMode(1)
    --self.TotalBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay )
    --self.TotalBar:SetBackground(Background)
    self.TotalBar:SetSize(width, height)
    self.TotalBar:SetMouseVisible(false)

    -- The current value of the display
    self.CurrentBar = Turbine.UI.Control()
    --self.CurrentBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay )
    self.CurrentBar:SetParent(self)
    self.CurrentBar:SetSize(0, height)
    self.CurrentBar:SetMouseVisible(false)

    -- Indicating morale loss/gain
    self.MoveBar = Turbine.UI.Control()
    --self.MoveBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.MoveBar:SetParent(self)
    self.MoveBar:SetSize(0, 0)
    self.MoveBar:SetMouseVisible(false)

    -- Bar to show temporary effects (bubbles)
    self.TemporaryBar = Turbine.UI.Control()
    --self.TemporaryBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.TemporaryBar:SetParent(self)
    self.TemporaryBar:SetSize(0, height)
    self.TemporaryBar:SetMouseVisible(false)

    -- Bar to show temporary effects negative (dread)
    self.DreadBar = Turbine.UI.Control()
    --self.DreadBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.DreadBar:SetParent(self)
    self.DreadBar:SetSize(0, 0)
    self.DreadBar:SetMouseVisible(false)

	-- The animation classes for smoothly moving the bars.

    -- The display text for the vitals bar.
    -- [[
    if self.showText then
        self.text = Turbine.UI.Label()
        self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1, 1 ) )
        self.text:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
        self.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
        self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold19 )
        if textAlignment == Turbine.UI.ContentAlignment.MiddleRight then
            self.text:SetPosition(-10, 0)
        end
        self.text:SetTextAlignment( textAlignment )
        self.text:SetZOrder( 100 )
        self.text:SetParent( self )
        self.text:SetSize(width, height)
        self.text:SetMouseVisible(false)
    end
    --]]

	--self.horizontalLayout = Turbine.UI.HorizontalLayout.LeftToRight
	self.showPercentage = false

	self.lastUpdate = 0

    self.ExecuteUpdate = function(delta)
        local newCurrent = self.CurrentValue:GetValue() - delta
        self:SetCurrentValue(newCurrent)
    
        if newCurrent < 0  then 
            if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
            self.updateCallback = nil
        end
    end
end

function VitalBar:SetColours(BackColour, BarColour, TempColour, DreadColour)
    self.TotalBar:SetBackColor(BackColour)
    self.CurrentBar:SetBackColor(BarColour)
    self.TemporaryBar:SetBackColor(TempColour)
    self.DreadBar:SetBackColor(DreadColour)
end

function VitalBar:SetMaxValue(value)
    self.MaxValue = value
    self.CurrentValue:SetRate( self.MaxValue / self:GetWidth() * 200 )
end

function VitalBar:SetCurrentValue(value)
    self.CurrentValue:SetValue(value)

    if ( self.CurrentValue:NeedsUpdate() ) then
		self:SetWantsUpdates( true )
	end
end

function VitalBar:SetCurrentValueImmediate(value)
    self.CurrentValue:SetValueImmediate(value)

    --if ( self.CurrentValue:NeedsUpdate() ) then
		self:SetWantsUpdates( true )
	--end
end

function VitalBar:SetTempValue(value)
    self.TempValue = value
    self:AdjustBars()
end

function VitalBar:SetMaxTempValue(value)
    self.MaxTempValue = value
    --self:AdjustBars()
end

function VitalBar:SetDreadValue(value)
    self.DreadValue = value
end

function VitalBar:Update( args )
	local delta = 0
	local currentTime = Turbine.Engine.GetGameTime()

	if ( self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate
	end

	self.lastUpdate = currentTime

	self.CurrentValue:Update( delta )
	--self.MaxValue:Update( delta )
	--self.baseMax:Update( delta )

        --[[
	local current = math.floor( self.CurrentValue:GetValue() + 0.5 ) 
	local max = math.floor( self.MaxValue:GetValue() + 0.5 ) 
    local baseMax = math.floor( self.baseMax:GetValue() + 0.5 ) 
    
	if ( self.showPercentage ) then
		local percentage = math.floor( ( current / max * 100 ) + 0.5 )
		self.text:SetText( percentage .. "%" )
	else
		self.text:SetText( current .. "/" .. max )
    end
    

	self:PerformLayout()

    --]]
	if not(self.CurrentValue:NeedsUpdate()) then
		self:SetWantsUpdates( false )
		self.lastUpdate = 0
    end
    
    self:AdjustBars()
end

function VitalBar:AdjustBars()

    local value = self.CurrentValue:GetValue()
    local totalWidth, currentHeight = self.TotalBar:GetSize()
    local totalHealthValue = self.MaxValue + self.TempValue
    local currentWidth = value / totalHealthValue * totalWidth

    self:UpdatePosition(currentWidth, totalWidth)

    --self.CurrentBar:SetBackColor(Turbine.UI.Color(0.4 + 0.6 - 0.6 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.5, 0.1))
    --self.TotalBar:SetBackColor(Turbine.UI.Color(0.4 + 0.6 - 0.6 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.7 - 0.3 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.1))

    --if self.TempValue > 0 then 
        --self.TemporaryBar:SetWidth(math.ceil(self.TempValue / totalHealthValue * totalWidth))
        --self.TemporaryBar:SetPosition(currentWidth, 0)
    --end

    if self.showText then
        local tempString = ""

        if self.TempValue > 0 then
            tempString = " (+" ..  self:FormatNumber(math.ceil(self.TempValue)) .. ") " 
        end

        self.text:SetText(  self:GetHealthString(value) .. tempString .. self:FormatPercentage(value))
    end
end

function VitalBar:UpdatePosition(currentWidth, totalWidth)
    self.CurrentBar:SetWidth(math.ceil(currentWidth))
    if self.barAlignment == 1 then
        self.CurrentBar:SetLeft(totalWidth / 2 - currentWidth / 2)
    end
end

function VitalBar:SetTextVisible(value)
    if self.text then self.text:SetVisible(value) end
end

function VitalBar:FormatNumber(number) 
    if self.NumberMethod == 1 then
        return number
    elseif self.NumberMethod == 2 then
        return FormatBigNumber(number)
    end
end

function VitalBar:GetHealthString(value)
    if self.OnlyShowCurrent then
        return self:FormatNumber(math.floor( value+ 0.5 ))
    else
        return self:FormatNumber(math.floor( value + 0.5 ))  .. "/" .. self:FormatNumber(math.floor( self.MaxValue + 0.5 ))
    end
end

function VitalBar:FormatPercentage(value) 
    if self.PercentageShown then
        return " - " .. math.floor(value / self.MaxValue * 100) .. "%"
    else
        return ""
    end
end

function VitalBar:SetCurrentWithUpdate(value)
    self:SetCurrentValueImmediate(value)
    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
end

function VitalBar:Unload()
    self:SetVisible(false)
    self:SetParent(nil)
end
-------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------

ValueBar = class( Turbine.UI.Control )
function ValueBar:Constructor(parent, width, height, x, y, barAlignment, barColour, backgroundColour, maxValue, barName, vertical, afterAnimation, visibitilityThreshold, stopAutoUpdate)
    Turbine.UI.Control.Constructor( self )

    self:SetParent(parent)
    
    self:SetSize(width, height)
    --self:SetZOrder(100)
    self:SetMouseVisible(false)
    self:SetPosition(x, y)

    self.baseColour = backgroundColour

    --self.backgroundImage:SetStretchMode(1)
    --self.backgroundImage:SetSize(width, height)
    --self.backgroundImage:SetOpacity(0.4)

    --self.MaxValue = 100
    --self.CurrentValue = 0
    self.TempValue = 0
    self.MaxTempValue = 0

    self.widthChange = -999

    self.width = width
    self.height = height

    self.visibitilityThreshold = visibitilityThreshold or 999999

    self.vertical = vertical

    self.animation = false
    self.afterAnimation = afterAnimation

    self.delta = 0

    self.NumberMethod = 1
    self.PercentageShown = false
    self.OnlyShowCurrent = true
    self.barColour = barColour

    self.stopAutoUpdate = stopAutoUpdate

    self.CurrentImmediate = 0
    self.CurrentValue = 0--Turbine.Animation.LerpValue()
    self.MaxValue = maxValue--Turbine.Animation.LerpValue()
    self.baseMax = 0--Turbine.Animation.LerpValue()

    self.barAlignment = barAlignment

    if barName then
        self.bar = BackgroundHandler:GetBarTextureData()[barName]
    end
    
    -- The background bar that contains all other bars
    self.TotalBar = Turbine.UI.Window()
    self.TotalBar:SetParent(self)
    self.TotalBar:SetMouseVisible(false)
    self.TotalBar:SetVisible(true)

    if barName then
        self.TotalBar:SetSize(self.bar[2], self.bar[3])
        self.TotalBar:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
        self.TotalBar:SetBackground(BackgroundHandler:GetBackground(self.bar[1]))
    end

    self.TotalBar:SetBackColor(self.baseColour)
    self.TotalBar:SetStretchMode(1)
    self.TotalBar:SetSize(width, height)
    self.TotalBar:SetVisible(self.baseColour ~= nil)

    -- The current value of the display
    self.CurrentBar = Turbine.UI.Window()
    self.CurrentBar:SetParent(self)
    self.CurrentBar:SetVisible(true)

    if barName then
        self.CurrentBar:SetSize(self.bar[2], self.bar[3])
        self.CurrentBar:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
        self.CurrentBar:SetBackground(BackgroundHandler:GetBackground(self.bar[1]))
    end

    self.CurrentBar:SetMouseVisible(false)
    self.CurrentBar:SetBackColor(self.barColour)
    self.CurrentBar:SetStretchMode(1)
    self.CurrentBar:SetSize(0, 0)
    --self.CurrentBar:SetSize(width, height)

    self.ExecuteUpdate = function( delta )
        self.CurrentValue = self.CurrentValue - delta

        self:SetVisible(self.CurrentValue < self.visibitilityThreshold)
    
        if self.CurrentValue < 0 then
            if not(self.animation) then
                if self.afterAnimation then
                    self.animation = true
                    self:Animation()
                else
                    self.animation = false
                    self.CurrentBar:SetOpacity(1)
                    if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
                    self.updateCallback = nil
                end
            end
            if self.CurrentValue < -1 then
                self.animation = false
                self.CurrentBar:SetOpacity(1)
                if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
                self.updateCallback = nil
            end
        end
    
        if self.animation then
            self:Animate()
        else
            self:AdjustBars()
        end
    end
end

function ValueBar:SetMaxValue(value)
    self.MaxValue = value
end

function ValueBar:SetCurrentValue(value)
    self.CurrentValue = value

    self.CurrentBar:SetVisible(true)
    self.animation = false
    self.CurrentBar:SetOpacity(1)

    if not(self.updateCallback) and not(self.stopAutoUpdate) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
    if self.stopAutoUpdate then
        self:AdjustBars()
    end
end


function ValueBar:AdjustBars()

   local currentWidth = self.CurrentValue / (self.MaxValue + self.TempValue)

    if self.vertical then
        currentWidth = currentWidth * self.height
    else         
        currentWidth = currentWidth * self.width
    end

    if self.barAlignment == 1 then
        local newWidth = math.ceil(currentWidth)

        if math.abs(self.widthChange - newWidth) > 1 or newWidth == 0 or self.widthChange == -999 then
            if self.vertical then
                self.CurrentBar:SetSize(self.width, newWidth)
                self.CurrentBar:SetTop(math.ceil( (self.height - currentWidth) / 2))
            else
                self.CurrentBar:SetSize(newWidth, self.height)
                self.CurrentBar:SetLeft(math.ceil( (self.width - currentWidth) / 2))
            end
            self.widthChange = newWidth
        end

    elseif self.barAlignment == 2 then
        if self.vertical then
            self.CurrentBar:SetSize(self.width, math.ceil(currentWidth))
            self.CurrentBar:SetTop(self.height - math.ceil(currentWidth))
        else
            self.CurrentBar:SetSize(math.ceil(currentWidth), self.height)
            self.CurrentBar:SetLeft(self.width - math.ceil(currentWidth))
        end
    else
        if self.vertical then
            self.CurrentBar:SetSize(self.width, math.ceil(currentWidth))
        else
            self.CurrentBar:SetSize(math.ceil(currentWidth), self.height)
        end
    end
end

function ValueBar:Unload()
    self:SetVisible(false)
    self:SetParent(nil)
end

function ValueBar:ToggleBar(value)
    if value then
        self.CurrentBar:SetSize(self.width, self.height)
    else
        self.CurrentBar:SetSize(0, 0)
    end
end

function ValueBar:Animation()
    self.animation = true
    self.CurrentBar:SetSize(self.width, self.height)
end

function ValueBar:Animate()
    self.CurrentBar:SetOpacity(1 + self.CurrentValue)
end

---------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------


PermanentBar = class( Turbine.UI.Control )
function PermanentBar:Constructor(parent, x, y, width, height, textFormat, textAlignment, barAlignment, barColours, barbackground, font, intervalColour, intervals)
    Turbine.UI.Control.Constructor( self )
    
    self:SetParent(parent)
    self:SetSize(width, height)
    self:SetPosition(x, y)
    self:SetZOrder(100)
    self:SetMouseVisible(false)

    self.TempValue = 0
    self.MaxTempValue = 0

    self.NumberMethod = 1
    self.PercentageShown = false
    self.OnlyShowCurrent = true
    self.textFormat = textFormat
    self.textAlignment = textAlignment or Turbine.UI.ContentAlignment.MiddleCenter


    self.CurrentImmediate = 0
    self.CurrentValue = Turbine.Animation.LerpValue()
	self.MaxValue = 0--Turbine.Animation.LerpValue()
    self.baseMax = 0--Turbine.Animation.LerpValue()

    self.barAlignment = barAlignment
    
    if barbackground then
        self.bar = BackgroundHandler:GetBarTextureData()[barbackground]
        self.Background = self.bar[1]
    else
        self.Background = "PrimePlugins/Vitals/Images/FittedSmooth.tga"
    end

    self.font = font
    if not(self.font) then
        self.font = Turbine.UI.Lotro.Font.BookAntiquaBold19
    end

    --self:SetBackColor( Turbine.UI.Color( 1, 1, 0, 0 ) )
    
    -- The background bar that contains all other bars
    self.TotalBar = Turbine.UI.Control()
    self.TotalBar:SetParent(self)
    self.TotalBar:SetSize(width, height)
    --self.TotalBar:SetStretchMode(1)
    --self.TotalBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay )
    self.TotalBar:SetBackground(BackgroundHandler:GetBackground(Background))
    self.TotalBar:SetSize(width, height)
    self.TotalBar:SetMouseVisible(false)
    self.TotalBar:SetBackColor(barColours[1])


    -- The current value of the display
    self.CurrentBar = Turbine.UI.Control()
    --self.CurrentBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay )
    self.CurrentBar:SetParent(self)
    self.CurrentBar:SetSize(width, height)
    self.CurrentBar:SetBackground(BackgroundHandler:GetBackground(Background))
    self.CurrentBar:SetMouseVisible(false)
    self.CurrentBar:SetBackColor(barColours[2])


    -- Bar to show temporary effects (bubbles)
    self.TemporaryBar = Turbine.UI.Control()
    --self.TemporaryBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.TemporaryBar:SetParent(self)
    self.TemporaryBar:SetSize(0, height)
    self.TemporaryBar:SetMouseVisible(false)
    self.TemporaryBar:SetBackColor(barColours[3])

    if intervals and intervals > 0 then
        self.intervalLines = {}
        for i = 1, intervals, 1 do
            self.intervalLines[i] = Turbine.UI.Control()
            self.intervalLines[i]:SetParent(self)
            self.intervalLines[i]:SetSize(2, height)
            self.intervalLines[i]:SetMouseVisible(false)
            self.intervalLines[i]:SetBackColor(intervalColour)
            self.intervalLines[i]:SetPosition(i * ((width) / (intervals)), 0)
        end
    end    

    -- The display text for the vitals bar.
    self.text = Turbine.UI.Label()
    self.text:SetForeColor(Turbine.UI.Color(1, 1, 1, 1 ))
    self.text:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0 ))
    self.text:SetFontStyle( Turbine.UI.FontStyle.Outline)
    self.text:SetFont(self.font)
    self.text:SetTextAlignment(self.textAlignment)
    self.text:SetZOrder(100)
    self.text:SetParent(self)
    if height > 20 and width > 20 then
        self.text:SetPosition(2,2)
        self.text:SetSize(width - 4, height - 4)
    else
        self.text:SetSize(width, height)
    end
    self.text:SetMouseVisible(false)

	self.lastUpdate = 0

    self.ExecuteUpdate = function(delta)
        local newCurrent = self.CurrentValue:GetValue() - delta
        self:SetCurrentValue(newCurrent)
    
        if newCurrent < 0  then 
            if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
            self.updateCallback = nil
        end
    end
end

function PermanentBar:SetMaxValue(value)
    self.MaxValue = value
    self.CurrentValue:SetRate( self.MaxValue / self:GetWidth() * 200 )
end

function PermanentBar:SetCurrentValue(value)
    self.CurrentValue:SetValue(value)

    if ( self.CurrentValue:NeedsUpdate() ) then
		self:SetWantsUpdates( true )
	end
end

function PermanentBar:SetCurrentValueImmediate(value)
    self.CurrentValue:SetValueImmediate(value)

    --if ( self.CurrentValue:NeedsUpdate() ) then
		self:SetWantsUpdates( true )
	--end
end

function PermanentBar:SetTempValue(value)
    self.TempValue = value
    self:AdjustBars()
end

function PermanentBar:SetMaxTempValue(value)
    self.MaxTempValue = value
    --self:AdjustBars()
end

function PermanentBar:SetDreadValue(value)
    self.DreadValue = value
end

function PermanentBar:Update( args )
	local delta = 0
	local currentTime = Turbine.Engine.GetGameTime()

	if ( self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate
	end

	self.lastUpdate = currentTime

	self.CurrentValue:Update( delta )

	if not(self.CurrentValue:NeedsUpdate()) then
		self:SetWantsUpdates( false )
		self.lastUpdate = 0
    end
    
    self:AdjustBars()
end

function PermanentBar:AdjustBars()

    local value = self.CurrentValue:GetValue()
    local totalWidth, currentHeight = self.TotalBar:GetSize()
    local totalHealthValue = self.MaxValue + self.TempValue
    local currentWidth = value / totalHealthValue * totalWidth

    local tempWidth
    if self.TempValue > 0 then
        tempWidth = self.TempValue / totalHealthValue * totalWidth
    end

    self:UpdatePosition(currentWidth, totalWidth, tempWidth)

    local current = self.CurrentValue:GetTargetValue()

    --self.text:SetText(string.format(self.textFormat, value, totalHealthValue, value/totalHealthValue * 100))
    if self.MaxValue and current and current > 0 and self.MaxValue > 0 then
        local tempString = ""

        if self.TempValue > 0 then
            tempString = " (+" ..  FormatBigNumberVitals(math.ceil(self.TempValue)) .. ") " 
        end
        self.text:SetText(string.gsub(string.gsub(string.gsub(self.textFormat, 
                    "<current>", FormatBigNumberVitals(current)),  
                    "<total>",  FormatBigNumberVitals(self.MaxValue)), 
                    "<percentage>", Round(current/self.MaxValue * 100,2)) ..
                    tempString
                )
    else
        self.text:SetText(string.gsub(string.gsub(string.gsub(self.textFormat, 
        "<current>", 0),  
        "<total>",  0), 
        "<percentage>", 100.0)
    )
    end
    --self.text:SetText(  self:GetHealthString(value) .. tempString .. self:FormatPercentage(value))
end

function PermanentBar:UpdatePosition(currentWidth, totalWidth, tempWidth)
    self.CurrentBar:SetWidth(currentWidth)
    self.TemporaryBar:SetLeft(currentWidth)
    self.TemporaryBar:SetWidth(tempWidth or 0)
    
    if self.barAlignment == 1 then
        self.CurrentBar:SetLeft(totalWidth / 2 - currentWidth / 2)
    end
end

function PermanentBar:SetTextVisible(value)
    if self.text then self.text:SetVisible(value) end
end

function PermanentBar:FormatNumber(number) 
    if self.NumberMethod == 1 then
        return number
    elseif self.NumberMethod == 2 then
        return FormatBigNumber(number)
    end
end

function PermanentBar:GetHealthString(value)
    if self.OnlyShowCurrent then
        return self:FormatNumber(math.floor( value+ 0.5 ))
    else
        return self:FormatNumber(math.floor( value + 0.5 ))  .. "/" .. self:FormatNumber(math.floor( self.MaxValue + 0.5 ))
    end
end

function PermanentBar:FormatPercentage(value) 
    if self.PercentageShown then
        return " - " .. math.floor(value / self.MaxValue * 100) .. "%"
    else
        return ""
    end
end

function PermanentBar:SetCurrentWithUpdate(value)
    self:SetCurrentValueImmediate(value)
    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
end

function PermanentBar:Unload()
    self:SetVisible(false)
    self:SetParent(nil)
end