CountdownWindow = class(Turbine.UI.Window)
function CountdownWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    local width = Settings.CWidth
    local height = Settings.CHeight
    local x = Settings.CX
    local y = Settings.CY
    self.cooldownTimer = -100
    self.lastNumber = -100
    self.minShow = 99999

    self:SetSize(width,height)
    self:SetPosition(x,y)
    self:SetZOrder(1)

    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(false)
    self:SetVisible(true)

    self.sounds = Sounds:GetSoundList()

    self.countdownBox = Turbine.UI.Label()
    self.countdownBox:SetParent(self)
    self.countdownBox:SetSize(width, height - 20)
    self.countdownBox:SetPosition(0,20)
    self.countdownBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.countdownBox:SetFont(Settings.CFont)
    self.countdownBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.countdownBox:SetMouseVisible(false)
    self.countdownBox:SetVisible(false)

    local moveBox = MoveBox(self, width, height, "Countdown")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.GetCountdown = function()
        return(self.cooldownTimer)
    end

    self.ExecuteUpdate = function(delta)
        self.cooldownTimer = self.cooldownTimer - delta
        local wholeNumber = math.ceil(self.cooldownTimer)
        self:SetZOrder(1)
    
        if wholeNumber ~= self.lastNumber then
            
            -- Handle < 5 colour change
            if(wholeNumber <= 5) then
                self.countdownBox:SetForeColor(Turbine.UI.Color(.40,.0,.0))
            else
                self.countdownBox:SetForeColor(Turbine.UI.Color(.95,.67,.04))
            end

            if self.cooldownTimer <= self.minShow then
                self.countdownBox:SetVisible(true)

                if (wholeNumber <= 10) then
                    if self.sounds[tostring(wholeNumber)] ~= nil then
                        Sounds:PlaySoundEffect(self.sounds[tostring(wholeNumber)])
                    end
                end
            end
        
            --if (wholeNumber == 0) then
                --self.countdownBox:SetText("GO")
                --ChatOutput("GO")
            --end
        
            if (wholeNumber >= 1) then
                self.countdownBox:SetText(wholeNumber)
                --ChatOutput(self.cooldownTimer)
            else
                self.countdownBox:SetVisible(false)
                --self:SetWantsUpdates(false)
                RemoveCallback(Updater, "ExecuteUpdate", self.callback)
                self.callback = nil
            end
            
            self.lastNumber = wholeNumber
        end
    end


end

function CountdownWindow:Countdown(duration, minShow)
    self.cooldownTimer = duration
    self.lastNumber = duration + 1
    self.countdownBox:SetText(math.ceil(self.cooldownTimer))
    if minShow then
        self.minShow = minShow
    else
        self.minShow = self.lastNumber
    end
    if(math.ceil(self.cooldownTimer) <= 5) then
        self.countdownBox:SetForeColor(Turbine.UI.Color(.40,.0,.0))
    else
        self.countdownBox:SetForeColor(Turbine.UI.Color(.95,.67,.04))
    end

    self.countdownBox:SetVisible(self.cooldownTimer <= self.minShow)
    --countdownWindow:SetWantsUpdates(true)
    if not(self.callback) then  self.callback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
end