DNFTracker = class(Turbine.UI.Control)
function DNFTracker:Constructor(ReloadStateData)
    Turbine.UI.Control.Constructor(self)
    
    assert(Updater ~= nil, "Update hanlder is not loaded")
    assert(GroupEffectsHandler ~= nil, "Group effects handler is not loaded")
    assert(ChatEventHandler ~= nil, "Parser is not loaded")

    self.DNFS = {}

    if ReloadStateData ~= nil and ReloadStateData.DNFS ~= nil then
        self.DNFS = ReloadStateData.DNFS
    end

    self.GetDNFS = function()
        return(self.DNFS)
    end
    
    self.lowestEvent = 2147483647
    self.lowestName = ""


    for name, time in pairs(self.DNFS) do
        if time < self.lowestEvent then
            self.lowestEvent = time
            self.lowestName = name
        end
    end

    self.DNFEvent = function(sender, event, args)
        if type(event)=="function" then
            event(args)
        else
            if type(event)=="table" then
                for i=1,#event do
                    if type(event[i])=="function" then
                        event[i](args)
                    end
                end
            end
        end
    end

    self.ExecuteUpdate = function()
        if self.lowestEvent <= Turbine.Engine.GetGameTime() then
            for key, _ in pairs(self.DNFS) do
                if key == self.lowestName then
                    self.DNFS[self.lowestName] = nil
                    self.DNFEvent(self, self.DNFRemoval, {["Name"] = self.lowestName})
                    if tablelength(self.DNFS) > 0 then
                        for name, time in pairs(self.DNFS) do
                            if time < self.lowestEvent then
                                self.lowestEvent = time
                                self.lowestName = name
                            end
                        end
                    else
                        self.lowestEvent = 2147483647
                        self.lowestName = ""
                        if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
                        self.updateCallback = nil
                    end
                    break
                end
            end
        end
    end

    self.DNFstring = "Do Not Fall This Day"

    self.dnfCallback = AddCallback(GroupEffectsHandler, "EffectAdded", function(args)
        if args["effect"].Name == self.DNFstring then
            self:DNFApplied(args.name, args.effect.StartTime + args.effect.Duration, args.effect.Duration)
        end
    end)

    self.defeatCallback = AddCallback(ChatEventHandler, "Defeated", function(args)
        if args.Name and args.Name then
            self:Death(args.Name)
        end
    end)
end

function DNFTracker:GetDNFInfo()
    return self.DNFS
end

function DNFTracker:DNFApplied(name, time, effectDuration)
    self.DNFS[name] = time

    if self.lowestName == name then self.lowestEvent = time end

    for key, value in pairs(self.DNFS) do
        if value < self.lowestEvent then
            self.lowestEvent = value
            self.lowestName = key
        end
    end

    if not(self.updateCallback) then
        self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) 
    end

    self.DNFEvent(self, self.DNFApplication, {["Name"] = name, ["Time"] = effectDuration})
end

function DNFTracker:Death(name)
    if name and self.DNFS[name] and self.DNFS[name] > Turbine.Engine.GetGameTime() then 
        local messageWindow = EventWindows:GetAlertWindow()
        if messageWindow then
            messageWindow:Message(8, string.format("DNF on: <rgb=#009900>%s</rgb>", name), 1091454172, false)
        end
        self.DNFEvent(self, self.DNFRemoval, {["Name"] = name})
        self.DNFS[name] = nil

        if tablelength(self.DNFS) > 0 then
            for dnfName, time in pairs(self.DNFS) do
                if time < self.lowestEvent then
                    self.lowestEvent = time
                    self.lowestName = dnfName
                end
            end
        else
            self.lowestEvent = 2147483647
            self.lowestName = ""
            if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
            self.updateCallback = nil
        end
    end
end

function DNFTracker:HasDNF(name)
    return (self.DNFS[name] and self.DNFS[name] > Turbine.Engine.GetGameTime())
end