
IconViewerWindow = class(Turbine.UI.Window)
function IconViewerWindow:Constructor(data)
    Turbine.UI.Window.Constructor(self)
    self:SetSize(490, 400)
    self:SetPosition(300, 215)
    self:SetVisible(true)
    self:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.currentItem = 1

    self.VisibleChanged = function()
        if self:IsVisible() then
            self:SetZOrder(100)
            local x, y = self:GetMousePosition()
            local oldX, oldY = self:GetPosition()
            self:SetPosition((x + oldX) - 250, y + oldY + 5)
        end
    end

    self.IconWindowHeaderLabel = Turbine.UI.Label()
    self.IconWindowHeaderLabel:SetParent(self)
    self.IconWindowHeaderLabel:SetSize(490 - 2, 20 - 1)
    self.IconWindowHeaderLabel:SetPosition(1, 1)
    --self.IconWindowHeaderLabel:SetMouseVisible(false)
    --self.IconWindowHeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    self.IconWindowHeaderLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.IconWindowHeaderLabel:SetMultiline(true)
    self.IconWindowHeaderLabel:SetText("Icon selection")

    
    self.Moving = false

    self.IconWindowHeaderLabel.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.IconWindowHeaderLabel.MouseUp = function()
        self.Moving = false
    end

    self.IconWindowHeaderLabel.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    -- Close Button
    self.IconCloseBackground = Turbine.UI.Control()
    self.IconCloseBackground:SetParent(self)
    self.IconCloseBackground:SetPosition(490 - 20, 0)
    self.IconCloseBackground:SetSize(20, 20)
    self.IconCloseBackground:SetMouseVisible(true)
    self.IconCloseBackground:SetBackColor(Turbine.UI.Color(153/255, 0, 0))


    self.IconCloseBackground.MouseClick = function()
        self:SetVisible(false)
    end

    self.iconListBox = Turbine.UI.ListBox()
    self.iconListBox:SetSize(32, 32)
    self.iconListBox:SetPosition(1, 21)
    self.iconListBox:SetParent(self)
    self.iconListBox:SetMouseVisible(false)
    self.iconListBox:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    self.iconListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
    self.iconListBox:SetMaxColumns(15)

    self.iconListBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.iconListBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.iconListBoxScrollbar:SetParent(self)
    self.iconListBoxScrollbar:SetPosition(480, 21)
    self.iconListBoxScrollbar:SetSize(10, 378)
    self.iconListBox:SetVerticalScrollBar(self.iconListBoxScrollbar)

    self.searchBox = Turbine.UI.Lotro.TextBox()
    self.searchBox:SetParent(self)
    self.searchBox:SetSize(250, 19)
    self.searchBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.searchBox:SetPosition(250 - 20 - 1, 1)

    self.searchBox.TextChanged = function()
        self.filterKey = self.searchBox:GetText()
        self.allVisible = string.len(self.filterKey) < 1
        for i = 1, self.iconListBox:GetItemCount(), 1 do
            local object = self.iconListBox:GetItem(i)
            if self.allVisible then
                object:SetVisible(true)
            else
                object:SetVisible(string.find(string.lower(object.name), string.lower(self.filterKey)))
            end
        end
    end

    local iconControlList = {}
    local whiteList = {}
    for key, value in pairs(data) do

        table.insert(iconControlList, key)

        --self.iconListBox:AddItem(icon)
    end

    local icon = Turbine.UI.Control()
    icon:SetParent(self)
    icon:SetSize(32,32)
    icon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    icon:SetBackground(BackgroundHandler:GetBackground(iconControlList[self.currentItem]))
    icon:SetMouseVisible(true)
    icon:SetVisible(true)
    icon.name = self.currentItem

    icon.MouseClick = function(sender, args)
        if args.Button == 1 then
            ChatOutput("Left")
            whiteList[iconControlList[self.currentItem]] = true
        elseif args.Button == 2 then
            ChatOutput("Right")
        elseif args.Button == 3 then
            ChatOutput("Middle")
        end

        self.currentItem = self.currentItem + 1
        if iconControlList[self.currentItem] then
            icon:SetBackground(BackgroundHandler:GetBackground(iconControlList[self.currentItem]))
        else
            icon:SetVisible(false)
            ChatOutput("Saving")
            SaveTable(Turbine.DataScope.Account, "CorrectIcons", whiteList)
        end
        --self:SetVisible(false)
    end

    local icon2 = Turbine.UI.Control()
    icon2:SetParent(self)
    icon2:SetSize(32,32)
    icon2:SetPosition(100, 100)
    icon2:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    icon2:SetBackground(BackgroundHandler:GetBackground(0x41000000))
    icon2:SetMouseVisible(true)
    icon2:SetVisible(true)

    icon2.MouseClick = function(sender, args)
        ChatOutput("Saving")
        SaveTable(Turbine.DataScope.Account, "CorrectIcons", whiteList)
    end
end
