ChatAlertSettings = class(Turbine.UI.Control)
function ChatAlertSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(0,-30)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local colorTurn = 0
    local prevItem = nil
    local prevColour = nil
    local prevControl = nil
    local selectedName = nil   
    local selectedPhrase = nil 

    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(700, 80)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(10, 455)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("*: Names are approximate due to not recognising most special characters, this is handeled automatically. Reload the plugin to see the effects of your actions.\n**: Phrases can be a smaller part of the entire phrase since some phrases are represented differently and thus can be missed")

    self.ChatLabelItem = function(box, name, alert, ph)
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 600, 100 )
        listItem:SetMouseVisible(true)
        local colourddd = 0.125 + colorTurn * 0.125
        listItem:SetBackColor(Turbine.UI.Color(colourddd, colourddd, colourddd))
        if colorTurn == 1 then
            colorTurn = 0
        else
            colorTurn = 1
        end

        
        local SingleBackground = Turbine.UI.Control()
        SingleBackground:SetParent(listItem)
        --SingleBackground:SetPosition(550 - 2, 240 - 2)
        SingleBackground:SetSize(600, 100)
        SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))
        SingleBackground:SetMouseVisible(false)

        local SingleBackground = Turbine.UI.Control()
        SingleBackground:SetParent(listItem)
        SingleBackground:SetPosition(2, 2)
        SingleBackground:SetSize(600 - 4, 100 - 4)
        SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
        SingleBackground:SetMouseVisible(false)
        --listItem:SetBackColor(GetRandomColour())
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(600, 20)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetPosition(4, 2)
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetText("<rgb=#0071b8>Approximate source:</rgb> <rgb=#FF9900>" .. name)

        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(600, 20)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetPosition(4, 40)
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetText("<rgb=#0071b8>Key phrase: </rgb><rgb=#FF9900>" .. ph)

        local AlertLabel  = Turbine.UI.Label()
        AlertLabel:SetParent(listItem)
        AlertLabel:SetSize(200, 20)
        AlertLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        AlertLabel:SetMouseVisible(false)
        AlertLabel:SetMultiline(false)
        AlertLabel:SetPosition(4, 80)
        AlertLabel:SetMarkupEnabled(true)
        AlertLabel:SetText("<rgb=#0071b8>Alert:</rgb> <rgb=#FF9900>" .. alert[2])
        --AlertLabel:SetPosition(400, 20)

        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(100, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(4, 20)
        DurationLabel:SetMarkupEnabled(true)
        DurationLabel:SetText("<rgb=#0071b8>Duration:</rgb> <rgb=#FF9900>" .. alert[1])

        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(200, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(100, 20)
        DurationLabel:SetMarkupEnabled(true)
        local yesno = nil
        if alert[4] then
            yesno = "<rgb=#00FF00>yes"
        else
            yesno = "<rgb=#FF0000>no"
        end 
        DurationLabel:SetText("<rgb=#0071b8>Countdown Shown:</rgb> " .. yesno)

        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(300, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(250, 20)
        DurationLabel:SetMarkupEnabled(true)
        if alert[5] ~= nil then 
            DurationLabel:SetText("<rgb=#0071b8>Soundeffect: <rgb=#00FF00>" .. alert[5])
        else
            DurationLabel:SetText("<rgb=#0071b8>Soundeffect: <rgb=#FF0000>No Soundeffect")
        end

        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(200, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(450, 00)
        DurationLabel:SetMarkupEnabled(true)
        local yesno = nil
        if alert[6] then
            yesno = "<rgb=#00FF00>yes"
        else
            yesno = "<rgb=#FF0000>no"
        end 
        DurationLabel:SetText("<rgb=#0071b8>Targetbox Shown:</rgb> " .. yesno)

        listItem.MouseClick = function()
            if prevControl then
                prevControl:SetBackColor(prevColour)
            end
            prevItem = listItem
            prevControl = SingleBackground
            prevColour = prevControl:GetBackColor()
            SingleBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
            selectedName = name
            selectedPhrase = ph
        end

        return (listItem)
    end

    self.CreateChatItem = function(box, name, effect, ph)
        box:AddItem( self.ChatLabelItem(box, name, effect, ph) )
    end

    local SelfEffects = Turbine.UI.Control()
    SelfEffects:SetSize(width, height - 100)
    SelfEffects:SetParent(self)
    SelfEffects:SetPosition(0, 40)

    local container = Turbine.UI.ListBox()
    container:SetParent(SelfEffects)
    container:SetSize(600, height - 300)
    container:SetPosition(30, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( SelfEffects )
    containerScrollbar:SetPosition( 630 - 10, 50 )
    containerScrollbar:SetSize( 10, height - 300 )
    container:SetVerticalScrollBar( containerScrollbar )

    local sortedEffects = {}
    for key, value in pairs(A) do table.insert( sortedEffects,key ) end
    table.sort( sortedEffects )

    for key, value in pairs(sortedEffects) do
        for key2, value2 in pairs(A[value]) do
            self.CreateChatItem(container, value, value2, key2)
        end
    end

    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(200, 30)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    InfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    InfoLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(30, 300)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("Add custom alert")

    -- Duration

    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(200, 30)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    InfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    InfoLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(30, 330)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("Alert duration in seconds")

    local ItemTextBox3 = Turbine.UI.Lotro.TextBox()
    ItemTextBox3:SetParent(self)
    ItemTextBox3:SetSize(50, 30)
    ItemTextBox3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox3:SetMouseVisible(false)
    ItemTextBox3:SetPosition(210, 330)
    ItemTextBox3:SetMultiline(false)

    -- Source
    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(100, 30)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    InfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    InfoLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(270, 330)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("Chat source*")

    local ItemTextBox0 = Turbine.UI.Lotro.TextBox()
    ItemTextBox0:SetParent(self)
    ItemTextBox0:SetSize(300, 30)
    ItemTextBox0:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox0:SetMouseVisible(false)
    ItemTextBox0:SetPosition(360, 330)
    ItemTextBox0:SetMultiline(false)

    -- Key phrase

    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(200, 30)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    InfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    InfoLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(30, 360)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("Key Phrase**")

    local ItemTextBox = Turbine.UI.Lotro.TextBox()
    ItemTextBox:SetParent(self)
    ItemTextBox:SetSize(400, 60)
    ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox:SetMouseVisible(false)
    ItemTextBox:SetPosition(120, 360)
    ItemTextBox:SetMultiline(true)

    -- Alert
    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(200, 30)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    InfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    InfoLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(30, 420)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("Alert")

    local ItemTextBox2 = Turbine.UI.Lotro.TextBox()
    ItemTextBox2:SetParent(self)
    ItemTextBox2:SetSize(400, 30)
    ItemTextBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox2:SetMouseVisible(false)
    ItemTextBox2:SetMultiline(false)
    ItemTextBox2:SetPosition(90, 420)

    -- Countdown
    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(200, 30)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    InfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    InfoLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(530, 360)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("Countdown")

    local CountdownButton = Turbine.UI.Lotro.Button()
    CountdownButton:SetParent(self)
    CountdownButton:SetSize(100, 30)
    CountdownButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    CountdownButton:SetMouseVisible(true)
    CountdownButton:SetPosition(610, 367)
    CountdownButton:SetText("No")

    CountdownButton.Click = function()
        if CountdownButton:GetText() == "No" then
            CountdownButton:SetText("Yes")
        else
            CountdownButton:SetText("No")
        end
    end

    -- Sound effects
    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(200, 30)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    InfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    InfoLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(530, 390)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("Sound Effect")

    local menu = Turbine.UI.ContextMenu()

    local SoundeffectButton = Turbine.UI.Lotro.Button()
    SoundeffectButton:SetParent(self)
    SoundeffectButton:SetSize(100, 15)
    SoundeffectButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SoundeffectButton:SetMouseVisible(true)
    SoundeffectButton:SetPosition(620, 397)
    SoundeffectButton:SetText("SoundEffect")

    SoundeffectButton.Click = function()
        menu:ShowMenu()
    end

    local menuItems = menu:GetItems()
    for key, value in pairs( Sounds:GetSoundList() ) do
        local menuItem = Turbine.UI.MenuItem( key )
        menuItems:Add(menuItem)
        menuItem.Click = function()
            SoundeffectButton:SetText(key)
        end
        --ChatOutput(fontName)
    end

    -- Target Box 
    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(200, 30)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    InfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    InfoLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(530, 420)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("Target Box")

    local CountdownButton2 = Turbine.UI.Lotro.Button()
    CountdownButton2:SetParent(self)
    CountdownButton2:SetSize(100, 30)
    CountdownButton2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    CountdownButton2:SetMouseVisible(true)
    CountdownButton2:SetPosition(610, 427)
    CountdownButton2:SetText("No")

    CountdownButton2.Click = function()
        if CountdownButton2:GetText() == "No" then
            CountdownButton2:SetText("Yes")
        else
            CountdownButton2:SetText("No")
        end
    end

    local CreateButton = Turbine.UI.Lotro.Button()
    CreateButton:SetParent(self)
    CreateButton:SetSize(100, 15)
    CreateButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    CreateButton:SetMouseVisible(true)
    CreateButton:SetPosition(200, 307)
    CreateButton:SetText("Make Alert")

    local FailLabel = Turbine.UI.Label()
    FailLabel:SetParent(self)
    FailLabel:SetSize(200, 30)
    FailLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    FailLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    FailLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    FailLabel:SetMouseVisible(false)
    FailLabel:SetPosition(330, 300)
    FailLabel:SetVisible(false)
    FailLabel:SetMarkupEnabled(true)
    FailLabel:SetText("<rgb=#FF0000>One or more fields invalid!")

    local SuccessLabel = Turbine.UI.Label()
    SuccessLabel:SetParent(self)
    SuccessLabel:SetSize(200, 30)
    SuccessLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    SuccessLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SuccessLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    SuccessLabel:SetMouseVisible(false)
    SuccessLabel:SetPosition(330, 300)
    SuccessLabel:SetMarkupEnabled(true)
    SuccessLabel:SetVisible(false)
    SuccessLabel:SetText("<rgb=#00FF00>Chat alert added")

    CreateButton.Click = function()
        local name = GetNameDemo(ItemTextBox0:GetText())
        local phrase = ItemTextBox:GetText()
        local alert = ItemTextBox2:GetText()
        local duration = tonumber(ItemTextBox3:GetText() )
        local countdown = CountdownButton:GetText()
        local soundeffect = SoundeffectButton:GetText()
        local target = CountdownButton2:GetText()
        if phrase ~= "Key Phrase" and alert ~= "Alert" and duration ~= nil and countdown ~= "Countdown" and soundeffect ~= "SoundEffect" then
            if countdown == "No" then 
                countdown = nil
            else
                countdown = true
            end

            if target == "No" then
                target = nil
            else
                target = true
            end

            local item = {}
            item[1] = duration
            item[2] = alert
            item[3] = nil
            item[4] = countdown
            item[5] = Sounds:GetSoundList()[soundeffect]
            item[6] = target
            item[7] = nil

            if AddedChatAlerts[name] == nil then
                AddedChatAlerts[name] = {}
            end
            AddedChatAlerts[name][phrase] = item
            self.ChatLabelItem(container, name, item, phrase)
            FailLabel:SetVisible(false)
            SuccessLabel:SetVisible(true)
        else
            SuccessLabel:SetVisible(false)
            FailLabel:SetVisible(true)
            ChatOutput("Failed to add effect, make sure you have all options filled!")
        end
    end

    local SelfEffects2 = Turbine.UI.Control()
    SelfEffects2:SetSize(width, height - 100)
    SelfEffects2:SetParent(self)
    SelfEffects2:SetPosition(0, 40)
    SelfEffects2:SetVisible(false)

    local container = Turbine.UI.ListBox()
    container:SetParent(SelfEffects2)
    container:SetSize(600, height - 200)
    container:SetPosition(30, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( SelfEffects2 )
    containerScrollbar:SetPosition( 630 - 10, 50 )
    containerScrollbar:SetSize( 10, height - 200 )
    container:SetVerticalScrollBar( containerScrollbar )

    local sortedEffects = {}
    for key, value in pairs(RemovedChatAlerts) do table.insert( sortedEffects,key ) end
    table.sort( sortedEffects )

    for key, value in pairs(sortedEffects) do
        for key2, value2 in pairs(RemovedChatAlerts[value]) do
            self.CreateChatItem(container, value, value2, key2)
        end
    end

    
    local ReAddButton = Turbine.UI.Lotro.Button()
    ReAddButton:SetParent(self)
    ReAddButton:SetSize(100, 15)
    ReAddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ReAddButton:SetMouseVisible(true)
    ReAddButton:SetPosition(635, 90)
    ReAddButton:SetVisible(false)
    ReAddButton:SetText("Re-Add effect")

    ReAddButton.Click = function()
        RemovedChatAlerts[selectedName][selectedPhrase] = nil
    end

    local RemoveButton = Turbine.UI.Lotro.Button()
    RemoveButton:SetParent(self)
    RemoveButton:SetSize(100, 15)
    RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    RemoveButton:SetMouseVisible(true)
    RemoveButton:SetPosition(635, 120)
    RemoveButton:SetText("Remove effect")

    RemoveButton.Click = function()
        if selectedName == nil or selectedPhrase == nil then return end
        if AddedChatAlerts[selectedName] ~= nil and AddedChatAlerts[selectedName][selectedPhrase] then
            AddedChatAlerts[selectedName][selectedPhrase] = nil
        else
            if RemovedChatAlerts[selectedName] == nil then
                RemovedChatAlerts[selectedName] = {}
            end
            RemovedChatAlerts[selectedName][selectedPhrase] = A[selectedName][selectedPhrase]
        end
    end


    local SwitchButton = Turbine.UI.Lotro.Button()
    SwitchButton:SetParent(self)
    SwitchButton:SetSize(150, 15)
    SwitchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SwitchButton:SetMouseVisible(true)
    SwitchButton:SetPosition(30, 40)
    SwitchButton:SetText("Chat alerts")

    SwitchButton.Click = function()
        SelfEffects:SetVisible(true)
        SelfEffects2:SetVisible(false)
        ReAddButton:SetVisible(false)
        RemoveButton:SetVisible(true)
    end

    local SwitchButton = Turbine.UI.Lotro.Button()
    SwitchButton:SetParent(self)
    SwitchButton:SetSize(200, 15)
    SwitchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SwitchButton:SetMouseVisible(true)
    SwitchButton:SetPosition(180, 40)
    SwitchButton:SetText("Removed Default Alerts")

    SwitchButton.Click = function()
        SelfEffects:SetVisible(false)
        SelfEffects2:SetVisible(true)
        ReAddButton:SetVisible(true)
        RemoveButton:SetVisible(false)
    end


    

end

