DamageHandler = class(Turbine.UI.Window)
function DamageHandler:Constructor()
    Turbine.UI.Window.Constructor(self)

    self.width = 1080
    self.height = 500
    local x = 500
    local y = 200

    self.listboxes = {}

    self.IconSize = 32

    self.CurrentOutput = ""

    self.ChatOutput = Settings.ChatOutput
    
    self.oldGameTime = Turbine.Engine.GetGameTime()
    self.UpdateDelay = 0.1
    self.decimalPlaces = 1

    self.CurrentTimeStamp = Turbine.Engine.GetGameTime()

    self.CurrentItem = 0

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.trainedSkills = self.player:GetTrainedSkills()

    self.equipmentCallbacks = {}
    self.playerCallbacks = {}
    self.skillCallbacks = {}

    -- Encounter storage
    self.CurrentEncounter = nil
    self.Encounters = {}

    self.skillOverviewLock = nil
    self.skillOverviewName = nil
    self.skillOverviewTime = nil

    -- Stats
    self.StartTimesLUT = {}
    self.CurrentTotalDamage = {}
    self.TotalHits = {}
    self.TotalCrits = {}
    self.TotalDevs = {}
    self.Actions = {}
    self.ItemActions = {}
    self.MaxDamage = {}
    self.SkillDamage = {}
    --self.CurrentDPS = 0
    self.DPSMapped = {}
    self.TargetBreakdown = {}
    self.PowerMapped = {}
    self.MoraleMapped = {}
    self.DamageMapped = {}

    self.SkillsMapped = {}

    self.ItemsMapped = {}

    self.SkillIcons = {}

    self.SkillModulo = 0
    self.ItemModulo = 0

    self.CurrentViewingTime = 0

    self.BarWidth = 1
    self.MaxDps = 0
    self.EndingDPS = 0

    self.CombatStartTime = Turbine.Engine.GetGameTime()

    self.CurrentViewingStartTime = 0

    self.XIcon = "PrimePlugins/RaidTools/Images/X.tga"
    self.MoveIcon = "PrimePlugins/RaidTools/Images/Move.tga"

    self.skillIcons = {}

    local index = 0
    for i = 1, self.trainedSkills:GetCount(), 1 do
        self.skillIcons[self.trainedSkills:GetItem(i):GetSkillInfo():GetName()] = self.trainedSkills:GetItem(i):GetSkillInfo():GetIconImageID()
    end

    self.chatHandler = ChatHandler()

    self:SetSize(self.width,self.height)
    self:SetPosition(x,y)
    --self:SetZOrder(1)

    --self:SetMouseVisible(false)
    self:SetVisible(false)
    self:SetWantsUpdates(true)
    self:SetWantsKeyEvents(true)

    self.KeyDown = function(sender, args)
        if args["Action"] == 145 then
            if self:IsVisible() then self:SetVisible(false) end
        end
    end

    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local ColorBackground = Turbine.UI.Control()
    ColorBackground:SetParent(self)
    ColorBackground:SetPosition(10, 10)
    ColorBackground:SetSize(self.width - 20, self.height - 20)
    ColorBackground:SetMouseVisible(false)
    ColorBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    self.Moving = false

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.MouseUp = function()
        self.Moving = false
    end
  
    self.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          self:SetPosition(newLeft,newTop)
        end
    end


    --[[
    local skillContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    skillContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Horizontal )
    skillContainerScrollbar:SetParent( self )
    skillContainerScrollbar:SetPosition( 10, 390 )
    skillContainerScrollbar:SetSize( 480, 10 )
    skillContainer:SetHorizontalScrollBar( skillContainerScrollbar )
    --]]
    --skillContainer:SetHorizontalScrollBar( damageContainerScrollbar )

    --damageContainer:GetValue()

    -- Setup UI
    

    -- Add item to damageContainer
    self.AdddamageContainerItem = function(DPSValue, TimeStamp, StartTime, totalDamage, notLoaded, lastDPS)
        local MiddleValue = DPSValue / self.MaxDps * 200
        local Entry = Turbine.UI.Control()
        Entry:SetSize(self.BarWidth, 200)
        Entry:IsMouseVisible(true)
        --Entry:SetBackColor(GetRandomColour())

        local bottomBar = Turbine.UI.Label()
        bottomBar:SetParent(Entry)
        bottomBar:SetSize(self.BarWidth, MiddleValue)
        bottomBar:SetPosition(0, 200 - MiddleValue)
        bottomBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

        local line = Turbine.UI.Label()
        line:SetParent(Entry)
        line:SetSize(self.BarWidth, math.max(5, math.abs(MiddleValue -  lastDPS / self.MaxDps * 200)))
        line:SetPosition(0, 200 - MiddleValue)
        line:SetBackColor(Turbine.UI.Color(1, 102/255, 0))

        --self.GraphDamage = self.GraphDamage + MiddleValue

        Entry.MouseEnter = function()
            self.DamageLabel:SetText("DPS: " .. Round(DPSValue, 2))
            self.TimeStampLabel:SetText("TimeStamp: " .. Round(TimeStamp - StartTime, self.decimalPlaces) .. "s")
            self.TotalDamageLabel:SetText("Total Damage: " .. math.floor(totalDamage))
            bottomBar:SetBackColor(Turbine.UI.Color(1, 102/255, 0))

            if notLoaded then
                if self.SkillsMapped[StartTime][TimeStamp] then
                        
                    for key, value in pairs(self.SkillIcons[StartTime][TimeStamp]) do
                        value:SetBackColor(Turbine.UI.Color(0, 1, 0))
                    end

                end
            end
        end

        Entry.MouseLeave = function()
            bottomBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

            if notLoaded then
                if self.SkillsMapped[StartTime][TimeStamp] then
                        
                    for key, value in pairs(self.SkillIcons[StartTime][TimeStamp]) do
                        value:SetBackColor(nil)
                    end

                end
            end
        end

        if notLoaded then 
            local StartPosition = nil

            Entry.PositionChanged = function(sender, args)
                if StartPosition then
                    local PositionChange = Entry:GetLeft() - StartPosition
                    if self.SkillsMapped[StartTime][TimeStamp] or self.ItemsMapped[StartTime][TimeStamp] then
                        
                        for key, value in pairs(self.SkillIcons[StartTime][TimeStamp]) do
                            value:SetLeft(value:GetLeft() + PositionChange)
                        end

                    end
                end
                StartPosition = Entry:GetPosition()
                --for key, value in pairs(args) do
                --end
                --ChatOutput("X")
            end
        end

        self.damageContainer:AddItem(Entry)
    end

    self.ItemIcon = function()
    end

    -- Setup Skill Usage Tracking
    local tskills = self.player:GetTrainedSkills()

    --[[
    local ClassAttr
    if self.player:GetClass() == Turbine.Gameplay.Class.Warden then
        ClassAttr = self.player:GetClassAttributes():GetTrainedGambits()
    end

    for i = 1, ClassAttr:GetCount(), 1 do
        local item = ClassAttr:GetItem(i)
        ChatOutput(item:GetSkillInfo():GetName())
    end
    ClassAttr.GambitChanged = function(sender, args)
        for key, value in pairs(args) do
            ChatOutput(key)
            ChatOutput(value)
        end
    end
    --]]

    for i = 1, self.player:GetTrainedSkills():GetCount(), 1 do
        local item = tskills:GetItem(i)--:GetSkillInfo()
        if item.GetCooldown then
            self.skillCallbacks[item] = {}
            self.skillCallbacks[item]["ResetTimeChanged"] = AddCallback(item, "ResetTimeChanged", function(sender, args)
                if self.player:IsInCombat() and item:GetCooldown() - 0.1 < item:GetResetTime() - Turbine.Engine.GetGameTime() then
                    self.Actions[self.CombatStartTime] = self.Actions[self.CombatStartTime] + 1
                    self.ActionLabel:SetText("Actions: " .. self.Actions[self.CombatStartTime])

                    if not(self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp]) then
                        self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp] = {}
                    end
                    --ChatOutput(item:GetSkillInfo():GetName() )
        
                    self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp][item:GetSkillInfo():GetName()] = {self.CurrentItem, item:GetSkillInfo():GetIconImageID(), item:GetSkillInfo():GetName()}

                    --self.SkillIcon(self.CurrentItem, self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp][item:GetSkillInfo():GetName()][1], self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp][item:GetSkillInfo():GetName()][2], self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp][item:GetSkillInfo():GetName()][3])
                    --self.AddSkillContainerItem(self.CurrentItem, self.CurrentTimeStamp)
                end
            end)
        end
        --local name = item:GetSkillInfo():GetName() 
        --local description = item:GetSkillInfo():GetDescription()
    end

    -- ChatOutput
    local ReloadBackground = Turbine.UI.Control()
    ReloadBackground:SetParent(self)
    ReloadBackground:SetPosition(self.width / 2 + 200, 32)
    ReloadBackground:SetSize(24, 24)
    ReloadBackground:SetMouseVisible(false)
    ReloadBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.clearResetButton = Turbine.UI.Lotro.Quickslot()
    self.clearResetButton:SetPosition(0, 0)
    self.clearResetButton:SetSize(24 - 4, 24 - 4)
    self.clearResetButton:SetParent(ReloadBackground)

    self.ResetShortcut = function()
        self.clearResetButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, self.ChatOutput .. self.CurrentOutput))
    end

    self.ResetShortcut()

    local ReloadBorder = Turbine.UI.Control()
    ReloadBorder:SetParent(ReloadBackground)
    ReloadBorder:SetPosition(2, 2)
    ReloadBorder:SetSize(24 - 4, 24 - 4)
    ReloadBorder:SetMouseVisible(false)
    ReloadBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local Image = Turbine.UI.Label()
    Image:SetParent(ReloadBackground)
    Image:SetPosition(2, 2)
    Image:SetSize(24 - 4, 24 - 6)
    Image:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    Image:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    --Image:SetBackColor(Turbine.UI.Color(0, 102/255, 0))
    Image:SetBackground(ChatIcon)
    Image:SetWantsKeyEvents(false)
    Image:SetMouseVisible(false)
    

    -- Handle item swaps
    self.equipment = self.player:GetEquipment()

    -- Share
    self.OutputParse = function(StartTime)
        TableToString(self.DPSMapped[StartTime], "DPSMapped", 0)
        TableToString(self.TargetBreakdown[StartTime], "TargetBreakdown", 0)
        --TableToString(self.SkillsMapped[StartTime], "SkillsMapped")
        --TableToString(self.ItemsMapped[StartTime], "ItemsMapped")
        --TableToString(self.SkillDamage[StartTime], "SkillDamage")
        TableToString({
            ["Actions"] = self.Actions[StartTime], 
            ["ItemActions"] = self.ItemActions[StartTime], 
            ["EndingDPS"] = self.EndingDPS, 
            ["End Time"] = self.StartTimesLUT[StartTime], 
            ["Start Time"] = StartTime, 
            ["Total Damage"] = self.CurrentTotalDamage[StartTime], 
            ["Total Hits"] = self.TotalHits[StartTime], 
            ["Total Crits"] = self.TotalCrits[StartTime], 
            ["Total Devs"] = self.TotalDevs[StartTime]}, "Misc data", 0)
    end

    local ReloadBackground = Turbine.UI.Control()
    ReloadBackground:SetParent(self)
    ReloadBackground:SetPosition(self.width / 2 - 335, 32)
    ReloadBackground:SetSize(124, 24)
    ReloadBackground:SetMouseVisible(false)
    ReloadBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local ReloadBorder = Turbine.UI.Control()
    ReloadBorder:SetParent(ReloadBackground)
    ReloadBorder:SetPosition(2, 2)
    ReloadBorder:SetSize(124 - 4, 24 - 4)
    ReloadBorder:SetMouseVisible(false)
    ReloadBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local shareButton = Turbine.UI.Label()
    shareButton:SetParent(ReloadBackground)
    shareButton:SetPosition(62, 2)
    shareButton:SetSize(60, 20)
    shareButton:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    shareButton:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    shareButton:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
    shareButton:SetText("Share")
    shareButton:SetMouseVisible(true)

    shareButton.MouseEnter = function()
        shareButton:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    end

    shareButton.MouseLeave = function()
        shareButton:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    end

    shareButton.MouseClick = function()
        shareButton:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))
        self.OutputParse(self.CurrentViewingStartTime)
    end

    local Divider = Turbine.UI.Control()
    Divider:SetParent(ReloadBackground)
    Divider:SetPosition(60, 2)
    Divider:SetSize(2, 24)
    Divider:SetMouseVisible(false)
    Divider:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.TextBox = Turbine.UI.Lotro.TextBox()
    self.TextBox:SetParent(ReloadBackground)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.Verdana10)
    self.TextBox:SetReadOnly(true)
    self.TextBox:SetSelectable(true)
    self.TextBox:SetMouseVisible(true)
    self.TextBox:SetSize(58, 20)
    self.TextBox:SetPosition(2,2)
    
    self.TextBox.MouseEnter = function()
        self.TextBox:SelectAll()  
    end

    -- Input sharing
    local ReloadBackground = Turbine.UI.Control()
    ReloadBackground:SetParent(self)
    ReloadBackground:SetPosition(self.width / 2 - 485, 32)
    ReloadBackground:SetSize(124, 24)
    ReloadBackground:SetMouseVisible(false)
    ReloadBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local ReloadBorder = Turbine.UI.Control()
    ReloadBorder:SetParent(ReloadBackground)
    ReloadBorder:SetPosition(2, 2)
    ReloadBorder:SetSize(124 - 4, 24 - 4)
    ReloadBorder:SetMouseVisible(false)
    ReloadBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local inputButton = Turbine.UI.Label()
    inputButton:SetParent(ReloadBackground)
    inputButton:SetPosition(2, 2)
    inputButton:SetSize(60, 20)
    inputButton:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    inputButton:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    inputButton:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
    inputButton:SetText("Load")
    inputButton:SetMouseVisible(true)

    inputButton.MouseEnter = function()
        inputButton:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    end

    inputButton.MouseLeave = function()
        inputButton:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    end

    inputButton.MouseClick = function()
        inputButton:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))
        self.SetupLoadedParse(StringToTable(self.InputTextBox:GetText()))
        self.InputTextBox:SetText("")
    end

    local Divider = Turbine.UI.Control()
    Divider:SetParent(ReloadBackground)
    Divider:SetPosition(60, 2)
    Divider:SetSize(2, 24)
    Divider:SetMouseVisible(false)
    Divider:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.InputTextBox = Turbine.UI.Lotro.TextBox()
    self.InputTextBox:SetParent(ReloadBackground)
    self.InputTextBox:SetFont(Turbine.UI.Lotro.Font.Verdana10)
    --self.InputTextBox:SetReadOnly(true)
    self.InputTextBox:SetSelectable(true)
    self.InputTextBox:SetMouseVisible(true)
    self.InputTextBox:SetSize(58, 20)
    self.InputTextBox:SetPosition(62,2)

    self.SetupLoadedParse = function(LoadedParse)

        self:ClearStatWindows()

        -- Setup Target Breakdown
        if LoadedParse["TargetBreakdown"] then
            for key,value in spairs(LoadedParse["TargetBreakdown"], function(t,a,b) return t[a] > t[b] end) do
                self:TargetDamageItem(tonumber(key), tonumber(value), tonumber(LoadedParse["Misc data"]["Total Damage"]))
            end
        end

        -- Setup dps graph with mapped skills
        if LoadedParse["DPSMapped"] then
            -- Get max dps
            self.MaxDps = -1
            self.PrevDamageItem = 0
            for _, value in pairs( LoadedParse["DPSMapped"]) do
                if self.MaxDps < tonumber(value) then self.MaxDps = tonumber(value) end
            end

            self.MaxDps = self.MaxDps * 1.2

            self:SetGraphLabelText()

            local lastDPSValue = 0

            for key,value in spairs( LoadedParse["DPSMapped"], function(t,a,b) return a < b end) do
                --ChatOutput(key .. " - " .. value)

                -- Add dps bar
                self.AdddamageContainerItem(tonumber(value), tonumber(key), tonumber(LoadedParse["Misc data"]["Start Time"]), tonumber(LoadedParse["Misc data"]["Total Damage"]), false, lastDPSValue)

                lastDPSValue = tonumber(value)

                self.EndingDPS = value
            end

            
            -- Setup labels
            -- [[
            self.ActionPerSecondLabel:SetText("APS: " .. Round(tonumber(LoadedParse["Misc data"]["Actions"])/ (tonumber(LoadedParse["Misc data"]["End Time"]) - tonumber(LoadedParse["Misc data"]["Start Time"])) ,self.decimalPlaces))
            self.ItemActionPerSecondLabel:SetText("I+APS: " .. Round((tonumber(LoadedParse["Misc data"]["Actions"]) + tonumber(LoadedParse["Misc data"]["ItemActions"])) / (tonumber(LoadedParse["Misc data"]["End Time"]) - tonumber(LoadedParse["Misc data"]["Start Time"])), self.decimalPlaces))
            self.DamageLabel:SetText("DPS: " .. Round(tonumber(LoadedParse["Misc data"]["EndingDPS"]), self.decimalPlaces))
            self.TimeStampLabel:SetText("TimeStamp: " .. Round(tonumber(LoadedParse["Misc data"]["End Time"]) - tonumber(LoadedParse["Misc data"]["Start Time"]), self.decimalPlaces))
            self.TotalDamageLabel:SetText("Total Damage: " .. math.floor(tonumber(LoadedParse["Misc data"]["Total Damage"])))
            self.TotalHitsLabel:SetText("Total Hits: " .. tonumber(LoadedParse["Misc data"]["Total Hits"]))
            self.TotalCritsLabel:SetText("Crits: " .. Round(tonumber(LoadedParse["Misc data"]["Total Crits"]) / tonumber(LoadedParse["Misc data"]["Total Hits"]) * 100, self.decimalPlaces) .. "%")
            self.TotalDevLabel:SetText("Devs: " .. Round(tonumber(LoadedParse["Misc data"]["Total Devs"]) / tonumber(LoadedParse["Misc data"]["Total Hits"]) * 100, self.decimalPlaces) .. "%")
            --]]
            -- Setup ChatOutput
            --self.OutputParse(StartTime)
            --FormatBigNumber(self.CurrentTotalDamage[self.CombatStartTime] / (self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime)), FormatBigNumber(self.CurrentTotalDamage[self.CombatStartTime]), Round(self.TotalCrits[self.CombatStartTime] / self.TotalHits[self.CombatStartTime] * 100, 2), FormatTimeString(self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime), HighestTarget)

            --[[
            local HighestTarget = ""
            if self.TargetBreakdown[StartTime] then
                for key, value in spairs(self.TargetBreakdown[StartTime], function(t,a,b) return t[a] < t[b] end) do
                    --ChatOutput(key)
                    --ChatOutput(value)
                    HighestTarget = key
                    break
                end
            end

            self.CurrentOutput = " <rgb=#06d60d>" .. HighestTarget .. "</rgb> <rgb=#ffffff>-</rgb> <rgb=#a30e0e>DPS:</rgb> <rgb=#ffffff>" .. FormatBigNumber(self.EndingDPS) .. " [" .. math.floor(self.CurrentTotalDamage[StartTime]) .. "] </rgb><rgb=#d8880f>Crit:</rgb> <rgb=#ffffff>" .. Round(self.TotalCrits[StartTime] / self.TotalHits[StartTime] * 100, 2) .. "%</rgb> <rgb=#FF9900>(" .. FormatTimeString(self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime) .. ")"
            self.ResetShortcut()
                        --]]
        end
    end

    self.SetupStatWindows = function(StartTime)

        self:ClearStatWindows()
        self.CurrentViewingTime = StartTime

        self.EncounterData = self.Encounters[StartTime]:GetInformation()

        for key, value in pairs(self.EncounterData["SkillDamage"]) do
            ChatOutput(key)
            ChatOutput(value)
        end

        -- Setup skill damage breakdown
        if self.EncounterData["SkillDamage"] then
            for key,value in spairs(self.EncounterData["SkillDamage"], function(t,a,b) return t[a] > t[b] end) do
                self:AddSkillDamageLabel(key, StartTime)
            end
        end

        -- Setup Target Breakdown
        if self.EncounterData["TargetDamage"] then
            for key,value in spairs(self.EncounterData["TargetDamage"], function(t,a,b) return t[a] > t[b] end) do
                self:TargetDamageItem(key, value, self.EncounterData["CurrentTotalDamage"])
            end
        end

        -- Setup dps graph with mapped skills
        if self.EncounterData["DPSMapped"] then
            -- Get max dps
            self.MaxDps = -1
            self.PrevDamageItem = 0
            for _, value in pairs(self.EncounterData["DPSMapped"]) do
                if self.MaxDps < value then self.MaxDps = value end
            end

            self.MaxDps = self.MaxDps * 1.2

            self:SetGraphLabelText()

            local lastDPS = 0

            for key,value in spairs(self.EncounterData["DPSMapped"], function(t,a,b) return a < b end) do
                --ChatOutput(key .. " - " .. value)

                -- Add dps bar
                self.AdddamageContainerItem(value, key, StartTime, self.EncounterData["CurrentTotalDamage"], true, lastDPS)

                lastDPS = value
                
                --[[
                -- Add skills 
                if self.SkillsMapped[StartTime][key] then
                    for skill, icon in pairs(self.SkillsMapped[StartTime][key]) do
                        self:SkillIcon(StartTime, key, icon[1], icon[2], icon[3])
                    end
                end

                -- Add items
                if self.ItemsMapped[StartTime][key] then
                    for skill, icon in pairs(self.ItemsMapped[StartTime][key]) do
                        self.ItemLabel(StartTime, key, icon[1], icon[2], icon[3], icon[4])
                    end
                end
                --]]

                self.EndingDPS = value
            end

            -- Draw power lines
            local lastPower = self.player:GetMaxPower()

            self.MaxPower = -1
            for _, value in pairs(self.EncounterData["PowerMapped"]) do
                if self.MaxPower < value then self.MaxPower = value end
            end

            self.MaxPower = self.MaxPower * 1.2

            for key, value in spairs(self.EncounterData["PowerMapped"], function(t,a,b) return a < b end) do

                self:AddPowerEntry(value, lastPower)
                lastPower = value

            end

            -- Draw morale lines
            local lastMorale = self.player:GetMaxPower()

            self.MaxMorale = -1
            for _, value in pairs(self.EncounterData["MoraleMapped"]) do
                if self.MaxMorale < value then self.MaxMorale = value end
            end

            self.MaxMorale = self.MaxMorale * 1.2

            for key, value in spairs(self.EncounterData["MoraleMapped"], function(t,a,b) return a < b end) do

                self:AddMoraleEntry(value, lastMorale)
                lastMorale = value

            end

            -- Draw total damage lines
            local lastDamage = 0

            self.TotalMaxDamage = -1
            for _, value in pairs(self.EncounterData["DamageMapped"]) do
                if self.TotalMaxDamage < value then self.TotalMaxDamage = value end
            end

            self.TotalMaxDamage = self.TotalMaxDamage * 1.2

            for key, value in spairs(self.EncounterData["DamageMapped"], function(t,a,b) return a < b end) do

                self:AddTotalDamageEntry(value, lastDamage)
                lastDamage = value

            end


            -- Setup labels
            self.ActionPerSecondLabel:SetText("APS: " .. Round(self.EncounterData["Actions"] / (self.StartTimesLUT[StartTime] - StartTime), self.decimalPlaces))
            self.ItemActionPerSecondLabel:SetText("I+APS: " .. Round((self.EncounterData["Actions"] + self.EncounterData["ItemActions"]) / (self.StartTimesLUT[StartTime] - StartTime), self.decimalPlaces))
            self.DamageLabel:SetText("DPS: " .. Round(self.EndingDPS, self.decimalPlaces))
            self.TimeStampLabel:SetText("TimeStamp: " .. Round(self.StartTimesLUT[StartTime]  - StartTime, self.decimalPlaces))
            self.TotalDamageLabel:SetText("Total Damage: " .. math.floor(self.EncounterData["CurrentTotalDamage"]))
            self.TotalHitsLabel:SetText("Total Hits: " .. self.EncounterData["TotalHits"])
            self.TotalCritsLabel:SetText("Crits: " .. Round(self.EncounterData["HitTypeData"]["critical "] / self.EncounterData["TotalHits"] * 100, self.decimalPlaces) .. "%")
            self.TotalDevLabel:SetText("Devs: " .. Round(self.EncounterData["HitTypeData"]["devastating "] / self.EncounterData["TotalHits"] * 100, self.decimalPlaces) .. "%")

            -- Setup ChatOutput
            --self.OutputParse(StartTime)
            --FormatBigNumber(self.CurrentTotalDamage[self.CombatStartTime] / (self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime)), FormatBigNumber(self.CurrentTotalDamage[self.CombatStartTime]), Round(self.TotalCrits[self.CombatStartTime] / self.TotalHits[self.CombatStartTime] * 100, 2), FormatTimeString(self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime), HighestTarget)

            local HighestTarget = ""
            if self.TargetBreakdown[StartTime] then
                for key, value in spairs(self.TargetBreakdown[StartTime], function(t,a,b) return t[a] < t[b] end) do
                    --ChatOutput(key)
                    --ChatOutput(value)
                    HighestTarget = key
                    break
                end
            end

            self.CurrentOutput = " <rgb=#06d60d>" .. HighestTarget .. "</rgb> <rgb=#ffffff>-</rgb> <rgb=#a30e0e>DPS:</rgb> <rgb=#ffffff>" .. FormatBigNumber(self.EndingDPS) .. " [" .. math.floor(self.CurrentTotalDamage[StartTime]) .. "] </rgb><rgb=#d8880f>Crit:</rgb> <rgb=#ffffff>" .. Round(self.TotalCrits[StartTime] / self.TotalHits[StartTime] * 100, 2) .. "%</rgb> <rgb=#FF9900>(" .. FormatTimeString(self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime) .. ")"
            self.ResetShortcut()

        end

    end

    -- Handle combat changes
    self.CombatChanged = function()
        if self.player:IsInCombat() then
            --ChatOutput("Combat Started")
            self.CombatStartTime = Turbine.Engine.GetGameTime()
            self.StartTimesLUT[self.CombatStartTime] = Turbine.Engine.GetGameTime()
            self.DPSMapped[self.CombatStartTime] = {}
            self.SkillsMapped[self.CombatStartTime] = {}
            self.ItemsMapped[self.CombatStartTime] = {}
            self.SkillIcons[self.CombatStartTime] = {}
            self.SkillDamage[self.CombatStartTime] = {}
            self.TargetBreakdown[self.CombatStartTime] = {}
            self.PowerMapped[self.CombatStartTime] = {}
            self.MoraleMapped[self.CombatStartTime] = {}
            self.DamageMapped[self.CombatStartTime] = {}

            self.CurrentTotalDamage[self.CombatStartTime] = 0
            self.TotalHits[self.CombatStartTime] = 0
            self.TotalCrits[self.CombatStartTime] = 0
            self.TotalDevs[self.CombatStartTime] = 0
            self.Actions[self.CombatStartTime] = 0
            self.ItemActions[self.CombatStartTime] = 0
            self.MaxDamage[self.CombatStartTime] = 0

            self.Encounters[self.CombatStartTime] = Encounter()
            self.CurrentEncounter = self.Encounters[self.CombatStartTime]

            self.CurrentItem = 0

            smallPP:StartTimer()
        else
            if self.CurrentEncounter then
                self.CurrentEncounter:SetWantsUpdates(false)
                self.CurrentEncounter = nil
            end
            --ChatOutput("Combat Ended")

            self.StartTimesLUT[self.CombatStartTime] = Turbine.Engine.GetGameTime()

            smallPP:SetWantsUpdates(false)

            if self.CombatStartTime ~= self.StartTimesLUT[self.CombatStartTime] then
                --ChatOutput("\n" .. TableToString(self.DPSMapped[self.CombatStartTime], "DPSMapped", 0))
                local HighestTarget = ""
                if self.TargetBreakdown[self.CombatStartTime] then
                    for key, value in spairs(self.TargetBreakdown[self.CombatStartTime], function(t,a,b) return t[a] < t[b] end) do
                        --ChatOutput(key)
                        --ChatOutput(value)
                        HighestTarget = key
                        break
                    end
                end
                self.AddTimestampEntry(self.CombatStartTime, FormatTimeString(self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime), HighestTarget)
                smallPP:SetupChatoutput(FormatBigNumber(self.CurrentTotalDamage[self.CombatStartTime] / (self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime)), FormatBigNumber(self.CurrentTotalDamage[self.CombatStartTime]), Round(self.TotalCrits[self.CombatStartTime] / self.TotalHits[self.CombatStartTime] * 100, 2), FormatTimeString(self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime), HighestTarget)
            end

            --self.SetupStatWindows(self.CombatStartTime)

            --]]

        end
    end

    self.Update = function()

        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == self.oldGameTime then
            return(true)
        end
        local delta = currentGameTime - self.oldGameTime
        if delta < self.UpdateDelay then return end

        --ChatOutput(currentGameTime)
        --ChatOutput(numberRound(currentGameTime, self.decimalPlaces))
        self.oldGameTime =  numberRound(currentGameTime, self.decimalPlaces)

        if self.player:IsInCombat() then
            self.CurrentItem = self.CurrentItem + 1

            self.DPSMapped[self.CombatStartTime][self.oldGameTime] = self.CurrentTotalDamage[self.CombatStartTime] / (Turbine.Engine.GetGameTime() - self.CombatStartTime)
            self.PowerMapped[self.CombatStartTime][self.oldGameTime] = self.player:GetPower()
            self.MoraleMapped[self.CombatStartTime][self.oldGameTime] = self.player:GetMorale()
            self.DamageMapped[self.CombatStartTime][self.oldGameTime] = self.CurrentTotalDamage[self.CombatStartTime]
            --self.AdddamageContainerItem(self.DPSMapped[self.CombatStartTime][self.CurrentTimeStamp], currentGameTime)

            smallPP:SetDPS(self.CurrentEncounter:GetDPS())
            --ChatOutput(self.CurrentTotalDamage / (Turbine.Engine.GetGameTime() - self.CombatStartTime) / 50000 * 200)
        end

    end

    PlayerName = self.player:GetName()
 
    -- Set parse function

    self:SetupUI()
    self:SetCallbacks()
    self.CombatChanged()
    self.chatHandler:SetParseFunction(self)
end

function DamageHandler:AddText(text)
    self.TextBox:AppendText(text)
end

function DamageHandler:SetCallbacks()
    self.equipmentCallbacks["ItemEquipped"] = AddCallback(self.equipment, "ItemEquipped", function(sender, args)
        --self:SetVisible(true)
        if self.player:IsInCombat() then
            local item = self.equipment:GetItem(args.Index)
            if item ~= nil then 
                local itemName = item:GetName()

                self.ItemActions[self.CombatStartTime] = self.ItemActions[self.CombatStartTime] + 1

                if not(self.ItemsMapped[self.CombatStartTime][self.CurrentTimeStamp]) then
                    self.ItemsMapped[self.CombatStartTime][self.CurrentTimeStamp] = {}
                end

                --ChatOutput(itemName )

                self.ItemsMapped[self.CombatStartTime][self.CurrentTimeStamp][itemName] = {self.CurrentItem, item:GetItemInfo():GetIconImageID(), item:GetItemInfo():GetBackgroundImageID(), itemName}
            end	
        end
    end)

    self.equipmentCallbacks["ItemUnequipped"] = AddCallback(self.equipment, "ItemUnequipped", function(sender, args)
        --self:SetVisible(false)
        local item = self.equipment:GetItem(args.Index)
        if item ~= nil then    
            local itemName = item:GetName()    
        end	
    end)

    -- Set Player Events
    self.playerCallbacks["InCombatChanged"] = AddCallback(self.player, "InCombatChanged", function(sender, args)
        self.CombatChanged()
    end)
end

function DamageHandler:RemoveCallbacks()
    for key, value in pairs(self.equipmentCallbacks) do
        RemoveCallback(self.equipment, key, value)
    end

    for key, value in pairs(self.playerCallbacks) do
        RemoveCallback(self.player, key, value)
    end

    for skill, callback in pairs(self.skillCallbacks) do
        for key, value in pairs(callback) do
            RemoveCallback(skill, key, value)
        end
    end
end

function DamageHandler:HandleDamage(damage, damageType, hitType, skillName, target)

    if self.CurrentEncounter then
        self.CurrentEncounter:UpdateDamage(damage, damageType, hitType, skillName, target)

        smallPP:SetTotal(self.CurrentEncounter:GetTotalDamage())
        smallPP:SetCrit(self.CurrentEncounter:GetTotalCritPercentage())
    end

    --[[

    -- 1 + 1 = 3
    self.CurrentTotalDamage[self.CombatStartTime] = self.CurrentTotalDamage[self.CombatStartTime] + damage

    -- Detect special hit types
    local hitCategory = 1

    if string.find(HitType, "critical") then
        self.TotalCrits[self.CombatStartTime] = self.TotalCrits[self.CombatStartTime] + 1
        hitCategory = 2
    elseif string.find(HitType, "devastating") then
        self.TotalDevs[self.CombatStartTime] = self.TotalDevs[self.CombatStartTime] + 1
        hitCategory = 3
    else
        --??
    end

    -- Max damage
    if damage > self.MaxDamage[self.CombatStartTime] then self.MaxDamage[self.CombatStartTime] = damage end

    -- Total hits
    self.TotalHits[self.CombatStartTime] = self.TotalHits[self.CombatStartTime] + 1

    -- Skill damage saving
    if not(self.SkillDamage[self.CombatStartTime][SkillName]) then
        local skillItem = {damage, damage, 1, 0, 0}
        if hitCategory == 2 then skillItem[4] = 1 elseif hitCategory == 3 then skillItem[5] = 1 end
        self.SkillDamage[self.CombatStartTime][SkillName] = skillItem
    else
        local skillItem = self.SkillDamage[self.CombatStartTime][SkillName]
        skillItem[1] = skillItem[1] + damage
        skillItem[3] = skillItem[3] + 1
        if skillItem[2] < damage then skillItem[2] = damage end
        if hitCategory == 2 then skillItem[4] = skillItem[4] + 1 elseif hitCategory == 3 then skillItem[5] = skillItem[5] +  1 end

        self.SkillDamage[self.CombatStartTime][SkillName] = skillItem
    end

    -- Handle target damage
    if self.TargetBreakdown[self.CombatStartTime][Target] then
        self.TargetBreakdown[self.CombatStartTime][Target] = self.TargetBreakdown[self.CombatStartTime][Target] + damage
    else
        self.TargetBreakdown[self.CombatStartTime][Target] = damage
    end

    -- Handle DPS meter
    smallPP:SetTotal(self.CurrentTotalDamage[self.CombatStartTime])
    smallPP:SetCrit(self.TotalCrits[self.CombatStartTime] / self.TotalHits[self.CombatStartTime] * 100)
    --]]
end

function DamageHandler:SetupUI()
    self:TargetBreakdownUI()

    self:SetupButtonUI()

    self:SetupSkilldamageUI()

    self:SetupStatUI()

    self:SetupDamageUI()

    self:SetupGraphLineUI()

    self:DropdownmenuUI()

    self:PowerOverview()
    self:MoraleOverview()
    self:TotalDamageOverview()
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:TargetBreakdownUI()
    -- Target breakdown UI
    self.TargetBreakdownContainer = Turbine.UI.Control()
    self.TargetBreakdownContainer:SetParent(self)
    self.TargetBreakdownContainer:SetPosition(760 - 5, 80 - 5)
    self.TargetBreakdownContainer:SetSize(280,220)
    self.TargetBreakdownContainer:SetMouseVisible(false)
    self.TargetBreakdownContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.TargetBreakdownContainer2 = Turbine.UI.Control()
    self.TargetBreakdownContainer2:SetParent(self)
    self.TargetBreakdownContainer2:SetPosition(760, 80)
    self.TargetBreakdownContainer2:SetSize(280 - 10, 220 - 10)
    self.TargetBreakdownContainer2:SetMouseVisible(false)
    self.TargetBreakdownContainer2:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    self.TargetDamageContainer = Turbine.UI.ListBox()
    self.TargetDamageContainer:SetParent(self.TargetBreakdownContainer2)
    self.TargetDamageContainer:SetSize(280-10, 220 - 10)
    self.TargetDamageContainer:SetPosition(0, 0)
    self.TargetDamageContainer:SetVisible(true)
    --self.TargetDamageContainer:SetBackColor(GetRandomColour())
    self.TargetDamageContainer:SetOrientation( Turbine.UI.Orientation.Vertical )

    self.listboxes["Target"] = self.TargetDamageContainer

    self.TargetDamageContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.TargetDamageContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    self.TargetDamageContainerScrollbar:SetParent( self.TargetBreakdownContainer2 )
    self.TargetDamageContainerScrollbar:SetPosition( 280-10, 0 )
    self.TargetDamageContainerScrollbar:SetSize( 10, 200 - 10 )
    self.TargetDamageContainerScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    self.TargetDamageContainer:SetVerticalScrollBar( self.TargetDamageContainerScrollbar )
end

function DamageHandler:TargetDamageItem(Name, Damage, CurrentTotalDamage)

    local ListItem = Turbine.UI.Control()
    ListItem:SetSize(270, 34)
    ListItem:SetMouseVisible(true)
    ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

    local BackGroundControl = Turbine.UI.Control()
    BackGroundControl:SetParent(ListItem)
    BackGroundControl:SetSize(270, 30)
    BackGroundControl:SetPosition(0, 2)
    BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(ListItem)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    NameLabel:SetSize(170, 30)
    NameLabel:SetPosition(0, 2)
    NameLabel:SetMultiline(false)
    NameLabel:SetText(Name)

    
    local DamageLabel = Turbine.UI.Label()
    DamageLabel:SetParent(ListItem)
    DamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    DamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    DamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    DamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    DamageLabel:SetSize(120, 30)
    DamageLabel:SetMultiline(false)
    DamageLabel:SetPosition(150,2)
    DamageLabel:SetText(FormatBigNumber(Damage) .. "(" .. Round(Damage / CurrentTotalDamage * 100, 2) .. "%)" )

    ListItem.MouseEnter = function()
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    end

    ListItem.MouseLeave = function()
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    end

    self.TargetDamageContainer:AddItem(ListItem)
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:SetupButtonUI()
    -- Reload button
    self.ReloadBackground = Turbine.UI.Control()
    self.ReloadBackground:SetParent(self)
    self.ReloadBackground:SetPosition(10, 10)
    self.ReloadBackground:SetSize(35, 35)
    self.ReloadBackground:SetMouseVisible(false)
    self.ReloadBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.ReloadImage = Turbine.UI.Label()
    self.ReloadImage:SetParent(self.ReloadBackground)
    self.ReloadImage:SetPosition(0, 0)
    self.ReloadImage:SetSize(25, 25)
    self.ReloadImage:SetBackColor(Turbine.UI.Color(0, 102/255, 0))
    self.ReloadImage:SetWantsKeyEvents(false)
    self.ReloadImage:SetMouseVisible(false)

    self.ClearButton = Turbine.UI.Label()
    self.ClearButton:SetParent(self.ReloadBackground)
    self.ClearButton:SetPosition(0, 0)
    self.ClearButton:SetSize(25, 25)
    self.ClearButton:SetBackground(self.MoveIcon)
    self.ClearButton:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.ClearButton:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ClearButton:SetWantsKeyEvents(false)
    self.ClearButton:SetMouseVisible(true)

    self.ClearButton.MouseClick = function()
        self:ClearStatWindows()
    end
    
    -- Close Button
    self.CloseBackground = Turbine.UI.Control()
    self.CloseBackground:SetParent(self)
    self.CloseBackground:SetPosition(self.width - 45, 10)
    self.CloseBackground:SetSize(35, 35)
    self.CloseBackground:SetMouseVisible(false)
    self.CloseBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.CloseImage = Turbine.UI.Label()
    self.CloseImage:SetParent(self.CloseBackground)
    self.CloseImage:SetPosition(10, 0)
    self.CloseImage:SetSize(25, 25)
    self.CloseImage:SetBackColor(Turbine.UI.Color(153/255, 0, 0))
    self.CloseImage:SetWantsKeyEvents(false)
    self.CloseImage:SetMouseVisible(false)

    self.CloseButton = Turbine.UI.Label()
    self.CloseButton:SetParent(self.CloseBackground)
    self.CloseButton:SetPosition(10, 0)
    self.CloseButton:SetSize(25, 25)
    self.CloseButton:SetBackground(self.XIcon)
    self.CloseButton:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.CloseButton:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    self.CloseButton:SetWantsKeyEvents(false)
    self.CloseButton:SetMouseVisible(true)

    self.CloseButton.MouseClick = function()
        self:SetVisible(false)
    end
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:SetupStatUI()
    self.SkillStatContainer = Turbine.UI.Control()
    self.SkillStatContainer:SetParent(self)
    self.SkillStatContainer:SetPosition(840 - 5, 310 - 5)
    self.SkillStatContainer:SetSize(200, self.IconSize * 5 + 10)
    self.SkillStatContainer:SetMouseVisible(false)
    self.SkillStatContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.SkillStatContainer2 = Turbine.UI.Control()
    self.SkillStatContainer2:SetParent(self)
    self.SkillStatContainer2:SetPosition(840, 310)
    self.SkillStatContainer2:SetSize(200 - 10, self.IconSize * 5)
    self.SkillStatContainer2:SetMouseVisible(false)
    self.SkillStatContainer2:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    self.HeaderDivider = Turbine.UI.Control()
    self.HeaderDivider:SetParent(self.SkillStatContainer2)
    self.HeaderDivider:SetSize(200, 30)
    self.HeaderDivider:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.HeaderLabel = Turbine.UI.Label()
    self.HeaderLabel:SetParent(self.SkillStatContainer2)
    self.HeaderLabel:SetPosition(0, 0)
    self.HeaderLabel:SetSize(200, 25)
    self.HeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.HeaderLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    self.HeaderLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.HeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.HeaderLabel:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    self.HeaderLabel:SetText("Skill Stats")
    self.HeaderLabel:SetMouseVisible(false)

    self.SkillDamageLabel = Turbine.UI.Label()
    self.SkillDamageLabel:SetParent(self.SkillStatContainer2)
    self.SkillDamageLabel:SetPosition(0, 30)
    self.SkillDamageLabel:SetSize(200, 20)
    self.SkillDamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.SkillDamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.SkillDamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.SkillDamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.SkillDamageLabel:SetText("DPS: ")
    self.SkillDamageLabel:SetMouseVisible(false)

    self.SkillMaxDamageLabel = Turbine.UI.Label()
    self.SkillMaxDamageLabel:SetParent(self.SkillStatContainer2)
    self.SkillMaxDamageLabel:SetPosition(0, 50)
    self.SkillMaxDamageLabel:SetSize(300, 20)
    self.SkillMaxDamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.SkillMaxDamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.SkillMaxDamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.SkillMaxDamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.SkillMaxDamageLabel:SetText("Max Damage: ")
    self.SkillMaxDamageLabel:SetMouseVisible(false)

    self.SkillTotalDamageLabel = Turbine.UI.Label()
    self.SkillTotalDamageLabel:SetParent(self.SkillStatContainer2)
    self.SkillTotalDamageLabel:SetPosition(0, 70)
    self.SkillTotalDamageLabel:SetSize(300, 20)
    self.SkillTotalDamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.SkillTotalDamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.SkillTotalDamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.SkillTotalDamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.SkillTotalDamageLabel:SetText("Total Damage: ")
    self.SkillTotalDamageLabel:SetMouseVisible(false)

    self.SkillTotalHitsLabel = Turbine.UI.Label()
    self.SkillTotalHitsLabel:SetParent(self.SkillStatContainer2)
    self.SkillTotalHitsLabel:SetPosition(0, 90)
    self.SkillTotalHitsLabel:SetSize(300, 20)
    self.SkillTotalHitsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.SkillTotalHitsLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.SkillTotalHitsLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.SkillTotalHitsLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.SkillTotalHitsLabel:SetText("Total Hits: ")
    self.SkillTotalHitsLabel:SetMouseVisible(false)

    self.SkillTotalCritsLabel = Turbine.UI.Label()
    self.SkillTotalCritsLabel:SetParent(self.SkillStatContainer2)
    self.SkillTotalCritsLabel:SetPosition(0, 110)
    self.SkillTotalCritsLabel:SetSize(300, 20)
    self.SkillTotalCritsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.SkillTotalCritsLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.SkillTotalCritsLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.SkillTotalCritsLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.SkillTotalCritsLabel:SetText("Crits: ")
    self.SkillTotalCritsLabel:SetMouseVisible(false)

    self.SkillTotalDevLabel = Turbine.UI.Label()
    self.SkillTotalDevLabel:SetParent(self.SkillStatContainer2)
    self.SkillTotalDevLabel:SetPosition(0, 130)
    self.SkillTotalDevLabel:SetSize(300, 20)
    self.SkillTotalDevLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.SkillTotalDevLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.SkillTotalDevLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.SkillTotalDevLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.SkillTotalDevLabel:SetText("Devs: ")
    self.SkillTotalDevLabel:SetMouseVisible(false)

    self.ContainerContainer = Turbine.UI.Control()
    self.ContainerContainer:SetParent(self)
    self.ContainerContainer:SetPosition(40 - 5, 80 - 5)
    self.ContainerContainer:SetSize(500, 220)
    self.ContainerContainer:SetMouseVisible(false)
    self.ContainerContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.ContainerContainer2 = Turbine.UI.Control()
    self.ContainerContainer2:SetParent(self)
    self.ContainerContainer2:SetPosition(40, 80)
    self.ContainerContainer2:SetSize(500 - 10, 220 - 10)
    self.ContainerContainer2:SetMouseVisible(false)
    self.ContainerContainer2:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    self.damageContainer = Turbine.UI.ListBox()
    self.damageContainer:SetParent(self)
    self.damageContainer:SetSize(500-10, 200)
    self.damageContainer:SetPosition(40, 80)
    --self.damageContainer:SetBackColor(Turbine.UI.Color(0,0,0))
    self.damageContainer:SetVisible(true)
    self.damageContainer:SetOrientation( Turbine.UI.Orientation.Horizontal )
    --self.damageContainer:SetFlippedLayout(true)
    --self.damageContainer:SetReverseFill(true)
    --self.damageContainer:SetWantsKeyEvents(true)
    --self.damageContainer:SetMouseVisible(true)

    self.listboxes["DPS"] = self.damageContainer

    self.damageContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.damageContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Horizontal )
    self.damageContainerScrollbar:SetParent( self )
    self.damageContainerScrollbar:SetPosition( 40, 280 )
    self.damageContainerScrollbar:SetSize( 500 - 10, 10 )
    self.damageContainer:SetHorizontalScrollBar( self.damageContainerScrollbar )
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:SetupGraphLineUI()
    local GraphLine = Turbine.UI.Control()
    GraphLine:SetParent(self)
    GraphLine:SetSize(490, 1)
    GraphLine:SetPosition(40, 80)
    GraphLine:SetMouseVisible(false)
    GraphLine:SetBackColor(Turbine.UI.Color(1,1,1))

    local GraphLine = Turbine.UI.Control()
    GraphLine:SetParent(self)
    GraphLine:SetSize(490, 1)
    GraphLine:SetPosition(40, 132)
    GraphLine:SetMouseVisible(false)
    GraphLine:SetBackColor(Turbine.UI.Color(1,1,1))

    local GraphLine = Turbine.UI.Control()
    GraphLine:SetParent(self)
    GraphLine:SetSize(490, 1)
    GraphLine:SetPosition(40, 185)
    GraphLine:SetMouseVisible(false)
    GraphLine:SetBackColor(Turbine.UI.Color(1,1,1))

    local GraphLine = Turbine.UI.Control()
    GraphLine:SetParent(self)
    GraphLine:SetSize(490, 1)
    GraphLine:SetPosition(40, 237)
    GraphLine:SetMouseVisible(false)
    GraphLine:SetBackColor(Turbine.UI.Color(1,1,1))

    local GraphLine = Turbine.UI.Control()
    GraphLine:SetParent(self)
    GraphLine:SetSize(490, 1)
    GraphLine:SetPosition(40, 280)
    GraphLine:SetMouseVisible(false)
    GraphLine:SetBackColor(Turbine.UI.Color(1,1,1))

    self.GraphLabel1 = Turbine.UI.Label()
    self.GraphLabel1:SetParent(self)
    self.GraphLabel1:SetSize(80, 20)
    self.GraphLabel1:SetPosition(450, 80)
    self.GraphLabel1:SetTextAlignment(Turbine.UI.ContentAlignment.TopRight)
    self.GraphLabel1:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.GraphLabel1:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.GraphLabel1:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.GraphLabel1:SetMouseVisible(false)
    --self.GraphLabel1:SetBackColor(Turbine.UI.Color(1,1,1))
    self.GraphLabel1:SetText("0")

    self.GraphLabel2 = Turbine.UI.Label()
    self.GraphLabel2:SetParent(self)
    self.GraphLabel2:SetSize(80, 20)
    self.GraphLabel2:SetPosition(450, 185)
    self.GraphLabel2:SetTextAlignment(Turbine.UI.ContentAlignment.TopRight)
    self.GraphLabel2:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.GraphLabel2:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.GraphLabel2:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.GraphLabel2:SetMouseVisible(false)
    --self.GraphLabel2:SetBackColor(Turbine.UI.Color(1,1,1))
    self.GraphLabel2:SetText("0")

    self.GraphLabel3 = Turbine.UI.Label()
    self.GraphLabel3:SetParent(self)
    self.GraphLabel3:SetSize(80, 20)
    self.GraphLabel3:SetPosition(450, 260)
    self.GraphLabel3:SetTextAlignment(Turbine.UI.ContentAlignment.BottomRight)
    self.GraphLabel3:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.GraphLabel3:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.GraphLabel3:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.GraphLabel3:SetMouseVisible(false)
    --self.GraphLabel3:SetBackColor(Turbine.UI.Color(1,1,1))
    self.GraphLabel3:SetText("0")
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:SetGraphLabelText()
    self.GraphLabel2:SetText(FormatBigNumber(self.MaxDps * 0.5))
    self.GraphLabel1:SetText(FormatBigNumber(self.MaxDps))
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:SetupSkilldamageUI()
    self.SkillContainerContainer = Turbine.UI.Control()
    self.SkillContainerContainer:SetParent(self)
    self.SkillContainerContainer:SetPosition(40 - 5, 310 - 5)
    self.SkillContainerContainer:SetSize(500, self.IconSize * 5 + 10)
    self.SkillContainerContainer:SetMouseVisible(false)
    self.SkillContainerContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.SkillContainerContainer2 = Turbine.UI.Control()
    self.SkillContainerContainer2:SetParent(self)
    self.SkillContainerContainer2:SetPosition(40, 310)
    self.SkillContainerContainer2:SetSize(500 - 10, self.IconSize * 5 )
    self.SkillContainerContainer2:SetMouseVisible(false)
    self.SkillContainerContainer2:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    self.skillContainer = Turbine.UI.Control()
    self.skillContainer:SetParent(self)
    self.skillContainer:SetSize(500 - 10, self.IconSize * 5)
    self.skillContainer:SetPosition(40, 310)
    --skillContainer:SetBackColor(Turbine.UI.Color(0,0,0))
    self.skillContainer:SetVisible(true)
    --skillContainer:SetForeColor(Turbine.UI.Color(0,0,0))
    --skillContainer:SetText("IIIIIIIIIII")
    --skillContainer:SetOrientation( Turbine.UI.Orientation.Horizontal )
    --skillContainer:SetIgnoreCellAlignment(true)
    --skillContainer:SetFlippedLayout(true)
    --skillContainer:SetReverseFill(true)
    --skillContainer:SetWantsKeyEvents(true)
    --skillContainer:SetMouseVisible(true)

    self.itemContainer = Turbine.UI.Control()
    self.itemContainer:SetParent(self)
    self.itemContainer:SetSize(500, 80)
    self.itemContainer:SetPosition(40, 370)
    --self.itemContainer:SetBackColor(Turbine.UI.Color(0,0,0))
    self.itemContainer:SetVisible(true)

    self.SkillBreakdownContainer = Turbine.UI.Control()
    self.SkillBreakdownContainer:SetParent(self)
    self.SkillBreakdownContainer:SetPosition(550 - 5, 310 - 5)
    self.SkillBreakdownContainer:SetSize(280, self.IconSize * 5 + 10)
    self.SkillBreakdownContainer:SetMouseVisible(false)
    self.SkillBreakdownContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.SkillBreakdownContainer2 = Turbine.UI.Control()
    self.SkillBreakdownContainer2:SetParent(self)
    self.SkillBreakdownContainer2:SetPosition(550, 310)
    self.SkillBreakdownContainer2:SetSize(280 - 10, self.IconSize * 5 - 10 + 10)
    self.SkillBreakdownContainer2:SetMouseVisible(false)
    self.SkillBreakdownContainer2:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    self.skillDamageContainer = Turbine.UI.ListBox()
    self.skillDamageContainer:SetParent(self.SkillBreakdownContainer2)
    self.skillDamageContainer:SetSize(280-10, self.IconSize * 5 - 10 + 10)
    self.skillDamageContainer:SetPosition(0, 0)
    self.skillDamageContainer:SetVisible(true)
    --self.skillDamageContainer:SetBackColor(GetRandomColour())
    self.skillDamageContainer:SetOrientation( Turbine.UI.Orientation.Vertical )

    self.listboxes["Skill"] = self.skillDamageContainer

    self.skillDamageContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.skillDamageContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    self.skillDamageContainerScrollbar:SetParent( self.SkillBreakdownContainer2 )
    self.skillDamageContainerScrollbar:SetPosition( 280-10, 0 )
    self.skillDamageContainerScrollbar:SetSize( 10, self.IconSize * 5 - 10 + 10 )
    self.skillDamageContainerScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    self.skillDamageContainer:SetVerticalScrollBar( self.skillDamageContainerScrollbar )
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:AddSkillDamageLabel(Name, Time)
    local ListItem = Turbine.UI.Control()
    ListItem:SetSize(270, 36)
    ListItem:SetMouseVisible(true)
    ListItem:SetBackColor(Turbine.UI.Color(0.2, 0.2, 0.2))

    ListItem.barBackround = Turbine.UI.Control()
    ListItem.barBackround:SetParent(ListItem)
    ListItem.barBackround:SetSize(270, 32)
    ListItem.barBackround:SetPosition(0, 2)
    ListItem.barBackround:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    ListItem.barBackround:SetMouseVisible(false)

    ListItem.BackGroundControl = Turbine.UI.Control()
    ListItem.BackGroundControl:SetParent(ListItem)
    ListItem.BackGroundControl:SetSize((270 - 32) * self.EncounterData["SkillDamage"][Name] / self.EncounterData["CurrentTotalDamage"], 30)
    ListItem.BackGroundControl:SetPosition(32, 2)
    ListItem.BackGroundControl:SetBackColor(Turbine.UI.Color(0.6, 0.1, 0.1))
    ListItem.BackGroundControl:SetMouseVisible(false)
    ListItem.BackGroundControl:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    
    ListItem.IconLabel = Turbine.UI.Label()
    ListItem.IconLabel:SetParent(ListItem)
    ListItem.IconLabel:SetSize(32, 32)
    ListItem.IconLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    ListItem.IconLabel:SetPosition(0, 2)
    ListItem.IconLabel:SetMouseVisible(false)
    if self.skillIcons[Name] then
        ListItem.IconLabel:SetBackground(self.skillIcons[Name])
    else
        ListItem.IconLabel:SetBackground(1090551617)
    end


    ListItem.NameLabel = Turbine.UI.Label()
    ListItem.NameLabel:SetParent(ListItem)
    ListItem.NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    ListItem.NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    ListItem.NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    ListItem.NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    ListItem.NameLabel:SetSize(150, 32)
    ListItem.NameLabel:SetPosition(34, 2)
    ListItem.NameLabel:SetText(Name)
    ListItem.NameLabel:SetMouseVisible(false)

    ListItem.DamageLabel = Turbine.UI.Label()
    ListItem.DamageLabel:SetParent(ListItem)
    ListItem.DamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    ListItem.DamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    ListItem.DamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    ListItem.DamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    ListItem.DamageLabel:SetSize(120, 32)
    ListItem.DamageLabel:SetMultiline(false)
    ListItem.DamageLabel:SetPosition(140,2)
    ListItem.DamageLabel:SetMouseVisible(false)
    ListItem.DamageLabel:SetText(FormatBigNumber(self.EncounterData["SkillDamage"][Name]) .. " (" .. Round(self.EncounterData["SkillDamage"][Name] / self.EncounterData["CurrentTotalDamage"] * 100, 2) .. "%)" )

    ListItem.MouseEnter = function()
        if self.skillOverviewLock ~= ListItem then
            ListItem.BackGroundControl:SetBackColor(Turbine.UI.Color(0.6, 0.6, 0.1, 0.1))
        end
        self:ChangeSkillDamageLabelText(Name, Time)
    end

    ListItem.MouseClick = function()
        ListItem.BackGroundControl:SetBackColor(Turbine.UI.Color(0.4, 0, 0))
        if self.skillOverviewLock == ListItem then
            ListItem.BackGroundControl:SetBackColor(Turbine.UI.Color(0.6, 0.6, 0.1, 0.1))
            self.skillOverviewLock = nil
            self.skillOverviewName = nil
            self.skillOverviewTime = nil
        else
            if self.skillOverviewLock ~= nil then
                self.skillOverviewLock.BackGroundControl:SetBackColor(Turbine.UI.Color(0.6, 0.1, 0.1))
            end
            self.skillOverviewLock = ListItem
            self.skillOverviewName = Name
            self.skillOverviewTime = Time
        end
        self:ChangeSkillDamageLabelText(Name, Time)
    end

    ListItem.MouseLeave = function()
        if self.skillOverviewLock ~= ListItem then
            ListItem.BackGroundControl:SetBackColor(Turbine.UI.Color(0.6, 0.1, 0.1))
            if self.skillOverviewLock ~= nil then
                self:ChangeSkillDamageLabelText(self.skillOverviewName, self.skillOverviewTime)
            end
        end
    end

    self.skillDamageContainer:AddItem(ListItem)
end

function DamageHandler:ChangeSkillDamageLabelText(skillName, Time)
    if self.EncounterData == nil then return end
    self.SkillDamageLabel:SetText("DPS: " .. Round(self.EncounterData["SkillDamage"][skillName] / (self.StartTimesLUT[Time] - Time), 2))
    self.SkillMaxDamageLabel:SetText("Max Damage: " .. self.EncounterData["SkillMaxDamage"][skillName])
    self.SkillTotalDamageLabel:SetText("Total Damage: " .. self.EncounterData["SkillDamage"][skillName])
    self.SkillTotalHitsLabel:SetText("Total Hits: " .. self.EncounterData["SkillTotalHits"][skillName])
    self.SkillTotalCritsLabel:SetText("Crits: " .. self.EncounterData["SkillHits"][skillName]["critical "] .. " (" .. Round(self.EncounterData["SkillHits"][skillName]["critical "] / self.EncounterData["SkillTotalHits"][skillName] * 100, 2) .. "%)" )
    self.SkillTotalDevLabel:SetText("Devs: " .. self.EncounterData["SkillHits"][skillName]["devastating "]  .. " (" .. Round(self.EncounterData["SkillHits"][skillName]["devastating "] / self.EncounterData["SkillTotalHits"][skillName] * 100, 2) .. "%)")
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:SetupDamageUI()
    self.StatContainer = Turbine.UI.Control()
    self.StatContainer:SetParent(self)
    self.StatContainer:SetPosition(550 - 5, 80 - 5)
    self.StatContainer:SetSize(200, 200 + 20)
    self.StatContainer:SetMouseVisible(false)
    self.StatContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.StatContainer2 = Turbine.UI.Control()
    self.StatContainer2:SetParent(self)
    self.StatContainer2:SetPosition(550, 80)
    self.StatContainer2:SetSize(200 - 10, 200 + 20 - 10)
    self.StatContainer2:SetMouseVisible(false)
    self.StatContainer2:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    self.HeaderDivider = Turbine.UI.Control()
    self.HeaderDivider:SetParent(self.StatContainer2)
    self.HeaderDivider:SetSize(200, 30)
    self.HeaderDivider:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.HeaderLabel = Turbine.UI.Label()
    self.HeaderLabel:SetParent(self.StatContainer2)
    self.HeaderLabel:SetPosition(0, 0)
    self.HeaderLabel:SetSize(200, 25)
    self.HeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.HeaderLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    self.HeaderLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.HeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.HeaderLabel:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    self.HeaderLabel:SetText("DPS Stats")
    self.HeaderLabel:SetMouseVisible(false)

    self.DamageLabel = Turbine.UI.Label()
    self.DamageLabel:SetParent(self.StatContainer2)
    self.DamageLabel:SetPosition(0, 30)
    self.DamageLabel:SetSize(200, 20)
    self.DamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.DamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.DamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.DamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.DamageLabel:SetText("DPS: ")
    self.DamageLabel:SetMouseVisible(false)

    self.TimeStampLabel = Turbine.UI.Label()
    self.TimeStampLabel:SetParent(self.StatContainer2)
    self.TimeStampLabel:SetPosition(0, 50)
    self.TimeStampLabel:SetSize(200, 20)
    self.TimeStampLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.TimeStampLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.TimeStampLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TimeStampLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.TimeStampLabel:SetText("TimeStamp: ")
    self.TimeStampLabel:SetMouseVisible(false)

    self.TotalDamageLabel = Turbine.UI.Label()
    self.TotalDamageLabel:SetParent(self.StatContainer2)
    self.TotalDamageLabel:SetPosition(0, 70)
    self.TotalDamageLabel:SetSize(300, 20)
    self.TotalDamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.TotalDamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.TotalDamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TotalDamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.TotalDamageLabel:SetText("Total Damage: ")
    self.TotalDamageLabel:SetMouseVisible(false)

    self.TotalHitsLabel = Turbine.UI.Label()
    self.TotalHitsLabel:SetParent(self.StatContainer2)
    self.TotalHitsLabel:SetPosition(0, 90)
    self.TotalHitsLabel:SetSize(300, 20)
    self.TotalHitsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.TotalHitsLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.TotalHitsLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TotalHitsLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.TotalHitsLabel:SetText("Total Hits: ")
    self.TotalHitsLabel:SetMouseVisible(false)

    self.TotalCritsLabel = Turbine.UI.Label()
    self.TotalCritsLabel:SetParent(self.StatContainer2)
    self.TotalCritsLabel:SetPosition(0, 110)
    self.TotalCritsLabel:SetSize(300, 20)
    self.TotalCritsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.TotalCritsLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.TotalCritsLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TotalCritsLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.TotalCritsLabel:SetText("Crits: ")
    self.TotalCritsLabel:SetMouseVisible(false)

    self.TotalDevLabel = Turbine.UI.Label()
    self.TotalDevLabel:SetParent(self.StatContainer2)
    self.TotalDevLabel:SetPosition(0, 130)
    self.TotalDevLabel:SetSize(300, 20)
    self.TotalDevLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.TotalDevLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.TotalDevLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TotalDevLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.TotalDevLabel:SetText("Devs: ")
    self.TotalDevLabel:SetMouseVisible(false)

    self.ActionLabel = Turbine.UI.Label()
    self.ActionLabel:SetParent(self.StatContainer2)
    self.ActionLabel:SetPosition(0, 150)
    self.ActionLabel:SetSize(300, 20)
    self.ActionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.ActionLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.ActionLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.ActionLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.ActionLabel:SetText("Actions: ")
    self.ActionLabel:SetMouseVisible(false)

    self.ActionPerSecondLabel = Turbine.UI.Label()
    self.ActionPerSecondLabel:SetParent(self.StatContainer2)
    self.ActionPerSecondLabel:SetPosition(0, 170)
    self.ActionPerSecondLabel:SetSize(300, 20)
    self.ActionPerSecondLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.ActionPerSecondLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.ActionPerSecondLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.ActionPerSecondLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.ActionPerSecondLabel:SetText("APS: ")
    self.ActionPerSecondLabel:SetMouseVisible(false)

    self.ItemActionPerSecondLabel = Turbine.UI.Label()
    self.ItemActionPerSecondLabel:SetParent(self.StatContainer2)
    self.ItemActionPerSecondLabel:SetPosition(0, 190)
    self.ItemActionPerSecondLabel:SetSize(300, 20)
    self.ItemActionPerSecondLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.ItemActionPerSecondLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.ItemActionPerSecondLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.ItemActionPerSecondLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.ItemActionPerSecondLabel:SetText("I+APS: ")
    self.ItemActionPerSecondLabel:SetMouseVisible(false)
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:ItemLabel(startTime, time, item, icon, background, name)

    local skillLabel = Turbine.UI.Label()
    skillLabel:SetParent(skillContainer)
    skillLabel:SetPosition((item - 1) * self.BarWidth, self.SkillModulo)
    skillLabel:SetSize(self.IconSize, self.IconSize)

    -- [[
    local backgroundLabel = Turbine.UI.Label()
    backgroundLabel:SetParent(skillLabel)
    backgroundLabel:SetSize(32, 32)
    backgroundLabel:SetStretchMode(1)
    backgroundLabel:SetBackground(background)
    backgroundLabel:SetSize(self.IconSize, self.IconSize)

    local iconLabel = Turbine.UI.Label()
    iconLabel:SetParent(skillLabel)
    iconLabel:SetSize(32, 32)
    iconLabel:SetStretchMode(1)
    iconLabel:SetBackground(icon)
    iconLabel:SetSize(self.IconSize, self.IconSize)
    --]]

    if skillLabel:GetLeft() < 0 or skillLabel:GetLeft() > 490 - 32 then
        skillLabel:SetVisible(false)
    else
        skillLabel:SetVisible(true)
    end

    skillLabel.PositionChanged = function()
        local XCord = skillLabel:GetLeft() 
        if XCord < 0 or XCord > 490 - 32 then
            skillLabel:SetVisible(false)
        else
            skillLabel:SetVisible(true)
        end
    end

    self.SkillModulo = (self.SkillModulo + self.IconSize) % (self.IconSize * 5)

    if not(self.SkillIcons[startTime][time]) then
        self.SkillIcons[startTime][time] = {}
    end

    self.SkillIcons[startTime][time][name] = skillLabel
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:SkillIcon(startTime, time, item, icon, name)
    local skillLabel = Turbine.UI.Label()
    skillLabel:SetParent(skillContainer)
    skillLabel:SetSize(32, 32)
    skillLabel:SetStretchMode(1)
    skillLabel:SetPosition((item - 1) * self.BarWidth, self.SkillModulo)
    skillLabel:SetBackground(icon)
    skillLabel:SetSize(self.IconSize, self.IconSize)

    if skillLabel:GetLeft() < 0 or skillLabel:GetLeft() > 490 - 32 then
        skillLabel:SetVisible(false)
    else
        skillLabel:SetVisible(true)
    end

    skillLabel.PositionChanged = function()
        local XCord = skillLabel:GetLeft() 
        if XCord < 0 or XCord > 490 - 32 then
            skillLabel:SetVisible(false)
        else
            skillLabel:SetVisible(true)
        end
    end
    self.SkillModulo = (self.SkillModulo + self.IconSize) % (self.IconSize * 5)

    if not(self.SkillIcons[startTime][time]) then
        self.SkillIcons[startTime][time] = {}
    end

    self.SkillIcons[startTime][time][name] = skillLabel
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:DropdownmenuUI()
    self.SelectionContainer = Turbine.UI.Control()
    self.SelectionContainer:SetParent(self)
    self.SelectionContainer:SetPosition(self.width / 2 - 200 - 5, 30 - 5)
    self.SelectionContainer:SetSize(400, 40)
    self.SelectionContainer:SetMouseVisible(false)
    self.SelectionContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.SelectionContainer2 = Turbine.UI.Control()
    self.SelectionContainer2:SetParent(self)
    self.SelectionContainer2:SetPosition(self.width / 2 - 200, 30)
    self.SelectionContainer2:SetSize(400 - 10, 40 - 10)
    self.SelectionContainer2:SetMouseVisible(true)
    self.SelectionContainer2:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    self.SelectionContainer2.MouseEnter = function()
        self.SelectionContainer2:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    end

    self.SelectionContainer2.MouseLeave = function()
        self.SelectionContainer2:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    end

    self.SelectionContainerPopOutBorder = Turbine.UI.Control()
    self.SelectionContainerPopOutBorder:SetParent(self)
    self.SelectionContainerPopOutBorder:SetPosition(self.width / 2 - 200 - 5, 65 - 5)
    self.SelectionContainerPopOutBorder:SetSize(400, 240)
    self.SelectionContainerPopOutBorder:SetMouseVisible(false)
    self.SelectionContainerPopOutBorder:SetVisible(false)
    self.SelectionContainerPopOutBorder:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.SelectionContainerPopOut = Turbine.UI.Control()
    self.SelectionContainerPopOut:SetParent(self.SelectionContainerPopOutBorder)
    self.SelectionContainerPopOut:SetPosition(5, 5)
    self.SelectionContainerPopOut:SetSize(400 - 10, 240 - 10)
    self.SelectionContainerPopOut:SetMouseVisible(true)
    self.SelectionContainerPopOut:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    self.SelectionContainerPopOut:SetZOrder(100)

    self.SelectionContainer2.MouseClick = function()
        self.SelectionContainerPopOutBorder:SetVisible(not(self.SelectionContainerPopOutBorder:IsVisible()))
    end


    self.SelectionLabel = Turbine.UI.Label()
    self.SelectionLabel:SetParent(self.SelectionContainer2)
    self.SelectionLabel:SetPosition(0, 0)
    self.SelectionLabel:SetSize(400 - 10, 40 - 10)
    self.SelectionLabel:SetMouseVisible(false)
    --self.SelectionLabel:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    self.SelectionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.SelectionLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    self.SelectionLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.SelectionLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.SelectionLabel:SetText("Select Parse To Analyse")

    self.PopOoutContainer = Turbine.UI.ListBox()
    self.PopOoutContainer:SetParent(self.SelectionContainerPopOut)
    self.PopOoutContainer:SetSize(380, 230)
    self.PopOoutContainer:SetPosition(0, 0)
    self.PopOoutContainer:SetVisible(true)
    --self.PopOoutContainer:SetBackColor(GetRandomColour())
    self.PopOoutContainer:SetOrientation( Turbine.UI.Orientation.Vertical )

    self.ScrollbarBackground = Turbine.UI.Control()
    self.ScrollbarBackground:SetParent( self.SelectionContainerPopOut )
    self.ScrollbarBackground:SetPosition( 380, 0 )
    self.ScrollbarBackground:SetSize( 10, 230)
    self.ScrollbarBackground:SetMouseVisible(false)
    self.ScrollbarBackground:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

    self.PopOoutContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.PopOoutContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    self.PopOoutContainerScrollbar:SetParent( self.SelectionContainerPopOut )
    self.PopOoutContainerScrollbar:SetPosition( 380, 0 )
    self.PopOoutContainerScrollbar:SetSize( 10, 230)
    self.PopOoutContainerScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    self.PopOoutContainer:SetVerticalScrollBar( self.PopOoutContainerScrollbar )

    self.AddTimestampEntry = function(Time, TimeString, HighestTarget)

        if HighestTarget == nil then return end

        local ListItem = Turbine.UI.Control()
        ListItem:SetSize(380, 34)
        ListItem:SetMouseVisible(true)
        ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

        local BackGroundControl = Turbine.UI.Control()
        BackGroundControl:SetParent(ListItem)
        BackGroundControl:SetSize(380, 30)
        BackGroundControl:SetPosition(0, 2)
        BackGroundControl:SetMouseVisible(false)
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(ListItem)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        NameLabel:SetSize(380, 30)
        NameLabel:SetPosition(0, 2)
        NameLabel:SetMouseVisible(false)
        NameLabel:SetMultiline(false)
        NameLabel:SetText(HighestTarget .." (" .. TimeString .. ")")

        self.CurrentViewingStartTime = Time
        
        ListItem.MouseClick = function()
            self.SetupStatWindows(Time)
            self.SelectionContainerPopOutBorder:SetVisible(false)
        end

        ListItem.MouseEnter = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
        end

        ListItem.MouseLeave = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
        end

        self.PopOoutContainer:AddItem(ListItem)
    end
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:PowerOverview()
    self.powerContainer = Turbine.UI.Control()
    self.powerContainer:SetParent(self)
    self.powerContainer:SetPosition(40, 80)
    self.powerContainer:SetSize(500 - 10, 220 - 10)
    self.powerContainer:SetMouseVisible(false)
    --self.powerContainer:SetBackColor(Turbine.UI.Color(0, 0, 1))

    self.powerListbox = Turbine.UI.ListBox()
    self.powerListbox:SetParent(self)
    self.powerListbox:SetSize(500-10, 200)
    self.powerListbox:SetPosition(40, 80)
    --self.powerListbox:SetBackColor(Turbine.UI.Color(0,0,0))
    self.powerListbox:SetVisible(true)
    self.powerListbox:SetMouseVisible(false)
    self.powerListbox:SetOrientation( Turbine.UI.Orientation.Horizontal )
    --self.powerListbox:SetFlippedLayout(true)
    --self.powerListbox:SetReverseFill(true)
    --self.powerListbox:SetWantsKeyEvents(true)
    --self.powerListbox:SetMouseVisible(true)

    self.listboxes["Power"] = self.powerListbox

    self.powerListbox:SetHorizontalScrollBar( self.damageContainerScrollbar )
end

function DamageHandler:AddPowerEntry(powerValue, lastPower)

        local MiddleValue = powerValue / self.MaxPower * 200
        local Entry = Turbine.UI.Control()
        Entry:SetSize(self.BarWidth, 200)
        Entry:SetMouseVisible(false)
        --Entry:SetBackColor(GetRandomColour())

        local line = Turbine.UI.Label()
        line:SetParent(Entry)
        line:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
        line:SetBackColor(Turbine.UI.Color(0.6, 0, 0, 0.6))
        line:SetMouseVisible(false)

        local numberDifference = MiddleValue -  lastPower / self.MaxPower * 200
        line:SetPosition(0, 200 - MiddleValue)
        if numberDifference > 0 then
            line:SetSize(self.BarWidth, numberDifference + 3)
        elseif numberDifference < 0 then
            line:SetSize(self.BarWidth, math.abs(numberDifference) + 4)
            line:SetPosition(0, 200 - MiddleValue + numberDifference)
        else
            line:SetSize(self.BarWidth, 3)
        end

        self.powerListbox:AddItem(Entry)
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:MoraleOverview()
    self.moraleContainer = Turbine.UI.Control()
    self.moraleContainer:SetParent(self)
    self.moraleContainer:SetPosition(40, 80)
    self.moraleContainer:SetSize(500 - 10, 220 - 10)
    self.moraleContainer:SetMouseVisible(false)
    --self.moraleContainer:SetBackColor(Turbine.UI.Color(0, 0, 1))

    self.moraleListbox = Turbine.UI.ListBox()
    self.moraleListbox:SetParent(self)
    self.moraleListbox:SetSize(500-10, 200)
    self.moraleListbox:SetPosition(40, 80)
    self.moraleListbox:SetVisible(true)
    self.moraleListbox:SetMouseVisible(false)
    self.moraleListbox:SetOrientation( Turbine.UI.Orientation.Horizontal )
    
    self.listboxes["Morale"] = self.moraleListbox

    self.moraleListbox:SetHorizontalScrollBar( self.damageContainerScrollbar )
end

function DamageHandler:AddMoraleEntry(moraleValue, lastMorale)

        local MiddleValue = moraleValue / self.MaxMorale * 200
        local Entry = Turbine.UI.Control()
        Entry:SetSize(self.BarWidth, 200)
        Entry:SetMouseVisible(false)
        --Entry:SetBackColor(GetRandomColour())

        local line = Turbine.UI.Label()
        line:SetParent(Entry)
        local numberDifference = MiddleValue -  lastMorale / self.MaxMorale * 200

        line:SetPosition(0, 200 - MiddleValue)
        line:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
        if numberDifference > 0 then
            line:SetSize(self.BarWidth, numberDifference + 3)
        elseif numberDifference < 0 then
            line:SetSize(self.BarWidth, math.abs(numberDifference) + 4)
            line:SetPosition(0, 200 - MiddleValue + numberDifference)
        else
            line:SetSize(self.BarWidth, 3)
        end
        line:SetBackColor(Turbine.UI.Color(0.6, 0, 0.6, 0))
        line:SetMouseVisible(false)

        self.moraleListbox:AddItem(Entry)
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:TotalDamageOverview()
    self.totalDamageContainer = Turbine.UI.Control()
    self.totalDamageContainer:SetParent(self)
    self.totalDamageContainer:SetPosition(40, 80)
    self.totalDamageContainer:SetSize(500 - 10, 220 - 10)
    self.totalDamageContainer:SetMouseVisible(false)

    self.totalDamageListbox = Turbine.UI.ListBox()
    self.totalDamageListbox:SetParent(self)
    self.totalDamageListbox:SetSize(500-10, 200)
    self.totalDamageListbox:SetPosition(40, 80)
    self.totalDamageListbox:SetVisible(true)
    self.totalDamageListbox:SetMouseVisible(false)
    self.totalDamageListbox:SetOrientation( Turbine.UI.Orientation.Horizontal )

    self.listboxes["TotalDamage"] = self.totalDamageListbox

    self.totalDamageListbox:SetHorizontalScrollBar( self.damageContainerScrollbar )
end

function DamageHandler:AddTotalDamageEntry(damageValue, lastDamage)

        local MiddleValue = damageValue / self.TotalMaxDamage * 200
        local Entry = Turbine.UI.Control()
        Entry:SetSize(self.BarWidth, 200)
        Entry:SetMouseVisible(false)
        --Entry:SetBackColor(GetRandomColour())

        local line = Turbine.UI.Label()
        line:SetParent(Entry)
        local numberDifference = MiddleValue -  lastDamage / self.TotalMaxDamage * 200

        line:SetPosition(0, 200 - MiddleValue)
        line:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
        if numberDifference > 0 then
            line:SetSize(self.BarWidth, numberDifference + 3)
        elseif numberDifference < 0 then
            line:SetSize(self.BarWidth, math.abs(numberDifference) + 4)
            line:SetPosition(0, 200 - MiddleValue + numberDifference)
        else
            line:SetSize(self.BarWidth, 3)
        end
        line:SetBackColor(Turbine.UI.Color(0.6, 0.6, 0, 0))
        line:SetMouseVisible(false)

        self.totalDamageListbox:AddItem(Entry)
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

function DamageHandler:ClearStatWindows()
    for key, value in pairs(self.listboxes) do
        value:ClearItems()
    end

    if self.SkillIcons then
        for key, value in pairs(self.SkillIcons) do
            for key2, value2 in pairs(value) do
                for key3, value3 in pairs(value2) do
                    value3:SetVisible(false)
                    value3:SetParent(nil)
                end
            end
        end
    end
    self.SkillModulo = 0
    self.TextBox:SetText("")
end