EffectAlertSettings = class(Turbine.UI.Control)
function EffectAlertSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,-10)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    local colorTurn = 0
    local prevItem = nil
    local prevColour = nil
    local selectedName = nil
    local selfWindowSelected = true

    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(self)
    InfoLabel:SetSize(700, 30)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(30, 460)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("Reload the plugin to see the effects of your actions. Sometimes it requires time so you need to reload an additional time in order for the data to be loaded correctly!")



    self.EffectLabelItem = function(box, name, effect)
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 600, 50 )
        listItem:SetMouseVisible(true)
        local colourddd = 0.125 + colorTurn * 0.125
        listItem:SetBackColor(Turbine.UI.Color(colourddd, colourddd, colourddd))
        if colorTurn == 1 then
            colorTurn = 0
        else
            colorTurn = 1
        end
        --listItem:SetBackColor(GetRandomColour())
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 20)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetTop(2)
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetText("<rgb=#0071b8>Effect:</rgb> <rgb=#FF9900>" .. name)

        local AlertLabel  = Turbine.UI.Label()
        AlertLabel:SetParent(listItem)
        AlertLabel:SetSize(300, 20)
        AlertLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        AlertLabel:SetMouseVisible(false)
        AlertLabel:SetMultiline(false)
        AlertLabel:SetTop(2)
        AlertLabel:SetMarkupEnabled(true)
        AlertLabel:SetText("<rgb=#0071b8>Alert:</rgb> <rgb=#FF9900>" .. effect[2])
        AlertLabel:SetPosition(150, 2)

        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(100, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(0, 20)
        DurationLabel:SetMarkupEnabled(true)
        DurationLabel:SetText("<rgb=#0071b8>Duration:</rgb> <rgb=#FF9900>" .. effect[1])

        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(100, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(120, 20)
        DurationLabel:SetMarkupEnabled(true)
        local yesno = nil
        if effect[4] then
            yesno = "<rgb=#00FF00>yes"
        else
            yesno = "<rgb=#FF0000>no"
        end 
        DurationLabel:SetText("<rgb=#0071b8>Countdown:</rgb> " .. yesno)

        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(300, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(180, 20)
        DurationLabel:SetMarkupEnabled(true)
        if effect[5] ~= nil then 
            DurationLabel:SetText("<rgb=#0071b8>Soundeffect: <rgb=#00FF00>")-- .. effect[5])
        else
            DurationLabel:SetText("<rgb=#0071b8>Soundeffect: <rgb=#FF0000>No Soundeffect")
        end


        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(100, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(410, 20)
        DurationLabel:SetMarkupEnabled(true)
        DurationLabel:SetText("<rgb=#0071b8>Icon:</rgb> ")

        local DurationLabel = Turbine.UI.Label()
        DurationLabel:SetParent(listItem)
        DurationLabel:SetSize(100, 20)
        DurationLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DurationLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DurationLabel:SetTop(2)
        DurationLabel:SetPosition(480, 20)
        DurationLabel:SetMarkupEnabled(true)
        if effect[3] == true then
            DurationLabel:SetText("<rgb=#00FF00>From Effect")
        elseif effect[3] ~= nil then
            DurationLabel:SetText("<rgb=#0000FF>From plugin")
        else
            DurationLabel:SetText("<rgb=#FF0000>None")
        end

        listItem.MouseClick = function()
            if prevItem ~= nil then
                prevItem:SetBackColor(prevColour)
            end
            prevItem = listItem
            prevColour = prevItem:GetBackColor()
            listItem:SetBackColor(Turbine.UI.Color.White)
            selectedName = name
        end

        return (listItem)
    end

    self.CreateEffectItem = function(box, name, effect)
        box:AddItem( self.EffectLabelItem(box, name, effect) )
    end

    local SelfEffects = Turbine.UI.Control()
    SelfEffects:SetSize(width, height - 100)
    SelfEffects:SetParent(self)
    SelfEffects:SetPosition(0, 40)

    local container = Turbine.UI.ListBox()
    container:SetParent(SelfEffects)
    container:SetSize(600, height - 200)
    container:SetPosition(30, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( SelfEffects )
    containerScrollbar:SetPosition( 630 - 10, 50 )
    containerScrollbar:SetSize( 10, height - 200 )
    container:SetVerticalScrollBar( containerScrollbar )

    local sortedEffects = {}
    for key, value in pairs(E.EffectsAdded) do table.insert( sortedEffects,key ) end
    table.sort( sortedEffects )

    for key, value in pairs(sortedEffects) do
        self.CreateEffectItem(container, value, E.EffectsAdded[value])
    end

    local SelfEffects2 = Turbine.UI.Control()
    SelfEffects2:SetSize(width, height - 100)
    SelfEffects2:SetParent(self)
    SelfEffects2:SetPosition(0, 40)
    SelfEffects2:SetVisible(false)

    local container = Turbine.UI.ListBox()
    container:SetParent(SelfEffects2)
    container:SetSize(600, height - 200)
    container:SetPosition(30, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( SelfEffects2 )
    containerScrollbar:SetPosition( 630 - 10, 50 )
    containerScrollbar:SetSize( 10, height - 200 )
    container:SetVerticalScrollBar( containerScrollbar )

    local sortedEffects = {}
    for key, value in pairs(E.AllEffectsAdded) do table.insert( sortedEffects,key ) end
    table.sort( sortedEffects )

    for key, value in pairs(sortedEffects) do
        self.CreateEffectItem(container, value, E.AllEffectsAdded[value])
    end

    -- Save effects

    local SelfEffects3 = Turbine.UI.Control()
    SelfEffects3:SetSize(width, height - 100)
    SelfEffects3:SetParent(self)
    SelfEffects3:SetPosition(0, 40)
    SelfEffects3:SetVisible(false)

    local container = Turbine.UI.ListBox()
    container:SetParent(SelfEffects3)
    container:SetSize(600, height - 200)
    container:SetPosition(30, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( SelfEffects3 )
    containerScrollbar:SetPosition( 630 - 10, 50 )
    containerScrollbar:SetSize( 10, height - 200 )
    container:SetVerticalScrollBar( containerScrollbar )

    local sortedEffects = {}
    for key, value in pairs(RemovedBasicPlayerEffectsAll) do table.insert( sortedEffects,key ) end
    table.sort( sortedEffects )

    for key, value in pairs(sortedEffects) do
        self.CreateEffectItem(container, value, RemovedBasicPlayerEffectsAll[value])
    end

    local SelfEffects4 = Turbine.UI.Control()
    SelfEffects4:SetSize(width, height - 100)
    SelfEffects4:SetParent(self)
    SelfEffects4:SetPosition(0, 40)
    SelfEffects4:SetVisible(false)

    local container = Turbine.UI.ListBox()
    container:SetParent(SelfEffects4)
    container:SetSize(600, height - 200)
    container:SetPosition(30, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( SelfEffects4 )
    containerScrollbar:SetPosition( 630 - 10, 50 )
    containerScrollbar:SetSize( 10, height - 200 )
    container:SetVerticalScrollBar( containerScrollbar )

    local sortedEffects = {}
    for key, value in pairs(RemovedBasicPlayerEffectsSelf) do table.insert( sortedEffects,key ) end
    table.sort( sortedEffects )

    for key, value in pairs(sortedEffects) do
        self.CreateEffectItem(container, value, RemovedBasicPlayerEffectsSelf[value])
    end

    local SwitchButton = Turbine.UI.Lotro.Button()
    SwitchButton:SetParent(self)
    SwitchButton:SetSize(150, 15)
    SwitchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SwitchButton:SetMouseVisible(true)
    SwitchButton:SetPosition(30, 40)
    SwitchButton:SetText("Self player effects")

    SwitchButton.Click = function()
        selfWindowSelected = true
        SelfEffects:SetVisible(true)
        SelfEffects2:SetVisible(false)
        SelfEffects3:SetVisible(false)
        SelfEffects4:SetVisible(false)
    end

    local SwitchButton = Turbine.UI.Lotro.Button()
    SwitchButton:SetParent(self)
    SwitchButton:SetSize(150, 15)
    SwitchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SwitchButton:SetMouseVisible(true)
    SwitchButton:SetPosition(180, 40)
    SwitchButton:SetText("Group player effects")

    SwitchButton.Click = function()
        selfWindowSelected = false
        SelfEffects:SetVisible(false)
        SelfEffects2:SetVisible(true)
        SelfEffects3:SetVisible(false)
        SelfEffects4:SetVisible(false)
    end

    local SwitchButton = Turbine.UI.Lotro.Button()
    SwitchButton:SetParent(self)
    SwitchButton:SetSize(150, 15)
    SwitchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SwitchButton:SetMouseVisible(true)
    SwitchButton:SetPosition(330, 40)
    SwitchButton:SetText("Removed group effects")

    SwitchButton.Click = function()
        selfWindowSelected = false
        SelfEffects:SetVisible(false)
        SelfEffects2:SetVisible(false)
        SelfEffects3:SetVisible(true)
        SelfEffects4:SetVisible(false)
    end

    local SwitchButton = Turbine.UI.Lotro.Button()
    SwitchButton:SetParent(self)
    SwitchButton:SetSize(150, 15)
    SwitchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SwitchButton:SetMouseVisible(true)
    SwitchButton:SetPosition(330, 40)
    SwitchButton:SetText("Removed group effects")

    SwitchButton.Click = function()
        selfWindowSelected = false
        SelfEffects:SetVisible(false)
        SelfEffects2:SetVisible(false)
        SelfEffects3:SetVisible(true)
        SelfEffects4:SetVisible(false)
    end

    local SwitchButton = Turbine.UI.Lotro.Button()
    SwitchButton:SetParent(self)
    SwitchButton:SetSize(150, 15)
    SwitchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SwitchButton:SetMouseVisible(true)
    SwitchButton:SetPosition(480, 40)
    SwitchButton:SetText("Removed self effects")

    SwitchButton.Click = function()
        selfWindowSelected = true
        SelfEffects:SetVisible(false)
        SelfEffects2:SetVisible(false)
        SelfEffects3:SetVisible(false)
        SelfEffects4:SetVisible(true)
    end

    local SwitchButton = Turbine.UI.Lotro.Button()
    SwitchButton:SetParent(self)
    SwitchButton:SetSize(100, 15)
    SwitchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SwitchButton:SetMouseVisible(true)
    SwitchButton:SetPosition(635, 90)
    SwitchButton:SetText("Re-Add effect")

    SwitchButton.Click = function()
        if selectedName == nil then return end
        if selfWindowSelected then
            if AddedCharPlayerEffectsSelf[selectedName] then
                AddedCharPlayerEffectsSelf[selectedName] = nil
            end
            RemovedBasicPlayerEffectsSelf[selectedName] = nil
            
        else
            if AddedCharPlayerEffectsAll[selectedName] then
                AddedCharPlayerEffectsAll[selectedName] = nil
            end
            RemovedBasicPlayerEffectsAll[selectedName] = nil
            
        end
        InfoLabel:SetVisible(true)
    end

    local SwitchButton = Turbine.UI.Lotro.Button()
    SwitchButton:SetParent(self)
    SwitchButton:SetSize(100, 15)
    SwitchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SwitchButton:SetMouseVisible(true)
    SwitchButton:SetPosition(635, 120)
    SwitchButton:SetText("Remove effect")

    SwitchButton.Click = function()
        if selectedName == nil then return end
        if selfWindowSelected then
            if AddedCharPlayerEffectsSelf[selectedName] then
                AddedCharPlayerEffectsSelf[selectedName] = nil
            else
                RemovedBasicPlayerEffectsSelf[selectedName] = E.EffectsAdded[selectedName]
            end
        else
            if AddedCharPlayerEffectsAll[selectedName] then
                AddedCharPlayerEffectsAll[selectedName] = nil
            else
                RemovedBasicPlayerEffectsAll[selectedName] = E.AllEffectsAdded[selectedName]
            end
        end
        InfoLabel:SetVisible(true)
    end

    local TypeButton = Turbine.UI.Lotro.Button()
    TypeButton:SetParent(self)
    TypeButton:SetSize(100, 15)
    TypeButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    TypeButton:SetMouseVisible(true)
    TypeButton:SetPosition(105, 430)
    TypeButton:SetText("Self")

    TypeButton.Click = function()
        if TypeButton:GetText() == "Self" then
            TypeButton:SetText("Group")
        else
            TypeButton:SetText("Self")
        end
    end

    local ItemTextBox = Turbine.UI.Lotro.TextBox()
    ItemTextBox:SetParent(self)
    ItemTextBox:SetSize(150, 30)
    ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox:SetMouseVisible(false)
    ItemTextBox:SetPosition(30, 400)
    ItemTextBox:SetMultiline(false)
    ItemTextBox:SetText("Effect")

    local ItemTextBox2 = Turbine.UI.Lotro.TextBox()
    ItemTextBox2:SetParent(self)
    ItemTextBox2:SetSize(350, 30)
    ItemTextBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox2:SetMouseVisible(false)
    ItemTextBox2:SetMultiline(false)
    ItemTextBox2:SetPosition(180, 400)
    ItemTextBox2:SetText("Alert")

    local ItemTextBox3 = Turbine.UI.Lotro.TextBox()
    ItemTextBox3:SetParent(self)
    ItemTextBox3:SetSize(100, 30)
    ItemTextBox3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox3:SetMouseVisible(false)
    ItemTextBox3:SetPosition(530, 400)
    ItemTextBox3:SetMultiline(false)
    ItemTextBox3:SetText("Duration")

    local CountdownButton = Turbine.UI.Lotro.Button()
    CountdownButton:SetParent(self)
    CountdownButton:SetSize(100, 15)
    CountdownButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    CountdownButton:SetMouseVisible(true)
    CountdownButton:SetPosition(205, 430)
    CountdownButton:SetText("Countdown")

    CountdownButton.Click = function()
        if CountdownButton:GetText() == "No" then
            CountdownButton:SetText("Yes")
        else
            CountdownButton:SetText("No")
        end
    end

    local IconButton = Turbine.UI.Lotro.Button()
    IconButton:SetParent(self)
    IconButton:SetSize(100, 15)
    IconButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    IconButton:SetMouseVisible(true)
    IconButton:SetPosition(305, 430)
    IconButton:SetText("Icon")

    IconButton.Click = function()
        if IconButton:GetText() == "None" then
            IconButton:SetText("Effect")
        else
            IconButton:SetText("None")
        end
    end

    local menu = Turbine.UI.ContextMenu()

    local SoundeffectButton = Turbine.UI.Lotro.Button()
    SoundeffectButton:SetParent(self)
    SoundeffectButton:SetSize(100, 15)
    SoundeffectButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SoundeffectButton:SetMouseVisible(true)
    SoundeffectButton:SetPosition(405, 430)
    SoundeffectButton:SetText("SoundEffect")

    SoundeffectButton.Click = function()
        menu:ShowMenu()
    end

    local menuItems = menu:GetItems()
    for key, value in pairs( Sounds:GetSoundList() ) do
        local menuItem = Turbine.UI.MenuItem( key )
        menuItems:Add(menuItem)
        menuItem.Click = function()
            SoundeffectButton:SetText(key)
        end
        --ChatOutput(fontName)
    end

    local CreateButton = Turbine.UI.Lotro.Button()
    CreateButton:SetParent(self)
    CreateButton:SetSize(100, 15)
    CreateButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    CreateButton:SetMouseVisible(true)
    CreateButton:SetPosition(505, 430)
    CreateButton:SetText("Make Alert")

    CreateButton.Click = function()
        local typetype = TypeButton:GetText()
        local effect = ItemTextBox:GetText()
        local alert = ItemTextBox2:GetText()
        local duration = tonumber(ItemTextBox3:GetText() )
        local countdown = CountdownButton:GetText()
        local icon = IconButton:GetText()
        local soundeffect = SoundeffectButton:GetText()
        if effect ~= "Effect" and alert ~= "Alert" and duration ~= nil and countdown ~= "Countdown" and icon ~= "Icon" and soundeffect ~= "SoundEffect" then
            if icon == "None" then 
                icon = nil
            else
                icon = true
            end

            if countdown == "No" then 
                countdown = nil
            else
                countdown = true
            end

            local item = {duration, alert, icon, countdown, Sounds:GetSoundList()[soundeffect]}
            if typetype == "Self" then
                AddedCharPlayerEffectsSelf[effect] = item
            elseif typetype == "Group" then
                AddedCharPlayerEffectsAll[effect] = item
            end
            InfoLabel:SetVisible(true)
        else
            ChatOutput("Failed to add effect, make sure you have all options filled!")
        end
    end
end

EffectAlertDualSettings = class(Turbine.UI.Control)
function EffectAlertDualSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SkillSettings = EffectAlertSettings(self)
    import "PrimePlugins.RaidTools.EffectSettings"
    local WindowSettings = EffectSettings(self)

    local AllButton = Turbine.UI.Lotro.Button()
    AllButton:SetParent(self)
    AllButton:SetSize(200, 15)
    AllButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    AllButton:SetMouseVisible(true)
    AllButton:SetPosition(100, 10)
    AllButton:SetText("Alert settings")

    AllButton.Click = function()
        SkillSettings:SetVisible(true)
        WindowSettings:SetVisible(false)
    end

    local AllButton = Turbine.UI.Lotro.Button()
    AllButton:SetParent(self)
    AllButton:SetSize(200, 15)
    AllButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    AllButton:SetMouseVisible(true)
    AllButton:SetPosition(300, 10)
    AllButton:SetText("Window settings")

    AllButton.Click = function()
        SkillSettings:SetVisible(false)
        WindowSettings:SetVisible(true)
    end

end