LootWindowSettings = class(Turbine.UI.Control)
function LootWindowSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,-30)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    
    --E.PlayerEffects ->
    --E.AllPlayerEffects -> Generic group effects

    local AllButton = Turbine.UI.Lotro.Button()
    AllButton:SetParent(self)
    AllButton:SetSize(200, 15)
    AllButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    AllButton:SetMouseVisible(true)
    AllButton:SetPosition(175, 50)
    AllButton:SetText("Instance Chests")

    local SelfButton = Turbine.UI.Lotro.Button()
    SelfButton:SetParent(self)
    SelfButton:SetSize(200, 15)
    SelfButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SelfButton:SetMouseVisible(true)
    SelfButton:SetPosition(450, 50)
    SelfButton:SetText("Raid Chests")

    local AllPlayerEffectWindow = Turbine.UI.Control()
    AllPlayerEffectWindow:SetSize(width, height - 75)
    AllPlayerEffectWindow:SetPosition(0, 75)
    AllPlayerEffectWindow:SetParent(self)

    local SpecificPlayerEffectWindow = Turbine.UI.Control()
    SpecificPlayerEffectWindow:SetSize(width, height - 75)
    SpecificPlayerEffectWindow:SetPosition(0, 75)
    SpecificPlayerEffectWindow:SetParent(self)
    SpecificPlayerEffectWindow:SetVisible(false)

    self.MakeAllPlayerEffects = function()
        --AllPlayerEffectWindow:SetBackColor(GoldColor)
    
        local InfoLabel = Turbine.UI.Label()
        InfoLabel:SetParent(AllPlayerEffectWindow)
        InfoLabel:SetSize(200, 100)
        InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        InfoLabel:SetMouseVisible(false)
        InfoLabel:SetPosition(300, 300)
        InfoLabel:SetVisible(false)
        InfoLabel:SetText("Reload the plugin to see the effects of your actions. Sometimes it requires time so you need to reload an additional time in order for the data to be loaded correctly!")
    
        local DescriptionLabel = Turbine.UI.Label()
        DescriptionLabel:SetParent(AllPlayerEffectWindow)
        DescriptionLabel:SetSize(200, 15)
        DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DescriptionLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DescriptionLabel:SetPosition(30, 35)
        DescriptionLabel:SetText("Currently tracked chests ")
    
        local ItemSelectedInfoLabel = Turbine.UI.Label()
        ItemSelectedInfoLabel:SetParent(AllPlayerEffectWindow)
        ItemSelectedInfoLabel:SetSize(200, 15)
        ItemSelectedInfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemSelectedInfoLabel:SetMouseVisible(false)
        ItemSelectedInfoLabel:SetPosition(300, 50)
        ItemSelectedInfoLabel:SetText("Chest selected:")
    
        local ItemSelectedLabel = Turbine.UI.Label()
        ItemSelectedLabel:SetParent(AllPlayerEffectWindow)
        ItemSelectedLabel:SetSize(200, 15)
        ItemSelectedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemSelectedLabel:SetMouseVisible(false)
        --ItemSelectedLabel:SetMultiline(false)
        ItemSelectedLabel:SetPosition(300, 70)
    
        local RemoveButton = Turbine.UI.Lotro.Button()
        RemoveButton:SetParent(AllPlayerEffectWindow)
        RemoveButton:SetSize(100, 15)
        RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemoveButton:SetMouseVisible(false)
        RemoveButton:SetPosition(300, 90)
        RemoveButton:SetText("Remove Chest")
    
        RemoveButton.Click = function()
            --TargetEffects[ItemSelectedLabel:GetText()] = nil
            if AddedInstanceChests[ItemSelectedLabel:GetText()] then 
                AddedInstanceChests[ItemSelectedLabel:GetText()] = nil
            else
                RemovedInstanceChests[ItemSelectedLabel:GetText()] = SpecialChestNames[ItemSelectedLabel:GetText()]--E.PlayerEffects[ItemSelectedLabel:GetText()]
            end
            ChatOutput("Removed Chest: " .. ItemSelectedLabel:GetText())
            InfoLabel:SetVisible(true)
        end
    
        local AddButton = Turbine.UI.Lotro.Button()
        AddButton:SetParent(AllPlayerEffectWindow)
        AddButton:SetSize(100, 15)
        AddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        AddButton:SetMouseVisible(false)
        AddButton:SetPosition(400, 90)
        AddButton:SetText("Re-Add Chest")
    
        AddButton.Click = function()
            --E.AllPlayerEffects[ItemSelectedLabel:GetText()] = RemovedBasicSkillTimersAll[ItemSelectedLabel:GetText()]
            RemovedInstanceChests[ItemSelectedLabel:GetText()] = nil
            ChatOutput("ReAdded chest: " .. ItemSelectedLabel:GetText())
            InfoLabel:SetVisible(true)
        end
    
        local container = Turbine.UI.ListBox()
        container:SetParent(AllPlayerEffectWindow)
        container:SetSize(200, height - 100)
        container:SetPosition(30, 50)
        --container:SetBackColor(GoldColor)
        container:SetVisible(true)
        container:SetWantsKeyEvents(true)
        container:SetMouseVisible(true)
    
        local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
        containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
        containerScrollbar:SetParent( AllPlayerEffectWindow )
        containerScrollbar:SetPosition( 230 - 10, 50 )
        containerScrollbar:SetSize( 10, height - 100 )
        container:SetVerticalScrollBar( containerScrollbar )
    
        local sortedAllPlayerSkills = {}
        for key, value in pairs(SpecialChestNames) do table.insert( sortedAllPlayerSkills, key ) end
        table.sort( sortedAllPlayerSkills )
    
        for key, value in pairs(sortedAllPlayerSkills) do
            AddListItem(value, container, ItemSelectedLabel, SpecialChestNames[value])
        end
    
        -- [1] duration [2] name [3] unique [4] activity timer [5] show activity
    
        -- Chest name    
        local ItemTextBox = Turbine.UI.Lotro.TextBox()
        ItemTextBox:SetParent(AllPlayerEffectWindow)
        ItemTextBox:SetSize(200, 30)
        ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemTextBox:SetMouseVisible(false)
        ItemTextBox:SetPosition(300, 170)
        ItemTextBox:SetText("Chest name")
    
        -- Key    
        local ItemTextBox2 = Turbine.UI.Lotro.TextBox()
        ItemTextBox2:SetParent(AllPlayerEffectWindow)
        ItemTextBox2:SetSize(200, 30)
        ItemTextBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemTextBox2:SetMouseVisible(false)
        ItemTextBox2:SetPosition(300, 200)
        ItemTextBox2:SetText("Alias")
    
        local TextAddButton = Turbine.UI.Lotro.Button()
        TextAddButton:SetParent(AllPlayerEffectWindow)
        TextAddButton:SetSize(200, 15)
        TextAddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        TextAddButton:SetMouseVisible(false)
        TextAddButton:SetPosition(300, 250)
        TextAddButton:SetText("Add New Chest")
    
        TextAddButton.Click = function()
            if ItemTextBox:GetText() ~= "Chest name" and ItemTextBox2:GetText() ~= "Alias" then
                AddedInstanceChests[ItemTextBox:GetText()] = ItemTextBox2:GetText()
                ChatOutput("Added Chest: " .. ItemTextBox:GetText() .. " - " .. ItemTextBox2:GetText())
                InfoLabel:SetVisible(true)
            end
        end
    
        local RemovedDescriptionLabel = Turbine.UI.Label()
        RemovedDescriptionLabel:SetParent(AllPlayerEffectWindow)
        RemovedDescriptionLabel:SetSize(200, 15)
        RemovedDescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemovedDescriptionLabel:SetMouseVisible(false)
        RemovedDescriptionLabel:SetPosition(530, 35)
        RemovedDescriptionLabel:SetText("Deleted default chests: ")
    
        local removedContainer = Turbine.UI.ListBox()
        removedContainer:SetParent(AllPlayerEffectWindow)
        removedContainer:SetSize(200, height - 100)
        removedContainer:SetPosition(530, 50)
        --removedContainer:SetBackColor(GoldColor)
        removedContainer:SetVisible(true)
        removedContainer:SetWantsKeyEvents(true)
        removedContainer:SetMouseVisible(true)
    
        local removedContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
        removedContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
        removedContainerScrollbar:SetParent( self )
        removedContainerScrollbar:SetPosition( 730 - 10, 50 )
        removedContainerScrollbar:SetSize( 10, height - 100 )
        removedContainer:SetVerticalScrollBar( removedContainerScrollbar )
    
        local RemovedSortedEffects = {}
        for key, value in pairs(RemovedInstanceChests) do table.insert( RemovedSortedEffects,key ) end
        table.sort( RemovedSortedEffects )
    
        for key, value in pairs(RemovedSortedEffects) do
            AddListItem(value, removedContainer, ItemSelectedLabel, RemovedInstanceChests[value])
        end
    end

    self.MakeSpecificPlayerEffects = function()
        --AllPlayerEffectWindow:SetBackColor(GoldColor)

        local InfoLabel = Turbine.UI.Label()
        InfoLabel:SetParent(SpecificPlayerEffectWindow)
        InfoLabel:SetSize(200, 100)
        InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        InfoLabel:SetMouseVisible(false)
        InfoLabel:SetPosition(300, 300)
        InfoLabel:SetVisible(false)
        InfoLabel:SetText("Reload the plugin to see the effects of your actions. Sometimes it requires time so you need to reload an additional time in order for the data to be loaded correctly!")
    
        local DescriptionLabel = Turbine.UI.Label()
        DescriptionLabel:SetParent(SpecificPlayerEffectWindow)
        DescriptionLabel:SetSize(200, 15)
        DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        DescriptionLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        DescriptionLabel:SetPosition(30, 35)
        DescriptionLabel:SetText("Currently tracked chests ")
    
        local ItemSelectedInfoLabel = Turbine.UI.Label()
        ItemSelectedInfoLabel:SetParent(SpecificPlayerEffectWindow)
        ItemSelectedInfoLabel:SetSize(200, 15)
        ItemSelectedInfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemSelectedInfoLabel:SetMouseVisible(false)
        ItemSelectedInfoLabel:SetPosition(300, 50)
        ItemSelectedInfoLabel:SetText("Chest selected:")
    
        local ItemSelectedLabel = Turbine.UI.Label()
        ItemSelectedLabel:SetParent(SpecificPlayerEffectWindow)
        ItemSelectedLabel:SetSize(200, 15)
        ItemSelectedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemSelectedLabel:SetMouseVisible(false)
        --ItemSelectedLabel:SetMultiline(false)
        ItemSelectedLabel:SetPosition(300, 70)
    
        local RemoveButton = Turbine.UI.Lotro.Button()
        RemoveButton:SetParent(SpecificPlayerEffectWindow)
        RemoveButton:SetSize(100, 15)
        RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemoveButton:SetMouseVisible(false)
        RemoveButton:SetPosition(300, 90)
        RemoveButton:SetText("Remove Chest")
    
        RemoveButton.Click = function()
            --TargetEffects[ItemSelectedLabel:GetText()] = nil
            if AddedRaidChests[ItemSelectedLabel:GetText()] then 
                AddedRaidChests[ItemSelectedLabel:GetText()] = nil
            else
                RemovedRaidChests[ItemSelectedLabel:GetText()] = SpecialRaidChestNames[ItemSelectedLabel:GetText()]--E.PlayerEffects[ItemSelectedLabel:GetText()]
            end
            ChatOutput("Removed Chest: " .. ItemSelectedLabel:GetText())
            InfoLabel:SetVisible(true)
        end
    
        local AddButton = Turbine.UI.Lotro.Button()
        AddButton:SetParent(SpecificPlayerEffectWindow)
        AddButton:SetSize(100, 15)
        AddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        AddButton:SetMouseVisible(false)
        AddButton:SetPosition(400, 90)
        AddButton:SetText("Re-Add Chest")
    
        AddButton.Click = function()
            --E.AllPlayerEffects[ItemSelectedLabel:GetText()] = RemovedBasicSkillTimersAll[ItemSelectedLabel:GetText()]
            RemovedRaidChests[ItemSelectedLabel:GetText()] = nil
            ChatOutput("ReAdded chest: " .. ItemSelectedLabel:GetText())
            InfoLabel:SetVisible(true)
        end
    
        local container = Turbine.UI.ListBox()
        container:SetParent(SpecificPlayerEffectWindow)
        container:SetSize(200, height - 100)
        container:SetPosition(30, 50)
        --container:SetBackColor(GoldColor)
        container:SetVisible(true)
        container:SetWantsKeyEvents(true)
        container:SetMouseVisible(true)
    
        local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
        containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
        containerScrollbar:SetParent( SpecificPlayerEffectWindow )
        containerScrollbar:SetPosition( 230 - 10, 50 )
        containerScrollbar:SetSize( 10, height - 100 )
        container:SetVerticalScrollBar( containerScrollbar )
    
        local sortedAllPlayerSkills = {}
        for key, value in pairs(SpecialRaidChestNames) do table.insert( sortedAllPlayerSkills, key ) end
        table.sort( sortedAllPlayerSkills )
    
        for key, value in pairs(sortedAllPlayerSkills) do
            AddListItem(value, container, ItemSelectedLabel, SpecialRaidChestNames[value])
        end
    
        -- [1] duration [2] name [3] unique [4] activity timer [5] show activity
    
        -- Chest name    
        local ItemTextBox = Turbine.UI.Lotro.TextBox()
        ItemTextBox:SetParent(SpecificPlayerEffectWindow)
        ItemTextBox:SetSize(200, 30)
        ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemTextBox:SetMouseVisible(false)
        ItemTextBox:SetPosition(300, 170)
        ItemTextBox:SetText("Chest name")
    
        -- Key    
        local ItemTextBox2 = Turbine.UI.Lotro.TextBox()
        ItemTextBox2:SetParent(SpecificPlayerEffectWindow)
        ItemTextBox2:SetSize(200, 30)
        ItemTextBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemTextBox2:SetMouseVisible(false)
        ItemTextBox2:SetPosition(300, 200)
        ItemTextBox2:SetText("Alias")
    
        local TextAddButton = Turbine.UI.Lotro.Button()
        TextAddButton:SetParent(SpecificPlayerEffectWindow)
        TextAddButton:SetSize(200, 15)
        TextAddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        TextAddButton:SetMouseVisible(false)
        TextAddButton:SetPosition(300, 250)
        TextAddButton:SetText("Add New Chest")
    
        TextAddButton.Click = function()
            if ItemTextBox:GetText() ~= "Chest name" and ItemTextBox2:GetText() ~= "Alias" then
                AddedRaidChests[ItemTextBox:GetText()] = ItemTextBox2:GetText()
                ChatOutput("Added Chest: " .. ItemTextBox:GetText() .. " - " .. ItemTextBox2:GetText())
                InfoLabel:SetVisible(true)
            end
        end
    
        local RemovedDescriptionLabel = Turbine.UI.Label()
        RemovedDescriptionLabel:SetParent(SpecificPlayerEffectWindow)
        RemovedDescriptionLabel:SetSize(200, 15)
        RemovedDescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemovedDescriptionLabel:SetMouseVisible(false)
        RemovedDescriptionLabel:SetPosition(530, 35)
        RemovedDescriptionLabel:SetText("Deleted default chests: ")
    
        local removedContainer = Turbine.UI.ListBox()
        removedContainer:SetParent(SpecificPlayerEffectWindow)
        removedContainer:SetSize(200, height - 100)
        removedContainer:SetPosition(530, 50)
        --removedContainer:SetBackColor(GoldColor)
        removedContainer:SetVisible(true)
        removedContainer:SetWantsKeyEvents(true)
        removedContainer:SetMouseVisible(true)
    
        local removedContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
        removedContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
        removedContainerScrollbar:SetParent( self )
        removedContainerScrollbar:SetPosition( 730 - 10, 50 )
        removedContainerScrollbar:SetSize( 10, height - 100 )
        removedContainer:SetVerticalScrollBar( removedContainerScrollbar )
    
        local RemovedSortedEffects = {}
        for key, value in pairs(RemovedRaidChests) do table.insert( RemovedSortedEffects,key ) end
        table.sort( RemovedSortedEffects )
    
        for key, value in pairs(RemovedSortedEffects) do
            AddListItem(value, removedContainer, ItemSelectedLabel, RemovedRaidChests[value])
        end
    end

    self.MakeAllPlayerEffects()
    self.MakeSpecificPlayerEffects()

    AllButton.Click = function()
        AllPlayerEffectWindow:SetVisible(true)
        SpecificPlayerEffectWindow:SetVisible(false)
    end

    SelfButton.Click = function()
        AllPlayerEffectWindow:SetVisible(false)
        SpecificPlayerEffectWindow:SetVisible(true)
    end

    self.TimezoneBox = Turbine.UI.Lotro.TextBox()
    self.TimezoneBox:SetParent(self)
    self.TimezoneBox:SetSize(30, 20)
    self.TimezoneBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TimezoneBox:SetPosition(400, 400)
    self.TimezoneBox:SetText(AccountData["TimeZone"])

    self.TimeZoneLabel = Turbine.UI.Label()
    self.TimeZoneLabel:SetParent(self)
    self.TimeZoneLabel:SetSize(60, 20)
    self.TimeZoneLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TimeZoneLabel:SetPosition(340, 400)
    self.TimeZoneLabel:SetText("GMT")

    self.TimeZoneBUtton = Turbine.UI.Lotro.Button()
    self.TimeZoneBUtton:SetParent(self)
    self.TimeZoneBUtton:SetSize(100, 20)
    self.TimeZoneBUtton:SetPosition(430, 400)
    self.TimeZoneBUtton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TimeZoneBUtton:SetText("Set Timezone")

    self.TimeZoneBUtton.Click = function()
        local newZone = tonumber(self.TimezoneBox:GetText())
        if newZone then
            AccountData["TimeZone"] = newZone
        end
    end
    
end

