MessageWindow = class(Turbine.UI.Window)
local width = Settings.MWidth
local height = Settings.MHeight
local x = Settings.MX
local y = Settings.MY
local cooldownTimer = 0
local oldsecond = Turbine.Engine.GetDate().Second

function MessageWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(width,height)
    self:SetPosition(x,y)
    self:SetZOrder(1)

    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    self:SetWantsUpdates(true)

    self.messageBox = Turbine.UI.Label()
    self.messageBox:SetParent(self)
    self.messageBox:SetSize(width - 250,height - 20)
    self.messageBox:SetPosition(125,20)
    self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox:SetFont(Settings.MFont)
    self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox:SetMouseVisible(false)
    self.messageBox:SetVisible(false)
    self.messageBox:SetMarkupEnabled(true)
    self.messageBox:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.messageBox:SetFontStyle( Turbine.UI.FontStyle.Outline )

    local countDownVisible = false
    self.imageBox1 = Turbine.UI.Label()
    self.imageBox1:SetParent(self)
    self.imageBox1:SetSize(Settings.MIWidth, Settings.MIHeight)
    self.imageBox1:SetPosition(0, 0)
    self.imageBox1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.imageBox1:SetFont(Settings.MFont)
    self.imageBox1:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.imageBox1:SetForeColor(Turbine.UI.Color(1, 1, 1))

    self.imageBox2 = Turbine.UI.Label()
    self.imageBox2:SetParent(self)
    self.imageBox2:SetSize(Settings.MIWidth, Settings.MIHeight)
    self.imageBox2:SetPosition(width - 125, 0)
    self.imageBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.imageBox2:SetFont(Settings.MFont)
    self.imageBox2:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.imageBox2:SetForeColor(Turbine.UI.Color(1, 1, 1))

  
    self.MoveBox = Turbine.UI.Control()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(width, height)
    self.MoveBox:SetBackColor(Turbine.UI.Color(0, 1, 0))
    self.MoveBox:SetVisible(false)

    self.messageBox1 = Turbine.UI.Label()
    self.messageBox1:SetParent(self.MoveBox)
    self.messageBox1:SetSize(width, height)
    self.messageBox1:SetPosition(0,0)
    self.messageBox1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox1:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.messageBox1:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox1:SetMouseVisible(false)
    self.messageBox1:SetText("Chat Alerts")

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          if newLeft < 0 then newLeft = 0 end
          if newTop < 0 then newTop = 0 end
          if newLeft > (Turbine.UI.Display.GetWidth() - self:GetWidth()) then
            newLeft = Turbine.UI.Display.GetWidth() - self:GetWidth() end
          if newTop > (Turbine.UI.Display.GetHeight() - self:GetHeight()) then
            newTop = Turbine.UI.Display.GetHeight() - self:GetHeight() end
          self:SetPosition(newLeft,newTop)
        end
    end
    
    self.ToggleMove = function()
        self.MoveBox:SetVisible(not self.MoveBox:IsVisible())
    end
end

MessageWindow.Update = function(sender, args)
    local currentsecond = Turbine.Engine.GetDate().Second
    if(currentsecond == oldsecond) then
        return(true) 
    end

    if (cooldownTimer <= 0) then
        messageWindow.messageBox:SetVisible(false)
        messageWindow.imageBox1:SetVisible(false)
        messageWindow.imageBox2:SetVisible(false)
    end

    if(cooldownTimer > 0) then
        cooldownTimer = cooldownTimer - 1
    end

    if messageWindow.countDownVisible then
      messageWindow.imageBox1:SetText(cooldownTimer)
      messageWindow.imageBox2:SetText(cooldownTimer)
    end
    oldsecond = currentsecond
end

function MessageWindow:Message(duration, message, icon, cdVisible)
  ChatOutput(message)
  cooldownTimer = duration
  self.messageBox:SetText(message)
  self.messageBox:SetVisible(true)

  if icon ~= nil then
    self.imageBox1:SetBackground(BackgroundHandler:GetBackground(icon))
    self.imageBox1:SetVisible(true)
    self.imageBox2:SetBackground(BackgroundHandler:GetBackground(icon))
    self.imageBox2:SetVisible(true)
  else
    self.imageBox1:SetBackground("")
    self.imageBox1:SetVisible(true)
    self.imageBox2:SetBackground("")
    self.imageBox2:SetVisible(true)
  end

  if cdVisible then
    self.countDownVisible = true
    self.imageBox1:SetText(duration)
    self.imageBox2:SetText(duration)
  else 
    self.countDownVisible = false
    self.imageBox1:SetText("")
    self.imageBox2:SetText("")
  end
end

function MessageWindow:Clear()
  self.messageBox:SetText("")
  cooldownTimer = 0
  self.imageBox1:SetBackground("")
  self.imageBox2:SetBackground("")
end