RatTracker=class(Turbine.UI.Lotro.Window)
function RatTracker:Constructor()
    Turbine.UI.Window.Constructor(self)
    local width = Settings.RWidth
    local height = Settings.RHeight
    local font = Turbine.UI.Lotro.Font.TrajanPro16
    local oldsecond = Turbine.Engine.GetDate().Second
    self:SetSize(width,height)
    self:SetPosition(0,0)
    --self:SetWantsKeyEvents(true)
    self:SetVisible(true)
    self:SetPosition(Settings.NoteX, Settings.NoteY)
    self:SetMouseVisible(false)
    self:SetWantsUpdates(true)
    --self:SetBackColor(GoldColor)

    local GroupLabels = Turbine.UI.Control()
    local Targets = {}
    GroupLabels.Labels = {}

    self.ContainsTarget = function(Target, bounce)
        local contained = true
        local TargetName = Target:GetName()

        if Targets[TargetName] then return(true) end
        
        for key, value in pairs(Targets) do
            if value:GetTarget() ~= nil then
                --ChatOutput(value:GetTarget():GetName() .. " " .. TargetName)
                if value:GetTarget():GetName() == TargetName then
                    return(true)
                end
            end
        end

        if bounce == 0 then
            if Target:GetTarget() ~= nil then
                 return(self.ContainsTarget(Target:GetTarget(), 1)) 
            end
        end
        return(false)
    end

    self.NullRat = function()
        for key, value in pairs(Targets) do
            if value:GetTarget() ~= nil then
                return(false)
            end
        end
        return(true)
    end

    self.UpdateLabelText = function(i)
        local target = ""
        if Group[i].player:GetTarget()~= nil then
            target = Group[i].player:GetTarget():GetName()
            if self.ContainsTarget(Group[i].player:GetTarget(), 0) then
                GroupLabels.Labels[Group[i].player:GetName()]:SetForeColor(Turbine.UI.Color(0, 1, 0))
            else
                GroupLabels.Labels[Group[i].player:GetName()]:SetForeColor(Turbine.UI.Color(1, 0, 0))
            end
        elseif self.NullRat() then
            GroupLabels.Labels[Group[i].player:GetName()]:SetForeColor(Turbine.UI.Color(0, 1, 0))
        else
            GroupLabels.Labels[Group[i].player:GetName()]:SetForeColor(Turbine.UI.Color(1, 0, 0))
        end
        GroupLabels.Labels[Group[i].player:GetName()]:SetText(Group[i].player:GetName() .. " - " .. target)
    end

    self.UpdateText = function()
        local string = ""
        if GroupLabels.Labels ~= nil then
            for key, value in pairs(GroupLabels.Labels) do
                value:SetText("")
            end
        end
        GroupLabels = Turbine.UI.Control()
        GroupLabels:SetParent(self)
        GroupLabels:SetSize(width, height)
        GroupLabels.Labels = {}
        Targets = {}
        if Party ~= nil then
            for i = 1, Party:GetAssistTargetCount(), 1 do
                GroupLabels.Labels[Party:GetAssistTarget(i):GetName() .. "Assist"] = AddRatLabel(GroupLabels, width, i - 1)
                local target = ""
                Targets[Party:GetAssistTarget(i):GetName()] = Party:GetAssistTarget(i)
                if  Party:GetAssistTarget(i):GetTarget() ~= nil then
                    target = Party:GetAssistTarget(i):GetTarget():GetName()
                end
                GroupLabels.Labels[Party:GetAssistTarget(i):GetName() .. "Assist"]:SetText("RAT " .. Party:GetAssistTarget(i):GetName() .. " - " .. target)
            end
            for i = 1, Party:GetMemberCount(), 1 do
                GroupLabels.Labels[Group[i].player:GetName()] = AddRatLabel(GroupLabels, width, i + Party:GetAssistTargetCount() - 1)
                
                self.UpdateLabelText(i)
                Group[i].player.TargetChanged = function(sender, args)
                    if Targets[Group[i].player:GetName()] then
                        local target = ""
                        if  Group[i].player:GetTarget() ~= nil then
                            target = Group[i].player:GetTarget():GetName()        
                        end
                        GroupLabels.Labels[Group[i].player:GetName() .. "Assist"]:SetText("RAT " .. Group[i].player:GetName() .. " - " .. target)
                    end
                    ChatOutput(Group[i].player:GetName())
                    self.UpdateLabelText(i)
                end
            end
        end
    end

    self.UpdateText()
    if Party ~= nil then
        Party.AssistTargetAdded = function()
            self.UpdateText()
        end

        Party.AssistTargetRemoved = function()
            self.UpdateText()
        end    
    end

    self.Update = function()
        local currentsecond = Turbine.Engine.GetDate().Second
        if(currentsecond == oldsecond) then
            return(true) 
        end

        self.UpdateText()

        oldsecond = currentsecond
    end


    self.MoveBox = Turbine.UI.Control()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(width, height)
    self.MoveBox:SetBackColor(Turbine.UI.Color(0, 0, 1))
    self.MoveBox:SetVisible(false)

    self.messageBox1 = Turbine.UI.Label()
    self.messageBox1:SetParent(self.MoveBox)
    self.messageBox1:SetSize(width, height)
    self.messageBox1:SetPosition(0,0)
    self.messageBox1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox1:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.messageBox1:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox1:SetMouseVisible(false)
    self.messageBox1:SetText("Rat Tracker")


    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          if newLeft < 0 then newLeft = 0 end
          if newTop < 0 then newTop = 0 end
          if newLeft > (Turbine.UI.Display.GetWidth() - self:GetWidth()) then
            newLeft = Turbine.UI.Display.GetWidth() - self:GetWidth() end
          if newTop > (Turbine.UI.Display.GetHeight() - self:GetHeight()) then
            newTop = Turbine.UI.Display.GetHeight() - self:GetHeight() end
          self:SetPosition(newLeft,newTop)
        end
    end
    
    self.ToggleMove = function()
        self.MoveBox:SetVisible(not self.MoveBox:IsVisible())
    end
end

function AddRatLabel(parent, width, index)
    local messageBox = Turbine.UI.Label()
    messageBox:SetParent(parent)
    messageBox:SetSize(width,15)
    messageBox:SetPosition(0,15 * index)
    messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    messageBox:SetMouseVisible(true)
    messageBox:SetVisible(true)
    messageBox:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    return(messageBox)
end