SkillWindow = class(Turbine.UI.Window)
function SkillWindow:Constructor()
    local width = Settings.SWWidth
    local height = 100
    local x = Settings.SWX
    local y = Settings.SWY
    local cooldownTimer = 0
    local combat = nil
    local minutes = 0
    local seconds = 0


    Turbine.UI.Window.Constructor(self)
    self:SetSize(width,height)
    self:SetPosition(x,y)
    self:SetZOrder(1)

    self.ResetTimes = {}
    self.EarliestReset = nil
    self.Labels = {}

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    --self:SetWantsKeyEvents(true)
    self:SetMouseVisible(false)
    self:SetVisible(Settings.SWVisible)
    --self:SetWantsUpdates(false)

    local tskills = self.player:GetTrainedSkills()
    local counter = 0

    for i = 1, self.player:GetTrainedSkills():GetCount(), 1 do
        local item = tskills:GetItem(i)--:GetSkillInfo()

        --ChatOutput(item:GetSkillInfo():GetName() .. " " .. item:GetSkillInfo():GetIconImageID())
        
        if SkillAlerts.PlayerEffects[self.player:GetClass()][item:GetSkillInfo():GetName()] then

            SkillWindowSkill[item] = self

            local itemInfo = item:GetSkillInfo()
            local usable = false

            if item:GetResetTime() < 0 then
                usable = true
            elseif self.EarliestReset == nil or item:GetResetTime() < self.EarliestReset then
               -- ChatOutput("XD")
                --self.EarliestReset = item:GetResetTime()
                --self.ResetTimes[itemInfo:GetName()] = item:GetResetTime()
                --self:SetWantsUpdates(true)
                --Updater:Subscribe(self)

            end

            self.Labels[itemInfo:GetName()] = SkillLabel(itemInfo:GetIconImageID(), itemInfo:GetName(), self, usable, counter, item:GetCooldown(), item)
            --self.Labels[itemInfo:GetName()]:SetVisible(usable)

            if not(usable) then self:DoSkill(item) end


            --ChatOutput(self.EarliestReset)
            counter = counter + 1
        end
    end

    height = 32 * tablelength(self.Labels)
    self:SetSize(width, height)

    local moveBox = MoveBox(self, width, height, "Skill Alerts")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end
end

function SkillWindow:ExecuteUpdate()
    if Turbine.Engine.GetGameTime() >= self.EarliestReset then
        for key, value in pairs(self.ResetTimes) do
            if value == self.EarliestReset then
                self.ResetTimes[key] = nil
                self.Labels[key]:SwapState(false)
                Sounds:PlaySoundEffect(SoundEffects["Ping"])
                self.EarliestReset = nil
                for item, item2 in pairs(self.ResetTimes) do
                    if self.EarliestReset == nil or self.EarliestReset > item2 then
                        self.EarliestReset = item2
                    end
                end

                if self.EarliestReset == nil then
                    --self:SetWantsUpdates(false)
                    Updater:UnSubscribe(self)
                end
            end
        end
    end
end

function SkillWindow:DoSkill(item)
    local itemInfo = item:GetSkillInfo()
    self.ResetTimes[itemInfo:GetName()] = item:GetResetTime()
    self.Labels[itemInfo:GetName()]:SwapState(true)
    self.Labels[itemInfo:GetName()]:SkillUsed(item:GetResetTime() - Turbine.Engine.GetGameTime())
    if self.EarliestReset == nil or self.EarliestReset > item:GetResetTime() then
        self.EarliestReset = item:GetResetTime()
    end
    --self:SetWantsUpdates(true)
    Updater:Subscribe(self)
end

function SkillWindow:RemoveCallbacks()
    for key, value in pairs(self.Labels) do
        value:RemoveCallbacks()
    end
end

SkillLabel = class(Turbine.UI.Control)
function SkillLabel:Constructor(image, message, parent, visible, index, cooldown, skill)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetVisible(true)
    self:SetSize(100, 32)
    self:SetPosition(0, 32 * index)
    --self:SetBackColor(Turbine.UI.Color(0,0,0))
    self:SetMouseVisible(false)
    
    self.skill = skill

    self.Countdown = cooldown
    self.CurrentCooldown = -2

    local colorThreshold = cooldown / 8
    self.decimalThreshold = 3

    self.bigCooldown = cooldown >= 300
    self.oldCooldown = cooldown

    self.opacityWindow = Turbine.UI.Window()
    self.opacityWindow:SetParent(self)
    self.opacityWindow:SetSize(32, 32)
    self.opacityWindow:SetPosition(0,0)
    self.opacityWindow:SetMouseVisible(false)
    self.opacityWindow:SetVisible(true)
    --self.opacityWindow:SetBackColor(Turbine.UI.Color(0, 0, 0))
    --self.opacityWindow:SetOpacity(0.5)

    
    self.opacityWindow2 = Turbine.UI.Window()
    self.opacityWindow2:SetParent(self)
    self.opacityWindow2:SetSize(32, 32)
    self.opacityWindow2:SetPosition(0,0)
    self.opacityWindow2:SetMouseVisible(false)
    self.opacityWindow2:SetVisible(true)
    --self.opacityWindow2:SetBackColor(Turbine.UI.Color(0, 0, 0))
    --self.opacityWindow2:SetOpacity1)

    self.icon = Turbine.UI.Label()
    self.icon:SetParent(self.opacityWindow)
    self.icon:SetSize(32, 32)
    self.icon:SetPosition(0,0)
    self.icon:SetBackground(image)
    self.icon:SetMouseVisible(false)
    --self.icon:SetStretchMode(1)

    self.countdownLabel = Turbine.UI.Label()
    self.countdownLabel:SetParent(self.opacityWindow2)
    self.countdownLabel:SetSize(32, 32)
    self.countdownLabel:SetPosition(0, 0)
    self.countdownLabel:SetMouseVisible(false)
    self.countdownLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.countdownLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.countdownLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetSize(100 - 32, 32)
    self.label:SetPosition(32,0)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiqua18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetMouseVisible(false)
    self.label:SetVisible(false)
    self.label:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.label:SetForeColor(Turbine.UI.Color(0, 1, 0))
    --self.label:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.label:SetText("READY")

    self.callback = AddCallback(self.skill, "ResetTimeChanged", function(sender, args) self:SkillUsed(self.skill:GetResetTime() - Turbine.Engine.GetGameTime()) end)
end

function SkillLabel:RemoveCallbacks()
    RemoveCallback(self.skill, "ResetTimeChanged", self.callback)
end

function SkillLabel:SwapState(state)
    --self:SetVisible(not(state))
    if state then 
        self.opacityWindow:SetOpacity(0.5)
        self.opacityWindow:SetBackColor(Turbine.UI.Color(0, 0, 0))
    else 
        self.opacityWindow:SetOpacity(1)
        self.opacityWindow:SetBackColor()
    end
    --self.label:SetVisible(not(state)) 
end

function SkillLabel:SkillUsed(cd)
    self.CurrentCooldown = cd
    self.countdownLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.countdownLabel:SetVisible(true)
    self.countdownLabel:SetText(math.ceil(cd))
    self.opacityWindow:SetOpacity(0.5)
    --self:SetWantsUpdates(true)
    Updater:Subscribe(self)
    self.oldCooldown = cd
end

function SkillLabel:ExecuteUpdate(delta)
    self.CurrentCooldown = self.CurrentCooldown - delta

    if self.oldCooldown - self.CurrentCooldown > 0.05 then
        if self.CurrentCooldown < self.decimalThreshold and self.CurrentCooldown < 100 and not(self.bigCooldown) then
            self.countdownLabel:SetText(Round(self.CurrentCooldown, 1))
        elseif self.CurrentCooldown < 120 then
            self.countdownLabel:SetText(Round(self.CurrentCooldown, 0))
        else
            self.countdownLabel:SetText(Round(self.CurrentCooldown / 60, 0) .. "m")
        end
        self.oldCooldown = self.CurrentCooldown
    end

    if self.CurrentCooldown < 0 then
        --self:SetWantsUpdates(false)
        --self:SetVisible(true)
        self.opacityWindow:SetOpacity(1)
        self.opacityWindow:SetBackColor()
        self.countdownLabel:SetText("")
        Updater:UnSubscribe(self)
    --elseif self.CurrentCooldown < colorThreshold and not(bigCooldown) then
    --    self.countdownLabel:SetForeColor(Turbine.UI.Color(1, 0, 0))
    end
end

SkillWindowSkill = {}