SmallDamageMeter = class(Turbine.UI.Window)
function SmallDamageMeter:Constructor()

    self.width = 234 + 48 - 4
    self.height = 24
    local x = Settings.MeterX
    local y = Settings.MeterY

    self.meterWidth = 234
    self.meterHeight = 24

    self.CurrentOutput = ""

    self.ChatOutput = Settings.ChatOutput

    
    Turbine.UI.Window.Constructor(self)
    self:SetSize(self.width,self.height)
    self:SetPosition(x,y)
    --self:SetZOrder(1)

    self:SetMouseVisible(true)
    self:SetVisible(true)
    self:SetWantsUpdates(true)
    self:SetWantsKeyEvents(true)
    --self:SetOpacity(0.7)

    AnalyseIcon = "PrimePlugins/RaidTools/Images/AnalyseIcon.tga"
    ChatIcon = "PrimePlugins/RaidTools/Images/ChatBubble.tga"

    local BorderColour = Turbine.UI.Color(0.125, 0.125, 0.125)

    self:SetBackColor(BorderColour)

    self.Moving = false

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.MouseUp = function()
        self.Moving = false
    end
  
    self.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          self:SetPosition(newLeft,newTop)
        end
    end

    self.StartTime = nil


    -- Meters
    self.MeterContainer = Turbine.UI.Control()
    self.MeterContainer:SetParent(self)
    self.MeterContainer:SetPosition(self.height, 2)
    self.MeterContainer:SetSize(self.meterWidth - 4, self.meterHeight - 4)
    self.MeterContainer:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    self.MeterContainer:SetMouseVisible(false)

    -- DPS
    self.DamageLabel = Turbine.UI.Label()
    self.DamageLabel:SetParent(self.MeterContainer)
    self.DamageLabel:SetPosition(0, 0)
    self.DamageLabel:SetSize(50, 20)
    self.DamageLabel:SetMultiline(false)
    self.DamageLabel:SetMouseVisible(false)
    self.DamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.DamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.DamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.DamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    --self.DamageLabel:SetBackColor(GetRandomColour())
    self.DamageLabel:SetText("0")

    -- Total Damage
    self.TotalDamageLabel = Turbine.UI.Label()
    self.TotalDamageLabel:SetParent(self.MeterContainer)
    self.TotalDamageLabel:SetPosition(50, 0)
    self.TotalDamageLabel:SetSize(60, 20)
    self.TotalDamageLabel:SetMultiline(false)
    self.TotalDamageLabel:SetMouseVisible(false)
    self.TotalDamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.TotalDamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.TotalDamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TotalDamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    --self.TotalDamageLabel:SetBackColor(GetRandomColour())
    self.TotalDamageLabel:SetText("[0]")

    -- Crits
    self.TotalCritsLabel = Turbine.UI.Label()
    self.TotalCritsLabel:SetParent(self.MeterContainer)
    self.TotalCritsLabel:SetPosition(110, 0)
    self.TotalCritsLabel:SetSize(60, 20)
    self.TotalCritsLabel:SetMultiline(false)
    self.TotalCritsLabel:SetMouseVisible(false)
    self.TotalCritsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.TotalCritsLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.TotalCritsLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TotalCritsLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    --self.TotalCritsLabel:SetBackColor(GetRandomColour())
    self.TotalCritsLabel:SetText("(0.00%)")

    -- Time
    self.TimeStampLabel = Turbine.UI.Label()
    self.TimeStampLabel:SetParent(self.MeterContainer)
    self.TimeStampLabel:SetPosition(170, 0)
    self.TimeStampLabel:SetSize(60, 20)
    self.TimeStampLabel:SetMultiline(false)
    self.TimeStampLabel:SetMouseVisible(false)
    self.TimeStampLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.TimeStampLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.TimeStampLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TimeStampLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    --self.TimeStampLabel:SetBackColor(GetRandomColour())
    self.TimeStampLabel:SetText("00:00.00")

    self.Seperator = Turbine.UI.Control()
    self.Seperator:SetParent(self.MeterContainer)
    self.Seperator:SetSize(2, self.height)
    self.Seperator:SetBackColor(BorderColour)
    self.Seperator:SetPosition(49, 0)
    self.Seperator:SetMouseVisible(false)

    self.Seperator = Turbine.UI.Control()
    self.Seperator:SetParent(self.MeterContainer)
    self.Seperator:SetSize(2, self.height)
    self.Seperator:SetBackColor(BorderColour)
    self.Seperator:SetPosition(109, 0)
    self.Seperator:SetMouseVisible(false)

    self.Seperator = Turbine.UI.Control()
    self.Seperator:SetParent(self.MeterContainer)
    self.Seperator:SetSize(2, self.height)
    self.Seperator:SetBackColor(BorderColour)
    self.Seperator:SetPosition(169, 0)
    self.Seperator:SetMouseVisible(false)

    self.Update = function()
        self.TimeStampLabel:SetText(FormatTimeString(Turbine.Engine.GetGameTime() - self.StartTime))
    end

    -- Chat button
    -- [[
    local ReloadBackground = Turbine.UI.Control()
    ReloadBackground:SetParent(self)
    ReloadBackground:SetPosition(0, 0)
    ReloadBackground:SetSize(self.height, self.height)
    ReloadBackground:SetMouseVisible(false)
    ReloadBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.clearResetButton = Turbine.UI.Lotro.Quickslot()
    self.clearResetButton:SetPosition(0, 0)
    self.clearResetButton:SetSize(self.height - 4, self.height - 4)
    self.clearResetButton:SetParent(ReloadBackground)

    self.ResetShortcut = function()
        self.clearResetButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, self.ChatOutput .. self.CurrentOutput))
    end

    self.ResetShortcut()

    local ReloadBorder = Turbine.UI.Control()
    ReloadBorder:SetParent(ReloadBackground)
    ReloadBorder:SetPosition(2, 2)
    ReloadBorder:SetSize(self.height - 4, self.height - 4)
    ReloadBorder:SetMouseVisible(false)
    ReloadBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local Image = Turbine.UI.Label()
    Image:SetParent(ReloadBackground)
    Image:SetPosition(2, 2)
    Image:SetSize(self.height - 4, self.height - 6)
    Image:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    Image:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    --Image:SetBackColor(Turbine.UI.Color(0, 102/255, 0))
    Image:SetBackground(ChatIcon)
    Image:SetWantsKeyEvents(false)
    Image:SetMouseVisible(false)
    
    local menu = Turbine.UI.ContextMenu()
    local menuItems = menu:GetItems()

    -- Say
    local menuItem = Turbine.UI.MenuItem( "Say" )
    menuItem.Click = function()
        self.ChatOutput = "/Say"
        self.ResetShortcut()
        Image:SetMouseVisible(false)
    end
    menuItems:Add(menuItem)

    -- Fellowship
    local menuItem = Turbine.UI.MenuItem( "Fellowship" )
    menuItem.Click = function()
        self.ChatOutput = "/f"
        self.ResetShortcut()
        Image:SetMouseVisible(false)
    end
    menuItems:Add(menuItem)

    -- Raid
    local menuItem = Turbine.UI.MenuItem( "Raid" )
    menuItem.Click = function()
        self.ChatOutput = "/ra"
        self.ResetShortcut()
        Image:SetMouseVisible(false)
    end
    menuItems:Add(menuItem)

    -- Kinship
    local menuItem = Turbine.UI.MenuItem( "Kinship" )
    menuItem.Click = function()
        self.ChatOutput = "/k"
        self.ResetShortcut()
        Image:SetMouseVisible(false)
    end
    menuItems:Add(menuItem)

    -- Officer
    local menuItem = Turbine.UI.MenuItem( "Officer" )
    menuItem.Click = function()
        self.ChatOutput = "/o"
        self.ResetShortcut()
        Image:SetMouseVisible(false)
    end
    menuItems:Add(menuItem)

    -- OOC
    local menuItem = Turbine.UI.MenuItem( "OOC" )
    menuItem.Click = function()
        self.ChatOutput = "/ooc"
        self.ResetShortcut()
        Image:SetMouseVisible(false)
    end
    menuItems:Add(menuItem)

    self.KeyDown = function(sender, args)
        if args.Action == 268435575 then
            Image:SetMouseVisible(true)
        else
            Image:SetMouseVisible(false)
        end
    end

    Image.MouseEnter = function()
        ReloadBorder:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    end

    Image.MouseLeave = function()
        ReloadBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    end

    Image.MouseClick = function()
        ReloadBorder:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
        menu:ShowMenu()
    end

    self.clearResetButton.MouseEnter = function()
        ReloadBorder:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    end

    self.clearResetButton.MouseLeave = function()
        ReloadBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    end

    self.clearResetButton.MouseClick = function()
        ReloadBorder:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    end

    --]]

    -- Analyse button
    local ReloadBackground = Turbine.UI.Control()
    ReloadBackground:SetParent(self)
    ReloadBackground:SetPosition(self.meterWidth + self.height - 2, 0)
    ReloadBackground:SetSize(self.height, self.height)
    ReloadBackground:SetMouseVisible(false)
    ReloadBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local ReloadBorder = Turbine.UI.Control()
    ReloadBorder:SetParent(ReloadBackground)
    ReloadBorder:SetPosition(0, 2)
    ReloadBorder:SetSize(self.height - 4, self.height - 4)
    ReloadBorder:SetMouseVisible(false)
    ReloadBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local Image = Turbine.UI.Label()
    Image:SetParent(ReloadBackground)
    Image:SetPosition(0, 2)
    Image:SetSize(self.height - 4, self.height - 6)
    --Image:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    --Image:SetBlendMode()
    Image:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    Image:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    Image:SetBackground(AnalyseIcon)
    Image:SetWantsKeyEvents(false)
    Image:SetMouseVisible(true)

    Image.MouseEnter = function()
        ReloadBorder:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    end

    Image.MouseLeave = function()
        ReloadBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    end

    Image.MouseClick = function()
        ReloadBorder:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
        bigPP:SetVisible(true)
    end


end

function SmallDamageMeter:SetCrit(crits)
    self.TotalCritsLabel:SetText("(" .. Round(crits, 2) .. "%)")
end

function SmallDamageMeter:SetTotal(total)
    self.TotalDamageLabel:SetText("[" .. FormatBigNumber(total) .. "]")
end

function SmallDamageMeter:SetDPS(dps)
    self.DamageLabel:SetText(FormatBigNumber(dps))
end

function SmallDamageMeter:StartTimer()
    self.StartTime = Turbine.Engine.GetGameTime()
    self.DamageLabel:SetText("0")
    self.TotalDamageLabel:SetText("[0]")
    self.TotalCritsLabel:SetText("(0.00%)")
    self.TimeStampLabel:SetText("00:00.00")
    self:SetWantsUpdates(true)
end

function SmallDamageMeter:SaveData()
    Settings.MeterX, Settings.MeterY = self:GetPosition()
    Settings.ChatOutput = self.ChatOutput
end

function SmallDamageMeter:SetupChatoutput(dps, total, crits, time, mainTarget)
    self.CurrentOutput = " <rgb=#06d60d>" .. mainTarget .. "</rgb> <rgb=#ffffff>-</rgb> <rgb=#a30e0e>DPS:</rgb> <rgb=#ffffff>" .. dps .. " [" .. total .. "] </rgb><rgb=#d8880f>Crit:</rgb> <rgb=#ffffff>" .. crits .. "%</rgb> <rgb=#FF9900>(" .. time .. ")"
    self.ResetShortcut()
end
