DiagWindow = class(Turbine.UI.Window)
function DiagWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.width = 400
    self.height = 120
    self:SetSize(self.width,self.height)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(false)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetBackColor(GetRandomColour())

    -- Plugin version
    self.VersionLabel = Turbine.UI.Label()
    self.VersionLabel:SetParent(self)
    self.VersionLabel:SetPosition(5, 5)
    self.VersionLabel:SetSize(self.width - 10, 20)
    self.VersionLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.VersionLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.VersionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    self.VersionLabel:SetMouseVisible(false)
    self.VersionLabel:SetText("Plugin Version " .. plugin:GetVersion())

    -- Container name
    for key, value in pairs(Turbine.PluginManager:GetAvailablePlugins()) do
        if value["Name"] == "PrimePlugin" then
            self.scriptstate = value["ScriptState"]
        end
    end

    self.ContainerLabel = Turbine.UI.Label()
    self.ContainerLabel:SetParent(self)
    self.ContainerLabel:SetPosition(5, 5 + 20)
    self.ContainerLabel:SetSize(self.width - 10, 20)
    self.ContainerLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.ContainerLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.ContainerLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    self.ContainerLabel:SetMouseVisible(false)
    self.ContainerLabel:SetText(self.scriptstate)

    -- Container size
    self.SizeLabel = Turbine.UI.Label()
    self.SizeLabel:SetParent(self)
    self.SizeLabel:SetPosition(5, 5)
    self.SizeLabel:SetSize(self.width, 20)
    self.SizeLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.SizeLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.SizeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.SizeLabel:SetMouseVisible(false)

    -- Updates
    self.UpdateLabel = Turbine.UI.Label()
    self.UpdateLabel:SetParent(self)
    self.UpdateLabel:SetPosition(5, 5 + 20)
    self.UpdateLabel:SetSize(self.width, 20)
    self.UpdateLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.UpdateLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.UpdateLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.UpdateLabel:SetMouseVisible(false)

    self.lastUpdate = Turbine.Engine.GetGameTime()
    self.lastDraw = Turbine.Engine.GetGameTime()

    -- Skill hanlder info
    self.UpdateAverageLabel = Turbine.UI.Label()
    self.UpdateAverageLabel:SetParent(self)
    self.UpdateAverageLabel:SetPosition(5, 5 + 20 + 20)
    self.UpdateAverageLabel:SetSize(self.width, 20)
    self.UpdateAverageLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.UpdateAverageLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.UpdateAverageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.UpdateAverageLabel:SetMouseVisible(false)

    self.lowest = 10000
    self.highest = 0
    self.average = 0
    self.updateCount = 0
    self.updateTotal = 0

    -- Updateable objects
    self.UpdateCountLabel = Turbine.UI.Label()
    self.UpdateCountLabel:SetParent(self)
    self.UpdateCountLabel:SetPosition(5, 5 + 20 + 20 + 20)
    self.UpdateCountLabel:SetSize(self.width, 20)
    self.UpdateCountLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.UpdateCountLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.UpdateCountLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.UpdateCountLabel:SetMouseVisible(false)

    -- PrimeUI
    self.PrimeUILabel = Turbine.UI.Label()
    self.PrimeUILabel:SetParent(self)
    self.PrimeUILabel:SetPosition(5, 5 + 20 + 20 + 20 + 20)
    self.PrimeUILabel:SetSize(self.width, 20)
    self.PrimeUILabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.PrimeUILabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.PrimeUILabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.PrimeUILabel:SetMouseVisible(false)

    -- Target hanlder info
    self.TargetLabel = Turbine.UI.Label()
    self.TargetLabel:SetParent(self)
    self.TargetLabel:SetPosition(5, 5 + 20 + 20 + 20 + 20 + 20)
    self.TargetLabel:SetSize(self.width, 20)
    self.TargetLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.TargetLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.TargetLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.TargetLabel:SetMouseVisible(false)

    -- Gametime
    self.GameTimeLabel = Turbine.UI.Label()
    self.GameTimeLabel:SetParent(self)
    self.GameTimeLabel:SetPosition(5, 5 + 20 + 20 + 20 + 20)
    self.GameTimeLabel:SetSize(self.width - 10, 20)
    self.GameTimeLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.GameTimeLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.GameTimeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    self.GameTimeLabel:SetMouseVisible(false)

    -- Localtime
    self.LocalTimeLabel = Turbine.UI.Label()
    self.LocalTimeLabel:SetParent(self)
    self.LocalTimeLabel:SetPosition(5, 5 + 20 + 20 + 20 + 20 + 20)
    self.LocalTimeLabel:SetSize(self.width - 10, 20)
    self.LocalTimeLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.LocalTimeLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.LocalTimeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    self.LocalTimeLabel:SetMouseVisible(false)
    

    self.ExecuteUpdate = function(delta)
        -- Update size
        self.SizeLabel:SetText(string.format("%.2f MB", collectgarbage("count")/1024))

        --Update fps
        local currentGameTime = Turbine.Engine.GetGameTime()

        local delta = currentGameTime - self.lastUpdate

        if (currentGameTime - self.lastDraw) > 0.06 then
            self.UpdateLabel:SetText(string.format("%.2f Updates Per Second", 1 / delta))
            self.lastDraw = currentGameTime
        end

        self.lastUpdate = currentGameTime

        -- Update count
        self.UpdateCountLabel:SetText(Updater:GetUpdateCount() .. " Updatable objects")

        -- Update stats
        if delta > self.highest then self.highest = delta end
        if delta < self.lowest then self.lowest = delta end
        self.updateTotal = self.updateTotal + delta
        self.updateCount = self.updateCount + 1
        self.UpdateAverageLabel:SetText(string.format("L: %.3f, A: %.3f, H: %.3f", self.lowest, self.updateTotal / self.updateCount, self.highest))

        -- Update primeUI count
        self.PrimeUILabel:SetText(string.format("%i/%i PrimeUI Active", PrimeUIHandlerObject:GetPrimeUICount(), PrimeUIHandlerObject:GetTotalPrimeUICount()))

        -- Update Target handler info
        self.TargetLabel:SetText(string.format("T: %i, I %i, H: %i, TH: %i, P: %i, E: %i", TargetHandlerObject:GetActives()))

        -- Update gametime
        self.GameTimeLabel:SetText(Round(currentGameTime, 1) .. " Gametime")

        -- Update localtime
        self.LocalTimeLabel:SetText(Turbine.Engine.GetLocalTime() .. " Localtime")
    end

    if self.callback then
        RemoveCallback(Updater, "ExecuteUpdate", self.callback)
        self.callback = nil
    end

    if not(self.callback) then self.callback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
end
