-- Effect alerts
EffectSettings = class(Turbine.UI.Control)
function EffectSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    --GetOptionsBackground(height, 250, Turbine.UI.Color(0.5, 0, 1))

    local height = 0
    
    -- Effect alerts
    local EffectAlertLabel = GetLabelUI(self, "Effect Alert Settings:", height)

    local EffectTestButton = Turbine.UI.Lotro.Button()
    EffectTestButton:SetParent(self)
    EffectTestButton:SetPosition(220, height)
    EffectTestButton:SetSize(100,15)
    EffectTestButton:SetText("Test alert")
    EffectTestButton:SetVisible(true)

    EffectTestButton.Click = function()
        local effectsWindow = EventWindows:GetEffectWindow()
        if effectsWindow then
            effectsWindow:Message(10, "<rgb=#FF9900>Test</rgb>", "PrimePlugins/RaidTools/Images/AlertRound.tga", true, "", true)
        end
    end

    local EffectAlertCheckBox = GetCheckUI(self, height + 30, "Effect alerts enabled", Settings.EEnabled)
    EffectAlertCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.EEnabled = EffectAlertCheckBox.cBox:IsChecked()
        ReloadPlugin()
    end

    local EffectAlertOptions = GetWindowUI(self, "Window Width/Height", height + 50, Settings.EWidth, Settings.EHeight)
    EffectAlertOptions.button.Click = function()
        Settings.EWidth = EffectAlertOptions.windowX:GetText()
        Settings.EHeight = EffectAlertOptions.windowY:GetText()
        ReloadPlugin()
    end

    local FontMenuEffect = GetFontMenu(self, height + 90, FontsLUTR[Settings.EFont]) 
    for i = 1, FontMenuEffect.menuItems:GetCount() do
        local menuItem = FontMenuEffect.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.EFont = FontsLUT[sender:GetText()]
            FontMenuEffect.button:SetText(Settings.EFont)
            ReloadPlugin()
        end
    end

    --EffectAlertLabel2 = GetLabelUI(options, "Icon size:", height + 130)
    --EffectWindowOptions2 = GetWindowUI(options, "Width              Height", height + 160, Settings.EIWidth, Settings.EIHeight)
    --EffectWindowOptions2.button.Click = function()
    --    Settings.EIWidth = EffectWindowOptions2.windowX:GetText()
    --    Settings.EIHeight = EffectWindowOptions2.windowY:GetText()
    --    ReloadPlugin()
    --end

    local EffectAlertCheckBox2 = GetCheckUI(self, height + 200, "Left Icon Enabled", Settings.EL)
    EffectAlertCheckBox2.cBox.CheckedChanged = function(sender,args)
        Settings.EL = EffectAlertCheckBox2.cBox:IsChecked()
        ReloadPlugin()
    end
    
    local EffectAlertCheckBox3 = GetCheckUI(self, height + 220, "Right Icon Enabled", Settings.ER)
    EffectAlertCheckBox3.cBox.CheckedChanged = function(sender,args)
        Settings.ER = EffectAlertCheckBox3.cBox:IsChecked()
        ReloadPlugin()
    end
end