EffectsWindow = class(Turbine.UI.Window)
function EffectsWindow:Constructor()
  Turbine.UI.Window.Constructor(self)
  local width = Settings.EWidth
  local height = Settings.EHeight
  local x = Settings.EX
  local y = Settings.EY
  self.cooldownTimer = 0
  self.maxFadeTimer = 5
  self.fadeTimer = self.maxFadeTimer
  self.maxTimer = 0
  self.alertEffectName = ""

  self.active = false
  self.fiveCDActive = false
  self.fiveCD = nil

  self:SetSize(width,height)
  self:SetPosition(x,y)
  self:SetZOrder(1)

  self:SetWantsKeyEvents(false)
  self:SetMouseVisible(false)
  self:SetVisible(true)

  self:GreetingMessage()
  --self:SetBackColor(GetRandomColour())
  --self:SetWantsUpdates(true)
  --self:SetOpacity(0.3)

  self.messageBox = Turbine.UI.Label()
  self.messageBox:SetParent(self)
  self.messageBox:SetSize(width - 250,height - 20)
  self.messageBox:SetPosition(125,20)
  self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.messageBox:SetFont(Settings.EFont)
  self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.messageBox:SetVisible(false)
  self.messageBox:SetMarkupEnabled(true)
  self.messageBox:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
  self.messageBox:SetFontStyle( Turbine.UI.FontStyle.Outline )
  self.messageBox:SetMouseVisible(false)
  --self.messageBox:SetBackColor(GetRandomColour())

  self.imageWindow = Turbine.UI.Window()
  self.imageWindow:SetParent(self)
  self.imageWindow:SetVisible(true)
  self.imageWindow:SetSize(Settings.EIWidth, Settings.EIHeight)
  self.imageWindow:SetMouseVisible(false)
  --self.imageWindow:SetBackColor(GetRandomColour())
  self.imageWindow:SetPosition(12.5, 12.5)

  self.imageBox1 = Turbine.UI.Label()
  self.imageBox1:SetParent(self.imageWindow)
  self.imageBox1:SetSize(Settings.EIWidth, Settings.EIHeight)
  --self.imageBox1:SetPosition(12.5, 12.5)
  self.imageBox1:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
  self.imageBox1:SetForeColor(Turbine.UI.Color(1, 1, 1))
  self.imageBox1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.imageBox1:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.imageBox1:SetFont(Settings.EFont)
  self.imageBox1:SetMouseVisible(false)
  --self.imageBox1:SetBackColor(GetRandomColour())

  self.countdownWindow = Turbine.UI.Window()
  self.countdownWindow:SetParent(self)
  self.countdownWindow:SetVisible(true)
  self.countdownWindow:SetSize(Settings.EIWidth, Settings.EIHeight)
  self.countdownWindow:SetMouseVisible(false)

  self.countdownBox = Turbine.UI.Label()
  self.countdownBox:SetParent(self.countdownWindow)
  self.countdownBox:SetSize(Settings.EIWidth, Settings.EIHeight)
  self.countdownBox:SetPosition(12.5, 12.5)
  self.countdownBox:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
  self.countdownBox:SetForeColor(Turbine.UI.Color(1, 1, 1))
  self.countdownBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.countdownBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.countdownBox:SetFont(Settings.EFont)
  self.countdownBox:SetOpacity(1)
  self.countdownBox:SetMouseVisible(false)

  self.imageBox2 = Turbine.UI.Label()
  self.imageBox2:SetParent(self)
  self.imageBox2:SetSize(Settings.EIWidth, Settings.EIHeight)
  self.imageBox2:SetPosition(width - 125 + 12.5, 12.5)
  self.imageBox2:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
  self.imageBox2:SetForeColor(Turbine.UI.Color(1, 1, 1))
  self.imageBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.imageBox2:SetFont(Settings.EFont)
  self.imageBox2:SetMouseVisible(false)


  local moveBox = MoveBox(self, width, height, "Self alerts")
    
  self.ToggleMove = function()
      moveBox:ToggleMove()
  end

  self.ExecuteUpdate = function(delta)
    if (self.cooldownTimer <= 0) then
      self.messageBox:SetVisible(false)
      self.imageBox1:SetVisible(false)
      self.imageBox2:SetVisible(false)
      self.imageWindow:SetVisible(false)
      self.countdownWindow:SetVisible(false)
      self.alertEffectName = nil
      if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
      self.updateCallback = nil
    end
  
    if self.cooldownTimer < 1 then
      self:SetOpacity(self.cooldownTimer + 0.3)
  end
  
    if(self.cooldownTimer > 0) then
        self.cooldownTimer = self.cooldownTimer - delta
    end

    if self.fiveCD and self.cooldownTimer <= 5 and not(self.fiveCDActive) and countdownWindow then
      countdownWindow:Countdown(self.cooldownTimer)
      self.fiveCDActive = true
    end
  
    if self.countDownVisible then
      if self.cooldownTimer <= 2 then
        self.countdownBox:SetText(string.format("%.1f", self.cooldownTimer))
        self.countdownBox:SetForeColor(Turbine.UI.Color(0.75, 0, 0))
      else
        self.countdownBox:SetText(math.floor(self.cooldownTimer))
      end
        --effectsWindow.imageBox2:SetText(self.cooldownTimer)
    end
  
    if(self.cooldownTimer <= self.maxTimer - self.fadeTimer) then
      if Settings.EL then
        self.imageBox1:SetBackground("")
      end
      if Settings.ER then
        self.imageBox2:SetBackground("")
      end
    else
      --effectsWindow.imageWindow:SetOpacity(0.1)
      --ChatOutput(1 - ((self.maxTimer - self.cooldownTimer) / 3))
      self.imageWindow:SetOpacity(1 - ((self.maxTimer - self.cooldownTimer) / self.fadeTimer))
    end
  end

  if not(Settings.ReloadData) then 
    self:Message(8, "<rgb=#0008CFF>".. self.greetings[math.random(1, tablelength(self.greetings))] .. "</rgb>",nil,false) 
  end
end

function EffectsWindow:Clear()
  self.messageBox:SetText("")
  self.cooldownTimer = 0
  self.imageBox1:SetBackground("")
  self.imageBox2:SetBackground("")
end  

function EffectsWindow:Unload()
  if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
  self.updateCallback = nil
end

function EffectsWindow:Message(duration, message, icon, cdVisible, effectName, fiveCD)
  if effectName == "Necrotic Ooze" and effectName == self.alertEffectName then return end

  self:SetOpacity(1)

  if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end

  ChatOutput(message)
  self.cooldownTimer = duration
  self.maxTimer = duration
  self.alertEffectName = effectName
  self.messageBox:SetText(message)
  self.messageBox:SetVisible(true)
  self.imageWindow:SetOpacity(1)
  self.imageWindow:SetVisible(true)
  self.countdownWindow:SetVisible(true)

  self.fiveCD = fiveCD
  self.fiveCDActive = false
  self.lastSoundCD = 6

  self.fadeTimer = math.min(self.maxFadeTimer, duration)
  
  if icon ~= nil then
    if Settings.EL then
      self.imageBox1:SetStretchMode(nil)
      self.imageBox1:SetBackground(BackgroundHandler:GetBackground(icon))
      self.imageBox1:SetStretchMode(2)
      self.imageBox1:SetStretchMode(1)
      self.imageBox1:SetSize(Settings.EIWidth, Settings.EIHeight)
      self.imageBox1:SetVisible(true)
    end
    if Settings.ER then
      self.imageBox2:SetBackground(icon)
      self.imageBox2:SetVisible(false)
    end
  else
    self.imageBox1:SetBackground("")
    self.imageBox1:SetVisible(true)
    self.imageBox2:SetBackground("")
    self.imageBox2:SetVisible(true)
  end

  if cdVisible then
    self.countDownVisible = true
    self.countdownBox:SetText(duration)
    self.countdownBox:SetForeColor(Turbine.UI.Color(1, 1, 1))
    --self.imageBox2:SetText(duration)
  else 
    self.countDownVisible = false
    self.countdownBox:SetText("")
    self.imageBox2:SetText("")
  end
end

function EffectsWindow:GreetingMessage()
    self.greetings = {
      [1] = "Lets go champ!",
      [2] = "Welcome.... Slacker",
      [3] = "Hey there good looking",
      [4] = "Hi, what should we do?",
      [5] = "Nice hair!",
      [6] = "I like your shoes!",
      [7] = "Prime rules!",
      [8] = "Fuck Hunters",
      [9] = "You Come Here often?",
      [10] = "<3",
      [11] = "Subscribe To Our Youtube!",
      [12] = "Don't Forget To Sign Up For Raids!",
      [13] = "Sauron Says Hi!",
      [14] = "LM Bear > Actual tanks",
      [15] = "Did You Lose Some Weight?",
      [16] = "Have you heard about our lord and saviour?",
      [17] = "The Dictator sends his regards!",
      [18] = "Mikkye: Why is rk attunement not require any focus?",
      [19] = "That is what she said",
      [20] = "But we are already in an anvil... haHA",
      [21] = "Look on the bright side, you are not from America",
      [22] = "Always look on the bright side of life!",
      [23] = "Sup",
      [24] = "Burgers or Pizza?",
      [25] = "Waffles or Pancakes?",
      [26] = "Milk or cereal first?",
      [27] = "What is your favourite colour?",
      [28] = "You call that a cosmetic?!",
      [29] = "Nice cosmetic!",
      [30] = "You need a haircut bro",
      [31] = "Just use fates",
      [32] = "Alt + F4 to start the plugin",
      [33] = "You have a puddle!",
      [34] = "Beeeeeeeeeeeeeees",
      [35] = "Dude, your shoes are untied",
      [36] = "Ehm dude, your fly is open",
      [37] = "Copy paste this greeting to kin chat",
      [38] = "The Eagles are coming!",
      [39] = "Tell Mikkye hunters suck",
      [40] = "Ask someone else in kin how their day is going",
      [41] = "Give someone a compliment",
      [42] = "Do 10 pushups",
      [43] = "Gandalf wants his pipeweed back",
      [44] = "Elrond says, Stay safe!",
      [45] = "Hobbits suck",
      [46] = "I have killed goblins today, can you say the same?",
      [47] = "By the order of the Peaky Blinders",
      [48] = "They are taking the hobbits to Isengard!",
      [49] = "It is just a scratch",
      [50] = "Da tovarishch",
      [51] = "Sprechen Sie Deutsch?",
      [52] = "Sabes falar português?",
      [53] = "Pratar du svenska?",
      [54] = "Swedish meatballs are amazing!",
      [55] = "You want a bacon milkshake?",
      [56] = "I am disappointed in you!",
      [57] = "Preventing clown fiestas since 2019",
      [58] = "Stonks",
      [59] = "Cuppa tea?",
      [60] = "Fuck.",
      [61] = "Hmmmm....",
      [62] = ";)",
      [63] = "d8^)",
      [64] = " ¯\\_(-.-)_/¯",
      [65] = "World broadcast: Worlds are going to shut down in 5 minutes. Find a safe space to log off.",
      [66] = "EU>NA",
      [67] = "Do you like what you see?!",
      [68] = "Eyes are up here, buddy!",
      [69] = "Nice",
      [70] = "Whaddup dude!",
      [71] = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA oh hello",
      [72] = "OK Boomer",
      [73] = "Have you heard about the tragedy of Darth Plagueis",
      [74] = "Hello there",
      [75] = "I'm pregnant.",
      [76] = "English Motherfucker. Do you speak it?!",
      [77] = "Scropes please",
      [78] = "LET ME OUT! ROLO IS KEEPING ME TRAPPED IN HERE",
      [79] = "Pop me some hope",
      [80] = "Hey now, you're an all-star",
      [81] = "Let it be",
      [82] = "Na-na-na na, hey Jude Na, na, na, na-na-na na Na-na-na na, hey Jude",
      [83] = "Oooh I wonder how you taste",
      [84] = "Oooh la la",
      [85] = "THICC",
      [86] = "Did you do your dailies?",
      [87] = "There must always be a Lich King",
      [88] = "Aethrilia: I should just buy a child",
      [89] = "Pear man says, more festivals!",
      [90] = "Knock knock!",
      [91] = "Who is there?",
      [92] = "New plugin who dis?",
      [93] = "Only fools don't wrap their tools",
      [94] = "A turtle has made it to the water!",
      [95] = "I can't help but to root for the little ones",
      [96] = "What the hell are you doing?",
      [97] = "Was zum Teufel ist das?",
      [98] = "ProTip: Try to avoid frontal hits!",
      [99] = "ProTip: Clear your wounds!",
      [100] = "ProTip: When low pop a pot!",
      [101] = "Don't stand in puddles!",
      [102] = "Generally speaking standing in fire is not a good idea",
      [103] = "Don't be THAT guy",
      [104] = "::::__::::",
      [105] = "ProTip: Stun immunity prevents loss of control and threat upon fear",
      [106] = "For Narnia!",
      [107] = "Arise, arise, Riders of Théoden!",
      [108] = "spear shall be shaken, shield shall be splintered,",
      [109] = "a sword-day, a red day, ere the sun rises!",
      [110] = "Ride now, ride now, ride! Ride for ruin and the world's ending!",
      [111] = "Death! Death! Death!",
      [112] = "Forth Eorlingas!",
      [113] = "It's a dangerous business, Frodo, going out your door.",
      [114] = "You step onto the road, and if you don't keep your feet, there's no knowing where you might be swept off to.",
      [115] = "Three Rings for the Elven-kings under the sky,",
      [116] = "Seven for the Dwarf-lords in their halls of stone,",
      [117] = "Nine for Mortal Men, doomed to die,",
      [118] = "One for the Dark Lord on his dark throne",
      [119] = "In the Land of Mordor where the Shadows lie.",
      [120] = "One Ring to rule them all, One Ring to find them,",
      [121] = "One Ring to bring them all and in the darkness bind them.",
      [122] = "In the Land of Mordor where the Shadows lie",
      [123] = "Roads go ever ever on",
      [124] = "But in the end it's only a passing thing, this shadow; even darkness must pass\n- Samwise Gamgee",
      [125] = "The world is indeed full of peril, and in it there are many dark places; but still there is much that is fair\n- Haldir",
      [126] = "I would rather spend one lifetime with you, than face all the ages of this world alone\n- Arwen",
      [127] = "That there’s some good in this world, Mr. Frodo… and it’s worth fighting for\n- Sam Gamgee",
      [128] = "Even the smallest person can change the course of the future",
      [129] = "A day may come when the courage of men fails… but it is not THIS day\n- Aragorn",
      [130] = "It’s the job that’s never started as takes longest to finish \n- Sam Gamgee",
      [131] = "Memory is not what the heart desires. That is only a mirror.\n- Gimli",
      [132] = "Deeds will not be less valiant because they are unpraised\n- Aragorn",
      [133] = "May your beer be laid under an enchantment of surpassing excellence for seven years!\n-Gandalf",
      [134] = "Be Bold, but Wary! Keep up your merry hears, and ride to meet your fortune!",
      [135] = "It is useless to meet revenge with revenge: it will heal nothing. \n- Frodo Baggins",
      [136] = "He that breaks a thing to find out what it is has left the path of wisdom.\n- Gandalf",
      [137] = "All we have to decide is what to do with the time that is given us.\n- Gandalf",
      [138] = "If more of us valued food and cheer and song above hoarded gold, it would be a merrier world.\n- Thorin Oakenshield",
      [139] = "It is useless to meet revenge with revenge: it will heal nothing.\n- Frodo Baggins",
      [140] = "All have their worth and each contributes to the worth of the others.",
      [141] = "Be kind",
      [142] = "Getting closer",
      [143] = "Fun Fact: You rock!",
      [144] = "https://www.youtube.com/watch?v=dQw4w9WgXcQ",
      [145] = "/follow",
      [146] = "Fuck Lotro",
      [147] = "For Frodo!",
      [148] = "Can I have a moment of your time?",
      [149] = "Essences are a scourge on this game",
      [150] = "Hey there sweet cheecks",
      [151] = "Buying accounts is bad mmmmkay?",
      [152] = "You have the eyes of one that has travelled much",
      [153] = "Stonks",
      [154] = "The cycle of life can be cruel",
      [155] = "Ich bin der Uwe und ich bin auch dabei",
      [156] = "Any W I D E R S in the chat?",
      [157] = "The best way to win over a girl is to buy her a dress with pockets",
      [158] = "New to the LOTRO store: A plugin carry-all!",
      [159] = "It’s easy to do nothing, it’s hard to forgive. \n- Aang",
      [160] = "Sometimes life is like this tunnel. You can’t always see the light at the end of the tunnel, but if you keep moving, you will come to a better place. \n- Iroh",
      [161] = "My cabbages!!",
      [162] = "Little Soldier Boy Comes Marching Home. \n- Iroh",
      [163] = "Protection and power are overrated. I think you are very wise to choose happiness and love. \n- Iroh",
      [164] = "Life happens wherever you are, whether you make it or not.",
      [165] = "A man needs his rest.",
      [166] = "Leonthorn: alt tabbed for music instead of healing for agr",
      [167] = "Did you know the human body contains enough bones to make a skeleton?",
      [168] = "Your gameplay made possible by Prime!",
      [169] = "Prime confirmed best kin on Evernight",
      [170] = "Prime is the best kin in this game obvo",
      [171] = "You are hereby claimed as property of Prime",
      [172] = "You are welcome",
      [173] = "Prime send their regards",
      [174] = "If your kin doesn't have it's own Mikkye, is it really a kin?",
      [175] = "Getting carried by Prime",
      [176] = "With the help of Prime you don't even need your exploits anymore",
      [177] = "Can you imagine not wiping with Prime - I can't.",
      [178] = "Other kins may have select prime times, but in Prime it's always that time!",
      [179] = "Do you even 6 man Abyss bro?",
      [180] = "VT Tangleshot Barrage is a Prime original",
      [181] = "The results came in, you are NOT the father!",
      [182] = "The results came in, you are the father!",
      [183] = "Prime, the official World First Remmorchant T5 champions",  
      [184] = "If you are lagging remember; it is not you, this game is shit",  
      [185] = "/prime help, for a bunch of helpful commands",
      [186] = "/prime noteClear, to clear the notewindow",
      [187] = "New tiers of essences are an SSG scam to make more money",
      [188] = "The only thing essences provide the players with is an illusion of choice",
      [189] = "Mini-expansion is just code for moneygrab",
      [190] = "$$G",
      [191] = "2>1",
      [192] = "I am not fat, I am bouncy",
      [193] = "6 seasons and a movie",
      [194] = "Perfectly splendid!",
      [195] = "Exploits!",
      [196] = "How long is the perfect pull timer?",
      [197] = "STRANGER DANGER",
      [198] = "Shift + Escape to enable advanced mode",
      [199] = "This world is a prison",
      [200] = "Day " ..  math.floor((Turbine.Engine.GetLocalTime() - 1601467200) / 86400) .. " of asking for pvmp changes",
      [201] = "Too many requests, slow down!",
      [202] = "Help, I'm stuck ;)",
      [203] = "UO is a trash boss",
      [204] = "This is the way",
      [205] = "If you can't beat a raid just set it to level 1",
      [206] = "I was a professional raider until I took 6 permabans to the knee ;)",
      [207] = "EEEEAAAAGGGGLLLLEEEEEE",
      [208] = "How can I help?",
      [209] = "kick  out - to force someone to leave a place or organization",
      [210] = "Everybody lies",
      [211] = "Who has two thumbs and doesn't give a fuck? \n Not me :)",
      [212] = "Once a prime member, always a prime member i guess",
      [213] = "There is probably a PrimeUI for that.",
      [214] = "<Insert funny quote>",
      [215] = "They have taken the Bridge and the Second Hall. We have barred the gates, but cannot hold them for long. The ground shakes...",
      [216] = "Drums. Drums in the deep",
      [217] = "We cannot get out. A Shadow moves in the dark... We cannot get out... They are coming.",
      [218] = "Objection!",
      [219] = "Did you know you can move your combat timer and change its font? Wow, I know!",
      [220] = "You can disable group cooldown timers in the options",
      [221] = ":punch:",
      [222] = "If are enjoying the plugin and want to support it even more you can visit our patreon on: www.patreon.com/Rolorion",
      [223] = "Did you remember to thank your lord and plugin maker Rolo today?",
      [224] = "Rolo handing out raid completions on a server near you!",
      [225] = "Puhutko suomea?",
      [226] = "SNUGGLESTEIN!",
      [227] = "C&D, lack of players or lack of funding.",
      [228] = "Do you recall the most famous warg of them all?",
      [229] = "Greeting message #229",
      [230] = "Are you even a successful SSG dev if you do not have a fanfic?",
      [231] = "Lotro capitalisation is every word with a capital exept articles (Most of the time)",
      [232] = "Would you rather fight one man sized pear or 100 pear sized men?",
      [233] = "You have 100 LOTRO points!",
      [234] = "You have reloaded the plugin " .. tostring(StatEventHandling and StatEventHandling:GetAccountData()["Reload"] or -1) .. " times!",
      [235] = "Shiny and chrome!",
  }
end