LocationHandler = class(Turbine.UI.Control)
function LocationHandler:Constructor()
    Turbine.UI.Control.Constructor(self)

    assert(Settings ~= nil, "Settings are not loaded")

    self.LocationUpdate = function(sender, event, args)
        if type(event)=="function" then
            event(args)
        else
            if type(event)=="table" then
                for i = 1, #event do
                    if type(event[i])=="function" then
                        event[i](args)
                    end
                end
            end
        end
    end

    self.locations = LoadTable(Turbine.DataScope.Account, "PrimeLocations")

    if self.locations == nil then
        self.locations = {}
    end

    self.chatCallback = AddCallback(ChatEventHandler, "Standard", function(line)
        local location = string.match(line, "Entered the (.*) %- Regional channel.")
        if location then
            Settings.Location = location
            if not(self.locations [location]) then self.locations[location] = {} end
            self.LocationUpdate(self, self.Location, {["Location"] = location, ["Entered"] = true, ["Left"] = false})
        end

        local leftLocation = string.match(line, "Left the (.*) %- Regional channel.")
        if leftLocation then
            Settings.Location = ""
            self.LocationUpdate(self, self.Location, {["Location"] = "", ["Entered"] = false, ["Left"] = true})
        end
    end)
end

function LocationHandler:GetLocations()
    return self.locations
end

function LocationHandler:GetCurrentLocation()
    return Settings.Location
end

function LocationHandler:Unload()
    SaveTable(Turbine.DataScope.Account, "PrimeLocations", self.locations)
end