PlayerEffectEvents = class(Turbine.UI.Control)
function PlayerEffectEvents:Constructor()
    Turbine.UI.Control.Constructor(self)
    self.Player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.PlayerEffects = self.Player:GetEffects()

    self.EffectUpdate = function(sender, event, args)
        if type(event) == "function" then
            event(args)
        else
            if type(event) == "table" then
                for i = 1, #event do
                    if type(event[i]) == "function" then
                        event[i](args)
                    end
                end
            end
        end
    end

    self.addedCallbacks = AddCallback(self.PlayerEffects, "EffectAdded", function(sender, args)
        self.EffectUpdate(self, self.EffectAdded, self.PlayerEffects:Get(args.Index))
    end)

    self.removedCallbacks = AddCallback(self.PlayerEffects, "EffectRemoved", function(sender, args)
        if args.Effect then
            self.EffectUpdate(self, self.EffectRemoved, args.Effect)
        end
    end)
end

function PlayerEffectEvents:RemoveCallbacks()
    RemoveCallback(PlayerEffectsHandler, "EffectAdded", self.addedCallbacks)
    RemoveCallback(PlayerEffectsHandler, "EffectRemoved", self.removedCallbacks)
end