UpdateHandler = class(Turbine.UI.Control)
function UpdateHandler:Constructor()
    Turbine.UI.Control.Constructor(self)
    self:SetWantsUpdates(true)

    assert(Settings ~= nil, "Settings are not loaded")

    self.oldGameTime = Turbine.Engine.GetGameTime()

    self.UpdateDelay = Settings.UpdateDelay

    self.UpdateEvent = function(sender, event, args)
        if type(event)=="function" then
            event(args)
        else
            if type(event)=="table" then
                for i=1,#event do
                    if type(event[i])=="function" then
                        event[i](args)
                    end
                end
            end
        end
    end

    if self.UpdateDelay > 0 then 
        self.Update = function()
            local currentGameTime = Turbine.Engine.GetGameTime()
            if currentGameTime == self.oldGameTime then
                return(true)
            end
            local delta = currentGameTime - self.oldGameTime
    
            if delta < self.UpdateDelay then return end

            self.UpdateEvent(self, self.ExecuteUpdate, delta)
    
            self.oldGameTime = currentGameTime
        end
    else
        self.Update = function()
            local currentGameTime = Turbine.Engine.GetGameTime()
            if currentGameTime == self.oldGameTime then
                return(true)
            end
            local delta = currentGameTime - self.oldGameTime
    
            self.UpdateEvent(self, self.ExecuteUpdate, delta)
            
            self.oldGameTime = currentGameTime
        end
    end
end
 
function UpdateHandler:GetUpdateCount()
    return tablelength(self.ExecuteUpdate)
end