InstanceInfoWindow = class(Turbine.UI.Lotro.Window)
function InstanceInfoWindow:Constructor()
    local width = 700--math.max((tablelength(LootLocks.Characters) + 1) * 125, 5 * 125)
    local height = 700
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Window.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(x,y)
    self:SetVisible(true)
    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(true)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.windowBackground = Turbine.UI.Control()
    self.windowBackground:SetParent(self)
    self.windowBackground:SetSize(width - 5 * 2, height - 5 * 2)
    self.windowBackground:SetPosition(5, 5)
    self.windowBackground:SetMouseVisible(false)
    self.windowBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    if InstanceController then self.dungeonNames = InstanceController:GetDungeonNameTable() else self.dungeonNames = {} end

    self.topButtonDictionary = {}

    self.Moving = false

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MouseUp = function()
        self.Moving = false
    end

    self.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    self.closingButtonBackground = Turbine.UI.Control()
    self.closingButtonBackground:SetParent(self.windowBackground)
    self.closingButtonBackground:SetSize(35, 35)
    self.closingButtonBackground:SetPosition(self.windowBackground:GetWidth() - 35, 0)
    self.closingButtonBackground:SetMouseVisible(false)
    self.closingButtonBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local ClosingBUtton = Turbine.UI.Label()
    ClosingBUtton:SetParent(self.windowBackground)
    ClosingBUtton:SetPosition(self.windowBackground:GetWidth() - 30, 0)
    ClosingBUtton:SetSize(30, 30)
    ClosingBUtton:SetBackColor(Turbine.UI.Color(153/255, 0, 0))

    local ClosingBUttonImage = Turbine.UI.Label()
    ClosingBUttonImage:SetParent(ClosingBUtton)
    ClosingBUttonImage:SetPosition(2.5, 2.5)
    ClosingBUttonImage:SetSize(25, 25)
    ClosingBUttonImage:SetBackground("PrimePlugins/RaidTools/Images/X.tga")
    ClosingBUttonImage:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    ClosingBUttonImage:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    ClosingBUttonImage:SetWantsKeyEvents(false)
    ClosingBUttonImage:SetMouseVisible(false)

    ClosingBUtton.MouseClick = function()
        self:SetVisible(false)
    end

    --if true then return end

    self.active = "Loot"
    self.ChangeTopButtonChange = function(button)
        for key, value in pairs(self.topButtonDictionary) do
            if value == button and button ~= self.active then
                key:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
                self.active = button

            else
                if value == self.active then self.active = "" end
                key:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))
            end
        end

        if button == "Loot" then
            self.lootMenu:SetVisible(true)
        end

        if button == "History" then
            self.historicTreeview:SetVisible(true)
        end

        if button == "TEQ" then
            self.MplusWindow:SetVisible(true)
        end

        if button ~= "Loot" or self.active == "" then
            self.lootMenu:SetVisible(false)
        end

        if button ~= "History" or self.active == "" then
            self.historicTreeview:SetVisible(false)
        end

        if button ~= "TEQ" or self.active == "" then
            self.MplusWindow:SetVisible(false)
        end
    end

    
    self.mainMenuBackground = Turbine.UI.Control()
    self.mainMenuBackground:SetParent(self)
    self.mainMenuBackground:SetSize(width - 45, 35)
    self.mainMenuBackground:SetPosition(5, 5)
    self.mainMenuBackground:SetMouseVisible(false)
    self.mainMenuBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.mainMenu = Turbine.UI.Control()
    self.mainMenu:SetParent(self.mainMenuBackground)
    self.mainMenu:SetSize(width - 45, 30)
    self.mainMenu:SetPosition(0, 0)
    self.mainMenu:SetMouseVisible(false)
    self.mainMenu:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))

    self.lootButton = Turbine.UI.Label()
    self.lootButton:SetParent(self.mainMenu)
    self.lootButton:SetSize((width - 45) / 3, 30)
    self.lootButton:SetPosition(0, 0)
    self.lootButton:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    self.lootButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.lootButton:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    self.lootButton:SetText("Loot")
    self.lootButton:SetMouseVisible(true)
    self.topButtonDictionary[self.lootButton] = "Loot"

    self.lootButton.MouseClick = function()
        self.ChangeTopButtonChange("Loot")
    end

    self.InstanceHistory = Turbine.UI.Label()
    self.InstanceHistory:SetParent(self.mainMenu)
    self.InstanceHistory:SetSize((width - 45) / 3, 30)
    self.InstanceHistory:SetPosition((width - 45) / 3, 0)
    self.InstanceHistory:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))
    self.InstanceHistory:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.InstanceHistory:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    self.InstanceHistory:SetText("History")
    self.InstanceHistory:SetMouseVisible(true)
    self.topButtonDictionary[self.InstanceHistory] = "History"

    self.InstanceHistory.MouseClick = function()
        self.ChangeTopButtonChange("History")
    end

    self.teqScore = Turbine.UI.Label()
    self.teqScore:SetParent(self.mainMenu)
    self.teqScore:SetSize(math.ceil(width - 45) / 3 + 2, 30)
    self.teqScore:SetPosition((width - 45) / 3 * 2, 0)
    self.teqScore:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))
    self.teqScore:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.teqScore:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    self.teqScore:SetMouseVisible(true)
    self.teqScore:SetText("TEQ")
    self.topButtonDictionary[self.teqScore] = "TEQ"

    self.teqScore.MouseClick = function()
        self.ChangeTopButtonChange("TEQ")
    end

    self.teqControl = Turbine.UI.Control()
    self.teqControl:SetParent(self)
    self.teqControl:SetPosition(5 + (width - 500) / 2, 40)

    self.MplusWindow = MythicPlusViewer(self.teqControl)


    self.lootMenu = Turbine.UI.Control()
    self.lootMenu:SetParent(self)
    self.lootMenu:SetSize(width, height - 40)
    self.lootMenu:SetPosition(0, 40)
    self.lootMenu:SetMouseVisible(false)
    self.lootMenu:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.lootPage = LootUtils.LootLockWindow(self.lootMenu, LootHandler)

    self.InstanceLocks = nil
    self.RaidLocks = nil
    self.QuestLocks = nil

    BeginningOfPrimeTime = (AccountData["TimeZone"] - 1) * 3600

    local UIparent = nil

    local ButtonDictionary = {}
    local PageDictionary = {}

    local CurrentPage = nil

    self.KeyDown = function(sender, args)
        if args["Action"] == 145 then
            if self:IsVisible() then self:SetVisible(false) end
        end
    end

    self.ChangeButtonState = function(name)

        if CurrentPage == name then
            PageDictionary[name]:SetVisible(false)
            ButtonDictionary[name]:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
            CurrentPage = nil
            
        else
            for key, value in pairs(PageDictionary) do
                value:SetVisible(false)
            end
    
            for key, value in pairs(ButtonDictionary) do
                value:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
            end
    
            ButtonDictionary[name]:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
            
            PageDictionary[name]:SetVisible(true)

            CurrentPage = name
        end
    end

    self.ClearUI = function()
        for key, value in pairs(PageDictionary) do
            value:SetParent(nil)
        end

        for key, value in pairs(ButtonDictionary) do
            value:SetParent(nil)
        end
    end


    local _, accData = StatEventHandling:GetData()
    self.historicData = accData["BossData"]

    self.historicTreeview = Turbine.UI.TreeView()
    self.historicTreeview:SetParent(self)
    self.historicTreeview:SetSize(width - 10, height - 45)
    self.historicTreeview:SetPosition(5, 40)
    self.historicTreeview:SetVisible(false)
    self.historicTreeview:SetWantsKeyEvents(true)
    self.historicTreeview:SetMouseVisible(true)
    self.historicTreeview:SetIndentationWidth(0)

    self.historicTreeviewScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.historicTreeviewScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    self.historicTreeviewScrollbar:SetParent( self )
    self.historicTreeviewScrollbar:SetPosition( 2000 - 10, 46 )
    self.historicTreeviewScrollbar:SetSize( 10,46 )
    self.historicTreeview:SetVerticalScrollBar( self.historicTreeviewScrollbar )

    self.rootNodes = self.historicTreeview:GetNodes()

    for raidName, raidData in spairs(self.historicData, function(t, a, b) return tostring(self.dungeonNames[a]) < tostring(self.dungeonNames[b]) end) do

        local valuebar = Turbine.UI.TreeNode()
        valuebar:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        valuebar:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        --valuebar:SetBackColor(Turbine.UI.Color(0.6, 0.125, 0.125, 0.125))
        valuebar:SetSize(width, 65)
    
        valuebar.left = Turbine.UI.Control()
        valuebar.left:SetParent(valuebar)
        valuebar.left:SetSize(80,80)
        valuebar.left:SetBackground(0x411C0E92)
        valuebar.left:SetPosition(-5, -5)
        valuebar.left:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    
        valuebar.middle = Turbine.UI.Control()
        valuebar.middle:SetParent(valuebar)
        valuebar.middle:SetSize(width - 155,80)
        valuebar.middle:SetBackground(0x411C0E94)
        valuebar.middle:SetPosition(75, -5)
        valuebar.middle:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    
        valuebar.right = Turbine.UI.Control()
        valuebar.right:SetParent(valuebar)
        valuebar.right:SetSize(80,80)
        valuebar.right:SetBackground(0x411C0E9D)
        valuebar.right:SetPosition(width - 80, -5)
        valuebar.right:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
     
        valuebar.label = Turbine.UI.Label()
        valuebar.label:SetParent(valuebar)
        valuebar.label:SetSize(width, 70)
        valuebar.label:SetPosition(30, 0)
        valuebar.label:SetMouseVisible(false)
        valuebar.label:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        --valuebar.label:SetBackColor(Turbine.UI.Color(0.6, 0.125, 0.125, 0.125))
        valuebar.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        valuebar.label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
        valuebar.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
        valuebar.label:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        valuebar.label:SetText(tostring(self.dungeonNames[raidName]))

        local raidNodes = valuebar:GetChildNodes()

        for bossName, tierData in spairs(raidData, function(t, a, b) return a < b end) do
            local bossNameHeader = Turbine.UI.TreeNode()
            bossNameHeader:SetSize(width - 10, 30)
            
            bossNameHeader.bossNameHeaderControl = Turbine.UI.Control()
            bossNameHeader.bossNameHeaderControl:SetParent(bossNameHeader)
            bossNameHeader.bossNameHeaderControl:SetSize(width - 10, 30)
        
            bossNameHeader.bossNameHeaderLeft = Turbine.UI.Control()
            bossNameHeader.bossNameHeaderLeft:SetParent(bossNameHeader)
            bossNameHeader.bossNameHeaderLeft:SetSize(34, 30)
            bossNameHeader.bossNameHeaderLeft:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
            bossNameHeader.bossNameHeaderLeft:SetBackground(0x4110A0E0)
        
            bossNameHeader.bossNameHeaderRight = Turbine.UI.Label()
            bossNameHeader.bossNameHeaderRight:SetParent(bossNameHeader)
            bossNameHeader.bossNameHeaderRight:SetPosition(width - 34 - 10, 0)
            bossNameHeader.bossNameHeaderRight:SetSize(34, 30)
            bossNameHeader.bossNameHeaderRight:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
            bossNameHeader.bossNameHeaderRight:SetBackground(0x4110A0DB)
        
            bossNameHeader.bossNameHeaderMiddle = Turbine.UI.Label()
            bossNameHeader.bossNameHeaderMiddle:SetParent(bossNameHeader)
            bossNameHeader.bossNameHeaderMiddle:SetPosition(34, 0)
            bossNameHeader.bossNameHeaderMiddle:SetSize(width - 68 - 10, 30)
            bossNameHeader.bossNameHeaderMiddle:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
            bossNameHeader.bossNameHeaderMiddle:SetBackground(0x4110A0D9)
        
            bossNameHeader.bossNameHeaderHeaderLabel = Turbine.UI.Label()
            bossNameHeader.bossNameHeaderHeaderLabel:SetParent(bossNameHeader)
            bossNameHeader.bossNameHeaderHeaderLabel:SetSize(width - 10, 30)
            bossNameHeader.bossNameHeaderHeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
            bossNameHeader.bossNameHeaderHeaderLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
            bossNameHeader.bossNameHeaderHeaderLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
            bossNameHeader.bossNameHeaderHeaderLabel:SetText(bossName)
             
            bossNameHeader.bossNameHeaderHeaderLabel.MouseEnter = function()
                bossNameHeader.bossNameHeaderLeft:SetBackground(0x4110A0DF)
                bossNameHeader.bossNameHeaderMiddle:SetBackground(0x4110A0DD)
                bossNameHeader.bossNameHeaderRight:SetBackground(0x4110A0DE)
            end
        
            bossNameHeader.bossNameHeaderHeaderLabel.MouseUp = function()
                bossNameHeader.bossNameHeaderLeft:SetBackground(0x4110A0E0)
                bossNameHeader.bossNameHeaderMiddle:SetBackground(0x4110A0D9)
                bossNameHeader.bossNameHeaderRight:SetBackground(0x4110A0DB)
            end
        
            bossNameHeader.bossNameHeaderHeaderLabel.MouseDown = function()
                bossNameHeader.bossNameHeaderLeft:SetBackground(0x4110A0D8)
                bossNameHeader.bossNameHeaderMiddle:SetBackground(0x4110A0DA)
                bossNameHeader.bossNameHeaderRight:SetBackground(0x4110A0DC)
            end
        
            bossNameHeader.bossNameHeaderHeaderLabel.MouseLeave = function()
                bossNameHeader.bossNameHeaderLeft:SetBackground(0x4110A0E0)
                bossNameHeader.bossNameHeaderMiddle:SetBackground(0x4110A0D9)
                bossNameHeader.bossNameHeaderRight:SetBackground(0x4110A0DB)
            end
    
            raidNodes:Add(bossNameHeader)

            local tierNodes = bossNameHeader:GetChildNodes()

            for tier, bossTierData in spairs(tierData, function(t, a, b) return tostring(a) < tostring(b) end) do
                local SourceNode = Turbine.UI.TreeNode()
                SourceNode:SetSize(width - 10, 20 + 2)
            
                SourceNode.SourceLabel = Turbine.UI.Label()
                SourceNode.SourceLabel:SetParent(SourceNode)
                SourceNode.SourceLabel:SetPosition(1,1)
                SourceNode.SourceLabel:SetSize(width - 10- 2, 20)
                SourceNode.SourceLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                SourceNode.SourceLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
                SourceNode.SourceLabel:SetMouseVisible(true)
            
                SourceNode.LefLabel = Turbine.UI.Label()
                SourceNode.LefLabel:SetParent(SourceNode)
                SourceNode.LefLabel:SetPosition(0, 0)
                SourceNode.LefLabel:SetSize(30, 20)
                SourceNode.LefLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                SourceNode.LefLabel:SetBackground(0x4111D1FA)
                SourceNode.LefLabel:SetMouseVisible(false)
            
                SourceNode.RigthLabel = Turbine.UI.Label()
                SourceNode.RigthLabel:SetParent(SourceNode)
                SourceNode.RigthLabel:SetPosition(width - 157, 0)
                SourceNode.RigthLabel:SetSize(147, 20)
                SourceNode.RigthLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                SourceNode.RigthLabel:SetBackground(0x4111D1FA)
                SourceNode.RigthLabel:SetMouseVisible(false)
            
                SourceNode.MidLabel = Turbine.UI.Label()
                SourceNode.MidLabel:SetParent(SourceNode)
                SourceNode.MidLabel:SetPosition(30, 0)
                SourceNode.MidLabel:SetSize(width - 70, 20)
                SourceNode.MidLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                SourceNode.MidLabel:SetBackground(0x4111D201)
                SourceNode.MidLabel:SetMouseVisible(false)
            
                SourceNode.textLabel = Turbine.UI.Label()
                SourceNode.textLabel:SetParent(SourceNode)
                SourceNode.textLabel:SetPosition(1,1)
                SourceNode.textLabel:SetSize(width - 10- 2, 20)
                SourceNode.textLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                SourceNode.textLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
                SourceNode.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
                SourceNode.textLabel:SetMouseVisible(false)
                SourceNode.textLabel:SetText("Tier: " .. tier)
            
                SourceNode.SourceLabel.MouseEnter = function()
                    SourceNode.LefLabel:SetBackground(0x4111D1FB)
                    SourceNode.RigthLabel:SetBackground(0x4111D1FB)
                    SourceNode.MidLabel:SetBackground(0x4111D202)
                end
            
                SourceNode.SourceLabel.MouseLeave = function()
                    SourceNode.LefLabel:SetBackground(0x4111D1FA)
                    SourceNode.RigthLabel:SetBackground(0x4111D1FA)
                    SourceNode.MidLabel:SetBackground(0x4111D201)
                end
            
                SourceNode.SourceLabel.MouseDown = function()
                    SourceNode.LefLabel:SetBackground(0x4111D1FC)
                    SourceNode.RigthLabel:SetBackground(0x4111D1FC)
                    SourceNode.MidLabel:SetBackground(0x4111D203)
                end
            
                SourceNode.SourceLabel.MouseUp = function()
                    SourceNode.LefLabel:SetBackground(0x4111D1FA)
                    SourceNode.RigthLabel:SetBackground(0x4111D1FA)
                    SourceNode.MidLabel:SetBackground(0x4111D201)
                end

                tierNodes:Add(SourceNode)

                local tierDataNodes = SourceNode:GetChildNodes()

                for valueName, value in spairs(bossTierData, function(t, a, b) return tostring(a) < tostring(b) end) do
                    local valueNode = Turbine.UI.TreeNode()
                    valueNode:SetSize(width - 10, 20 + 2 + 2)
                
                    valueNode.SourceLabel = Turbine.UI.Label()
                    valueNode.SourceLabel:SetParent(valueNode)
                    valueNode.SourceLabel:SetPosition(1,1)
                    valueNode.SourceLabel:SetSize(width - 10- 2, 20)
                    --valueNode.SourceLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                    valueNode.SourceLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
                    valueNode.SourceLabel:SetMouseVisible(true)
                    valueNode.SourceLabel:SetText(self:HandleInfoText(valueName, value))

                    valueNode.LineControl = Turbine.UI.Control()
                    valueNode.LineControl:SetParent(valueNode)
                    valueNode.LineControl:SetPosition(1,20)
                    valueNode.LineControl:SetSize(width - 10- 2, 2)
                    valueNode.LineControl:SetMouseVisible(true)
                    valueNode.LineControl:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

                    if valueName == "FirstCompletedGroup" then
                        valueNode:SetSize(width - 10, 40 + 2 + 2)
                        valueNode.SourceLabel:SetSize(width - 10- 2, 40)
                        valueNode.LineControl:SetPosition(1,40)
                    end

                    tierDataNodes:Add(valueNode)
                end
            end
        end

        self.rootNodes:Add(valuebar)
    end

end

function InstanceInfoWindow:HandleInfoText(valueName, value)
    if valueName == "BestTime" then
        if value > 999999 then
            return "Best Time: -"
        else
            return "Best Time: " .. FormatTimeString(value)
        end
    end

    if valueName == "FirstCompletion" then
        if value == -1 then
            return "First Completion: -"
        else
            local deltaTime = value - 1546297200            
            local years = math.floor(deltaTime / 31556926)
            local months = math.floor((deltaTime - years * 31556926) /  2629743.83)
            local days = math.floor(((deltaTime - years * 31556926) - months * 2629743.83) / 86400)
            return "First Completion: " .. ((days) % 31) + 1 .. "/" .. ((months) % 12) + math.floor((days) / 31) + 1 .. "/" .. years + 19 + math.floor((months) / 12)
        end
    end

    if valueName == "FirstCompletionCount" then
        if value == -1 then
            return "First Completed Attempt: -"
        else
            return "First Completed Attempt: " .. tostring(value)
        end
    end

    if valueName == "FirstCompletedCharacter" then
        return "First Completed on Character: " .. value
    end

    if valueName == "FirstCompletedGroup" then
        return "First Completed with Group: " .. value
    end
    
    return valueName .. ": " .. value
end

InstanceWindowButton = class(Turbine.UI.Lotro.Window)
function InstanceWindowButton:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.width = 32
    self.height = 32
    self:SetPosition(Settings.MythicPlusButtonX, Settings.MythicPlusButtonY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(Settings.MythicPlusVisible)
    self:SetMouseVisible(true)
    self:SetBackground(0x411D3647)
    self:SetBackground(0x410DB85B)
    
    self.MouseClick = function()
        if InstanceWindow then
            InstanceWindow:SetVisible(true)
        else
            InstanceWindow = Instances.InstanceInfoWindow()
        end
    end

    self.moveBox = MoveBox(self, self.width, self.height, "Instance Button")

    self.ToggleMove = function()
        self.moveBox:ToggleMove()
    end

end

function InstanceWindowButton:Unload()
    Settings.MythicPlusButtonX, Settings.MythicPlusButtonY = self:GetPosition()
end