
MythicPlus = class(Turbine.UI.Window)
function MythicPlus:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.width = 300
    self.height = 190
    self:SetPosition(Settings.MythicPlusX, Settings.MythicPlusY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(false)
    self:SetMouseVisible(true)

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.NameLabel = Turbine.UI.Label()
    self.NameLabel:SetParent(self)
    self.NameLabel:SetSize(300, 30)
    self.NameLabel:SetPosition(0, 0)
    self.NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold30)
    self.NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.NameLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.NameLabel:SetMouseVisible(false)
    --self.NameLabel:SetText("Cord's Panties")

    self.TimeLabel = Turbine.UI.Label()
    self.TimeLabel:SetParent(self)
    self.TimeLabel:SetSize(300, 20)
    self.TimeLabel:SetPosition(0, 30)
    self.TimeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.TimeLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold22)
    self.TimeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TimeLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.TimeLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.TimeLabel:SetMouseVisible(false)
    --self.TimeLabel:SetText("[T2] 25:44 / 41:00")

    self.DeathLabel = Turbine.UI.Label()
    self.DeathLabel:SetParent(self)
    self.DeathLabel:SetSize(300, 20)
    self.DeathLabel:SetPosition(0, 50)
    self.DeathLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.DeathLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.DeathLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.DeathLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.DeathLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.DeathLabel:SetMouseVisible(false)
    --self.DeathLabel:SetText("Deaths: 0 - Time lost: 0:00")

    self.TrashLabel = Turbine.UI.Label()
    self.TrashLabel:SetParent(self)
    self.TrashLabel:SetSize(300, 20)
    self.TrashLabel:SetPosition(0, 70)
    self.TrashLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.TrashLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.TrashLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.TrashLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.TrashLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.TrashLabel:SetMouseVisible(false)
    --self.TrashLabel:SetText("Enemy Forces - 0.0%")

    -- Reset logic

    Settings.MythicPlusSeason = 2

    self.bossLabels = {}

    self.active = false

    self:LoadData()

    self.instanceVersion = 0
    self.instanceData = nil
    self.trashCount = 0
    self.maxTrashCount = 1
    self.timer = 0
    self.startTime = Turbine.Engine.GetGameTime()
    self.tier = 0
    self.maxTime = 0
    self.maxTimeString = ""
    self.maxTimeString = CombatTimeDeltaToString((41 * 60))
    self.bossCount = 0
    self.addedDeathTime = 0
    self.deathCount = 0

    --self:LoadDungeon(32, 2)

    self.Moving = false

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.MouseUp = function()
        self.Moving = false
    end
  
    self.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          self:SetPosition(newLeft,newTop)
        end
    end
    
    self.ToggleMove = function()
      self.MoveBox:SetVisible(not self.MoveBox:IsVisible())
    end
end

function MythicPlus:GetDungeonData(id)
    if id and self.DungeonInfo then return self.DungeonInfo[id] end
    return self.DungeonInfo
end

function MythicPlus:AddBossLabel(name)
    local BossLabel = Turbine.UI.Label()
    BossLabel:SetParent(self)
    BossLabel:SetSize(300, 20)
    BossLabel:SetPosition(0, 90 + self.bossCount * 20)
    BossLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    BossLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    BossLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    BossLabel:SetMultiline(false)
    BossLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    BossLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    BossLabel:SetMouseVisible(false)
    BossLabel:SetText("0/1 " .. name)

    self.bossLabels[name] = BossLabel

    self.bossCount = self.bossCount + 1
end

function MythicPlus:LoadDungeon(id, tier)

    self.active = false

    self:SetVisible(false)
    for key, value in pairs(self.bossLabels) do
        value:SetParent(nil)
        self.bossLabels[key] = nil
    end
    self.bossCount = 0

    self.instanceVersion = id
    self.tier = tier
    self.trashCount = 0
    self.timer = 0
    self.startTime = 0
    self.finished = false
    self.progress = nil
    self.instanceData = nil
    self.maxTime = 0
    self.maxTrashCount = 0
    self.maxTimeString = 0
    self.addedDeathTime = 0
    self.deathCount = 0
    self:SetWantsUpdates(false)
    self.trashComplete = false
    self.partyNames = {}
    collectgarbage()

    if not(tonumber(tier)) or tonumber(tier) < 2 then 
        return
    end

    if self.DungeonInfo[id] then
        self.active = true
        self.instanceData = self.DungeonInfo[id]
        self.maxTime = self.instanceData["Time"]
        self.maxTrashCount = self.instanceData["MaxTrash"]
        self.maxTimeString = CombatTimeDeltaToString(self.instanceData["Time"])
        self.NameLabel:SetText(self.instanceData["Name"])
        self.startTime = Turbine.Engine.GetGameTime()
        self.progress = {
            ["Trash"] = false
        }
        for key, value in spairs(self.instanceData["Bosses"], function(t,a,b) return t[b] > t[a] end) do
            self:AddBossLabel(key)
            self.progress[key] = false
        end
        self.DeathLabel:SetText("Deaths: 0 - Time lost: 0:00")
        self.TrashLabel:SetText("Enemy Forces - 0.0%")
        self:SetVisible(Settings.MythicPlusVisible)
        self.party = self.player:GetParty()

        if self.party then
            for i = 1, self.party:GetMemberCount(), 1 do
                self.partyNames[self.party:GetMember(i):GetName()] = true
            end
        end
    end


    self:SetWantsUpdates(true)

end

function MythicPlus:Update(sender, args)
    self.timer = Turbine.Engine.GetGameTime() - self.startTime
    self.TimeLabel:SetText("[T" .. self.tier ..  "] ".. FormatTimeString(self.timer + self.addedDeathTime) .. " / " .. self.maxTimeString)
end

function MythicPlus:Parse(line, chatType)
    if not(self.active) then return end

    if line then self:KillParse(line) end
end

function MythicPlus:KillParse(line)

    local kill = string.match(line, "defeated ".."(.+)".. "%.")

    local newCount = self.instanceData["Trash"][kill]
    if newCount then
        self:UpdateCount(newCount)
    end

    if self.partyNames[kill] then self:AddDeath() end

    if self.instanceData["Bosses"][kill] then
        self:UpdateBoss(kill)
    else
        local suicide = string.match(line, "(.+)" .. " died.")
        if self.instanceData["Bosses"][suicide] then
            self:UpdateBoss(suicide)
        end
    end

    if string.find(line, "has been defeated") or 
    string.find(line, " incapacitated you.") or 
    string.find(line, "You have been incapacitated by misadventure.") then
        self:AddDeath()
    end

end

function MythicPlus:UpdateBoss(name)
    self.bossLabels[name]:SetText("1/1 " .. name .. " " .. FormatTimeString(Turbine.Engine.GetGameTime() - self.startTime))
    self.progress[name] = true
    self:UpdateProgress()
end

function MythicPlus:UpdateCount(newCount)
    self.trashCount = self.trashCount + newCount

    if self.trashComplete then return end

    if self.trashCount >= self.maxTrashCount then 
        self.progress["Trash"] = true
        self.trashComplete = true
        self:UpdateProgress() 
        self.TrashLabel:SetText("Enemy Forces - 100%") 
    else
        self.TrashLabel:SetText("Enemy Forces - " .. Round(self.trashCount / self.maxTrashCount * 100) .. "%")    
    end

    --ChatOutput(self.trashCount)
    -- update UI
end

function MythicPlus:AddDeath()
    self.deathCount = self.deathCount + 1
    self.addedDeathTime = self.addedDeathTime + 5

    self.DeathLabel:SetText("Deaths: " .. self.deathCount .. " - Time lost: " .. CombatTimeDeltaToString(self.addedDeathTime))

end

function MythicPlus:UpdateProgress()
    for key, value in pairs(self.progress) do
        --ChatOutput(key)
        if value == false then return end
    end

    self:Finish()


    -- we won
end

function MythicPlus:Finish()
    if self.finished then return end

    self.finished = true

    self:SetWantsUpdates(false)

    local score = self:CalculateScore(self.tier, self.timer + self.addedDeathTime, self.maxTime)

    local party = {}

    if self.player:GetParty() then
        for i = 1, self.player:GetParty():GetMemberCount(), 1 do
            local member = self.player:GetParty():GetMember(i)
            party[i] = {["Name"] = member:GetName(), ["Class"] = member:GetClass(), ["Level"] = member:GetLevel()}
        end
    end

    --SaveMythicPlusData(self.instanceVersion, self.player:GetName(), {["Date"] = Turbine.Engine.GetLocalTime(), ["Trash"] = self.trashCount, ["TrashM"] = self.maxTrashCount, ["Deaths"] = self.deathCount, ["DeathTime"] = self.addedDeathTime, ["CompletionTime"] = self.timer + self.addedDeathTime, ["MaxTime"] = self.maxTime, ["Name"] = self.instanceData["Name"], ["Tier"] = self.tier, ["Finished"] = self.finished, ["Progress"] = self.progress, ["GameTime"] = Turbine.Engine.GetGameTime(), ["Timer"] = self.timer, ["StartTime"] = self.startTime, ["Name"] = self.player:GetName(), ["Level"] = self.player:GetLevel(), ["Class"] = self.player:GetClass(), ["Role"] = Roles:GetRole(), ["Line"] = Roles:GetLine(), ["Score"] = score, ["Party"] = party, ["Season"] = Settings.MythicPlusSeason})
    StatEventHandling:AddMythicPlusScore(self.instanceVersion, self.player:GetName(), {["Score"] = score, ["Tier"] = self.tier, ["Time"] = self.timer + self.addedDeathTime, ["Max Time"] = self.maxTime, ["Season"] = Settings.MythicPlusSeason})

    ChatOutput("<rgb=#FF9900>Completed " .. self.instanceData["Name"] .. " in " .. FormatTimeString(self.timer + self.addedDeathTime) .. " on T" .. self.tier .. " difficulty for a score of " .. Round(score, 1) .. "!")
end

function MythicPlus:CalculateScore(tier, time, maxTime)
    return math.max((tier - 1) * 100 + self:ReturnScoreRange(tier, time, maxTime), 0)
end

function MythicPlus:ReturnScoreRange(tier, time, maxTime)
    --local scaling = time / maxTime

    --local bonus = math.floor(math.max(0, math.abs(math.max(0.7, scaling) - 1)) / 0.1)

    --local timeScore = 1 - (1 / (math.exp((1 - scaling - 0.5)))) * 1000

    --local timeScore = 300 - 300 * scaling + bonus * 20
    return (1 - (1 / (math.exp( (1 - (time / maxTime)) * (0.1 + 0.1 * (tier - 1)))))) * 1000

    --return timeScore
end

function MythicPlus:LoadData()
    -- Roost 15 
    self.DungeonInfo = {
        [10] = {
            ["Bosses"] = {
                ["Azbauz"] = 1,
                ["Maugrush"] = 2,
                ["Shatarkha"] = 3,
                ["Groz-and-Ulk"] = 4,
            },
            ["Trash"] = {
                ["the Gundabad Warg"] = 2, -- 3 
                ["the Gundabad Goblin Trasher"] = 1, -- 6
                ["the Gundabad Defiler"] = 2, -- 3
                ["the Gundabad Warrior"] = 1, -- 19
                ["the Gundabad Archer"] = 1, -- 3
                ["the Gundabad Captain"] = 5, -- 2
                ["the Frostbound Hobgoblin"] = 5, -- 2
                ["the Gundabad Troll"] = 4, -- 3
                ["the Gundabad Heaver"] = 3, -- 2

            },
            ["Time"] = 18 * 60,
            ["Name"] = "Shakalush",
            ["MaxTrash"] = 78,
            ["Season"] = 1,
        },
        [11] = {
            ["Bosses"] = {
                ["Shaktur"] = 1,
                ["Dargásh"] = 2,
            },
            ["Trash"] = {
                ["the Goblin-scout"] = 0, -- 6
                ["the Ugrukhôr Warrior"] = 2, -- 16 2
                ["the Ugrukhôr Archer"] = 1, -- 2 1
                ["the Ugrukhôr Sergeant"] = 5, -- 4
                ["the Ugrukhôr Defiler"] = 3, -- 2
                ["the Gothmog Warrior"] = 2, -- 7
                ["the Gothmog Sergeant"] = 5, -- 2
                ["the Gothmog Defiler"] = 3, -- 2
                ["the Gothmog Archer"] = 1, -- 1

            },
            ["Time"] = 8 * 60,
            ["Name"] = "Harrowing",
            ["MaxTrash"] = 86,
            ["Season"] = 0,
        },
        [12] = {
            ["Bosses"] = {
                ["Manôzagar"] = 1,
                ["Narkhor the Flensed"] = 2,
                ["Agath-kali, the Gaunt-woman"] = 3,
            },
            ["Trash"] = {
                ["the Bound Fell-spirit"] = 0, -- 2
                ["the Nîluzir"] = 10, -- 3
                ["the Shadow-sworn Tormentor"] = 15, 
                ["the Shadow-sworn Acolyte"] = 3,  -- 3

                ["the Flayed Servant"] = 1, -- 20
                ["the Flayed Fanatic"] = 1, -- 23
                ["the Flayed Warrior"] = 3, -- 12

                ["the Stained Morvul"] = 5, -- 5
                ["the Stained Morroval"] = 5, -- 5
                ["the Stained Great-bat"] = 3, -- 3

                ["the Gaunt-man"] = 10, -- 7
                ["the Dark Tendril"] = 0, -- 10  

            },
            ["Time"] = 35 * 60,
            ["Name"] = "Bâr Nírnaeth",
            ["MaxTrash"] = 260, --247
            ["Season"] = 0,
        }, 
        [13] = {
            ["Bosses"] = {
                ["Balchneth"] = 1,
                ["Gwaurodel"] = 2,
            },
            ["Trash"] = {
                ["the Bloated Morgul Leech"] = 3, --
                ["the Morgulduin Vapour"] = 1, -- 4
                ["the Morgul Fumarole"] = 10, -- 2
                ["the Morgul Leech"] = 3, -- 
                ["the Morgul Darkwater"] = 3, --
                ["the Rotting Darkwater"] = 3, --
                ["the Morgul Crawler"] = 3, --
                ["the Bloated Morgul Crawler"] = 3, --
                ["the Morgul Root"] = 5, --
                ["the Morgul Filth"] = 3, --
                ["the Shadow Fumarole"] = 10, --

            },
            ["Time"] = 25 * 60,
            ["Name"] = "Eithel Gwaur",
            ["MaxTrash"] = 60,
            ["Season"] = 0,
        },
        [14] = {
            ["Bosses"] = {
                ["Khúrthak the Rent"] = 1, 
                ["Khatlob, the Brood Mother"] = 2,
            },
            ["Trash"] = {
                ["the Orc Guard"] = 3, -- 9
                ["the Orc Sentry"] = 2, -- 6
                ["the Gorthrog Warrior"] = 5, -- 2
                ["the Fell Beast Hatchling"] = 1, -- 6
                ["the Shadow-roost Fell Beast"] = 0, -- 1
            },
            ["Time"] = 8 * 60,
            ["Name"] = "Gath Daeroval",
            ["MaxTrash"] = 45,
            ["Season"] = 0,
        },
        [15] = {
            ["Bosses"] = {
                ["Dolguzigir, the Dark Archivist"] = 1,
            },
            ["Trash"] = {
                ["the Bound Protector"] = 3, -- 8
                ["the Dark Cataloguer"] = 2, -- 3
                ["the Shade of the Past"] = 2, -- 8
                ["the Warden of the Archive"] = 20, -- 2
                ["the Shade of Dark Knowledge"] = 4, -- 3
                ["the Dark Curator"] = 1, -- 10
                ["the Bound Protector"] = 4, -- 2
                ["the Shade of the Past"] = 4, -- 2
            },
            ["Time"] = 15 * 60,
            ["Name"] = "Ghashan-kútot",
            ["MaxTrash"] = 140,
            ["Season"] = 0,
        },
        [16] = {
            ["Bosses"] = {
                ["Shalgoth"] = 1,
                ["Gurzhorn"] = 2,
            },
            ["Trash"] = {
                ["the Morgul Wight"] = 0, -- 3
                ["the Corpse Eater"] = 1, -- 17
                ["the Pile of Bones"] = 10, -- 10
                ["the Kergrim Ravager"] = 1, -- 9 -- 2
                ["the Kergrim Prowler"] = 2, -- 11
                ["the Kergrim Invoker"] = 2, -- 4
                ["the Morgul Barrow-wight"] = 2, -- 10
                ["the Morgul Ritualist"] = 3, -- 15
                ["the Shambling Barrow-wight"] = 5, -- 6

            },
            ["Time"] = 20 * 60,
            ["Name"] = "Gorthad Nûr",
            ["MaxTrash"] = 251,
            ["Season"] = 0,
        },
        [17] = {
            ["Bosses"] = {
                ["The Witch-king"] = 1,
            },
            ["Trash"] = {
                ["The Bane of Rhûn"] = 1, 
                ["The High Sorcerer of Harad"] = 1, 
                ["The Black Blade of Lebennin"] = 1,
                ["The Forsaken Reaver"] = 1,
                ["The Gloom of Nurn"] = 1, 
                ["The Cursed Rider"] = 1, 
                ["The Grim Southron"] = 1, 
                ["The Woe of Khand"] = 1, 

            },
            ["Time"] = 10 * 60,
            ["Name"] = "The Fallen Kings",
            ["MaxTrash"] = 8,
            ["Season"] = 0,
        },
        [32] = {
            ["Bosses"] = {
                ["Aigrith the Ashen"] = 1,
                ["Rúcrog Hoarpelt"] = 2,
                ["Storm of the Witch-king"] = 3,
            },
            ["Trash"] = {
                ["the Angmarim Sorceress"] = 2, -- 13 -- 3
                ["the Angmarim Sorcerer"] = 2, -- 14 -- 5
                ["the Angmarim Captain"] = 5, -- 11
                ["the Gauradan Hunter"] = 1, -- 9
                ["the Gauradan Elder"] = 3, -- 4
                ["the Gauradan Warrior"] = 2, -- 9

            },
            ["Time"] = 12 * 60,
            ["Name"] = "Agoroth",
            ["MaxTrash"] = 148,
            ["Season"] = 1,
        },
        [33] = {
            ["Bosses"] = {
                ["Gulmúk Dampmould"] = 1,
                ["The Morgul Blade"] = 2,
            },
            ["Trash"] = {
                ["the Wood-troll Warrior"] = 3, -- 8 -- 5
                ["the Wood-troll Lobber"] = 3, -- 8 -- 4
                ["the Wood-troll Corruptor"] = 3, -- 12 -- 4
                ["the Accursed Fell-spirit"] = 6, -- 2
                ["the Creeping Root"] = 1, -- 11
            },
            ["Time"] = 6 * 60,
            ["Name"] = "Woe",
            ["MaxTrash"] = 50,
            ["Season"] = 1,
        },
        [36] = {
            ["Bosses"] = {
                ["The Shadowed King"] = 1,
            },
            ["Trash"] = {
                ["the Oozing Darkling"] = 1, -- 11
                ["the Shadowed Dark-maw"] = 2, -- 4
                ["the Frenzied Dark-maw"] = 2, -- 9
                ["the Vigilant Dark-maw"] = 3, -- 3
                ["the Shadowed World-eater"] = 5, -- 1
            },
            ["Time"] = 10 * 60,
            ["Name"] = "Askâd-mazal",
            ["MaxTrash"] = 51,
            ["Season"] = 0,
        },
        [39] = {
            ["Bosses"] = {
                ["Gâdh-and-Shum"] = 1,
                ["Mozrúk"] = 2,
            },
            ["Trash"] = {
                ["the Goblin Bomber"] = 1, -- 3 + 0 + 4
                ["the Orc Sentry"] = 1, --4 + 1 + )
                ["the Orc Guard"] = 1, --4 + 3 + 0
                ["the Goblin Book-tosser"] = 3, --4 + 5 + 0
                ["the Shadow Apprentice"] = 5, --2 + 2 + 0
                ["the Goblin Burglar"] = 5, -- 2 + 0 + 0
                ["the Orc Beast-master"] = 5, -- 1 + 0 + 1 (2)
                ["the Goblin Scroll-snatcher"] = 3, --1 + 1
                ["the Troll Hauler"] = 10, -- 1 + 0
            },
            ["Time"] = 15 * 60,
            ["Name"] = "Assault on Dhúrstrok",
            ["MaxTrash"] = 80,
            ["Season"] = 2,
        },
        [40] = {
            ["Bosses"] = {
                ["Kordkoth"] = 1,
                ["Pughlak"] = 2,
            },
            ["Trash"] = {
                ["the Influenced Goblin"] = 3, -- 5
                ["the Deep-toad"] = 4, -- 4

            },
            ["Time"] = 15 * 60,
            ["Name"] = "Den of Pughlak",
            ["MaxTrash"] = 30,
            ["Season"] = 2,
        }
    }
end

MythicButton = class(Turbine.UI.Lotro.Window)
function MythicButton:Constructor(window)
    Turbine.UI.Window.Constructor(self)
    self.width = 24
    self.height = 24
    self:SetPosition(Settings.MythicPlusButtonX, Settings.MythicPlusButtonY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(Settings.MythicPlusVisible)
    self:SetMouseVisible(true)
    self:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/Keystone.tga"))

    self.MouseClick = function()
        window:SetVisible(not(window:IsVisible()))
    end

    self.Moving = false

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.MouseUp = function()
        self.Moving = false
    end
  
    self.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          self:SetPosition(newLeft,newTop)
        end
    end
    
    self.ToggleMove = function()
      self.MoveBox:SetVisible(not self.MoveBox:IsVisible())
    end

end

MythicPlusViewer = class(Turbine.UI.Window)
function MythicPlusViewer:Constructor(parent)
    Turbine.UI.Window.Constructor(self)
    self:SetParent(parent)
    self.width = 500
    self.height = 500
    --self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - self.width / 2, Turbine.UI.Display.GetHeight() / 2 - self.height / 2)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(false)
    self:SetMouseVisible(true)
    self:SetText("TEQ Scores")

    if InstanceController then 
        self.dungeonNames = InstanceController:GetDungeonNameTable() 
        self.dungeonData = InstanceController:GetMPlusTable()
    else 
        self.dungeonNames = {} 
        self.dungeonData = {}
    end

    self.currentSeason = 2

    self.totalScoreTitleLabel = Turbine.UI.Label()
    self.totalScoreTitleLabel:SetParent(self)
    self.totalScoreTitleLabel:SetSize(200, 20)
    self.totalScoreTitleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.totalScoreTitleLabel:SetMultiline(false)
    self.totalScoreTitleLabel:SetPosition(10, 50)
    self.totalScoreTitleLabel:SetText("TEQ Score: ")

    self.TotalScoreLabel = Turbine.UI.Label()
    self.TotalScoreLabel:SetParent(self)
    self.TotalScoreLabel:SetSize(200, 20)
    self.TotalScoreLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TotalScoreLabel:SetMultiline(false)
    self.TotalScoreLabel:SetPosition(95, 50)
    self.TotalScoreLabel:SetText(0)

    self.SeasonLabel = Turbine.UI.Label()
    self.SeasonLabel:SetParent(self)
    self.SeasonLabel:SetSize(200, 20)
    self.SeasonLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.SeasonLabel:SetMultiline(false)
    self.SeasonLabel:SetPosition(395, 50)
    self.SeasonLabel:SetText("Season: " .. self.currentSeason)

    self.nameLabel = Turbine.UI.Label()
    self.nameLabel:SetParent(self)
    self.nameLabel:SetSize(200, 20)
    self.nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.nameLabel:SetMultiline(false)
    self.nameLabel:SetPosition(10, 80)
    self.nameLabel:SetForeColor(Turbine.UI.Color(255, 153, 0))
    self.nameLabel:SetText("Dungeon Name")

    self.tierLabel = Turbine.UI.Label()
    self.tierLabel:SetParent(self)
    self.tierLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.tierLabel:SetSize(200, 15)
    self.tierLabel:SetPosition(220, 80)
    self.tierLabel:SetForeColor(Turbine.UI.Color(255, 153, 0))
    self.tierLabel:SetText("Tier")

    self.timeLabel = Turbine.UI.Label()
    self.timeLabel:SetParent(self)
    self.timeLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.timeLabel:SetSize(200, 15)
    self.timeLabel:SetPosition(270, 80)
    self.timeLabel:SetForeColor(Turbine.UI.Color(255, 153, 0))
    self.timeLabel:SetText("TEQ Score")

    self.scoreLabel = Turbine.UI.Label()
    self.scoreLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.scoreLabel:SetParent(self)
    self.scoreLabel:SetSize(200, 15)
    self.scoreLabel:SetPosition(370, 80)
    self.scoreLabel:SetForeColor(Turbine.UI.Color(255, 153, 0))
    self.scoreLabel:SetText("Time")

    self.container = Turbine.UI.ListBox()
    self.container:SetParent(self)
    self.container:SetSize(480, 380)
    self.container:SetPosition(10, 100)
    --self.container:SetBackColor(GoldColor)
    self.container:SetVisible(true)
    self.container:SetMouseVisible(true)

    self.containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    self.containerScrollbar:SetParent( self )
    self.containerScrollbar:SetPosition( 980, 50 )
    self.containerScrollbar:SetSize( 10, 480 )
    self.containerScrollbar:SetVisible(false)

    self.container:SetVerticalScrollBar( self.containerScrollbar )

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self:FillItems()
end

function MythicPlusViewer:ClearItems()
    self.container:ClearItems()
end

function MythicPlusViewer:FillItems()
    local _, accData = StatEventHandling:GetData()
    local items = accData["TEQ"][self.player:GetName()]

    if items == nil then return end

    local maxScores = 0

    for key, value in pairs(items) do
        if self.dungeonData[key]["Season"] == self.currentSeason then
            self.container:AddItem(self:CreateScoreItem(key, value))
            maxScores = maxScores + value["Score"]
        end
    end
    self.TotalScoreLabel:SetText(Round(maxScores, 1))
end

function MythicPlusViewer:CreateScoreItem(id, item)
    local listItemBackground = Turbine.UI.Control()
    listItemBackground:SetBackColor(Turbine.UI.Color(1, 1, 1))
    listItemBackground:SetVisible(true)
    listItemBackground:SetSize( 480, 22 )
    listItemBackground:SetMouseVisible(true) 

    local listItem = Turbine.UI.Control()
    listItem:SetParent(listItemBackground)
    listItem:SetBackColor(Turbine.UI.Color(0, 0, 0))
    listItem:SetPosition(0, 1)
    listItem:SetVisible(true)
    listItem:SetSize( 480, 20 )
    listItem:SetMouseVisible(true) 

    local nameLabel = Turbine.UI.Label()
    nameLabel:SetParent(listItem)
    nameLabel:SetSize(200, 20)
    nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    nameLabel:SetMultiline(false)
    nameLabel:SetText(self.dungeonNames[id])

    local tierLabel = Turbine.UI.Label()
    tierLabel:SetParent(listItem)
    tierLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    tierLabel:SetSize(200, 15)
    tierLabel:SetPosition(210, 0)
    tierLabel:SetText(item["Tier"])

    local timeLabel = Turbine.UI.Label()
    timeLabel:SetParent(listItem)
    timeLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    timeLabel:SetSize(200, 15)
    timeLabel:SetPosition(260, 0)
    timeLabel:SetText(Round(item["Score"], 1))

    local scoreLabel = Turbine.UI.Label()
    scoreLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    scoreLabel:SetParent(listItem)
    scoreLabel:SetSize(200, 15)
    scoreLabel:SetPosition(360, 0)
    scoreLabel:SetText(FormatTimeString(item["Time"]))

    return listItemBackground
end