LeaderWindow = class(Turbine.UI.Lotro.Window)
local width = 300
local height = 650
local x = 50
local y = 50
local font = Turbine.UI.Lotro.Font.TrajanPro16
local labelFont = Turbine.UI.Lotro.Font.TrajanPro10
local colour = Turbine.UI.Color(1, 1, 1)
local chatchannel = "ra"

function LeaderWindow:Constructor()
    Turbine.UI.Lotro.Window.Constructor(self)

    local buttonUpdate = Turbine.Engine.GetGameTime()

    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(x,y)
    self:SetWantsKeyEvents(true)
    self:SetText("Raid")
    --self:SetMouseVisible(false)
    --self:SetBackColor(Turbine.UI.Color(0,0,0))
    self:SetVisible(false)

    self.KeyDown = function(sender, args)
        if args["Action"] == 145 then
            if self:IsVisible() then self:SetVisible(false) end
        end
    end

    self.checkBox = Turbine.UI.CheckBox()
    self.checkBox:SetParent(self)
    self.checkBox:SetPosition(50,0)
    self.checkBox:SetSize(100,100)
    self.checkBox:SetText(" Test")
    
    self.noteLabel = Turbine.UI.Label()
    self.noteLabel:SetVisible(true)
    self.noteLabel:SetFont(labelFont)
    self.noteLabel:SetText("Add text to the Note here")
    self.noteLabel:SetForeColor(colour)
    self.noteLabel:SetParent(self)
    self.noteLabel:SetSize(250, 30)
    self.noteLabel:SetPosition(40, 40)
    
    self.textField = Turbine.UI.Lotro.TextBox()
    self.textField:SetPosition(25, 70)
    self.textField:SetSize(250, 80)
    self.textField:SetFont(font)
    self.textField:SetBackColor(Turbine.UI.Color(1, 1, 1))
    self.textField:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.textField:SetVisible(true)
    self.textField:SetParent(self)

    self.addLabel = Turbine.UI.Label()
    self.addLabel:SetVisible(true)
    self.addLabel:SetFont(labelFont)
    self.addLabel:SetText("Add text:")
    self.addLabel:SetPosition(20, 173)
    self.addLabel:SetSize(80, 30)
    self.addLabel:SetForeColor(colour)
    self.addLabel:SetParent(self)
    
    
    self.textButton = Turbine.UI.Lotro.Quickslot()
    self.textButton:SetUseOnRightClick(false)
    self.textButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " noteAdd "))
    self.textButton:SetPosition(self:GetWidth()/3 - self.textButton:GetWidth()/2, 160)
    self.textButton:SetParent(self)

    self.textField.TextChanged = function()
        self.textButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " noteAdd " .. self.textField:GetText() .. "\n"))
    end
    
    self.clearButton = Turbine.UI.Lotro.Button()
    self.clearButton:SetPosition(self:GetWidth()/3*2 - self.clearButton:GetWidth()/2, 160)
    self.clearButton:SetText("Clear Textbox")
    self.clearButton:SetWidth(100)
    self.clearButton:SetParent(self)

    self.clearButton.Click = function()
        self.textField:SetText("")
    end
    
    -------------------------------------------------------------------------------------------------
    self.countdownDescription = Turbine.UI.Label()
    self.countdownDescription:SetVisible(true)
    self.countdownDescription:SetFont(labelFont)
    self.countdownDescription:SetText("Fill in length of countdown")
    self.countdownDescription:SetPosition(20, 230)
    self.countdownDescription:SetSize(200, 30)
    self.countdownDescription:SetForeColor(colour)
    self.countdownDescription:SetParent(self)
    
    
    self.countdownField = Turbine.UI.Lotro.TextBox()
    self.countdownField:SetPosition(75, 250)
    self.countdownField:SetSize(150, 30)
    self.countdownField:SetFont(font)
    self.countdownField:SetBackColor(Turbine.UI.Color(1, 1, 1))
    self.countdownField:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.countdownField:SetVisible(true)
    self.countdownField:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.countdownField:SetParent(self)
    
    self.countdownLabel = Turbine.UI.Label()
    self.countdownLabel:SetVisible(true)
    self.countdownLabel:SetFont(labelFont)
    self.countdownLabel:SetText("Start countdown:")
    self.countdownLabel:SetPosition(20, 313)
    self.countdownLabel:SetSize(140, 30)
    self.countdownLabel:SetForeColor(colour)
    self.countdownLabel:SetParent(self)
    
    self.countdownButton = Turbine.UI.Lotro.Quickslot()
    self.countdownButton:SetPosition(self:GetWidth()/2 - self.textButton:GetWidth()/2, 300)
    self.countdownButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " countdown"))
    self.countdownButton:SetParent(self)

    self.countdownField.TextChanged = function()
        self.countdownButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " countdown " .. self.countdownField:GetText()))
    end
    
    self.getTextButton = Turbine.UI.Lotro.Button()
    self.getTextButton:SetWidth(100)
    self.getTextButton:SetText("Get Text")
    self.getTextButton:SetPosition(self:GetWidth()/2 - self.getTextButton:GetWidth()/2, 480)
    self.getTextButton:SetParent(self)
    
    
    self.clearResetButton = Turbine.UI.Lotro.Quickslot()
    self.clearResetButton:SetPosition(self:GetWidth()/3 - self.textButton:GetWidth()/2, 450)
    self.clearResetButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " noteClear"))
    self.clearResetButton:SetParent(self)
    
    self.resetButton = Turbine.UI.Lotro.Quickslot()
    self.resetButton:SetPosition(self:GetWidth()/3*2 - self.textButton:GetWidth()/2, 450)
    self.resetButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " "))
    self.resetButton:SetParent(self)
    
    self.getTextButton.Click = function()
        self.resetButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " noteAdd " .. noteWindow.noteWindow:GetText()))
        self.textField:SetText(noteWindow.noteWindow:GetText())
    end
    
    self.setFellowshipButton = Turbine.UI.Lotro.Button()
    self.setFellowshipButton:SetPosition(self:GetWidth()/2 - self.setFellowshipButton:GetWidth()/2, 370)
    self.setFellowshipButton:SetText("Fellowship")
    self.setFellowshipButton:SetWidth(100)
    self.setFellowshipButton:SetParent(self)
    
    self.chatchannelLabel = Turbine.UI.Label()
    self.chatchannelLabel:SetVisible(true)
    self.chatchannelLabel:SetFont(labelFont)
    self.chatchannelLabel:SetText("Set chatchannel:")
    self.chatchannelLabel:SetSize(140, 30)
    self.chatchannelLabel:SetPosition(self:GetWidth()/2 - self.chatchannelLabel:GetWidth()/2, 350)
    self.chatchannelLabel:SetForeColor(colour)
    self.chatchannelLabel:SetParent(self)
    
    self.setFellowshipButton.Click = function()
        chatchannel = "f"
        self.countdownButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " countdown " .. self.countdownField:GetText()))
        self.resetButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " noteAdd " .. noteWindow.noteWindow:GetText()))
        self.clearResetButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " noteClear"))
        self.textButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " noteAdd " .. self.textField:GetText() .. "\n"))
        self:SetText("Fellowship")
    end
    
    self.setRaidButton = Turbine.UI.Lotro.Button()
    self.setRaidButton:SetPosition(self:GetWidth()/2 - self.setRaidButton:GetWidth()/2, 390)
    self.setRaidButton:SetText("Raid")
    self.setRaidButton:SetWidth(100)
    self.setRaidButton:SetParent(self)
    
    self.setRaidButton.Click = function()
        chatchannel = "ra"
        self.countdownButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " countdown " .. self.countdownField:GetText()))
        self.resetButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " noteAdd " .. noteWindow.noteWindow:GetText()))
        self.clearResetButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " noteClear"))
        self.textButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. chatchannel .. " noteAdd " .. self.textField:GetText() .. "\n"))
        self:SetText("Raid")
    end
    

    self.sentClearLabel = Turbine.UI.Label()
    self.sentClearLabel:SetVisible(true)
    self.sentClearLabel:SetFont(labelFont)
    self.sentClearLabel:SetText("Send Clear:")
    self.sentClearLabel:SetSize(140, 30)
    self.sentClearLabel:SetPosition(self:GetWidth()/3 - self.sentClearLabel:GetWidth()/2, 430)
    self.sentClearLabel:SetForeColor(colour)
    self.sentClearLabel:SetParent(self)

    self.resendLabel = Turbine.UI.Label()
    self.resendLabel:SetVisible(true)
    self.resendLabel:SetFont(labelFont)
    self.resendLabel:SetText("Resend:")
    self.resendLabel:SetSize(140, 30)
    self.resendLabel:SetPosition(self:GetWidth()/3 + self.resendLabel:GetWidth()/2, 430)
    self.resendLabel:SetForeColor(colour)
    self.resendLabel:SetParent(self)    
end

AdminPanelButton=class(Turbine.UI.Window)
function AdminPanelButton:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(100, 100)
    self:SetPosition(260, Turbine.UI.Display.GetHeight() - 20)
    self:SetVisible(true)
    
    self.toggleButton = Turbine.UI.Lotro.Button()
    self.toggleButton:SetParent(self)
    self.toggleButton:SetText("Leader Panel")
    self.toggleButton:SetVisible(true)
    self.toggleButton:SetWidth(100)
    
    self.toggleButton.Click = function()
        leaderWindow:SetVisible(not leaderWindow:IsVisible())
    end   
end


