LogWindow = class(Turbine.UI.Window)
local width = Settings.LWidth
local height = Settings.LHeight
local x = Settings.LX
local y = Settings.LY

function LogWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(width, height)
    self:SetPosition(0, 0)
    --self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self:SetFont(Turbine.UI.Lotro.Font.TrajanPro28)
    --self:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self:SetMouseVisible(false)
    self:SetVisible(false)
    self:SetWantsKeyEvents(true)

    self.messageBox = Turbine.UI.ListBox()
    self.messageBox:SetParent(self)
    self.messageBox:SetSize(width - 12, height)
    self.messageBox:SetPosition(x,y)
    self.messageBox:SetVisible(true)

    --self.messageBox:SetOutlineColor(Turbine.UI.Color(0,0,0))
    --self.messageBox:SetForeColor(Turbine.UI.Color(1, 1, 1))
    --self.messageBox:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.scrollbar = Turbine.UI.Lotro.ScrollBar()
    self.scrollbar:SetParent(self)
    self.scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.scrollbar:SetSize(12,height)
    --self.scrollbar:SetPosition(self.messageBox:GetLeft() + self.messageBox:GetWidth(),self.messageBox:GetTop())
    self.scrollbar:SetPosition(width - 12, 0)
    self.messageBox:SetVerticalScrollBar(self.scrollbar)

    self.MoveBox = Turbine.UI.Control()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(width, height)
    self.MoveBox:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0))
    self.MoveBox:SetVisible(false)

    self.messageBox1 = Turbine.UI.Label()
    self.messageBox1:SetParent(self.MoveBox)
    self.messageBox1:SetSize(width, height)
    self.messageBox1:SetPosition(0,0)
    self.messageBox1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox1:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.messageBox1:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox1:SetMouseVisible(false)
    self.messageBox1:SetText("Log window")

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          if newLeft < 0 then newLeft = 0 end
          if newTop < 0 then newTop = 0 end
          if newLeft > (Turbine.UI.Display.GetWidth() - self:GetWidth()) then
            newLeft = Turbine.UI.Display.GetWidth() - self:GetWidth() end
          if newTop > (Turbine.UI.Display.GetHeight() - self:GetHeight()) then
            newTop = Turbine.UI.Display.GetHeight() - self:GetHeight() end
          self:SetPosition(newLeft,newTop)
        end
    end
    
    self.ToggleMove = function()
        self.MoveBox:SetVisible(not self.MoveBox:IsVisible())
    end
end

function LogWindow:Message(message, debuff)
    local item = Turbine.UI.Control()
    item:SetSize(width-12, 15)
    item:SetBackColor(Turbine.UI.Color(0,0,0))

    item.label = Turbine.UI.Label()
    item.label:SetSize(width - 12, 15)
    --self.label:SetPosition(0,0)
    item.label:SetTextAlignment(Turbine.UI.ContentAlignment.TopMiddle)
    item.label:SetFont(Turbine.UI.Lotro.Font.TrajanPro18)
    item.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    item.label:SetMouseVisible(false)
    item.label:SetVisible(true)
    item.label:SetOutlineColor(Turbine.UI.Color(0,0,0))
    if debuff then
        item.label:SetForeColor(Turbine.UI.Color(1, 0, 0))
    else
        item.label:SetForeColor(Turbine.UI.Color(0, 1, 0))
    end
    item.label:SetBackColor(Turbine.UI.Color(0, 0, 0))
    item.label:SetText(message)
    item.label:SetParent(item)

    
    self.messageBox:AddItem(item)
end

LogToggleButton=class(Turbine.UI.Window) 

function LogToggleButton:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(100, 100)
    self:SetPosition(160, Turbine.UI.Display.GetHeight() - 20)
    self:SetVisible(true)
    
    self.toggleButton = Turbine.UI.Lotro.Button()
    self.toggleButton:SetParent(self)
    self.toggleButton:SetText("LogWindow")
    self.toggleButton:SetVisible(true)
    self.toggleButton:SetWidth(100)
    
    self.toggleButton.Click = function()
        logWindow:SetVisible(not logWindow:IsVisible())
    end
end