MoveBox = class(Turbine.UI.Window)
function MoveBox:Constructor(parent, width, height, name)
  Turbine.UI.Control.Constructor(self)
  self.MoveBox = Turbine.UI.Window()
  self.MoveBox:SetParent(parent)
  self.MoveBox:SetSize(width, height)
  --self.MoveBox:SetBackColor(GetRandomColour())
  self.MoveBox:SetBackColor(Turbine.UI.Color(0,0,0))
  self.MoveBox:SetVisible(false)
  self.MoveBox:SetMouseVisible(true)
  --self.MoveBox:SetOpacity(0.5)

  self.OpacityBox = Turbine.UI.Control()
  self.OpacityBox:SetParent(self.MoveBox)
  self.OpacityBox:SetSize(width - 4, height - 4)
  self.OpacityBox:SetPosition(2, 2)
  --self.OpacityBox:SetBackColor(GetRandomColour())
  self.OpacityBox:SetBackColor(Turbine.UI.Color(0.2, 0,0,0))
  self.OpacityBox:SetVisible(true)
  self.OpacityBox:SetMouseVisible(false)
  self.OpacityBox:SetOpacity(0.5)

  self.anchorBox = Turbine.UI.Control()
  self.anchorBox:SetParent(self.MoveBox)
  self.anchorBox:SetSize(math.min(width, 200), math.min(height,30))
  self.anchorBox:SetPosition(width / 2 - math.min(width, 200) / 2, height / 2 - math.min(height, 30) / 2)
  self.anchorBox:SetBackColor(Turbine.UI.Color(1,1,1))
  self.anchorBox:SetMouseVisible(false)

  self.messageBox1 = Turbine.UI.Label()
  self.messageBox1:SetParent(self.anchorBox)
  self.messageBox1:SetSize(math.min(width, 200) - 2, math.min(height,30) - 2)
  self.messageBox1:SetPosition(1, 1)
  self.messageBox1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.messageBox1:SetBackColor(Turbine.UI.Color(0,0,0))
  self.messageBox1:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
  self.messageBox1:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.messageBox1:SetMouseVisible(false)
  self.messageBox1:SetText(name)

  self.ParentVisibleMemory = parent:IsVisible()

  self.Moving = false

  self.MoveBox.MouseDown = function(sender,args)
      self.MoveX = args.X
      self.MoveY = args.Y
      self.Moving = true
  end

  self.MoveBox.MouseUp = function()
      self.Moving = false
  end

  self.MoveBox.MouseMove = function(sender,args)
      if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        parent:SetPosition(newLeft,newTop)
      end
  end
  
  self.ToggleMove = function()
    if not(self.MoveBox:IsVisible()) then
      self.ParentVisibleMemory = parent:IsVisible()
    end
    self.MoveBox:SetVisible(not self.MoveBox:IsVisible())
    if not(self.MoveBox:IsVisible()) then
      parent:SetVisible(self.ParentVisibleMemory)
    end
  end

  self.MoveBox.MouseEnter = function()
    self.OpacityBox:SetBackColor(Turbine.UI.Color(0.2, 0.375,0.375,0.375))
    self.messageBox1:SetBackColor(Turbine.UI.Color(0.25,0.25,0.25))
  end

  self.MoveBox.MouseLeave = function()
    self.OpacityBox:SetBackColor(Turbine.UI.Color(0.2, 0,0,0))
    self.messageBox1:SetBackColor(Turbine.UI.Color(0,0,0))
  end
end

function MoveBox:Unload()
  self:SetVisible(false)
  self.MoveBox:SetVisible(false)
  self.MoveBox:SetParent(nil)
  self:SetParent(nil)
end