NameHandler = class()
function NameHandler:Constructor()
    self.nameDictionary = LoadTable(Turbine.DataScope.Account, "PrimeNameData") or {}
    --[[
        name
            rename

            p2
            markupcode
            markupenabled
            list of senderobjects
            list of sendertypes
    --]]
end

---checks if there is a renaming scheme available for the situation and name
---@param name string
---@param markupEnabled boolean
---@param senderObject string
---@param senderType string
function NameHandler:GetName(name, markupEnabled, senderObject, senderType)
    if self.nameDictionary[name] then
        return self.nameDictionary[name].Rename
    else
        return name
    end
end

---retrieves the table of names
---@return table
function NameHandler:GetNameList()
    return self.nameDictionary
end

---Changes an entry in the table or adds a new one
---@param name string
---@param change table
function NameHandler:NameChange(name, change)
    self.nameDictionary[name] = change
end

---Get a rename table if it exists
---@param name string
---@return table
function NameHandler:GetNameTable(name)
    return self.nameDictionary[name]
end

---Save the name table
function NameHandler:Unload()
    SaveTable(Turbine.DataScope.Account, "PrimeNameData", self.nameDictionary)
end