NameOptions = class(Turbine.UI.Control)
function NameOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 550
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width,height)
    self:SetPosition(0, 0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local optionsHeight = 0
    local listboxHeight = height - 50

    self.targetNameBox = Turbine.UI.Lotro.TextBox()
    self.targetNameBox:SetParent(self)
    self.targetNameBox:SetSize(300, 20)
    self.targetNameBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.targetNameBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.targetNameBox:SetMouseVisible(false)
    self.targetNameBox:SetPosition(310, optionsHeight)
    self.targetNameBox:SetMultiline(false)
    self.targetNameBox:SetText("Name")

    optionsHeight = optionsHeight + 30

    self.renameBox = Turbine.UI.Lotro.TextBox()
    self.renameBox:SetParent(self)
    self.renameBox:SetSize(300, 20)
    self.renameBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.renameBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.renameBox:SetMouseVisible(false)
    self.renameBox:SetPosition(310, optionsHeight)
    self.renameBox:SetMultiline(false)
    self.renameBox:SetText("Name Change")
    
    self.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    self.addTriggerEntryButton:SetParent(self)
    self.addTriggerEntryButton:SetSize(100, 20)
    self.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.addTriggerEntryButton:SetPosition(610, optionsHeight)
    self.addTriggerEntryButton:SetText("Add")

    self.addTriggerEntryButton.Click = function()
        local name = self.targetNameBox:GetText()
        if not(NameHandlerObject:GetNameTable(name)) then
            self.AddListboxItem(name)
            if string.len(name) > 0 then
                NameHandlerObject:NameChange(name, {
                    ["Rename"] = self.renameBox:GetText(),
                })
            end 
        end
    end


    self.listbox = Turbine.UI.ListBox()
    self.listbox:SetParent(self)
    self.listbox:SetSize(300, listboxHeight)
    self.listbox:SetPosition(0, 0)
    self.listbox:SetBackColor(Turbine.UI.Color.DarkSlateGray)

    self.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    self.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.Scrollbar:SetParent(self)
    self.Scrollbar:SetPosition(300, 0)
    self.Scrollbar:SetSize(10, listboxHeight)
    self.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    self.listbox:SetVerticalScrollBar(self.Scrollbar)

    self.selectedIndex = -1
    self.listbox.SelectedIndexChanged = function()
        local item = self.listbox:GetSelectedItem()
        if item and item.innerBox then
            if self.selectedIndex > 0 then
                self.listbox:GetItem(self.selectedIndex).innerBox:SetBackColor(Turbine.UI.Color.DarkSlateGray)
            end
            self.selectedIndex = self.listbox:GetSelectedIndex()
            item.innerBox:SetBackColor(Turbine.UI.Color.SlateGray)
        end
    end


    optionsHeight = optionsHeight + 50

    self.targetNameLabel = Turbine.UI.Label()
    self.targetNameLabel:SetParent(self)
    self.targetNameLabel:SetSize(300, 20)
    self.targetNameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.targetNameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.targetNameLabel:SetMouseVisible(false)
    self.targetNameLabel:SetPosition(310, optionsHeight)
    self.targetNameLabel:SetMultiline(false)
    self.targetNameLabel:SetText("Target Name:")

    self.targetNameChangeLabel = Turbine.UI.Label()
    self.targetNameChangeLabel:SetParent(self)
    self.targetNameChangeLabel:SetSize(300, 20)
    self.targetNameChangeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.targetNameChangeLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.targetNameChangeLabel:SetMouseVisible(false)
    self.targetNameChangeLabel:SetPosition(410, optionsHeight)
    self.targetNameChangeLabel:SetMultiline(false)
    self.targetNameChangeLabel:SetText("")

    optionsHeight = optionsHeight + 30

    self.renameBoxRename = Turbine.UI.Lotro.TextBox()
    self.renameBoxRename:SetParent(self)
    self.renameBoxRename:SetSize(300, 20)
    self.renameBoxRename:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.renameBoxRename:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.renameBoxRename:SetMouseVisible(false)
    self.renameBoxRename:SetPosition(310, optionsHeight)
    self.renameBoxRename:SetMultiline(false)
    self.renameBoxRename:SetText("Name Change")


    self.changeFunction = function()
        local name = self.targetNameChangeLabel:GetText()
        if string.len(name) > 0 then
            NameHandlerObject:NameChange(name, {
                ["Rename"] = self.renameBoxRename:GetText(),
            })
        end
    end

    self.renameBoxRename.TextChanged = function()
        self.changeFunction()
    end


    self.OpenOptions = function(name)
        local nameValueTable = NameHandlerObject:GetNameTable(name)
        if nameValueTable then
            self.targetNameChangeLabel:SetText(tostring(name))
            self.renameBoxRename:SetText(nameValueTable.Rename)
        else
            self.targetNameChangeLabel:SetText("")
            self.renameBoxRename:SetText("Name Change")
        end
    end

    self.AddListboxItem = function(effectName)
        local listBoxItem = Turbine.UI.Control()
        listBoxItem:SetSize(300, 20)
        listBoxItem:SetBackColor(Turbine.UI.Color.Black)

        listBoxItem.innerBox = Turbine.UI.Control()
        listBoxItem.innerBox:SetParent(listBoxItem)
        listBoxItem.innerBox:SetSize(300 - 2, 20 - 2)
        listBoxItem.innerBox:SetPosition(1, 1)
        listBoxItem.innerBox:SetBackColor(Turbine.UI.Color.DarkSlateGray)
        listBoxItem.innerBox.MouseClick = function()
            self.OpenOptions(effectName)
        end


        listBoxItem.effectLabel = Turbine.UI.Label()
        listBoxItem.effectLabel:SetParent(listBoxItem.innerBox)
        listBoxItem.effectLabel:SetSize(300 - 2 - 50, 20 - 2)
        listBoxItem.effectLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
        listBoxItem.effectLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        listBoxItem.effectLabel:SetOutlineColor(Turbine.UI.Color.Black)
        listBoxItem.effectLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        listBoxItem.effectLabel:SetText(effectName)
        listBoxItem.effectLabel:SetMouseVisible(false)

        listBoxItem.removeButton = Turbine.UI.Control()
        listBoxItem.removeButton:SetParent(listBoxItem.innerBox)
        listBoxItem.removeButton:SetSize(14, 14)
        listBoxItem.removeButton:SetPosition(300 - 1 - 14, 3)
        listBoxItem.removeButton:SetBackground(BackgroundHandler:GetBackground(0x41005F0A))
        listBoxItem.removeButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

        listBoxItem.removeButton.MouseClick = function()
            NameHandlerObject:NameChange(effectName, nil)
            self.listbox:RemoveItem(listBoxItem)
        end
        self.listbox:AddItem(listBoxItem)
    end

    for key, value in pairs(NameHandlerObject:GetNameList()) do
        self.AddListboxItem(key)        
    end
end