
-- Welcome window
FirstTimerWindowsWelcome = class(Turbine.UI.Control)
function FirstTimerWindowsWelcome:Constructor(parent)
    local width = 800
    local height = 600
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    --self:SetPosition(x,y)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetParent(parent)

    self.logo = Turbine.UI.Control()
    self.logo:SetParent(self)
    self.logo:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/PrimeBig.tga"))
    self.logo:SetStretchMode(2)
    self.logo:SetSize(self.logo:GetSize())
    self.logo:SetPosition(self:GetWidth() / 2 - self.logo:GetWidth() / 2, 30)

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(400, 200)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetPosition(100, 210)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    NameLabel:SetText("New Version Setup")


    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(self)
    NameLabel:SetSize(600, 500)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetMarkupEnabled(true)
    NameLabel:SetSelectable(true)
    NameLabel:SetPosition(100, 210)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)

    local introText =     [[
        
This is the new version setup for the Prime Plugin to update you on the changes and help you customize it to your needs. Subsequent pages will allow you to toggle some of the basic features of the plugin.
        
If you have any questions or feedback visit the discord: https://discord.gg/aW6SmZKB79. The discord is also the place to find many PrimeUI strings to customise your UI as well as tutorials for many aspects of PrimeUI.

If you want to see the plugin in action in many raid encounters you can visit our youtube page at: https://www.youtube.com/channel/UCPbYAZhrKgzxxfff9NCXkbg, which features many videos where the only plugin used is the primeplugin. Most of the PrimeUIs shown here can be found on the discord.
    ]]
    NameLabel:SetText(introText)


    local PatchButton = Turbine.UI.Lotro.Button()
    PatchButton:SetParent(self)
    PatchButton:SetVisible(true)
    PatchButton:SetSize(150, 15)
    PatchButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    PatchButton:SetMouseVisible(true)
    PatchButton:SetPosition(325, 530)
    PatchButton:SetText("Check Patch Notes")

    
    PatchButton.Click = function()
        WindowsHandlerController:CreatePatchWindow()
    end

    local FinishButton2 = Turbine.UI.Lotro.Button()
    FinishButton2:SetParent(self)
    FinishButton2:SetVisible(true)
    FinishButton2:SetSize(100, 15)
    FinishButton2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    FinishButton2:SetMouseVisible(true)
    FinishButton2:SetPosition(350, 570)
    FinishButton2:SetText("Skip Setup")

    FinishButton2.Click = function()
        Settings.FirstTime = false
        ReloadPlugin(true)
    end

    self.menu = Turbine.UI.ContextMenu()
    self.menuItems = self.menu:GetItems()



    for key, value in pairs(Profiles:GetPreferences()) do
        local menuItem = Turbine.UI.MenuItem(key)
        menuItem.Click = function()
            Profiles:ChangePreference(key)
            self.button:SetText("Current profile: " .. key)
            ReloadPlugin()
        end
        self.menuItems:Add(menuItem)
    end

    self.button = Turbine.UI.Lotro.Button()
    self.button:SetParent(self)
    self.button:SetPosition(550, 40)
    self.button:SetSize(200,15)
    self.button:SetText("Current profile: " .. Profiles:GetPreferences()[Turbine.Gameplay.LocalPlayer.GetInstance():GetName()])
    self.button:SetVisible(true)

    self.button.Click = function()
        self.menu:ShowMenu()
    end

    --[[
    local EffectBox1 = Turbine.UI.Lotro.CheckBox()
    EffectBox1:SetParent(self)
    EffectBox1:SetPosition(300, 40)
    EffectBox1:SetSize(200,20)
    EffectBox1:SetChecked(LoadSettings[Turbine.Gameplay.LocalPlayer.GetInstance():GetName()] == 1)
    EffectBox1:SetText("Character settings")
    EffectBox1:SetVisible(true)

    local EffectBox2 = Turbine.UI.Lotro.CheckBox()
    EffectBox2:SetParent(self)
    EffectBox2:SetPosition(300, 60)
    EffectBox2:SetSize(200,20)
    EffectBox2:SetChecked(LoadSettings[Turbine.Gameplay.LocalPlayer.GetInstance():GetName()] == 2)
    EffectBox2:SetText("Account settings")
    EffectBox2:SetVisible(true)

    EffectBox1.CheckedChanged = function()
        if EffectBox1:IsChecked() then
            LoadSettings[Turbine.Gameplay.LocalPlayer.GetInstance():GetName()] = 1
            LoadSettings.SaveSettings = false
            EffectBox2:SetChecked(false)
            ReloadPlugin()
        end
    end

    EffectBox2.CheckedChanged = function()
        if EffectBox2:IsChecked() then
            LoadSettings[Turbine.Gameplay.LocalPlayer.GetInstance():GetName()] = 2
            LoadSettings.SaveSettings = false
            EffectBox1:SetChecked(false)
            ReloadPlugin()
        end
    end
    --]]
end