NoteWindow=class(Turbine.UI.Lotro.Window)
 
local width = Settings.NoteWidth
local height = Settings.NoteHeight
local font = Turbine.UI.Lotro.Font.TrajanPro16

function NoteWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(width,height)
    --self:SetPosition(x,y)
    self:SetWantsKeyEvents(false)
    self:SetVisible(true)
    --self:SetOpacity(0.5)
    self:SetPosition(Settings.NoteX, Settings.NoteY)
    self:SetMouseVisible(false)

    self.noteWindow = Turbine.UI.Label()
    self.noteWindow:SetParent(self)
    self.noteWindow:SetSize(width,height)
    self.noteWindow:SetPosition(0,0)
    self.noteWindow:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    self.noteWindow:SetFont(font)
    self.noteWindow:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.noteWindow:SetMouseVisible(false)
    self.noteWindow:SetVisible(true)
    --self.noteWindow:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.MoveBox = Turbine.UI.Control()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(width, height)
    self.MoveBox:SetBackColor(Turbine.UI.Color(0, 0, 1))
    self.MoveBox:SetVisible(false)

    self.messageBox1 = Turbine.UI.Label()
    self.messageBox1:SetParent(self.MoveBox)
    self.messageBox1:SetSize(width, height)
    self.messageBox1:SetPosition(0,0)
    self.messageBox1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox1:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.messageBox1:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox1:SetMouseVisible(false)
    self.messageBox1:SetText("Notes")

    self.MouseEnter = function()
        --self:SetOpacity(1)
    end

    self.MouseLeave = function()
        --self:SetOpacity(0.5)    
    end

    self.ReturnText = function()
        return(noteWindow:GetText())
    end

    local moveBox = MoveBox(self, width, height, "Note Window")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end
end

NoteToggleButton=class(Turbine.UI.Window) 

function NoteToggleButton:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(100, 100)
    self:SetPosition(0, Turbine.UI.Display.GetHeight() - 20)
    self:SetVisible(true)
    
    self.toggleButton = Turbine.UI.Lotro.Button()
    self.toggleButton:SetParent(self)
    self.toggleButton:SetText("NoteWindow")
    self.toggleButton:SetVisible(true)
    self.toggleButton:SetWidth(100)
    
    self.toggleButton.Click = function()
        noteWindow:SetVisible(not noteWindow:IsVisible())
    end
end

