KillTracking = class(Turbine.UI.Window)
function KillTracking:Constructor()
    Turbine.UI.Window.Constructor(self)
    self.width = 150
    self.height = 500
    self.x = Settings.KLX
    self.y = Settings.KLY

    self.totalCount = 0
    self.currentCount = 0

    self:SetSize(self.width, self.height)
    self:SetPosition(self.x, self.y)
    self:SetVisible(false)
    self:SetWantsUpdates(true)
    self:SetMouseVisible(false)
    self:SetOpacity(1)

    self.BackgroundWindow = Turbine.UI.Control()
    self.BackgroundWindow:SetParent(self)
    self.BackgroundWindow:SetSize(self.width , 20)
    self.BackgroundWindow:SetBackColor(Turbine.UI.Color.Black)
    self.BackgroundWindow:SetOpacity(1)
    self.BackgroundWindow:SetVisible(true)
    self.BackgroundWindow:SetMouseVisible(false)

    self.OpacityBackground = Turbine.UI.Control()
    self.OpacityBackground:SetParent(self.BackgroundWindow)
    self.OpacityBackground:SetSize(self.width - 2, 20 - 2)
    self.OpacityBackground:SetPosition(1, 1)
    self.OpacityBackground:SetBackColor(Turbine.UI.Color.Silver)
    self.OpacityBackground:SetVisible(true)
    self.OpacityBackground:SetMouseVisible(false)

    self.TopWindow = Turbine.UI.Window()
    self.TopWindow:SetParent(self)
    self.TopWindow:SetSize(self.width, 20)
    self.TopWindow:SetVisible(true)
    self.TopWindow:SetMouseVisible(false)
    
    self.ProgressLabel = Turbine.UI.Label()
    self.ProgressLabel:SetParent(self.TopWindow)
    self.ProgressLabel:SetSize(self.width, 20)
    self.ProgressLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.ProgressLabel:SetMouseVisible(false)
    self.ProgressLabel:SetMultiline(false)
    self.ProgressLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.ProgressLabel:SetPosition(1,1)
    self.ProgressLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.ProgressLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.ProgressLabel:SetText(string.format("%d/%d", self.currentCount, self.totalCount))

    self.ItemContainer = Turbine.UI.ListBox()
    self.ItemContainer:SetParent(self)
    self.ItemContainer:SetVisible(true)
    self.ItemContainer:SetSize(self.width, 1000)
    self.ItemContainer:SetPosition(0, 20)
    self.ItemContainer:SetMouseVisible(false)

    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(self.width, 40)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        Settings.KLX, Settings.KLY = self:GetPosition()
        end
    end
end

function KillTracking:AddItem(name, count, nickname, icon)
    count = tonumber(count)

    if string.len(nickname) == 0 then
        nickname = name
    end
    local killItem = Turbine.UI.Control()
    killItem:SetSize(self.width, 20)
    killItem:SetMouseVisible(false)
    killItem:SetBackColor(Turbine.UI.Color(0,0,0))

    killItem.name = name
    killItem.count = count
    killItem.totalCount = count

    local offset = 0

    if icon and icon ~= "" then
        if tonumber(icon) then
            icon = tonumber(icon)
        end
        killItem.iconLabel = Turbine.UI.Control()
        killItem.iconLabel:SetParent(killItem)
        killItem.iconLabel:SetMouseVisible(false)
        killItem.iconLabel:SetPosition(1,1)
        killItem.iconLabel:SetSize(32, 32)
        killItem.iconLabel:SetBackground(icon)
        killItem.iconLabel:SetStretchMode(1)
        killItem.iconLabel:SetSize(20 - 2, 20 - 2)
        offset = 20
    end

    killItem.backgroundBar = Turbine.UI.Control()
    killItem.backgroundBar:SetParent(killItem)
    killItem.backgroundBar:SetSize(self.width - 2 - offset, 20 - 2)
    killItem.backgroundBar:SetMouseVisible(false)
    killItem.backgroundBar:SetBackColor(Turbine.UI.Color(0.38,0.09,0.09))
    killItem.backgroundBar:SetPosition(1 + offset,1)

    killItem.innerLabel = Turbine.UI.Label()
    killItem.innerLabel:SetParent(killItem)
    killItem.innerLabel:SetSize(self.width - 20 - offset, 20 - 2)
    killItem.innerLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    killItem.innerLabel:SetMouseVisible(false)
    killItem.innerLabel:SetMultiline(false)
    killItem.innerLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    --killItem.innerLabel:SetBackColor(Turbine.UI.Color(0.3, 0, 0, 0))
    killItem.innerLabel:SetPosition(1 + offset,1)
    killItem.innerLabel:SetOutlineColor(Turbine.UI.Color.Black)
    killItem.innerLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    killItem.innerLabel:SetText(nickname or name)

    killItem.countLabel = Turbine.UI.Label()
    killItem.countLabel:SetParent(killItem)
    killItem.countLabel:SetSize(20, 20 - 2)
    killItem.countLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    killItem.countLabel:SetMouseVisible(false)
    killItem.countLabel:SetMultiline(false)
    killItem.countLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    killItem.countLabel:SetPosition(self.width - 20 - 2, 1)
    killItem.countLabel:SetOutlineColor(Turbine.UI.Color.Black)
    killItem.countLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    if count and count > 1 then
        killItem.countLabel:SetText(count)
    end

    self:UpdateCount(count)

    self.ItemContainer:AddItem(killItem)
end

function KillTracking:ApplyKill(name)
    if self.ItemContainer:GetItemCount() == 0 then
        return
    end
    local removeItemList = {}
    for i = 1, self.ItemContainer:GetItemCount() do
        local item = self.ItemContainer:GetItem(i)
        if item.name == name then
            item.count = item.count - 1
            if item.count <= 0 then
                self.currentCount = self.currentCount - 1
                removeItemList[item] = true
            else
                item.countLabel:SetText(item.count)
                self.currentCount = self.currentCount - 1
                item.backgroundBar:SetSize((self.width - 2) * (item.count / item.totalCount), 20 - 2)
            end
            self:RedrawProgress()
            break
        end
    end

    for key, value in pairs(removeItemList) do
        self.ItemContainer:RemoveItem(key)
    end

    if self.ItemContainer:GetItemCount() == 0 then
        self:SetVisible(false)
        --ChatOutput("Kill Order Done")
    end
end

function KillTracking:UpdateCount(count)
    self.totalCount = self.totalCount + count
    self.currentCount = self.currentCount + count
    self:RedrawProgress()
end

function KillTracking:RedrawProgress()
    self.ProgressLabel:SetText(string.format("%d/%d", self.currentCount, self.totalCount))
    self.OpacityBackground:SetSize((self.width - 2) * (self.currentCount / self.totalCount), 20 - 2)
end

function KillTracking:ToggleHeader(visibility)
    self:SetVisible(visibility)
    self.ProgressLabel:SetVisible(visibility)
    self.BackgroundWindow:SetVisible(visibility)
end

function KillTracking:Clear()
    self:SetVisible(false)
    self.totalCount = 0
    self.currentCount = 0
    self.ItemContainer:ClearItems()
end

function KillTracking:Unload()
    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    self:SetParent(nil)
end