NoteWindowsSettings = class(Turbine.UI.Control)
function NoteWindowsSettings:Constructor(parent)
    local width = 750
    local height = 500
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    self.data = NoteHandler:GetNoteData()
    self.newWindow = NewNoteWindow(self)

    self.currentNote = ""

    self.BorderBackground = Turbine.UI.Control()
    self.BorderBackground:SetParent(self)
    self.BorderBackground:SetPosition(10 - 2, 10 - 2)
    self.BorderBackground:SetSize(730 + 4, 450 + 4)
    self.BorderBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.Background = Turbine.UI.Control()
    self.Background:SetParent(self)
    self.Background:SetPosition(10, 10)
    self.Background:SetSize(730, 450)
    self.Background:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    self.PersonalControl = Turbine.UI.Control()
    self.PersonalControl:SetParent(self.Background)
    self.PersonalControl:SetPosition(10, 40)
    self.PersonalControl:SetSize(710, 400)
    self.PersonalControl:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.GroupControl = Turbine.UI.Control()
    self.GroupControl:SetParent(self.Background)
    self.GroupControl:SetPosition(10, 40)
    self.GroupControl:SetSize(710, 400)
    self.GroupControl:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.NotesControl = Turbine.UI.Control()
    self.NotesControl:SetParent(self.Background)
    self.NotesControl:SetPosition(10, 40)
    self.NotesControl:SetSize(710, 400)
    self.NotesControl:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.PersonalButton = Turbine.UI.Label()
    self.PersonalButton:SetParent(self.Background)
    self.PersonalButton:SetPosition(470, 10)
    self.PersonalButton:SetSize(200, 20)
    self.PersonalButton:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    self.PersonalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.PersonalButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.PersonalButton:SetText("Personal")
    self.PersonalButton:SetVisible(false)    

    self.PersonalButton.MouseEnter = function()
        self.PersonalButton:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    end

    self.PersonalButton.MouseLeave = function()
        self.PersonalButton:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    end

    self.PersonalButton.MouseClick = function()
        self.PersonalButton:SetBackColor(Turbine.UI.Color(0, 0, 0))
        self.PersonalControl:SetVisible(true)
        self.GroupControl:SetVisible(false)
        self.NotesControl:SetVisible(false)
    end

    self.GroupButton = Turbine.UI.Label()
    self.GroupButton:SetParent(self.Background)
    self.GroupButton:SetPosition(240, 10)
    self.GroupButton:SetSize(200, 20)
    self.GroupButton:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    self.GroupButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.GroupButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.GroupButton:SetText("Settings")
    

    self.GroupButton.MouseEnter = function()
        self.GroupButton:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    end

    self.GroupButton.MouseLeave = function()
        self.GroupButton:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    end

    self.GroupButton.MouseDown = function()
        self.GroupButton:SetBackColor(Turbine.UI.Color(0, 0, 0))
        self.PersonalControl:SetVisible(false)
        self.NotesControl:SetVisible(false)
        self.GroupControl:SetVisible(true)
    end

    self.NotesButton = Turbine.UI.Label()
    self.NotesButton:SetParent(self.Background)
    self.NotesButton:SetPosition(10, 10)
    self.NotesButton:SetSize(200, 20)
    self.NotesButton:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    self.NotesButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.NotesButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.NotesButton:SetText("Notes")
    

    self.NotesButton.MouseEnter = function()
        self.NotesButton:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    end

    self.NotesButton.MouseLeave = function()
        self.NotesButton:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    end

    self.NotesButton.MouseClick = function()
        self.NotesButton:SetBackColor(Turbine.UI.Color(0, 0, 0))
        self.PersonalControl:SetVisible(false)
        self.GroupControl:SetVisible(false)
        self.NotesControl:SetVisible(true)
    end

    self:NoteContainterSettingsUI()
    self:NoteButtonUI()
    self:NoteCreationUI()
    self:GroupNoteSettingsUI()
end

function NoteWindowsSettings:NoteContainterSettingsUI()
    self.NoteListBackground = Turbine.UI.Control()
    self.NoteListBackground:SetParent(self.NotesControl)
    self.NoteListBackground:SetPosition(10, 10)
    self.NoteListBackground:SetSize(200, 380)
    self.NoteListBackground:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))

    self.NoteListHeader = Turbine.UI.Label()
    self.NoteListHeader:SetParent(self.NoteListBackground)
    self.NoteListHeader:SetPosition(4, 4)
    self.NoteListHeader:SetSize(200 - 8, 20)
    self.NoteListHeader:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    self.NoteListHeader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.NoteListHeader:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    self.NoteListHeader:SetOutlineColor(Turbine.UI.Color.Black)
    self.NoteListHeader:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.NoteListHeader:SetText("Notes")

    self.NoteListContainerBackground = Turbine.UI.Control()
    self.NoteListContainerBackground:SetParent(self.NoteListBackground)
    self.NoteListContainerBackground:SetSize(200 - 8, 380 - 8 - 20 - 4)
    self.NoteListContainerBackground:SetPosition(4, 28)
    self.NoteListContainerBackground:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    --self.NoteListContainer:SetIndentationWidth(0)

    self.NoteListContainer = Turbine.UI.TreeView()
    self.NoteListContainer:SetParent(self.NoteListContainerBackground)
    self.NoteListContainer:SetSize(200 - 8 - 10, 380 - 8 - 20 - 4)
    self.NoteListContainer:SetIndentationWidth(0)
    self.rootNodes = self.NoteListContainer:GetNodes()

    self.NoteListScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.NoteListScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.NoteListScrollbar:SetParent(self.NoteListContainerBackground)
    self.NoteListScrollbar:SetPosition(200 - 8 - 10, 0)
    self.NoteListScrollbar:SetSize(10, self.NoteListContainerBackground:GetHeight())
    self.NoteListContainer:SetVerticalScrollBar(self.NoteListScrollbar)

    for key, value in pairs(NoteHandler:GetNoteTextData()) do
        self.rootNodes:Add(UI.GetNiceTreeNode(200 - 8, key, function() self:SetNewNote(key) end))
    end
end

function NoteWindowsSettings:NoteButtonUI()
    self.NoteButtonBackground = Turbine.UI.Control()
    self.NoteButtonBackground:SetParent(self.NotesControl)
    self.NoteButtonBackground:SetPosition(200 + 4 + 10, 10)
    self.NoteButtonBackground:SetSize(490, 50)
    self.NoteButtonBackground:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))

    self.NoteActivationButton = Turbine.UI.Lotro.GoldButton()
    self.NoteActivationButton:SetParent(self.NoteButtonBackground)
    self.NoteActivationButton:SetPosition(5, 5)
    self.NoteActivationButton:SetSize(100, 20)
    self.NoteActivationButton:SetText("Set Note")
    self.NoteActivationButton.Click = function()
        NoteHandler:SetNoteActive(self.currentNote) 
    end

    self.NoteClearButton = Turbine.UI.Lotro.GoldButton()
    self.NoteClearButton:SetParent(self.NoteButtonBackground)
    self.NoteClearButton:SetPosition(110, 5)
    self.NoteClearButton:SetSize(100, 20)
    self.NoteClearButton:SetText("Clear Note")
    self.NoteClearButton.Click = function()
        NoteHandler:Clear()
    end

    self.NoteSelectedLabel = Turbine.UI.Label()
    self.NoteSelectedLabel:SetParent(self.NoteButtonBackground)
    self.NoteSelectedLabel:SetMouseVisible(false)
    self.NoteSelectedLabel:SetSize(200, 20)
    self.NoteSelectedLabel:SetPosition(self.NoteButtonBackground:GetWidth() / 2 - self.NoteSelectedLabel:GetWidth() / 2, 25)
    self.NoteSelectedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.NoteSelectedLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    self.NoteSelectedLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.NoteSelectedLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.NoteSelectedLabel:SetMarkupEnabled(true)
    self.NoteSelectedLabel:SetText("No Note Selected")

    self.NewNoteButton = Turbine.UI.Lotro.GoldButton()
    self.NewNoteButton:SetParent(self.NoteButtonBackground)
    self.NewNoteButton:SetPosition(self.NoteButtonBackground:GetWidth() - 100 - 5, 5)
    self.NewNoteButton:SetSize(100, 20)
    self.NewNoteButton:SetText("Create Note")
    self.NewNoteButton.Click = function()
        self.newWindow:View()
    end

    self.DeleteNoteButton = Turbine.UI.Lotro.GoldButton()
    self.DeleteNoteButton:SetParent(self.NoteButtonBackground)
    self.DeleteNoteButton:SetPosition(self.NoteButtonBackground:GetWidth() - 200 - 5 - 5, 5)
    self.DeleteNoteButton:SetSize(100, 20)
    self.DeleteNoteButton:SetText("Delete Note")
    self.DeleteNoteButton.Click = function()
        NoteHandler:DeleteNote(self.currentNote)

        for i = 1, self.rootNodes:GetCount() do
            local item = self.rootNodes:Get(i)
            if item.textLabel:GetText() == self.currentNote then
                self.rootNodes:Remove(item)
                break
            end
        end

        self.NoteCreationTextBox:SetText("")
        self.NoteSelectedLabel:SetText("No Note Selected")
        self.currentNote = ""
    end
end

function NoteWindowsSettings:NoteCreationUI()
    self.NoteCreationBackground = Turbine.UI.Control()
    self.NoteCreationBackground:SetParent(self.NotesControl)
    self.NoteCreationBackground:SetPosition(200 + 4 + 10, 60 + 4)
    self.NoteCreationBackground:SetSize(490, 325)
    self.NoteCreationBackground:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))

    self.NoteCreationTextBox = Turbine.UI.Lotro.TextBox()
    self.NoteCreationTextBox:SetParent(self.NoteCreationBackground)
    self.NoteCreationTextBox:SetPosition(4, 4)
    self.NoteCreationTextBox:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.NoteCreationTextBox:SetOutlineColor(Turbine.UI.Color.Black)
    self.NoteCreationTextBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.NoteCreationTextBox:SetSize(490 - 8 - 10, 325 - 8)

    self.NoteCreationTextBox.TextChanged = function()
        NoteHandler:ChangeNoteData(self.currentNote, self.NoteCreationTextBox:GetText())
    end

    self.NoteTextboxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.NoteTextboxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.NoteTextboxScrollbar:SetParent(self.NoteCreationBackground)
    self.NoteTextboxScrollbar:SetPosition(490 - 4 - 10, 0)
    self.NoteTextboxScrollbar:SetSize(10, self.NoteCreationBackground:GetHeight())
    self.NoteCreationTextBox:SetVerticalScrollBar(self.NoteTextboxScrollbar)
end

function NoteWindowsSettings:GroupNoteSettingsUI()
    local optionsWidth = self.GroupControl:GetWidth()
    self.GroupSettingsContainer = Turbine.UI.TreeView()
    self.GroupSettingsContainer:SetParent(self.GroupControl)
    self.GroupSettingsContainer:SetSize(optionsWidth - 8 - 10, self.GroupControl:GetHeight())
    self.GroupSettingsContainer:SetIndentationWidth(0)
    self.groupNodes = self.GroupSettingsContainer:GetNodes()

    self.GroupSettingsContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.GroupSettingsContainerScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.GroupSettingsContainerScrollbar:SetParent(self.GroupControl)
    self.GroupSettingsContainerScrollbar:SetPosition(optionsWidth - 8 - 10, 0)
    self.GroupSettingsContainerScrollbar:SetSize(10, self.GroupControl:GetHeight())
    self.GroupSettingsContainer:SetVerticalScrollBar(self.GroupSettingsContainerScrollbar)

    for key, value in spairs(self.data.Group, function(t, a, b) return a < b end) do
        if string.find(key, "Colour") then
            local element = UI.SingleColourOptions(optionsWidth, key, value, (function(newColour, index)
                if index then
                    self.data.Group[key] = newColour
                else
                    self.data.Group[key] = newColour
                end
                
                NoteHandler:Reload(self.data)
                self.data = NoteHandler:GetNoteData()
            end))
            self.groupNodes:Add(element)
            self.groupNodes:Add(UI.ListBoxBorder(optionsWidth))
        elseif string.find(key, "Font") then
            local element = UI.FontInput(optionsWidth, key, value, (function(newFont)
                self.data.Group[key] = newFont
                
                NoteHandler:Reload(self.data)
                self.data = NoteHandler:GetNoteData()
            end))
            self.groupNodes:Add(element)
            self.groupNodes:Add(UI.ListBoxBorder(optionsWidth))
        elseif IsNumber(value) then
            local element = UI.TextInput(optionsWidth, key, value, (function(text) 
                local number = tonumber(text)
                if number then
                    self.data.Group[key] = number
                    
                    NoteHandler:Reload(self.data)
                    self.data = NoteHandler:GetNoteData()
                end
            end))
            self.groupNodes:Add(element)
            self.groupNodes:Add(UI.ListBoxBorder(optionsWidth))
        elseif value == true or value == false then
            local element = UI.BoolInput(optionsWidth, key, value, (function(bool) 
                self.data.Group[key] = bool
                
                NoteHandler:Reload(self.data)
            end))
            self.groupNodes:Add(element)
            self.groupNodes:Add(UI.ListBoxBorder(optionsWidth))
        end
    end
end

function NoteWindowsSettings:CreateNew(title)
    if NoteHandler:AddNewNote(title) then
        self.rootNodes:Add(UI.GetNiceTreeNode(200 - 8, title, function() self:SetNewNote(title) end))
        self:SetNewNote(title)
        return true
    else
        return false
    end
end

function NoteWindowsSettings:SetNewNote(title)
    self.NoteCreationTextBox:SetText(NoteHandler:GetNoteDataText(title))
    self.NoteSelectedLabel:SetText(title)
    self.currentNote = title
end

NewNoteWindow = class(Turbine.UI.Lotro.Window)
function NewNoteWindow:Constructor(options)
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(300, 100)
    self:SetPosition(math.floor(Turbine.UI.Display.GetWidth() / 2 - (self:GetWidth() / 2)), math.floor(Turbine.UI.Display.GetHeight() / 2 - (self:GetHeight()/2)))
    self:SetVisible(false)
    self:SetText("Add")

    self.TextBox = Turbine.UI.Lotro.TextBox()
    self.TextBox:SetParent(self)
    self.TextBox:SetSize(280, 20)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.Arial12)
    self.TextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TextBox:SetMouseVisible(false)
    self.TextBox:SetPosition(10, 40)

    self.ImportButton = Turbine.UI.Lotro.Button()
	self.ImportButton:SetParent(self)
	self.ImportButton:SetSize(100, 20)
	self.ImportButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.ImportButton:SetPosition(math.floor(self:GetWidth() - (130)), 65)
    self.ImportButton:SetText("Add")

    self.options = options

    self.ImportButton.Click = function()
        if self.options:CreateNew(tostring(self.TextBox:GetText())) then
            self:SetVisible(false)
        else
            ChatOutput("Failed to make new Note: There is already a Note with that name!")
        end
    end
end

function NewNoteWindow:View()
    self:SetVisible(true)
    self:SetZOrder(100)
    self.TextBox:SetText("")
end