function GetWindowUI(parent, text, height, settingX, settingY)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(0, height)
    UIElement:SetSize(400, 35)

    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(20 , 0)
    UIElement.windowLabel:SetSize(200,15)
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    UIElement.windowLabel:SetVisible(true)
    UIElement.windowLabel:SetText(text)

    UIElement.windowX = Turbine.UI.TextBox()
    UIElement.windowX:SetParent(UIElement)
    UIElement.windowX:SetBackColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowX:SetForeColor(Turbine.UI.Color(0, 0, 0))
    UIElement.windowX:SetPosition(20 , 15)
    UIElement.windowX:SetSize(100,15)
    UIElement.windowX:SetText(settingX)
    UIElement.windowX:SetVisible(true)

    UIElement.windowY = Turbine.UI.TextBox()
    UIElement.windowY:SetParent(UIElement)
    UIElement.windowY:SetBackColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowY:SetForeColor(Turbine.UI.Color(0, 0, 0))
    UIElement.windowY:SetPosition(130 , 15)
    UIElement.windowY:SetSize(100,15)
    UIElement.windowY:SetText(settingY)
    UIElement.windowY:SetVisible(true)

    UIElement.button = Turbine.UI.Lotro.Button()
    UIElement.button:SetParent(UIElement)
    UIElement.button:SetPosition(240 , 10)
    UIElement.button:SetSize(100,15)
    UIElement.button:SetText("Apply change")
    UIElement.button:SetVisible(true)

    return(UIElement)
end

function GetLabelUI(parent, text, height)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(0, height)
    UIElement:SetSize(600, 30)
    -- NoteWindow
    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(20 , 0)
    UIElement.windowLabel:SetSize(600,30)
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana23)
    UIElement.windowLabel:SetVisible(true)
    UIElement.windowLabel:SetText(text)
    return(UIElement)
end

function GetCheckUI(parent, height, text, checked)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(20, height - 15)
    UIElement:SetSize(200, 40)

    UIElement.cBox = Turbine.UI.Lotro.CheckBox()
    UIElement.cBox:SetParent(UIElement)
    UIElement.cBox:SetPosition(15 , 0)
    UIElement.cBox:SetSize(300,40)
    UIElement.cBox:SetChecked(checked)
    UIElement.cBox:SetText(text)
    UIElement.cBox:SetVisible(true)
    return(UIElement)
end

function GetFontMenu(parent, height, text)
    local UIElement = Turbine.UI.Control()
    UIElement:SetParent(parent)
    UIElement:SetPosition(20, height - 15)
    UIElement:SetSize(400, 50)

    UIElement.windowLabel = Turbine.UI.Label()
    UIElement.windowLabel:SetParent(UIElement)
    UIElement.windowLabel:SetPosition(0 , 10)
    UIElement.windowLabel:SetSize(200,15)
    UIElement.windowLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    UIElement.windowLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    UIElement.windowLabel:SetVisible(true)
    UIElement.windowLabel:SetText("Change font")

    UIElement.menu = Turbine.UI.ContextMenu()
    UIElement.menuItems = UIElement.menu:GetItems()
    for i, fontName in pairs( Fonts ) do
        local menuItem = Turbine.UI.MenuItem( fontName )
        UIElement.menuItems:Add(menuItem)
        --ChatOutput(fontName)
     end

    UIElement.button = Turbine.UI.Lotro.Button()
    UIElement.button:SetParent(UIElement)
    UIElement.button:SetPosition(0, 30)
    UIElement.button:SetSize(200,15)
    UIElement.button:SetText(text)
    UIElement.button:SetVisible(true)

    UIElement.button.Click = function()
        UIElement.menu:ShowMenu()
    end

     return(UIElement)
end

Fonts = {}
FontsLUT = {}
FontsLUTR = {}
for key, item in pairs(Turbine.UI.Lotro.Font) do
    if ( item ~= "IsA" and item ~= "Undefined" ) then
       table.insert(Fonts, key)
       
       FontsLUT[key] = item
       FontsLUTR[item] = key

    end
end
table.sort(Fonts)

plugin.GetOptionsPanel = function( self )
    local options = Turbine.UI.Control()
    options:SetSize(500, 400)

    local MasterOptionsButton = Turbine.UI.Lotro.Button()
    MasterOptionsButton:SetParent(options)
    MasterOptionsButton:SetPosition(100, 100)
    MasterOptionsButton:SetSize(200,15)
    MasterOptionsButton:SetText("Open options panel")
    MasterOptionsButton:SetVisible(true)

    MasterOptionsButton.Click = function()
        if MasterOptions == nil then
            MasterOptions = OptionOptions()
        else
            MasterOptions:SetVisible(not(MasterOptions:IsVisible()))
        end
    end

    return options
end

function SetCommands()
    Command = Turbine.ShellCommand()

    local Line1 = "Help for <rgb=#FF9900>"..plugin:GetName() .. " Version " .. plugin:GetVersion() .. "</rgb>\n"
    local Line2 = "<rgb=#0071b8>Commands:\n/prime help: Brings up this help message\n/prime reload: Reloads the plugin\n/prime move: Unlocks all windows\n/prime lock: Locks all windows\n/prime loot: Opens/Closes the lootlock window\n/prime dungeon: Opens/Closes the dungeon log\n/prime party: Opens party window\n/prime reset: Resets settings to default\n/prime clear: Clears the UI\n/prime ready: Get the readycheck button\n/prime soundtest: plays a soundeffect\n/prime noteClear: clear the contents of the note window\n/prime time: PRIMETIME BABY</rgb>\n"
    local Line3 = "Change the plugin options in the plugins managers option panel!"
    local HelpString = Line1 .. Line2 .. Line3
    local Features = "Current features:\n\nCombat Timer:\nA lightweight combat timer that remembers your 3 last fight durations\n\nChat alerts:\nCertain phrases from enemies trigger alerts in the middle of your screen to help you to notice certain mechanics.\n\nCountdown:\nA pull timer\n\nEffect alerts:\nCertain effects cast on you trigger alerts to help you deal with certain mechanics. (Also notices certain puddles)\n\nLog Window:\nSaves all buffs and debuffs applied to you. (Mainly testing purposes)\n\nNotes:\nA group leader can put notes in this window to help you remember certain things\n\nMechanic timers:\nCertain mechanics from bosses are timed in this window to help you plan the fight\n\nSkill timers\nMajor cooldowns from your fellowship/raid members appear in this window (Excluding dps), helpful for support roles\n\nLoot tracker\nTracks Mithril chests on characters so you can view all your account locks on any character\n\nSkill tracker\nTracks if certain skills are up so you do not forget to use them\n\nDungeon Log\nFind all mechanics and loot from certain instances"


    function Command:Execute( _, command )
        if command ~= nil or string.len( command ) ~= 0 then
            if command == "options" then
                if MasterOptions == nil then
                    MasterOptions = OptionOptions()
                    Windows["OptionsWindow"] = MasterOptions
                else
                    MasterOptions:SetVisible(not(MasterOptions:IsVisible()))
                end
            elseif command == "reload" then
                ReloadPlugin()
            elseif command == "move" then
                MoveWindow(true)
            elseif command == "lock" then
                MoveWindow(false)
            elseif command == "help" then
                ChatOutput(HelpString)
            elseif command == "loot" then
                if InstanceWindow then
                    InstanceWindow:SetVisible(true)
                else
                    InstanceWindow = Instances.InstanceInfoWindow()
                end
            elseif command == "dungeon" then
                if DungeonWindow ~= nil then DungeonWindow:SetVisible(not(DungeonWindow:IsVisible())) end 
            elseif command == "features" then
                ChatOutput(Features)
            elseif command == "reset" then
                GetDefaultSettings()
                ReloadPlugin()
            elseif command == "time" then
                ChatOutput("Beginning of Prime time: 1578535200")
            elseif command == "soundtest" then
                Sounds:PlaySoundEffect(Sounds:GetSoundList()["Test"])
            elseif command == "ready" then
                if Party ~= nil then
                    if Party:GetLeader():GetName() == Player:GetName() then
                        RCButtonWindow:SetVisible(true)
                    end
                else
                    ChatOutput("You are not in a party!")
                end
            elseif command == "party" then
                if Party ~= nil then
                    if not(ReadyCheck:IsVisible()) then
                        ReadyCheck:SetVisible(true)
                        ReadyCheck:MakeNewReadyCheck()
                    end
                else
                    ChatOutput("You are not in a party!")
                end
            elseif command == "noteClear" then
                noteWindow.noteWindow:SetText("")
            else
                ChatOutput( "Non-existing command" )
            end
        end
    end
    
    Turbine.Shell.AddCommand( "prime", Command )
end

-- Define a tree node class to put into the tree.
MyTreeNode = class( Turbine.UI.TreeNode )
function MyTreeNode:Constructor(text, leaf)
    Turbine.UI.TreeNode.Constructor( self )
    --self:SetBackColor( Turbine.UI.Color( math.random(), math.random(), math.random() ) )
    self:SetSize( 220, 18 )

    self:SetVisible(true)
    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(true)

    local xPos = 0

    if not(leaf) then
        self.tickLabel = Turbine.UI.Label()
        self.tickLabel:SetVisible(true)
        self.tickLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        --self.tickLabel:SetForeColor(colour)
        self.tickLabel:SetParent(self)
        self.tickLabel:SetSize(16, 16)
        self.tickLabel:SetPosition(0, 0)
        self.tickLabel:SetWantsKeyEvents(false)
        self.tickLabel:SetMouseVisible(false)
        self.tickLabel:SetBackground("PrimePlugins/RaidTools/Images/Plus.jpg")
        xPos = 18
    end

    self.nameLabel = Turbine.UI.Label()
    self.nameLabel:SetVisible(true)
    self.nameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    --self.nameLabel:SetForeColor(colour)
    self.nameLabel:SetParent(self)
    self.nameLabel:SetSize(220, 18)
    self.nameLabel:SetPosition(xPos, 0)
    self.nameLabel:SetWantsKeyEvents(false)
    self.nameLabel:SetMouseVisible(false)
    self.nameLabel:SetMarkupEnabled(true)
    self.nameLabel:SetText(text)

    self.ChangeBackground = function()
        if self:IsExpanded() then
            self.tickLabel:SetBackground("PrimePlugins/RaidTools/Images/Min.jpg")
        else
            self.tickLabel:SetBackground("PrimePlugins/RaidTools/Images/Plus.jpg")
        end
    end
end
