OptionOptions = class(Turbine.UI.Window)
function OptionOptions:Constructor()
    local width = 1100
    local height = 590
    local x = Settings.LOX - 125
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Window.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(x,y)
    self:SetWantsKeyEvents(true)
    self:SetText("Option Options")
    self:SetVisible(true)

    self.buttonIdleColour = Turbine.UI.Color(0.1,0.1,0.1)
    self.buttonHoverColour = Turbine.UI.Color(0.3,0,0)
    self.buttonClickColour = Turbine.UI.Color(0.2,0,0)
    self.buttonEdgeColour = Turbine.UI.Color.Black

    self.borderLineColour = Turbine.UI.Color(0.1,0.1,0.1)
    self.backgroundColour = Turbine.UI.Color(0.6,0.1,0.1,0.1)
    self.borderColour = Turbine.UI.Color.Black
    self.innerBackgroundColour = Turbine.UI.Color(0.1, 0.1, 0.1)

    self:SetBackColor(self.borderColour)

    self.borderLineBackground = Turbine.UI.Control()
    self.borderLineBackground:SetParent(self)
    self.borderLineBackground:SetPosition(2, 2)
    self.borderLineBackground:SetSize(width - 4, height - 4)
    self.borderLineBackground:SetMouseVisible(false)
    self.borderLineBackground:SetBackColor(self.borderLineColour)

    OPTIONS_OPEN = true

    self.reloadStatus = false

    self.VisibleChanged = function()
        if self.reloadStatus then 
            ReloadPlugin(true) 
        elseif not self:IsVisible() then
            ReloadPlugin(true)
        end
    end

    -- Move logic
    self.Moving = false

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.MouseUp = function()
        self.Moving = false
    end
  
    self.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    -- Options Container
    local ColorBackground = Turbine.UI.Control()
    ColorBackground:SetParent(self)
    ColorBackground:SetPosition(10, 10)
    ColorBackground:SetSize(1080, 570)
    ColorBackground:SetMouseVisible(false)
    ColorBackground:SetBackColor(self.backgroundColour)

    -- Close Button
    local CloseBackground = Turbine.UI.Control()
    CloseBackground:SetParent(self)
    CloseBackground:SetPosition(1100 - 37, 2)
    CloseBackground:SetSize(35 - 2, 35 - 2)
    CloseBackground:SetMouseVisible(false)
    CloseBackground:SetBackColor(self.borderLineColour)

    local Image = Turbine.UI.Label()
    Image:SetParent(CloseBackground)
    Image:SetPosition(8, 7 )
    Image:SetSize(20, 20)
    Image:SetBackColor(Turbine.UI.Color.DarkRed)
    Image:SetWantsKeyEvents(false)
    Image:SetMouseVisible(false)

    local Button = Turbine.UI.Label()
    Button:SetParent(CloseBackground)
    Button:SetPosition(10, 0)
    Button:SetSize(25, 25)
    --Button:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/X.tga"))
    Button:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    Button:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    Button:SetWantsKeyEvents(false)
    Button:SetMouseVisible(true)

    Button.MouseClick = function()
        self:SetVisible(false)
    end

    local innerheight = 524 - 4

    self.optionsContainerBorder = Turbine.UI.Control()
    self.optionsContainerBorder:SetParent(self)
    self.optionsContainerBorder:SetPosition(290, 40)
    self.optionsContainerBorder:SetSize(770, innerheight + 4)
    self.optionsContainerBorder:SetBackColor(self.borderColour)
    self.optionsContainerBorder:SetMouseVisible(false)

    local OptionsContainer = Turbine.UI.Control()
    OptionsContainer:SetParent(self)
    OptionsContainer:SetPosition(290 + 2, 40 + 2)
    OptionsContainer:SetSize(770 - 4, innerheight)
    OptionsContainer:SetBackColor(self.innerBackgroundColour)
    OptionsContainer:SetMouseVisible(false)

    self.primeBackground = Turbine.UI.Control()
    self.primeBackground:SetParent(OptionsContainer)
    self.primeBackground:SetPosition(0, 0)
    self.primeBackground:SetSize(1920, 1080)
    self.primeBackground:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/Prime.jpg"))
    self.primeBackground:SetStretchMode(1)
    self.primeBackground:SetSize(770 - 4, innerheight)
    self.primeBackground:SetOpacity(0.8)
    self.primeBackground:SetMouseVisible(false)
    --self.primeBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    OptionsDic = {} 
    ActiveOptionsPages = {}
    OptionsFuncDic = {}

    OptionsDic["Target Window"] = true
    import "PrimePlugins.RaidTools.TargetWindowTools.TargetWindowOptionsNew"
    OptionsFuncDic["Target Window"] = TargetWindowTools.TargetWindowOptionsNew

    OptionsDic["Skill Overlay"] = true
    OptionsFuncDic["Skill Overlay"] = SkillTools.SkillOverlayOptions

    OptionsDic["Buff Bars"] = true
    import "PrimePlugins.RaidTools.SkillTools.BuffTrackerSettings"
    OptionsFuncDic["Buff Bars"] = SkillTools.BuffTrackerSettings

    OptionsDic["Weapon Swaps"] = true
    import "PrimePlugins.RaidTools.SwapWarnerSettings"
    OptionsFuncDic["Weapon Swaps"] = SwapWarnerSettings

    OptionsDic["Countdown"] = true
    import "PrimePlugins.RaidTools.CountdownSettings"
    OptionsFuncDic["Countdown"] = CountdownSettings

    OptionsDic["Prime UI"] = true
    OptionsFuncDic["Prime UI"] = PrimeUITools.PrimeUIOptions.PrimeUIOptions

    OptionsDic["Boss Timers"] = true
    import "PrimePlugins.RaidTools.Timers.BossTimerSettings"
    OptionsFuncDic["Boss Timers"] = Timers.BossTimerSettings

    OptionsDic["Combat Timer"] = true
    import "PrimePlugins.RaidTools.Timers.CombatTimerSettings"
    OptionsFuncDic["Combat Timer"] = Timers.CombatTimerSettings

    OptionsDic["Settings"] = true
    import "PrimePlugins.RaidTools.GeneralSettings"
    OptionsFuncDic["Settings"] = SettingsSettings

    OptionsDic["Note Windows"] = true
    import "PrimePlugins.RaidTools.Notes.NoteWindowSettings"
    OptionsFuncDic["Note Windows"] = Notes.NoteWindowsSettings

    OptionsDic["Skill Tracker"] = true
    import "PrimePlugins.RaidTools.SkillTools.SkillTrackerSettings"
    OptionsFuncDic["Skill Tracker"] = SkillTools.SkillTrackerWindowOptions

    OptionsDic["Class Tools"] = true
    import "PrimePlugins.RaidTools.ClassSpecificTools.ClassToolsSettings"
    OptionsFuncDic["Class Tools"] = ClassSpecificTools.ClassToolsOptions

    OptionsDic["Plugin Manager"] = true
    import "PrimePlugins.RaidTools.PluginManagerSettings"
    OptionsFuncDic["Plugin Manager"] = PluginsManagerSettings

    OptionsDic["Instances"] = true
    import "PrimePlugins.RaidTools.Instances.TEQOptions"
    OptionsFuncDic["Instances"] = Instances.MplusOptions

    OptionsDic["Sounds"] = true
    import "PrimePlugins.RaidTools.SoundSettings"
    OptionsFuncDic["Sounds"] = SoundOptions
    
    OptionsDic["Auras"] = true
    import "PrimePlugins.RaidTools.AuraCollection.AuraOptions"
    OptionsFuncDic["Auras"] = AuraCollection.AuraOptions

    OptionsDic["Alerts/Timers"] = true
    import "PrimePlugins.RaidTools.Alerts.AlertOptions"
    OptionsFuncDic["Alerts/Timers"] = Alerts.AlertOptions
    OptionsDic["Alerts/Timers Windows"] = true
    OptionsFuncDic["Alerts/Timers Windows"] =  Alerts.AlertWindowOptions

    OptionsDic["Windows"] = true
    import "PrimePlugins.RaidTools.WindowOptions"
    OptionsFuncDic["Windows"] =  WindowOptionsPage

    OptionsDic["Names"] = true
    import "PrimePlugins.RaidTools.Naming.NameOptions"
    OptionsFuncDic["Names"] =  Naming.NameOptions

    ButtonsDic = {}

    SortedNames = {}
    for key, value in pairs(OptionsDic) do table.insert( SortedNames, key ) end
    table.sort( SortedNames )

    local buttonSize = math.round(innerheight / #SortedNames)

    self.moveButtons = {}

    local index = 0
    for key, value in pairs(SortedNames) do
        local EdgeColour = Turbine.UI.Control()
        EdgeColour:SetParent(self)
        EdgeColour:SetPosition(40, 40 + index * buttonSize)
        EdgeColour:SetSize(250, buttonSize)
        EdgeColour:SetMouseVisible(true)
        EdgeColour:SetBackColor(self.buttonEdgeColour)

        self.moveButtons[key] = Turbine.UI.Label()
        self.moveButtons[key]:SetParent(self)
        self.moveButtons[key]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        self.moveButtons[key]:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
        self.moveButtons[key]:SetFontStyle(Turbine.UI.FontStyle.Outline)
        self.moveButtons[key]:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        self.moveButtons[key]:SetForeColor(Turbine.UI.Color(1, 1, 1))
        self.moveButtons[key]:SetText(value)
        self.moveButtons[key]:SetPosition(40 + 1, 40 + index * buttonSize + 1)
        self.moveButtons[key]:SetSize(250 - 2, buttonSize - 2)
        self.moveButtons[key]:SetMouseVisible(true)
        self.moveButtons[key]:SetBackColor(self.buttonIdleColour)
        self.moveButtons[key].MouseClick = function()
            for button, _ in pairs(ButtonsDic) do
                button:SetBackColor(self.buttonIdleColour)
            end
            self.moveButtons[key]:SetBackColor(self.buttonClickColour)

            for _, optionPage in pairs(ActiveOptionsPages) do
                optionPage:SetVisible(false)
            end
            if ActiveOptionsPages[value] then
                ActiveOptionsPages[value]:SetVisible(true)
            else
                ActiveOptionsPages[value] = OptionsFuncDic[value](OptionsContainer)
                ActiveOptionsPages[value]:SetVisible(true)
            end
            self.primeBackground:SetVisible(false)
        end

        self.moveButtons[key].updateTicks = 20
        self.moveButtons[key].colourUpdates = 0

        self.moveButtons[key].ExecuteUpdate = function() 
            self.moveButtons[key].currentColourA = (self.buttonHoverColour.A - self.buttonIdleColour.A) / self.moveButtons[key].updateTicks
            self.moveButtons[key].currentColourR = (self.buttonHoverColour.R - self.buttonIdleColour.R) / self.moveButtons[key].updateTicks
            self.moveButtons[key].currentColourG = (self.buttonHoverColour.G - self.buttonIdleColour.G) / self.moveButtons[key].updateTicks
            self.moveButtons[key].currentColourB = (self.buttonHoverColour.B - self.buttonIdleColour.B) / self.moveButtons[key].updateTicks

            self.moveButtons[key]:SetBackColor(Turbine.UI.Color(
            self.buttonHoverColour.A - self.moveButtons[key].currentColourA * self.moveButtons[key].colourUpdates, 
            self.buttonHoverColour.R - self.moveButtons[key].currentColourR * self.moveButtons[key].colourUpdates, 
            self.buttonHoverColour.G - self.moveButtons[key].currentColourG * self.moveButtons[key].colourUpdates, 
            self.buttonHoverColour.B - self.moveButtons[key].currentColourB * self.moveButtons[key].colourUpdates))

            self.moveButtons[key].colourUpdates = self.moveButtons[key].colourUpdates + 1

            if self.moveButtons[key].colourUpdates >= self.moveButtons[key].updateTicks then
                self.moveButtons[key]:SetBackColor(self.buttonIdleColour)
                if self.moveButtons[key].updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.moveButtons[key].updateCallback) end
                self.moveButtons[key].updateCallback = nil
            end
        end

        self.moveButtons[key].MouseEnter = function()
            if not(ActiveOptionsPages[value]) or not(ActiveOptionsPages[value]:IsVisible()) then
                self.moveButtons[key]:SetBackColor(self.buttonHoverColour)
            end
        end

        self.moveButtons[key].MouseLeave = function()
            if not(ActiveOptionsPages[value]) or not(ActiveOptionsPages[value]:IsVisible()) then
                self.moveButtons[key]:SetBackColor(self.buttonIdleColour)
                if not(self.moveButtons[key].updateCallback) then self.moveButtons[key].updateCallback = AddCallback(Updater, "ExecuteUpdate", self.moveButtons[key].ExecuteUpdate) end
                self.moveButtons[key].colourUpdates = 0
            end
        end

        ButtonsDic[self.moveButtons[key]] = true

        index = index + 1
    end
end

function OptionOptions:ChangesMade()
    self.reloadStatus = true
end