PluginManager = class(Turbine.UI.Control)
function PluginManager:Constructor()
    Turbine.UI.Control.Constructor(self)

    self.availablePlugins = {}

    for key, value in pairs(Turbine.PluginManager:GetAvailablePlugins()) do
        self.availablePlugins[value["ScriptState"]] = true
    end

    Turbine.PluginManager.UnloadScriptState("~PrimeReloader")

    for key, value in pairs(Settings.AlwaysLoad) do
        if self.availablePlugins[key] then            
            Turbine.PluginManager.LoadPlugin(key)
        end
    end

    Settings.NoUnload = false
end

-- Unloading all loaded plugins loaded by the plugin manager
function PluginManager:UnloadAllPlugins()
    for key, value in pairs(Settings.AlwaysLoad) do
        if self.availablePlugins[key] then            
            Turbine.PluginManager.UnloadScriptState(key)
        end
    end

    for key, value in pairs(Settings.RaidLoad) do
        if self.availablePlugins[key] then            
            Turbine.PluginManager.UnloadScriptState(key)
        end
    end

    for key, value in pairs(Settings.EttenmoorsLoad) do
        if self.availablePlugins[key] then            
            Turbine.PluginManager.UnloadScriptState(key)
        end
    end
end

-- Load all raid plugins
function PluginManager:LoadRaidPlugins()
    for key, value in pairs(Settings.RaidLoad) do
        if self.availablePlugins[key] then            
            Turbine.PluginManager.LoadPlugin(key)
        end
    end
end

-- Unload all raid plugins
function PluginManager:UnloadRaidPlugins()
    for key, value in pairs(Settings.RaidLoad) do
        if self.availablePlugins[key] then            
            Turbine.PluginManager.UnloadScriptState(key)
        end
    end
end

-- Load all ettens plugins
function PluginManager:LoadEttenmoorsPlugins()
    for key, value in pairs(Settings.EttenmoorsLoad) do
        if self.availablePlugins[key] then            
            Turbine.PluginManager.LoadPlugin(key)
        end
    end
end

-- Unload all ettens plugins
function PluginManager:UnloadEttenmoorsPlugins()
    for key, value in pairs(Settings.EttenmoorsLoad) do
        if self.availablePlugins[key] then            
            Turbine.PluginManager.UnloadScriptState(key)
        end
    end
end