PluginsManagerSettings = class(Turbine.UI.Control)
function PluginsManagerSettings:Constructor(parent)
    
    assert(Settings ~= nil, "Settings are not loaded")

    local width = 750
    local height = 500
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(20 - 2, 20 - 2)
    SingleBackground:SetSize(700 + 4, 400 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(20, 20)
    SingleBackground:SetSize(700, 400)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local container = Turbine.UI.ListBox()
    container:SetParent(SingleBackground)
    container:SetSize(700, 400)
    container:SetPosition(0, 0)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)
    --container:SetBackColor(GetRandomColour())

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( SingleBackground )
    containerScrollbar:SetPosition( 730 - 10, 10 )
    containerScrollbar:SetSize( 10, 400 )
    container:SetVerticalScrollBar( containerScrollbar )

    self.createPluginBar = function(name, scriptState, x, y)

        local pluginBar = Turbine.UI.Control()
        pluginBar:SetSize(800, 40)
        pluginBar:SetBackColor(Turbine.UI.Color(0, 0, 0))

        local backgroundBar = Turbine.UI.Control()
        backgroundBar:SetSize(800, 38)
        backgroundBar:SetPosition(0, 1)
        backgroundBar:SetParent(pluginBar)
        backgroundBar:SetMouseVisible(false)
        backgroundBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
        --pluginBar:SetBackColor(GetRandomColour())

        local nameLabel = Turbine.UI.Label()
        nameLabel:SetParent(pluginBar)
        nameLabel:SetSize(200, 20)
        nameLabel:SetPosition(0, 10)
        nameLabel:SetMouseVisible(false)
        nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
        nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        nameLabel:SetMultiline(false)
        nameLabel:SetText(name)

        local pluginLoadButton = Turbine.UI.Lotro.Quickslot()
        pluginLoadButton:SetParent(pluginBar)
        pluginLoadButton:SetUseOnRightClick(false)
        pluginLoadButton:SetMouseVisible(true)
        pluginLoadButton:SetSize(32, 32)
        pluginLoadButton:SetPosition(150, 2)
        pluginLoadButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/plugins load \"" .. scriptState .. "\""))

        local cover1 = Turbine.UI.Control()
        cover1:SetParent(pluginBar)
        cover1:SetPosition(151 + 6, 4 + 6)
        cover1:SetSize(16, 16)
        cover1:SetMouseVisible(false)
        --cover1:SetBlendMode(Turbine.UI.BlendMode.Overlay)
        cover1:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/Plus.jpg"))
        --cover1:SetStretchMode(1)
        --cover1:SetSize(20, 20)

        local pluginUnloadButton = Turbine.UI.Lotro.Quickslot()
        pluginUnloadButton:SetParent(pluginBar)
        pluginUnloadButton:SetUseOnRightClick(false)
        pluginUnloadButton:SetMouseVisible(true)
        pluginUnloadButton:SetSize(32, 32)
        pluginUnloadButton:SetPosition(200, 2)
        pluginUnloadButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/plugins unload \"" .. scriptState .. "\""))

        local cover2 = Turbine.UI.Control()
        cover2:SetParent(pluginBar)
        cover2:SetPosition(201 + 6, 4 + 6)
        cover2:SetSize(16, 16)
        cover2:SetMouseVisible(false)
        --cover2:SetStretchMode(1)
        --cover2:SetBlendMode(Turbine.UI.BlendMode.Overlay)
        cover2:SetBackground(BackgroundHandler:GetBackground(Min))
        --cover2:SetSize(20, 20)

        local EffectBox = Turbine.UI.Lotro.CheckBox()
        EffectBox:SetParent(pluginBar)
        EffectBox:SetPosition(240, 10)
        EffectBox:SetSize(120,20)
        EffectBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        EffectBox:SetChecked(Settings.AlwaysLoad[scriptState])
        EffectBox:SetText("Always load")
        EffectBox:SetVisible(true)

        local EffectBox1 = Turbine.UI.Lotro.CheckBox()
        EffectBox1:SetParent(pluginBar)
        EffectBox1:SetPosition(360, 10)
        EffectBox1:SetSize(200,20)
        EffectBox1:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        EffectBox1:SetChecked(Settings.RaidLoad[scriptState])
        EffectBox1:SetText("Load in instances")
        EffectBox1:SetVisible(true)

        local EffectBox2 = Turbine.UI.Lotro.CheckBox()
        EffectBox2:SetParent(pluginBar)
        EffectBox2:SetPosition(510, 10)
        EffectBox2:SetSize(300,20)
        EffectBox2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        EffectBox2:SetChecked(Settings.EttenmoorsLoad[scriptState])
        EffectBox2:SetText("Load in ettenmoors")
        EffectBox2:SetVisible(true)

        -- Load all
        EffectBox.CheckedChanged = function()
            if EffectBox:IsChecked() then
                EffectBox1:SetChecked(false)
                EffectBox2:SetChecked(false)
                Settings.AlwaysLoad[scriptState] = true
                Settings.RaidLoad[scriptState] = nil
                Settings.EttenmoorsLoad[scriptState] = nil
            else
                Settings.AlwaysLoad[scriptState] = nil
            end
            MasterOptions:ChangesMade()
        end

        -- Load raids
        EffectBox1.CheckedChanged = function()
            if EffectBox1:IsChecked() then
                EffectBox:SetChecked(false)
                Settings.AlwaysLoad[scriptState] = nil
                Settings.RaidLoad[scriptState] = true
            else
                Settings.RaidLoad[scriptState] = nil
            end
            MasterOptions:ChangesMade()
        end
    
        -- Load ettenmoors
        EffectBox2.CheckedChanged = function()
            if EffectBox2:IsChecked() then
                EffectBox:SetChecked(false)
                Settings.AlwaysLoad[scriptState] = nil
                Settings.EttenmoorsLoad[scriptState] = true
            else
                Settings.EttenmoorsLoad[scriptState] = nil
            end
            MasterOptions:ChangesMade()
        end

        return pluginBar
    end


    container:AddItem(self.createPluginBar("Prime Bags", "Prime Bags", 0, 20))
    container:AddItem(self.createPluginBar("Prime Cast", "Prime Cast", 0, 60))
    container:AddItem(self.createPluginBar("Prime Parse", "Prime Parse", 0, 100))
    container:AddItem(self.createPluginBar("Prime Party Vitals", "Prime Party Vitals", 0, 140))

    for key, value in pairs(Turbine.PluginManager:GetAvailablePlugins()) do
        --ChatOutput(value["Name"] .. " " .. value["ScriptState"])
        if not(string.find(value["ScriptState"], "Prime")) and not(string.find(value["ScriptState"], "Reload")) then 
            container:AddItem(self.createPluginBar(value["Name"], value["ScriptState"], 0, 20))
        end
    end

    --self.readyButton:SetWantsUpdates(true)

end