BalladBarPrimeUI = class(Turbine.UI.Control)
function BalladBarPrimeUI:Constructor(parent, index, x, y, width, height, damageColour, healColour, powerColour, borderSize, borderColour, backgroundColour)
    self.damageColour = damageColour
    self.healColour = healColour
    self.powerColour = powerColour
    self.backgroundColour = backgroundColour
    self.borderColour = borderColour

    Turbine.UI.Control.Constructor(self)
    self.width = width
    self.height = height
    self:SetParent(parent)
    self:SetMouseVisible(false)
    self:SetBackColor(self.borderColour)
    self:SetSize(self.width + 2 * borderSize, self.height + 2 * borderSize)
    self:SetPosition(x, y)

    self.innerBox = Turbine.UI.Control()
    self.innerBox:SetParent(self)
    self.innerBox:SetMouseVisible(false)
    self.innerBox:SetBackColor(self.backgroundColour)
    self.innerBox:SetSize(self.width, self.height)
    self.innerBox:SetPosition(borderSize, borderSize)

    self.index = index
end

function BalladBarPrimeUI:AdjustColour(type)
	if type == 1 then
		self.innerBox:SetBackColor(self.damageColour)
	elseif type == 2 then
		self.innerBox:SetBackColor(self.healColour)
	elseif type == 3 then
		self.innerBox:SetBackColor(self.powerColour)
	end
end

function BalladBarPrimeUI:Reset()
	self.innerBox:SetBackColor(self.backgroundColour)
end

BalladBarPrimeUIControl = class(Turbine.UI.Window)
function BalladBarPrimeUIControl:Constructor(parent, x, y, width, height, scale, boxOffset, borderSize, damageColour, healColour, powerColour, backgroundColour, borderColour, boxBackgroundColour)
    Turbine.UI.Window.Constructor(self)
    self.width = width
    self.height = height
    self:SetParent(parent)
    self:SetSize(self.width + 2 * borderSize, self.height + 2 * borderSize)
    self:SetBackColor(backgroundColour)
    self:SetVisible(true)
    self:SetMouseVisible(false)
    self:SetPosition(x, y)
    
    self.damageColour = damageColour
    self.healColour = healColour
    self.powerColour = powerColour
    self.backgroundColour = backgroundColour
    self.boxBackgroundColour = boxBackgroundColour
    self.borderColour = borderColour
    self.boxOffset = boxOffset or 10
    self.borderSize = borderSize
    self.scale = scale

    self.Y = y

    self.boxWidth = math.floor((self.width - 2 * self.boxOffset) / 3)

    self.balladBars = {}
    self.balladBars[1] = BalladBarPrimeUI(self, 1, 0, 0, self.boxWidth, self.height, self.damageColour, self.healColour, self.powerColour, self.borderSize, self.borderColour, self.boxBackgroundColour)
    self.balladBars[2] = BalladBarPrimeUI(self, 2, self.boxWidth + self.boxOffset, 0, self.boxWidth, self.height, self.damageColour, self.healColour, self.powerColour, self.borderSize, self.borderColour, self.boxBackgroundColour)
    self.balladBars[3] = BalladBarPrimeUI(self, 3, 2 * (self.boxWidth + self.boxOffset), 0, self.boxWidth, self.height, self.damageColour, self.healColour, self.powerColour, self.borderSize, self.borderColour, self.boxBackgroundColour)

    self.balladID = {
   		[1] = 0,
   		[2] = 0,
   		[3] = 0,
    }

    self.balladTimes = {
    	[1] = -1,
    	[2] = -1,
    	[3] = -1,
    }

    self.balladCount = 0

    self.balladTypes = {
    	-- Red
    	["Ballad Damage Bonus"] = 1,

    	-- Green
    	["Ballad Healing Bonus"] = 2,

    	-- Blue
    	["Ballad Incoming Healing Bonus"] = 3,
    }
end

function BalladBarPrimeUIControl:AddBallad(effect)
	if self.balladCount == 3 then
		local smallestTime = -1
		local smallestKey = -1
		for key, value in pairs(self.balladTimes) do
			if smallestTime == -1 or smallestTime > value then
				smallestTime = value
				smallestKey = key
			end
		end

		self.balladBars[smallestKey]:Reset()
		self.balladID[smallestKey] = 0

		self.balladCount = self.balladCount - 1
	end

	for key, value in pairs(self.balladID) do
		if value == 0 then
			self.balladID[key] = effect:GetID()
			self.balladBars[key]:AdjustColour(self.balladTypes[effect:GetName()])
			self.balladCount = self.balladCount + 1
			self.balladTimes[key] = Turbine.Engine.GetGameTime()
			break
		end
	end
end

function BalladBarPrimeUIControl:RemoveBallad(id)
	for key, value in pairs(self.balladID) do
		if value == id then
			self.balladID[key] = 0
			self.balladBars[key]:Reset()
			self.balladCount = self.balladCount - 1
			break
		end
	end
end