PrimeUIEffectListBox = class(Turbine.UI.ListBox)
function PrimeUIEffectListBox:Constructor(parent, x, y, width, height, orientation, reversefill, flippedLayout, itemSize)
    Turbine.UI.ListBox.Constructor(self)
    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(width, height)
    self:SetOrientation(orientation)
    self:SetReverseFill(reversefill)
    self:SetFlippedLayout(flippedLayout)
    self:SetMouseVisible(false)

    if orientation == Turbine.UI.Orientation.Horizontal then
        self:SetMaxColumns(math.floor(width / itemSize))
    else
        self:SetMaxRows(math.floor(height / itemSize))
    end

    self.sortFunction = function(a, b)
        if a:GetValue() > 99999 and b:GetValue() > 99999 or a:GetValue() == b:GetValue() then
            return a:GetName() < b:GetName()
        else
            return a:GetValue() > b:GetValue()
        end  
    end
end

function PrimeUIEffectListBox:Add(item)
    self:AddItem(item)
    self:Sort(self.sortFunction)
end

function PrimeUIEffectListBox:Remove(item)
    item:SetVisible(false)
    self:RemoveItem(item)
    item:Unload()
    self:Sort(self.sortFunction)
end

function PrimeUIEffectListBox:Unload()
    for i = 1, self:GetItemCount() do
        self:GetItem(i):SetVisible(false)
    end
    self:ClearItems()
end