PrimeUIFigure = class(Turbine.UI.Window)
function PrimeUIFigure:Constructor(data, parent, colour)
    Turbine.UI.Window.Constructor(self)

    self.data = data
    self.data.Toggle_Type = "Flash"

    self.duration = 0
    self.maxDuration = self.data.Max_Duration
    self.flashDuration = self.data.Flash_Duration
    self.maxOpacity = self.data.Max_Opacity
    self.flashOpacity = self.data.Flash_Opacity
    self.processOpacity = (self.maxOpacity - self.flashOpacity) / self.flashDuration
    if self.processOpacity == 0 then self.processOpacity = self.maxOpacity / self.maxDuration * 2 end
    self.down = true

    if self.data.Use_Screen_Width then
        self.data.Width = Turbine.UI.Display.GetWidth()
    end

    if self.data.Use_Screen_Height then
        self.data.Height = Turbine.UI.Display.GetHeight()
    end

    self:SetParent(parent)
    self:SetPosition(self.data.X, self.data.Y)
    self:SetVisible(false)
    self:SetMouseVisible(false)

    if self.data.useTexture then
        self:SetBackground(self.data.texture)
        self:SetStretchMode(2)
        self:SetStretchMode(1)
        self:SetSize(self.data.Width, self.data.Height)
    else
        self:SetBackColor(colour)
        self:SetSize(self.data.Width, self.data.Height)
    end

    if self.data.useColour then
        self:SetBackColor(colour)
        self:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    end

    self:SetOpacity(self.flashOpacity)

    self.ExecuteUpdate = function(delta)
        if self.duration > 0 then
            self.duration = self.duration - delta
            if self.down then
                self:SetOpacity(self:GetOpacity() - self.processOpacity * delta)
                if self:GetOpacity() <= 0 then
                    self:SetVisible(false)
                    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
                    self.updateCallback = nil
                end
            else
                self:SetOpacity(math.min(self.maxOpacity, self:GetOpacity() + self.processOpacity * delta))
                if self:GetOpacity() + 0.05 >= self.maxOpacity then
                    self.down = true
                end
            end
        else
            if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
            self.updateCallback = nil
        end
    end

    --self:Toggle()
end

function PrimeUIFigure:Toggle()

    if self.data.Toggle_Type == "Flash" then
        self.duration = self.maxDuration
        self.flashes = 0
        self.down = false
        self:SetVisible(true)
        self:SetOpacity(self.flashOpacity)
        if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end

    elseif self.data.Toggle_Type == "Show" then

    end
end

function PrimeUIFigure:Unload()
    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
    self.updateCallback = nil
end