GambitBar = class(Turbine.UI.Window)
function GambitBar:Constructor(parent, data)
    Turbine.UI.Window.Constructor(self)
    self:SetParent(parent)

    if Turbine.Gameplay.LocalPlayer.GetInstance():GetClass() ~= Turbine.Gameplay.Class.Warden then return end
    self.attr = Turbine.Gameplay.LocalPlayer.GetInstance():GetClassAttributes()

    self.gambitCount = self.attr:GetMaxGambitCount()

    if data.Vertical then
        data.Height = (29 + 2 * data.BoxBorderSize + data.Offset) * data.Scale * self.gambitCount - data.Offset * data.Scale + 2 * data.BorderSize * data.Scale
        data.Width = (30 + 2 * data.BoxBorderSize) * data.Scale + 2 * data.BorderSize * data.Scale
    else
        data.Width = (30 + 2 * data.BoxBorderSize + data.Offset) * data.Scale * self.gambitCount - data.Offset * data.Scale + 2 * data.BorderSize * data.Scale
        data.Height = (29 + 2 * data.BoxBorderSize) * data.Scale + 2 * data.BorderSize * data.Scale
    end


    self:SetSize(data.Width, data.Height)
    self:SetMouseVisible(false)
    self:SetBackColor(ColourTupleToTurbineColour(data.BarBackgroundColour))
    self:SetVisible(true)

    self.gambitBoxes = {}

    for i = 1, self.gambitCount, 1 do
        if data.UseBackground then
            GambitBackgroundBox(self, data, i - 1)
        end
        self.gambitBoxes[i] = GambitBox(self, data, i - 1)
    end

    self.gambitIcons = {
        [0] = "",
        [1] = 0x410E72ED,
        [2] = 0x410E72EE,
        [3] = 0x410E72EF,
        [4] = 0x41123653,
        [5] = 0x4112B3D1, -- blue shield??
    }

    self.gambitChangeCallback = AddCallback(self.attr, "GambitChanged", function()
        for i = 1, self.gambitCount, 1 do
            self.gambitBoxes[data.Reverse_Fill and 6 - i or i]:GambitIcon(self.gambitIcons[self.attr:GetGambit(i)])
        end
    end)

    for i = 1, self.gambitCount, 1 do
        self.gambitBoxes[i]:GambitIcon(self.gambitIcons[self.attr:GetGambit(i)])
    end
end

function GambitBar:Unload()
    if Turbine.Gameplay.LocalPlayer.GetInstance():GetClass() ~= Turbine.Gameplay.Class.Warden then return end
    if self.gambitChangeCallback then RemoveCallback(self.attr, "GambitChanged", self.gambitChangeCallback) end
    self:SetVisible(false)
    for i = 1, #self.gambitBoxes, 1 do
        self.gambitBoxes[i]:SetParent(nil)
    end
    self:SetParent(nil)
end

GambitBox = class(Turbine.UI.Window)
function GambitBox:Constructor(parent, data, index)
    Turbine.UI.Window.Constructor(self)
    self:SetParent(parent)
    if data.Vertical then
        self:SetPosition(data.BorderSize * data.Scale, (29 + 2 * data.BoxBorderSize + data.Offset) * data.Scale * index + data.BorderSize * data.Scale)
    else
        self:SetPosition((30 + 2 * data.BoxBorderSize + data.Offset) * data.Scale * index + data.BorderSize * data.Scale, data.BorderSize * data.Scale)
    end    
    self:SetSize((30 + 2 * data.BoxBorderSize) * data.Scale, (29 + 2 * data.BoxBorderSize) * data.Scale)
    self:SetMouseVisible(false)
    if not(data.UseBackground) then
        self:SetBackColor(ColourTupleToTurbineColour(data.BoxBorderColour))
    end
    --self:SetBackground(0x410E7447)
    self:SetVisible(false)

        self.data = data

    self.icon = Turbine.UI.Window()
    self.icon:SetParent(self)
    self.icon:SetPosition(data.BoxBorderSize * data.Scale, data.BoxBorderSize * data.Scale)
    if not(data.UseBackground) then
        self.icon:SetBackColor(ColourTupleToTurbineColour(self.data.IconBackgroundColour))
    end
    self.icon:SetVisible(not(self.data.HideWhenEmpty))
    self.icon:SetSize(30, 29)
    self.icon:SetStretchMode(1)
    self.icon:SetSize(30 * data.Scale, 29 * data.Scale)


end

function GambitBox:GambitIcon(background)
    if background == "" then
        if self.data.HideWhenEmpty then
            self:SetVisible(false)
        else
            if not(self.data.UseBackground) then
                self.icon:SetBackColor(ColourTupleToTurbineColour(self.data.IconBackgroundColour))
            end
        end
        self.icon:SetBackground(background)
    else
        if not(self.data.UseBackground) then
            self.icon:SetBackColor(nil)
        end
        self:SetVisible(true)
        self.icon:SetBackground(background)
        self.icon:SetSize(30, 29)
        self.icon:SetStretchMode(1)
        self.icon:SetSize(30 * self.data.Scale, 29 * self.data.Scale)
    end
end

GambitBackgroundBox = class(Turbine.UI.Window)
function GambitBackgroundBox:Constructor(parent, data, index)
    Turbine.UI.Window.Constructor(self)
    self:SetParent(parent)
    self:SetPosition(not(data.Vertical) and data.Offset / 2 * data.Scale + (30 + 2 * data.BoxBorderSize + data.Offset) * data.Scale * index or 0, 
    data.Vertical and data.Offset / 2 * data.Scale + (29 + 2 * data.BoxBorderSize + data.Offset) * data.Scale * index or 0)
    self:SetSize(30, 29)
    self:SetBackground(0x410E7447)
    self:SetStretchMode(1)
    self:SetSize((30 + 2 * data.BoxBorderSize) * data.Scale, (29 + 2 * data.BoxBorderSize) * data.Scale)
    --self:SetStretchMode(0)
    self:SetMouseVisible(false)
    --self:SetBackColor(data.BorderColour)
    self:SetBackground(0x410E7447)
    self:SetVisible(true)
end
