function PrimeUI:BalladBar(data, parent)
    local x = self:ContentAlignement(data["Alignment"], (data["Width"] + 2 * data["BorderSize"]) * data["Scale"])
    local y = self.currentHeight
    if self.groupMode then
        x = data["X"]
        y = data["Y"]
    end

    local valuebar = BalladBarPrimeUIControl(parent, x, y, data["Width"], data["Height"], data["Scale"], data["Box Offset"], data["BorderSize"],
    self:ColourTupleToTurbineColour(data["DamageColour"]), self:ColourTupleToTurbineColour(data["HealColour"]), self:ColourTupleToTurbineColour(data["PowerColour"]), self:ColourTupleToTurbineColour(data["BackgroundColour"]), self:ColourTupleToTurbineColour(data["BorderColour"]), self:ColourTupleToTurbineColour(data["BoxBackgroundColour"]))
    self.lookup[data.NickName or ""] = valuebar
    if self.groupMode then
        valuebar.moveBox = MoveBox(valuebar, data["Width"] * data["Scale"], data["Height"] * data["Scale"], data["NickName"] or "Skill label")
        valuebar.savePosition = function()
            data["X"], data["Y"] = valuebar:GetPosition()
        end
    end

    
    valuebar.balladTypes = {
    	-- Red
    	["Ballad Damage Bonus"] = 1,

    	-- Green
    	["Ballad Healing Bonus"] = 2,

    	-- Blue
    	["Ballad Incoming Healing Bonus"] = 3,
    }

    valuebar.effectFunction = function(effect)
        if valuebar.balladTypes[effect:GetName()] then
            valuebar:AddBallad(effect)
        end
    end

    for i = 1, self.player:GetEffects():GetCount() do
        valuebar.effectFunction(self.player:GetEffects():Get(i))
    end

    table.insert(self.effectAddedCallbacks, AddCallback(PlayerEffectsHandler, "EffectAdded", valuebar.effectFunction))

    table.insert(self.effectRemovedCallbacks, AddCallback(PlayerEffectsHandler, "EffectRemoved", 
    function(effect)
        if valuebar.balladTypes[effect:GetName()] then
            valuebar:RemoveBallad(effect:GetID())
        end
    end))

    self.currentHeight = self.currentHeight + data["Height"]

    table.insert(self.UI, valuebar)
end