function PrimeUI:Code(data, parent, sessionData)
    local valuebar = Turbine.UI.Control()
    valuebar:SetParent(parent)

    valuebar.codeData = sessionData

    valuebar.Tools = {        
        AddCallback = AddCallback,
        RemoveCallback = RemoveCallback,
        Turbine = Turbine,
        pairs = pairs,
        math = math,
        Print = ChatOutput,
        string = string,
        FormatTimeString = FormatTimeString,
        tonumber = tonumber,
        PrintTable = PrintTable,
        Round = Round,

        -- Handlers
        Updater = Updater,
        ChatEventHandler = ChatEventHandler,
        PlayerEffectsHandler = PlayerEffectsHandler,
        GroupEffectsHandler = GroupEffectsHandler,
        EventWindows = EventWindows,
        PlayerHandlerObject = PlayerHandlerObject,
        ActionHandlerObject = ActionHandlerObject,
        SkillEventHandler = SkillEventHandler,
        StatEventHandling = StatEventHandling,
        Roles = Roles,
        TargetHandlerObject = TargetHandlerObject,
        rezTracker = rezTracker,
        LocationHandler = LocationHandler,
        NameHandlerObject = NameHandlerObject,
    }

    local result, func = pcall(loadstring, string.format("return function(PrimeUIObject, codeData, args, event) %s end", data.Code))

    if result and func then
        valuebar.func = func()
        setfenv(valuebar.func, valuebar.Tools)
    else
        ChatOutput(string.format("Failed to load code for %s", parent.name))
    end

    valuebar.events = {}

    for keyword in string.gmatch(data["Triggers"], "([^,]+)") do
        valuebar.events[keyword] = true
    end

    if valuebar.func then
        table.insert(self.eventTriggerCallbacks, AddCallback(self, "EventTrigger",
        function(event)
            --PrintTable(self.codeData)
            if valuebar.events[event] then
                valuebar.func(parent, valuebar.codeData, self.args[event], event)
            end
        end))
    end

    table.insert(self.UI, valuebar)
end