function PrimeUI:ContentAlignement(alignment, width)
    if alignment == "Middle" then
        return (self.width - width) / 2
    elseif alignment == "Right" then
        return self.width - width
    else
        return 0 
    end
end

function PrimeUI:AlignmentToNumber(text)
    if text == "Middle" then return 2 end
    if text == "Left" then return 1 end
    if text == "Right" then return 3 end
    return 4
end

function PrimeUI:AlignmentToNumberSmall(text)
    if text == "Middle" then return 1 end
    if text == "Left" then return 2 end
    if text == "Right" then return 3 end
    return 3
end

function PrimeUI:ColourTupleToTurbineColour(tuple)
    if tuple then
        if type(tuple[1]) == "table" then
            local colourTable = {}
            for key, value in pairs(tuple) do
                if value then
                    colourTable[key] = Turbine.UI.Color(value[1], value[2], value[3], value[4])
                else
                    colourTable[key] = nil
                end
            end

            return colourTable
        else
            return Turbine.UI.Color(tuple[1], tuple[2], tuple[3], tuple[4])
        end
    else
        return Turbine.UI.Color(0,0,0,0)
    end
end

function PrimeUI:FontToFont(font)
    return Turbine.UI.Lotro.Font[font]
end