function PrimeUI:EffectListBox(data, parent)
    local x = self:ContentAlignement(data["Listbox_Alignment"], (data["Width"] + 2 * data["BorderSize"]) * data["Scale"])
    local y = self.currentHeight
    if self.groupMode then
        x = data["X"]
        y = data["Y"]
    end

    local valuebar = PrimeUITools.PrimeUIEffectListBox(parent, x, y, data["Width"], data["Height"], Turbine.UI.Orientation[data.Orientation], data.Reverse_Fill, data.Flipped_Layout, data.Effect_Size * data.Scale)
    self.lookup[data.NickName or ""] = valuebar
    if self.groupMode then
        valuebar.moveBox = MoveBox(valuebar, data["Width"] * data["Scale"], data["Height"] * data["Scale"], data["NickName"] or "Effect ListBox")
        valuebar.savePosition = function()
            data["X"], data["Y"] = valuebar:GetPosition()
        end
    end

    valuebar.SkillID = {}

    valuebar.BlackListPresent = valuebar.BlackList and tablelength(valuebar.BlackList) > 0

    valuebar.effectFunction = function(effect)
        local debuff = effect:IsDebuff()
        if not(debuff) and data.All_Buffs or debuff and data.All_Debuffs then

            if valuebar.BlackListPresent and valuebar.BlackList[effect:GetName()] then return end

            local ID = effect:GetID()

            local effectItem = PrimeUITools.PrimeUIEffectBox(effect, data.Effect_Size, data.Scale, data.Spacing, data.BorderSize, self:ColourTupleToTurbineColour(data.BorderColour), data.Show_Duration, self:FontToFont(data.Effect_Duration_Font), Turbine.UI.ContentAlignment[data.Effect_Duration_TextAlignment], data.Visibility_Threshold, data.Show_Stack, self:FontToFont(data.Effect_Stack_Font), Turbine.UI.ContentAlignment[data.Effect_Stack_TextAlignment])

            valuebar:Add(effectItem)

            valuebar.SkillID[ID] = effectItem
        end
    end

    for i = 1, self.player:GetEffects():GetCount() do
        valuebar.effectFunction(self.player:GetEffects():Get(i))
    end

    table.insert(self.effectAddedCallbacks, AddCallback(PlayerEffectsHandler, "EffectAdded", valuebar.effectFunction))

    table.insert(self.effectRemovedCallbacks, AddCallback(PlayerEffectsHandler, "EffectRemoved", 
    function(effect)
        local ID = effect:GetID()
        if valuebar.SkillID[ID] then
            valuebar:Remove(valuebar.SkillID[ID])
            valuebar.SkillID[ID] = nil
        end

    end))

    self.currentHeight = self.currentHeight + data["Height"]

    table.insert(self.tools, valuebar)

end