PrimeUI = class(Turbine.UI.Window)
function PrimeUI:Constructor(data, name, x, y, advancedMode, ooc, ic, AX, AY, codeData)
    Turbine.UI.Window.Constructor(self)
    self.data = data
    self.width = 0
    self.height = 3000
    self.currentHeight = 0
    self.groupMode = advancedMode

    if self.groupMode then
        self:SetPosition(AX or 0, AY or 0)
        self:SetSize(Turbine.UI.Display.GetWidth(), Turbine.UI.Display.GetHeight())
        self.advancedMoveBox = MoveBox(self, 120, 120, string.format("Anchor:\n%s", name))
    else
        self:SetPosition(x, y)
    end

    self:SetVisible(true)
    self:SetMouseVisible(false)
    
    self.hideState = {}

    self.codeData = codeData or {}
    self.codeSessionData = {}
    self.userVars = {}
    self.loaded = false

    self.FireEventTrigger = function(sender, event, args)
        if type(event)=="function" then
            event(args)
        else
            if type(event)=="table" then
                for i=1,#event do
                    if type(event[i])=="function" then
                        event[i](args)
                    end
                end
            end
        end
    end

    self.ooc = ooc
    self.ic = ic

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.playerClass = self.player:GetClass()
    self.ClassAttr = self.player:GetClassAttributes()

    self.skillCallbacks = {}
    self.playerCallbacks = {}
    self.attrCallbacks = {}
    self.effectAddedCallbacks = {}
    self.effectRemovedCallbacks = {}
    self.playerChatCallback = {}
    self.enemyChatCallback = {}
    self.sayChatCallback = {}
    self.sayInfoChatCallback = {}
    self.partyChatCallback = {}
    self.partyInfoChatCallback = {}
    self.standardChatCallback = {}
    self.playerHealthCallbacks = {}
    self.healthThresholdCooldowns = {}
    self.healthThresholdPercentage = {}
    self.effectAddedGroupCallbacks = {}
    self.deathChatCallbacks = {}
    self.instanceEventCallbacks = {}
    self.fightEventStartCallbacks = {}
    self.fightEventPhaseCallback = {}
    self.fightEventEndCallbacks = {}
    self.effectTargetAddedCallbacks = {}
    self.healthTargetCallbacks = {}
    self.temporaryHealthTargetCallbacks = {}
    self.powerTargetCallbacks = {}
    self.targetInfoCallbacks = {}
    self.combatCallbacks = {}
    self.playerBenefitCallbacks = {}
    self.playerHealCallbacks = {}
    self.playerMoraleHandlerCallbacks = {}
    self.playerMaxMoraleHandlerCallbacks = {}
    self.playerPowerHandlerCallbacks = {}
    self.playerMaxPowerHandlerCallbacks = {}
    self.playerTemporaryMoraleHandlerCallbacks = {}
    self.playerTemporaryPowerHandlerCallbacks = {}
    self.playerLevelHandlerCallbacks = {}
    self.playerCombatHandlerCallbacks = {}
    self.petMoraleCallbacks = {}
    self.petTemporaryMoraleCallbacks = {}
    self.petInfoCallbacks = {}
    self.eventTriggerCallbacks = {}
    self.defeatEventCallback = {}
    self.effectCategoryAddedCallback = {}
    self.effectCategoryRemovedCallback = {}
    self.dnfAppliedCallbacks = {}
    self.dnfRemovedCallbacks = {}
    self.playerDispellCallback = {}
    self.QuestAcceptedCallbacks = {}
    self.QuestOrDeedCompletedCallbacks = {}
    self.QuestOrDeedProgress = {}
    self.NewDeedCallbacks = {}
    self.pvpCallbacks = {}
    self.locationCallbacks = {}
    self.delvingEventCallbacks = {}
    self.actionCallbacks = {}

    self.args = {}

    self.combatState = self.player:IsInCombat()

    self.alignments = {
        ["BottomCenter"] = Turbine.UI.ContentAlignment.BottomCenter,
        ["BottomLeft"] = Turbine.UI.ContentAlignment.BottomLeft,
        ["BottomRight"]	= Turbine.UI.ContentAlignment.BottomRight,
        ["MiddleCenter"] = Turbine.UI.ContentAlignment.MiddleCenter,
        ["MiddleLeft"] = Turbine.UI.ContentAlignment.MiddleLeft,
        ["MiddleRight"] = Turbine.UI.ContentAlignment.MiddleRight,
        ["TopCenter"] = Turbine.UI.ContentAlignment.TopCenter,
        ["TopLeft"] = Turbine.UI.ContentAlignment.TopLeft,
        ["TopRight"] = Turbine.UI.ContentAlignment.TopRight,
    }

    self.fortificationTable = {
        ["Improved Fortification I"] = 1,
        ["Improved Fortification II"] = 2,
        ["Improved Fortification III"] = 3,
        ["Improved Fortification IV"] = 4,
        ["Improved Fortification V"] = 5,
    }

    self.classObjectsToName = {
        [Turbine.Gameplay.Class.Burglar] = "Burglar",
        [Turbine.Gameplay.Class.Captain] = "Captain",
        [Turbine.Gameplay.Class.Champion] = "Champion",
    --    [Turbine.Gameplay.Class.Corsair] = "Corsair",
        [Turbine.Gameplay.Class.Guardian] = "Guardian",
        [Turbine.Gameplay.Class.Hunter] = "Hunter",
        [Turbine.Gameplay.Class.LoreMaster] = "LoreMaster",
        [Turbine.Gameplay.Class.Minstrel] = "Minstrel",
        [Turbine.Gameplay.Class.RuneKeeper] = "RuneKeeper",
        [Turbine.Gameplay.Class.Warden] = "Warden",
        [Turbine.Gameplay.Class.Beorning] = "Beorning",
        [Turbine.Gameplay.Class.Brawler] = "Brawler",
        [Turbine.Gameplay.Class.BlackArrow] = "BlackArrow",
        [Turbine.Gameplay.Class.Defiler] = "Defiler",
        [Turbine.Gameplay.Class.Reaver] = "Reaver",
        [Turbine.Gameplay.Class.Stalker] = "Stalker",
        [Turbine.Gameplay.Class.WarLeader] = "WarLeader",
        [Turbine.Gameplay.Class.Weaver] = "Weaver",
    } 

    self.keyWordCategories = {
        -- Morale keywords
        ["Player_Morale"] = "Player_Morale",
        ["Player_Max_Morale"] = "Player_Morale",
        ["Player_Base_Max_Morale"] = "Player_Morale",
        ["Player_Morale_Percentage"] = "Player_Morale",

        -- Temp Morale Keywords
        ["Player_Temporary_Morale"] = "Player_Temporary_Morale",
        ["Player_Max_Temporary_Morale"] = "Player_Temporary_Morale",

        ["Pet_Morale"] = "Pet_Morale",
        ["Pet_Max_Morale"] = "Pet_Morale",
        ["Pet_Morale_Percentage"] = "Pet_Morale",

        -- Temp Morale Keywords
        ["Pet_Temporary_Morale"] = "Pet_Temporary_Morale",
        ["Pet_Max_Temporary_Morale"] = "Pet_Temporary_Morale",

        ["Pet_Name"] = "Pet_Info",

        -- Power keywords
        ["Player_Power"] = "Player_Power",
        ["Player_Max_Power"] = "Player_Power",
        ["Player_Base_Max_Power"] = "Player_Power",
        ["Player_Power_Percentage"] = "Player_Power",

        -- Temp Power Keywords
        ["Player_Temporary_Power"] = "Player_Temporary_Power",
        ["Player_Max_Temporary_Power"] = "Player_Temporary_Power",

        -- Level keyword
        ["Player_Level"] = "Player_Level",

        -- Combat keywords
        ["Player_Is_In_Combat"] = "Player_Is_In_Combat",
        
        -- Target Morale keywords
        ["Target_Morale"] = "Target_Morale",
        ["Target_Max_Morale"] = "Target_Morale",
        ["Target_Base_Max_Morale"] = "Target_Morale",
        ["Target_Name"] = "Target_Level",

        -- Target Temp Morale Keywords
        ["Target_Temporary_Morale"] = "Target_Temporary_Morale",
        ["Target_Max_Temporary_Morale"] = "Target_Temporary_Morale",

        -- Target Power keywords
        ["Target_Power"] = "Target_Power",
        ["Target_Max_Power"] = "Target_Power",
        ["Target_Base_Max_Power"] = "Target_Power",

        -- Target Temp Power Keywords
        ["Target_Temporary_Power"] = "Target_Temporary_Power",
        ["Target_Max_Temporary_Power"] = "Target_Temporary_Power",

        -- Target Level keyword
        ["Target_Level"] = "Target_Level",

        ["Killstreak"] = "PvP",
        ["Daily_KBs"] = "PvP",
        ["Daily_Deaths"] = "PvP",
        ["Last_KB"] = "PvP",
        ["Last_KB_KC"] = "PvP",
        ["Last_KB_Deaths"] = "PvP",

        ["Location"] = "Location",
    }

    self.compareFunctions = {
        ["<="] = function(percentage, value) return percentage <= value end,
        [">="] = function(percentage, value) return percentage >= value end,
    }

    self.fortificationID = 0
    self.battleFlowID = 0
    self.venomID = 0

    self.name = name

    -- All tools are contained here
    self.tools = {}
    self.UI = {}
    self.timers = {}
    self.icons = {}
    self.timerCount = 0
    self.lookup = {}

    self.ExecuteUpdate = function(delta)    
        --We had an update
        for key,_ in pairs(self.timers) do 
            if key:UpdateText(delta) == true then 
                if key.highlight then key.highlight:Toggle(false) end
                key.currentEffect = ""
                self.timers[key] = nil
                if tablelength(self.timers) == 0 and tablelength(self.icons) == 0 then
                    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
                    self.updateCallback = nil
                end
            end
        end

        for key,_ in pairs(self.icons) do
            if key:ExecuteUpdate(delta) == true then 
                if key.highlight then key.highlight:Toggle(key.highlightWhileOff) end
                self.icons[key] = nil
                if tablelength(self.timers) == 0 and tablelength(self.icons) == 0 then
                    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
                    self.updateCallback = nil
                end
            end
        end
    end

    self.Update = function()
        if Turbine.Engine.GetGameTime() > self.reloadTime then
            self.playerClass = self.player:GetClass()
            self.ClassAttr = self.player:GetClassAttributes()
            self:UnloadObject()
            self:Setup()
            self:SetWantsUpdates(false)
            if not(self.ooc) or not(self.ic) then
                table.insert(self.combatCallbacks, AddCallback(self.player, "InCombatChanged", function()
                    self.combatVisibility()
                end))
            end
        end
    end

    self.combatVisibility = function()
        if self.player:IsInCombat() then
            if self.ic then
                self:SetVisible(true)
            else
                self:SetVisible(false)
            end
        else
            if self.ooc then
                self:SetVisible(true)
            else
                self:SetVisible(false)
            end

        end
    end
    if not(self.ooc) or not(self.ic) then
        table.insert(self.combatCallbacks, AddCallback(self.player, "InCombatChanged", function()
            self.combatVisibility()
        end))
    end

    self.combatVisibility()
    self:Setup()
end

function PrimeUI:ReloadWithDelay()
    if self.skills  then
        self.reloadTime = Turbine.Engine.GetGameTime() + 5
        self:SetWantsUpdates(true)
    end
end

function PrimeUI:Setup(newData)


    if newData then self.data = newData end

    self.currentHeight = 0
    self.currentOrder = 0
    self.sameOrderOffset = 0
    self.width = 0

    for toolName, data in spairs(self.data, function(t, a, b) return t[a]["Order"] < t[b]["Order"] end) do
        self:CalculateNewBiggestWidth(data)
    end

    if not self.groupMode then
        self:SetSize(self.width, self.height)
    end


    -- Setup all the tools
    for toolName, data in spairs(self.data, function(t, a, b) return t[a]["Order"] < t[b]["Order"] end) do
        -- Make sure we udpate offset before creating tool
        self.currentHeight = self.currentHeight + (data["OffsetAbove"] or 0)

        -- Setup dynamic skill bar
        if data["Type"] == "Skills" then
            self:SetupSkillBar(data, self)
        end

        if data["Type"] == "MoraleBar" then
            self:SetupMoraleBar(data, self)
        end

        if data["Type"] == "PetMoraleBar" then
            self:SetupPetMoraleBar(data, self)
        end

        if data["Type"] == "MoraleBar_Target" then
            self:SetupTargetMoraleBar(data, self)
        end

        if data["Type"] == "PowerBar" then
            self:SetupPowerBar(data, self)
        end

        if data["Type"] == "PowerBar_Target" then
            self:SetupTargetPowerBar(data, self)
        end

        if data["Type"] == "WrathBar" then
            self:SetupWrathBar(data, self)
        end

        if data["Type"] == "ResourceBar" then
            self:ResourceBar(data, self)
        end

        if data["Type"] == "ValueBar" then
            self:ValueBar(data, self)
        end

        if data["Type"] == "BuffBar" then
            self:BuffBar(data, self)
        end

        if data["Type"] == "BuffBar_Target" then
            self:TargetBuffBar(data, self)
        end
        
        if data["Type"] == "Icon" then
            self:Icon(data, self)
        end

        if data["Type"] == "TimerIcon" then
            self:TimerIcon(data, self)
        end

        if data["Type"] == "Timer" then
            self:Timer(data, self)
        end

        if data["Type"] == "Text" then
            self:Text(data, self)
        end

        if data["Type"] == "Countdown" then
            self:Countdown(data, self)
        end

        if data["Type"] == "Sound" then
            self:Sound(data, self)
        end

        if data["Type"] == "TimerGroup" then
            self:TimerGroup(data, self)
        end

        if data["Type"] == "SkillLabel" then
            self:SkillLabel(data, self)
        end

        if data["Type"] == "Alert" then
            self:Alert(data, self)
        end

        if data["Type"] == "AlertGroup" then
            self:AlertGroup(data, self)
        end

        if data["Type"] == "Ballad Bar" then
            self:BalladBar(data, self)
        end

        if data["Type"] == "Circle Timer" then
            self:CircleTimer(data, self)
            self:SetRotation({x=0, y=0, z=0})
        end

        if data["Type"] == "Note Event" then
            self:NoteEvent(data, self)
        end

        if data["Type"] == "Note Activation" then
            self:NoteActivation(data, self)
        end

        if data["Type"] == "Effect Listbox" then
            self:EffectListBox(data, self)
        end

        if data["Type"] == "Counter" then
            self:Counter(data, self)
        end

        if data["Type"] == "Conditions" then
            self:Conditions(data, self)
        end

        if data["Type"] == "Event Keyword" then
            self:EventKeyword(data, self)
        end

        if data["Type"] == "Figures" then
            self:Figures(data, self)
        end

        if data["Type"] == "Gambit Bar" then
            self:PrimeUIGambitBar(data, self)
        end

        if data["Type"] == "Code" then
            self:Code(data, self, self.codeSessionData)
        end

        if data["Type"] == "User Variables" then
            self:Variables(data, self)
        end

        -- Make sure we update offset after creating tool
        self.currentHeight = self.currentHeight + (data["OffsetBelow"] or 0)
    end
    if self.currentHeight < 10 then self.currentHeight = 100 end
    if not self.groupMode then
        self:SetSize(self.width, self.currentHeight)
    end
    self.moveBox = MoveBox(self, (self.width or 100), (self.currentHeight or 100), self.name)

    if not(self.loaded) then
        self:FireTrigger("LOAD", PlayerHandlerObject:GetInfo())
        self.loaded = true
    end
end

function PrimeUI:CalculateNewBiggestWidth(data)
    local width = 100

    if data["Width"] and data["Width"] > 32 then width = data["Width"] end
    if data["BorderSize"] then width = width + 2 * data["BorderSize"] end
    if data["Scale"] then width = width * data["Scale"] end

    if self.width < width then self.width = width end

end

function PrimeUI:FireTrigger(event, args)
    if args then
        self.args[event] = args
    end
    self.FireEventTrigger(self, self.EventTrigger, event)
end

function PrimeUI:Hide(hide)
    if not(hide) then
        for key, value in pairs(self.UI) do
            self.hideState[key] = value:IsVisible()
            value:SetVisible(false)
        end

        for key, value in pairs(self.tools) do
            self.hideState[key] = value:IsVisible()
            value:SetVisible(false)
        end
    else
        for key, value in pairs(self.tools) do
            if self.hideState[key] then
                self.tools[key]:SetVisible(true)
            end
        end

        for key, value in pairs(self.UI) do
            if self.hideState[key] then
                self.UI[key]:SetVisible(true)
            end
        end
        
        self.hideState = {}
    end
end