function PrimeUI:SetupPowerBar(data, parent)
    local valuebar = Turbine.UI.Control()
    valuebar:SetParent(parent)
    if self.groupMode then
        valuebar:SetPosition(data["X"], data["Y"])
        valuebar.moveBox = MoveBox(valuebar, data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"], data["NickName"] or "Power Bar")
        valuebar.savePosition = function()
            data["X"], data["Y"] = valuebar:GetPosition()
        end
    else
        valuebar:SetPosition(self:ContentAlignement(data["Alignment"], data["Width"] + 2 * data["BorderSize"]), self.currentHeight)
    end
    valuebar:SetSize(data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"])
    valuebar:SetMouseVisible(false)
    valuebar:SetBackColor(self:ColourTupleToTurbineColour(data["BorderColour"]))

    -- args (parent, x, y, width, height, textFormat, textAlignment, barAlignment, barColours, barbackground)
    local powerbar = ClassSpecificTools.PermanentBar(valuebar, data["BorderSize"], data["BorderSize"], data["Width"], data["Height"], data["Text"], Turbine.UI.ContentAlignment[data.TextAlignment], data["Alignment"], self:ColourTupleToTurbineColour(data["Colours"]), "bar25", self:FontToFont(data["Font"]), self:ColourTupleToTurbineColour(data["Interval_Colour"]), data["Intervals"])
    powerbar:SetMaxValue(self.player:GetMaxPower())
    powerbar:SetCurrentValue(self.player:GetPower())
    self.lookup[data.NickName or ""] = powerbar
    if data["Smooth"] then
        table.insert(self.playerPowerHandlerCallbacks, AddCallback(PlayerHandlerObject, "PowerChanged", function(args) powerbar:SetCurrentValue(args.Player_Power) end))
    else
        table.insert(self.playerPowerHandlerCallbacks, AddCallback(PlayerHandlerObject, "PowerChanged", function(args) powerbar:SetCurrentValueImmediate(args.Player_Power) end))
    end
    table.insert(self.playerMaxPowerHandlerCallbacks, AddCallback(PlayerHandlerObject, "MaxPowerChanged", function(args) powerbar:SetMaxValue(args.Player_Max_Power) end))
    table.insert(self.playerTemporaryPowerHandlerCallbacks, AddCallback(PlayerHandlerObject, "TemporaryPowerChanged", function(args) powerbar:SetTempValue(args.Player_Temporary_Power) end))
    powerbar:SetCurrentValue(self.player:GetPower())
    powerbar:SetMaxValue(self.player:GetMaxPower())
    table.insert(self.UI, valuebar)
    table.insert(self.tools, powerbar)

    self.currentHeight = self.currentHeight + data["Height"] + 2 * data["BorderSize"]
end