function PrimeUI:SetupSkillBar(data, parent)
    -- Determine bar height
    local barHeight = 0
    self.skills = true

    -- Bar -> Bar name
    -- Bar data
    -- Skills
    -- Scale

    --args (parent, x, y, width, height, labelSize, sortMethod, hide)
    local x = 0
    local y = self.currentHeight
    if self.groupMode then
        x = data.X
        y = data.Y
    end
    local skillbar = ClassSpecificTools.DynamicSkillBar(parent, x, y, self.width, 34 * data["Scale"], 34 * data["Scale"], 4, false, false, data["Offset"])
    self.lookup[data.NickName or ""] = skillbar
    -- Skill data
    -- Name
    -- ID
    -- X prio
    -- Y prio
    -- Special triggers?
    local count = 0
    local height = 1

    -- [[
    local highlightTable = {}

    if data["Highlight_On_Effect"] then
        for key, value in pairs(data["Highlight_On_Effect"]) do
            highlightTable[value.Skill] = true
        end
    end

    if data["Highlight_On_Resource"] then
        for key, value in pairs(data["Highlight_On_Resource"]) do
            highlightTable[value.Skill] = true
        end
    end

    if data["Highlight_On_Event"] then
        for key, value in pairs(data["Highlight_On_Event"]) do
            highlightTable[value.Skill] = true
        end
    end

    local highlightReadyTable = {}
    if data["Highlight_When_Ready"] then
        for key, value in pairs(data["Highlight_When_Ready"]) do
            highlightReadyTable[value.Skill] = value.Highlight_Duration 
        end
    end
    --]]

    for key, value in pairs(data["Skills"]) do

        if SkillEventHandler:SkillExists(key) then

            local highlight = highlightTable[key]

            --args (parent, x, y, base, normal, skill, hideOnCreation, pet, highlight)
            local skillSlot = ClassSkillSlotPrimeUI(skillbar, 0, 0, 34, 34, value["Code"], self:ColourTupleToTurbineColour(data["BorderColour"]), data["BorderSize"], nil, 
            value["visibitilityThreshold"], value["hideWhileOff"], value["hideWhileOn"], value["opacityOff"], value["opacityOn"], self:FontToFont(data["Font"]), data["Scale"], highlight, self:ColourTupleToTurbineColour(data["HighlightColour"]), data["HighlightSize"], value["Event_Keyword"] and function() self:FireTrigger(value["Event_Keyword"]) end, nil, data["Lock_Quickslot"], highlightReadyTable[key] or 0) --data["Scale"])

            count = math.max(count, value["XPrio"] or 1)
            
            -- Add the callback for this skill slot
            if not(self.skillCallbacks[key]) then self.skillCallbacks[key] = {} end
            table.insert(self.skillCallbacks[key], AddCallback(SkillEventHandler, key, function(skill) 
                local time = skill:GetResetTime() - Turbine.Engine.GetGameTime()
                if time + 1 > skill:GetCooldown() then
                    
                    if IsNumber(value["Time"]) then
                        time = value["Time"]
                    end
                end
                skillbar:SetLabelTimer(key, math.max(0.1, time), skill:GetCooldown())
            end))

            -- args (skill, label, priority, skillObject, y)
            skillbar:AddLabel(key, skillSlot, value["XPrio"] or 1, nil, value["YPrio"] or 1)

            -- Update max bar height
            barHeight = math.max(barHeight, value["YPrio"] or 1)

            local tempSkill = SkillEventHandler:GetSkill(key)
            if tempSkill then
                local time = tempSkill:GetResetTime() - Turbine.Engine.GetGameTime()
                if time > 0 then
                    
                    if IsNumber(value["Time"]) then
                        time = value["Time"]
                    end
                    skillbar:SetLabelTimer(key, math.max(0.1, time), tempSkill:GetCooldown())
                end

            end
        end
    end

    if tablelength(data["Quickslots"]) > 0 then
        for key, value in pairs(data["Quickslots"]) do
            local skillSlot = ClassSkillSlotPrimeUI(skillbar, 0, 0, 34, 34, {["Data"] = value["Data"], ["Type"] = value["Type"], ["Item"] = value["Item"]}, self:ColourTupleToTurbineColour(data["BorderColour"]), data["BorderSize"], nil, 
            value["visibitilityThreshold"], value["hideWhileOff"], value["hideWhileOn"], value["opacityOff"], value["opacityOn"],  self:FontToFont(data["Font"]), data["Scale"], nil, self:ColourTupleToTurbineColour(data["HighlightColour"]), data["HighlightSize"], nil, self.player:GetBackpack(), data["Lock_Quickslot"]) --data["Scale"])

            count = math.max(count, value["XPrio"])

            -- args (skill, label, priority, skillObject, y)
            skillbar:AddLabel(key, skillSlot, value["XPrio"], nil, value["YPrio"])

            if value.HideOnType and value.HideOnType ~= "" then
                table.insert(self.effectCategoryAddedCallback, AddCallback(PlayerHandlerObject, "CategoryAdded", function(args) 
                    if args.Type == value.HideOnType then
                        skillSlot:SetVisible(true)
                    end
                end))

                table.insert(self.effectCategoryRemovedCallback, AddCallback(PlayerHandlerObject, "CategoryRemoved", function(args) 
                    if args.Type == value.HideOnType then
                        skillSlot:SetVisible(false)
                    end
                end))

                skillSlot:SetVisible(PlayerHandlerObject:CategoryApplied(value.HideOnType))
            end

            -- Update max bar height
            barHeight = math.max(barHeight, value["YPrio"])
        end
    end

    if tablelength(data["Highlight_On_Effect"]) > 0 then
        skillbar.SkillID = {}
        skillbar.SkillTable = {}
        skillbar.EffectIDs = {}
        for key, value in pairs(data["Highlight_On_Effect"]) do
            if not skillbar.SkillTable[value["Effect"]] then skillbar.SkillTable[value["Effect"]] = {} end
            table.insert(skillbar.SkillTable[value["Effect"]], key)
        end

        local effectsFound = {}

        for i = 1, self.player:GetEffects():GetCount() do
            local effect = self.player:GetEffects():Get(i)
            if skillbar.SkillTable[effect:GetName()] then
                effectsFound[effect:GetName()] = true
                skillbar.EffectIDs[effect:GetName()] = effect:GetID()
                for _, index in pairs(skillbar.SkillTable[effect:GetName()]) do
                    local value = data["Highlight_On_Effect"][index]
                    local ID = effect:GetID()
    
                    skillbar.SkillID[ID] = true
                    skillbar:ToggleHighlight(value["Skill"], not(value["Invert_Highlight"]))
                end
            end
        end

        for key, _ in pairs(skillbar.SkillTable) do
            if not(effectsFound[key]) then
                for _, index in pairs(skillbar.SkillTable[key]) do
                    local value = data["Highlight_On_Effect"][index]
                    if value["Invert_Highlight"] then
                        skillbar:ToggleHighlight(value["Skill"], value["Invert_Highlight"])
                    end
                end
            end
        end

        table.insert(self.effectAddedCallbacks, AddCallback(PlayerEffectsHandler, "EffectAdded", 
        function(effect)
            local name = effect:GetName()
            if skillbar.SkillTable[name] then
                skillbar.EffectIDs[effect:GetName()] = effect:GetID()
                for _, index in pairs(skillbar.SkillTable[name]) do
                    local value = data["Highlight_On_Effect"][index]
                    local ID = effect:GetID()

                    if value.Fit_Icon then
                        if effect:GetIcon() ~= value.Icon then return end
                    end
    
                    skillbar.SkillID[ID] = true
                    skillbar:ToggleHighlight(value["Skill"], not(value["Invert_Highlight"]))
                end
            end
        end))

        table.insert(self.effectRemovedCallbacks, AddCallback(PlayerEffectsHandler, "EffectRemoved", 
        function(effect)
            local ID = effect:GetID()
            if skillbar.SkillID[ID] and skillbar.EffectIDs[effect:GetName()] == effect:GetID() then
                for _, index in pairs(skillbar.SkillTable[effect:GetName()]) do
                    local value = data["Highlight_On_Effect"][index]
                    skillbar:ToggleHighlight(value["Skill"], value["Invert_Highlight"])
                end
            end

        end))
    end

    if tablelength(data["Highlight_On_Event"]) > 0 then
        table.insert(self.eventTriggerCallbacks, AddCallback(self, "EventTrigger", 
        function(event)
            for key, value in pairs(data["Highlight_On_Event"]) do
                if event == value.Effect then
                    skillbar:ToggleHighlight(value["Skill"], not(value["Invert_Highlight"]))
                end
            end
        end))
    end

    if tablelength(data["Toggle_Visibility_On_Event"]) > 0 then
        table.insert(self.eventTriggerCallbacks, AddCallback(self, "EventTrigger", 
        function(event)
            for key, value in pairs(data["Toggle_Visibility_On_Event"]) do
                if event == value.Effect then
                    skillbar:ToggleVisible(value["Skill"], not(value["Invert_Highlight"]))
                end
            end
        end))
    end

    if tablelength(data["Highlight_On_Resource"]) > 0 then
        skillbar.resourceFunction = function(resourceNumber)
            for key, value in pairs(data["Highlight_On_Resource"]) do
                if self.compareFunctions[value.Comparator](resourceNumber, value.Number) then
                    skillbar:ToggleHighlight(value["Skill"], not(value["Invert_Highlight"]))
                else
                    skillbar:ToggleHighlight(value["Skill"], value["Invert_Highlight"])
                end
            end
        end

        if self.playerClass == Turbine.Gameplay.Class.Beorning then
            skillbar.resourceFunction(self.ClassAttr:GetWrath())
            if not(self.attrCallbacks["WrathChanged"] ) then self.attrCallbacks["WrathChanged"] = {} end
            table.insert(self.attrCallbacks["WrathChanged"], AddCallback(self.ClassAttr, "WrathChanged", function(sender, args) skillbar.resourceFunction( self.ClassAttr:GetWrath() ) end))
        elseif self.playerClass == Turbine.Gameplay.Class.Champion then
            skillbar.resourceFunction(self.ClassAttr:GetFervor())
            if not(self.attrCallbacks["FervorChanged"] ) then self.attrCallbacks["FervorChanged"] = {} end
            table.insert(self.attrCallbacks["FervorChanged"], AddCallback(self.ClassAttr, "FervorChanged", function(sender, args) skillbar.resourceFunction( self.ClassAttr:GetFervor() ) end))
        elseif self.playerClass == Turbine.Gameplay.Class.Hunter then
            skillbar.resourceFunction(self.ClassAttr:GetFocus())
            if not(self.attrCallbacks["FocusChanged"] ) then self.attrCallbacks["FocusChanged"] = {} end
            table.insert(self.attrCallbacks["FocusChanged"], AddCallback(self.ClassAttr, "FocusChanged", function(sender, args) skillbar.resourceFunction( self.ClassAttr:GetFocus() ) end))
        elseif self.playerClass == Turbine.Gameplay.Class.RuneKeeper then
            if not(self.attrCallbacks["AttunementChanged"] ) then self.attrCallbacks["AttunementChanged"] = {} end
            skillbar.resourceFunction(self.ClassAttr:GetAttunement())
            table.insert(self.attrCallbacks["AttunementChanged"], AddCallback(self.ClassAttr, "AttunementChanged", function(sender, args) skillbar.resourceFunction( self.ClassAttr:GetAttunement() ) end))
        end
    end

    skillbar:SetStaticPositions(data.Skill_Alignment, data.Use_Priority_As_Index)

    data["Width"] = (35 + (data["Offset"] or 1)) * count

    if self.groupMode then
        skillbar.moveBox = MoveBox(skillbar, (35 + (data["Offset"] or 1)) * count + 50, barHeight * 34 * data["Scale"] + 50, data["NickName"] or "Skill bar")
        skillbar.savePosition = function()
            data["X"], data["Y"] = skillbar:GetPosition()
        end
    end

    table.insert(self.tools, skillbar)

    -- Update height
    self.currentHeight = self.currentHeight + barHeight * 34 * data["Scale"] + barHeight * (data["BorderSize"] or 0)
end