function PrimeUI:TargetBuffBar(data, parent)
    local x = self:ContentAlignement(data["Alignment"], data["Width"])
    local y = self.currentHeight
    if self.groupMode then
        x = data.X
        y = data.Y
    end

    local buffbar = ClassSpecificTools.DynamicSkillBar(parent, x, y, data["Width"], 32 * data["Scale"], 32 * data["Scale"], self:AlignmentToNumber(data["Alignment"]), true, false, data["Offset"])
    buffbar.name = ""
    buffbar.uniqueTable = {}
    buffbar.uniqueTableIDs = {}
    self.lookup[data.NickName or ""] = buffbar
    if self.groupMode then
        buffbar.moveBox = MoveBox(buffbar, data["Width"], data["Width"], data["NickName"] or "Target Buffbar")
        buffbar.savePosition = function()
            data["X"], data["Y"] = buffbar:GetPosition()
        end
    end

    if tablelength(data["EffectAdded_Target"]) > 0 or data["AllEffects"] then
        table.insert(self.effectTargetAddedCallbacks, TargetHandlerObject:AddEffectCallback(
        function(args)
            local name = args.Name
            if data["EffectAdded_Target"][name] or data["AllEffects"] then
                if (not(data["OnlyBuffs"]) and not(data["OnlyDebuffs"])) or (data["OnlyDebuffs"] and args.IsDebuff) or (data["OnlyBuffs"] and not(args.IsDebuff)) then
                    local highlight = data["AllHighlight"]
                    local icon = nil
                    local value = data["EffectAdded_Target"][name]
                    if value then
                        highlight = highlight or value["Highlight"]
                        if value["Icon"] == true then 
                            icon = args.Icon
                        else
                            icon = value["Icon"] 
                        end

                        local time = value["Time"]
                        if time == true then
                            time = args.Duration - (Turbine.Engine.GetGameTime() - args.StartTime)
                        end

                        if value["Fit_Icon"] and value["Icon"] and value["Icon"] ~= true then
                            if args.Icon ~= tonumber(value["Icon"]) then 
                                return 
                            end
                        end

                        if value["Unique"] then
                            local id = string.match(name, "%D+") .. tostring(icon)
                            if not(buffbar.uniqueTable[id]) or Turbine.Engine.GetGameTime() >= buffbar.uniqueTable[id] then
                                buffbar.uniqueTable[id] = Turbine.Engine.GetGameTime() + time - (Turbine.Engine.GetGameTime() - args.StartTime)
                                buffbar.uniqueTableIDs[id] = args.ID

                            elseif Turbine.Engine.GetGameTime() < buffbar.uniqueTable[id] then
                                buffbar:RemoveLabel(buffbar.uniqueTableIDs[id])
                                local ID = args.ID
                                buffbar:AddLabel(ID, ClassSpecificTools.ClassTimerLabel(buffbar, 0, 0, 32, 32, icon, false, false, nil, 1, 1, false, false, true, data["Scale"], name, true, self.alignments[data["TextAlignment"]], self.alignments[data["StackTextAlignment"]], highlight, self:FontToFont(data["Font_Timer"]), self:FontToFont(data["Font_Stack"]), self:ColourTupleToTurbineColour(data["Font_Timer_Colour"]), self:ColourTupleToTurbineColour(data["Font_Stack_Colour"])), value["Time"] == true and time or time - (Turbine.Engine.GetGameTime() - args.StartTime))
                                buffbar:ToggleLabel(ID, true, time - (Turbine.Engine.GetGameTime() - args.StartTime))
                                buffbar.uniqueTable[id] = Turbine.Engine.GetGameTime() + time - (Turbine.Engine.GetGameTime() - args.StartTime)
                                buffbar.uniqueTableIDs[id] = args.ID
                                return
                            end
                        end

                        local ID = args.ID
                        buffbar:AddLabel(ID, ClassSpecificTools.ClassTimerLabel(buffbar, 0, 0, 32, 32, icon, false, false, nil, 1, 1, false, false, true, data["Scale"], name, true, self.alignments[data["TextAlignment"]], self.alignments[data["StackTextAlignment"]], highlight, self:FontToFont(data["Font_Timer"]), self:FontToFont(data["Font_Stack"]), self:ColourTupleToTurbineColour(data["Font_Timer_Colour"]), self:ColourTupleToTurbineColour(data["Font_Stack_Colour"])), value["Time"] == true and time or time - (Turbine.Engine.GetGameTime() - args.StartTime))
                        buffbar:ToggleLabel(ID, true, value["Time"] == true and time or time - (Turbine.Engine.GetGameTime() - args.StartTime))
                        return
                    else
                        return
                    end

                    local ID = args.ID
                    buffbar:AddLabel(ID, ClassSpecificTools.ClassTimerLabel(buffbar, 0, 0, 32, 32, icon, false, false, nil, 1, 1, false, false, true, data["Scale"], name, true, self.alignments[data["TextAlignment"]], self.alignments[data["StackTextAlignment"]], highlight, self:FontToFont(data["Font_Timer"]), self:FontToFont(data["Font_Stack"]), self:ColourTupleToTurbineColour(data["Font_Timer_Colour"]), self:ColourTupleToTurbineColour(data["Font_Stack_Colour"])), effect:GetDuration())
                    buffbar:ToggleLabel(ID, true, args.Duration - (Turbine.Engine.GetGameTime() - args.StartTime))
                end
            end
        end))

        if data["Reset_On_Retarget"] then
            table.insert(self.targetInfoCallbacks, TargetHandlerObject:AddTargetInfoCallback(function(value) 
                if value then
                    --if buffbar.name ~= value["Name"] then
                        buffbar:Clear()
                        buffbar.uniqueTable = {}
                        buffbar.uniqueTableIDs = {}
                    --end
                    buffbar.name = value["Name"]
                else
                    buffbar.name = ""
                    buffbar:Clear()
                end
                
            end))
        end
    end

    self.currentHeight = self.currentHeight + 32 * data["Scale"]
    table.insert(self.tools, buffbar)
end