function PrimeUI:SetupTargetMoraleBar(data, parent)
    local valuebar = Turbine.UI.Window()
    valuebar:SetParent(parent)
    if self.groupMode then
        valuebar:SetPosition(data["X"], data["Y"])
        valuebar.moveBox = MoveBox(valuebar, data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"], data["NickName"] or "Target Morale Bar")
        valuebar.savePosition = function()
            data["X"], data["Y"] = valuebar:GetPosition()
        end
    else
        valuebar:SetPosition(self:ContentAlignement(data["Alignment"], data["Width"] + 2 * data["BorderSize"]), self.currentHeight)
    end
    valuebar:SetSize(data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"])
    valuebar:SetMouseVisible(false)
    valuebar:SetBackColor(self:ColourTupleToTurbineColour(data["BorderColour"]))
    valuebar:SetVisible(false)

    -- args (parent, x, y, width, height, textFormat, textAlignment, barAlignment, barColours, barbackground)
    local moralebar = ClassSpecificTools.PermanentBar(valuebar, data["BorderSize"], data["BorderSize"], data["Width"], data["Height"], data["Text"], Turbine.UI.ContentAlignment[data.TextAlignment], data["Alignment"], self:ColourTupleToTurbineColour(data["Colours"]), "bar25", self:FontToFont(data["Font"]), self:ColourTupleToTurbineColour(data["Interval_Colour"]), data["Intervals"])
    self.lookup[data.NickName or ""] = moralebar
    moralebar:SetMaxValue(1)
    moralebar:SetCurrentValue(1)
    moralebar:SetTempValue(0)
    
    if data["Smooth"] then
        table.insert(self.healthTargetCallbacks, TargetHandlerObject:AddHealthCallback(function(value) moralebar:SetCurrentValue(value) end))
    else
        table.insert(self.healthTargetCallbacks, TargetHandlerObject:AddHealthCallback(function(value) moralebar:SetCurrentValueImmediate(value) end))
    end
    table.insert(self.temporaryHealthTargetCallbacks, TargetHandlerObject:AddTemporaryHealthCallback(function(value) moralebar:SetTempValue(value) end))

    table.insert(self.targetInfoCallbacks, TargetHandlerObject:AddTargetInfoCallback(function(value) 
        if value then
            valuebar:SetVisible(true)
            moralebar:SetMaxValue(value["MaxMorale"] or 1)
            moralebar:SetCurrentValueImmediate(value["Morale"] or 1)
            moralebar:SetTempValue(value["TemporaryMorale"] or 0)
        else
            valuebar:SetVisible(false)
        end
    end))

    table.insert(self.UI, valuebar)
    table.insert(self.tools, moralebar)

    self.currentHeight = self.currentHeight + data["Height"] + 2 * data["BorderSize"]
end