function PrimeUI:SetupTargetPowerBar(data, parent)
    local valuebar = Turbine.UI.Control()
    valuebar:SetParent(parent)
    if self.groupMode then
        valuebar:SetPosition(data["X"], data["Y"])
        valuebar.moveBox = MoveBox(valuebar, data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"], data["NickName"] or "Target Power Bar")
        valuebar.savePosition = function()
            data["X"], data["Y"] = valuebar:GetPosition()
        end
    else
        valuebar:SetPosition(self:ContentAlignement(data["Alignment"], data["Width"] + 2 * data["BorderSize"]), self.currentHeight)
    end
    valuebar:SetSize(data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"])
    valuebar:SetMouseVisible(false)
    valuebar:SetBackColor(self:ColourTupleToTurbineColour(data["BorderColour"]))
    valuebar:SetVisible(false)

    -- args (parent, x, y, width, height, textFormat, textAlignment, barAlignment, barColours, barbackground)
    local powerbar = ClassSpecificTools.PermanentBar(valuebar, data["BorderSize"], data["BorderSize"], data["Width"], data["Height"], data["Text"], Turbine.UI.ContentAlignment[data.TextAlignment], data["Alignment"], self:ColourTupleToTurbineColour(data["Colours"]), "bar25", self:FontToFont(data["Font"]), self:ColourTupleToTurbineColour(data["Interval_Colour"]), data["Intervals"])
    self.lookup[data.NickName or ""] = powerbar
    powerbar:SetMaxValue(1)
    powerbar:SetCurrentValue(1)
    
    if data["Smooth"] then
        table.insert(self.powerTargetCallbacks, TargetHandlerObject:AddPowerCallback(function(value) powerbar:SetCurrentValue(value) end))
    else
        table.insert(self.powerTargetCallbacks, TargetHandlerObject:AddPowerCallback(function(value) powerbar:SetCurrentValueImmediate(value) end))
    end

    table.insert(self.targetInfoCallbacks, TargetHandlerObject:AddTargetInfoCallback(function(value) 
        if value then
            valuebar:SetVisible(true)
            powerbar:SetCurrentValueImmediate(value["Power"] or 0)
            powerbar:SetCurrentValue(value["MaxPower"] or value["Power"] or 0)
        else
            valuebar:SetVisible(false)
        end
    end))

    table.insert(self.UI, valuebar)
    table.insert(self.tools, powerbar)

    self.currentHeight = self.currentHeight + data["Height"] + 2 * data["BorderSize"]
end