function PrimeUI:UnloadObject(returnData)
    
    self:FireTrigger("UNLOAD", PlayerHandlerObject:GetInfo())

    for name, callbackTable in pairs(self.skillCallbacks) do
        for key, callback in pairs(callbackTable) do
            RemoveCallback(SkillEventHandler, name, callback)
            self.skillCallbacks[name][key] = nil
        end
        self.skillCallbacks[name] = nil
    end

    for key, callback in pairs(self.eventTriggerCallbacks) do
        RemoveCallback(self, "EventTrigger", callback)
        self.eventTriggerCallbacks[key] = nil
    end

    for key, callbackPair in pairs(self.playerCallbacks) do
        RemoveCallback(self.player, callbackPair[1], callbackPair[2])
        self.playerCallbacks[key] = nil
    end

    for key, callback in pairs(self.effectAddedCallbacks) do
        RemoveCallback(PlayerEffectsHandler, "EffectAdded", callback)
        self.effectAddedCallbacks[key] = nil
    end

    for name, callbackTable in pairs(self.attrCallbacks) do
        for key, callback in pairs(callbackTable) do
            RemoveCallback(self.ClassAttr, name, callback)
            self.attrCallbacks[name][key] = nil
        end
        self.attrCallbacks[name] = nil 
    end
    
    for key, callback in pairs(self.effectRemovedCallbacks) do
        RemoveCallback(PlayerEffectsHandler, "EffectRemoved", callback)
        self.effectRemovedCallbacks[key] = nil
    end

    for key, callback in pairs(self.effectAddedGroupCallbacks) do
        RemoveCallback(GroupEffectsHandler, "EffectAdded", callback)
        self.effectAddedGroupCallbacks[key] = nil
    end

    for key, value in pairs(self.enemyChatCallback) do
        RemoveCallback(ChatEventHandler, "EnemyCombat", value)
        self.enemyChatCallback[key] = nil
    end

    for key, value in pairs(self.playerChatCallback) do
        RemoveCallback(ChatEventHandler, "PlayerCombat", value)
        self.playerChatCallback[key] = nil
    end

    for key, value in pairs(self.playerHealCallbacks) do
        RemoveCallback(ChatEventHandler, "PlayerHeal", value)
        self.playerHealCallbacks[key] = nil
    end

    for key, value in pairs(self.playerBenefitCallbacks) do
        RemoveCallback(ChatEventHandler, "PlayerBenefit", value)
        self.playerBenefitCallbacks[key] = nil
    end
    
    for key, value in pairs(self.sayChatCallback) do
        RemoveCallback(ChatEventHandler, "SayLine", value)
        self.sayChatCallback[key] = nil
    end

    for key, value in pairs(self.playerDispellCallback) do
        RemoveCallback(ChatEventHandler, "PlayerDispell", value)
        self.playerDispellCallback[key] = nil
    end
    
    for key, value in pairs(self.partyChatCallback) do
        RemoveCallback(ChatEventHandler, "PartyInfo", value)
        self.partyChatCallback[key] = nil
    end

    for key, value in pairs(self.partyInfoChatCallback) do
        RemoveCallback(ChatEventHandler, "Party", value)
        self.partyInfoChatCallback[key] = nil
    end
    
    for key, value in pairs(self.standardChatCallback) do
        RemoveCallback(ChatEventHandler, "Standard", value)
        self.standardChatCallback[key] = nil
    end

    for key, value in pairs(self.deathChatCallbacks) do
        RemoveCallback(ChatEventHandler, "Death", value)
        self.deathChatCallbacks[key] = nil
    end

    for key, value in pairs(self.defeatEventCallback) do
        RemoveCallback(ChatEventHandler, "DeathEvent", value)
        self.defeatEventCallback[key] = nil
    end

    for key, value in pairs(self.QuestAcceptedCallbacks) do
        RemoveCallback(ChatEventHandler, "QuestAccepted", value)
        self.QuestAcceptedCallbacks[key] = nil
    end

    for key, value in pairs(self.QuestOrDeedCompletedCallbacks) do
        RemoveCallback(ChatEventHandler, "QuestOrDeedCompleted", value)
        self.QuestOrDeedCompletedCallbacks[key] = nil
    end

    for key, value in pairs(self.QuestOrDeedProgress) do
        RemoveCallback(ChatEventHandler, "QuestOrDeedProgress", value)
        self.QuestOrDeedProgress[key] = nil
    end

    for key, value in pairs(self.NewDeedCallbacks) do
        RemoveCallback(ChatEventHandler, "NewDeed", value)
        self.NewDeedCallbacks[key] = nil
    end

    for key, value in pairs(self.instanceEventCallbacks) do
        RemoveCallback(InstanceController, "InstanceEvent", value)
        self.instanceEventCallbacks[key] = nil
    end

    for key, value in pairs(self.delvingEventCallbacks) do
        RemoveCallback(InstanceController, "DelvingEvent", value)
        self.delvingEventCallbacks[key] = nil
    end

    for key, value in pairs(self.fightEventStartCallbacks) do
        RemoveCallback(InstanceController, "FightEventStart", value)
        self.fightEventStartCallbacks[key] = nil
    end

    
    for key, value in pairs(self.fightEventEndCallbacks) do
        RemoveCallback(InstanceController, "FightEventEnd", value)
        self.fightEventEndCallbacks[key] = nil
    end

    for key, value in pairs(self.fightEventPhaseCallback) do
        RemoveCallback(InstanceController, "FightEventPhase", value)
        self.fightEventPhaseCallback[key] = nil
    end

    for key, value in pairs(self.effectTargetAddedCallbacks) do
        TargetHandlerObject:RemoveEffectCallback(value)
        self.effectTargetAddedCallbacks[key] = nil
    end

    for key, value in pairs(self.healthTargetCallbacks) do
        TargetHandlerObject:RemoveHealthCallback(value)
        self.healthTargetCallbacks[key] = nil
    end

    for key, value in pairs(self.temporaryHealthTargetCallbacks) do
        TargetHandlerObject:RemoveTemporaryHealthCallback(value)
        self.temporaryHealthTargetCallbacks[key] = nil
    end

    for key, value in pairs(self.powerTargetCallbacks) do
        TargetHandlerObject:RemovePowerCallback(value)
        self.powerTargetCallbacks[key] = nil
    end

    for key, value in pairs(self.targetInfoCallbacks) do
        TargetHandlerObject:RemoveTargetInfoCallback(value)
        self.targetInfoCallbacks[key] = nil
    end

    for key, value in pairs(self.playerMoraleHandlerCallbacks) do
        RemoveCallback(PlayerHandlerObject, "MoraleChanged", value)
        self.playerMoraleHandlerCallbacks[key] = nil
    end

    for key, value in pairs(self.playerMaxMoraleHandlerCallbacks) do
        RemoveCallback(PlayerHandlerObject, "MaxMoraleChanged", value)
        self.playerMaxMoraleHandlerCallbacks[key] = nil
    end

    for key, value in pairs(self.playerPowerHandlerCallbacks) do
        RemoveCallback(PlayerHandlerObject, "PowerChanged", value)
        self.playerPowerHandlerCallbacks[key] = nil
    end
    
    for key, value in pairs(self.playerMaxPowerHandlerCallbacks) do
        RemoveCallback(PlayerHandlerObject, "MaxPowerChanged", value)
        self.playerMaxPowerHandlerCallbacks[key] = nil
    end

    for key, value in pairs(self.playerTemporaryMoraleHandlerCallbacks) do
        RemoveCallback(PlayerHandlerObject, "TemporaryMoraleChanged", value)
        self.playerTemporaryMoraleHandlerCallbacks[key] = nil
    end

    for key, value in pairs(self.playerTemporaryPowerHandlerCallbacks) do
        RemoveCallback(PlayerHandlerObject, "TemporaryPowerChanged", value)
        self.playerTemporaryPowerHandlerCallbacks[key] = nil
    end

    for key, value in pairs(self.playerLevelHandlerCallbacks) do
        RemoveCallback(PlayerHandlerObject, "LevelChanged", value)
        self.playerLevelHandlerCallbacks[key] = nil
    end

    for key, value in pairs(self.petInfoCallbacks) do
        RemoveCallback(PlayerHandlerObject, "PetInfo", value)
        self.petInfoCallbacks[key] = nil
    end

    for key, value in pairs(self.petMoraleCallbacks) do
        RemoveCallback(PlayerHandlerObject, "PetMoraleChanged", value)
        self.petMoraleCallbacks[key] = nil
    end

    for key, value in pairs(self.petTemporaryMoraleCallbacks) do
        RemoveCallback(PlayerHandlerObject, "PetTemporaryMoraleChanged", value)
        self.petTemporaryMoraleCallbacks[key] = nil
    end
    
    for key, callback in pairs(self.combatCallbacks) do
        RemoveCallback(self.player, "InCombatChanged", callback)
        self.playerCallbacks[key] = nil
    end

    for key, callback in pairs(self.eventTriggerCallbacks) do
        RemoveCallback(self, "EventTrigger", callback)
        self.eventTriggerCallbacks[key] = nil
    end

    for key, callback in pairs(self.effectCategoryAddedCallback) do
        RemoveCallback(self, "CategoryAdded", callback)
        self.effectCategoryAddedCallback[key] = nil
    end

    for key, callback in pairs(self.effectCategoryRemovedCallback) do
        RemoveCallback(self, "CategoryRemoved", callback)
        self.effectCategoryRemovedCallback[key] = nil
    end

    
    for key, callback in pairs(self.dnfAppliedCallbacks) do
        RemoveCallback(rezTracker, "DNFApplication", callback)
        self.dnfAppliedCallbacks[key] = nil
    end

    
    for key, callback in pairs(self.dnfRemovedCallbacks) do
        RemoveCallback(rezTracker, "DNRRemoval", callback)
        self.dnfRemovedCallbacks[key] = nil
    end

    for key, callback in pairs(self.pvpCallbacks) do
        RemoveCallback(InstanceController, "PvpInfo", callback)
        self.pvpCallbacks[key] = nil
    end

    for key, callback in pairs(self.locationCallbacks) do
        RemoveCallback(LocationHandler, "Location", callback)
        self.locationCallbacks[key] = nil
    end

    for key, callback in pairs(self.actionCallbacks) do
        RemoveCallback(ActionHandlerObject, "Action", callback)
        self.actionCallbacks[key] = nil
    end

    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
    self.updateCallback = nil

    for key, tool in pairs(self.tools) do
        tool:Unload()
        tool:SetVisible(false)
        self.tools[key] = nil
    end

    for key, UI in pairs(self.UI) do
        if UI.SetStretchMode then UI:SetStretchMode(nil) end
        UI:SetParent(nil)
        UI:SetVisible(false)
        self.UI[key] = nil
    end

    if self.moveBox then 
        self.moveBox:Unload() 
        self.moveBox = nil
    end

    self.currentHeight = 0

    self.skillCallbacks = nil
    self.playerCallbacks = nil
    self.attrCallbacks = nil
    self.effectAddedCallbacks = nil
    self.effectRemovedCallbacks = nil
    self.playerChatCallback = nil
    self.enemyChatCallback = nil
    self.sayChatCallback = nil
    self.sayInfoChatCallback = nil
    self.partyChatCallback = nil
    self.partyInfoChatCallback = nil
    self.standardChatCallback = nil
    self.timers = nil
    self.icons = nil
    self.effectAddedGroupCallbacks = nil
    self.deathChatCallbacks = nil
    self.instanceEventCallbacks = nil
    self.fightEventStartCallbacks = nil
    self.fightEventEndCallbacks = nil
    self.effectTargetAddedCallbacks = nil
    self.healthTargetCallbacks = nil
    self.temporaryHealthTargetCallbacks = nil
    self.powerTargetCallbacks = nil
    self.targetInfoCallbacks = nil
    self.combatCallbacks = nil
    self.playerBenefitCallbacks = nil
    self.playerHealCallbacks = nil
    self.playerMoraleHandlerCallbacks = nil
    self.playerMaxMoraleHandlerCallbacks = nil
    self.playerPowerHandlerCallbacks = nil
    self.playerMaxPowerHandlerCallbacks = nil
    self.playerTemporaryMoraleHandlerCallbacks = nil
    self.playerTemporaryPowerHandlerCallbacks = nil
    self.playerLevelHandlerCallbacks = nil
    self.playerCombatHandlerCallbacks = nil
    self.eventTriggerCallbacks = nil
    self.effectCategoryAddedCallback = nil
    self.effectCategoryRemovedCallback = nil
    self.dnfAppliedCallbacks = nil
    self.dnfRemovedCallbacks = nil
    self.petMoraleCallbacks = nil
    self.petTemporaryMoraleCallbacks = nil
    self.petInfoCallbacks = nil
    self.playerDispellCallback = nil
    self.QuestAcceptedCallbacks = nil
    self.QuestOrDeedCompletedCallbacks = nil
    self.QuestOrDeedProgress = nil
    self.NewDeedCallbacks = nil
    self.pvpCallbacks = nil
    self.locationCallbacks = nil
    self.delvingEventCallbacks = nil
    self.actionCallbacks = nil
    self.args = nil
    self.userVars = nil

    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end

    collectgarbage()

    self.timers = {}
    self.icons = {}
    self.skillCallbacks = {}
    self.playerCallbacks = {}
    self.attrCallbacks = {}
    self.effectAddedCallbacks = {}
    self.effectRemovedCallbacks = {}
    self.playerChatCallback = {}
    self.enemyChatCallback = {}
    self.sayChatCallback = {}
    self.sayInfoChatCallback = {}
    self.partyChatCallback = {}
    self.partyInfoChatCallback = {}
    self.standardChatCallback = {}
    self.effectAddedGroupCallbacks = {}
    self.deathChatCallbacks = {}
    self.instanceEventCallbacks = {}
    self.fightEventStartCallbacks = {}
    self.fightEventPhaseCallback = {}
    self.fightEventEndCallbacks = {}
    self.effectTargetAddedCallbacks = {}
    self.healthTargetCallbacks = {}
    self.temporaryHealthTargetCallbacks = {}
    self.powerTargetCallbacks = {}
    self.targetInfoCallbacks = {}
    self.combatCallbacks = {}
    self.playerBenefitCallbacks = {}
    self.playerHealCallbacks = {}
    self.playerMoraleHandlerCallbacks = {}
    self.playerMaxMoraleHandlerCallbacks = {}
    self.playerPowerHandlerCallbacks = {}
    self.playerMaxPowerHandlerCallbacks = {}
    self.playerTemporaryMoraleHandlerCallbacks = {}
    self.playerTemporaryPowerHandlerCallbacks = {}
    self.playerLevelHandlerCallbacks = {}
    self.playerCombatHandlerCallbacks = {}
    self.eventTriggerCallbacks = {}
    self.defeatEventCallback = {}
    self.effectCategoryAddedCallback = {}
    self.effectCategoryRemovedCallback = {}
    self.dnfAppliedCallbacks = {}
    self.dnfRemovedCallbacks = {}
    self.petMoraleCallbacks = {}
    self.petTemporaryMoraleCallbacks = {}
    self.petInfoCallbacks = {}
    self.playerDispellCallback = {}
    self.QuestAcceptedCallbacks = {}
    self.QuestOrDeedCompletedCallbacks = {}
    self.QuestOrDeedProgress = {}
    self.NewDeedCallbacks = {}
    self.pvpCallbacks = {}
    self.locationCallbacks = {}
    self.delvingEventCallbacks = {}
    self.actionCallbacks = {}
    self.userVars = {}
    self.args = {}

    self.loaded = false

    if returnData then
        return self.codeData
    end
end

function PrimeUI:DeleteObject()
    self:SetParent(nil)
    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    for key, _ in pairs(self) do
        self[key] = nil
    end
    collectgarbage()
end