function PrimeUI:SetupWrathBar(data, parent)
    local valuebar = Turbine.UI.Control()
    valuebar:SetParent(parent)
    if self.groupMode then
        valuebar:SetPosition(data["X"], data["Y"])
        valuebar.moveBox = MoveBox(valuebar, data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"], data["NickName"] or "Wrath Bar")
        valuebar.savePosition = function()
            data["X"], data["Y"] = valuebar:GetPosition()
        end
    else
        valuebar:SetPosition(self:ContentAlignement(data["Alignment"], data["Width"] + 2 * data["BorderSize"]), self.currentHeight)
    end
    valuebar:SetSize(data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"])
    valuebar:SetMouseVisible(false)
    valuebar:SetBackColor(self:ColourTupleToTurbineColour(data["BorderColour"]))
    
    -- args (parent, x, y, width, height, textFormat, textAlignment, barAlignment, barColours, barbackground)
    local wrathBar = ClassSpecificTools.PermanentBar(valuebar, data["BorderSize"], data["BorderSize"], data["Width"], data["Height"], data["Text"], Turbine.UI.ContentAlignment[data.TextAlignment], data["Alignment"], self:ColourTupleToTurbineColour(data["Colours"]), "bar25", self:FontToFont(data["Font"]), self:ColourTupleToTurbineColour(data["Interval_Colour"]), data["Intervals"])
    self.lookup[data.NickName or ""] = wrathBar
    if self.playerClass == Turbine.Gameplay.Class.Beorning then
        wrathBar:SetMaxValue(100)
        wrathBar:SetCurrentValue(self.ClassAttr:GetWrath())
        if data["Smooth"] then
            if not(self.attrCallbacks["WrathChanged"]) then self.attrCallbacks["WrathChanged"] = {} end
            table.insert(self.attrCallbacks["WrathChanged"], AddCallback(self.ClassAttr, "WrathChanged", function(sender, args) wrathBar:SetCurrentValue( self.ClassAttr:GetWrath() ) end))
        else
            if not(self.attrCallbacks["WrathChanged"]) then self.attrCallbacks["WrathChanged"] = {} end
            table.insert(self.attrCallbacks["WrathChanged"], AddCallback(self.ClassAttr, "WrathChanged", function(sender, args) wrathBar:SetCurrentValueImmediate( self.ClassAttr:GetWrath() ) end))
        end
        wrathBar:SetCurrentValue( self.ClassAttr:GetWrath() )
    end

    table.insert(self.UI, valuebar)
    table.insert(self.tools, wrathBar)

    self.currentHeight = self.currentHeight + data["Height"] + 2 * data["BorderSize"]
end