NumericalInput = class(Turbine.UI.TreeNode)
function NumericalInput:Constructor(width, text, currentValue, changeFunction)
    Turbine.UI.TreeNode.Constructor(self)
    self.width = width

    self:SetSize(self.width, 22)
    self:SetPosition(0, 0)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBlock = Turbine.UI.Control()
    self.innerBlock:SetParent(self)
    self.innerBlock:SetSize(self.width, 20)
    self.innerBlock:SetPosition(1, 1)
    self.innerBlock:SetBackColor(Turbine.UI.Color(0.01,0.31,0.31))

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.innerBlock)
    self.label:SetSize(150, 20)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(text)
    
    self.searchBar = Turbine.UI.Lotro.TextBox()
    self.searchBar:SetParent(self.innerBlock)
    self.searchBar:SetSize(100, 20)
    self.searchBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.searchBar:SetPosition(150, 0)
    self.searchBar:SetText(currentValue)
    
    self.searchBar.TextChanged = function()
        if tonumber(self.searchBar:GetText()) then
            changeFunction(tonumber(self.searchBar:GetText())) 
        end        
    end
end

function NumericalInput:SetValue(value)
    self.searchBar:SetText(tonumber(tostring(value)))
end

StringInput = class(Turbine.UI.TreeNode)
function StringInput:Constructor(width, text, currentValue, big, changeFunction)
    Turbine.UI.TreeNode.Constructor(self)
    self.width = width

    self.height = 22

    if big then self.height = 102 end

    self:SetSize(self.width, self.height)
    self:SetPosition(0, 0)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBlock = Turbine.UI.Control()
    self.innerBlock:SetParent(self)
    self.innerBlock:SetSize(self.width, self.height - 2)
    self.innerBlock:SetPosition(1, 1)
    self.innerBlock:SetBackColor(Turbine.UI.Color(0.01,0.31,0.31))

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.innerBlock)
    self.label:SetSize(150, 20)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(text)
    
    self.searchBar = Turbine.UI.Lotro.TextBox()
    self.searchBar:SetParent(self.innerBlock)
    if big then
        self.searchBar:SetSize(300, 100)
    else
        self.searchBar:SetSize(100, 20)
    end    
    self.searchBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.searchBar:SetPosition(150, 0)
    self.searchBar:SetText(currentValue)
    
    self.searchBar.TextChanged = function()
        changeFunction(tostring(self.searchBar:GetText()))     
    end
end

StringButtonInput = class(Turbine.UI.TreeNode)
function StringButtonInput:Constructor(width, text, currentValue, changeFunction)
    Turbine.UI.TreeNode.Constructor(self)
    self.width = width

    self.height = 400

    self:SetSize(self.width, self.height)
    self:SetPosition(0, 0)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBlock = Turbine.UI.Control()
    self.innerBlock:SetParent(self)
    self.innerBlock:SetSize(self.width, self.height - 2)
    self.innerBlock:SetPosition(1, 1)
    self.innerBlock:SetBackColor(Turbine.UI.Color(0.01,0.31,0.31))

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.innerBlock)
    self.label:SetSize(150, 20)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(text)
    
    self.searchBar = Turbine.UI.Lotro.TextBox()
    self.searchBar:SetParent(self.innerBlock)
    self.searchBar:SetSize(400, 400) 
    self.searchBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.searchBar:SetPosition(100, 0)
    self.searchBar:SetText(currentValue)

    self.inputButton = Turbine.UI.Lotro.Button()
    self.inputButton:SetParent(self.innerBlock)
	self.inputButton:SetSize(100, 20)
	self.inputButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.inputButton:SetPosition(0, 20)
    self.inputButton:SetText("Change")

    self.inputButton.Click = function()
        changeFunction(tostring(self.searchBar:GetText()))
    end
end

IconInput = class(Turbine.UI.TreeNode)
function IconInput:Constructor(width, text, currentValue, options, changeFunction)
    Turbine.UI.TreeNode.Constructor(self)
    self.width = width

    self:SetSize(self.width, 42)
    self:SetPosition(0, 0)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBlock = Turbine.UI.Control()
    self.innerBlock:SetParent(self)
    self.innerBlock:SetSize(self.width, 40)
    self.innerBlock:SetPosition(1, 1)
    self.innerBlock:SetBackColor(Turbine.UI.Color(0.01,0.31,0.31))

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.innerBlock)
    self.label:SetSize(150, 20)
    self.label:SetPosition(0, 10)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(text)
    
    self.EffectTimerIconBox = Turbine.UI.Control()
    self.EffectTimerIconBox:SetParent(self.innerBlock)
    self.EffectTimerIconBox:SetPosition(50, 4)
    self.EffectTimerIconBox:SetSize(32,32)
    self.EffectTimerIconBox:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.EffectTimerIconBox:SetBackground(BackgroundHandler:GetBackground(tonumber(currentValue) or currentValue))
    self.EffectTimerIconBox:SetVisible(true)

    self.TimerIconTextBox = Turbine.UI.Lotro.TextBox()
    self.TimerIconTextBox:SetParent(self.innerBlock)
    self.TimerIconTextBox:SetSize(250, 20)
    self.TimerIconTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.TimerIconTextBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.TimerIconTextBox:SetMouseVisible(false)
    self.TimerIconTextBox:SetPosition(90, 10)
    self.TimerIconTextBox:SetMultiline(false)
    self.TimerIconTextBox:SetText(currentValue)

    self.EffectTimerIconBox.MouseClick = function()
        local iconWindow = options:GetIconWindow()
        iconWindow:SetVisible(true) 
        iconWindow:Register(self.EffectTimerIconBox, self.TimerIconTextBox)
    end

    self.EffectTimerIconBox.MouseDoubleClick = function()
        self.EffectTimerIconBox:SetBackground(BackgroundHandler:GetBackground(0x41007F41))
        self.TimerIconTextBox:SetText(0x41007F41)
    end

    self.Button = Turbine.UI.Lotro.Button()
    self.Button:SetParent(self)
    self.Button:SetSize(150, 10)
    self.Button:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.Button:SetMouseVisible(false)
    self.Button:SetPosition(345, 10)
    self.Button:SetText("Set New Icon")

    self.Button.Click = function()
        changeFunction(tostring(self.TimerIconTextBox:GetText()))
    end
end

BoolInput = class(Turbine.UI.TreeNode)
function BoolInput:Constructor(width, text, currentValue, changeFunction, backgroundColour)
    Turbine.UI.TreeNode.Constructor(self)
    self.width = width

    self:SetSize(self.width, 22)
    self:SetPosition(0, 0)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBlock = Turbine.UI.Control()
    self.innerBlock:SetParent(self)
    self.innerBlock:SetSize(self.width, 20)
    self.innerBlock:SetPosition(1, 1)
    self.innerBlock:SetBackColor(backgroundColour or Turbine.UI.Color(0.01,0.31,0.31))

    self.label = Turbine.UI.Lotro.CheckBox()
    self.label:SetParent(self.innerBlock)
    self.label:SetSize(width, 20)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(text)
    self.label:SetChecked(currentValue)
    
    self.label.CheckedChanged = function()
        changeFunction(self.label:IsChecked())    
    end
end

function BoolInput:SetChecked(value)
    self.label:SetChecked(value)
end

function BoolInput:IsChecked()
    return self.label:IsChecked()
end

FontInput = class(Turbine.UI.TreeNode)
function FontInput:Constructor(width, text, currentValue, changeFunction)
    Turbine.UI.TreeNode.Constructor(self)
    self.width = width

    self:SetSize(self.width, 22)
    self:SetPosition(0, 0)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBlock = Turbine.UI.Control()
    self.innerBlock:SetParent(self)
    self.innerBlock:SetSize(self.width, 20)
    self.innerBlock:SetPosition(1, 1)
    self.innerBlock:SetBackColor(Turbine.UI.Color(0.01,0.31,0.31))

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.innerBlock)
    self.label:SetSize(150, 20)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(text)

    local menu = Turbine.UI.ContextMenu()
    local menuItems = menu:GetItems()

    local sortedKeys = {}
    for key, _ in pairs(Turbine.UI.Lotro.Font) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )

    self.Button = Turbine.UI.Lotro.Button()
    self.Button:SetParent(self)
    self.Button:SetSize(150, 100)
    self.Button:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.Button:SetMouseVisible(false)
    self.Button:SetPosition(150, 0)
    self.Button:SetText(currentValue)

    for key, name in pairs(sortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            self.Button:SetText(name)
            changeFunction(name)
        end
        
        menuItems:Add(menuItem)
    end

    self.Button.Click = function()
        menu:ShowMenu()
    end
end

AlignmentInput = class(Turbine.UI.TreeNode)
function AlignmentInput:Constructor(width, text, currentValue, options, changeFunction)
    Turbine.UI.TreeNode.Constructor(self)
    self.width = width

    self:SetSize(self.width, 22)
    self:SetPosition(0, 0)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBlock = Turbine.UI.Control()
    self.innerBlock:SetParent(self)
    self.innerBlock:SetSize(self.width, 20)
    self.innerBlock:SetPosition(1, 1)
    self.innerBlock:SetBackColor(Turbine.UI.Color(0.01,0.31,0.31))

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.innerBlock)
    self.label:SetSize(250, 20)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(text)

    local menu = Turbine.UI.ContextMenu()
    local menuItems = menu:GetItems()

    local sortedKeys = {}
    for key, _ in pairs(options) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )

    self.Button = Turbine.UI.Lotro.Button()
    self.Button:SetParent(self)
    self.Button:SetSize(150, 100)
    self.Button:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.Button:SetMouseVisible(false)
    self.Button:SetPosition(250, 0)
    self.Button:SetText(currentValue)

    for key, name in pairs(sortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            self.Button:SetText(name)
            changeFunction(name)
        end
        
        menuItems:Add(menuItem)
    end

    self.Button.Click = function()
        menu:ShowMenu()
    end
end

ButtonInput = class(Turbine.UI.TreeNode)
function ButtonInput:Constructor(width, text, func)
    Turbine.UI.TreeNode.Constructor(self)
    self.width = width

    self:SetSize(self.width, 22)
    self:SetPosition(0, 0)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBlock = Turbine.UI.Control()
    self.innerBlock:SetParent(self)
    self.innerBlock:SetSize(self.width, 20)
    self.innerBlock:SetPosition(1, 1)
    self.innerBlock:SetBackColor(Turbine.UI.Color(0.01,0.31,0.31))

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.innerBlock)
    self.label:SetSize(150, 20)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(text)
    
    self.button = Turbine.UI.Lotro.Button()
    self.button:SetParent(self.innerBlock)
    self.button:SetSize(300, 20)
    self.button:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.button:SetPosition(150, 0)
    
    self.button.Click = function()
        func()     
    end
end

function ButtonInput:SetText(text)
    self.button:SetText(text)
end

function ButtonInput:GetText()
    return self.button:GetText()
end

HeaderNode = class(Turbine.UI.TreeNode)
function HeaderNode:Constructor(width, text, alignment, font, backgroundColour)
    Turbine.UI.TreeNode.Constructor(self)
    self.width = width

    self:SetSize(self.width, 27)
    self:SetPosition(0, 0)
    self:SetMouseVisible(true)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBlock = Turbine.UI.Control()
    self.innerBlock:SetParent(self)
    self.innerBlock:SetSize(self.width, 25)
    self.innerBlock:SetPosition(1, 1)
    self.innerBlock:SetBackColor(backgroundColour or Turbine.UI.Color(0.01,0.31,0.31))
    self.innerBlock:SetMouseVisible(false)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.innerBlock)
    self.label:SetSize(width, 25)
    self.label:SetFont(font or Turbine.UI.Lotro.Font.BookAntiquaBold22)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetTextAlignment(alignment or Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(text)
    self.label:SetMouseVisible(false)
end