function CreateTriggerListBox(width, triggerType, listboxItems, UIType, func, optionPage)
    local headerNode = Turbine.UI.TreeNode()
    headerNode:SetMouseVisible(false)
    headerNode:SetSize(width, 20)

    -- The header label with the trigger name
    headerNode.label = Turbine.UI.Label()
    headerNode.label:SetParent(headerNode)
    headerNode.label:SetSize(width, 20)
    headerNode.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    headerNode.label:SetPosition(0, 0)
    headerNode.label:SetText(string.format("%s (%s)", triggerType, tostring(tablelength(listboxItems))))
    headerNode.label:SetBackColor(Turbine.UI.Color.Black)

    local optionsTreeNode = headerNode:GetChildNodes()

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

   local optionsHeight = 0
   local listboxHeight = 350

    valuebar.optionsControl = Turbine.UI.Control()
	valuebar.optionsControl:SetParent(valuebar)
    valuebar.optionsControl:SetPosition(0, 0)
    valuebar.optionsControl:SetBackColor(Turbine.UI.Color.DarkSlateGray)

    valuebar.nameTextBox = Turbine.UI.Lotro.TextBox()
    valuebar.nameTextBox:SetParent(valuebar.optionsControl)
    valuebar.nameTextBox:SetSize(width - 50, 20)
    valuebar.nameTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.nameTextBox:SetPosition(0, optionsHeight)

    -- Set the correct name for the name text box
    if string.find(triggerType, "Effect") then
        valuebar.nameTextBox:SetText("Effect Name")
    elseif string.find(triggerType, "Skills") then
        valuebar.nameTextBox:SetText("Skill Name")
    elseif string.find(triggerType, "Target_HealthThreshold") then
        valuebar.nameTextBox:SetText("Target Name")
    elseif string.find(triggerType, "Hits") then
        valuebar.nameTextBox:SetText("Hit Name")
    elseif string.find(triggerType, "Chat") then
        valuebar.nameTextBox:SetText("Phrase")
    elseif string.find(triggerType, "HealthThreshold")  or string.find(triggerType, "Fight")  or string.find(triggerType, "DNF") or triggerType == "Corruption" or string.find(triggerType, "Resource") then
        valuebar.nameTextBox:SetVisible(false)
    elseif string.find(triggerType, "Player") then
        valuebar.nameTextBox:SetText("Skill Name")
    elseif string.find(triggerType, "CCBreak")  then
        valuebar.nameTextBox:SetText("Target Name (or empty for all names)")
    elseif string.find(triggerType, "Action")  then
        valuebar.nameTextBox:SetText("Action code (use the the overview)")
    else
        valuebar.nameTextBox:SetText("Name")
    end

    -- Create the time input box
    if (UIType ~= "Conditions" or (UIType == "Conditions" and triggerType == "EventTrigger")) and UIType ~= "Event Keyword" and UIType ~= "Counter" and UIType ~= "Icon" and UIType ~= "Note Event" and UIType ~= "Sound" and UIType ~= "Text" and UIType ~= "MoraleBar" and  UIType ~= "Note Activation" and not(string.find(triggerType, "Highlight_On_Effect")) and triggerType ~= "Effect_BlackList" and UIType ~= "User Variables" then
        valuebar.timeBar = Turbine.UI.Lotro.TextBox()
        valuebar.timeBar:SetParent(valuebar.optionsControl)
        valuebar.timeBar:SetSize(50, 20)
        valuebar.timeBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.timeBar:SetPosition(width - 50, optionsHeight)
        valuebar.timeBar:SetText("Time")
    end

    if UIType == "Conditions" and triggerType == "EventTrigger" then
        optionsHeight = optionsHeight + 25
        valuebar.conditionEventBox = Turbine.UI.Lotro.TextBox()
        valuebar.conditionEventBox:SetParent(valuebar.optionsControl)
        valuebar.conditionEventBox:SetSize(300, 20)
        valuebar.conditionEventBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.conditionEventBox:SetPosition(0, optionsHeight)
        valuebar.conditionEventBox:SetText("Condition Name")
    end

    -- Handle fight as name input
    if string.find(triggerType, "Fight") and InstanceController then
        valuebar.fightButton = Turbine.UI.Lotro.Button()
        valuebar.fightButton:SetParent(valuebar.optionsControl)
        valuebar.fightButton:SetSize(300, 20)
        valuebar.fightButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.fightButton:SetPosition(0, optionsHeight)
        valuebar.fightButton:SetText("Fight Name")
    
    
        valuebar.fightMenu = Turbine.UI.ContextMenu()
        valuebar.fightMenuItems = valuebar.fightMenu:GetItems()
        for key, _ in spairs(InstanceController:GetFightNames(), function(t, a, b) return a < b end) do
            local menuItem = Turbine.UI.MenuItem( key )
            valuebar.fightMenuItems:Add(menuItem)
            menuItem.Click = function()
                valuebar.fightButton:SetText(key)
            end
        end

        local allMenuItem = Turbine.UI.MenuItem( "All" )
        valuebar.fightMenuItems:Add(allMenuItem)
        allMenuItem.Click = function()
            valuebar.fightButton:SetText("All" )
        end
    
        valuebar.fightButton.Click = function()
            valuebar.fightMenu:ShowMenu()
        end
    end

    optionsHeight = optionsHeight + 25

    if UIType == "Conditions" and not(triggerType == "Location" or triggerType == "Resource" or triggerType == "HealthThreshold" or triggerType == "FightPhase") then
        valuebar.notAppliedCheckbox = Turbine.UI.Lotro.CheckBox()
        valuebar.notAppliedCheckbox:SetParent(valuebar.optionsControl)
        valuebar.notAppliedCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        if triggerType == "Effects" then
            valuebar.notAppliedCheckbox:SetText("When not applied")
        elseif triggerType == "Skill_Ready" then
            valuebar.notAppliedCheckbox:SetText("When not ready")
        else
            valuebar.notAppliedCheckbox:SetText("When not valid")
        end
        valuebar.notAppliedCheckbox:SetPosition(width - 150, optionsHeight + 20)
        valuebar.notAppliedCheckbox:SetSize(250, 20)
    end

    if UIType == "Conditions" and triggerType == "Effects" then

        valuebar.applicationTextBar = Turbine.UI.Label()
        valuebar.applicationTextBar:SetParent(valuebar.optionsControl)
        valuebar.applicationTextBar:SetSize(100, 20)
        valuebar.applicationTextBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.applicationTextBar:SetPosition(width - 150, optionsHeight)
        valuebar.applicationTextBar:SetText("Instances")

        valuebar.applicationTextBarInfoButton = InfoButton(valuebar.optionsControl, width, width - 70, optionsHeight + 2, "The minimal amount of applications of this effect needed to set this trigger to true.", optionPage.infoWindow)

        valuebar.applicationBar = Turbine.UI.Lotro.TextBox()
        valuebar.applicationBar:SetParent(valuebar.optionsControl)
        valuebar.applicationBar:SetSize(50, 20)
        valuebar.applicationBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.applicationBar:SetPosition(width - 50, optionsHeight)
        valuebar.applicationBar:SetText("1")
    end

    -- Browse button input box
    if string.find(triggerType, "Effect") then
        valuebar.effectBrowseButton = Turbine.UI.Lotro.Button()
        valuebar.effectBrowseButton:SetParent(valuebar.optionsControl)
        valuebar.effectBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.effectBrowseButton:SetPosition(0, optionsHeight)
        valuebar.effectBrowseButton:SetText("Browse Encountered Effects")
        valuebar.effectBrowseButton:SetSize(500, 20)

        valuebar.effectBrowseButton.Click = function()
            local effectWindow = optionPage:GetEffectWindow()
            effectWindow:SetVisible(true) 
            effectWindow:Register(valuebar.nameTextBox)
        end
    elseif string.find(triggerType, "Skill") then
        valuebar.skillBrowseButton = Turbine.UI.Lotro.Button()
        valuebar.skillBrowseButton:SetParent(valuebar.optionsControl)
        valuebar.skillBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.skillBrowseButton:SetPosition(0, optionsHeight)
        valuebar.skillBrowseButton:SetText("Browse Detected Skills")
        valuebar.skillBrowseButton:SetSize(500, 20)

        valuebar.skillBrowseButton.Click = function()
            local skillWindow = optionPage:GetSkillWindow()
            skillWindow:SetVisible(true) 
            skillWindow:Register(valuebar.nameTextBox)
        end
    elseif string.find(triggerType, "Threshold") or triggerType == "Resource" then
        valuebar.thresholdBrowseButton = Turbine.UI.Lotro.Button()
        valuebar.thresholdBrowseButton:SetParent(valuebar.optionsControl)
        valuebar.thresholdBrowseButton:SetSize(100, 20)
        valuebar.thresholdBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.thresholdBrowseButton:SetPosition(0, optionsHeight)
        valuebar.thresholdBrowseButton:SetText("<=")

        valuebar.thresholdBrowseMenu = Turbine.UI.ContextMenu()
        valuebar.thresholdBrowseMenuItems = valuebar.thresholdBrowseMenu :GetItems()

        local leqItem = Turbine.UI.MenuItem("<=")
        valuebar.thresholdBrowseMenuItems:Add(leqItem)
        leqItem.Click = function()
            valuebar.thresholdBrowseButton:SetText("<=")
        end

        local moqItem = Turbine.UI.MenuItem(">=")
        valuebar.thresholdBrowseMenuItems:Add(moqItem)
        moqItem.Click = function()
            valuebar.thresholdBrowseButton:SetText(">=")
        end
    
        valuebar.thresholdBrowseButton.Click = function()
            valuebar.thresholdBrowseMenu:ShowMenu()
        end

        valuebar.thresholdNumberTextBox = Turbine.UI.Lotro.TextBox()
        valuebar.thresholdNumberTextBox:SetParent(valuebar.optionsControl)
        valuebar.thresholdNumberTextBox:SetSize(200, 20)
        valuebar.thresholdNumberTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.thresholdNumberTextBox:SetPosition(120, optionsHeight)
        if triggerType == "Resource" then
            valuebar.thresholdNumberTextBox:SetText("Threshold value")
        else
            valuebar.thresholdNumberTextBox:SetText("Percentage")
        end

        valuebar.thresholdOperatorInforButton = InfoButton(valuebar.optionsControl, width, 100, optionsHeight + 2, "This is the operator which is used to judge if a certain threshold has been reached or passed. The options are less or equal \"<=\" or more or equal \">=\".", optionPage.infoWindow)
    elseif string.find(triggerType, "Action") then
        valuebar.actionBrowseButton = Turbine.UI.Lotro.Button()
        valuebar.actionBrowseButton:SetParent(valuebar.optionsControl)
        valuebar.actionBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.actionBrowseButton:SetPosition(0, optionsHeight)
        valuebar.actionBrowseButton:SetText("Browse Actions")
        valuebar.actionBrowseButton:SetSize(500, 20)

        valuebar.actionMenu = UI.DropDownMenuControl(self, 340, "Actions Menu")
        for key, value in spairs(Turbine.UI.Lotro.Action, function(t, a, b) return a < b end) do
            valuebar.actionMenu:AddItem(key, 
            function()
                valuebar.nameTextBox:SetText(value)
                valuebar.actionMenu:SetVisible(false)
            end)
        end

        valuebar.actionBrowseButton.Click = function()
            valuebar.actionMenu:ToggleVisible() 
        end 

        optionsHeight = optionsHeight + 25
    end

    if UIType ~= "Counter" and UIType ~= "Conditions" and UIType ~= "Event Keyword" and UIType ~= "Icon" and UIType ~= "Text" and UIType ~= "Note Event" and UIType ~= "Sound" and ((string.find(triggerType, "Effect") and not(string.find(triggerType, "Highlight_On_Effect"))) or string.find(triggerType, "Skill")) and UIType ~= "MoraleBar" and triggerType ~= "Effect_BlackList" and  UIType ~= "Note Activation" or string.find(triggerType, "DNF")  then
        -- Get time for effect or skill
        valuebar.timerCheckBox = Turbine.UI.Lotro.CheckBox()
        valuebar.timerCheckBox:SetParent(valuebar.optionsControl)
        valuebar.timerCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        if string.find(triggerType, "Skill") then
            valuebar.timerCheckBox:SetText("Use skill cooldown as time")
            valuebar.timerCheckBox:SetPosition(width - 250, optionsHeight)
            valuebar.timerCheckBox:SetSize(250, 20)
        else
            valuebar.timerCheckBox:SetText("Use duration as time")
            valuebar.timerCheckBox:SetPosition(width - 200, optionsHeight)
            valuebar.timerCheckBox:SetSize(200, 20)
        end        
    end

    if string.find(triggerType, "Highlight_On_Effect") and UIType == "SkillLabel" then
        -- Get time for effect or skill
        valuebar.skillLabelHighlightBox = Turbine.UI.Lotro.CheckBox()
        valuebar.skillLabelHighlightBox:SetParent(valuebar.optionsControl)
        valuebar.skillLabelHighlightBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.skillLabelHighlightBox:SetText("Invert")
        valuebar.skillLabelHighlightBox:SetPosition(width - 200, optionsHeight)
        valuebar.skillLabelHighlightBox:SetSize(200, 20)
    end

    if string.find(triggerType, "Effect") or string.find(triggerType, "Skill") or string.find(triggerType, "Threshold") or string.find(triggerType, "DNF") then 
        optionsHeight = optionsHeight + 25
    end

    -- Add text box option
    if UIType == "Circle Timer" or UIType == "TimerGroup" or UIType == "Alert" or UIType == "AlertGroup" then
        valuebar.shownTextInputBox = Turbine.UI.Lotro.TextBox()
        valuebar.shownTextInputBox:SetParent(valuebar.optionsControl)
        valuebar.shownTextInputBox:SetSize(width - 16, 20)
        valuebar.shownTextInputBox:SetPosition(0, optionsHeight)
        valuebar.shownTextInputBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        if string.find(UIType, "Timer") then
            valuebar.shownTextInputBox:SetText("Text shown on Timer")
        else
            valuebar.shownTextInputBox:SetText("Text")
        end

        valuebar.showTextInfoButton = InfoButton(valuebar.optionsControl, width, width - 16, optionsHeight + 2, "Using \"<name>\" as your timer text will in applicable cases replace this part of the text with the name of the target of this trigger type. \nFor the CCBreak trigger you can instead use \"<Target>\", \"<Type>\" and/or \"<Culprit>\" to get the cc break target, the cc type that was broken and the source of the cc break respectively.", optionPage.infoWindow)
    end

    if UIType == "Note Event" then
        valuebar.noteEventTriggerIntputBox = Turbine.UI.Lotro.TextBox()
        valuebar.noteEventTriggerIntputBox:SetParent(valuebar.optionsControl)
        valuebar.noteEventTriggerIntputBox:SetSize(width - 16, 20)
        valuebar.noteEventTriggerIntputBox:SetPosition(0, optionsHeight)
        valuebar.noteEventTriggerIntputBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.noteEventTriggerIntputBox:SetText("Note Event Trigger")
    end

    if UIType == "Note Activation" then
        valuebar.noteActivationNameBox = Turbine.UI.Lotro.TextBox()
        valuebar.noteActivationNameBox:SetParent(valuebar.optionsControl)
        valuebar.noteActivationNameBox:SetSize(width - 16, 20)
        valuebar.noteActivationNameBox:SetPosition(0, optionsHeight)
        valuebar.noteActivationNameBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.noteActivationNameBox:SetText("Note Name")
    end

    if (UIType == "Icon" or UIType == "Text") and triggerType == "Effects" then
        valuebar.iconModeBox = Turbine.UI.Lotro.CheckBox()
        valuebar.iconModeBox:SetParent(valuebar.optionsControl)
        valuebar.iconModeBox:SetSize(100, 20)
        valuebar.iconModeBox:SetPosition(200, optionsHeight)
        valuebar.iconModeBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.iconModeBox:SetText("Toggle")
        valuebar.iconModeBox:SetChecked(true)

        valuebar.iconModeShowInfo = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "This toggle sets if the icon should be shown if the effect is applied (toggled) or not applied (not toggled). This option interacts with the conjunction option in the settings too.", optionPage.infoWindow)
    end

    if UIType == "Sound" then
        valuebar.soundButton = Turbine.UI.Lotro.Button()
        valuebar.soundButton:SetParent(valuebar.optionsControl)
        valuebar.soundButton:SetSize(100, 20)
        valuebar.soundButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.soundButton:SetPosition(0, optionsHeight)
        valuebar.soundButton:SetText("SoundEffect")

        valuebar.soundMenu = UI.DropDownMenuControl(nil, 200, "Sound Menu")
        for key, value in spairs(Sounds:GetSoundList(), function(t, a, b) return a < b end) do
            valuebar.soundMenu:AddItem(key, 
            function()
                valuebar.soundButton:SetText(key)
                valuebar.soundMenu:ToggleVisible()
            end)
        end
    
        valuebar.soundButton.Click = function()
            valuebar.soundMenu:ToggleVisible()
        end
    end

    optionsHeight = optionsHeight + 25

    -- If applicable add an icon to the trigger
    if UIType == "TimerGroup" or UIType == "Timer" or UIType == "BuffBar" or UIType == "BuffBar_Target" or UIType == "AlertGroup" or (UIType == "Alert" and (string.find(triggerType, "Effect") or string.find(triggerType, "Skill"))) then
        valuebar.EffectTimerIconBox = Turbine.UI.Control()
        valuebar.EffectTimerIconBox:SetParent(valuebar.optionsControl)
        valuebar.EffectTimerIconBox:SetPosition(0, optionsHeight)
        valuebar.EffectTimerIconBox:SetSize(32,32)
        valuebar.EffectTimerIconBox:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        valuebar.EffectTimerIconBox:SetBackground(BackgroundHandler:GetBackground(0x41007F41))
        valuebar.EffectTimerIconBox:SetVisible(true)

        valuebar.TimerIconTextBox = Turbine.UI.Lotro.TextBox()
        valuebar.TimerIconTextBox:SetParent(valuebar.optionsControl)
        valuebar.TimerIconTextBox:SetSize(110, 30)
        valuebar.TimerIconTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        valuebar.TimerIconTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.TimerIconTextBox:SetMouseVisible(false)
        valuebar.TimerIconTextBox:SetPosition(40, optionsHeight)
        valuebar.TimerIconTextBox:SetMultiline(false)
        valuebar.TimerIconTextBox:SetText(0x41007F41)

        valuebar.EffectTimerIconBox.MouseClick = function()
            local iconWindow = optionPage:GetIconWindow()
            iconWindow:SetVisible(true) 
            iconWindow:Register(valuebar.EffectTimerIconBox, valuebar.TimerIconTextBox)
        end

        valuebar.EffectTimerIconBox.MouseDoubleClick = function()
            valuebar.EffectTimerIconBox:SetBackground(BackgroundHandler:GetBackground(0x41007F41))
            valuebar.TimerIconTextBox:SetText(0x41007F41)
        end

        valuebar.iconInputShowInfo = InfoButton(valuebar.optionsControl, width, 150, optionsHeight + 7, "If applicable pick an icon to show on the UI element when this trigger is activated. You can either pick one through the menu by clicking on the box on the left or fill in your own ID in the textbox. You can also input a path to a specific image. For example: \"PrimePlugins/RaidTools/Images/RolePlay.tga\" to get the PrimePlugin roleplay icon in the image folder.", optionPage.infoWindow)

        if (string.find(triggerType, "Effect") or string.find(triggerType, "Skill")) and UIType ~= "Counter" then
            valuebar.takeIconFromTriggerBox = Turbine.UI.Lotro.CheckBox()
            valuebar.takeIconFromTriggerBox:SetParent(valuebar.optionsControl)
            valuebar.takeIconFromTriggerBox:SetSize(200, 20)
            valuebar.takeIconFromTriggerBox:SetPosition(200, optionsHeight + 20)
            valuebar.takeIconFromTriggerBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            if triggerType == "Skills" then
                valuebar.takeIconFromTriggerBox:SetText("Take icon from skill")
            else
                valuebar.takeIconFromTriggerBox:SetText("Take icon from effect")
            end
        end

        if string.find(triggerType, "Effect") then
            valuebar.iconMatchBox = Turbine.UI.Lotro.CheckBox()
            valuebar.iconMatchBox:SetParent(valuebar.optionsControl)
            valuebar.iconMatchBox:SetSize(100, 20)
            valuebar.iconMatchBox:SetPosition(200, optionsHeight)
            valuebar.iconMatchBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            valuebar.iconMatchBox:SetText("Match icon")

            valuebar.iconInputShowInfo = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "The icon picked in the icon box will be matched against the icon supplied on the trigger, only if these are a match will the trigger active. This option is not compatible with the \"Take icon from effect\" option.", optionPage.infoWindow)
        end

        if UIType == "AlertGroup" then
            valuebar.showIconBox = Turbine.UI.Lotro.CheckBox()
            valuebar.showIconBox:SetParent(valuebar.optionsControl)
            valuebar.showIconBox:SetSize(100, 20)
            valuebar.showIconBox:SetPosition(380, optionsHeight)
            valuebar.showIconBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            valuebar.showIconBox:SetText("Show Icon")

            valuebar.showIconShowInfo = InfoButton(valuebar.optionsControl, width, 480, optionsHeight + 2, "Enable this to show the selected icon on the alert.", optionPage.infoWindow)
        end
    end

    if UIType == "Counter" then
        valuebar.counterNameLabel = Turbine.UI.Label()
        valuebar.counterNameLabel:SetParent(valuebar.optionsControl)
        valuebar.counterNameLabel:SetSize(100, 20)
        valuebar.counterNameLabel:SetPosition(0, optionsHeight)
        valuebar.counterNameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.counterNameLabel:SetText("Counter Text:")
    
        valuebar.counterNameBox = Turbine.UI.Lotro.TextBox()
        valuebar.counterNameBox:SetParent(valuebar.optionsControl)
        valuebar.counterNameBox:SetSize(250, 20)
        valuebar.counterNameBox:SetPosition(100, optionsHeight)
        valuebar.counterNameBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

        valuebar.CounterNameInfo = InfoButton(valuebar.optionsControl, width, 350, optionsHeight + 2, "The text on the counter, this is also the ID of the counter. So multiple triggers with the same text will work on the same counter!", optionPage.infoWindow)

        optionsHeight = optionsHeight + 25

        valuebar.startCountLabel = Turbine.UI.Label()
        valuebar.startCountLabel:SetParent(valuebar.optionsControl)
        valuebar.startCountLabel:SetSize(100, 20)
        valuebar.startCountLabel:SetPosition(0, optionsHeight)
        valuebar.startCountLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.startCountLabel:SetText("Start Count:")
    
        valuebar.startCountBox = Turbine.UI.Lotro.TextBox()
        valuebar.startCountBox:SetParent(valuebar.optionsControl)
        valuebar.startCountBox:SetSize(50, 20)
        valuebar.startCountBox:SetPosition(100, optionsHeight)
        valuebar.startCountBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.startCountBox:SetText("0")

        valuebar.startCountInfo = InfoButton(valuebar.optionsControl, width, 150, optionsHeight + 2, "The amount the counter starts at.", optionPage.infoWindow)
    
        optionsHeight = optionsHeight + 25

        valuebar.minVisLabel = Turbine.UI.Label()
        valuebar.minVisLabel:SetParent(valuebar.optionsControl)
        valuebar.minVisLabel:SetSize(130, 20)
        valuebar.minVisLabel:SetPosition(0, optionsHeight)
        valuebar.minVisLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.minVisLabel:SetText("Minimal visiblity:")
    
        valuebar.minVisBox = Turbine.UI.Lotro.TextBox()
        valuebar.minVisBox:SetParent(valuebar.optionsControl)
        valuebar.minVisBox:SetSize(50, 20)
        valuebar.minVisBox:SetPosition(130, optionsHeight)
        valuebar.minVisBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.minVisBox:SetText("0")
    
        valuebar.maxVisLabel = Turbine.UI.Label()
        valuebar.maxVisLabel:SetParent(valuebar.optionsControl)
        valuebar.maxVisLabel:SetSize(135, 20)
        valuebar.maxVisLabel:SetPosition(180, optionsHeight)
        valuebar.maxVisLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.maxVisLabel:SetText("Maximal visibility:")
    
        valuebar.maxVisBox = Turbine.UI.Lotro.TextBox()
        valuebar.maxVisBox:SetParent(valuebar.optionsControl)
        valuebar.maxVisBox:SetSize(50, 20)
        valuebar.maxVisBox:SetPosition(310, optionsHeight)
        valuebar.maxVisBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.maxVisBox:SetText("9999")
    
        valuebar.visiblityInfoBox = InfoButton(valuebar.optionsControl, width, 360, optionsHeight + 2, "The counter item is only visible if the count is inbetween (or equal) to these numbers.", optionPage.infoWindow)
    
        optionsHeight = optionsHeight + 25

        valuebar.decrementBox = Turbine.UI.Lotro.CheckBox()
        valuebar.decrementBox:SetParent(valuebar.optionsControl)
        valuebar.decrementBox:SetSize(100, 20)
        valuebar.decrementBox:SetPosition(0, optionsHeight)
        valuebar.decrementBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.decrementBox:SetText("Decrement")

        valuebar.incrementInfo = InfoButton(valuebar.optionsControl, width, 100, optionsHeight + 2, "If this is checked this trigger will decrement the counter instead of increment it.", optionPage.infoWindow)
    
        optionsHeight = optionsHeight + 25

        valuebar.numberTextLabel = Turbine.UI.Label()
        valuebar.numberTextLabel:SetParent(valuebar.optionsControl)
        valuebar.numberTextLabel:SetSize(150, 20)
        valuebar.numberTextLabel:SetPosition(0, optionsHeight)
        valuebar.numberTextLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.numberTextLabel:SetText("Inc/dec amount:")
    
        valuebar.numberTextBox = Turbine.UI.Lotro.TextBox()
        valuebar.numberTextBox:SetParent(valuebar.optionsControl)
        valuebar.numberTextBox:SetSize(50, 20)
        valuebar.numberTextBox:SetPosition(150, optionsHeight)
        valuebar.numberTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.numberTextBox:SetText("1")

        valuebar.numberInfoLabel = InfoButton(valuebar.optionsControl, width, 200, optionsHeight + 2, "The amount the counter is incremented or decremented by when this trigger fires.", optionPage.infoWindow)
    
        optionsHeight = optionsHeight + 25
        if triggerType ~= "Effects" then
            valuebar.conditionNameLabel = Turbine.UI.Label()
            valuebar.conditionNameLabel:SetParent(valuebar.optionsControl)
            valuebar.conditionNameLabel:SetSize(150, 20)
            valuebar.conditionNameLabel:SetPosition(0, optionsHeight)
            valuebar.conditionNameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            valuebar.conditionNameLabel:SetText("Condition Name:")
        
            valuebar.conditionNameTextBox = Turbine.UI.Lotro.TextBox()
            valuebar.conditionNameTextBox:SetParent(valuebar.optionsControl)
            valuebar.conditionNameTextBox:SetSize(200, 20)
            valuebar.conditionNameTextBox:SetPosition(150, optionsHeight)
            valuebar.conditionNameTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            valuebar.conditionNameTextBox:SetText("")

            optionsHeight = optionsHeight + 25
            
            valuebar.counterTimeLabel = Turbine.UI.Label()
            valuebar.counterTimeLabel:SetParent(valuebar.optionsControl)
            valuebar.counterTimeLabel:SetSize(150, 20)
            valuebar.counterTimeLabel:SetPosition(0, optionsHeight)
            valuebar.counterTimeLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            valuebar.counterTimeLabel:SetText("Time:")
        
            valuebar.counterTimeTextBox = Turbine.UI.Lotro.TextBox()
            valuebar.counterTimeTextBox:SetParent(valuebar.optionsControl)
            valuebar.counterTimeTextBox:SetSize(100, 20)
            valuebar.counterTimeTextBox:SetPosition(100, optionsHeight)
            valuebar.counterTimeTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            valuebar.counterTimeTextBox:SetText("")

            if string.find(triggerType, "Effect") then
                valuebar.counterTimeCheckbox = Turbine.UI.Lotro.CheckBox()
                valuebar.counterTimeCheckbox:SetParent(valuebar.optionsControl)
                valuebar.counterTimeCheckbox:SetSize(200, 20)
                valuebar.counterTimeCheckbox:SetPosition(250, optionsHeight)
                valuebar.counterTimeCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
                if triggerType == "Skills" then
                    valuebar.counterTimeCheckbox:SetText("Take time from skill")
                else
                    valuebar.counterTimeCheckbox:SetText("Take time from effect")
                end
            end

            optionsHeight = optionsHeight + 25
        end
    end

    if triggerType == "Corruption" then
        valuebar.targetTextLabel = Turbine.UI.Label()
        valuebar.targetTextLabel:SetParent(valuebar.optionsControl)
        valuebar.targetTextLabel:SetSize(250, 20)
        valuebar.targetTextLabel:SetPosition(0, optionsHeight)
        valuebar.targetTextLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.targetTextLabel:SetText("Target name (empty for all):")
    
        valuebar.targetTextBox = Turbine.UI.Lotro.TextBox()
        valuebar.targetTextBox:SetParent(valuebar.optionsControl)
        valuebar.targetTextBox:SetSize(200, 20)
        valuebar.targetTextBox:SetPosition(250, optionsHeight)
        valuebar.targetTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.targetTextBox:SetText("")

        valuebar.targetCounterInfo = InfoButton(valuebar.optionsControl, width, 500, optionsHeight + 2, "This trigger will only fire if the target affected by this trigger matches.", optionPage.infoWindow)
    
        optionsHeight = optionsHeight + 25

        valuebar.effectTextLabel = Turbine.UI.Label()
        valuebar.effectTextLabel:SetParent(valuebar.optionsControl)
        valuebar.effectTextLabel:SetSize(250, 20)
        valuebar.effectTextLabel:SetPosition(0, optionsHeight)
        valuebar.effectTextLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.effectTextLabel:SetText("Effect name (empty for all):")
    
        valuebar.effectTextBox = Turbine.UI.Lotro.TextBox()
        valuebar.effectTextBox:SetParent(valuebar.optionsControl)
        valuebar.effectTextBox:SetSize(200, 20)
        valuebar.effectTextBox:SetPosition(250, optionsHeight)
        valuebar.effectTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.effectTextBox:SetText("")

        valuebar.effectTextInfo = InfoButton(valuebar.optionsControl, width, 500, optionsHeight + 2, "If a name is specified only when the effect name matches the removed corrupted this trigger will fire.", optionPage.infoWindow)
    

        optionsHeight = optionsHeight + 25
    end

    if UIType == "Event Keyword" then
        valuebar.eventKeywordLabel = Turbine.UI.Label()
        valuebar.eventKeywordLabel:SetParent(valuebar.optionsControl)
        valuebar.eventKeywordLabel:SetSize(100, 20)
        valuebar.eventKeywordLabel:SetPosition(0, optionsHeight)
        valuebar.eventKeywordLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.eventKeywordLabel:SetText("Event:")
    
        valuebar.eventKeywordBox = Turbine.UI.Lotro.TextBox()
        valuebar.eventKeywordBox:SetParent(valuebar.optionsControl)
        valuebar.eventKeywordBox:SetSize(250, 20)
        valuebar.eventKeywordBox:SetPosition(100, optionsHeight)
        valuebar.eventKeywordBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

        valuebar.EventKeywordInfo = InfoButton(valuebar.optionsControl, width, 350, optionsHeight + 2, "When this trigger fires the event specified here will be activated. You can fire multiple events with the same trigger by seperating them with a \",\".", optionPage.infoWindow)

        optionsHeight = optionsHeight + 25

    end

    if UIType == "TimerGroup" or (UIType == "Timer" and triggerType == "EffectAdded_Target") or UIType == "BuffBar" or UIType == "BuffBar_Target" then
        valuebar.uniqueCheckBox = Turbine.UI.Lotro.CheckBox()
        valuebar.uniqueCheckBox:SetParent(valuebar.optionsControl)
        valuebar.uniqueCheckBox:SetSize(100, 20)
        valuebar.uniqueCheckBox:SetPosition(width - 100, optionsHeight)
        valuebar.uniqueCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.uniqueCheckBox:SetText("Unique")

        valuebar.uniqueInfoShow = InfoButton(valuebar.optionsControl, width, width - 16 - 100, optionsHeight + 2, "Set this trigger as unique so it can not create multiple instances of the same trigger while the another trigger of the same type is still active.", optionPage.infoWindow)

        if UIType == "TimerGroup" then
            valuebar.overrideInfoCheckBox = Turbine.UI.Lotro.CheckBox()
            valuebar.overrideInfoCheckBox:SetParent(valuebar.optionsControl)
            valuebar.overrideInfoCheckBox:SetSize(100, 20)
            valuebar.overrideInfoCheckBox:SetPosition(width - 100, optionsHeight + 20)
            valuebar.overrideInfoCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            valuebar.overrideInfoCheckBox:SetText("Override")
    
            valuebar.overrideInfo = InfoButton(valuebar.optionsControl, width, width - 16 - 100, optionsHeight + 2 + 20, "This will override a timer in the list if a duplicate already exist instead of creating a new one. This requires the unique option to be enabled.", optionPage.infoWindow)
        end
    end

    if UIType == "BuffBar" or UIType == "BuffBar_Target" then
        valuebar.highlightCheckBox = Turbine.UI.Lotro.CheckBox()
        valuebar.highlightCheckBox:SetParent(valuebar.optionsControl)
        valuebar.highlightCheckBox:SetSize(100, 20)
        valuebar.highlightCheckBox:SetPosition(width - 100, optionsHeight + 20)
        valuebar.highlightCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.highlightCheckBox:SetText("Highlight")
    end

    optionsHeight = optionsHeight + 40

    if UIType == "TimerGroup" then
        valuebar.increasingCheckbox = Turbine.UI.Lotro.CheckBox()
        valuebar.increasingCheckbox:SetParent(valuebar.optionsControl)
        valuebar.increasingCheckbox:SetSize(100, 20)
        valuebar.increasingCheckbox:SetPosition(width - 100, optionsHeight + 20)
        valuebar.increasingCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.increasingCheckbox:SetText("Increase")

        
    optionsHeight = optionsHeight + 20
    end


    if triggerType == "FightPhase" then
        valuebar.FightPhaseBox = Turbine.UI.Lotro.TextBox()
        valuebar.FightPhaseBox:SetParent(valuebar.optionsControl)
        valuebar.FightPhaseBox:SetSize(110, 20)
        valuebar.FightPhaseBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        valuebar.FightPhaseBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.FightPhaseBox:SetMouseVisible(false)
        valuebar.FightPhaseBox:SetPosition(0, optionsHeight)
        valuebar.FightPhaseBox:SetMultiline(false)
        valuebar.FightPhaseBox:SetText("Phase")

        valuebar.uniqueInfoShow = InfoButton(valuebar.optionsControl, width, 110, optionsHeight + 2, "The phase number specifies at what phase in the fight this trigger activates. A fight will start in phase 1 and might have additional phases as marked by the blue text popup.", optionPage.infoWindow)
    end

    if string.find(triggerType, "Fight") then
        valuebar.fightTierBox = Turbine.UI.Lotro.TextBox()
        valuebar.fightTierBox:SetParent(valuebar.optionsControl)
        valuebar.fightTierBox:SetSize(100, 20)
        valuebar.fightTierBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        valuebar.fightTierBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.fightTierBox:SetMouseVisible(false)
        valuebar.fightTierBox:SetPosition(200, optionsHeight)
        valuebar.fightTierBox:SetMultiline(false)
        valuebar.fightTierBox:SetText("Tier")

        valuebar.fightTierOverrideBox = Turbine.UI.Lotro.CheckBox()
        valuebar.fightTierOverrideBox:SetParent(valuebar.optionsControl)
        valuebar.fightTierOverrideBox:SetSize(100, 20)
        valuebar.fightTierOverrideBox:SetPosition(320, optionsHeight)
        valuebar.fightTierOverrideBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.fightTierOverrideBox:SetChecked(true)
        valuebar.fightTierOverrideBox:SetText("All tiers")

        valuebar.uniqueInfoShow = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "Here you can specify the trigger to only activate on a specific tier. This can be overwritten with the checkbox which will make sure the trigger will work on any tier. Helpful for certain triggers that have dynamic timings based on tier.", optionPage.infoWindow)

        optionsHeight = optionsHeight + 20
    end

    if UIType == "Event Keyword" then
        valuebar.argCheckbox = Turbine.UI.Lotro.CheckBox()
        valuebar.argCheckbox:SetParent(valuebar.optionsControl)
        valuebar.argCheckbox:SetSize(300, 20)
        valuebar.argCheckbox:SetPosition(0, optionsHeight)
        valuebar.argCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.argCheckbox:SetChecked(false)
        valuebar.argCheckbox:SetText("Send arguments with event")

        valuebar.argInfo = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "Adds any arguments from the event trigger to the event.", optionPage.infoWindow)

        optionsHeight = optionsHeight + 25
    end

    if UIType == "BuffBar" then
        
        valuebar.lowerWiggleLabel = Turbine.UI.Label()
        valuebar.lowerWiggleLabel:SetParent(valuebar.optionsControl)
        valuebar.lowerWiggleLabel:SetSize(200, 20)
        valuebar.lowerWiggleLabel:SetPosition(0, optionsHeight)
        valuebar.lowerWiggleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.lowerWiggleLabel:SetText("Wiggle Stop Time:")
    
        valuebar.lowerWiggleBox = Turbine.UI.Lotro.TextBox()
        valuebar.lowerWiggleBox:SetParent(valuebar.optionsControl)
        valuebar.lowerWiggleBox:SetSize(100, 20)
        valuebar.lowerWiggleBox:SetPosition(200, optionsHeight)
        valuebar.lowerWiggleBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

        valuebar.lowerWiggleInfo = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "A duration value above this value and below the upper bound the wiggle will active.", optionPage.infoWindow)

        optionsHeight = optionsHeight + 25
        
        valuebar.upperWiggleLabel = Turbine.UI.Label()
        valuebar.upperWiggleLabel:SetParent(valuebar.optionsControl)
        valuebar.upperWiggleLabel:SetSize(200, 20)
        valuebar.upperWiggleLabel:SetPosition(0, optionsHeight)
        valuebar.upperWiggleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.upperWiggleLabel:SetText("Wiggle Start Time:")
    
        valuebar.upperWiggleBox = Turbine.UI.Lotro.TextBox()
        valuebar.upperWiggleBox:SetParent(valuebar.optionsControl)
        valuebar.upperWiggleBox:SetSize(100, 20)
        valuebar.upperWiggleBox:SetPosition(200, optionsHeight)
        valuebar.upperWiggleBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

        valuebar.upperWiggleInfo = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "A duration below this value will activate the wiggle until it reaches the wiggle lower bound", optionPage.infoWindow)

        optionsHeight = optionsHeight + 25

        valuebar.alwaysWiggleBox = Turbine.UI.Lotro.CheckBox()
        valuebar.alwaysWiggleBox:SetParent(valuebar.optionsControl)
        valuebar.alwaysWiggleBox:SetSize(200, 20)
        valuebar.alwaysWiggleBox:SetPosition(320, optionsHeight)
        valuebar.alwaysWiggleBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.alwaysWiggleBox:SetText("Always wiggle")

        valuebar.alwaysWiggleInfo = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "Always wiggle.", optionPage.infoWindow)

        optionsHeight = optionsHeight + 25
    end

    if string.find(triggerType, "CCBreak") then
        valuebar.ccTypeTextBox = Turbine.UI.Lotro.TextBox()
        valuebar.ccTypeTextBox:SetParent(valuebar.optionsControl)
        valuebar.ccTypeTextBox:SetSize(100, 20)
        valuebar.ccTypeTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        valuebar.ccTypeTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.ccTypeTextBox:SetMouseVisible(false)
        valuebar.ccTypeTextBox:SetPosition(0, optionsHeight)
        valuebar.ccTypeTextBox:SetMultiline(false)
        valuebar.ccTypeTextBox:SetText("CC type")

        valuebar.ccTypeOverrideBox = Turbine.UI.Lotro.CheckBox()
        valuebar.ccTypeOverrideBox:SetParent(valuebar.optionsControl)
        valuebar.ccTypeOverrideBox:SetSize(120, 20)
        valuebar.ccTypeOverrideBox:SetPosition(100, optionsHeight)
        valuebar.ccTypeOverrideBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.ccTypeOverrideBox:SetText("All CC types")

        valuebar.cctypeInfoShow = InfoButton(valuebar.optionsControl, width, 220, optionsHeight + 2, "The trigger will only fire if the type of crowd control that is broken matches this type. If all types is selected it will fire for any type that is detected. The CC type are all spelled without a capital, for example \"daze\".", optionPage.infoWindow)

        optionsHeight = optionsHeight + 20
    end

    if UIType == "TimerGroup" or UIType == "Timer" or UIType == "Countdown" or UIType == "Alert" or UIType == "AlertGroup" or UIType == "Circle Timer" then
        valuebar.eventTriggerTextbox = Turbine.UI.Lotro.TextBox()
        valuebar.eventTriggerTextbox:SetParent(valuebar.optionsControl)
        valuebar.eventTriggerTextbox:SetSize(200, 20)
        valuebar.eventTriggerTextbox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        valuebar.eventTriggerTextbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.eventTriggerTextbox:SetMouseVisible(false)
        valuebar.eventTriggerTextbox:SetPosition(0, optionsHeight)
        valuebar.eventTriggerTextbox:SetMultiline(false)
        valuebar.eventTriggerTextbox:SetText("Event Keyword")

        valuebar.eventTriggerInfoShow = InfoButton(valuebar.optionsControl, width, 220, optionsHeight + 2, "This event will fire when the current trigger expires. For example, when a timer runs out this event will fire. This event will be applied to the current primeUI and all UI elements that have a TriggerEvent with this keyword will fire. This allows you to fire events at the end of other events, or create loops.", optionPage.infoWindow)

        optionsHeight = optionsHeight + 20
    end

    if UIType == "User Variables" then
        valuebar.typeButton = Turbine.UI.Lotro.Button()
        valuebar.typeButton:SetParent(valuebar.optionsControl)
        valuebar.typeButton:SetSize(100, 20)
        valuebar.typeButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.typeButton:SetPosition(0, optionsHeight)
        valuebar.typeButton:SetText("Type")

        valuebar.typeMenu = UI.DropDownMenuControl(nil, 200, "Types")

        valuebar.typeMenu:AddItem("boolean", 
        function()
            valuebar.typeButton:SetText("boolean")
            valuebar.typeMenu:ToggleVisible()
        end)

        valuebar.typeMenu:AddItem("number", 
        function()
            valuebar.typeButton:SetText("number")
            valuebar.typeMenu:ToggleVisible()
        end)

        valuebar.typeMenu:AddItem("string", 
        function()
            valuebar.typeButton:SetText("string")
            valuebar.typeMenu:ToggleVisible()
        end)
    
        valuebar.typeButton.Click = function()
            valuebar.typeMenu:ToggleVisible()
        end

        optionsHeight = optionsHeight + 20
    end

    valuebar.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    valuebar.addTriggerEntryButton:SetParent(valuebar)
    valuebar.addTriggerEntryButton:SetSize(100, 20)
    valuebar.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.addTriggerEntryButton:SetPosition(width - 120, optionsHeight)
    valuebar.addTriggerEntryButton:SetText("Add")

    optionsHeight = optionsHeight + 20

    -- Set options control to match all its children
    valuebar.optionsControl:SetSize(width, optionsHeight)

    -- Add listbox for items
    valuebar.listbox = Turbine.UI.ListBox()
    valuebar.listbox:SetParent(valuebar)
    valuebar.listbox:SetSize(width - 10, listboxHeight)
    valuebar.listbox:SetPosition(0, valuebar.optionsControl:GetHeight())
    valuebar.listbox:SetVisible(tablelength(listboxItems) > 0)

    valuebar.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    valuebar.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    valuebar.Scrollbar:SetParent(valuebar)
    valuebar.Scrollbar:SetPosition(width - 10, valuebar.optionsControl:GetHeight())
    valuebar.Scrollbar:SetSize(10, listboxHeight)
    valuebar.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    valuebar.listbox:SetVerticalScrollBar(valuebar.Scrollbar)

    for key, value in spairs(listboxItems, function(t, a, b) return tostring(a) < tostring(b) end) do
        valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(key, value, width - 10, triggerType, UIType, func, valuebar.listbox))
    end

    valuebar:SetSize(width, valuebar.listbox:GetHeight() + valuebar.optionsControl:GetHeight())

    optionsTreeNode:Add(valuebar.optionsControl)

    valuebar.addTriggerEntryButton.Click = function()
        local triggerEntry
        
        if UIType == "Circle Timer" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end
            local timeValue = tonumber(valuebar.timeBar:GetText())
            if valuebar.timerCheckBox and valuebar.timerCheckBox:IsChecked() then timeValue = valuebar.timerCheckBox:IsChecked() end
            if not(triggerToken) or not(timeValue) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            triggerEntry = {
                ["Time"] = timeValue,
                ["Unique"] = valuebar.uniqueCheckBox and valuebar.uniqueCheckBox:IsChecked(),
                ["Message"] = valuebar.shownTextInputBox and valuebar.shownTextInputBox:GetText(),
                ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
            }
            if func(triggerToken, triggerEntry) then
                return
            end

            valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            valuebar.listbox:SetVisible(true)

        elseif UIType == "Countdown" or UIType == "SkillLabel" or UIType == "TimerIcon" or UIType == "ValueBar" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end
            local timeValue = valuebar.timeBar and tonumber(valuebar.timeBar:GetText())
            if valuebar.timerCheckBox and valuebar.timerCheckBox:IsChecked() then timeValue = valuebar.timerCheckBox:IsChecked() end
            if not(triggerToken) or (not(timeValue) and triggerType ~= "Highlight_On_Effect") or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            if valuebar.thresholdNumberTextBox then
                triggerEntry = {
                    ["Countdown"] = timeValue,
                    ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                    ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                    ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
                    ["Highlight_Value"] = valuebar.skillLabelHighlightBox and valuebar.skillLabelHighlightBox:IsChecked(),
                }
                if func(triggerToken, triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            else
                triggerEntry = {
                    ["Countdown"] = timeValue,
                    ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
                    ["Highlight_Value"] = valuebar.skillLabelHighlightBox and valuebar.skillLabelHighlightBox:IsChecked(),
                }
                if func(triggerToken, triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            end

            valuebar.listbox:SetVisible(true)

        elseif UIType == "Sound" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end
            local sound = tostring(valuebar.soundButton:GetText())
            if not(triggerToken) or not(sound) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            if valuebar.thresholdNumberTextBox then
                triggerEntry = {
                    ["Sound"] = sound,
                    ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                    ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                }
                if func(triggerToken, triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            else
                if func(triggerToken, sound) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, sound, width - 10, triggerType, UIType, func, valuebar.listbox))
            end

            valuebar.listbox:SetVisible(true)

        elseif UIType == "Icon" or UIType == "Text" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if triggerType == "HealthThreshold" and valuebar.thresholdNumberTextBox then
                triggerToken = tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end
            local showIconValue
            if valuebar.iconModeBox then
                showIconValue = valuebar.iconModeBox:IsChecked()
            end
            if not(triggerToken) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            if valuebar.thresholdBrowseButton then
                triggerEntry = {
                    ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                }
                if func(triggerToken, triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            elseif string.find(triggerType, "Invisibility_Event") or string.find(triggerType, "Visibilty_Event") then
                triggerEntry = {
                }
                if func(triggerToken, triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            else
                if func(triggerToken, showIconValue) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, showIconValue, width - 10, triggerType, UIType, func, valuebar.listbox))
            end

            
            valuebar.listbox:SetVisible(true)
        elseif UIType == "Note Event" or UIType == "Note Activation" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if triggerType == "HealthThreshold" and valuebar.thresholdNumberTextBox then
                triggerToken = tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end
            local tierInfo
            if valuebar.fightTierBox then
                tierInfo = tonumber(valuebar.fightTierBox:GetText())
                if valuebar.fightTierOverrideBox and valuebar.fightTierOverrideBox:IsChecked() then
                    tierInfo = valuebar.fightTierOverrideBox:IsChecked()
                end
            end

            if not(triggerToken) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            if valuebar.thresholdBrowseButton then
                triggerEntry = {
                    ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                    ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                    ["Event"] = valuebar.noteEventTriggerIntputBox and tostring(valuebar.noteEventTriggerIntputBox:GetText()),
                    ["Note_Name"] = valuebar.noteActivationNameBox and tostring(valuebar.noteActivationNameBox:GetText())
                }
                if func(triggerToken, triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            elseif string.find(triggerType, "Fight") then
                triggerEntry = {
                    ["Event"] = valuebar.noteEventTriggerIntputBox and tostring(valuebar.noteEventTriggerIntputBox:GetText()),
                    ["Note_Name"] = valuebar.noteActivationNameBox and tostring(valuebar.noteActivationNameBox:GetText()),
                    ["Phase"] = valuebar.FightPhaseBox and tonumber(valuebar.FightPhaseBox:GetText()),
                    ["Boss_Name"] = valuebar.fightButton and tostring(valuebar.fightButton:GetText()),
                    ["Tier_Info"] = tierInfo,
                }

                if func(Turbine.Engine.GetGameTime(), triggerEntry) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(Turbine.Engine.GetGameTime(), triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            elseif UIType == "Note Event" then
                if func(triggerToken, valuebar.noteEventTriggerIntputBox and tostring(valuebar.noteEventTriggerIntputBox:GetText())) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, valuebar.noteEventTriggerIntputBox and tostring(valuebar.noteEventTriggerIntputBox:GetText()), width - 10, triggerType, UIType, func, valuebar.listbox))
            elseif UIType == "Note Activation" then
                if func(triggerToken, valuebar.noteActivationNameBox and tostring(valuebar.noteActivationNameBox:GetText())) then
                    return
                end
                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, valuebar.noteActivationNameBox and tostring(valuebar.noteActivationNameBox:GetText()), width - 10, triggerType, UIType, func, valuebar.listbox))
            end

            valuebar.listbox:SetVisible(true)

        elseif UIType == "TimerGroup"  then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "Fight") and valuebar.fightButton or string.find(triggerType, "DNF") then
                triggerToken = Turbine.Engine.GetGameTime()--tostring(valuebar.fightButton:GetText())
            end
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end
            local timeValue = tonumber(valuebar.timeBar:GetText())
            if valuebar.timerCheckBox and valuebar.timerCheckBox:IsChecked() then timeValue = valuebar.timerCheckBox:IsChecked() end
            local iconValue = valuebar.TimerIconTextBox:GetText()
            if valuebar.takeIconFromTriggerBox and valuebar.takeIconFromTriggerBox:IsChecked() == true then iconValue = valuebar.takeIconFromTriggerBox:IsChecked() end
            local iconMatch
            if valuebar.iconMatchBox then iconMatch = valuebar.iconMatchBox:IsChecked() end
            local tierInfo
            if valuebar.fightTierBox then
                tierInfo = tonumber(valuebar.fightTierBox:GetText())
                if valuebar.fightTierOverrideBox and valuebar.fightTierOverrideBox:IsChecked() then
                    tierInfo = valuebar.fightTierOverrideBox:IsChecked()
                end
            end
            local incraseValue = valuebar.increasingCheckbox and valuebar.increasingCheckbox:IsChecked()
            if incraseValue and not(timeValue) then
                timeValue = -1
            end

            if not(triggerToken) or (not(timeValue) and not(incraseValue)) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            triggerEntry = {
                ["Time"] = timeValue,
                ["Unique"] = valuebar.uniqueCheckBox:IsChecked(),
                ["Message"] = valuebar.shownTextInputBox:GetText(),
                ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                ["Icon"] = iconValue,
                ["Match_icon"] = iconMatch,
                ["Phase"] = valuebar.FightPhaseBox and tonumber(valuebar.FightPhaseBox:GetText()),
                ["Boss_Name"] = valuebar.fightButton and tostring(valuebar.fightButton:GetText()),
                ["Tier_Info"] = tierInfo,
                ["Override"] = valuebar.overrideInfoCheckBox and valuebar.overrideInfoCheckBox:IsChecked(),
                ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
                ["Increasing"] = incraseValue,
            }
            if func(triggerToken, triggerEntry) then
                return
            end

            valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            valuebar.listbox:SetVisible(true)
        elseif UIType == "BuffBar" or UIType == "BuffBar_Target" or UIType == "Timer" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end
            local timeValue = tonumber(valuebar.timeBar:GetText())
            if valuebar.timerCheckBox and valuebar.timerCheckBox:IsChecked() then timeValue = valuebar.timerCheckBox:IsChecked() end
            local iconValue = valuebar.TimerIconTextBox:GetText()
            if valuebar.takeIconFromTriggerBox and valuebar.takeIconFromTriggerBox:IsChecked() == true then iconValue = valuebar.takeIconFromTriggerBox:IsChecked() end
            local iconMatch
            if valuebar.iconMatchBox then iconMatch = valuebar.iconMatchBox:IsChecked() end
            local highlight
            if valuebar.highlightCheckBox then highlight = valuebar.highlightCheckBox:IsChecked() end
            if not(triggerToken) or not(timeValue) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            triggerEntry = {
                ["Time"] = timeValue,
                ["Unique"] = valuebar.uniqueCheckBox and valuebar.uniqueCheckBox:IsChecked(),
                ["Icon"] = iconValue,
                ["Fit_Icon"] = iconMatch,
                ["Highlight"] = highlight,
                ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
                ["Wiggle_Lower"] = valuebar.lowerWiggleBox and tonumber(valuebar.lowerWiggleBox:GetText()) or 0,
                ["Wiggle_Upper"] = valuebar.upperWiggleBox and tonumber(valuebar.upperWiggleBox:GetText()) or 0,
                ["Always_Wiggle"] = valuebar.alwaysWiggleBox and valuebar.alwaysWiggleBox:IsChecked(),
            }
            if func(triggerToken, triggerEntry) then
                return
            end

            valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            valuebar.listbox:SetVisible(true)
        elseif UIType == "Alert" or UIType == "AlertGroup" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            if string.find(triggerType, "DNF") then
                triggerToken = Turbine.Engine.GetGameTime()
            end
            if triggerType == "HealthThreshold" then
               triggerToken = tostring(tonumber(valuebar.thresholdNumberTextBox:GetText())) .. tostring(valuebar.thresholdBrowseButton:GetText())
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end
            local timeValue = tonumber(valuebar.timeBar:GetText())
            if valuebar.timerCheckBox and valuebar.timerCheckBox:IsChecked() then timeValue = valuebar.timerCheckBox:IsChecked() end
            local iconValue = valuebar.TimerIconTextBox and valuebar.TimerIconTextBox:GetText()
            if valuebar.takeIconFromTriggerBox and valuebar.takeIconFromTriggerBox:IsChecked() == true then iconValue = valuebar.takeIconFromTriggerBox:IsChecked() end
            local iconMatch
            if valuebar.iconMatchBox then iconMatch = valuebar.iconMatchBox:IsChecked() end
            local showIcon 
            if valuebar.showIconBox then showIcon = valuebar.showIconBox:IsChecked() end
            local ccType
            if valuebar.ccTypeTextBox then
                ccType = tostring(valuebar.ccTypeTextBox:GetText())
                if valuebar.ccTypeOverrideBox and valuebar.ccTypeOverrideBox:IsChecked() then ccType = valuebar.ccTypeOverrideBox:IsChecked() end
            end
            if not(triggerToken) or not(timeValue) or
            valuebar.thresholdNumberTextBox and not(tonumber(valuebar.thresholdNumberTextBox:GetText())) then
                ChatOutput("Not all fields are correctly filled!")
                return
            end
            triggerEntry = {
                ["Countdown"] = timeValue,
                ["Text"] = valuebar.shownTextInputBox:GetText(),
                ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                ["Icon"] = iconValue,
                ["Match_Icon"] = iconMatch,
                ["Show_Icon"] = showIcon,
                ["CCType"] = ccType,
                ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),
            }
            if func(triggerToken, triggerEntry) then
                return
            end

            valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            valuebar.listbox:SetVisible(true)
        elseif UIType == "MoraleBar" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") or string.find(triggerType, "Fight") and valuebar.fightButton then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText())
            end
            if triggerToken then
                triggerEntry = {
                    ["Highlight_Colour"] = "Temp",
                }
                if func(triggerToken, triggerEntry) then
                    return
                end

                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
                valuebar.listbox:SetVisible(true)
            end
        elseif UIType == "Counter" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if triggerType == "Corruption" then
                triggerToken = Turbine.Engine.GetGameTime()
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end
            if triggerToken then
                triggerEntry = {
                    ["MinVis"] = valuebar.minVisBox and tonumber(tostring(valuebar.minVisBox:GetText())) or 0,
                    ["MaxVis"] = valuebar.maxVisBox and tonumber(tostring(valuebar.maxVisBox:GetText())) or 99999,
                    ["Decrement"] = valuebar.decrementBox and valuebar.decrementBox:IsChecked(),
                    ["Number"] = valuebar.numberTextBox and tonumber(tostring(valuebar.numberTextBox:GetText())) or 0,
                    ["Target"] =  valuebar.targetTextBox and tostring(valuebar.targetTextBox:GetText()) or "",
                    ["EffectName"] = valuebar.effectTextBox and tostring(valuebar.effectTextBox:GetText()) or "",
                    ["StartCount"] = valuebar.startCountBox and tonumber(tostring(valuebar.startCountBox:GetText())) or 0,
                    ["Text"] = valuebar.counterNameBox and tostring(valuebar.counterNameBox:GetText()),
                    ["Condition_Name"] = valuebar.conditionNameTextBox and tostring(valuebar.conditionNameTextBox:GetText()),
                    ["Time"] = valuebar.counterTimeCheckbox and valuebar.counterTimeCheckbox:IsChecked() or valuebar.counterTimeTextBox and tonumber(tostring(valuebar.counterTimeTextBox:GetText())),
                }
                if func(triggerToken, triggerEntry) then
                    return
                end

                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
                valuebar.listbox:SetVisible(true)
            end
        elseif UIType == "Conditions" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if triggerType == "Resource" or triggerType == "FightPhase" then
                triggerToken = Turbine.Engine.GetGameTime()
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end
            local tierInfo
            if valuebar.fightTierBox then
                tierInfo = tonumber(valuebar.fightTierBox:GetText())
                if valuebar.fightTierOverrideBox and valuebar.fightTierOverrideBox:IsChecked() then
                    tierInfo = valuebar.fightTierOverrideBox:IsChecked()
                end
            end
            if triggerToken then
                triggerEntry = {
                    ["Applications"] = valuebar.applicationBar and tonumber(tostring(valuebar.applicationBar:GetText())) or 1,
                    ["Not_Applied"] = valuebar.notAppliedCheckbox and valuebar.notAppliedCheckbox:IsChecked(),
                    ["Phase"] = valuebar.FightPhaseBox and tonumber(valuebar.FightPhaseBox:GetText()),
                    ["Boss_Name"] = valuebar.fightButton and tostring(valuebar.fightButton:GetText()),
                    ["Tier_Info"] = tierInfo,
                    ["Number"] = valuebar.thresholdNumberTextBox and tonumber(tostring(valuebar.thresholdNumberTextBox:GetText())) or 0,
                    ["Comparator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(),
                    ["Time"] = valuebar.timeBar and tonumber(tostring(valuebar.timeBar:GetText())),
                    ["Condition_Name"] = valuebar.conditionEventBox and tostring(valuebar.conditionEventBox:GetText()),
                }
                if func(triggerToken, triggerEntry) then
                    return
                end

                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
                valuebar.listbox:SetVisible(true)
            end
        elseif UIType == "Figures" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if triggerType == "Corruption" then
                triggerToken = Turbine.Engine.GetGameTime()
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end
            if triggerToken then
                triggerEntry = {
                    
                }
                if func(triggerToken, triggerEntry) then
                    return
                end

                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
                valuebar.listbox:SetVisible(true)
            end
        elseif UIType == "Event Keyword" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            if string.find(triggerType, "HealthThreshold") and not(string.find(triggerType, "Target_HealthThreshold")) then
                triggerToken = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()) or 0
            elseif string.find(triggerType, "Target_HealthThreshold") then
                triggerToken = Turbine.Engine.GetGameTime()
            elseif triggerType == "Corruption" or string.find(triggerType, "Fight") then
                triggerToken = Turbine.Engine.GetGameTime()
            end
            if string.find(triggerType, "Action") then
                triggerToken = tonumber(tostring(valuebar.nameTextBox:GetText()))
            end

            local tierInfo
            if valuebar.fightTierBox then
                tierInfo = tonumber(valuebar.fightTierBox:GetText())
                if valuebar.fightTierOverrideBox and valuebar.fightTierOverrideBox:IsChecked() then
                    tierInfo = valuebar.fightTierOverrideBox:IsChecked()
                end
            end

            if triggerToken then
                triggerEntry = {
                    ["Target_Name"] = tostring(valuebar.nameTextBox:GetText()),
                    ["Event"] = valuebar.eventKeywordBox and tostring(valuebar.eventKeywordBox:GetText()) or "",
                    ["Number"] = valuebar.thresholdNumberTextBox and tonumber(valuebar.thresholdNumberTextBox:GetText()),
                    ["Operator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText() or "<=",
                    ["Phase"] = valuebar.FightPhaseBox and tonumber(valuebar.FightPhaseBox:GetText()),
                    ["Boss_Name"] = valuebar.fightButton and tostring(valuebar.fightButton:GetText()),
                    ["Tier_Info"] = tierInfo,
                    ["Args"] = valuebar.argBox and valuebar.argBox:GetText() or "",
                }
                if func(triggerToken, triggerEntry) then
                    return
                end

                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
                valuebar.listbox:SetVisible(true)
            end

        elseif UIType == "Effect Listbox" then

            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            
            if triggerToken then
                triggerEntry = {
                }
                if func(triggerToken, triggerEntry) then
                    return
                end

                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
                valuebar.listbox:SetVisible(true)
            end
        elseif UIType == "User Variables" then

            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            
            local valueType = valuebar.typeButton:GetText()

            if valueType == "Type" then return end

            if triggerToken then
                triggerEntry = {
                    ["Type"] = valueType,
                    ["Value"] = valueType == "boolean" and true or valueType == "number" and 0 or valueType == "string" and "" or "",
                }
                if func(triggerToken, triggerEntry) then
                    return
                end

                valuebar.listbox:AddItem(GetListboxTiemPrimeUIEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
                valuebar.listbox:SetVisible(true)
            end
        end
    end

    optionsTreeNode:Add(valuebar)

    return headerNode
end

function InfoButton(parent, width, x, y, text, infoWindow)
    local SelectButton = Turbine.UI.Control()
	SelectButton:SetParent(parent)
	SelectButton:SetSize(16, 16)
    --SelectButton:SetBackColor(GetRandomColour())
    SelectButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SelectButton:SetBackground(BackgroundHandler:GetBackground(0x41168DAC))
	SelectButton:SetPosition(x, y)
    SelectButton.Text = text
    SelectButton.MouseEnter = function()
        infoWindow:View(SelectButton.Text)
    end

    SelectButton.MouseLeave = function()
        infoWindow:SetVisible(false)
    end

    return SelectButton
end