function GetListboxTiemPrimeUIEntry(key, value, width, triggerType, UIType, func, listbox)
    local listBoxItem = Turbine.UI.Control()
    listBoxItem:SetMouseVisible(false)
    listBoxItem:SetSize(width, 20)
    listBoxItem:SetBackColor(Turbine.UI.Color.Black)

    local innerWidth = width - 2

    local itemHeight = 0

    listBoxItem.InnerBox = Turbine.UI.Control()
    listBoxItem.InnerBox:SetParent(listBoxItem)
    listBoxItem.InnerBox:SetPosition(1, 1)
    listBoxItem.InnerBox:SetSize(innerWidth, 18)
    listBoxItem.InnerBox:SetBackColor(Turbine.UI.Color.DarkSlateBlue)

    listBoxItem.label = Turbine.UI.Label()
	listBoxItem.label:SetParent(listBoxItem.InnerBox)
	listBoxItem.label:SetSize(innerWidth, 25)
	listBoxItem.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	listBoxItem.label:SetPosition(0, itemHeight)
    if string.find(triggerType, "Fight") then
        listBoxItem.label:SetText(tostring(value.Boss_Name))
    elseif string.find(triggerType, "Resource") then
        listBoxItem.label:SetVisible(false)
    elseif string.find(triggerType, "HealthThreshold") and UIType == "Conditions" then
        listBoxItem.label:SetText(tostring(value.Number))
    elseif not(string.find(triggerType, "DNF")) then
        listBoxItem.label:SetText(tostring(key))
    end
    listBoxItem.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    listBoxItem.label:SetOutlineColor(Turbine.UI.Color.Black)
    listBoxItem.label:SetBackColor(Turbine.UI.Color(0.2,0.15,0.53))

    listBoxItem.RemovalButton = Turbine.UI.Lotro.Button()
    listBoxItem.RemovalButton:SetParent(listBoxItem.InnerBox)
    listBoxItem.RemovalButton:SetSize(100, 20)
    listBoxItem.RemovalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.RemovalButton:SetMouseVisible(false)
    listBoxItem.RemovalButton:SetPosition(width - 110, itemHeight + 2)
    listBoxItem.RemovalButton:SetText("Remove")

    listBoxItem.RemovalButton.Click = function()
        func(key, nil)
        listbox:RemoveItem(listBoxItem)
    end

    listBoxItem.headerDivider = Turbine.UI.Control()
    listBoxItem.headerDivider:SetParent(listBoxItem.InnerBox)
    listBoxItem.headerDivider:SetPosition(0, 25)
    listBoxItem.headerDivider:SetSize(innerWidth, 1)
    listBoxItem.headerDivider:SetBackColor(Turbine.UI.Color.Black)

    itemHeight = itemHeight + 35

    -- Handle time in trigger
    if (UIType == "Icon" or UIType == "Text") and triggerType ~= "HealthThreshold" then
        listBoxItem.iconShowBox = Turbine.UI.Lotro.CheckBox()
        listBoxItem.iconShowBox:SetParent(listBoxItem.InnerBox)
        listBoxItem.iconShowBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        listBoxItem.iconShowBox:SetChecked(value)
        listBoxItem.iconShowBox:SetPosition(0, itemHeight)
        listBoxItem.iconShowBox:SetSize(100, 20)
        listBoxItem.iconShowBox:SetText("Toggle")

        listBoxItem.iconShowBox.CheckedChanged = function()
            listBoxItem.ChangeFunction()
        end

        itemHeight = itemHeight + 25
    elseif UIType == "Note Event" or  UIType == "Note Activation" then
        listBoxItem.noteEventBar = Turbine.UI.Lotro.TextBox()
        listBoxItem.noteEventBar:SetParent(listBoxItem.InnerBox)
        listBoxItem.noteEventBar:SetSize(300, 20)
        listBoxItem.noteEventBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        listBoxItem.noteEventBar:SetPosition(0, itemHeight)
        if type(value) ==  "table" then
            if string.find(triggerType, "HealthThreshold") then
                listBoxItem.noteEventBar:SetText(value.Event)
            elseif value.Event then
                listBoxItem.noteEventBar:SetText(value.Event)
            elseif value.Note_Name then
                listBoxItem.noteEventBar:SetText(value.Note_Name)
            end
        else
            listBoxItem.noteEventBar:SetText(value)
        end

        listBoxItem.noteEventBar.TextChanged = function()
            listBoxItem.ChangeFunction()
        end

        itemHeight = itemHeight + 25
    elseif UIType == "Sound" then
        listBoxItem.soundButton = Turbine.UI.Lotro.Button()
        listBoxItem.soundButton:SetParent(listBoxItem.InnerBox)
        listBoxItem.soundButton:SetSize(100, 20)
        listBoxItem.soundButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        listBoxItem.soundButton:SetPosition(0, itemHeight)
        if string.find(triggerType, "HealthThreshold") then
            listBoxItem.soundButton:SetText(value.Sound)
        else
            listBoxItem.soundButton:SetText(value)
        end

        listBoxItem.soundMenu = UI.DropDownMenuControl(nil, 200, "Sound Menu")
        for key, value in spairs(Sounds:GetSoundList(), function(t, a, b) return a < b end) do
            listBoxItem.soundMenu:AddItem(key, 
            function()
                listBoxItem.soundButton:SetText(key)
                listBoxItem.soundMenu:ToggleVisible()
            end)
        end
    
        listBoxItem.soundButton.Click = function()
            listBoxItem.soundMenu:ToggleVisible()
        end

        itemHeight = itemHeight + 25
    elseif UIType == "Countdown" or UIType == "SkillLabel" or UIType == "TimerIcon" or UIType == "ValueBar" or value.Time or value.Countdown then
        if (UIType == "Countdown" or UIType == "SkillLabel" or UIType == "TimerIcon" or UIType == "ValueBar") and (type(value) == "number" or type(value) == "boolean") then
            listBoxItem.countdownTypeInfoLabel = Turbine.UI.Label()
            listBoxItem.countdownTypeInfoLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.countdownTypeInfoLabel:SetSize(50, 20)
            listBoxItem.countdownTypeInfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.countdownTypeInfoLabel:SetPosition(0, itemHeight)
            listBoxItem.countdownTypeInfoLabel:SetText("Time:")

            listBoxItem.countdownTypeBar = Turbine.UI.Lotro.TextBox()
            listBoxItem.countdownTypeBar:SetParent(listBoxItem.InnerBox)
            listBoxItem.countdownTypeBar:SetSize(50, 20)
            listBoxItem.countdownTypeBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.countdownTypeBar:SetPosition(40, itemHeight)
            if type(value) == "number" then
                listBoxItem.countdownTypeBar:SetText(tonumber(value))
            else
                --listBoxItem.countdownTypeBar:SetText("Time from trigger")
            end

            listBoxItem.countdownTypeBar.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        elseif value.Time then
            listBoxItem.timeInfoLabel = Turbine.UI.Label()
            listBoxItem.timeInfoLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.timeInfoLabel:SetSize(50, 20)
            listBoxItem.timeInfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.timeInfoLabel:SetPosition(0, itemHeight)
            listBoxItem.timeInfoLabel:SetText("Time:")

            listBoxItem.timeBar = Turbine.UI.Lotro.TextBox()
            listBoxItem.timeBar:SetParent(listBoxItem.InnerBox)
            listBoxItem.timeBar:SetSize(50, 20)
            listBoxItem.timeBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.timeBar:SetPosition(40, itemHeight)
            listBoxItem.timeBar:SetText(tonumber(value.Time))

            listBoxItem.timeBar.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        elseif value.Countdown then
            listBoxItem.countdownInfoLabel = Turbine.UI.Label()
            listBoxItem.countdownInfoLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.countdownInfoLabel:SetSize(50, 20)
            listBoxItem.countdownInfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.countdownInfoLabel:SetPosition(0, itemHeight)
            listBoxItem.countdownInfoLabel:SetText("Time:")

            listBoxItem.countdownBar = Turbine.UI.Lotro.TextBox()
            listBoxItem.countdownBar:SetParent(listBoxItem.InnerBox)
            listBoxItem.countdownBar:SetSize(50, 20)
            listBoxItem.countdownBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.countdownBar:SetPosition(40, itemHeight)
            listBoxItem.countdownBar:SetText(tonumber(value.Countdown))

            listBoxItem.countdownBar.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        if (string.find(triggerType, "Effect") and not(string.find(triggerType, "Highlight"))) or string.find(triggerType, "Skill") or string.find(triggerType, "DNF") then
            listBoxItem.timerCheckBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.timerCheckBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.timerCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            if UIType == "SkillLabel" or UIType == "ValueBar" then
                if type(value) == "table" then
                    listBoxItem.timerCheckBox:SetChecked(value.Countdown == true)
                else
                    listBoxItem.timerCheckBox:SetChecked(value == true)
                end
            elseif  UIType == "TimerIcon" then
                if type(value) == "table" and value.Countdown then
                    listBoxItem.timerCheckBox:SetChecked(value.Countdown == true)
                elseif type(value) == "bool" then
                    listBoxItem.timerCheckBox:SetChecked(value)
                end
            elseif UIType == "Countdown" then
                if type(value) == "table" and value.Countdown then
                    listBoxItem.timerCheckBox:SetChecked(value.Countdown == true)
                elseif type(value) == "bool" then
                    listBoxItem.timerCheckBox:SetChecked(value)
                end
            elseif UIType == "AlertGroup" then
                listBoxItem.timerCheckBox:SetChecked(value.Countdown == true)
            else
                listBoxItem.timerCheckBox:SetChecked(value.Time == true)
            end
            if string.find(triggerType, "Skill") then
                listBoxItem.timerCheckBox:SetText("Use skill cooldown as time")
                listBoxItem.timerCheckBox:SetPosition(100, itemHeight)
                listBoxItem.timerCheckBox:SetSize(250, 20)
            else
                listBoxItem.timerCheckBox:SetText("Use duration as time")
                listBoxItem.timerCheckBox:SetPosition(100, itemHeight)
                listBoxItem.timerCheckBox:SetSize(200, 20)
            end  

            listBoxItem.timerCheckBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        itemHeight = itemHeight + 25
    end

    if UIType == "User Variables" then
        if value.Type == "boolean" then
            listBoxItem.variableBooleanBar = Turbine.UI.Lotro.CheckBox()
            listBoxItem.variableBooleanBar:SetParent(listBoxItem.InnerBox)
            listBoxItem.variableBooleanBar:SetSize(300, 20)
            listBoxItem.variableBooleanBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.variableBooleanBar:SetPosition(40, itemHeight)
            listBoxItem.variableBooleanBar:SetText("Value")
            listBoxItem.variableBooleanBar:SetChecked(value.Value)

            listBoxItem.variableBooleanBar.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end
        elseif value.Type == "number" then
            listBoxItem.variableNumberBar = Turbine.UI.Lotro.TextBox()
            listBoxItem.variableNumberBar:SetParent(listBoxItem.InnerBox)
            listBoxItem.variableNumberBar:SetSize(300, 20)
            listBoxItem.variableNumberBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.variableNumberBar:SetPosition(40, itemHeight)
            listBoxItem.variableNumberBar:SetText(tonumber(value.Value))

            listBoxItem.variableNumberBar.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        else
            listBoxItem.variableStringBar = Turbine.UI.Lotro.TextBox()
            listBoxItem.variableStringBar:SetParent(listBoxItem.InnerBox)
            listBoxItem.variableStringBar:SetSize(300, 20)
            listBoxItem.variableStringBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.variableStringBar:SetPosition(40, itemHeight)
            listBoxItem.variableStringBar:SetText(value.Value)

            listBoxItem.variableStringBar.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        itemHeight = itemHeight + 25
    end

    if type(value) == "table" then

        if value.Operator then
            listBoxItem.operatorLabel = Turbine.UI.Label()
            listBoxItem.operatorLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.operatorLabel:SetSize(100, 20)
            listBoxItem.operatorLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            if UIType == "Icon" or UIType == "Text" then 
                itemHeight = itemHeight + 25
            end
            listBoxItem.operatorLabel:SetPosition(innerWidth - 150, itemHeight - 25) 
            listBoxItem.operatorLabel:SetText(tostring(value.Operator))


        end

        if value.Operator and value.Number and UIType ~= "Sound" then
            listBoxItem.healthThresholdTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.healthThresholdTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.healthThresholdTextBox:SetSize(50, 20)
            listBoxItem.healthThresholdTextBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.healthThresholdTextBox:SetPosition(innerWidth - 50, itemHeight - 25)
            listBoxItem.healthThresholdTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
            listBoxItem.healthThresholdTextBox:SetText(tostring(value.Number))

            listBoxItem.healthThresholdTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        -- Handle text in trigger
        if value.Message then
            listBoxItem.messageTextLabel = Turbine.UI.Label()
            listBoxItem.messageTextLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.messageTextLabel:SetSize(80, 20)
            listBoxItem.messageTextLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.messageTextLabel:SetPosition(0, itemHeight)
            listBoxItem.messageTextLabel:SetText("Text shown: ")

            listBoxItem.messageTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.messageTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.messageTextBox:SetSize(innerWidth - 80, 20)
            listBoxItem.messageTextBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.messageTextBox:SetPosition(80, itemHeight)
            listBoxItem.messageTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
            listBoxItem.messageTextBox:SetText(tostring(value.Message))

            listBoxItem.messageTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        -- Handle threshold value for resource in conditions
        if value.Number and triggerType == "Resource" then
            listBoxItem.comparatorTextLabel = Turbine.UI.Label()
            listBoxItem.comparatorTextLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.comparatorTextLabel:SetSize(200, 20)
            listBoxItem.comparatorTextLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.comparatorTextLabel:SetPosition(0, itemHeight)
            listBoxItem.comparatorTextLabel:SetText(string.format("Operator: %s", value.Comparator))

            itemHeight = itemHeight + 25

            listBoxItem.conditionThresholdLabel = Turbine.UI.Label()
            listBoxItem.conditionThresholdLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.conditionThresholdLabel:SetSize(80, 20)
            listBoxItem.conditionThresholdLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.conditionThresholdLabel:SetPosition(0, itemHeight)
            listBoxItem.conditionThresholdLabel:SetText("Threshold Value: ")

            listBoxItem.conditionThresholdTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.conditionThresholdTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.conditionThresholdTextBox:SetSize(innerWidth - 80, 20)
            listBoxItem.conditionThresholdTextBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.conditionThresholdTextBox:SetPosition(80, itemHeight)
            listBoxItem.conditionThresholdTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
            listBoxItem.conditionThresholdTextBox:SetText(tostring(value.Number))

            listBoxItem.conditionThresholdTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        -- HealthThreshold operator
        if value.Comparator and triggerType == "HealthThreshold" then
            listBoxItem.comparatorTextLabel = Turbine.UI.Label()
            listBoxItem.comparatorTextLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.comparatorTextLabel:SetSize(200, 20)
            listBoxItem.comparatorTextLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.comparatorTextLabel:SetPosition(0, itemHeight)
            listBoxItem.comparatorTextLabel:SetText(string.format("Operator: %s", value.Comparator))

            itemHeight = itemHeight + 25
        end

        if value.Text then
            listBoxItem.textLabel = Turbine.UI.Label()
            listBoxItem.textLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.textLabel:SetSize(80, 20)
            listBoxItem.textLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.textLabel:SetPosition(0, itemHeight)
            listBoxItem.textLabel:SetText("Text shown: ")

            listBoxItem.textBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.textBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.textBox:SetSize(innerWidth - 80, 20)
            listBoxItem.textBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.textBox:SetPosition(80, itemHeight)
            listBoxItem.textBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
            listBoxItem.textBox:SetText(tostring(value.Text))

            listBoxItem.textBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end


        if value.Condition_Name then
            listBoxItem.conditionLabel = Turbine.UI.Label()
            listBoxItem.conditionLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.conditionLabel:SetSize(80, 20)
            listBoxItem.conditionLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.conditionLabel:SetPosition(0, itemHeight)
            listBoxItem.conditionLabel:SetText("Condition Name: ")

            listBoxItem.conditionTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.conditionTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.conditionTextBox:SetSize(innerWidth - 80, 20)
            listBoxItem.conditionTextBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.conditionTextBox:SetPosition(80, itemHeight)
            listBoxItem.conditionTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
            listBoxItem.conditionTextBox:SetText(tostring(value.Condition_Name))

            listBoxItem.conditionTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        -- Handle Unique value
        if value.Unique ~= nil then
            listBoxItem.uniqueCheckBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.uniqueCheckBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.uniqueCheckBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.uniqueCheckBox:SetChecked(value.Unique)
            listBoxItem.uniqueCheckBox:SetPosition(0, itemHeight)
            listBoxItem.uniqueCheckBox:SetSize(100, 20)
            listBoxItem.uniqueCheckBox:SetText("Unique")

            listBoxItem.uniqueCheckBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end

        end

        if value.Override ~= nil then
            listBoxItem.overrideCheckBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.overrideCheckBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.overrideCheckBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.overrideCheckBox:SetChecked(value.Override)
            listBoxItem.overrideCheckBox:SetPosition(200, itemHeight)
            listBoxItem.overrideCheckBox:SetSize(100, 20)
            listBoxItem.overrideCheckBox:SetText("Override")

            listBoxItem.overrideCheckBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if  UIType == "TimerGroup" then
            listBoxItem.increaseCheckbox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.increaseCheckbox:SetParent(listBoxItem.InnerBox)
            listBoxItem.increaseCheckbox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.increaseCheckbox:SetChecked(value.Increasing)
            listBoxItem.increaseCheckbox:SetPosition(0, itemHeight)
            listBoxItem.increaseCheckbox:SetSize(100, 20)
            listBoxItem.increaseCheckbox:SetText("Increase")

            listBoxItem.increaseCheckbox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        -- Handle Highlight value
        if value.Highlight ~= nil then
            listBoxItem.highlightCheckbox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.highlightCheckbox:SetParent(listBoxItem.InnerBox)
            listBoxItem.highlightCheckbox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.highlightCheckbox:SetChecked(value.Highlight)
            listBoxItem.highlightCheckbox:SetPosition(100, itemHeight)
            listBoxItem.highlightCheckbox:SetSize(100, 20)
            listBoxItem.highlightCheckbox:SetText("Highlight")

            listBoxItem.highlightCheckbox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        if value.Highlight_Value ~= nil then
            listBoxItem.skillLabelhighlightCheckbox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.skillLabelhighlightCheckbox:SetParent(listBoxItem.InnerBox)
            listBoxItem.skillLabelhighlightCheckbox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.skillLabelhighlightCheckbox:SetChecked(value.Highlight_Value)
            listBoxItem.skillLabelhighlightCheckbox:SetPosition(100, itemHeight)
            listBoxItem.skillLabelhighlightCheckbox:SetSize(100, 20)
            listBoxItem.skillLabelhighlightCheckbox:SetText("Invert")

            listBoxItem.skillLabelhighlightCheckbox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        if value.Unique ~= nil or value.Highlight ~= nil or value.Highlight_Value ~= nil then
            itemHeight = itemHeight + 25
        end

        if value.Icon then
            listBoxItem.iconLabel = Turbine.UI.Label()
            listBoxItem.iconLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.iconLabel:SetSize(innerWidth - 100, 20)
            listBoxItem.iconLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.iconLabel:SetPosition(0, itemHeight)
            if value.Icon == true then
                if string.find(triggerType, "Effect") then
                    listBoxItem.iconLabel:SetText("Icon: Taken from Effect")
                else
                    listBoxItem.iconLabel:SetText("Icon: Taken from Skill")
                end
            else
                listBoxItem.iconLabel:SetText("Icon: " .. tostring(value.Icon))
            end

            if value.Match_icon ~= nil then
                listBoxItem.matchiconBox = Turbine.UI.Lotro.CheckBox()
                listBoxItem.matchiconBox:SetParent(listBoxItem.InnerBox)
                listBoxItem.matchiconBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
                listBoxItem.matchiconBox:SetChecked(value.Match_icon)
                listBoxItem.matchiconBox:SetPosition(innerWidth - 100, itemHeight)
                listBoxItem.matchiconBox:SetSize(100, 20)
                listBoxItem.matchiconBox:SetText("Match Icon")

                listBoxItem.matchiconBox.CheckedChanged = function()
                    listBoxItem.ChangeFunction()
                end
            end 

            if value.Match_Icon ~= nil then
                listBoxItem.matchIconBox = Turbine.UI.Lotro.CheckBox()
                listBoxItem.matchIconBox:SetParent(listBoxItem.InnerBox)
                listBoxItem.matchIconBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
                listBoxItem.matchIconBox:SetChecked(value.Match_Icon)
                listBoxItem.matchIconBox:SetPosition(innerWidth - 100, itemHeight)
                listBoxItem.matchIconBox:SetSize(100, 20)
                listBoxItem.matchIconBox:SetText("Match Icon")

                listBoxItem.matchIconBox.CheckedChanged = function()
                    listBoxItem.ChangeFunction()
                end
            end

            if value.Fit_Icon ~= nil then
                listBoxItem.fitIconBox = Turbine.UI.Lotro.CheckBox()
                listBoxItem.fitIconBox:SetParent(listBoxItem.InnerBox)
                listBoxItem.fitIconBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
                listBoxItem.fitIconBox:SetChecked(value.Fit_Icon)
                listBoxItem.fitIconBox:SetPosition(innerWidth - 100, itemHeight)
                listBoxItem.fitIconBox:SetSize(100, 20)
                listBoxItem.fitIconBox:SetText("Match Icon")

                listBoxItem.fitIconBox.CheckedChanged = function()
                    listBoxItem.ChangeFunction()
                end
            end

            if value.Show_Icon ~= nil then
                listBoxItem.showIconBox = Turbine.UI.Lotro.CheckBox()
                listBoxItem.showIconBox:SetParent(listBoxItem.InnerBox)
                listBoxItem.showIconBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
                listBoxItem.showIconBox:SetChecked(value.Show_Icon)
                listBoxItem.showIconBox:SetPosition(innerWidth - 200, itemHeight)
                listBoxItem.showIconBox:SetSize(100, 20)
                listBoxItem.showIconBox:SetText("Show Icon")

                listBoxItem.showIconBox.CheckedChanged = function()
                    listBoxItem.ChangeFunction()
                end
            end

            itemHeight = itemHeight + 25
        end

        if value.Tier_Info then
            listBoxItem.fightTierBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.fightTierBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.fightTierBox:SetSize(100, 20)
            listBoxItem.fightTierBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
            listBoxItem.fightTierBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.fightTierBox:SetMouseVisible(false)
            listBoxItem.fightTierBox:SetPosition(200, itemHeight)
            listBoxItem.fightTierBox:SetMultiline(false)
            if type(value.Tier_Info) == "number" then
                listBoxItem.fightTierBox:SetText(tostring(value.Tier_Info))
            end

            listBoxItem.fightTierBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
    
            listBoxItem.fightTierOverrideBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.fightTierOverrideBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.fightTierOverrideBox:SetSize(100, 20)
            listBoxItem.fightTierOverrideBox:SetPosition(320, itemHeight)
            listBoxItem.fightTierOverrideBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.fightTierOverrideBox:SetChecked(value.Tier_Info == true)
            listBoxItem.fightTierOverrideBox:SetText("All tiers")

            listBoxItem.fightTierOverrideBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if value.CCType then
            listBoxItem.ccTypeTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.ccTypeTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.ccTypeTextBox:SetSize(100, 20)
            listBoxItem.ccTypeTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
            listBoxItem.ccTypeTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.ccTypeTextBox:SetMouseVisible(false)
            listBoxItem.ccTypeTextBox:SetPosition(0, itemHeight)
            listBoxItem.ccTypeTextBox:SetMultiline(false)
            if type(value.CCType) == "string" then
                listBoxItem.ccTypeTextBox:SetText(tostring(value.CCType))
            end

            listBoxItem.ccTypeTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
    
            listBoxItem.ccTypeOverrideBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.ccTypeOverrideBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.ccTypeOverrideBox:SetSize(120, 20)
            listBoxItem.ccTypeOverrideBox:SetPosition(100, itemHeight)
            listBoxItem.ccTypeOverrideBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.ccTypeOverrideBox:SetChecked(value.CCType == true)
            listBoxItem.ccTypeOverrideBox:SetText("All CC Types")

            listBoxItem.ccTypeOverrideBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if  UIType == "TimerGroup" or UIType == "Timer" or UIType == "Countdown" or UIType == "Alert" or UIType == "AlertGroup" or UIType == "Circle Timer" then
            listBoxItem.eventTriggerLabel = Turbine.UI.Label()
            listBoxItem.eventTriggerLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.eventTriggerLabel:SetSize(120, 20)
            listBoxItem.eventTriggerLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
            listBoxItem.eventTriggerLabel:SetPosition(0, itemHeight)
            listBoxItem.eventTriggerLabel:SetText("Event Keyword: ")

            listBoxItem.eventTriggerTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.eventTriggerTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.eventTriggerTextBox:SetSize(200, 20)
            listBoxItem.eventTriggerTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
            listBoxItem.eventTriggerTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.eventTriggerTextBox:SetMouseVisible(false)
            listBoxItem.eventTriggerTextBox:SetPosition(120, itemHeight)
            listBoxItem.eventTriggerTextBox:SetMultiline(false)
            listBoxItem.eventTriggerTextBox:SetText(value.Event_Keyword or "")

            listBoxItem.eventTriggerTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if triggerType == "Corruption" then
            listBoxItem.targetLabel = Turbine.UI.Label()
            listBoxItem.targetLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.targetLabel:SetSize(250, 20)
            listBoxItem.targetLabel:SetPosition(0, itemHeight)
            listBoxItem.targetLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.targetLabel:SetText("Target name (Empty for all)")
        
            listBoxItem.targetNameBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.targetNameBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.targetNameBox:SetSize(100, 20)
            listBoxItem.targetNameBox:SetPosition(250, itemHeight)
            listBoxItem.targetNameBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.targetNameBox:SetText(value.Target)

            listBoxItem.targetNameBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25

            listBoxItem.effectLabel = Turbine.UI.Label()
            listBoxItem.effectLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.effectLabel:SetSize(250, 20)
            listBoxItem.effectLabel:SetPosition(0, itemHeight)
            listBoxItem.effectLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.effectLabel:SetText("Effect name (Empty for all)")
        
            listBoxItem.effectBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.effectBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.effectBox:SetSize(100, 20)
            listBoxItem.effectBox:SetPosition(250, itemHeight)
            listBoxItem.effectBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.effectBox:SetText(value.EffectName)

            listBoxItem.effectBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if triggerType == "Event Keyword" then
            listBoxItem.eventKeywordLabel = Turbine.UI.Label()
            listBoxItem.eventKeywordLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.eventKeywordLabel:SetSize(80, 20)
            listBoxItem.eventKeywordLabel:SetPosition(0, itemHeight)
            listBoxItem.eventKeywordLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.eventKeywordLabel:SetText("Event:")
        
            listBoxItem.eventKeywordBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.eventKeywordBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.eventKeywordBox:SetSize(100, 20)
            listBoxItem.eventKeywordBox:SetPosition(80, itemHeight)
            listBoxItem.eventKeywordBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.eventKeywordBox:SetText(value.Event_Keyword)

            listBoxItem.eventKeywordBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if value.Event then
            listBoxItem.eventKeywordUILabel = Turbine.UI.Label()
            listBoxItem.eventKeywordUILabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.eventKeywordUILabel:SetSize(80, 20)
            listBoxItem.eventKeywordUILabel:SetPosition(0, itemHeight)
            listBoxItem.eventKeywordUILabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.eventKeywordUILabel:SetText("Event:")
        
            listBoxItem.eventKeywordUIBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.eventKeywordUIBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.eventKeywordUIBox:SetSize(100, 20)
            listBoxItem.eventKeywordUIBox:SetPosition(80, itemHeight)
            listBoxItem.eventKeywordUIBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.eventKeywordUIBox:SetText(value.Event)

            listBoxItem.eventKeywordUIBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if (triggerType == "Target_HealthThreshold" or triggerType == "EventTrigger" or triggerType == "EffectAdded_Target" or triggerType == "Effects" or triggerType == "Skill_Ready") and UIType == "Conditions" then       
            listBoxItem.notAppliedBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.notAppliedBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.notAppliedBox:SetSize(100, 20)
            listBoxItem.notAppliedBox:SetPosition(0, itemHeight)
            listBoxItem.notAppliedBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.notAppliedBox:SetText("Not applied")
            listBoxItem.notAppliedBox:SetChecked(value.Not_Applied)

            listBoxItem.notAppliedBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if (value.Comparator or value.Operator) and triggerType == "Target_HealthThreshold" then
            listBoxItem.ComparatorLabel = Turbine.UI.Label()
            listBoxItem.ComparatorLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.ComparatorLabel:SetSize(80, 20)
            listBoxItem.ComparatorLabel:SetPosition(0, itemHeight)
            listBoxItem.ComparatorLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.ComparatorLabel:SetText(tostring(value.Comparator or value.Operator))

            itemHeight = itemHeight + 25
        end

        if value.Phase then
            listBoxItem.phaseLabel = Turbine.UI.Label()
            listBoxItem.phaseLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.phaseLabel:SetSize(80, 20)
            listBoxItem.phaseLabel:SetPosition(0, itemHeight)
            listBoxItem.phaseLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.phaseLabel:SetText("Phase:")
        
            listBoxItem.phaseBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.phaseBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.phaseBox:SetSize(100, 20)
            listBoxItem.phaseBox:SetPosition(80, itemHeight)
            listBoxItem.phaseBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.phaseBox:SetText(value.Phase)

            listBoxItem.phaseBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end

        if UIType == "Counter" then
            listBoxItem.counterTextLabel = Turbine.UI.Label()
            listBoxItem.counterTextLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.counterTextLabel:SetSize(250, 20)
            listBoxItem.counterTextLabel:SetPosition(0, itemHeight)
            listBoxItem.counterTextLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.counterTextLabel:SetText("Counter Text")
        
            listBoxItem.counterTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.counterTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.counterTextBox:SetSize(100, 20)
            listBoxItem.counterTextBox:SetPosition(250, itemHeight)
            listBoxItem.counterTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.counterTextBox:SetText(value.Text)

            listBoxItem.counterTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25

            listBoxItem.startCountLabel = Turbine.UI.Label()
            listBoxItem.startCountLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.startCountLabel:SetSize(250, 20)
            listBoxItem.startCountLabel:SetPosition(0, itemHeight)
            listBoxItem.startCountLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.startCountLabel:SetText("Start Count")
        
            listBoxItem.startCountTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.startCountTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.startCountTextBox:SetSize(100, 20)
            listBoxItem.startCountTextBox:SetPosition(250, itemHeight)
            listBoxItem.startCountTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.startCountTextBox:SetText(value.StartCount)

            listBoxItem.startCountTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25

            listBoxItem.minVisLabel = Turbine.UI.Label()
            listBoxItem.minVisLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.minVisLabel:SetSize(130, 20)
            listBoxItem.minVisLabel:SetPosition(0, itemHeight)
            listBoxItem.minVisLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.minVisLabel:SetText("Minimal visiblity:")
        
            listBoxItem.minVisBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.minVisBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.minVisBox:SetSize(50, 20)
            listBoxItem.minVisBox:SetPosition(130, itemHeight)
            listBoxItem.minVisBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.minVisBox:SetText(value.MinVis)

            listBoxItem.minVisBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        
            listBoxItem.maxVisLabel = Turbine.UI.Label()
            listBoxItem.maxVisLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.maxVisLabel:SetSize(135, 20)
            listBoxItem.maxVisLabel:SetPosition(180, itemHeight)
            listBoxItem.maxVisLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.maxVisLabel:SetText("Maximal visibility:")
        
            listBoxItem.maxVisBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.maxVisBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.maxVisBox:SetSize(50, 20)
            listBoxItem.maxVisBox:SetPosition(310, itemHeight)
            listBoxItem.maxVisBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.maxVisBox:SetText(value.MaxVis)

            listBoxItem.maxVisBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        
            itemHeight = itemHeight + 25
    
            listBoxItem.decrementBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.decrementBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.decrementBox:SetSize(100, 20)
            listBoxItem.decrementBox:SetPosition(0, itemHeight)
            listBoxItem.decrementBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.decrementBox:SetText("Decrement")
            listBoxItem.decrementBox:SetChecked(value.Decrement)

            listBoxItem.decrementBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
    
            listBoxItem.numberTextLabel = Turbine.UI.Label()
            listBoxItem.numberTextLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.numberTextLabel:SetSize(150, 20)
            listBoxItem.numberTextLabel:SetPosition(0, itemHeight)
            listBoxItem.numberTextLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.numberTextLabel:SetText("Inc/dec amount:")
        
            listBoxItem.numberTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.numberTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.numberTextBox:SetSize(50, 20)
            listBoxItem.numberTextBox:SetPosition(150, itemHeight)
            listBoxItem.numberTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.numberTextBox:SetText(value.Number)

            listBoxItem.numberTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
    
            listBoxItem.effectTextLabel = Turbine.UI.Label()
            listBoxItem.effectTextLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.effectTextLabel:SetSize(150, 20)
            listBoxItem.effectTextLabel:SetPosition(0, itemHeight)
            listBoxItem.effectTextLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.effectTextLabel:SetText("EffectName:")
        
            listBoxItem.effectTextBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.effectTextBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.effectTextBox:SetSize(50, 20)
            listBoxItem.effectTextBox:SetPosition(150, itemHeight)
            listBoxItem.effectTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.effectTextBox:SetText(value.EffectName)

            listBoxItem.effectTextBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end
        end

        if UIType == "BuffBar" then
            listBoxItem.lowerWiggleLabel = Turbine.UI.Label()
            listBoxItem.lowerWiggleLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.lowerWiggleLabel:SetSize(200, 20)
            listBoxItem.lowerWiggleLabel:SetPosition(0, itemHeight)
            listBoxItem.lowerWiggleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.lowerWiggleLabel:SetText("Wiggle Stop Time:")
        
            listBoxItem.lowerWiggleBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.lowerWiggleBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.lowerWiggleBox:SetSize(100, 20)
            listBoxItem.lowerWiggleBox:SetPosition(200, itemHeight)
            listBoxItem.lowerWiggleBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.lowerWiggleBox:SetText((value.Wiggle_Lower or 0))
    
            listBoxItem.lowerWiggleBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
            
            listBoxItem.upperWiggleLabel = Turbine.UI.Label()
            listBoxItem.upperWiggleLabel:SetParent(listBoxItem.InnerBox)
            listBoxItem.upperWiggleLabel:SetSize(200, 20)
            listBoxItem.upperWiggleLabel:SetPosition(0, itemHeight)
            listBoxItem.upperWiggleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.upperWiggleLabel:SetText("Wiggle Start Time:")
        
            listBoxItem.upperWiggleBox = Turbine.UI.Lotro.TextBox()
            listBoxItem.upperWiggleBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.upperWiggleBox:SetSize(100, 20)
            listBoxItem.upperWiggleBox:SetPosition(200, itemHeight)
            listBoxItem.upperWiggleBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.upperWiggleBox:SetText((value.Wiggle_Upper or 0))

            listBoxItem.upperWiggleBox.TextChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25

            listBoxItem.alwaysWiggleBox = Turbine.UI.Lotro.CheckBox()
            listBoxItem.alwaysWiggleBox:SetParent(listBoxItem.InnerBox)
            listBoxItem.alwaysWiggleBox:SetSize(200, 20)
            listBoxItem.alwaysWiggleBox:SetPosition(320, itemHeight)
            listBoxItem.alwaysWiggleBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            listBoxItem.alwaysWiggleBox:SetChecked(value.Always_Wiggle)
            listBoxItem.alwaysWiggleBox:SetText("Always wiggle")

            listBoxItem.alwaysWiggleBox.CheckedChanged = function()
                listBoxItem.ChangeFunction()
            end

            itemHeight = itemHeight + 25
        end
    end



    listBoxItem.InnerBox:SetSize(innerWidth, itemHeight)
    listBoxItem:SetSize(width, itemHeight + 2)

    listBoxItem.ChangeFunction = function()
        func(key, nil)

        -- CHeck special case for countdown
        if listBoxItem.countdownTypeBar and not(string.find(triggerType, "Target_HealthThreshold")) then
            local time = tonumber(listBoxItem.countdownTypeBar:GetText()) or 0
            if listBoxItem.timerCheckBox and listBoxItem.timerCheckBox:IsChecked() then time = listBoxItem.timerCheckBox:IsChecked() end
            func(key, tonumber(time))
            return
        end

        -- Handle Icon case
        if listBoxItem.iconShowBox then
            func(key, listBoxItem.iconShowBox:IsChecked())
            return
        end

        -- Handle note activation case
        if UIType == "Note Activation" then
            func(key, tostring(listBoxItem.noteEventBar:GetText()))
            return
        end

        -- Hanlde special note case
        if UIType == "Note Event" and not(string.find(triggerType, "HealthThreshold")) then
            func(key, tostring(listBoxItem.noteEventBar:GetText()))
            return
        end

        -- Handle special sound case
        if UIType == "Sound" and not(string.find(triggerType, "HealthThreshold")) then
            func(key, tostring(listBoxItem.soundButton:GetText()))
            return
        end

        if UIType == "ValueBar" and type(value) ~= "table" then
            local countdownValue = tonumber(listBoxItem.countdownBar:GetText()) or 0
            if listBoxItem.timerCheckBox and listBoxItem.timerCheckBox:IsChecked() then countdownValue = listBoxItem.timerCheckBox:IsChecked() end
            func(key, countdownValue)
            return
        end


        local rewrittenValue = {}
        for valueKey, valueValue in pairs(value) do
            rewrittenValue[valueKey] = valueValue
        end
        
        -- Check for timer value
        if listBoxItem.timeBar then 
            rewrittenValue.Time = tonumber(listBoxItem.timeBar:GetText()) or 0
            if listBoxItem.timerCheckBox and listBoxItem.timerCheckBox:IsChecked() then rewrittenValue.Time = listBoxItem.timerCheckBox:IsChecked() end
        end

        if listBoxItem.countdownBar then 
            rewrittenValue.Countdown = tonumber(listBoxItem.countdownBar:GetText()) or 0
            if listBoxItem.timerCheckBox and listBoxItem.timerCheckBox:IsChecked() then rewrittenValue.Countdown = listBoxItem.timerCheckBox:IsChecked() end
        end

        -- Check health threshold value
        if listBoxItem.healthThresholdTextBox then
            rewrittenValue.Number = tonumber(listBoxItem.healthThresholdTextBox:GetText())
        end

        if listBoxItem.variableBooleanBar then
            rewrittenValue.Value = listBoxItem.variableBooleanBar:IsChecked()
        end

        if listBoxItem.variableNumberBar then
            rewrittenValue.Value = tonumber(listBoxItem.variableNumberBar:GetText()) or 0
        end

        if listBoxItem.variableStringBar then
            rewrittenValue.Value = tostring(listBoxItem.variableStringBar:GetText()) or ""
        end

        -- Check text for UI element
        if listBoxItem.messageTextBox then
            rewrittenValue.Message = tostring(listBoxItem.messageTextBox:GetText())
        end

        if listBoxItem.textBox then
            rewrittenValue.Text = tostring(listBoxItem.textBox:GetText())
        end

        -- Check unique value
        if listBoxItem.uniqueCheckBox then
            rewrittenValue.Unique = listBoxItem.uniqueCheckBox:IsChecked()
        end

        -- Check override value
        if listBoxItem.overrideCheckBox then
            rewrittenValue.Override = listBoxItem.overrideCheckBox:IsChecked()
        end

        -- Incrase value
        if  listBoxItem.increaseCheckbox then
            rewrittenValue.Increasing = listBoxItem.increaseCheckbox:IsChecked()
        end

        -- Highlight
        if listBoxItem.highlightCheckbox then
            rewrittenValue.Highlight = listBoxItem.highlightCheckbox:IsChecked()
        end

        -- Match Icon
        if listBoxItem.matchiconBox then
            rewrittenValue.Match_icon = listBoxItem.matchiconBox:IsChecked()
        end

        if listBoxItem.matchIconBox then
            rewrittenValue.Match_Icon = listBoxItem.matchIconBox:IsChecked()
        end

        if listBoxItem.fitIconBox then
            rewrittenValue.Fit_Icon = listBoxItem.fitIconBox:IsChecked()
        end

        --Not applied
        if listBoxItem.notAppliedBox then
            rewrittenValue.Not_Applied = listBoxItem.notAppliedBox:IsChecked()
        end

        -- Show Icon
        if listBoxItem.showIconBox then
            rewrittenValue.Show_Icon = listBoxItem.showIconBox:IsChecked()
        end

        -- Hanlde normal event
        if listBoxItem.noteEventBar then
            rewrittenValue.Event = tostring(listBoxItem.noteEventBar:GetText())
        end

        -- Handle threshold sound case
        if listBoxItem.soundButton then
            rewrittenValue.Sound =  tostring(listBoxItem.soundButton:GetText())
        end

        if listBoxItem.skillLabelhighlightCheckbox then
            rewrittenValue.Highlight_Value = listBoxItem.skillLabelhighlightCheckbox:IsChecked()
        end

        -- Resource threshold value
        if listBoxItem.conditionThresholdTextBox then
            rewrittenValue.Number = tonumber(tostring(listBoxItem.conditionThresholdTextBox:GetText())) or 0
        end

        -- Trigger keyword
        if listBoxItem.eventTriggerTextBox then
            if listBoxItem.eventTriggerTextBox:GetText() == "" then
                rewrittenValue.Event_Keyword = nil
            else
                rewrittenValue.Event_Keyword = tostring(listBoxItem.eventTriggerTextBox:GetText())
            end
        end

        if listBoxItem.counterTextBox then
            rewrittenValue.Text = tostring(listBoxItem.counterTextBox:GetText()) or ""
        end

        if listBoxItem.effectBox then
            rewrittenValue.EffectName = tostring(listBoxItem.effectBox:GetText()) or ""
        end

        if listBoxItem.startCountTextBox then
            rewrittenValue.StartCount = tonumber(tostring(listBoxItem.startCountTextBox:GetText())) or 0
        end

        if listBoxItem.targetNameBox then
            rewrittenValue.Target =  tonumber(tostring(listBoxItem.targetNameBox:GetText())) or ""
        end

        if listBoxItem.minVisBox then
            rewrittenValue.MinVis =  tonumber(tostring(listBoxItem.minVisBox:GetText())) or 0
        end

        if listBoxItem.maxVisBox then
            rewrittenValue.MaxVis =  tonumber(tostring(listBoxItem.maxVisBox:GetText())) or 0
        end

        if listBoxItem.decrementBox then
            rewrittenValue.Decrement =  listBoxItem.decrementBox:IsChecked()
        end

        if listBoxItem.numberTextBox then
            rewrittenValue.Number =  tonumber(tostring(listBoxItem.numberTextBox:GetText())) or 0
        end
        
        if listBoxItem.effectTextBox then
            rewrittenValue.EffectName = tostring(listBoxItem.effectTextBox:GetText()) or ""
        end

        if listBoxItem.eventKeywordBox then
            rewrittenValue.Event_Keyword = tostring(listBoxItem.eventKeywordBox:GetText()) or ""
        end

        if listBoxItem.eventKeywordUIBox then
            rewrittenValue.Event = tostring(listBoxItem.eventKeywordUIBox:GetText()) or ""
        end

        if listBoxItem.phaseBox then
            rewrittenValue.Phase = tonumber(tostring(listBoxItem.phaseBox:GetText()))
        end

        if listBoxItem.lowerWiggleBox then
            rewrittenValue.Wiggle_Lower = tonumber(tostring(listBoxItem.lowerWiggleBox:GetText()))
        end

        if listBoxItem.upperWiggleBox then
            rewrittenValue.Wiggle_Upper = tonumber(tostring(listBoxItem.upperWiggleBox:GetText()))
        end

        if listBoxItem.alwaysWiggleBox then
            rewrittenValue.Always_Wiggle = listBoxItem.alwaysWiggleBox:IsChecked()
        end

        if listBoxItem.fightTierBox then
            local tierInfo = tonumber(listBoxItem.fightTierBox:GetText()) or 1
            if listBoxItem.fightTierOverrideBox and listBoxItem.fightTierOverrideBox:IsChecked() then
                tierInfo = listBoxItem.fightTierOverrideBox:IsChecked()
            end

            rewrittenValue.Tier_Info = tierInfo
        end

        if listBoxItem.ccTypeTextBox then
            local ccTypeInfo = tostring(listBoxItem.ccTypeTextBox:GetText())
            if listBoxItem.ccTypeOverrideBox and listBoxItem.ccTypeOverrideBox:IsChecked() then
                ccTypeInfo = listBoxItem.ccTypeOverrideBox:IsChecked()
            end

            rewrittenValue.CCType = ccTypeInfo
        end

        func(key, rewrittenValue)
    end

    return listBoxItem
end