function GetListboxTiemPrimeUISkillEntry(key, value, width, triggerType, UIType, func, listbox)
    local listBoxItem = Turbine.UI.Control()
    listBoxItem:SetMouseVisible(false)
    listBoxItem:SetSize(width, 20)
    listBoxItem:SetBackColor(Turbine.UI.Color.Black)

    local innerWidth = width - 2

    local itemHeight = 0

    listBoxItem.InnerBox = Turbine.UI.Control()
    listBoxItem.InnerBox:SetParent(listBoxItem)
    listBoxItem.InnerBox:SetPosition(1, 1)
    listBoxItem.InnerBox:SetSize(innerWidth, 18)
    listBoxItem.InnerBox:SetBackColor(Turbine.UI.Color.DarkSlateBlue)

    listBoxItem.label = Turbine.UI.Label()
	listBoxItem.label:SetParent(listBoxItem.InnerBox)
	listBoxItem.label:SetSize(innerWidth, 25)
	listBoxItem.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	listBoxItem.label:SetPosition(0, itemHeight)
    listBoxItem.label:SetText(tostring(key))

    listBoxItem.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    listBoxItem.label:SetOutlineColor(Turbine.UI.Color.Black)
    listBoxItem.label:SetBackColor(Turbine.UI.Color(0.2,0.15,0.53))

    listBoxItem.RemovalButton = Turbine.UI.Lotro.Button()
    listBoxItem.RemovalButton:SetParent(listBoxItem.InnerBox)
    listBoxItem.RemovalButton:SetSize(100, 20)
    listBoxItem.RemovalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.RemovalButton:SetMouseVisible(false)
    listBoxItem.RemovalButton:SetPosition(width - 110, itemHeight + 2)
    listBoxItem.RemovalButton:SetText("Remove")

    listBoxItem.RemovalButton.Click = function()
        func(key, nil)
        listbox:RemoveItem(listBoxItem)
    end

    listBoxItem.headerDivider = Turbine.UI.Control()
    listBoxItem.headerDivider:SetParent(listBoxItem.InnerBox)
    listBoxItem.headerDivider:SetPosition(0, 25)
    listBoxItem.headerDivider:SetSize(innerWidth, 1)
    listBoxItem.headerDivider:SetBackColor(Turbine.UI.Color.Black)

    itemHeight = itemHeight + 35

    listBoxItem.timeInfoLabel = Turbine.UI.Label()
    listBoxItem.timeInfoLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.timeInfoLabel:SetSize(50, 20)
    listBoxItem.timeInfoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.timeInfoLabel:SetPosition(0, itemHeight)
    listBoxItem.timeInfoLabel:SetText("Time:")

    listBoxItem.timeBar = Turbine.UI.Lotro.TextBox()
    listBoxItem.timeBar:SetParent(listBoxItem.InnerBox)
    listBoxItem.timeBar:SetSize(50, 20)
    listBoxItem.timeBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.timeBar:SetPosition(40, itemHeight)
    listBoxItem.timeBar:SetText(tonumber(value.Time))

    listBoxItem.timeBar.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.timerCheckBox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.timerCheckBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.timerCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.timerCheckBox:SetChecked(value.Time == true)
    listBoxItem.timerCheckBox:SetText("Use skill cooldown as time")
    listBoxItem.timerCheckBox:SetPosition(100, itemHeight)
    listBoxItem.timerCheckBox:SetSize(250, 20)

    listBoxItem.timerCheckBox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    -- X & Y
    listBoxItem.XLabel = Turbine.UI.Label()
    listBoxItem.XLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.XLabel:SetSize(60, 20)
    listBoxItem.XLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.XLabel:SetPosition(0, itemHeight)
    listBoxItem.XLabel:SetText("X-order:")

    listBoxItem.XBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.XBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.XBox:SetSize(50, 20)
    listBoxItem.XBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.XBox:SetPosition(60, itemHeight)
    listBoxItem.XBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.XBox:SetText(tostring(value.XPrio))

    listBoxItem.XBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.YLabel = Turbine.UI.Label()
    listBoxItem.YLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.YLabel:SetSize(60, 20)
    listBoxItem.YLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.YLabel:SetPosition(110, itemHeight)
    listBoxItem.YLabel:SetText("Y-order:")

    listBoxItem.YBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.YBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.YBox:SetSize(50, 20)
    listBoxItem.YBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.YBox:SetPosition(170, itemHeight)
    listBoxItem.YBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.YBox:SetText(tostring(value.YPrio))

    listBoxItem.YBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.highlightBox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.highlightBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.highlightBox:SetSize(100, 20)
    listBoxItem.highlightBox:SetPosition(240, itemHeight)
    listBoxItem.highlightBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.highlightBox:SetText("Highlight")
    listBoxItem.highlightBox:SetChecked(value.Highlight)

    listBoxItem.highlightBox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.hideWhileOff = Turbine.UI.Lotro.CheckBox()
    listBoxItem.hideWhileOff:SetParent(listBoxItem.InnerBox)
    listBoxItem.hideWhileOff:SetSize(150, 20)
    listBoxItem.hideWhileOff:SetPosition(0, itemHeight)
    listBoxItem.hideWhileOff:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.hideWhileOff:SetText("Hide While Ready")
    listBoxItem.hideWhileOff:SetChecked(value.hideWhileOff)

    
    listBoxItem.hideWhileOff.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.hideWhileOn = Turbine.UI.Lotro.CheckBox()
    listBoxItem.hideWhileOn:SetParent(listBoxItem.InnerBox)
    listBoxItem.hideWhileOn:SetSize(150, 20)
    listBoxItem.hideWhileOn:SetPosition(150, itemHeight)
    listBoxItem.hideWhileOn:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.hideWhileOn:SetText("Hide While On CD")
    listBoxItem.hideWhileOn:SetChecked(value.hideWhileOn)

    
    listBoxItem.hideWhileOn.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.visibitilityThresholdLabel = Turbine.UI.Label()
    listBoxItem.visibitilityThresholdLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.visibitilityThresholdLabel:SetSize(150, 20)
    listBoxItem.visibitilityThresholdLabel:SetPosition(0, itemHeight)
    listBoxItem.visibitilityThresholdLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.visibitilityThresholdLabel:SetText("Visibilty Threshold:")

    listBoxItem.visibitilityThreshold = Turbine.UI.Lotro.TextBox()
    listBoxItem.visibitilityThreshold:SetParent(listBoxItem.InnerBox)
    listBoxItem.visibitilityThreshold:SetSize(100, 20)
    listBoxItem.visibitilityThreshold:SetPosition(150, itemHeight)
    listBoxItem.visibitilityThreshold:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.visibitilityThreshold:SetText(value.visibitilityThreshold)

    listBoxItem.visibitilityThreshold.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.opacityOnLabel = Turbine.UI.Label()
    listBoxItem.opacityOnLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.opacityOnLabel:SetSize(160, 20)
    listBoxItem.opacityOnLabel:SetPosition(0, itemHeight)
    listBoxItem.opacityOnLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.opacityOnLabel:SetText("Opacity While Ready:")

    listBoxItem.opacityOn = Turbine.UI.Lotro.TextBox()
    listBoxItem.opacityOn:SetParent(listBoxItem.InnerBox)
    listBoxItem.opacityOn:SetSize(50, 20)
    listBoxItem.opacityOn:SetPosition(160, itemHeight)
    listBoxItem.opacityOn:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.opacityOn:SetText(value.opacityOn)

    listBoxItem.opacityOn.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.opacityOffLabel = Turbine.UI.Label()
    listBoxItem.opacityOffLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.opacityOffLabel:SetSize(160, 20)
    listBoxItem.opacityOffLabel:SetPosition(0, itemHeight)
    listBoxItem.opacityOffLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.opacityOffLabel:SetText("Opacity While On CD:")

    listBoxItem.opacityOff = Turbine.UI.Lotro.TextBox()
    listBoxItem.opacityOff:SetParent(listBoxItem.InnerBox)
    listBoxItem.opacityOff:SetSize(50, 20)
    listBoxItem.opacityOff:SetPosition(160, itemHeight)
    listBoxItem.opacityOff:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.opacityOff:SetText(value.opacityOff)

    listBoxItem.opacityOff.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.eventTriggerLabel = Turbine.UI.Label()
    listBoxItem.eventTriggerLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.eventTriggerLabel:SetSize(120, 20)
    listBoxItem.eventTriggerLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.eventTriggerLabel:SetPosition(0, itemHeight)
    listBoxItem.eventTriggerLabel:SetText("Event Keyword: ")

    listBoxItem.eventTriggerTextBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.eventTriggerTextBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.eventTriggerTextBox:SetSize(200, 20)
    listBoxItem.eventTriggerTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.eventTriggerTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.eventTriggerTextBox:SetMouseVisible(false)
    listBoxItem.eventTriggerTextBox:SetPosition(120, itemHeight)
    listBoxItem.eventTriggerTextBox:SetMultiline(false)
    listBoxItem.eventTriggerTextBox:SetText(value.Event_Keyword or "")

    listBoxItem.eventTriggerTextBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.InnerBox:SetSize(innerWidth, itemHeight)
    listBoxItem:SetSize(width, itemHeight + 2)

    listBoxItem.ChangeFunction = function()
        func(key, nil)

        local rewrittenValue = {}
        for valueKey, valueValue in pairs(value) do
            rewrittenValue[valueKey] = valueValue
        end
        
        -- Check for timer value
        if listBoxItem.timeBar then 
            rewrittenValue.Time = tonumber(listBoxItem.timeBar:GetText()) or 1
            if listBoxItem.timerCheckBox and listBoxItem.timerCheckBox:IsChecked() then rewrittenValue.Time = listBoxItem.timerCheckBox:IsChecked() end
        end

        -- Check visibilty threshold value
        if listBoxItem.visibitilityThreshold then
            rewrittenValue.visibitilityThreshold = tonumber(listBoxItem.visibitilityThreshold:GetText())
        end

        -- Check X & Y Prio
        if listBoxItem.XBox then
            rewrittenValue.XPrio = tonumber(listBoxItem.XBox:GetText()) or 1
        end

        if listBoxItem.YBox then
            rewrittenValue.YPrio = tonumber(listBoxItem.YBox:GetText()) or 1
        end

        if listBoxItem.YBox then
            rewrittenValue.YPrio = tonumber(listBoxItem.YBox:GetText()) or 1
        end

        -- Opacity off and on
        if listBoxItem.opacityOn then
            rewrittenValue.opacityOn = tonumber(listBoxItem.opacityOn:GetText())
        end

        if listBoxItem.opacityOff then
            rewrittenValue.opacityOff = tonumber(listBoxItem.opacityOff:GetText())
        end

        -- Hide while on or off
        if listBoxItem.hideWhileOff then
            rewrittenValue.hideWhileOff = listBoxItem.hideWhileOff:IsChecked()
        end

        if listBoxItem.hideWhileOn then
            rewrittenValue.hideWhileOn = listBoxItem.hideWhileOn:IsChecked()
        end

        -- Highlight
        if listBoxItem.highlightBox then
            rewrittenValue.Highlight = listBoxItem.highlightBox:IsChecked()
        end

        -- Trigger keyword
        if listBoxItem.eventTriggerTextBox then
            if listBoxItem.eventTriggerTextBox:GetText() == "" then
                rewrittenValue.Event_Keyword = nil
            else
                rewrittenValue.Event_Keyword = tostring(listBoxItem.eventTriggerTextBox:GetText())
            end
        end

        func(key, rewrittenValue)
    end

    return listBoxItem
end