function GetQuickslotListboxItem(key, value, width, triggerType, UIType, func, listbox)
    local listBoxItem = Turbine.UI.Control()
    listBoxItem:SetMouseVisible(false)
    listBoxItem:SetSize(width, 20)
    listBoxItem:SetBackColor(Turbine.UI.Color.Black)

    local innerWidth = width - 2

    local itemHeight = 0

    listBoxItem.InnerBox = Turbine.UI.Control()
    listBoxItem.InnerBox:SetParent(listBoxItem)
    listBoxItem.InnerBox:SetPosition(1, 1)
    listBoxItem.InnerBox:SetSize(innerWidth, 18)
    listBoxItem.InnerBox:SetBackColor(Turbine.UI.Color.DarkSlateBlue)

    listBoxItem.RemovalButton = Turbine.UI.Lotro.Button()
    listBoxItem.RemovalButton:SetParent(listBoxItem.InnerBox)
    listBoxItem.RemovalButton:SetSize(100, 20)
    listBoxItem.RemovalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.RemovalButton:SetMouseVisible(false)
    listBoxItem.RemovalButton:SetPosition(width - 110, itemHeight + 2)
    listBoxItem.RemovalButton:SetText("Remove")

    listBoxItem.RemovalButton.Click = function()
        func(key, nil)
        listbox:RemoveItem(listBoxItem)
    end

    itemHeight = itemHeight + 35

    listBoxItem.slotBox = Turbine.UI.Lotro.Quickslot()
    listBoxItem.slotBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.slotBox:SetSize(35, 35)
    listBoxItem.slotBox:SetPosition(0, itemHeight)
    local success, result = pcall(Turbine.UI.Lotro.Shortcut, value.Type, value.Data)
    if success then 
        pcall(listBoxItem.slotBox.SetShortcut, result)
    end

    itemHeight = itemHeight + 35

    -- X & Y
    listBoxItem.XLabel = Turbine.UI.Label()
    listBoxItem.XLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.XLabel:SetSize(60, 20)
    listBoxItem.XLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.XLabel:SetPosition(0, itemHeight)
    listBoxItem.XLabel:SetText("X-order:")

    listBoxItem.XBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.XBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.XBox:SetSize(50, 20)
    listBoxItem.XBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.XBox:SetPosition(60, itemHeight)
    listBoxItem.XBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.XBox:SetText(tostring(value.XPrio))

    listBoxItem.XBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.YLabel = Turbine.UI.Label()
    listBoxItem.YLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.YLabel:SetSize(60, 20)
    listBoxItem.YLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.YLabel:SetPosition(110, itemHeight)
    listBoxItem.YLabel:SetText("Y-order:")

    listBoxItem.YBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.YBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.YBox:SetSize(50, 20)
    listBoxItem.YBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.YBox:SetPosition(170, itemHeight)
    listBoxItem.YBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.YBox:SetText(tostring(value.YPrio))

    listBoxItem.YBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    if value.HideOnType and value.HideOnType ~= "" then
        listBoxItem.YLabel = Turbine.UI.Label()
        listBoxItem.YLabel:SetParent(listBoxItem.InnerBox)
        listBoxItem.YLabel:SetSize(300, 20)
        listBoxItem.YLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        listBoxItem.YLabel:SetPosition(0, itemHeight)
        listBoxItem.YLabel:SetText("Only show on removable:" .. tostring(value.HideOnType))

        itemHeight = itemHeight + 25
    end

    listBoxItem.InnerBox:SetSize(innerWidth, itemHeight)
    listBoxItem:SetSize(width, itemHeight + 2)

    listBoxItem.ChangeFunction = function()
        func(key, nil)

        local rewrittenValue = {}
        for valueKey, valueValue in pairs(value) do
            rewrittenValue[valueKey] = valueValue
        end

        -- Check X & Y Prio
        if listBoxItem.XBox then
            rewrittenValue.XPrio = tonumber(listBoxItem.XBox:GetText())
        end

        if listBoxItem.YBox then
            rewrittenValue.YPrio = tonumber(listBoxItem.YBox:GetText())
        end


        func(key, rewrittenValue)
    end

    return listBoxItem
end