function CreateQuickslotOptions(width, triggerType, listboxItems, UIType, func, optionPage)
    local headerNode = Turbine.UI.TreeNode()
    headerNode:SetMouseVisible(false)
    headerNode:SetSize(width, 20)

    -- The header label with the trigger name
    headerNode.label = Turbine.UI.Label()
    headerNode.label:SetParent(headerNode)
    headerNode.label:SetSize(width, 20)
    headerNode.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    headerNode.label:SetPosition(0, 0)
    headerNode.label:SetText(triggerType)
    headerNode.label:SetBackColor(Turbine.UI.Color.Black)

    local optionsTreeNode = headerNode:GetChildNodes()

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

   local optionsHeight = 0
   local listboxHeight = 350

    valuebar.optionsControl = Turbine.UI.Control()
	valuebar.optionsControl:SetParent(valuebar)
    valuebar.optionsControl:SetPosition(0, 0)
    valuebar.optionsControl:SetBackColor(Turbine.UI.Color.DarkSlateGray)

    valuebar.slotInfo = Turbine.UI.Label()
    valuebar.slotInfo:SetParent(valuebar.optionsControl)
    valuebar.slotInfo:SetSize(200, 20)
    valuebar.slotInfo:SetPosition(0, optionsHeight)
    valuebar.slotInfo:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.slotInfo:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    valuebar.slotInfo:SetText("Drag item/skill etc here ->")

    valuebar.slotBox = Turbine.UI.Lotro.Quickslot()
    valuebar.slotBox:SetParent(valuebar.optionsControl)
    valuebar.slotBox:SetSize(35, 35)
    valuebar.slotBox:SetPosition(220, optionsHeight)

    optionsHeight = optionsHeight + 45

    valuebar.xBox = Turbine.UI.Label()
    valuebar.xBox:SetParent(valuebar.optionsControl)
    valuebar.xBox:SetSize(60, 20)
    valuebar.xBox:SetPosition(0, optionsHeight)
    valuebar.xBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.xBox:SetText("X-order:")

    valuebar.xBoxValue = Turbine.UI.Lotro.TextBox()
    valuebar.xBoxValue:SetParent(valuebar.optionsControl)
    valuebar.xBoxValue:SetSize(50, 20)
    valuebar.xBoxValue:SetPosition(60, optionsHeight)
    valuebar.xBoxValue:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    valuebar.yBox = Turbine.UI.Label()
    valuebar.yBox:SetParent(valuebar.optionsControl)
    valuebar.yBox:SetSize(60, 20)
    valuebar.yBox:SetPosition(110, optionsHeight)
    valuebar.yBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.yBox:SetText("Y-order:")

    valuebar.yBoxValue = Turbine.UI.Lotro.TextBox()
    valuebar.yBoxValue:SetParent(valuebar.optionsControl)
    valuebar.yBoxValue:SetSize(50, 20)
    valuebar.yBoxValue:SetPosition(170, optionsHeight)
    valuebar.yBoxValue:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    valuebar.orderBoxShowInfo = InfoButton(valuebar.optionsControl, width, 220, optionsHeight + 2, "The X and Y order is where in the grid the skill is placed. These are not coordinates, but the order of the skills. The skillbar will place the skill on the appropriate Y level and then sort all skills based on their X order.", optionPage.infoWindow)

    optionsHeight = optionsHeight + 25

    valuebar.categoryLabel = Turbine.UI.Lotro.CheckBox()
    valuebar.categoryLabel:SetParent(valuebar.optionsControl)
    valuebar.categoryLabel:SetSize(220, 20)
    valuebar.categoryLabel:SetPosition(0, optionsHeight)
    valuebar.categoryLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.categoryLabel:SetText("Only show on removable:")

    valuebar.categoryButton = Turbine.UI.Lotro.Button()
    valuebar.categoryButton:SetParent(valuebar.optionsControl)
    valuebar.categoryButton:SetSize(100, 20)
    valuebar.categoryButton:SetPosition(220, optionsHeight)
    valuebar.categoryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    valuebar.categoryMenu = UI.DropDownMenuControl(valuebar, 200, "Tier Menu Dropdown Menu")
    for key, value in pairs(Turbine.Gameplay.EffectCategory) do
        valuebar.categoryMenu:AddItem(key, 
        function()
            valuebar.categoryButton:SetText(key)
            valuebar.categoryMenu:ToggleVisible()
        end)
    end

    valuebar.categoryButton.Click = function()
        valuebar.categoryMenu:ToggleVisible()
    end

    valuebar.categoryShowInfo = InfoButton(valuebar.optionsControl, width, 320, optionsHeight + 2, "This quick slot will only be shown if this type of removable effect is applied to the player.", optionPage.infoWindow)

    optionsHeight = optionsHeight + 25

    valuebar.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    valuebar.addTriggerEntryButton:SetParent(valuebar)
    valuebar.addTriggerEntryButton:SetSize(100, 20)
    valuebar.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.addTriggerEntryButton:SetPosition(width - 120, optionsHeight)
    valuebar.addTriggerEntryButton:SetText("Add")

    optionsHeight = optionsHeight + 20

    -- Set options control to match all its children
    valuebar.optionsControl:SetSize(width, optionsHeight)

    -- Add listbox for items
    valuebar.listbox = Turbine.UI.ListBox()
    valuebar.listbox:SetParent(valuebar)
    valuebar.listbox:SetSize(width - 10, listboxHeight)
    valuebar.listbox:SetPosition(0, valuebar.optionsControl:GetHeight())
    valuebar.listbox:SetVisible(tablelength(listboxItems) > 0)

    valuebar.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    valuebar.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    valuebar.Scrollbar:SetParent(valuebar)
    valuebar.Scrollbar:SetPosition(width - 10, valuebar.optionsControl:GetHeight())
    valuebar.Scrollbar:SetSize(10, listboxHeight)
    valuebar.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    valuebar.listbox:SetVerticalScrollBar(valuebar.Scrollbar)

    for key, value in pairs(listboxItems) do
        valuebar.listbox:AddItem(GetQuickslotListboxItem(key, value, width - 10, triggerType, UIType, func, valuebar.listbox))
    end

    valuebar.addTriggerEntryButton.Click = function()
        local xPrio = tonumber(tostring(valuebar.xBoxValue:GetText()))
        local yPrio = tonumber(tostring(valuebar.yBoxValue:GetText()))
        local shortcutData = valuebar.slotBox:GetShortcut():GetData()
        local shortcutType = valuebar.slotBox:GetShortcut():GetType()
        local shortcutItem = valuebar.slotBox:GetShortcut():GetItem()
        local ID = Turbine.Engine.GetGameTime()

        if not(shortcutData) or not(shortcutType) or not(ID) or not(xPrio) or not(yPrio) then ChatOutput("Not all fields are correctly filled!"); return end

        local triggerEntry = {["Code"] = code, ["XPrio"] = xPrio, ["YPrio"] = yPrio, ["Type"] = shortcutType, ["Data"] = shortcutData, ["Item"] = shortcutItem, ["HideOnType"] = valuebar.categoryLabel and valuebar.categoryLabel:IsChecked() and valuebar.categoryButton:GetText() or ""}

        if func(ID, triggerEntry) then
            return
        end

        valuebar.listbox:AddItem(GetQuickslotListboxItem(ID, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
        valuebar.listbox:SetVisible(true)
    end

    valuebar:SetSize(width, valuebar.listbox:GetHeight() + valuebar.optionsControl:GetHeight())

    optionsTreeNode:Add(valuebar.optionsControl)

    optionsTreeNode:Add(valuebar)

    return headerNode
end