function GetPrimeUISkillHighlightListboxItem(key, value, width, triggerType, UIType, func, listbox)
    local listBoxItem = Turbine.UI.Control()
    listBoxItem:SetMouseVisible(false)
    listBoxItem:SetSize(width, 20)
    listBoxItem:SetBackColor(Turbine.UI.Color.Black)

    local innerWidth = width - 2

    local itemHeight = 0

    listBoxItem.InnerBox = Turbine.UI.Control()
    listBoxItem.InnerBox:SetParent(listBoxItem)
    listBoxItem.InnerBox:SetPosition(1, 1)
    listBoxItem.InnerBox:SetSize(innerWidth, 18)
    listBoxItem.InnerBox:SetBackColor(Turbine.UI.Color.DarkSlateBlue)

    listBoxItem.RemovalButton = Turbine.UI.Lotro.Button()
    listBoxItem.RemovalButton:SetParent(listBoxItem.InnerBox)
    listBoxItem.RemovalButton:SetSize(100, 20)
    listBoxItem.RemovalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.RemovalButton:SetMouseVisible(false)
    listBoxItem.RemovalButton:SetPosition(width - 110, itemHeight + 2)
    listBoxItem.RemovalButton:SetText("Remove")

    listBoxItem.RemovalButton.Click = function()
        func(key, nil)
        listbox:RemoveItem(listBoxItem)
    end

    listBoxItem.headerDivider = Turbine.UI.Control()
    listBoxItem.headerDivider:SetParent(listBoxItem.InnerBox)
    listBoxItem.headerDivider:SetPosition(0, 25)
    listBoxItem.headerDivider:SetSize(innerWidth, 1)
    listBoxItem.headerDivider:SetBackColor(Turbine.UI.Color.Black)

    itemHeight = itemHeight + 35

    if string.find(triggerType, "Highlight_When_Ready") then
        listBoxItem.EffectLabel = Turbine.UI.Label()
        listBoxItem.EffectLabel:SetParent(listBoxItem.InnerBox)
        listBoxItem.EffectLabel:SetSize(60, 20)
        listBoxItem.EffectLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        listBoxItem.EffectLabel:SetPosition(0, itemHeight)
        listBoxItem.EffectLabel:SetText("Time:")
        

        listBoxItem.HighlightDurationTextbox = Turbine.UI.Lotro.TextBox()
        listBoxItem.HighlightDurationTextbox:SetParent(listBoxItem.InnerBox)
        listBoxItem.HighlightDurationTextbox:SetSize(width - 80, 20)
        listBoxItem.HighlightDurationTextbox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        listBoxItem.HighlightDurationTextbox:SetPosition(70, itemHeight)
        listBoxItem.HighlightDurationTextbox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        listBoxItem.HighlightDurationTextbox:SetText(value.Highlight_Duration)
    
        listBoxItem.HighlightDurationTextbox.TextChanged = function()
            listBoxItem.ChangeFunction()
        end
    
        itemHeight = itemHeight + 25
    else
        listBoxItem.EffectLabel = Turbine.UI.Label()
        listBoxItem.EffectLabel:SetParent(listBoxItem.InnerBox)
        listBoxItem.EffectLabel:SetSize(60, 20)
        listBoxItem.EffectLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        listBoxItem.EffectLabel:SetPosition(0, itemHeight)
        if string.find(triggerType, "Event") then
            listBoxItem.EffectLabel:SetText("Event:")
        else
            listBoxItem.EffectLabel:SetText("Effect:")
        end
    
        listBoxItem.EffectBox = Turbine.UI.Lotro.TextBox()
        listBoxItem.EffectBox:SetParent(listBoxItem.InnerBox)
        listBoxItem.EffectBox:SetSize(width - 80, 20)
        listBoxItem.EffectBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        listBoxItem.EffectBox:SetPosition(70, itemHeight)
        listBoxItem.EffectBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        listBoxItem.EffectBox:SetText(tostring(value.Effect))
    
        listBoxItem.EffectBox.TextChanged = function()
            listBoxItem.ChangeFunction()
        end
    
        itemHeight = itemHeight + 25
    end


    listBoxItem.SkillLabel = Turbine.UI.Label()
    listBoxItem.SkillLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.SkillLabel:SetSize(60, 20)
    listBoxItem.SkillLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.SkillLabel:SetPosition(0, itemHeight)
    listBoxItem.SkillLabel:SetText("Skill:")

    listBoxItem.SkillBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.SkillBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.SkillBox:SetSize(width - 80, 20)
    listBoxItem.SkillBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.SkillBox:SetPosition(70, itemHeight)
    listBoxItem.SkillBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.SkillBox:SetText(tostring(value.Skill))

    listBoxItem.SkillBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    if not(string.find(triggerType, "Highlight_When_Ready")) then
        listBoxItem.highlightBox = Turbine.UI.Lotro.CheckBox()
        listBoxItem.highlightBox:SetParent(listBoxItem.InnerBox)
        listBoxItem.highlightBox:SetSize(200, 20)
        listBoxItem.highlightBox:SetPosition(0, itemHeight)
        listBoxItem.highlightBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        if triggerType == "Highlight_On_Event" then
            listBoxItem.highlightBox:SetText("Disable Highlight")
        elseif triggerType == "Toggle_Visibility_On_Event" then
            listBoxItem.highlightBox:SetText("Set Invisible")
        else
            listBoxItem.highlightBox:SetText("Invert Highlight")
        end
        listBoxItem.highlightBox:SetChecked(value.Invert_Highlight)
    
        listBoxItem.highlightBox.CheckedChanged = function()
            listBoxItem.ChangeFunction()
        end
        itemHeight = itemHeight + 25
    end


    if string.find(triggerType, "Effect") then
        listBoxItem.iconLabel = Turbine.UI.Label()
        listBoxItem.iconLabel:SetParent(listBoxItem.InnerBox)
        listBoxItem.iconLabel:SetSize(innerWidth - 100, 20)
        listBoxItem.iconLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        listBoxItem.iconLabel:SetPosition(0, itemHeight)
        listBoxItem.iconLabel:SetText("Icon: " .. tostring(value.Icon or ""))

        listBoxItem.fitIconBox = Turbine.UI.Lotro.CheckBox()
        listBoxItem.fitIconBox:SetParent(listBoxItem.InnerBox)
        listBoxItem.fitIconBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        listBoxItem.fitIconBox:SetChecked(value.Fit_Icon)
        listBoxItem.fitIconBox:SetPosition(innerWidth - 100, itemHeight)
        listBoxItem.fitIconBox:SetSize(100, 20)
        listBoxItem.fitIconBox:SetText("Match Icon")

        listBoxItem.fitIconBox.CheckedChanged = function()
            listBoxItem.ChangeFunction()
        end

        itemHeight = itemHeight + 25
    end

    listBoxItem.InnerBox:SetSize(innerWidth, itemHeight)
    listBoxItem:SetSize(width, itemHeight + 2)

    listBoxItem.ChangeFunction = function()
        func(key, nil)

        local rewrittenValue = {}
        for valueKey, valueValue in pairs(value) do
            rewrittenValue[valueKey] = valueValue
        end

        -- Effect
        if listBoxItem.EffectBox then
            rewrittenValue.Effect = tostring(listBoxItem.EffectBox:GetText())
        end

        -- Skill
        if listBoxItem.SkillBox then
            rewrittenValue.Skill = tostring(listBoxItem.SkillBox:GetText())
        end

        -- Match Icon
        if listBoxItem.fitIconBox then
            rewrittenValue.Fit_Icon = listBoxItem.fitIconBox:IsChecked()
        end

        -- Highlight
        if listBoxItem.highlightBox then
            rewrittenValue.Invert_Highlight = listBoxItem.highlightBox:IsChecked()
        end

        -- Highlight duration
        if listBoxItem.HighlightDurationTextbox then
            rewrittenValue.Highlight_Duration = tonumber(listBoxItem.HighlightDurationTextbox:GetText()) or 0
        end

        func(key, rewrittenValue)
    end

    return listBoxItem
end