function CreateHighlightSkillListBox(width, triggerType, listboxItems, UIType, func, optionPage)
    local headerNode = Turbine.UI.TreeNode()
    headerNode:SetMouseVisible(false)
    headerNode:SetSize(width, 20)

    -- The header label with the trigger name
    headerNode.label = Turbine.UI.Label()
    headerNode.label:SetParent(headerNode)
    headerNode.label:SetSize(width, 20)
    headerNode.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    headerNode.label:SetPosition(0, 0)
    headerNode.label:SetText(triggerType)
    headerNode.label:SetBackColor(Turbine.UI.Color.Black)

    local optionsTreeNode = headerNode:GetChildNodes()

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

   local optionsHeight = 0
   local listboxHeight = 350

    valuebar.optionsControl = Turbine.UI.Control()
	valuebar.optionsControl:SetParent(valuebar)
    valuebar.optionsControl:SetPosition(0, 0)
    valuebar.optionsControl:SetBackColor(Turbine.UI.Color.DarkSlateGray)

    valuebar.nameTextBox = Turbine.UI.Lotro.TextBox()
    valuebar.nameTextBox:SetParent(valuebar.optionsControl)
    valuebar.nameTextBox:SetSize(width - 16, 20)
    valuebar.nameTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.nameTextBox:SetPosition(0, optionsHeight)

    if triggerType == "Highlight_On_Effect" then
        valuebar.nameTextBox:SetText("Effect Name")

        valuebar.thresholdOperatorInforButton = InfoButton(valuebar.optionsControl, width, width - 16, optionsHeight + 2, "When this effect is applied to the player the trigger will activate.", optionPage.infoWindow)

    elseif triggerType == "Highlight_On_Resource" then
        valuebar.nameTextBox:SetText("Threshold")

        valuebar.thresholdOperatorInforButton = InfoButton(valuebar.optionsControl, width, width - 16, optionsHeight + 2, "When this threshold is reached the trigger will activate.", optionPage.infoWindow)
    elseif string.find(triggerType, "Event") then
        valuebar.nameTextBox:SetText("Event")

        valuebar.thresholdOperatorInforButton = InfoButton(valuebar.optionsControl, width, width - 16, optionsHeight + 2, "When this event is fired a skill can be highlighted or if already highlighted it can be turned off.", optionPage.infoWindow)
    elseif string.find(triggerType, "Highlight_When_Ready") then
        valuebar.nameTextBox:SetText("Highlight time")

        valuebar.thresholdOperatorInforButton = InfoButton(valuebar.optionsControl, width, width - 16, optionsHeight + 2, "When the skill becomes ready again the skill will be highlighted for the specified time.", optionPage.infoWindow)

    end

    optionsHeight = optionsHeight + 25

    if string.find(triggerType, "Effect") then
        valuebar.effectBrowseButton = Turbine.UI.Lotro.Button()
        valuebar.effectBrowseButton:SetParent(valuebar.optionsControl)
        valuebar.effectBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.effectBrowseButton:SetPosition(0, optionsHeight)
        valuebar.effectBrowseButton:SetText("Browse Encountered Effects")
        valuebar.effectBrowseButton:SetSize(500, 20)

        valuebar.effectBrowseButton.Click = function()
            local effectWindow = optionPage:GetEffectWindow()
            effectWindow:SetVisible(true) 
            effectWindow:Register(valuebar.nameTextBox)
        end

        optionsHeight = optionsHeight + 25
    end

    valuebar.skillTextBox = Turbine.UI.Lotro.TextBox()
    valuebar.skillTextBox:SetParent(valuebar.optionsControl)
    valuebar.skillTextBox:SetSize(width - 16, 20)
    valuebar.skillTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.skillTextBox:SetPosition(0, optionsHeight)
    valuebar.skillTextBox:SetText("Skill Name")

    valuebar.thresholdOperatorInforButton = InfoButton(valuebar.optionsControl, width, width - 16, optionsHeight + 2, "When the specified effect is applied to the player this skill will be highlighted.", optionPage.infoWindow)

    optionsHeight = optionsHeight + 25

    valuebar.skillBrowseButton = Turbine.UI.Lotro.Button()
    valuebar.skillBrowseButton:SetParent(valuebar.optionsControl)
    valuebar.skillBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.skillBrowseButton:SetPosition(0, optionsHeight)
    valuebar.skillBrowseButton:SetText("Browse Detected Skills")
    valuebar.skillBrowseButton:SetSize(500, 20)

    valuebar.skillBrowseButton.Click = function()
        local skillWindow = optionPage:GetSkillWindow()
        skillWindow:SetVisible(true) 
        skillWindow:Register(valuebar.skillTextBox)
    end

    optionsHeight = optionsHeight + 25

    if not(string.find(triggerType, "Highlight_When_Ready")) then
        valuebar.highlightBox = Turbine.UI.Lotro.CheckBox()
        valuebar.highlightBox:SetParent(valuebar.optionsControl)
        valuebar.highlightBox:SetSize(200, 20)
        valuebar.highlightBox:SetPosition(0, optionsHeight)
        valuebar.highlightBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        if triggerType == "Highlight_On_Event" then
            valuebar.highlightBox:SetText("Disable Highlight")
        elseif triggerType == "Toggle_Visibility_On_Event" then
            valuebar.highlightBox:SetText("Set Invisible")
        else
            valuebar.highlightBox:SetText("Invert Highlight")
        end

        valuebar.thresholdOperatorInforButton = InfoButton(valuebar.optionsControl, width, 200, optionsHeight + 2, "This reverses the mechanism so the skill is highlighted when the specified effect is NOT applied to the player.", optionPage.infoWindow)

        optionsHeight = optionsHeight + 25
    end

    if triggerType == "Highlight_On_Resource" then
        valuebar.thresholdBrowseButton = Turbine.UI.Lotro.Button()
        valuebar.thresholdBrowseButton:SetParent(valuebar.optionsControl)
        valuebar.thresholdBrowseButton:SetSize(100, 20)
        valuebar.thresholdBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.thresholdBrowseButton:SetPosition(0, optionsHeight)
        valuebar.thresholdBrowseButton:SetText("<=")

        valuebar.thresholdBrowseMenu = Turbine.UI.ContextMenu()
        valuebar.thresholdBrowseMenuItems = valuebar.thresholdBrowseMenu :GetItems()

        local leqItem = Turbine.UI.MenuItem("<=")
        valuebar.thresholdBrowseMenuItems:Add(leqItem)
        leqItem.Click = function()
            valuebar.thresholdBrowseButton:SetText("<=")
        end

        local moqItem = Turbine.UI.MenuItem(">=")
        valuebar.thresholdBrowseMenuItems:Add(moqItem)
        moqItem.Click = function()
            valuebar.thresholdBrowseButton:SetText(">=")
        end
    
        valuebar.thresholdBrowseButton.Click = function()
            valuebar.thresholdBrowseMenu:ShowMenu()
        end

        valuebar.thresholdOperatorInforButton = InfoButton(valuebar.optionsControl, width, 100, optionsHeight + 2, "This is the operator which is used to judge if a certain threshold has been reached or passed. The options are less or equal \"<=\" or more or equal \">=\".", optionPage.infoWindow)

        optionsHeight = optionsHeight + 25
    end

    if triggerType == "Highlight_On_Effect" then
        valuebar.EffectTimerIconBox = Turbine.UI.Control()
        valuebar.EffectTimerIconBox:SetParent(valuebar.optionsControl)
        valuebar.EffectTimerIconBox:SetPosition(0, optionsHeight)
        valuebar.EffectTimerIconBox:SetSize(32,32)
        valuebar.EffectTimerIconBox:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        valuebar.EffectTimerIconBox:SetBackground(BackgroundHandler:GetBackground(0x41007F41))
        valuebar.EffectTimerIconBox:SetVisible(true)

        valuebar.TimerIconTextBox = Turbine.UI.Lotro.TextBox()
        valuebar.TimerIconTextBox:SetParent(valuebar.optionsControl)
        valuebar.TimerIconTextBox:SetSize(110, 30)
        valuebar.TimerIconTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        valuebar.TimerIconTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.TimerIconTextBox:SetMouseVisible(false)
        valuebar.TimerIconTextBox:SetPosition(40, optionsHeight)
        valuebar.TimerIconTextBox:SetMultiline(false)
        valuebar.TimerIconTextBox:SetText(0x41007F41)

        valuebar.EffectTimerIconBox.MouseClick = function()
            local iconWindow = optionPage:GetIconWindow()
            iconWindow:SetVisible(true) 
            iconWindow:Register(valuebar.EffectTimerIconBox, valuebar.TimerIconTextBox)
        end

        valuebar.EffectTimerIconBox.MouseDoubleClick = function()
            valuebar.EffectTimerIconBox:SetBackground(BackgroundHandler:GetBackground(0x41007F41))
            valuebar.TimerIconTextBox:SetText(0x41007F41)
        end

        valuebar.iconMatchBox = Turbine.UI.Lotro.CheckBox()
        valuebar.iconMatchBox:SetParent(valuebar.optionsControl)
        valuebar.iconMatchBox:SetSize(100, 20)
        valuebar.iconMatchBox:SetPosition(200, optionsHeight)
        valuebar.iconMatchBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.iconMatchBox:SetText("Match icon")

        valuebar.iconInputShowInfo = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "The icon picked in the icon box will be matched against the icon supplied on the trigger, only if these are a match will the trigger active.", optionPage.infoWindow)

        optionsHeight = optionsHeight + 35
    end

    valuebar.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    valuebar.addTriggerEntryButton:SetParent(valuebar)
    valuebar.addTriggerEntryButton:SetSize(100, 20)
    valuebar.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.addTriggerEntryButton:SetPosition(width - 120, optionsHeight)
    valuebar.addTriggerEntryButton:SetText("Add")

    optionsHeight = optionsHeight + 20

    -- Set options control to match all its children
    valuebar.optionsControl:SetSize(width, optionsHeight)

    -- Add listbox for items
    valuebar.listbox = Turbine.UI.ListBox()
    valuebar.listbox:SetParent(valuebar)
    valuebar.listbox:SetSize(width - 10, listboxHeight)
    valuebar.listbox:SetPosition(0, valuebar.optionsControl:GetHeight())
    valuebar.listbox:SetVisible(tablelength(listboxItems) > 0)

    valuebar.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    valuebar.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    valuebar.Scrollbar:SetParent(valuebar)
    valuebar.Scrollbar:SetPosition(width - 10, valuebar.optionsControl:GetHeight())
    valuebar.Scrollbar:SetSize(10, listboxHeight)
    valuebar.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    valuebar.listbox:SetVerticalScrollBar(valuebar.Scrollbar)

    for key, value in pairs(listboxItems) do
        valuebar.listbox:AddItem(GetPrimeUISkillHighlightListboxItem(key, value, width - 10, triggerType, UIType, func, valuebar.listbox))
    end

    valuebar.addTriggerEntryButton.Click = function()
        local triggerEntry
        local effectName = tostring(valuebar.nameTextBox:GetText())
        local highlightDuration = tonumber(effectName) or 0
        local skillName = tostring(valuebar.skillTextBox:GetText())
        if not(effectName) or not(skillName) then
            ChatOutput("Not all fields are correctly filled!")
            return
        end

        local ID = Turbine.Engine.GetGameTime()

        triggerEntry = {["Icon"] = valuebar.TimerIconTextBox and tostring(valuebar.TimerIconTextBox:GetText()), ["Invert_Highlight"] = valuebar.highlightBox and valuebar.highlightBox:IsChecked(), 
        ["Fit_Icon"] = valuebar.iconMatchBox and valuebar.iconMatchBox:IsChecked(), ["Highlight_Duration"] = highlightDuration, ["Effect"] = effectName, ["Skill"] = skillName, ["Comparator"] = valuebar.thresholdBrowseButton and valuebar.thresholdBrowseButton:GetText(), ["Number"] = tonumber(effectName) or 0}

        if func(ID, triggerEntry) then
            return
        end

        

        valuebar.listbox:AddItem(GetPrimeUISkillHighlightListboxItem(ID, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
        valuebar.listbox:SetVisible(true)
    end

    valuebar:SetSize(width, valuebar.listbox:GetHeight() + valuebar.optionsControl:GetHeight())

    optionsTreeNode:Add(valuebar.optionsControl)

    optionsTreeNode:Add(valuebar)

    return headerNode
end