function CreateSkillListBox(width, triggerType, listboxItems, UIType, func, optionPage)
    local headerNode = Turbine.UI.TreeNode()
    headerNode:SetMouseVisible(false)
    headerNode:SetSize(width, 20)

    -- The header label with the trigger name
    headerNode.label = Turbine.UI.Label()
    headerNode.label:SetParent(headerNode)
    headerNode.label:SetSize(width, 20)
    headerNode.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    headerNode.label:SetPosition(0, 0)
    headerNode.label:SetText(triggerType)
    headerNode.label:SetBackColor(Turbine.UI.Color.Black)

    local optionsTreeNode = headerNode:GetChildNodes()

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

   local optionsHeight = 0
   local listboxHeight = 350

    valuebar.optionsControl = Turbine.UI.Control()
	valuebar.optionsControl:SetParent(valuebar)
    valuebar.optionsControl:SetPosition(0, 0)
    valuebar.optionsControl:SetBackColor(Turbine.UI.Color.DarkSlateGray)

    valuebar.nameTextBox = Turbine.UI.Label()
    valuebar.nameTextBox:SetParent(valuebar.optionsControl)
    valuebar.nameTextBox:SetSize(width - 50, 20)
    valuebar.nameTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.nameTextBox:SetPosition(0, optionsHeight)

    valuebar.hiddenBar = Turbine.UI.Lotro.TextBox()
    valuebar.hiddenBar:SetParent(valuebar.optionsControl)
    valuebar.hiddenBar:SetVisible(false)

    valuebar.timeBar = Turbine.UI.Lotro.TextBox()
    valuebar.timeBar:SetParent(valuebar.optionsControl)
    valuebar.timeBar:SetSize(50, 20)
    valuebar.timeBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.timeBar:SetPosition(width - 50, optionsHeight)
    valuebar.timeBar:SetText("Time")

    optionsHeight = optionsHeight + 25

    valuebar.skillBrowseButton = Turbine.UI.Lotro.Button()
    valuebar.skillBrowseButton:SetParent(valuebar.optionsControl)
    valuebar.skillBrowseButton:SetSize(400, 20)
    valuebar.skillBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.skillBrowseButton:SetPosition(0, optionsHeight)
    valuebar.skillBrowseButton:SetText("Find skill in database")

    valuebar.skillBrowseButton.Click = function()
        local skillCodesWindow = optionPage:SkillOverview2()
        if skillCodesWindow then 
            skillCodesWindow:SetVisible(true) 
            skillCodesWindow:Register(valuebar.nameTextBox, valuebar.hiddenBar)
        end
    end

    valuebar.timerCheckBox = Turbine.UI.Lotro.CheckBox()
    valuebar.timerCheckBox:SetParent(valuebar.optionsControl)
    valuebar.timerCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.timerCheckBox:SetText("Use skill cooldown as time")
    valuebar.timerCheckBox:SetPosition(width - 250, optionsHeight)
    valuebar.timerCheckBox:SetSize(250, 20)

    optionsHeight = optionsHeight + 25

    valuebar.xBox = Turbine.UI.Label()
    valuebar.xBox:SetParent(valuebar.optionsControl)
    valuebar.xBox:SetSize(60, 20)
    valuebar.xBox:SetPosition(0, optionsHeight)
    valuebar.xBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.xBox:SetText("X-order:")

    valuebar.xBoxValue = Turbine.UI.Lotro.TextBox()
    valuebar.xBoxValue:SetParent(valuebar.optionsControl)
    valuebar.xBoxValue:SetSize(50, 20)
    valuebar.xBoxValue:SetPosition(60, optionsHeight)
    valuebar.xBoxValue:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    valuebar.yBox = Turbine.UI.Label()
    valuebar.yBox:SetParent(valuebar.optionsControl)
    valuebar.yBox:SetSize(60, 20)
    valuebar.yBox:SetPosition(110, optionsHeight)
    valuebar.yBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.yBox:SetText("Y-order:")

    valuebar.yBoxValue = Turbine.UI.Lotro.TextBox()
    valuebar.yBoxValue:SetParent(valuebar.optionsControl)
    valuebar.yBoxValue:SetSize(50, 20)
    valuebar.yBoxValue:SetPosition(170, optionsHeight)
    valuebar.yBoxValue:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    valuebar.orderBoxShowInfo = InfoButton(valuebar.optionsControl, width, 220, optionsHeight + 2, "The X and Y order is where in the grid the skill is placed. These are not coordinates, but the order of the skills. The skillbar will place the skill on the appropriate Y level and then sort all skills based on their X order.", optionPage.infoWindow)

    valuebar.highlightBox = Turbine.UI.Lotro.CheckBox()
    valuebar.highlightBox:SetParent(valuebar.optionsControl)
    valuebar.highlightBox:SetSize(100, 20)
    valuebar.highlightBox:SetPosition(240, optionsHeight)
    valuebar.highlightBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.highlightBox:SetText("Highlight")

    optionsHeight = optionsHeight + 25

    valuebar.hideWhileOff = Turbine.UI.Lotro.CheckBox()
    valuebar.hideWhileOff:SetParent(valuebar.optionsControl)
    valuebar.hideWhileOff:SetSize(150, 20)
    valuebar.hideWhileOff:SetPosition(0, optionsHeight)
    valuebar.hideWhileOff:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.hideWhileOff:SetText("Hide While Ready")

    valuebar.hideWhileOn = Turbine.UI.Lotro.CheckBox()
    valuebar.hideWhileOn:SetParent(valuebar.optionsControl)
    valuebar.hideWhileOn:SetSize(150, 20)
    valuebar.hideWhileOn:SetPosition(150, optionsHeight)
    valuebar.hideWhileOn:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.hideWhileOn:SetText("Hide While On CD")

    valuebar.hideShowInfo = InfoButton(valuebar.optionsControl, width, 300, optionsHeight + 2, "These toggle will hide the skill slot if the skill is on or off cooldown.", optionPage.infoWindow)

    optionsHeight = optionsHeight + 25

    valuebar.visibitilityThresholdLabel = Turbine.UI.Label()
    valuebar.visibitilityThresholdLabel:SetParent(valuebar.optionsControl)
    valuebar.visibitilityThresholdLabel:SetSize(150, 20)
    valuebar.visibitilityThresholdLabel:SetPosition(0, optionsHeight)
    valuebar.visibitilityThresholdLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.visibitilityThresholdLabel:SetText("Visibilty Threshold:")

    valuebar.visibitilityThreshold = Turbine.UI.Lotro.TextBox()
    valuebar.visibitilityThreshold:SetParent(valuebar.optionsControl)
    valuebar.visibitilityThreshold:SetSize(100, 20)
    valuebar.visibitilityThreshold:SetPosition(150, optionsHeight)
    valuebar.visibitilityThreshold:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.visibitilityThreshold:SetText("99999")

    valuebar.visibiltyShowInfo = InfoButton(valuebar.optionsControl, width, 250, optionsHeight + 2, "While the skill is on cooldown it will only be visible if the cooldown is below this threshold.", optionPage.infoWindow)

    optionsHeight = optionsHeight + 25

    valuebar.opacityOnLabel = Turbine.UI.Label()
    valuebar.opacityOnLabel:SetParent(valuebar.optionsControl)
    valuebar.opacityOnLabel:SetSize(160, 20)
    valuebar.opacityOnLabel:SetPosition(0, optionsHeight)
    valuebar.opacityOnLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.opacityOnLabel:SetText("Opacity While Ready:")

    valuebar.opacityOn = Turbine.UI.Lotro.TextBox()
    valuebar.opacityOn:SetParent(valuebar.optionsControl)
    valuebar.opacityOn:SetSize(50, 20)
    valuebar.opacityOn:SetPosition(160, optionsHeight)
    valuebar.opacityOn:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.opacityOn:SetText("1")

    valuebar.opactiyOnShowInfo = InfoButton(valuebar.optionsControl, width, 210, optionsHeight + 2, "The opacity of the skill while it is ready for use.", optionPage.infoWindow)

    optionsHeight = optionsHeight + 25

    valuebar.opacityOffLabel = Turbine.UI.Label()
    valuebar.opacityOffLabel:SetParent(valuebar.optionsControl)
    valuebar.opacityOffLabel:SetSize(160, 20)
    valuebar.opacityOffLabel:SetPosition(0, optionsHeight)
    valuebar.opacityOffLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.opacityOffLabel:SetText("Opacity While On CD:")

    valuebar.opacityOff = Turbine.UI.Lotro.TextBox()
    valuebar.opacityOff:SetParent(valuebar.optionsControl)
    valuebar.opacityOff:SetSize(50, 20)
    valuebar.opacityOff:SetPosition(160, optionsHeight)
    valuebar.opacityOff:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.opacityOff:SetText("1")

    valuebar.opacityOffShowInfo = InfoButton(valuebar.optionsControl, width, 210, optionsHeight + 2, "The opacity of the skill while it is on cooldown.", optionPage.infoWindow)

    optionsHeight = optionsHeight + 25

    valuebar.eventTriggerTextbox = Turbine.UI.Lotro.TextBox()
    valuebar.eventTriggerTextbox:SetParent(valuebar.optionsControl)
    valuebar.eventTriggerTextbox:SetSize(200, 20)
    valuebar.eventTriggerTextbox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    valuebar.eventTriggerTextbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.eventTriggerTextbox:SetMouseVisible(false)
    valuebar.eventTriggerTextbox:SetPosition(0, optionsHeight)
    valuebar.eventTriggerTextbox:SetMultiline(false)
    valuebar.eventTriggerTextbox:SetText("Event Keyword")

    valuebar.eventTriggerInfoShow = InfoButton(valuebar.optionsControl, width, 220, optionsHeight + 2, "This event will fire when the current trigger expires. For example, when a timer runs out this event will fire. This event will be applied to the current primeUI and all UI elements that have a TriggerEvent with this keyword will fire. This allows you to fire events at the end of other events, or create loops.", optionPage.infoWindow)

    optionsHeight = optionsHeight + 20

    valuebar.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    valuebar.addTriggerEntryButton:SetParent(valuebar)
    valuebar.addTriggerEntryButton:SetSize(100, 20)
    valuebar.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.addTriggerEntryButton:SetPosition(width - 120, optionsHeight)
    valuebar.addTriggerEntryButton:SetText("Add")

    optionsHeight = optionsHeight + 20

    -- Set options control to match all its children
    valuebar.optionsControl:SetSize(width, optionsHeight)

    -- Add listbox for items
    valuebar.listbox = Turbine.UI.ListBox()
    valuebar.listbox:SetParent(valuebar)
    valuebar.listbox:SetSize(width - 10, listboxHeight)
    valuebar.listbox:SetPosition(0, valuebar.optionsControl:GetHeight())
    valuebar.listbox:SetVisible(tablelength(listboxItems) > 0)

    valuebar.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    valuebar.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    valuebar.Scrollbar:SetParent(valuebar)
    valuebar.Scrollbar:SetPosition(width - 10, valuebar.optionsControl:GetHeight())
    valuebar.Scrollbar:SetSize(10, listboxHeight)
    valuebar.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    valuebar.listbox:SetVerticalScrollBar(valuebar.Scrollbar)

    for key, value in spairs(listboxItems, function(t, a, b) return a < b end) do
        valuebar.listbox:AddItem(GetListboxTiemPrimeUISkillEntry(key, value, width - 10, triggerType, UIType, func, valuebar.listbox))
    end

    valuebar.addTriggerEntryButton.Click = function()
        local triggerEntry
        local triggerToken = tostring(valuebar.nameTextBox:GetText())
        local timeValue = tonumber(valuebar.timeBar:GetText())
        local skillToken = valuebar.hiddenBar:GetText()
        if valuebar.timerCheckBox and valuebar.timerCheckBox:IsChecked() then timeValue = valuebar.timerCheckBox:IsChecked() end
        if not(triggerToken) or not(timeValue) or skillToken == "" then
            ChatOutput("Not all fields are correctly filled!")
            return
        end

        triggerEntry = {["Time"] = timeValue or 1, ["Highlight"] = valuebar.highlightBox:IsChecked(), ["Code"] = skillToken, ["XPrio"] = tonumber(valuebar.xBoxValue:GetText()) or 1, 
        ["YPrio"] = tonumber(valuebar.yBoxValue:GetText()) or 1, ["visibitilityThreshold"] = tonumber(valuebar.visibitilityThreshold:GetText()) or 99999, 
        ["opacityOn"] = tonumber(valuebar.opacityOn:GetText()) or 1, ["opacityOff"] = tonumber(valuebar.opacityOff:GetText()) or 1, 
        ["hideWhileOff"] = valuebar.hideWhileOff:IsChecked(), ["hideWhileOn"] = valuebar.hideWhileOn:IsChecked(),
        ["Event_Keyword"] = valuebar.eventTriggerTextbox and valuebar.eventTriggerTextbox:GetText() ~= "Event Keyword" and valuebar.eventTriggerTextbox:GetText(),}

        if func(triggerToken, triggerEntry) then
            return
        end

        valuebar.listbox:AddItem(GetListboxTiemPrimeUISkillEntry(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
        valuebar.listbox:SetVisible(true)
    end

    valuebar:SetSize(width, valuebar.listbox:GetHeight() + valuebar.optionsControl:GetHeight())

    optionsTreeNode:Add(valuebar.optionsControl)

    optionsTreeNode:Add(valuebar)

    return headerNode
end