function GetSpecialListBoxItem(key, value, width, triggerType, UIType, func, listbox)
    local listBoxItem = Turbine.UI.Control()
    listBoxItem:SetMouseVisible(false)
    listBoxItem:SetSize(width, 20)
    listBoxItem:SetBackColor(Turbine.UI.Color.Black)

    local innerWidth = width - 2

    local itemHeight = 0

    listBoxItem.InnerBox = Turbine.UI.Control()
    listBoxItem.InnerBox:SetParent(listBoxItem)
    listBoxItem.InnerBox:SetPosition(1, 1)
    listBoxItem.InnerBox:SetSize(innerWidth, 18)
    listBoxItem.InnerBox:SetBackColor(Turbine.UI.Color.DarkSlateBlue)

    listBoxItem.label = Turbine.UI.Label()
	listBoxItem.label:SetParent(listBoxItem.InnerBox)
	listBoxItem.label:SetSize(innerWidth, 25)
	listBoxItem.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	listBoxItem.label:SetPosition(0, itemHeight)
    listBoxItem.label:SetText(tostring(key))

    listBoxItem.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    listBoxItem.label:SetOutlineColor(Turbine.UI.Color.Black)
    listBoxItem.label:SetBackColor(Turbine.UI.Color(0.2,0.15,0.53))

    itemHeight = itemHeight + 30

    if triggerType == "Counter_Event" then
        listBoxItem.label:SetText("")
        listBoxItem.counterLabel = Turbine.UI.Label()
        listBoxItem.counterLabel:SetParent(listBoxItem.InnerBox)
        listBoxItem.counterLabel:SetSize(100, 20)
        listBoxItem.counterLabel:SetPosition(0, itemHeight)
        listBoxItem.counterLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        listBoxItem.counterLabel:SetText("Counter:")
    
        listBoxItem.counterBox = Turbine.UI.Lotro.TextBox()
        listBoxItem.counterBox:SetParent(listBoxItem.InnerBox)
        listBoxItem.counterBox:SetSize(250, 20)
        listBoxItem.counterBox:SetPosition(100, itemHeight)
        listBoxItem.counterBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        listBoxItem.counterBox:SetText(value.Counter_Text)

        listBoxItem.eventNumberKeywordLabel = Turbine.UI.Label()
        listBoxItem.eventNumberKeywordLabel:SetParent(listBoxItem.InnerBox)
        listBoxItem.eventNumberKeywordLabel:SetSize(80, 20)
        listBoxItem.eventNumberKeywordLabel:SetPosition(350, itemHeight)
        listBoxItem.eventNumberKeywordLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        listBoxItem.eventNumberKeywordLabel:SetText("Number:")
    
        listBoxItem.eventNumberKeywordBox = Turbine.UI.Lotro.TextBox()
        listBoxItem.eventNumberKeywordBox:SetParent(listBoxItem.InnerBox)
        listBoxItem.eventNumberKeywordBox:SetSize(50, 20)
        listBoxItem.eventNumberKeywordBox:SetPosition(430, itemHeight)
        listBoxItem.eventNumberKeywordBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        listBoxItem.eventNumberKeywordBox:SetText(value.Number)


        itemHeight = itemHeight + 25
    
        listBoxItem.eventKeywordBox = Turbine.UI.Lotro.TextBox()
        listBoxItem.eventKeywordBox:SetParent(listBoxItem.InnerBox)
        listBoxItem.eventKeywordBox:SetSize(250, 20)
        listBoxItem.eventKeywordBox:SetPosition(100, itemHeight)
        listBoxItem.eventKeywordBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        listBoxItem.eventKeywordBox:SetText(value.Event)

        itemHeight = itemHeight + 25

    end

    listBoxItem.RemovalButton = Turbine.UI.Lotro.Button()
    listBoxItem.RemovalButton:SetParent(listBoxItem.InnerBox)
    listBoxItem.RemovalButton:SetSize(100, 20)
    listBoxItem.RemovalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.RemovalButton:SetMouseVisible(false)
    listBoxItem.RemovalButton:SetPosition(width - 110, itemHeight + 2)
    listBoxItem.RemovalButton:SetText("Remove")

    listBoxItem.RemovalButton.Click = function()
        func(key, nil)
        listbox:RemoveItem(listBoxItem)
    end

    listBoxItem.headerDivider = Turbine.UI.Control()
    listBoxItem.headerDivider:SetParent(listBoxItem.InnerBox)
    listBoxItem.headerDivider:SetPosition(0, 25)
    listBoxItem.headerDivider:SetSize(innerWidth, 1)
    listBoxItem.headerDivider:SetBackColor(Turbine.UI.Color.Black)

    itemHeight = itemHeight + 35

    itemHeight = itemHeight + 25

    listBoxItem.InnerBox:SetSize(innerWidth, itemHeight)
    listBoxItem:SetSize(width, itemHeight + 2)

    listBoxItem.ChangeFunction = function()
        func(key, nil)

        local rewrittenValue = {}
        for valueKey, valueValue in pairs(value) do
            rewrittenValue[valueKey] = valueValue
        end

        if listBoxItem.counterBox then
            rewrittenValue.Counter_Text = tostring(listBoxItem.counterBox:GetText())
        end

        if listBoxItem.eventNumberKeywordBox then
            rewrittenValue.Number = tonumber(tostring(listBoxItem.eventNumberKeywordBox:GetText()))
        end

        if listBoxItem.eventKeywordBox then
            rewrittenValue.Event = tostring(listBoxItem.eventKeywordBox:GetText())
        end

        func(key, rewrittenValue)
    end

    return listBoxItem
end