function CreateSpecialListbox(width, triggerType, listboxItems, UIType, func, optionPage)
    local headerNode = Turbine.UI.TreeNode()
    headerNode:SetMouseVisible(false)
    headerNode:SetSize(width, 20)

    -- The header label with the trigger name
    headerNode.label = Turbine.UI.Label()
    headerNode.label:SetParent(headerNode)
    headerNode.label:SetSize(width, 20)
    headerNode.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    headerNode.label:SetPosition(0, 0)
    headerNode.label:SetText(triggerType)
    headerNode.label:SetBackColor(Turbine.UI.Color.Black)

    local optionsTreeNode = headerNode:GetChildNodes()

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

   local optionsHeight = 0
   local listboxHeight = 350

    valuebar.optionsControl = Turbine.UI.Control()
	valuebar.optionsControl:SetParent(valuebar)
    valuebar.optionsControl:SetPosition(0, 0)
    valuebar.optionsControl:SetBackColor(Turbine.UI.Color.DarkSlateGray)

    valuebar.nameTextBox = Turbine.UI.Lotro.TextBox()
    valuebar.nameTextBox:SetParent(valuebar.optionsControl)
    valuebar.nameTextBox:SetSize(width - 50, 20)
    valuebar.nameTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.nameTextBox:SetPosition(0, optionsHeight)
    valuebar.nameTextBox:SetText("Name")

    if triggerType == "Counter_Event" then
        valuebar.nameTextBox:SetVisible(false)
        valuebar.counterLabel = Turbine.UI.Label()
        valuebar.counterLabel:SetParent(valuebar.optionsControl)
        valuebar.counterLabel:SetSize(100, 20)
        valuebar.counterLabel:SetPosition(0, optionsHeight)
        valuebar.counterLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.counterLabel:SetText("Counter:")
    
        valuebar.counterBox = Turbine.UI.Lotro.TextBox()
        valuebar.counterBox:SetParent(valuebar.optionsControl)
        valuebar.counterBox:SetSize(250, 20)
        valuebar.counterBox:SetPosition(100, optionsHeight)
        valuebar.counterBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

        valuebar.eventNumberKeywordLabel = Turbine.UI.Label()
        valuebar.eventNumberKeywordLabel:SetParent(valuebar.optionsControl)
        valuebar.eventNumberKeywordLabel:SetSize(80, 20)
        valuebar.eventNumberKeywordLabel:SetPosition(350, optionsHeight)
        valuebar.eventNumberKeywordLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.eventNumberKeywordLabel:SetText("Number:")
    
        valuebar.eventNumberKeywordBox = Turbine.UI.Lotro.TextBox()
        valuebar.eventNumberKeywordBox:SetParent(valuebar.optionsControl)
        valuebar.eventNumberKeywordBox:SetSize(50, 20)
        valuebar.eventNumberKeywordBox:SetPosition(430, optionsHeight)
        valuebar.eventNumberKeywordBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

        valuebar.EventKeywordInfo = InfoButton(valuebar.optionsControl, width, 480, optionsHeight + 2, "When this count is reached for the specified counter name the specified event will fire.", optionPage.infoWindow)

        optionsHeight = optionsHeight + 25
    
        valuebar.eventKeywordBox = Turbine.UI.Lotro.TextBox()
        valuebar.eventKeywordBox:SetParent(valuebar.optionsControl)
        valuebar.eventKeywordBox:SetSize(250, 20)
        valuebar.eventKeywordBox:SetPosition(100, optionsHeight)
        valuebar.eventKeywordBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        valuebar.eventKeywordBox:SetText("Event")

        optionsHeight = optionsHeight + 25

    end

    valuebar.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    valuebar.addTriggerEntryButton:SetParent(valuebar)
    valuebar.addTriggerEntryButton:SetSize(100, 20)
    valuebar.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.addTriggerEntryButton:SetPosition(width - 120, optionsHeight)
    valuebar.addTriggerEntryButton:SetText("Add")

    optionsHeight = optionsHeight + 20

    -- Set options control to match all its children
    valuebar.optionsControl:SetSize(width, optionsHeight)

    -- Add listbox for items
    valuebar.listbox = Turbine.UI.ListBox()
    valuebar.listbox:SetParent(valuebar)
    valuebar.listbox:SetSize(width - 10, listboxHeight)
    valuebar.listbox:SetPosition(0, valuebar.optionsControl:GetHeight())
    valuebar.listbox:SetVisible(tablelength(listboxItems) > 0)

    valuebar.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    valuebar.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    valuebar.Scrollbar:SetParent(valuebar)
    valuebar.Scrollbar:SetPosition(width - 10, valuebar.optionsControl:GetHeight())
    valuebar.Scrollbar:SetSize(10, listboxHeight)
    valuebar.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    valuebar.listbox:SetVerticalScrollBar(valuebar.Scrollbar)

    for key, value in pairs(listboxItems) do
        valuebar.listbox:AddItem(GetSpecialListBoxItem(key, value, width - 10, triggerType, UIType, func, valuebar.listbox))
    end

    valuebar:SetSize(width, valuebar.listbox:GetHeight() + valuebar.optionsControl:GetHeight())

    optionsTreeNode:Add(valuebar.optionsControl)


    valuebar.addTriggerEntryButton.Click = function()
        local triggerEntry
        
        if triggerType == "Start_Keyword" or triggerType == "End_Keyword" or triggerType == "Reset_Keyword" or triggerType == "Name_Filter_List" then
            local triggerToken = tostring(valuebar.nameTextBox:GetText())
            triggerEntry = {
            }
            if func(triggerToken, triggerEntry) then
                return
            end

            valuebar.listbox:AddItem(GetSpecialListBoxItem(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            valuebar.listbox:SetVisible(true)
        elseif triggerType == "Counter_Event" then
            local triggerToken = Turbine.Engine.GetGameTime()
            triggerEntry = {
                ["Counter_Text"] = valuebar.counterBox and tostring(valuebar.counterBox:GetText()),
                ["Number"] = valuebar.eventNumberKeywordBox and tonumber(tostring(valuebar.eventNumberKeywordBox:GetText())),
                ["Event"] = valuebar.eventKeywordBox and tostring(valuebar.eventKeywordBox:GetText()),
            }
            if func(triggerToken, triggerEntry) then
                return
            end

            valuebar.listbox:AddItem(GetSpecialListBoxItem(triggerToken, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
            valuebar.listbox:SetVisible(true)
        end
    end

    optionsTreeNode:Add(valuebar)

    return headerNode
end