ClassSkillSlotPrimeUI = class(Turbine.UI.Window)
function ClassSkillSlotPrimeUI:Constructor(parent, x, y, width, height, code, borderColour, borderSize, reverse, visibitilityThreshold, hideWhileOff, hideWhileOn, opacityOn, opacityOff, font, scale, highlight, highlightColour, higlightSize, callbackFunction, backpack, locked, highlightOnReady)
    Turbine.UI.Window.Constructor(self)

    self.width = 34
    self.height = 34
    self.scale = scale or 1

    self.highlightOnReady = highlightOnReady or 0
    self.visibitilityThreshold = visibitilityThreshold or 9999
    self.hideWhileOff = hideWhileOff or false
    self.hideWhileOn = hideWhileOn or false
    self.opacityOff = opacityOff or 1
    self.opacityOn = opacityOn or 1
    self.borderSize = borderSize or 0
    self.callbackFunction = callbackFunction
    self.locked = locked

    if type(code) == "table" then
        self.data = code.Data
        self.type = code.Type
        self.item = code.Item
        self.shortcut = Turbine.UI.Lotro.Shortcut(self.type, self.data) 
        if self.shortcut:GetItem() ~= nil and self.shortcut:GetItem():GetItemInfo() then
            self.quickslotName = self.shortcut:GetItem():GetItemInfo():GetName()
            for i = 1, backpack:GetSize(), 1 do
                -- Create the bag slot
                local item = backpack:GetItem(i)
                if item then
                    local itemName = item:GetItemInfo():GetName()
                    if itemName == self.quickslotName then
                        self.IconLabel = Turbine.UI.Lotro.ItemControl()
                        self.IconLabel:SetItem(item)
                        self.shortcut = Turbine.UI.Lotro.Shortcut(item)
                        self.itemFound = true
                        break
                    end
                end
            end
        end
    else
        self.code = code
        self.success, self.shortcut = pcall(Turbine.UI.Lotro.Shortcut, 6, self.code)
    end

    self.currentDuration = 0

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetVisible(not(self.hideWhileOff))
    self:SetBackColor(borderColour or Turbine.UI.Color(0,0,0))
    self:SetOpacity(self.opacityOff)
    self:SetSize(self.width * self.scale + 2 * self.borderSize, self.height * self.scale + 2 * self.borderSize)

    self.textFunction = StringifyDuration

    if highlight or self.highlightOnReady then
        --self.highlight = HighlightFrame(self, borderSize)
        --self:SetZOrder(100)
        if self.scale == 1 and self.highlightOnReady > 0 then
            self.highlight = ClassSpecificTools.HighlightFrame(self, 1, 1, true)
        else
            self.highlight = ClassSpecificTools.HighlightFrame3(self, 0, 0, (self.width + 2 * self.borderSize) * self.scale, (self.height + 2 * self.borderSize) * self.scale, highlightColour, higlightSize)
        end
        
    end

    self.baseImageID = 0x41007E35

    self.currentNumber = -1

    if not(self.itemFound) then
        self.IconLabel = Turbine.UI.Lotro.Quickslot()
    end
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(35, 35)
    --self.IconLabel:SetBackColor(GetRandomColour())
    self.IconLabel:SetPosition(-2 + self.borderSize, -2 + self.borderSize)
    --self.IconLabel:SetAllowDrop(false)
    if not(self.itemFound) then
        self.IconLabel:SetShortcut(self.shortcut)
        self.IconLabel:SetUseOnRightClick(true)
    end
    if self.hideOnCreation then
        self.IconLabel:SetVisible(false)
    end
    --self.IconLabel:SetVisible(false)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    --self.textLabel:SetSize(self.width, self.height)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(font or Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetMultiline(false)
    --self.textLabel:SetPosition(-2, -2)
    --self.textLabel:SetStretchMode(1)
    self.textLabel:SetSize(self.width * self.scale + 2 * self.borderSize, self.height * self.scale + 2 * self.borderSize)

    self.IconLabel.ShortcutChanged = function()
        if self.locked then
            self.IconLabel:SetShortcut(self.shortcut)  
        end

        self.IconLabel:SetStretchMode(1)
        self.IconLabel:SetSize(35 * self.scale, 35 * self.scale)
        
        --self.IconLabel:SetShortcut(self.shortcut)
        ChatOutput(self.IconLabel:GetShortcut():GetData())
    end

    self.IconLabel:SetStretchMode(1)
    self.IconLabel:SetSize(35 * self.scale, 35 * self.scale)

    --self:ToggleHighlight(true)
    --self.textLabel:SetText("0")
end

function ClassSkillSlotPrimeUI:ExecuteUpdate(delta)

    --Update time
    self.currentDuration = self.currentDuration - delta

    self:SetVisible(self.currentDuration <= self.visibitilityThreshold and not(self.hideWhileOn))

    if self.currentDuration < 0 then
        --if self.callback then RemoveCallback(Updater, "ExecuteUpdate", self.callback) end
        --self.callback = nil
        self.textLabel:SetStretchMode(nil)
        self:SetOpacity(self.opacityOff)
        self.IconLabel:SetOpacity(self.opacityOff)
        self.textLabel:SetOpacity(self.opacityOff)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText("")

        if self.active and self.highlightOnReady > 0 then
            self:SetZOrder(100)
            self.highlight:Toggle(true, self.highlightOnReady)
            self:Activate()
            self.active = false
        end

        self:SetVisible(not(self.hideWhileOff))

        if self.callbackFunction then self.callbackFunction() end
        return true
    end

    -- Update timer label
    self.textLabel:SetStretchMode(nil)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetText(self.textFunction(self.currentDuration))
end

function ClassSkillSlotPrimeUI:Unload()
    if not(self.itemFound) then
        self.IconLabel.ShortcutChanged = function()
        end
        self.IconLabel:SetShortcut(nil)
    end
    self.shortcut = nil
    self.IconLabel:SetParent(nil)
    self:SetParent(nil)
end

function ClassSkillSlotPrimeUI:ToggleVisible(value)
    self.textLabel:SetVisible(value)
    self.IconLabel:SetVisible(value)
    self:SetVisible(value)
end

function ClassSkillSlotPrimeUI:ToggleHighlight(value)
    if self.highlight then
        if value then
            self:SetZOrder(100)
        else
            self:SetZOrder(1)
        end
        self.highlight:Toggle(value)
    end
end

function ClassSkillSlotPrimeUI:SetTimer(time, maxTimer)
    if not(time) then return end
    if time > 0 then
        self.active = true
        if self.highlightOnReady > 0 then
            self.highlight:Toggle(false)
        end
    end
    self.currentDuration = time
    self.maxDuration = maxTimer
    self:SetVisible(self.currentDuration <= self.visibitilityThreshold and not(self.hideWhileOn)  and time > 0.1)
    self:SetOpacity(self.opacityOn)
    self.IconLabel:SetOpacity(self.opacityOn)
    self.textLabel:SetOpacity(self.opacityOn)
end