KillCounter = class(Turbine.UI.Window)
function KillCounter:Constructor(instanceController)
    Turbine.UI.Window.Constructor(self)
    local width = 32 + 40
    local height = 32
    local x = Settings.KBX 
    local y = Settings.KBY

    self.LastKillTime = 0
    self.KillAmount = 0
    self.HighestMultiKill = 0
    self.KillStreak = Settings.PVMPKillStreak or 0
    self.instanceController = instanceController
    self.lastKB = ""
    self.lastKillCount = 0
    self.lastDeathCount = 0

    self:SetSize(width, height)
    self:SetPosition(x, y)
    self:SetVisible(Settings.KBVisible and Settings.EttenmoorsState)
    self:SetMouseVisible(true)
    --self:SetBackColor(GetRandomColour())

    local CharStats, accData = StatEventHandling:GetData()

    if not(CharStats) then return end

    if CharStats.DailyKB == nil then CharStats.DailyKB = 0 end

    if Settings.LastDailyReset < GetLastDailyReset() then 
        --SaveDailyPVMPStats()
        CharStats.DailyKB = 0
        CharStats.DailyDeaths = 0
        Settings.LastDailyReset = GetLastDailyReset()
    end

    self.KillStreaks = {
        [25] = {"Nuke Ready For Launch!", "PrimePlugins/RaidTools/Images/nuke100.tga"}
    }
    
    if Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == 2 then
        self.KillStreaks[10] = {"Angmar's Champion", nil}
        self.KillStreaks[20] = {"Sulfur Pit Survivor", nil}
        self.KillStreaks[30] = {"Witch King's Champion", nil}
        self.KillStreaks[40] = {"Mordirith's Disciple", nil}
        self.KillStreaks[50] = {"Sauron's Chosen Champion", "PrimePlugins/RaidTools/Images/sauronEyeLarge.tga"}
        self.KillStreaks[60] = {"Darkness Incarnate", nil}
        self.KillStreaks[100] = {"Morgoth's Champion", nil}
    else
        self.KillStreaks[10] = {"Bree's Champion", nil}
        self.KillStreaks[20] = {"Hero of the People", nil}
        self.KillStreaks[30] = {"Lainedhel's Champion", nil}
        self.KillStreaks[40] = {"Herald of The Free Peoples", nil}
        self.KillStreaks[50] = {"Champion of the Free-People", "PrimePlugins/RaidTools/Images/gondorTree.tga"}
        self.KillStreaks[60] = {"Champion of the Light", nil}
    end

    self.KillMessages = {
        [2] = "Double Kill",
        [3] = "Triple Kill",
        [4] = "Quadra Kill",
        [5] = "Penta Kill",
    }

    self.SkullLabel = Turbine.UI.Label()
    self.SkullLabel:SetParent(self)
    self.SkullLabel:SetSize(32, 32)
    --self.SkullLabel:SetBackColorBlendMode(Turbine.UI.BlendMode.Normal)
    --self.SkullLabel:SetBlendMode(Turbine.UI.BlendMode.Normal)
    if CharStats.DailyKB > 100 then
        self.SkullLabel:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/GoldSkull32.tga"))
    else
        self.SkullLabel:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/skull32.tga"))
    end
    self.SkullLabel:SetMouseVisible(false)

    local RedSkullLabel = Turbine.UI.Label()
    RedSkullLabel:SetParent(self)
    RedSkullLabel:SetSize(32, 32)
    --SkullLabel:SetBackColorBlendMode(Turbine.UI.BlendMode.Normal)
    --SkullLabel:SetBlendMode(Turbine.UI.BlendMode.Normal)
    RedSkullLabel:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/skullred32.tga"))
    RedSkullLabel:SetVisible(false)
    RedSkullLabel:SetMouseVisible(false)

    self.KillCount = Turbine.UI.Label()
    self.KillCount:SetParent(self)
    self.KillCount:SetSize(40, 32)
    self.KillCount:SetPosition(32, 0)
    self.KillCount:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.KillCount:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.KillCount:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.KillCount:SetMouseVisible(false)

    -- [[
    --]]
    self.KillCount:SetText(CharStats.DailyKB)

    self.DeathCount = Turbine.UI.Label()
    self.DeathCount:SetParent(self)
    self.DeathCount:SetSize(40, 32)
    self.DeathCount:SetPosition(32, 0)
    self.DeathCount:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.DeathCount:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.DeathCount:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.DeathCount:SetVisible(false)
    self.DeathCount:SetMouseVisible(false)
    self.DeathCount:SetForeColor(Turbine.UI.Color.Red)

    self.DeathCount:SetText(CharStats.DailyDeaths)

    self.moveBox = MoveBox(self, width, height, "KB")

    self.MouseClick = function()
        self.DeathCount:SetVisible(not(self.DeathCount:IsVisible()))
        self.KillCount:SetVisible(not(self.KillCount:IsVisible()))
        self.SkullLabel:SetVisible(not(self.SkullLabel:IsVisible()))
        RedSkullLabel:SetVisible(not(RedSkullLabel:IsVisible()))
    end

    self.instanceSwitchCallback = AddCallback(instanceController, "InstanceEvent", function(args)
        if args.PvMP_State then
            self:SetVisible(true)
        else
            self:SetVisible(false)
        end
    end)

    self.instanceController:PvpInfoDump({["Killstreak"] = self.KillStreak, ["Daily_KBs"] = CharStats.DailyKB, ["Daily_Deaths"] = CharStats.DailyDeaths, ["Last_KB"] = self.lastKB, ["Last_KB_KC"] = self.lastKillCount, ["Last_KB_Deaths"] = self.lastDeathCount})
end

function KillCounter:UpdateKill(kb)
    local CharStats, _ = StatEventHandling:GetData()
    -- Update kb count
    self.KillCount:SetText(CharStats.DailyKB)

    if CharStats.DailyKB > 100 then
        self.SkullLabel:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/GoldSkull32.tga"))
    end

    -- Kill streak
    self.KillStreak = self.KillStreak + 1
    Settings.PVMPKillStreak = self.KillStreak
    if self.KillStreak % 5 == 0 then 
        local KillStreakMessage = self.KillStreaks[self.KillStreak]
        local effectsWindow = EventWindows:GetEffectWindow()
        if KillStreakMessage ~= nil and effectsWindow then
            effectsWindow:Message(7, self.KillStreak .. " Kill Streak\n".. KillStreakMessage[1], KillStreakMessage[2], false, "Killstreak Message")
        else
            effectsWindow:Message(7, self.KillStreak .. " Kill Streak", "PrimePlugins/RaidTools/Images/skullstack.tga", false, "Killstreak Message") 
        end
    end

    -- Multi Kills
    if Turbine.Engine.GetGameTime() - self.LastKillTime < 20 then
        self.KillAmount = self.KillAmount + 1
        if self.KillAmount > 1 and effectsWindow then
            local message = nil
            local icon
            if self.KillAmount > 5 then
                message = "Domination"
                icon = "PrimePlugins/RaidTools/Images/skullgold100.tga"
            else
                message = self.KillMessages[self.KillAmount]
            end            

            effectsWindow:Message(4, message, icon, false, "Kill Message")
        end
    else
        self.KillAmount = 1
    end
    if self.HighestMultiKill < self.KillAmount then self.HighestMultiKill = self.KillAmount end
    self.LastKillTime = Turbine.Engine.GetGameTime()

    -- Chat message
    local DeathCount =  CharStats["KilledBy"][kb]
    local KillCount = CharStats["KB"][kb]
    self.lastKB = kb
    self.lastKillCount = KillCount
    self.lastDeathCount = DeathCount

    if DeathCount == nil then DeathCount = 0 end
    if KillCount == nil then KillCount = 0 end

    if Settings.EttenmoorsState and Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() < 2 then
        ChatOutput("You have vanquished " .. kb .. " <rgb=#006013>" .. KillCount .. "</rgb> times and perished <rgb=#8e0000>" .. DeathCount .. "</rgb> times!")
    elseif Settings.EttenmoorsState and Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == 2 then
        ChatOutput("You have slaughtered " .. kb .. " <rgb=#006013>" .. KillCount .. "</rgb> times for the glory of Angmar and sacrificed yourself <rgb=#8e0000>" .. DeathCount .. "</rgb> times!")
    end

    self.instanceController:PvpInfoDump({["Killstreak"] = self.KillStreak, ["Daily_KBs"] = CharStats.DailyKB, ["Daily_Deaths"] = CharStats.DailyDeaths, ["Last_KB"] = self.lastKB, ["Last_KB_KC"] = self.lastKillCount, ["Last_KB_Deaths"] = self.lastDeathCount})
end

function KillCounter:UpdateDeath()
    StatEventHandling:KillStreakDeath(self.KillStreak)
    self.KillStreak = 0
    Settings.PVMPKillStreak = self.KillStreak
    local charData, _ = StatEventHandling:GetData()
    self.DeathCount:SetText(charData.DailyDeaths)
    self.instanceController:PvpInfoDump({["Killstreak"] = self.KillStreak, ["Daily_KBs"] = charData.DailyKB, ["Daily_Deaths"] = charData.DailyDeaths, ["Last_KB"] = self.lastKB, ["Last_KB_KC"] = self.lastKillCount, ["Last_KB_Deaths"] = self.lastDeathCount})
end


function KillCounter:ToggleMove()
    self.moveBox:ToggleMove()
end

function KillCounter:GetKillStreak()
    return(self.KillStreak)
end

function KillCounter:HighestKillCombo()
    return(self.HighestMultiKill)
end

function KillCounter:GetInfo()
    local CharStats, _ = StatEventHandling:GetData()
    return {["Killstreak"] = self.KillStreak, ["Daily_KBs"] = CharStats.DailyKB, ["Daily_Deaths"] = CharStats.DailyDeaths, ["Last_KB"] = self.lastKB, ["Last_KB_KC"] = self.lastKillCount, ["Last_KB_Deaths"] = self.lastDeathCount}
end