PvpTimers = class(Turbine.UI.Window)
function PvpTimers:Constructor()
    self.width = Settings.PPWidth
    local height = Settings.PPHeight
    local x = Settings.PPX
    local y = Settings.PPY

    self.TimerHeight = 20

    self.Timers = {}
    self.resort = false

    Turbine.UI.Window.Constructor(self)
    self:SetSize(self.width,height)
    self:SetPosition(x,y)
    self:SetZOrder(1)

    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetWantsUpdates(true)

    self.messageBox = Turbine.UI.Label()
    self.messageBox:SetParent(self)
    self.messageBox:SetSize(self.width,height)
    self.messageBox:SetPosition(0,0)
    self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox:SetFont(Settings.SPFont)
    self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox:SetMouseVisible(false)
    self.messageBox:SetVisible(false)
  
    local moveBox = MoveBox(self, self.width, height, "PvP Timers")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.Clear = function()
        for key, value in pairs(self.Timers) do 
            value[1]:Destroy()
            self.Timers[key] = nil
        end

        if Tablelength(self.Timers) > 0 then
            self.Clear()
        end

        self.Timers = nil
        collectgarbage()
        self.Timers = {}
    end

    self.ResortList = function()
        if Tablelength(self.Timers) > 1 then  
            table.sort(self.Timers, Compare)
        end
        local counter = 0
        for key, value in pairs(self.Timers) do
            value[1]:SetPosition(0, counter * self.TimerHeight) 
            counter = counter + 1
        end

        self.resort = false
    end

    self.ExecuteUpdate = function(delta)   
        --We had an update
        for key, value in pairs(self.Timers) do 
            value[2] = value[2] - delta
            value[1]:UpdateText(delta)
            if value[2] < 0 then 
    
                local messageWindow = EventWindows:GetAlertWindow()
                if messageWindow then 
                    messageWindow:Message(4, "<rgb=#007700>" .. value[5] .. "</rgb> Ready on: <rgb=#FF0000>" .. value[4], value[6], false)
                end 
    
                --PrintTable(self.Timers)
                --ChatOutput("Delete ID: " .. key)
                value[1]:Destroy()
                self.Timers[key] = nil
                --PrintTable(self.Timers)
                self.resort = true
    
    
            end
            --value[1]:SetText(value[3].." "..value[2])
        end
    
        if self.resort then 
            if tablelength(self.Timers) == 0 then 
                self.Timers = nil
                collectgarbage()
                self.Timers = {}
                if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
                self.updateCallback = nil
                return
            end
            self.ResortList() 
        end
    end
end

function PvpTimers:Unload()
    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
    self:SetParent(nil)
end

-- Add a timer
function PvpTimers:NewTimer(maxDuration, targetName, effect, barrage)
    if not(Settings.EttenmoorsState) then return end
    -- [[
    local count = tablelength(self.Timers)
    local duration = maxDuration
    local effectName = nil
    local icon = nil
    if barrage then
        effectName = "Steadfast Barrage"
    else
        if effect.GetName == nil then
            effectName = effect
            targetName = targetName .. " " .. effect
        else
            effectName = effect:GetName()
            icon = effect:GetIcon()
        end
    end
    if barrage then
        for key, value in pairs(self.Timers) do
            --ChatOutput(value[4] .. " " .. effectName)
            if value[3] and value[4] == targetName then 
                value[1]:ChangeDuration(maxDuration)
                value[2] = 30
                return
                end
        end
    elseif effectName == "Steadfast Barrage" then
        return
    else
        for key, value in pairs(self.Timers) do
            --ChatOutput(value[4] .. " " .. effectName)
            if not(value[3]) and value[4] == targetName and value[5] == effectName then 
                return
            end
        end
        if effect.GetStartTime then
            duration = maxDuration - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
        else
            effect = nil
        end
    end

    --ChatOutput(effectName)
    self.Timers[#self.Timers + 1] = {Counter2(self, self.width, self.TimerHeight, count, maxDuration, targetName, Settings.SPNewFont, Turbine.UI.Color(1,0,0), Turbine.UI.Color(0.5,0,0), Turbine.UI.Color(0,0.125,0.5), Turbine.UI.Color(0,0.8,0.2), Turbine.UI.Color(0,0.5,0), nil, effect, nil, nil, 2), duration, barrage, targetName, effectName, icon}  

    --ID = ID + 1
    self.resort = true

    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
    --PrintTable(self.Timers)
    --]]
end