ReadyCheckHandler = class(Turbine.UI.Control)
function ReadyCheckHandler:Constructor()
    Turbine.UI.Control.Constructor(self)

    if not(Turbine.Gameplay.LocalPlayer.GetInstance():GetParty()) then return end

    self.readyActive = false
    self.readyStartTime = 0

    self.readyOverview = ReadyWindow(self)
    self.readyAcceptanceWindow = ReadyCheckWindow()
    self.ChatReadyButton = ReadyButtonWindow()

    self.ExecuteUpdate = function(delta)
        self.readyStartTime = self.readyStartTime + delta
    
        self.readyOverview:SetTimerBar((self.maxReadyTime - self.readyStartTime) / 60)
    
        if self.maxReadyTime < self.readyStartTime then
            self.readyOverview:OutputState()
            if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
            self.updateCallback = nil
        end
    end
end

function ReadyCheckHandler:MakeNewReadyCheck()
    -- Make sure the button to start is invisble 
    self.ChatReadyButton:SetVisible(false)

    -- Clear the old check and set ready state to undecided
    self.readyOverview:ClearOldReadyCheck()

    -- Initialize the new ready check
    self.readyStartTime = Turbine.Engine.GetGameTime()
    self.maxReadyTime = self.readyStartTime + 60
    self.readyActive = true
    --self.readyOverview:MakeNewReadyCheck()

    -- Open acceptance window
    self.readyAcceptanceWindow:MakeReadyCheck()

    -- Start timer
    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end

    -- All done
    Sounds:PlaySoundEffect(Sounds:GetSoundList()["Rc"]) 
end

function ReadyCheckHandler:ToggleButton(state)
    self.ChatReadyButton:SetVisible(state)
end

function ReadyCheckHandler:ReadyUpdate(player, status)
    if self.readyActive then self.readyOverview:UpdateReadycheckMember(player, status) end
end

function ReadyCheckHandler:ReadyCheckActive()
    return self.readyActive
end

function ReadyCheckHandler:ShowOverview()
    self.readyOverview:MakeNewReadyCheck()
    self.readyAcceptanceWindow:SetVisible(false)
end

function ReadyCheckHandler:ReadyDone()
    if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
    self.updateCallback = nil
    self.readyOverview:SetReadyDone()
end