ReadyLabelName = class(Turbine.UI.Control)
function ReadyLabelName:Constructor(player, parent, index)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetVisible(true)
    self:SetSize(120, 20)
    self:SetPosition(120 * ((index - 1) % 4), 25 + 20 * math.floor((index - 1) / 4))
    --self:SetBackColor(Turbine.UI.Color( math.random(), math.random(), math.random() ) )
    self:SetMouseVisible(false)
    --self:SetWantsUpdates(true)

    self.icons = {
        [Turbine.Gameplay.Class.Burglar] = 0x41007deb,
        [Turbine.Gameplay.Class.Captain] = 0x41007de7,
        [Turbine.Gameplay.Class.Champion] = 0x41007dec,
        --[Turbine.Gameplay.Class.Corsair] = 0x41007dec,
        [Turbine.Gameplay.Class.Guardian] = 0x41007de8,
        [Turbine.Gameplay.Class.Hunter] = 0x41007dea,
        [Turbine.Gameplay.Class.LoreMaster] = 0x41007de9,
        [Turbine.Gameplay.Class.Minstrel] = 0x41007de6,
        [Turbine.Gameplay.Class.RuneKeeper] = 0x410ea238,
        [Turbine.Gameplay.Class.Warden] = 0x410ea239,
        [Turbine.Gameplay.Class.Beorning] = 0x4115370d,
        [Turbine.Gameplay.Class.BlackArrow] = 0x41007def,
        [Turbine.Gameplay.Class.Defiler] = 0x410e6bf4,
        [Turbine.Gameplay.Class.Reaver] = 0x41007ded,
        [Turbine.Gameplay.Class.Stalker] = 0x41007df1, 
        [Turbine.Gameplay.Class.WarLeader] = 0x41007df0, 
        [Turbine.Gameplay.Class.Weaver] = 0x41007dee, 
        [Turbine.Gameplay.Class.Chicken] = 0x41091DE1,
        [Turbine.Gameplay.Class.Troll] = 0x41091DE2,
        [Turbine.Gameplay.Class.Ranger] = 0x41091DE3,
        [Turbine.Gameplay.Class.Brawler] = 0x411F516F, --0x4122F875 | big 0x4120FCD8
    }

    self.icon = Turbine.UI.Label()
    self.icon:SetParent(self)
    self.icon:SetSize(20, 20)
    self.icon:SetPosition(0, 0)
    self.icon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
    self.icon:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.icon:SetBackground(self.icons[player:GetClass()])
    self.icon:SetMouseVisible(false)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetSize(100, 20)
    self.label:SetPosition(20, 0)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetMouseVisible(false)
    self.label:SetVisible(true)
    self.label:SetMultiline(false)
    self.label:SetOutlineColor(Turbine.UI.Color(0,0,0))
    --self.label:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.label:SetText(player:GetName())
    --self.label:SetText(index)
    self.label:SetForeColor(Turbine.UI.Color(1, 1, 1))

end

function ReadyLabelName:UpdateReadyState(state)
    if state then
        self.label:SetForeColor(Turbine.UI.Color(0, 1, 0))
    else
        self.label:SetForeColor(Turbine.UI.Color(1, 0, 0))
    end
end

function ReadyLabelName:SetDefault()
    self.label:SetForeColor(Turbine.UI.Color(1, 1, 1))
end
