ReadyLabel = class(Turbine.UI.Control)
function ReadyLabel:Constructor(player, parent, index)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetVisible(true)
    self:SetSize(80, 300)
    self:SetPosition(80 * index, 20 + 5)
    --self:SetBackColor(Turbine.UI.Color( math.random(), math.random(), math.random() ) )
    self:SetMouseVisible(false)
    --self:SetWantsUpdates(true)

    self.icon = Turbine.UI.Label()
    self.icon:SetParent(self)
    self.icon:SetSize(20, 20)
    self.icon:SetPosition(30, 10)
    self.icon:SetBackground(Icons[player:GetClass()])
    self.icon:SetMouseVisible(false)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetSize(80, 32)
    self.label:SetPosition(0,32)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiqua18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetMouseVisible(false)
    self.label:SetVisible(true)
    self.label:SetOutlineColor(Turbine.UI.Color(0,0,0))
    --self.label:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.label:SetText(player:GetName())
    self.label:SetForeColor(Turbine.UI.Color(1, 1, 1))

    self.scrollOffensiveLabel = Turbine.UI.Label()
    self.scrollOffensiveLabel:SetParent(self)
    self.scrollOffensiveLabel:SetSize(80, 32)
    self.scrollOffensiveLabel:SetPosition(0,32 + 32)
    self.scrollOffensiveLabel:SetMouseVisible(false)
    self.scrollOffensiveLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua26)
    self.scrollOffensiveLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.scrollOffensiveLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.scrollOffensiveLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)

    self.scrollDefensiveLabel = Turbine.UI.Label()
    self.scrollDefensiveLabel:SetParent(self)
    self.scrollDefensiveLabel:SetSize(80, 32)
    self.scrollDefensiveLabel:SetPosition(0,64 + 32)
    self.scrollDefensiveLabel:SetMouseVisible(false)
    self.scrollDefensiveLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua26)
    self.scrollDefensiveLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.scrollDefensiveLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.scrollDefensiveLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)

    self.hopeLabel = Turbine.UI.Label()
    self.hopeLabel:SetParent(self)
    self.hopeLabel:SetSize(80, 32)
    self.hopeLabel:SetPosition(0,96 + 32)
    self.hopeLabel:SetMouseVisible(false)
    self.hopeLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua26)
    self.hopeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.hopeLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.hopeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)

    self.dbLabel = Turbine.UI.Label()
    self.dbLabel:SetParent(self)
    self.dbLabel:SetSize(80, 32)
    self.dbLabel:SetPosition(0,128 + 32)
    self.dbLabel:SetMouseVisible(false)
    self.dbLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua26)
    self.dbLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.dbLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.dbLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)

    local effectList = player:GetEffects()

    local PlayerEffects = {}
    local hope = false
    local oScrolls = false
    local dScrolls = false
    local dB = false
    for i = 1, effectList:GetCount(), 1 do
        PlayerEffects[effectList:Get(i):GetName()] = true
        --ChatOutput(player:GetName() .. effectList:Get(i):GetName())
        if string.find(effectList:Get(i):GetName(), "Battle Lore") then oScrolls = true end
        if string.find(effectList:Get(i):GetName(), "Warding Lore") then dScrolls = true end
        if string.find(effectList:Get(i):GetName(), "Token: Give Hope") then hope = true end
        if string.find(effectList:Get(i):GetName(), "Duty Bound") then dB = true end
    end

    if oScrolls then
        --self.scrollOffensiveLabel:SetBackground(1090642112)
        self.scrollOffensiveLabel:SetText("O")
        self.scrollOffensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    else
        self.scrollOffensiveLabel:SetText("X")
        self.scrollOffensiveLabel:SetForeColor(Turbine.UI.Color.Crimson)
    end

    if dScrolls then
        self.scrollDefensiveLabel:SetText("O")
        self.scrollDefensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    else
        self.scrollDefensiveLabel:SetText("X")
        self.scrollDefensiveLabel:SetForeColor(Turbine.UI.Color.Crimson)
    end

    if hope then
        self.hopeLabel:SetText("O")
        self.hopeLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    else
        self.hopeLabel:SetText("X")
        self.hopeLabel:SetForeColor(Turbine.UI.Color.Crimson)
    end

    if dB then
        self.dbLabel:SetText("O")
        self.dbLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    else
        self.dbLabel:SetText("X")
        self.dbLabel:SetForeColor(Turbine.UI.Color.Crimson)
    end

    local effectList = player:GetEffects()

    local PlayerEffects = {}
    local hope = false
    local oScrolls = false
    local dScrolls = false
    local dB = false
    for i = 1, effectList:GetCount(), 1 do
        PlayerEffects[effectList:Get(i):GetName()] = true
        --ChatOutput(player:GetName() .. effectList:Get(i):GetName())
        if string.find(effectList:Get(i):GetName(), "Battle Lore") then oScrolls = true end
        if string.find(effectList:Get(i):GetName(), "Warding Lore") then dScrolls = true end
        if string.find(effectList:Get(i):GetName(), "Token: Give Hope") then hope = true end
        if string.find(effectList:Get(i):GetName(), "Duty Bound") then dB = true end
    end

    if oScrolls then
        --self.scrollOffensiveLabel:SetBackground(1090642112)
        self.scrollOffensiveLabel:SetText("O")
        self.scrollOffensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    end

    if dScrolls then
        self.scrollDefensiveLabel:SetText("O")
        self.scrollDefensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    end

    if hope then
        self.hopeLabel:SetText("O")
        self.hopeLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    end

    if dB then
        self.dbLabel:SetText("O")
        self.dbLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
    end

    

    self.ScropeState = function(sender, buffname)
        --ChatOutput(buffname)
        if string.find(buffname,"Battle Lore") then
            --self.scrollOffensiveLabel:SetBackground(1090642112)
            self.scrollOffensiveLabel:SetText("O")
            self.scrollOffensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
        end
    
        if string.find(buffname, "Warding Lore") then
            self.scrollDefensiveLabel:SetText("O")
            self.scrollDefensiveLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
        end
    
        if string.find(buffname, "Token: Give Hope") then
            self.hopeLabel:SetText("O")
            self.hopeLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
        end

        if string.find(buffname, "Duty Bound") then
            self.dbLabel:SetText("O")
            self.dbLabel:SetForeColor(Turbine.UI.Color.DarkGreen)
        end
    end

    self.UpdateReadyState = function(sender, state)
        if state then
            self.label:SetForeColor(Turbine.UI.Color(0, 1, 0))
        else
            self.label:SetForeColor(Turbine.UI.Color(1, 0, 0))
        end
    end

    --ChatOutput(player:GetName() .. "Made Label")

end



--Duty Bound 1090553996
--Dwarf Endurance 1090554033