BuffTrackerSettings = class(Turbine.UI.Control)
function BuffTrackerSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    local colorTurn = 0
    local prevItem = nil
    local prevColour = nil
    local selectedName = nil
    local selfWindowSelected = true

    local SettingsWindows = {}

    local BuffWindowContainerItems = {}

    self.CreateBuffwindowItem = function(name)
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 200, 20 )
        listItem:SetMouseVisible(true)
        listItem:SetBackColor(Turbine.UI.Color.Gray)
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 20)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetForeColor(Turbine.UI.Color(0,0,0))
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetText(name)

        listItem.MouseClick = function()
            if prevItem ~= nil then
                prevItem:SetBackColor(Turbine.UI.Color.Gray)
            end
            prevItem = listItem
            listItem:SetBackColor(Turbine.UI.Color.LightGray)
            selectedName = name
            for key, value in pairs(SettingsWindows) do
                value:SetVisible(false)
                --ChatOutput(key)
            end
            --ChatOutput(name)
            SettingsWindows[name]:SetVisible(true)
        end

        return(listItem)
    end

    self.MakeEffectListItem = function(box, Name, text, print)
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 200, 20 )
        listItem:SetMouseVisible(true)

        if print then ChatOutput("Added Effect: " .. text .. " To Buff Window: " .. Name) end

        BuffWindows[Name].List[text] = true
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 20)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetForeColor(Turbine.UI.Color(1,1,1))
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetText(text)

        listItem.MouseClick = function()
            BuffWindows[Name].List[text] = nil
            ChatOutput("Removed Effect: " .. text .. " To Buff Window: " .. Name)
            box:RemoveItem(listItem)
        end

        box:AddItem(listItem)
    end

    self.MakeWindowSettingsWindow = function(Name)
        local WindowControl = Turbine.UI.Control()
        WindowControl:SetParent(self)
        WindowControl:SetSize(500, 600)
        WindowControl:SetPosition(300, 60)
        WindowControl:SetVisible(false)

        -- Info label
        local InfoLabel = Turbine.UI.Label()
        InfoLabel:SetParent(WindowControl)
        InfoLabel:SetSize(200, 40)
        InfoLabel:SetPosition(0, 240)
        InfoLabel:SetText("For some changes you need to reload the plugin")

        -- Buff/Debuff button
        local Button1 = Turbine.UI.Lotro.Button()
        Button1:SetParent(WindowControl)
        Button1:SetSize(100, 15)
        Button1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button1:SetMouseVisible(true)
        Button1:SetPosition(0, 0)

        if BuffWindows[Name].Buff then
            Button1:SetText("Buffs")
        else
            Button1:SetText("Debuffs")
        end
    
        Button1.Click = function()
            if Button1:GetText() == "Buffs" then
                Button1:SetText("Debuffs")
                BuffWindows[Name].Buff = false
            else
                Button1:SetText("Buffs")
                BuffWindows[Name].Buff = true
            end
        end

        -- Mode button
        local Button2 = Turbine.UI.Lotro.Button()
        Button2:SetParent(WindowControl)
        Button2:SetSize(100, 15)
        Button2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button2:SetMouseVisible(true)
        Button2:SetPosition(0, 30)
        if BuffWindows[Name].Mode == 0 then
            Button2:SetText("No Filter")
        elseif BuffWindows[Name].Mode == 1 then
            Button2:SetText("WhiteList")
        elseif BuffWindows[Name].Mode == 2 then
            Button2:SetText("BlackList")
        end
    
        Button2.Click = function()
            if Button2:GetText() == "No Filter" then
                Button2:SetText("WhiteList")
                BuffWindows[Name].Mode = 1
            elseif Button2:GetText() == "WhiteList" then
                Button2:SetText("BlackList")
                BuffWindows[Name].Mode = 2
            elseif Button2:GetText() == "BlackList" then
                Button2:SetText("No Filter")
                BuffWindows[Name].Mode = 0
            end
        end

        -- Effect list
        local ItemTextBox = Turbine.UI.Lotro.TextBox()
        ItemTextBox:SetParent(WindowControl)
        ItemTextBox:SetSize(150, 30)
        ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        ItemTextBox:SetMouseVisible(false)
        ItemTextBox:SetPosition(0, 60)
        ItemTextBox:SetMultiline(false)
        ItemTextBox:SetText("<Effect>")

        local lab = Turbine.UI.Label()
        lab:SetParent(WindowControl)
        lab:SetSize(250, 20)
        lab:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        lab:SetMouseVisible(false)
        lab:SetPosition(200, 0)
        lab:SetMultiline(false)
        lab:SetText("Click on an effect to remove it")

        local container = Turbine.UI.ListBox()
        container:SetParent(WindowControl)
        container:SetSize(200, height - 200)
        container:SetPosition(200, 20)
        --container:SetBackColor(GoldColor)
        container:SetVisible(true)
        container:SetWantsKeyEvents(true)
        container:SetMouseVisible(true)
    
        local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
        containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
        containerScrollbar:SetParent( WindowControl )
        containerScrollbar:SetPosition(430 - 10, 20 )
        containerScrollbar:SetSize( 10, height - 200 )
        container:SetVerticalScrollBar( containerScrollbar )

        local sortedKeys = {}
        for key, value in pairs(BuffWindows[Name].List) do table.insert( sortedKeys, key ) end
        table.sort( sortedKeys )
    
        for key, value in pairs(sortedKeys) do
            self.MakeEffectListItem(container, Name, value, false)
        end

        local Button3 = Turbine.UI.Lotro.Button()
        Button3:SetParent(WindowControl)
        Button3:SetSize(100, 15)
        Button3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button3:SetMouseVisible(true)
        Button3:SetPosition(0, 95)
        Button3:SetText("Add Effect")
    
        Button3.Click = function()
            self.MakeEffectListItem(container, Name, ItemTextBox:GetText(), true)
        end

        local Button4 = Turbine.UI.Lotro.Button()
        Button4:SetParent(WindowControl)
        Button4:SetSize(150, 15)
        Button4:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button4:SetMouseVisible(true)
        Button4:SetPosition(0, 125)
        if BuffWindows[Name].SortMethod == nil then
            BuffWindows[Name].SortMethod = 1
        end

        if BuffWindows[Name].SortMethod == 1 then
            Button4:SetText("Highest on Top")
        elseif  BuffWindows[Name].SortMethod == 2 then
            Button4:SetText("Lowest on Top")
        end
    
        Button4.Click = function()
            if Button4:GetText() == "Highest on Top" then
                Button4:SetText("Lowest on Top")
                BuffWindows[Name].SortMethod = 2
            else
                Button4:SetText("Highest on Top")
                BuffWindows[Name].SortMethod = 1
            end 
        end

        local Button5 = Turbine.UI.Lotro.Button()
        Button5:SetParent(WindowControl)
        Button5:SetSize(150, 15)
        Button5:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button5:SetMouseVisible(true)
        Button5:SetPosition(0, 150)
        if BuffWindows[Name].sortDirection == nil then
            BuffWindows[Name].sortDirection = 1
        end

        if BuffWindows[Name].sortDirection == 1 then
            Button5:SetText("Add timers at top")
        elseif  BuffWindows[Name].sortDirection == 2 then
            Button5:SetText("Add timers at bottom")
        end
    
        Button5.Click = function()
            if Button5:GetText() == "Add timers at top" then
                Button5:SetText("Add timers at bottom")
                BuffWindows[Name].sortDirection = 2
            else
                Button5:SetText("Add timers at top")
                BuffWindows[Name].sortDirection = 1
            end 
        end

        local timerBox = Turbine.UI.Lotro.TextBox()
        timerBox:SetParent(WindowControl)
        timerBox:SetSize(50, 20)
        timerBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        timerBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        timerBox:SetPosition(15, 180)
        timerBox:SetText(BuffWindows[Name].Width)
    
        local sizeButton = Turbine.UI.Lotro.Button()
        sizeButton:SetParent(WindowControl)
        sizeButton:SetSize(80, 20)
        sizeButton:SetPosition(5, 200)
        sizeButton:SetText("Set Width") 
    
        sizeButton.Click = function()
            BuffWindows[Name].Width = tonumber(timerBox:GetText())
            ChatOutput("Changed buff window ".. Name .. " width to " .. tonumber(timerBox:GetText()))
        end


        local Button4 = Turbine.UI.Lotro.Button()
        Button4:SetParent(WindowControl)
        Button4:SetSize(100, 15)
        Button4:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button4:SetMouseVisible(true)
        Button4:SetPosition(0, 220)
        Button4:SetText("Delete window")

            
        Button4.Click = function()
            BuffWindowContainerItems[Name]:SetVisible(false)

            --container:RemoveItem(item)
            BuffWindowObjects[Name]:SetVisible(false)
            BuffWindowObjects[Name]:SetParent(nil)
            BuffWindowObjects[Name] = nil
            BuffWindows[Name]= nil
            WindowControl:SetVisible(false)

            ChatOutput("Deleted Buff Window: " .. Name)
        end


        SettingsWindows[Name] = WindowControl

    end

    self.NewWindowSettings = function()
        
    end

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(30 - 2, 50 - 2)
    SingleBackground:SetSize(200 + 4, height - 200 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(30, 50)
    SingleBackground:SetSize(200, height - 200)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(200, height - 200)
    container:SetPosition(30, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( self )
    containerScrollbar:SetPosition(230 - 10, 50 )
    containerScrollbar:SetSize( 10, height - 200 )
    container:SetVerticalScrollBar( containerScrollbar )

    local sortedKeys = {}
    for key, value in pairs(BuffWindows) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )

    for key, value in pairs(sortedKeys) do
        self.MakeWindowSettingsWindow(value)
        local TempItem = self.CreateBuffwindowItem(value)
        BuffWindowContainerItems[value] = TempItem
        container:AddItem(TempItem)
    end

    local ItemTextBox = Turbine.UI.Lotro.TextBox()
    ItemTextBox:SetParent(self)
    ItemTextBox:SetSize(150, 30)
    ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox:SetMouseVisible(false)
    ItemTextBox:SetPosition(30, 10)
    ItemTextBox:SetMultiline(false)
    ItemTextBox:SetText("<Name>")

    local AddButton = Turbine.UI.Lotro.Button()
    AddButton:SetParent(self)
    AddButton:SetSize(100, 15)
    AddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    AddButton:SetMouseVisible(true)
    AddButton:SetPosition(190, 15)
    AddButton:SetText("Add window")

    AddButton.Click = function()
        if BuffWindows[ItemTextBox:GetText()] ~= nil then 
            ChatOutput("Already existing window")
            return
        end
        local Config = {}
        Config.Buff = true
        Config.List = {}
        Config.Name = ItemTextBox:GetText()
        Config.Mode = 0 -- 0 -> no filter | 1 --> whitelist | 2 --> blacklist
        Config.X = math.floor(Turbine.UI.Display.GetWidth() / 2 - (Settings.SNewWidth/2))
        Config.Y = math.floor(Turbine.UI.Display.GetHeight() / 1.5)
        Config.Width = 200
        Config.sortDirection = 1
        BuffWindows[ItemTextBox:GetText()] = Config
        self.MakeWindowSettingsWindow(ItemTextBox:GetText())
        local TempItem = self.CreateBuffwindowItem(ItemTextBox:GetText())
        BuffWindowContainerItems[ItemTextBox:GetText()] = TempItem
        container:AddItem(TempItem)
    end

    local WidthBackground = Turbine.UI.Control()
    WidthBackground:SetParent(self)
    WidthBackground:SetPosition(20, 350)
    WidthBackground:SetSize(230, 200)
    WidthBackground:SetMouseVisible(false)
    WidthBackground:SetVisible(true)
    --WidthBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    
    self.colourScheme = {Turbine.UI.Color(0.8,0,0,0), Turbine.UI.Color(0.8,0,0,0), Turbine.UI.Color(0,0.5,0), Turbine.UI.Color(1,1,1), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0.6,0.5,0,0), Settings.BuffBarFrontTexture, Settings.BuffBarBackTexture, Settings.BuffBarFrontOpacity, Settings.BuffBarBackOpacity}
    self.ExampleTimer = EffectTimer(WidthBackground, Settings.BuffBarWidth, 20, nil, "Test",  Settings.SPNewFont, self.colourScheme, true, nil, 20, 0x411172A2)
    self.ExampleTimer:SetPosition(130, 60)
    self.duration = 20

    self.ExecuteUpdate = function(delta)
        self.duration = self.duration - delta
    
        if self.duration < 2 then 
            self.duration = 20 
            self.ExampleTimer:ChangeDuration(self.duration)
        end
        self.ExampleTimer:UpdateText(delta)
    end
    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end



    local opacityBox = Turbine.UI.Lotro.TextBox()
    opacityBox:SetParent(WidthBackground)
    opacityBox:SetSize(50, 20)
    opacityBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    opacityBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    opacityBox:SetPosition(105, 0)
    opacityBox:SetText(Settings.BuffBarFrontOpacity)

    local opacityButton = Turbine.UI.Lotro.Button()
    opacityButton:SetParent(WidthBackground)
    opacityButton:SetSize(120, 20)
    opacityButton:SetPosition(90, 20)
    opacityButton:SetText("Set Front Opacity") 

    opacityButton.Click = function()
        Settings.BuffBarFrontOpacity = tonumber(opacityBox:GetText())
        ChatOutput("Changed buff bar opacity to " .. tonumber(opacityBox:GetText()))
        self.ExampleTimer:ChangeFrontOpacity(Settings.BuffBarFrontOpacity)
    end

    local opacityBackBox = Turbine.UI.Lotro.TextBox()
    opacityBackBox:SetParent(WidthBackground)
    opacityBackBox:SetSize(50, 20)
    opacityBackBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    opacityBackBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    opacityBackBox:SetPosition(15, 40)
    opacityBackBox:SetText(Settings.BuffBarBackOpacity)

    local opacityButtonBack = Turbine.UI.Lotro.Button()
    opacityButtonBack:SetParent(WidthBackground)
    opacityButtonBack:SetSize(120, 20)
    opacityButtonBack:SetPosition(0, 60)
    opacityButtonBack:SetText("Set Back Opacity") 

    opacityButtonBack.Click = function()
        Settings.BuffBarBackOpacity = tonumber(opacityBackBox:GetText())
        ChatOutput("Changed buff bar back opacity to " .. tonumber(opacityBackBox:GetText()))
        self.ExampleTimer:ChangeBackOpacity(Settings.BuffBarBackOpacity)
    end

    local frontbutton = Turbine.UI.Lotro.Button()
    frontbutton:SetParent(WidthBackground)
    frontbutton:SetPosition(0, 80)
    frontbutton:SetSize(150,15)
    frontbutton:SetText("Timer Texture")
    frontbutton:SetVisible(true)

    -- [[
    local sortedNames1 = {}
    for key, value in pairs(BackgroundHandler:GetBarTextureData()) do table.insert( sortedNames1, key ) end
    table.sort( sortedNames1 )
    
    self.frontmenu = Turbine.UI.ContextMenu()
    self.frontmenuItems = self.frontmenu:GetItems()

    self.frontBar = nil

    for key, value in pairs(sortedNames1) do
        local frontmenuItem = Turbine.UI.MenuItem( value )
        frontmenuItem.Click = function()
            self.frontBar = value
            Settings.BuffBarFrontTexture = self.frontBar 
            self.ExampleTimer:ChangeFrontTexture(Settings.BuffBarFrontTexture)
        end
        self.frontmenuItems:Add(frontmenuItem)
    end

    local frontmenuItemNil = Turbine.UI.MenuItem( "None" )
    frontmenuItemNil.Click = function()
        Settings.BuffBarFrontTexture = nil
        self.ExampleTimer:ChangeFrontTexture(Settings.BuffBarFrontTexture)
    end
    self.frontmenuItems:Add(frontmenuItemNil)
        --]]




    frontbutton.Click = function()
        self.frontmenu:ShowMenu()
    end

    local backbutton = Turbine.UI.Lotro.Button()
    backbutton:SetParent(WidthBackground)
    backbutton:SetPosition(0, 100)
    backbutton:SetSize(150,15)
    backbutton:SetText("Background Texture")
    backbutton:SetVisible(true)


    self.backbar = nil
    -- [[
    self.backmenu = Turbine.UI.ContextMenu()
    self.backmenuItems = self.backmenu:GetItems()

    local sortedNames2 = {}
    for key, value in pairs(BackgroundHandler:GetBarTextureData()) do table.insert( sortedNames2, key ) end
    table.sort( sortedNames2 )

    for key, value in pairs(sortedNames2) do
        local backmenuItem = Turbine.UI.MenuItem( value )
        backmenuItem.Click = function()
            self.backbar = value
            Settings.BuffBarBackTexture = self.backbar
            self.ExampleTimer:ChangeBackTexture(Settings.BuffBarBackTexture)
        end
        self.backmenuItems:Add(backmenuItem)
    end
    local backmenuItemNil = Turbine.UI.MenuItem( "None" )
    backmenuItemNil.Click = function()
        Settings.BuffBarBackTexture = nil
        self.ExampleTimer:ChangeBackTexture(Settings.BuffBarBackTexture)
    end
    self.backmenuItems:Add(backmenuItemNil)
        --]]

    backbutton.Click = function()
        self.backmenu:ShowMenu()
    end

end

