SkillOverlayOptions = class(Turbine.UI.Control)
function SkillOverlayOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(0,0)
    --self:SetWantsKeyEvents(true)
    self:SetVisible(false)    

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    local tskills = self.player:GetTrainedSkills()
    local counter = 0

    local currentlySelectedItem = nil
    local SkillDictionary = {}
    local LocalSkillBars = {}
    local SkillsByNames = {}

    self.optionBackground = Turbine.UI.Control()
    self.optionBackground:SetParent(self)
    self.optionBackground:SetSize(750, 150)
    self.optionBackground:SetPosition(20, 38)
    self.optionBackground:SetBackColor(Turbine.UI.Color(0.375,0.375,0.375))

    self.createBackground = Turbine.UI.Control()
    self.createBackground:SetParent(self)
    self.createBackground:SetSize(150, 90)
    self.createBackground:SetPosition(400, 90)
    self.createBackground:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))

    self.thresholdBackground = Turbine.UI.Control()
    self.thresholdBackground:SetParent(self)
    self.thresholdBackground:SetSize(150, 100)
    self.thresholdBackground:SetPosition(580, 50)
    self.thresholdBackground:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))

    self.skillBackground = Turbine.UI.Control()
    self.skillBackground:SetParent(self)
    self.skillBackground:SetSize(350, 90)
    self.skillBackground:SetPosition(30, 90)
    self.skillBackground:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))

    
    local itemSelectedLabel = Turbine.UI.Label()
    itemSelectedLabel:SetParent(self)
    itemSelectedLabel:SetSize(30, 20)
    itemSelectedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    itemSelectedLabel:SetMouseVisible(false)
    itemSelectedLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    itemSelectedLabel:SetPosition(153, 94)

    self.skillSelectedText = Turbine.UI.Label()
    self.skillSelectedText:SetParent(self)
    self.skillSelectedText:SetSize(100, 20)
    self.skillSelectedText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.skillSelectedText:SetMouseVisible(false)
    self.skillSelectedText:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.skillSelectedText:SetPosition(185, 94)
    self.skillSelectedText:SetText("Skill:")
    

    local skillSelected = Turbine.UI.Label()
    skillSelected:SetParent(self)
    skillSelected:SetSize(200, 20)
    skillSelected:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    skillSelected:SetMouseVisible(false)
    skillSelected:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    skillSelected:SetPosition(225, 94)

    local infoLabel = Turbine.UI.Label()
    infoLabel:SetSize(500, 40)
    infoLabel:SetPosition(0, 0)
    infoLabel:SetParent(self)
    infoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold16)
    infoLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    infoLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    infoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    infoLabel:SetVisible(true)
    infoLabel:SetText("Select a box that corresponds to the position on your skill bar. Then use the select skill button to bind a skill to that box. If you want to remove a skill there is an option at the bottom of the list.")

    local removeLabel = Turbine.UI.Label()
    removeLabel:SetSize(200, 40)
    removeLabel:SetPosition(530, 0)
    removeLabel:SetParent(self)
    removeLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    removeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    removeLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    removeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    removeLabel:SetForeColor(Turbine.UI.Color(0, 0.7,0))
    removeLabel:SetVisible(false)
    removeLabel:SetText("Skillbar added (default position is top left)")

    for i = 1, self.player:GetTrainedSkills():GetCount(), 1 do
        local item = tskills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName() 
        local description = item:GetSkillInfo():GetDescription()

        if (not(RealSkill(description))and string.len(description) > 0 and item:GetSkillInfo():GetType() ~= 1) then
            SkillsByNames[name] = item
        end
    end

    local SelectionContainerPopOutBorder = Turbine.UI.Control()
    SelectionContainerPopOutBorder:SetParent(self)
    SelectionContainerPopOutBorder:SetPosition(200 - 5, 90 - 5)
    SelectionContainerPopOutBorder:SetSize(400, 240)
    SelectionContainerPopOutBorder:SetMouseVisible(false)
    SelectionContainerPopOutBorder:SetVisible(false)
    SelectionContainerPopOutBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    SelectionContainerPopOutBorder:SetZOrder(100)

    local SelectionContainerPopOut = Turbine.UI.Control()
    SelectionContainerPopOut:SetParent(SelectionContainerPopOutBorder)
    SelectionContainerPopOut:SetPosition(5, 5)
    SelectionContainerPopOut:SetSize(400 - 10, 240 - 10)
    SelectionContainerPopOut:SetMouseVisible(true)
    SelectionContainerPopOut:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    SelectionContainerPopOut:SetZOrder(100)

    local PopOoutContainer = Turbine.UI.ListBox()
    PopOoutContainer:SetParent(SelectionContainerPopOut)
    PopOoutContainer:SetSize(380, 230)
    PopOoutContainer:SetPosition(0, 0)
    PopOoutContainer:SetVisible(true)
    --PopOoutContainer:SetBackColor(GetRandomColour())
    PopOoutContainer:SetOrientation( Turbine.UI.Orientation.Vertical )

    local ScrollbarBackground = Turbine.UI.Control()
    ScrollbarBackground:SetParent( SelectionContainerPopOut )
    ScrollbarBackground:SetPosition( 380, 0 )
    ScrollbarBackground:SetSize( 10, 230)
    ScrollbarBackground:SetMouseVisible(false)
    ScrollbarBackground:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

    local PopOoutContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    PopOoutContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    PopOoutContainerScrollbar:SetParent( SelectionContainerPopOut )
    PopOoutContainerScrollbar:SetPosition( 380, 0 )
    PopOoutContainerScrollbar:SetSize( 10, 230)
    PopOoutContainerScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    PopOoutContainer:SetVerticalScrollBar( PopOoutContainerScrollbar )


    local sortedKeys = {}
    for key, value in pairs(SkillsByNames) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )
    
    for key, name in pairs(sortedKeys) do
        local item = SkillsByNames[name]
        local menuItem = Turbine.UI.MenuItem( name )

        local ListItem = Turbine.UI.Control()
        ListItem:SetSize(380, 34)
        ListItem:SetMouseVisible(true)
        ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

        local BackGroundControl = Turbine.UI.Control()
        BackGroundControl:SetParent(ListItem)
        BackGroundControl:SetSize(380, 30)
        BackGroundControl:SetPosition(0, 2)
        BackGroundControl:SetMouseVisible(false)
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(ListItem)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        NameLabel:SetSize(380, 30)
        NameLabel:SetPosition(0, 2)
        NameLabel:SetMouseVisible(false)
        NameLabel:SetText(name)
        
        ListItem.MouseClick = function()
            if currentlySelectedItem ~= nil then
                skillSelected:SetText(name) 
                SkillDictionary[tonumber(currentlySelectedItem:GetText())] = item
                currentlySelectedItem:SetBackColor()
                currentlySelectedItem:SetBackground(item:GetSkillInfo():GetIconImageID())
             end
             SelectionContainerPopOutBorder:SetVisible(false)
        end

        ListItem.MouseEnter = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
        end

        ListItem.MouseLeave = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
        end

        PopOoutContainer:AddItem(ListItem)
    end

    local ListItem = Turbine.UI.Control()
    ListItem:SetSize(380, 34)
    ListItem:SetMouseVisible(true)
    ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

    local BackGroundControl = Turbine.UI.Control()
    BackGroundControl:SetParent(ListItem)
    BackGroundControl:SetSize(380, 30)
    BackGroundControl:SetPosition(0, 2)
    BackGroundControl:SetMouseVisible(false)
    BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(ListItem)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    NameLabel:SetSize(380, 30)
    NameLabel:SetPosition(0, 2)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetText("Remove skill")
    
    ListItem.MouseClick = function()
        if currentlySelectedItem ~= nil then
            skillSelected:SetText("") 
            SkillDictionary[tonumber(currentlySelectedItem:GetText())] = ""
            currentlySelectedItem:SetBackColor(GetRandomColour())
         end
         SelectionContainerPopOutBorder:SetVisible(false)
    end

    ListItem.MouseEnter = function()
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    end

    ListItem.MouseLeave = function()
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    end

    PopOoutContainer:AddItem(ListItem)
    

    self.MakeSkillBox = function(index)
        local skillLabel = Turbine.UI.Label()
        skillLabel:SetParent(self)
        skillLabel:SetPosition(35 * index, 50)
        skillLabel:SetSize(32, 32)
        skillLabel:SetText(index)
        skillLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        skillLabel:SetBackColor(GetRandomColour())
        skillLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        skillLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        skillLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        SkillDictionary[index] = ""

        skillLabel.MouseClick = function()
            itemSelectedLabel:SetText(index)
            currentlySelectedItem = skillLabel
            if SkillDictionary[index] ~= "" then
                skillSelected:SetText(SkillDictionary[index]:GetSkillInfo():GetName())
            else
                skillSelected:SetText("")
            end
        end
    end

    for i = 1, 12 do
        self.MakeSkillBox(i)
    end
    
    -- Show existing bars
    local listbox = Turbine.UI.ListBox()
    listbox:SetParent( self )
    --listbox:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) )
    listbox:SetPosition( 30, 200 )
    listbox:SetSize( 700, 240 )

    local listBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    listBoxScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    listBoxScrollbar:SetParent( self )
    listBoxScrollbar:SetPosition( 730, 200 )
    listBoxScrollbar:SetSize( 10, 240)
    --listBoxScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    listbox:SetVerticalScrollBar( listBoxScrollbar )

    self.AddSkillBarListItem = function(name, data) 
        local listItem = Turbine.UI.Control()
        listItem:SetBackColor( GetRandomColour() )

        -- data - [1] skillnames [2] scale [3] offset [4] background [5] hourglass [6] traitline (1 blue / 2 red / 3 yellow / 4 all)

        local nameLabel = Turbine.UI.Label()
        nameLabel:SetSize(100, 40)
        nameLabel:SetParent(listItem)
        nameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        nameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        nameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        nameLabel:SetText(name)

        local scaleLabel = Turbine.UI.Label()
        scaleLabel:SetSize(100, 40)
        scaleLabel:SetParent(listItem)
        scaleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        scaleLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        scaleLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        scaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        scaleLabel:SetPosition(0, 40)
        scaleLabel:SetText("Scale: " .. data[2])

        local scaleLabel = Turbine.UI.Label()
        scaleLabel:SetSize(100, 40)
        scaleLabel:SetParent(listItem)
        scaleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        scaleLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        scaleLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        scaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        scaleLabel:SetPosition(70, 40)
        scaleLabel:SetText("Offset: " .. data[3])

        local hideOnLabel = Turbine.UI.Label()
        hideOnLabel:SetSize(120, 40)
        hideOnLabel:SetParent(listItem)
        hideOnLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        hideOnLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        hideOnLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        hideOnLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        hideOnLabel:SetPosition(160, 40)
        if data[7] then
            hideOnLabel:SetText("Hide on cd: yes")
        else
            hideOnLabel:SetText("Hide on cd: no")
        end

        local hideOffLabel = Turbine.UI.Label()
        hideOffLabel:SetSize(120, 40)
        hideOffLabel:SetParent(listItem)
        hideOffLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        hideOffLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        hideOffLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        hideOffLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        hideOffLabel:SetPosition(290, 40)
        if data[8] then
            hideOffLabel:SetText("Hide off cd: yes")
        else
            hideOffLabel:SetText("Hide off cd: no")
        end

        local scaleLabel = Turbine.UI.Label()
        scaleLabel:SetSize(150, 40)
        scaleLabel:SetParent(listItem)
        scaleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        scaleLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        scaleLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        scaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        scaleLabel:SetPosition(410, 40)
        if data[4] then
            scaleLabel:SetText("Background: yes")
        else
            scaleLabel:SetText("Background: no")
        end

        local scaleLabel = Turbine.UI.Label()
        scaleLabel:SetSize(150, 40)
        scaleLabel:SetParent(listItem)
        scaleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        scaleLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        scaleLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        scaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        scaleLabel:SetPosition(550, 40)
        if data[5] then
            scaleLabel:SetText("Shade timer: yes")
        else
            scaleLabel:SetText("Shade timer: no")
        end

        local scaleLabel = Turbine.UI.Label()
        scaleLabel:SetSize(150, 40)
        scaleLabel:SetParent(listItem)
        scaleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        scaleLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        scaleLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        scaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        scaleLabel:SetPosition(550, 20)

        local traitName = ""
        if data[6] == 4 then
            traitName = "All Lines"
        elseif data[6] == 1 then
            traitName = "Blue Only"
        elseif data[6] == 2 then
            traitName = "Red Only"
        elseif data[6] == 3 then
            traitName = "Yellow only"
        end

        scaleLabel:SetText(traitName)

        listItem:SetSize( 700, 80 )
        self.CreateShowBar(data[1], listItem)
        listbox:AddItem( listItem )

        local removeButton = Turbine.UI.Lotro.Button()
        removeButton:SetParent(listItem)
        removeButton:SetSize(100, 30)
        removeButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        removeButton:SetMouseVisible(false)
        removeButton:SetPosition(100 + 35 * 13, 10)
        removeButton:SetText("Remove Bar")

        removeButton.Click = function()
            SkillsHandler:RemoveBar(name)
            --[[
            ActiveSkillBars[key]:SetVisible(false)
            ActiveSkillBars[key]:SetParent(nil)            
            ActiveSkillBars[key] = nil
            SkillBarsPositions[key] = nil
            SkillBars[key] = nil
            --]]
            --CreateSkillBars(LocalSkillBars)
            listItem:SetVisible(false)
        end

        local moveButton = Turbine.UI.Lotro.Button()
        moveButton:SetParent(listItem)
        moveButton:SetSize(100, 20)
        moveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        moveButton:SetMouseVisible(false)
        moveButton:SetPosition(0, 30)
        moveButton:SetText("Move Bar")

        moveButton.Click = function()
            SkillsHandler:MoveBar(name)
        end
    end

    
    local itemSelectedText = Turbine.UI.Label()
    itemSelectedText:SetParent(self)
    itemSelectedText:SetSize(100, 20)
    itemSelectedText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    itemSelectedText:SetMouseVisible(false)
    itemSelectedText:SetPosition(140, 94)
    itemSelectedText:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    itemSelectedText:SetText("Slot:")

    local SkillButton = Turbine.UI.Lotro.Button()
    SkillButton:SetParent(self)
    SkillButton:SetSize(100, 15)
    SkillButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SkillButton:SetMouseVisible(false)
    SkillButton:SetPosition(35, 94)
    SkillButton:SetText("Select skill")

    SkillButton.Click = function()
        --menu:ShowMenu()
        SelectionContainerPopOutBorder:SetVisible(not(SelectionContainerPopOutBorder:IsVisible()))
    end

    local ScaleLabel = Turbine.UI.Label()
    ScaleLabel:SetParent(self)
    ScaleLabel:SetSize(50, 30)
    ScaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    ScaleLabel:SetPosition(185, 130)
    ScaleLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    ScaleLabel:SetText("Scale") 

    local BarScaleBar = Turbine.UI.Lotro.TextBox()
    BarScaleBar:SetParent(self)
    BarScaleBar:SetSize(50, 30)
    BarScaleBar:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BarScaleBar:SetPosition(225, 124)
    BarScaleBar:SetText("1")

    local OffsetLabel = Turbine.UI.Label()
    OffsetLabel:SetParent(self)
    OffsetLabel:SetSize(50, 30)
    OffsetLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    OffsetLabel:SetPosition(285, 130)
    OffsetLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    OffsetLabel:SetText("Offset") 

    local OffsetBox = Turbine.UI.Lotro.TextBox()
    OffsetBox:SetParent(self)
    OffsetBox:SetSize(50, 30)
    OffsetBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    OffsetBox:SetPosition(325, 124)
    OffsetBox:SetText("0")
    
    
    local ShowBackground = Turbine.UI.Lotro.CheckBox()
    ShowBackground:SetParent(self)
    ShowBackground:SetPosition(40, 154)
    ShowBackground:SetSize(200, 20)
    ShowBackground:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    ShowBackground:SetText("Show background")
    ShowBackground:SetVisible(true)

    local HourglassBackground = Turbine.UI.Lotro.CheckBox()
    HourglassBackground:SetParent(self)
    HourglassBackground:SetPosition(185, 154)
    HourglassBackground:SetSize(200, 20)
    HourglassBackground:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    HourglassBackground:SetText("Shade Timer")
    HourglassBackground:SetVisible(true)

    local HideOnCd = Turbine.UI.Lotro.CheckBox()
    HideOnCd:SetParent(self)
    HideOnCd:SetPosition(40, 134)
    HideOnCd:SetSize(200, 20)
    HideOnCd:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    HideOnCd:SetText("Hide while on cd")
    HideOnCd:SetVisible(true)

    local HideOffCd = Turbine.UI.Lotro.CheckBox()
    HideOffCd:SetParent(self)
    HideOffCd:SetPosition(40, 114)
    HideOffCd:SetSize(200, 20)
    HideOffCd:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    HideOffCd:SetText("Hide while ready")
    HideOffCd:SetVisible(true)

    local Horizontal = Turbine.UI.Lotro.CheckBox()
    Horizontal:SetParent(self)
    Horizontal:SetPosition(465, 45)
    Horizontal:SetSize(200, 20)
    Horizontal:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    Horizontal:SetText("Vertical")
    Horizontal:SetVisible(true)

    local NoText = Turbine.UI.Lotro.CheckBox()
    NoText:SetParent(self)
    NoText:SetPosition(465, 65)
    NoText:SetSize(200, 20)
    NoText:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    NoText:SetText("No Text")
    NoText:SetVisible(true)

    local TraitButtons = Turbine.UI.Lotro.Button()
    TraitButtons:SetParent(self)
    TraitButtons:SetPosition(290, 155)
    TraitButtons:SetText("All traitlines")
    TraitButtons:SetSize(90, 100)

        
    local classMenu = Turbine.UI.ContextMenu()
    local classMenuItems = classMenu:GetItems()

    local traitLine = 4

    local classItem = Turbine.UI.MenuItem( "All traitlines" )
    classItem.Click = function()
        TraitButtons:SetText("All traitlines")
        traitLine = 4
    end
    classMenuItems:Add(classItem)

    local classItem = Turbine.UI.MenuItem( "Blue" )
    classItem.Click = function()
        TraitButtons:SetText("Blue" )
        traitLine = 1
    end
    classMenuItems:Add(classItem)

    local classItem = Turbine.UI.MenuItem( "Red" )
    classItem.Click = function()
        TraitButtons:SetText("Red")
        traitLine = 2
    end
    classMenuItems:Add(classItem)

    local classItem = Turbine.UI.MenuItem( "Yellow" )
    classItem.Click = function()
        TraitButtons:SetText("Yellow")
        traitLine = 3
    end
    classMenuItems:Add(classItem)

    TraitButtons.Click = function()
        classMenu:ShowMenu()
    end

    self.soundeffectName = nil

    local menu = Turbine.UI.ContextMenu()

    local SoundeffectButton = Turbine.UI.Lotro.Button()
    SoundeffectButton:SetParent(self)
    SoundeffectButton:SetSize(150, 15)
    SoundeffectButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SoundeffectButton:SetMouseVisible(true)
    SoundeffectButton:SetPosition(400, 135)
    SoundeffectButton:SetText("SoundEffect: None")
    
    local menu = UI.DropDownMenuControl(nil, 200, "Sound Menu")
    for key, value in spairs(Sounds:GetSoundList(), function(t, a, b) return a < b end) do
        menu:AddItem(key, 
        function()
            SoundeffectButton:SetText("SoundEffect: " .. key)
            self.soundeffectName = key
            menu:ToggleVisible()
        end)
    end

    SoundeffectButton.Click = function()
        menu:ToggleVisible()
    end

    local NameBox = Turbine.UI.Lotro.TextBox()
    NameBox:SetParent(self)
    NameBox:SetSize(130, 30)
    NameBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    NameBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    NameBox:SetPosition(410, 100)
    NameBox:SetText("<Enter Name>")

    local BarButton = Turbine.UI.Lotro.Button()
    BarButton:SetParent(self)
    BarButton:SetSize(100, 30)
    BarButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BarButton:SetMouseVisible(false)
    BarButton:SetPosition(425, 160)
    BarButton:SetText("Create Bar")

    BarButton.Click = function()
        local name = NameBox:GetText()
        local SkillBars = {}
        if name ~= "" and LocalSkillBars[name] == nil and not(SkillsHandler:ExistingBar(name)) then
            LocalSkillBars[name] = SkillDictionary
            SkillBars[name] = {}
            for key, value in pairs(SkillDictionary) do
                if value.GetSkillInfo then
                    SkillBars[name][key] =  value:GetSkillInfo():GetName()
                end
            end

            -- data - [1] skillnames [2] scale [3] offset [4] background [5] hourglass [6] traitline (1 blue / 2 red / 3 yellow / 4 all)
            SkillsHandler:CreateSkillBar({SkillBars[name], tonumber(BarScaleBar:GetText()), tonumber(OffsetBox:GetText()), ShowBackground:IsChecked(), HourglassBackground:IsChecked(), traitLine, HideOnCd:IsChecked(), HideOffCd:IsChecked(), Horizontal:IsChecked(), NoText:IsChecked(), self.soundeffectName}, name)
            self.AddSkillBarListItem(name, {SkillBars[name], tonumber(BarScaleBar:GetText()), tonumber(OffsetBox:GetText()), ShowBackground:IsChecked(), HourglassBackground:IsChecked(), traitLine, HideOnCd:IsChecked(), HideOffCd:IsChecked(), Horizontal:IsChecked(), NoText:IsChecked(), self.soundeffectName})
            removeLabel:SetVisible(true)
            LocalSkillBars = {}            
        else
            ChatOutput("No name or already existing name for bar!")
        end
    end

    self.moveBackground = Turbine.UI.Control()
    self.moveBackground:SetParent(self)
    self.moveBackground:SetSize(120, 30)
    self.moveBackground:SetPosition(580, 155)
    self.moveBackground:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))

    local MoveButton = Turbine.UI.Lotro.Button()
    MoveButton:SetParent(self)
    MoveButton:SetSize(100, 20)
    MoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    MoveButton:SetMouseVisible(false)
    MoveButton:SetPosition(590, 160)
    MoveButton:SetText("Move All Bars")

    MoveButton.Click = function()
        SkillsHandler:MoveBars()
    end

    self.MakeSkillBoxForShow = function(index, icon, parent)
        local skillLabel = Turbine.UI.Label()
        skillLabel:SetParent(parent)
        skillLabel:SetPosition(100 + 35 * index, 3)
        skillLabel:SetSize(32, 32)
        skillLabel:SetText(index)
        skillLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        if icon == nil then
            skillLabel:SetBackColor(GetRandomColour())
        else
            skillLabel:SetBackground(icon)
        end
        skillLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        skillLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        skillLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    end

    self.CreateShowBar = function(value, listItem)
        for index, skillName in pairs(value) do
            local skill = SkillsByNames[skillName]
            if skill ~= nil then 
                self.MakeSkillBoxForShow(index, skill:GetSkillInfo():GetIconImageID(), listItem)
            else
                self.MakeSkillBoxForShow(index, nil, listItem)
            end
        end
    end

    
    local blablaLabel = Turbine.UI.Label()
    blablaLabel:SetSize(200, 40)
    blablaLabel:SetPosition(30, 170)
    blablaLabel:SetParent(self)
    blablaLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    blablaLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    blablaLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    blablaLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    blablaLabel:SetText("Existing Action Bars:")

    if Tablelength(SkillBars) <= 0 then
        blablaLabel:SetVisible(false)
    end


    for key, value in pairs(SkillBars) do
        self.AddSkillBarListItem(key, value)
    end

    local cBox = Turbine.UI.Lotro.CheckBox()
    cBox:SetParent(self)
    cBox:SetPosition(590, 54)
    cBox:SetSize(200, 20)
    cBox:SetChecked(Settings.SkillbarPopups)
    cBox:SetText("Enable CD popups")
    cBox:SetVisible(true)

    cBox.CheckedChanged = function(sender,args)
        Settings.SkillbarPopups = cBox:IsChecked()
    end


    -- CD threshold
    local ScaleBox = Turbine.UI.Lotro.TextBox()
    ScaleBox:SetParent(self)
    ScaleBox:SetSize(50, 30)
    ScaleBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ScaleBox:SetPosition(630, 80)
    ScaleBox:SetText(Settings.SkilloverlayCDThreshold)

    local ScaleButton = Turbine.UI.Lotro.Button()
    ScaleButton:SetParent(self)
    ScaleButton:SetSize(150, 50)
    ScaleButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ScaleButton:SetMouseVisible(false)
    ScaleButton:SetPosition(580, 115)
    ScaleButton:SetText("Set Popup Threshold")

    ScaleButton.Click = function()
        if ScaleBox:GetText() ~= "" and ScaleBox:GetText() ~= nil and ScaleBox:GetText() ~= Settings.SkilloverlayCDThreshold then
            ChatOutput(ScaleBox:GetText())
            Settings.SkilloverlayCDThreshold = tonumber(ScaleBox:GetText())
        end
    end
end

---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------

function RealSkill(description)
    for key, _ in pairs(ForbiddenSkills) do
        if string.find(description, key) then return true end
    end
    return false
end

ForbiddenSkills = {
    ["Allows the Warden to travel"] = true,
    ["goat"] = true,
    ["horse"] = true,
    ["Brings out"] = true,
    ["steed"] = true,
    ["Summons"] = true,
    ["This is a fleet-footed goat"] = true,
    ["A mighty Lasgalen elk"] = true,
    ["This skill suppresses all mount speed buffs"] = true,
    ["A favourite toy"] = true,
    ["A brightly coloured theme sets"] = true,
    ["Black as the night"] = true,
    ["Swallow this potion"] = true,
    ["This is probably the best snowball"] = true,
    ["An elite goat"] = true,
    ["Return quickly"] = true,
    ["Elk"] = true,
    ["Journey to the"] = true,
    ["Rescued from the cruelty of Lhaereth."] = true,
    ["return to"] = true,
    ["stag"] = true,
    ["pig"] = true,
    ["cow"] = true,
    ["sheep"] = true,
    ["deer"] = true,
    ["Toad"] = true,
    ["This black silk glove"] = true,
    ["A winged companion."] = true,
    ["Bill the Pony."] = true,
    ["he provides pleasant company"] = true,
    ["A token of thanks"] = true,
    ["Soldier"] = true,
    ["to ride alongside of you."] = true,
    ["A violent strike against the target that focuses on your offensive capability, dealing damage and increasing threat against the target."] = true,
    ["Skill of the Eorlingas becomes Halt the Charge."] = true,
    ["on the radar"] = true,
    ["Herald to carry"] = true,
    ["Archer to assist"] = true,
}


-- ^^ Options Garbage ^^ --
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------


SkillBarHandler = class(Turbine.UI.Control)
function SkillBarHandler:Constructor()
    Turbine.UI.Control.Constructor(self)

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.skills = self.player:GetTrainedSkills()

    self.skillBars = {}
    self.skillBarsData = {}

    self.reloadTime = 0

    self.Update = function()
        if Turbine.Engine.GetGameTime() > self.reloadTime then
            self.skills = self.player:GetTrainedSkills()
            self:UnloadBars()
            self:LoadBars()
            self:SetWantsUpdates(false)
        end
    end
end

-- Schedule a reload of skill bars
function SkillBarHandler:ReloadBarsWithDelay()
    self.reloadTime = Turbine.Engine.GetGameTime() + 5
    self:SetWantsUpdates(true)
end

-- Use this to create a skill bar and hook it up correctly
function SkillBarHandler:CreateSkillBar(data, name)
    self.skillBars[name] = SkillBar(data, name, self.skills)
    self.skillBarsData[name] = data
end

-- Useable as initial load
function SkillBarHandler:CreateSkillBarFromDictionary()
    for key, value in pairs(SkillBars) do 
        self:CreateSkillBar(value, key) 
    end
end

-- Convert old safe formats to new format
function SkillBarHandler:ConvertLegacySave()
    for key, value in pairs(SkillBars) do 
        self:CreateSkillBar({value, 1, 0, false, false, 4, false, false, false, false, nil}, key) 
    end
end

-- Move all bars
function SkillBarHandler:MoveBars()
    for key, value in pairs(self.skillBars) do
        value:MoveBar()
    end
end

-- Move single bar by name
function SkillBarHandler:MoveBar(name)
    self.skillBars[name]:MoveBar()
end

-- Get the data from all active skill bar in [bar][index][skill] format
function SkillBarHandler:GetSaveState()
    local SaveableSkillBars = {}
    for _, value in pairs(self.skillBars) do
        SaveableSkillBars[value:GetBarName()] = value:GetSaveFormat()
    end
    return SaveableSkillBars
end

-- Get the positions of all active skill bars
function SkillBarHandler:GetPositions()
    local SkillBarsPositions = {}
    for _, value in pairs(self.skillBars) do
        local x, y = value:GetPosition()
        SkillBarsPositions[value:GetBarName()] = {x, y}
    end
    return SkillBarsPositions
end

function SkillBarHandler:Unload()
    for key, value in pairs(self.skillBars) do
        self:RemoveBar(key)
    end
end

-- Properly dispose of a bar
function SkillBarHandler:RemoveBar(name)
    self.skillBars[name]:DeleteBar()
    self.skillBars[name] = nil
end

-- Block duplicates
function SkillBarHandler:ExistingBar(name)
    if self.skillBars[name] then return true else return false end
end

-- Load All Bars
function SkillBarHandler:LoadBars()
    for key, value in pairs(self.skillBars) do
        if self.skillBarsData[key][6] == 4 or self.skillBarsData[key][6] == Roles:GetLine() then
            value:LoadBar()
        end
    end
end

-- Unload All Bars
function SkillBarHandler:UnloadBars()
    for key, value in pairs(self.skillBars) do
        value:UnloadBar()
    end
end

---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------

-- data - [1] skillnames [2] scale [3] offset [4] background [5] hourglass [6] traitline (1 blue / 2 red / 3 yellow / 4 all) [7] hide when on cooldown [8] hide when off cooldown [9] horizontal [10] no text

SkillBar = class(Turbine.UI.Window)
function SkillBar:Constructor(data, name, playerSkills)

    Turbine.UI.Window.Constructor(self)

    self.positions = SkillBarsPositions[name]
    self.callbacks = {}
    self.playerSkills = playerSkills

    self.skillList = data[1]
    self.scale = data[2]
    self.offset = data[3]
    self.background = data[4]
    self.hourglass = data[5]
    self.traitline = data[6]
    self.hideOnCd = data[7]
    self.hideOffCd = data[8]
    self.vertical = data[9]
    self.noText = data[10]
    self.sound = data[11]
    
    self.biggestIndex = table.maxn(self.skillList)
    self.smallestIndex = 9999

    for key, _ in pairs(self.skillList) do
        if self.smallestIndex > key then self.smallestIndex = key end
    end

    self.itemWidth = self.biggestIndex - self.smallestIndex + 1
    --[[
    local x = 0
    local y = 0
    if positions == nil then
        x = Settings.LOX
        y = Settings.LOY
    else
        x = positions[1]
        y = positions[2]
    end
    --]]



    if self.vertical then
        self.width = 35 * self.scale
        self.height = 35 * self.scale * self.itemWidth
        self:SetSize(self.width, 32 * self.scale + self.offset * self.itemWidth)
    else
        self.width = 35 * self.scale * self.itemWidth
        self.height = 35 * self.scale
        self:SetSize(self.width + self.offset * self.itemWidth, 32 * self.scale)
    end



    --self.font = Settings.LOFont
    --self.colour = Turbine.UI.Color(1, 1, 1)

     -- sets the window size to 200 by 200 pixels
    if self.positions then self:SetPosition(self.positions[1], self.positions[2]); end
    self:SetVisible(true)
    self:SetMouseVisible(false)
    self:SetZOrder(100)

    self.name = name

    self.skillNames = {}

    self.boxes = {}
    --self:SetBackColor(GetRandomColour())

    self.skillsIndexedByName = {}

    if self.traitline == 4 or self.traitline == Roles:GetLine() then 
        self:LoadBar() 
    end

    self.moveBox = MoveBox(self, self.width, self.height, name)
end

-- Get indexed list of skill names
function SkillBar:GetSkillName()
    return self.skillList
end

function SkillBar:GetSaveFormat()
    return {self.skillList, self.scale, self.offset, self.background, self.hourglass, self.traitline, self.hideOnCd, self.hideOffCd, self.vertical, self.noText, self.sound}
end

-- Get name of the bar
function SkillBar:GetBarName()
    return(self.name)
end

-- Properly dispose of the bar
function SkillBar:DeleteBar()
    for key, value in pairs(self.boxes) do
        value:Delete()
        value:SetParent(nil)
        self.boxes[key] = nil
    end
    self:SetParent(nil)
end

-- Unload bar
function SkillBar:UnloadBar()
    for key, value in pairs(self.boxes) do
        value:Delete()
        value:SetParent(nil)
    end
end

function SkillBar:LoadBar()
     -- Index all skills this bar will use
     for i = 1, self.playerSkills:GetCount(), 1 do
        local item = self.playerSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName() 

        for key, value in pairs(self.skillList) do
            if value == name then self.skillsIndexedByName[value] = item end
        end
    end

    for key, value in pairs(self.skillList) do
        if value ~= "" and self.skillsIndexedByName[value] then 
            local skill = self.skillsIndexedByName[value]
            self.boxes[key] = SkillBox(key - self.smallestIndex, self, skill, self.scale, self.offset, self.background, self.hourglass, self.hideOnCd, self.hideOffCd, self.vertical, self.noText, self.sound)
            self.skillNames[skill:GetSkillInfo():GetName()] = true
            -- Handle skill being on cooldown
            local currentCooldown = skill:GetResetTime() - Turbine.Engine.GetGameTime()
            if currentCooldown > 0 then
                self.boxes[key]:SetCooldown(currentCooldown)
            end
        end
    end
end

function SkillBar:MoveBar()
    self.moveBox:ToggleMove()
end


---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------

SkillBox = class(Turbine.UI.Window)
function SkillBox:Constructor(index, parent, skill, scale, offset, background, hourglass, hideOnCd, hideOffCd, vertical, noText, sound)
    if skill == nil then return end
    Turbine.UI.Window.Constructor(self)

    self.width = 32 * scale
    self.height = 32 * scale
    self:SetParent(parent)
    if vertical then
        self:SetPosition(0, 35 * scale * index + offset * index)
    else 
        self:SetPosition(35 * scale * index + offset * index, 0)
    end
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.parent = parent

    self.background = background
    self.hourglass = hourglass
    self.hideOnCd = hideOnCd
    self.hideOffCd = hideOffCd
    self.sound = sound

    self.baseImageID = 0x41007E35

    self.smallFont = Turbine.UI.Lotro.Font.TrajanProBold16
    self.bigFont = Turbine.UI.Lotro.Font.TrajanProBold30
    

    -- Set values
    self.skill = skill
    self.name = self.skill:GetSkillInfo():GetName()
    self.icon = self.skill:GetSkillInfo():GetIconImageID()
    self.Countdown = self.skill:GetCooldown()
    self.baseCD = self.skill:GetCooldown()

    self.cdThreshold = Settings.SkilloverlayCDThreshold
    self.SkillPopups = Settings.SkillbarPopups

    self.opacityBackground = Turbine.UI.Window()
    self.opacityBackground:SetParent(self)
    self.opacityBackground:SetSize(self.width, self.height)
    self.opacityBackground:SetOpacity(1)
    self.opacityBackground:SetMouseVisible(false)
    self.opacityBackground:SetVisible(true)

    if self.background then        
        self.backgroundLabel = Turbine.UI.Label()
        self.backgroundLabel:SetSize(32, 32)
        self.backgroundLabel:SetParent(self.opacityBackground)
        if scale ~= 1 then
            self.backgroundLabel:SetStretchMode(1)
        end
        self.backgroundLabel:SetSize(self.width, self.height)
        self.backgroundLabel:SetMouseVisible(false)
        self.backgroundLabel:SetBackground(self.skill:GetSkillInfo():GetIconImageID())
    end

    if self.hourglass then
        self.elapsedOverlay = Turbine.UI.Control()
        self.elapsedOverlay:SetStretchMode( 1 )
        self.elapsedOverlay:SetMouseVisible( false )
        --self.elapsedOverlay:SetZOrder( 99 )
        self.elapsedOverlay:SetOpacity( 0.7 )
        self.elapsedOverlay:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
        self.elapsedOverlay:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
        self.elapsedOverlay:SetParent( self.opacityBackground )
        self.elapsedOverlay:SetSize(self.width, self.height)
    end

    self.textBackground = Turbine.UI.Window()
    self.textBackground:SetParent(self)
    self.textBackground:SetSize(self.width, self.height)
    self.textBackground:SetOpacity(1)
    self.textBackground:SetVisible(true)
    self.textBackground:SetMouseVisible(false)

    self.countdownLabel = Turbine.UI.Label()
    self.countdownLabel:SetSize(self.width, self.height)
    self.countdownLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.countdownLabel:SetVisible(not(noText))
    self.countdownLabel:SetParent(self.textBackground)
    self.countdownLabel:SetFont(self.smallFont)
    self.countdownLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.countdownLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.countdownLabel:SetMultiline(false)
    self.countdownLabel:SetMouseVisible(false)
    --self.countdownLabel:SetText("")

    self.CurrentCooldown = -1
    
    self.decimalThreshold = 3

    self.bigCooldown = self.Countdown >= 300
    self.oldCooldown = self.Countdown

    if self.hideOffCd then self:SetVisible(false) end

    self.ExecuteUpdate = function(delta)
        self.CurrentCooldown = self.CurrentCooldown - delta
    
        if self.oldCooldown - self.CurrentCooldown > 0.05 then
            if self.CurrentCooldown < 120 and not(self.bigCooldown) then
                self.countdownLabel:SetText(Round(self.CurrentCooldown, 0))
            else
                self.countdownLabel:SetText(Round(self.CurrentCooldown / 60, 0) .. "m")
            end
            self.oldCooldown = self.CurrentCooldown
        end
    
    
        if self.CurrentCooldown < 0 then
            --self:SetWantsUpdates(false)
            if self.SkillPopups and self.baseCD >= self.cdThreshold and self:IsVisible() then 
                SkillPopups:Message(self.name, self.icon) 
            end
    
            if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
            self.updateCallback = nil
    
            if self.background and not(self.hourglass) then
                self.opacityBackground:SetOpacity(1)
            end
    
            if self.hourglass then
                self.elapsedOverlay:SetVisible(false)
            end
            self.countdownLabel:SetText("")
    
            if self.sound and Sounds then
                Sounds:PlaySoundEffect(self.sound)
            end
        --elseif self.CurrentCooldown < colorThreshold and not(bigCooldown) then
        --    self.countdownLabel:SetForeColor(Turbine.UI.Color(1, 0, 0))
        end
    
        if self.hourglass then
            local percentComplete = self.CurrentCooldown / self.baseCD
    
            local imageId = self.baseImageID + math.floor( 60 * percentComplete )
        
            self.elapsedOverlay:SetStretchMode( 3 )
            self.elapsedOverlay:SetPosition( 0, 0 )
            self.elapsedOverlay:SetSize( 32, 32 )
            self.elapsedOverlay:SetBackground( imageId )
        
            --local width, height = self:GetSize()
            self.elapsedOverlay:SetStretchMode( 1 )
            self.elapsedOverlay:SetSize( self.width , self.height  )
        end
    end

    self.callback = AddCallback(self.skill, "ResetTimeChanged", function(sender, args) self:SkillUsed(self.skill:GetResetTime() - Turbine.Engine.GetGameTime()) end)
end

function SkillBox:SkillUsed(countdown)
    self:SetCooldown(countdown)
    self.oldCooldown = countdown
    self.parent:SetZOrder(100)
end

function SkillBox:SetCooldown(value)
    if value < 0 then
        if self.SkillPopups and self.baseCD >= self.cdThreshold and self:IsVisible() then 
            SkillPopups:Message(self.name, self.icon) 
        end

        if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
        self.updateCallback = nil

        if self.background and not(self.hourglass) then
            self.opacityBackground:SetOpacity(1)
        end
        self.countdownLabel:SetText("")

        if self.hourglass then
            self.elapsedOverlay:SetVisible(false)
        end

        if self.hideOffCd then
            self:SetVisible(false)
        elseif self.hideOnCd then
            self:SetVisible(true)
        end

        return
    end

    if self.hideOffCd then
        self:SetVisible(true)
    elseif self.hideOnCd then
        self:SetVisible(false)
    end

    self.CurrentCooldown = value

    if self.hourglass then
        self.elapsedOverlay:SetVisible(true)
    end

    self.countdownLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.countdownLabel:SetText(math.ceil(value))
    if not(self.hourglass) then
        self.opacityBackground:SetOpacity(0.5)
    end
    --self:SetWantsUpdates(true)
    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end

end

function SkillBox:ToggleMove()
    self.moveBox:ToggleMove()
    self:SetZOrder(100)
end

function SkillBox:GetBarName()
    return(self.name)
end

function SkillBox:Delete()
    RemoveCallback(self.skill, "ResetTimeChanged", self.callback)
    if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
    self.updateCallback = nil
    self.countdownLabel:SetParent(nil)
    self:SetVisible(false)
    self:SetParent(nil)
end

function SkillBox:Unload()
    RemoveCallback(self.skill, "ResetTimeChanged", self.callback)
    if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
    self.updateCallback = nil
    self.countdownLabel:SetParent(nil)
    self:SetVisible(false)
    self:SetParent(nil)
end

---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------

SkillPopupWindow = class(Turbine.UI.Control)
function SkillPopupWindow:Constructor()
    Turbine.UI.Control.Constructor(self)
    self.width = 300
    self.height = 100
    local x = Settings.SKPX
    local y = Settings.SKPY
    self.Alerts = {}
    self.resort = false

    local MaxItems = 5

    self.count = 0

    self.messageDuration = 5

    self:SetSize(self.width, self.height)
    self:SetPosition(x,y)
    self:SetZOrder(1)

    self:SetWantsKeyEvents(false)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetBackColor(GetRandomColour())
    --self:SetWantsUpdates(true)

    self.ReUpdateAlertPositions = function()

        local counter = 0
        for _,v in spairs(self.Alerts, function(t,a,b) return t[b][2] > t[a][2] end) do
            v[1]:SetPosition(0, MaxItems * (Settings.ABaseHeight) - (counter * Settings.ABaseHeight)) 
            counter = counter + 1
        end

        self.resort = false
    end

    self.moveBox = MoveBox(self, self.width, self.height, "Skill Popups")

    self.ExecuteUpdate = function(delta)
        for key, value in pairs(self.Alerts) do
            if value ~= nil then
                value[2] = value[2] - delta
                value[1]:SetOpacity(value[2]/self.messageDuration)
                value[1]:SetPosition(0, self.height - self.height * value[2]/self.messageDuration)
                if value[2] <= 0 then
                    value[1]:SetParent(nil)
                    self.Alerts[key] = nil
                    self.resort = true
                    self.count = self.count - 1
                end
            end
        end
    
        --[[
        if self.resort then
            --self.ReUpdateAlertPositions()
            self.resort = false
        end
        --]]
    end

    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end

end

function SkillPopupWindow:Message(message, icon)

    local Popup = Turbine.UI.Window()
    Popup:SetParent(self)
    Popup:SetVisible(true)
    Popup:SetSize(self.width, 20)
    --Popup:SetBackColor(GetRandomColour())

    local iconLabel = Turbine.UI.Label()
    iconLabel:SetParent(Popup)
    iconLabel:SetSize(32, 32)
    iconLabel:SetStretchMode(1)
    iconLabel:SetBackground(icon)
    iconLabel:SetSize(20, 20)

    local messageLabel = Turbine.UI.Label()
    messageLabel:SetParent(Popup)
    messageLabel:SetPosition(20, 0)
    messageLabel:SetSize(self.width- 20, 20)
    messageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    messageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    messageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    messageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    messageLabel:SetMarkupEnabled(true)
    messageLabel:SetText("<rgb=#00FF00>" .. message .. "</rgb> is ready!")


    local counter = 0
    if self.count > 0 then
        for key, value in pairs(self.Alerts) do
            value[1]:SetPosition(0, value[1]:GetTop() + 20) 
            --ChatOutput(value[1]:GetTop())
        end
    end
    self.Alerts[#self.Alerts + 1] = {Popup, self.messageDuration}
    --self.resort = true

    self.count = self.count + 1
    --ChatOutput(message)
end

function SkillPopupWindow:ToggleMove()
    self.moveBox:ToggleMove()
end

---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------

-- Loading data
SkillBars = LoadTable(Turbine.DataScope.Character, "PrimeSkillBars")
if SkillBars == nil then
    SkillBars = {}
end

--SkillBars = {}
SkillBarsPositions = LoadTable(Turbine.DataScope.Character, "PrimeSkillBarsPositions")
if SkillBarsPositions == nil then
    SkillBarsPositions = {}
end
ActiveSkillBars = {}