SkillTimerSettings = class(Turbine.UI.Control)
function SkillTimerSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    
    --E.PlayerEffects ->
    --E.AllPlayerEffects -> Generic group effects

    local AllButton = Turbine.UI.Lotro.Button()
    AllButton:SetParent(self)
    AllButton:SetSize(200, 15)
    AllButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    AllButton:SetMouseVisible(true)
    AllButton:SetPosition(175, 50)
    AllButton:SetText("All class effects")

    local SelfButton = Turbine.UI.Lotro.Button()
    SelfButton:SetParent(self)
    SelfButton:SetSize(200, 15)
    SelfButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SelfButton:SetMouseVisible(true)
    SelfButton:SetPosition(450, 50)
    SelfButton:SetText("Specific class effects")

    local AllPlayerEffectWindow = AllPlayerEffects(self, width, height)

    local SpecificPlayerEffectWindow = SpecificPlayerEffects(self, width, height)

    self.MakeAllPlayerEffects = function()
        --AllPlayerEffectWindow:SetBackColor(GoldColor)
    end

    self.MakeSpecificPlayerEffects = function()
        
    end

    self.MakeAllPlayerEffects()
    self.MakeSpecificPlayerEffects()

    AllButton.Click = function()
        AllPlayerEffectWindow:SetVisible(true)
        SpecificPlayerEffectWindow:SetVisible(false)
    end

    SelfButton.Click = function()
        AllPlayerEffectWindow:SetVisible(false)
        SpecificPlayerEffectWindow:SetVisible(true)
    end
end

SpecificPlayerEffects = class(Turbine.UI.Control)
function SpecificPlayerEffects:Constructor(parent, width, height)
    --AllPlayerEffectWindow:SetBackColor(GoldColor)
    
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetMouseVisible(false)
    self:SetVisible(false)

    local prevControl = nil
    local prevColour = nil
    local selectedSkill = nil

    
    local SpecificPlayerEffectWindow = Turbine.UI.Control()
    SpecificPlayerEffectWindow:SetParent(parent)
    SpecificPlayerEffectWindow:SetSize(width, height - 75)
    SpecificPlayerEffectWindow:SetPosition(0, 75)
    SpecificPlayerEffectWindow:SetParent(self)

    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(SpecificPlayerEffectWindow)
    InfoLabel:SetSize(300, 300)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(350, 150)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("*If the buff is simulteanously applied to the whole group use this to stop multiple timers (e.g. banner) \n**If an effect has a duration you want to track (e.g. Last Stand)\n***Only check this class for the buff to enhance accuracy")

    local FailLabel = Turbine.UI.Label()
    FailLabel:SetParent(SpecificPlayerEffectWindow)
    FailLabel:SetSize(200, 30)
    FailLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    FailLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    FailLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    FailLabel:SetMouseVisible(false)
    FailLabel:SetPosition(180, 350)
    FailLabel:SetVisible(false)
    FailLabel:SetMarkupEnabled(true)
    FailLabel:SetText("<rgb=#FF0000>One or more fields invalid!")

    local SuccessLabel = Turbine.UI.Label()
    SuccessLabel:SetParent(SpecificPlayerEffectWindow)
    SuccessLabel:SetSize(200, 30)
    SuccessLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    SuccessLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SuccessLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    SuccessLabel:SetMouseVisible(false)
    SuccessLabel:SetPosition(180, 350)
    SuccessLabel:SetMarkupEnabled(true)
    SuccessLabel:SetVisible(false)
    SuccessLabel:SetText("<rgb=#00FF00>Effect alert added")

    local container = Turbine.UI.ListBox()
    container:SetParent(SpecificPlayerEffectWindow)
    container:SetSize(600, height - 260)
    container:SetPosition(30, 10)
    container:SetBackColor(Turbine.UI.Color(255, 153, 0))
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( SpecificPlayerEffectWindow )
    containerScrollbar:SetPosition( 630 - 10, 10 )
    containerScrollbar:SetSize( 10, height - 260 )
    container:SetVerticalScrollBar( containerScrollbar )


    self.AddContainerItem = function(skill, class)
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 600, 40 )
        listItem:SetMouseVisible(true)
        
        local SingleBackground = Turbine.UI.Control()
        SingleBackground:SetParent(listItem)
        --SingleBackground:SetPosition(550 - 2, 240 - 2)
        SingleBackground:SetSize(600, 400)
        SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))
        SingleBackground:SetMouseVisible(false)

        local SingleBackground = Turbine.UI.Control()
        SingleBackground:SetParent(listItem)
        SingleBackground:SetPosition(2, 2)
        SingleBackground:SetSize(600 - 4, 40 - 4)
        SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
        SingleBackground:SetMouseVisible(false)
        --listItem:SetBackColor(GetRandomColour())
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(600, 40)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetPosition(4, 0)
        NameLabel:SetText(ClassObjectToName[class] .. " - " .. skill)

        local RemoveButton = Turbine.UI.Lotro.Button()
        RemoveButton:SetParent(listItem)
        RemoveButton:SetSize(100, 15)
        RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemoveButton:SetPosition(300, 10)
        RemoveButton:SetText("Remove Item")
    
        RemoveButton.Click = function()
            --TargetEffects[ItemSelectedLabel:GetText()] = nil
        if AddedCharSkillTimersSpecific[class] then 
            if AddedCharSkillTimersSpecific[class][skill] then 
                AddedCharSkillTimersSpecific[class][skill] = nil
            end
        else
            if not(RemovedBasicSkillTimersSpecific[class]) then
                RemovedBasicSkillTimersSpecific[class] = {}
            end
                
            RemovedBasicSkillTimersSpecific[class][skill] = true--E.PlayerEffects[ItemSelectedLabel:GetText()]
        end
        container:RemoveItem(listItem)
            ChatOutput("Removed effect: " .. skill)
        end

        listItem.MouseClick = function()
            if prevControl then
                prevControl:SetBackColor(prevColour)
            end
            --prevItem = listItem
            prevControl = SingleBackground
            prevColour = prevControl:GetBackColor()
            SingleBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
            --selectedPhrase = ph
        end

        return (listItem)
    end

    self.AddContainerItem2 = function(skill, class)
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 600, 40 )
        listItem:SetMouseVisible(true)
        
        local SingleBackground = Turbine.UI.Control()
        SingleBackground:SetParent(listItem)
        --SingleBackground:SetPosition(550 - 2, 240 - 2)
        SingleBackground:SetSize(600, 400)
        SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))
        SingleBackground:SetMouseVisible(false)

        local SingleBackground = Turbine.UI.Control()
        SingleBackground:SetParent(listItem)
        SingleBackground:SetPosition(2, 2)
        SingleBackground:SetSize(600 - 4, 40 - 4)
        SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0, 0))
        SingleBackground:SetMouseVisible(false)
        --listItem:SetBackColor(GetRandomColour())
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(600, 20)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetPosition(4, 2)
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetPosition(4, 0)
        NameLabel:SetText(ClassObjectToName[class] .. " - " .. skill)

        local RemoveButton = Turbine.UI.Lotro.Button()
        RemoveButton:SetParent(listItem)
        RemoveButton:SetSize(100, 15)
        RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemoveButton:SetPosition(300, 10)
        RemoveButton:SetText("ReAdd Item")
    
        RemoveButton.Click = function()
            --TargetEffects[ItemSelectedLabel:GetText()] = nil
            RemovedBasicSkillTimersSpecific[class][skill] = nil
            SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
            RemoveButton:SetVisible(false)
            ChatOutput("ReAdded effect: " .. skill)
        end

        listItem.MouseClick = function()
            if prevControl then
                prevControl:SetBackColor(prevColour)
            end
            --prevItem = listItem
            prevControl = SingleBackground
            prevColour = prevControl:GetBackColor()
            SingleBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
            --selectedPhrase = ph
        end

        return (listItem)
    end

    for key, value in pairs(E.PlayerEffects) do
        for key2, value2 in pairs(value) do
            container:AddItem(self.AddContainerItem(key2, key))
        end
        --AddListItem(key, container, ItemSelectedLabel)
    end

    for key, value in pairs(RemovedBasicSkillTimersSpecific) do
        for key2, _ in pairs(value) do
            container:AddItem(self.AddContainerItem2(key2, key))
        end
    end

    -- [1] duration [2] name [3] unique [4] activity timer [5] show activity

    -- Name
    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(SpecificPlayerEffectWindow)
    DescriptionLabel:SetSize(100, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 280)
    DescriptionLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
    DescriptionLabel:SetText("Name:")

    local ItemTextBox = Turbine.UI.Lotro.TextBox()
    ItemTextBox:SetParent(SpecificPlayerEffectWindow)
    ItemTextBox:SetSize(200, 30)
    ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox:SetMouseVisible(false)
    ItemTextBox:SetPosition(75, 275)

    --Duration
    local DescriptionLabel2 = Turbine.UI.Label()
    DescriptionLabel2:SetParent(SpecificPlayerEffectWindow)
    DescriptionLabel2:SetSize(100, 15)
    DescriptionLabel2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel2:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel2:SetPosition(20, 310)
    DescriptionLabel2:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
    DescriptionLabel2:SetText("CD:")

    local ItemTextBox2 = Turbine.UI.Lotro.TextBox()
    ItemTextBox2:SetParent(SpecificPlayerEffectWindow)
    ItemTextBox2:SetSize(100, 30)
    ItemTextBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox2:SetMouseVisible(false)
    ItemTextBox2:SetPosition(75, 305)

    -- Name
    local DescriptionLabel3 = Turbine.UI.Label()
    DescriptionLabel3:SetParent(SpecificPlayerEffectWindow)
    DescriptionLabel3:SetSize(100, 15)
    DescriptionLabel3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel3:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel3:SetPosition(20, 340)
    DescriptionLabel3:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
    DescriptionLabel3:SetText("Class***:")

    local ClassButton = Turbine.UI.Lotro.Button()
    ClassButton:SetParent(SpecificPlayerEffectWindow)
    ClassButton:SetSize(100, 15)
    ClassButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ClassButton:SetMouseVisible(true)
    ClassButton:SetPosition(75, 337)
    ClassButton:SetText("Class")

    --Unique
    local cBox = Turbine.UI.Lotro.CheckBox()
    cBox:SetParent(SpecificPlayerEffectWindow)
    cBox:SetPosition(180, 305)
    cBox:SetSize(200,20)
    cBox:SetChecked(Settings.TEffects)
    cBox:SetText("Unique*")
    cBox:SetVisible(true)


    --Activity Timer
    local cBox2 = Turbine.UI.Lotro.CheckBox()
    cBox2:SetParent(SpecificPlayerEffectWindow)
    cBox2:SetPosition(180, 325)
    cBox2:SetSize(200,20)
    cBox2:SetChecked(Settings.TEffects)
    cBox2:SetText("Activity timer**")
    cBox2:SetVisible(true)

    local TextAddButton = Turbine.UI.Lotro.Button()
    TextAddButton:SetParent(SpecificPlayerEffectWindow)
    TextAddButton:SetSize(100, 15)
    TextAddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    TextAddButton:SetMouseVisible(false)
    TextAddButton:SetPosition(20, 360)
    TextAddButton:SetText("Add Effect")

    local menu = Turbine.UI.ContextMenu()
    local menuItems = menu:GetItems()

    local sortedKeys2 = {}
    for key, value in pairs(ClassnameToObject) do table.insert( sortedKeys2, key ) end
    table.sort( sortedKeys2 )
    
    for key, name in pairs(sortedKeys2) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            ClassButton:SetText(name)
        end
        
        menuItems:Add(menuItem)
    end

    ClassButton.Click = function()
        menu:ShowMenu()
    end

    TextAddButton.Click = function()
        if ItemTextBox:GetText() ~= nil and ItemTextBox2:GetText() ~= nil and ClassButton:GetText() ~= "Class" then
            local checkItem = nil
            if cBox2:IsChecked() then
                checkItem = true
            end
            local item = {tonumber(ItemTextBox2:GetText()), ItemTextBox:GetText(), cBox:IsChecked(), checkItem, checkItem, nil}
            E.PlayerEffects[ClassnameToObject[ClassButton:GetText()]][ItemTextBox:GetText()] = item
            --item[6] = ClassnameToObject[ClassButton:GetText()]
            if not(AddedCharSkillTimersSpecific[ClassnameToObject[ClassButton:GetText()]]) then
                AddedCharSkillTimersSpecific[ClassnameToObject[ClassButton:GetText()]] = {}
            end
            AddedCharSkillTimersSpecific[ClassnameToObject[ClassButton:GetText()]][ItemTextBox:GetText()] = item 
            ChatOutput("Added effect: " .. ItemTextBox:GetText())
            SuccessLabel:SetVisible(true)
            FailLabel:SetVisible(false)
        else
            SuccessLabel:SetVisible(false)
            FailLabel:SetVisible(true)
        end
    end
end

AllPlayerEffects = class(Turbine.UI.Control)
function AllPlayerEffects:Constructor(parent, width, height)

    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetMouseVisible(false)
    self:SetVisible(false)
    --self:SetBackColor(GetRandomColour())

    local AllPlayerEffectWindow = Turbine.UI.Control()
    AllPlayerEffectWindow:SetParent(parent)
    AllPlayerEffectWindow:SetSize(width, height - 75)
    AllPlayerEffectWindow:SetPosition(0, 75)
    AllPlayerEffectWindow:SetParent(self)

    local InfoLabel = Turbine.UI.Label()
    InfoLabel:SetParent(AllPlayerEffectWindow)
    InfoLabel:SetSize(300, 300)
    InfoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    InfoLabel:SetMouseVisible(false)
    InfoLabel:SetPosition(350, 150)
    InfoLabel:SetVisible(true)
    InfoLabel:SetText("*If the buff is simulteanously applied to the whole group use this to stop multiple timers (e.g. banner) \n**If an effect has a duration you want to track (e.g. Last Stand)")

    local FailLabel = Turbine.UI.Label()
    FailLabel:SetParent(AllPlayerEffectWindow)
    FailLabel:SetSize(200, 30)
    FailLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    FailLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    FailLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    FailLabel:SetMouseVisible(false)
    FailLabel:SetPosition(180, 350)
    FailLabel:SetVisible(false)
    FailLabel:SetMarkupEnabled(true)
    FailLabel:SetText("<rgb=#FF0000>One or more fields invalid!")

    local SuccessLabel = Turbine.UI.Label()
    SuccessLabel:SetParent(AllPlayerEffectWindow)
    SuccessLabel:SetSize(200, 30)
    SuccessLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    SuccessLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SuccessLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    SuccessLabel:SetMouseVisible(false)
    SuccessLabel:SetPosition(180, 350)
    SuccessLabel:SetMarkupEnabled(true)
    SuccessLabel:SetVisible(false)
    SuccessLabel:SetText("<rgb=#00FF00>Effect alert added")

    local container = Turbine.UI.ListBox()
    container:SetParent(AllPlayerEffectWindow)
    container:SetSize(600, height - 260)
    container:SetPosition(30, 10)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( AllPlayerEffectWindow )
    containerScrollbar:SetPosition( 630 - 10, 10 )
    containerScrollbar:SetSize( 10, height - 260 )
    container:SetVerticalScrollBar( containerScrollbar )

    self.AddContainerItem = function(skill)
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 600, 40 )
        listItem:SetMouseVisible(true)
        
        local SingleBackground = Turbine.UI.Control()
        SingleBackground:SetParent(listItem)
        --SingleBackground:SetPosition(550 - 2, 240 - 2)
        SingleBackground:SetSize(600, 400)
        SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))
        SingleBackground:SetMouseVisible(false)

        local SingleBackground = Turbine.UI.Control()
        SingleBackground:SetParent(listItem)
        SingleBackground:SetPosition(2, 2)
        SingleBackground:SetSize(600 - 4, 40 - 4)
        SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
        SingleBackground:SetMouseVisible(false)
        --listItem:SetBackColor(GetRandomColour())
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(600, 40)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetPosition(4, 0)
        NameLabel:SetText(skill)

        local RemoveButton = Turbine.UI.Lotro.Button()
        RemoveButton:SetParent(listItem)
        RemoveButton:SetSize(100, 15)
        RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemoveButton:SetPosition(300, 10)
        RemoveButton:SetText("Remove Item")
    
        RemoveButton.Click = function()
            --TargetEffects[ItemSelectedLabel:GetText()] = nil
            if AddedCharSkillTimersAll[skill] then 
                AddedCharSkillTimersAll[skill] = nil
            else
                RemovedBasicSkillTimersAll[skill] = true--E.PlayerEffects[ItemSelectedLabel:GetText()]
                container:RemoveItem(listItem)
            end
                
            ChatOutput("Removed effect: " .. skill)
        end

        listItem.MouseClick = function()
            if prevControl then
                prevControl:SetBackColor(prevColour)
            end
            --prevItem = listItem
            prevControl = SingleBackground
            prevColour = prevControl:GetBackColor()
            SingleBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
            --selectedPhrase = ph
        end

        return (listItem)
    end

    self.AddContainerItem2 = function(skill, class)
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 600, 40 )
        listItem:SetMouseVisible(true)
        
        local SingleBackground = Turbine.UI.Control()
        SingleBackground:SetParent(listItem)
        --SingleBackground:SetPosition(550 - 2, 240 - 2)
        SingleBackground:SetSize(600, 400)
        SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))
        SingleBackground:SetMouseVisible(false)

        local SingleBackground = Turbine.UI.Control()
        SingleBackground:SetParent(listItem)
        SingleBackground:SetPosition(2, 2)
        SingleBackground:SetSize(600 - 4, 40 - 4)
        SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0, 0))
        SingleBackground:SetMouseVisible(false)
        --listItem:SetBackColor(GetRandomColour())
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(600, 20)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        --NameLabel:SetMultiline(false)
        NameLabel:SetPosition(4, 2)
        NameLabel:SetMarkupEnabled(true)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetPosition(4, 0)
        NameLabel:SetText(skill)

        local RemoveButton = Turbine.UI.Lotro.Button()
        RemoveButton:SetParent(listItem)
        RemoveButton:SetSize(100, 15)
        RemoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        RemoveButton:SetPosition(300, 10)
        RemoveButton:SetText("ReAdd Item")
    
        RemoveButton.Click = function()
            --TargetEffects[ItemSelectedLabel:GetText()] = nil
            RemovedBasicSkillTimersAll[skill] = nil
            SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
            RemoveButton:SetVisible(false)
            ChatOutput("ReAdded effect: " .. skill)
        end

        listItem.MouseClick = function()
            if prevControl then
                prevControl:SetBackColor(prevColour)
            end
            --prevItem = listItem
            prevControl = SingleBackground
            prevColour = prevControl:GetBackColor()
            SingleBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
            --selectedPhrase = ph
        end

        return (listItem)
    end

    for key, value in pairs(E.AllPlayerEffects) do
        container:AddItem(self.AddContainerItem(key))
    end

    for key, value in pairs(RemovedBasicSkillTimersAll) do
        container:AddItem(self.AddContainerItem2(key))
    end

    -- [1] duration [2] name [3] unique [4] activity timer [5] show activity

    -- Name
    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(AllPlayerEffectWindow)
    DescriptionLabel:SetSize(100, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(20, 280)
    DescriptionLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
    DescriptionLabel:SetText("Name:")

    local ItemTextBox = Turbine.UI.Lotro.TextBox()
    ItemTextBox:SetParent(AllPlayerEffectWindow)
    ItemTextBox:SetSize(200, 30)
    ItemTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox:SetMouseVisible(false)
    ItemTextBox:SetPosition(75, 275)

    --Duration
    local DescriptionLabel2 = Turbine.UI.Label()
    DescriptionLabel2:SetParent(AllPlayerEffectWindow)
    DescriptionLabel2:SetSize(100, 15)
    DescriptionLabel2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel2:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel2:SetPosition(20, 310)
    DescriptionLabel2:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
    DescriptionLabel2:SetText("CD:")

    local ItemTextBox2 = Turbine.UI.Lotro.TextBox()
    ItemTextBox2:SetParent(AllPlayerEffectWindow)
    ItemTextBox2:SetSize(100, 30)
    ItemTextBox2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ItemTextBox2:SetMouseVisible(false)
    ItemTextBox2:SetPosition(75, 305)

    --Unique
    local cBox = Turbine.UI.Lotro.CheckBox()
    cBox:SetParent(AllPlayerEffectWindow)
    cBox:SetPosition(180, 305)
    cBox:SetSize(200,20)
    cBox:SetChecked(Settings.TEffects)
    cBox:SetText("Unique*")
    cBox:SetVisible(true)


    --Activity Timer
    local cBox2 = Turbine.UI.Lotro.CheckBox()
    cBox2:SetParent(AllPlayerEffectWindow)
    cBox2:SetPosition(180, 325)
    cBox2:SetSize(200,20)
    cBox2:SetChecked(Settings.TEffects)
    cBox2:SetText("Activity timer**")
    cBox2:SetVisible(true)

    local TextAddButton = Turbine.UI.Lotro.Button()
    TextAddButton:SetParent(AllPlayerEffectWindow)
    TextAddButton:SetSize(100, 15)
    TextAddButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    TextAddButton:SetMouseVisible(false)
    TextAddButton:SetPosition(20, 360)
    TextAddButton:SetText("Add Effect")

    TextAddButton.Click = function()
        if ItemTextBox:GetText() ~= nil and tonumber(ItemTextBox2:GetText()) and ItemTextBox2:GetText() ~= nil then
            local checkItem = nil
            if cBox2:IsChecked() then
                checkItem = true
            end
            local item = {tonumber(ItemTextBox2:GetText()), ItemTextBox:GetText(), cBox:IsChecked(), checkItem, checkItem}
            E.AllPlayerEffects[ItemTextBox:GetText()] = item
            AddedCharSkillTimersAll[ItemTextBox:GetText()] = item
            ChatOutput("Added effect: " .. ItemTextBox:GetText())
            InfoLabel:SetVisible(true)
            SuccessLabel:SetVisible(true)
            FailLabel:SetVisible(false)
        else
            SuccessLabel:SetVisible(false)
            FailLabel:SetVisible(true)
        end
    end
end

