SkillTimers = class(Turbine.UI.Window)
function SkillTimers:Constructor(timerType)
    Turbine.UI.Window.Constructor(self)
    self.width = 0
    self.height = 0
    local x = 0
    local y = 0
    self.showTimers = nil
    self.Name = nil
    if timerType == 0 then 
        self.width = Settings.SPWidth2
        self.height = Settings.SPHeight2
        x = Settings.SPX2
        y = Settings.SPY2
        self.showTimers = Settings.SPCDEnabled
        self.Name = "Cooldown Timers"
        self.sorting = Settings.SkilltimerSorting
        self.colourScheme = {Turbine.UI.Color(0,0,0), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0,0.5,0), Turbine.UI.Color(1,1,1), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0.5,0,0), Settings.SkillTimersFrontTexture, Settings.SkillTimersBackTexture, Settings.SkillTimersFrontOpacity, Settings.SkillTimersBackOpacity}
    else
        self.width = Settings.SPWidth2
        self.height = Settings.SPHeight2
        x = Settings.SPAX
        y = Settings.SPAY
        self.showTimers = Settings.SPActiveEnabled
        self.Name = "Active Timers"
        self.sorting = Settings.ActivetimerSorting
        self.colourScheme = {Turbine.UI.Color(0,0,0), Turbine.UI.Color(0,0,0), Turbine.UI.Color(255, 153, 0), Turbine.UI.Color(1,1,1), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0.5,0,0), Settings.SkillTimersFrontTexture, Settings.SkillTimersBackTexture, Settings.SkillTimersFrontOpacity, Settings.SkillTimersBackOpacity}

    end
    local cooldownTimer = 0
    local oldGameTime = Turbine.Engine.GetGameTime()
    self.Timers = {}
    local ID = 0
    local clearTimer = 0
    self.TimerType= timerType
    self.resort = false

    self.counter = 0
    self.UniqueTimers = {}

    self.offset = Settings.SPTimerHeight2 * Settings.SkillTimerScale
    self.TimerHeight = Settings.SPTimerHeight2 * Settings.SkillTimerScale
    self.font = Settings.SPNewFont


    self:SetSize(self.width, self.height)
    self:SetPosition(x,y)
    self:SetZOrder(1)
    self:SetVisible(true)
    self:SetMouseVisible(false)
    self:SetBackground(GetRandomColour())
    --self:SetVisible(not(Settings.SPInstance))
    --self:SetWantsUpdates(true)
  
    local moveBox = MoveBox(self, self.width, self.height, self.Name)
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.Clear = function()
        for key, value in pairs(self.Timers) do 
            value[1]:Destroy()
            self.Timers[key] = nil
        end

        if Tablelength(self.Timers) > 0 then
            self.Clear()
        end

        self.Timers = nil
        collectgarbage()
        self.Timers = {}
        self.counter = 0
        self.UniqueTimers = {}--
    end

    self.Compare = function(a, b)
        if a ~= nil and b ~= nil then
            return a[2] < b[2]
        end
    end

    if self.sorting == 1 then
        -- Top to bottom
        self.ResortList = function()
            local counter = 0
            for _,v in spairs(self.Timers, function(t,a,b) return t[b][2] > t[a][2] end) do
                v[1]:SetPosition(0, counter * self.offset) 
                counter = counter + 1
            end
    
            self.resort = false
        end
    elseif self.sorting == 2 then
        -- Bottom to top
        self.ResortList = function()
            local counter = 0
            for _,v in spairs(self.Timers, function(t,a,b) return t[b][2] > t[a][2] end) do
                v[1]:SetPosition(0, self.height - counter * self.offset) 
                counter = counter + 1
            end
    
            self.resort = false
        end
    end

    self.ExecuteUpdate = function(delta)   
        --We had an update
        for key, value in pairs(self.Timers) do 
            value[2] = value[2] - delta
            value[1]:UpdateText(delta)
            if value[2] < 0 then 
                --PrintTable(self.Timers)
                --ChatOutput("Delete ID: " .. key)
                self.UniqueTimers[value[4]] = nil
                value[1]:Destroy()
                self.Timers[key] = nil
                self.counter = self.counter - 1
                --PrintTable(self.Timers)
                self.resort = true
            end
            --value[1]:SetText(value[3].." "..value[2])
        end
    
        if self.resort then 
            if self.counter == 0 then 
                if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
                self.updateCallback = nil
                self.Timers = nil
                collectgarbage()
                self.Timers = {}
                return
            end
            self.ResortList() 
        end
    end
end

-- Add a timer
function SkillTimers:NewTimer(duration, effectName, message, unique, activityTimer, showActivity, icon, name)
    --if not(self.showTimers) then return end
    --local count = tablelength(self.Timers)
    if unique then
        if self.UniqueTimers[effectName] and self.UniqueTimers[effectName] > Turbine.Engine.GetGameTime() then
            return
        else
            self.UniqueTimers[effectName] = Turbine.Engine.GetGameTime() + activityTimer
        end

        --[[
        if activityTimer == nil then ChatOutput("Nill timer for: " .. effectName) end
        for key, value in pairs(self.Timers) do
            --ChatOutput(value[4] .. " " .. effectName)
            if value[4] == effectName and (self.TimerType == 1 or duration - activityTimer < value[1]:GetRemainingTime()) then 
                --ChatOutput("Return")
                return
            end
        end
        --]]
    end

    if E.BetterEffectIcons[effectName] ~= nil then
        icon = E.BetterEffectIcons[effectName]
    end

    local timerMessage = nil
    
    if showActivity ~= nil and self.TimerType ==  1 then
        if not(E.GroupEffectsActive[effectName]) then
            timerMessage = name
        else
            timerMessage = message
        end
        self.Timers[#self.Timers + 1] = {EffectTimer(self, self.width, self.TimerHeight, nil, timerMessage, self.font, self.colourScheme, true, nil, activityTimer, icon), activityTimer, timerMessage, effectName, unique}
        self.counter = self.counter + 1
        --count = count + 1
    end
            --self.Timers[ID] =  {Counter(self, self.width, height, count, duration, message), duration, message}
    if self.TimerType == 0 then
        if not(E.GroupEffectsCooldown[effectName]) then
            timerMessage = name
        else
            timerMessage = message
        end
        self.Timers[#self.Timers + 1] = {EffectTimer(self, self.width, self.TimerHeight, nil, timerMessage, self.font, self.colourScheme, true, nil, duration, icon), duration, timerMessage, effectName, unique}
        self.counter = self.counter + 1
    end

    --ID = ID + 1
    self.resort = true

    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
    --PrintTable(self.Timers)
end
