
SkillTrackerWindowOptions = class(Turbine.UI.Control)
function SkillTrackerWindowOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(0,-20)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    local tskills = self.player:GetTrainedSkills()

    self.selectedSkill = nil

    local currentlySelectedItem = nil
    local SkillDictionary = {}
    local LocalSkillBars = {}
    local SkillsByNames = {}

    for i = 1, self.player:GetTrainedSkills():GetCount(), 1 do
        local item = tskills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName() 
        local description = item:GetSkillInfo():GetDescription()

        if (not(RealSkill(description))and string.len(description) > 0 and item:GetSkillInfo():GetType() ~= 1) then
            SkillsByNames[name] = item
        end
    end

    -- New timer options
    local OptionsBackground = Turbine.UI.Control()
    OptionsBackground:SetParent(self)
    OptionsBackground:SetPosition(20, 40)
    OptionsBackground:SetSize(300, 170)
    OptionsBackground:SetMouseVisible(false)
    OptionsBackground:SetVisible(true)
    OptionsBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local textLabel = Turbine.UI.Label()
    textLabel:SetParent(OptionsBackground)
    textLabel:SetSize(200, 20)
    textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    textLabel:SetPosition(5, 5)
    textLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    textLabel:SetText("Add new timer:") 

    local skillTextLabel = Turbine.UI.Label()
    skillTextLabel:SetParent(OptionsBackground)
    skillTextLabel:SetSize(80, 20)
    skillTextLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    skillTextLabel:SetPosition(5, 30)
    skillTextLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    skillTextLabel:SetText("Skill:") 

    local skillSelectedLabel = Turbine.UI.Label()
    skillSelectedLabel:SetParent(OptionsBackground)
    skillSelectedLabel:SetSize(200, 20)
    skillSelectedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    skillSelectedLabel:SetPosition(55, 30)
    skillSelectedLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)

    local timerLabel = Turbine.UI.Label()
    timerLabel:SetParent(OptionsBackground)
    timerLabel:SetSize(200, 20)
    timerLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    timerLabel:SetPosition(5, 50)
    timerLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    timerLabel:SetText("Timer length:") 

    local timerBox = Turbine.UI.Lotro.TextBox()
    timerBox:SetParent(OptionsBackground)
    timerBox:SetSize(50, 20)
    timerBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    timerBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    timerBox:SetPosition(105, 50)

    local stackLabel = Turbine.UI.Label()
    stackLabel:SetParent(OptionsBackground)
    stackLabel:SetSize(80, 20)
    stackLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    stackLabel:SetPosition(5, 70)
    stackLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    stackLabel:SetText("Max stacks:") 

    local stackBox = Turbine.UI.Lotro.TextBox()
    stackBox:SetParent(OptionsBackground)
    stackBox:SetSize(50, 20)
    stackBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    stackBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    stackBox:SetPosition(85, 70)

    local Targetting = Turbine.UI.Lotro.CheckBox()
    Targetting:SetParent(OptionsBackground)
    Targetting:SetPosition(5, 90)
    Targetting:SetSize(200, 20)
    Targetting:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    Targetting:SetText("Get name from target*")
    Targetting:SetVisible(true)

    local infoLabel = Turbine.UI.Label()
    infoLabel:SetParent(OptionsBackground)
    infoLabel:SetSize(450, 20)
    infoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    infoLabel:SetPosition(5, 110)
    infoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    infoLabel:SetText("*currently disabled till SSG fixes problems") 

    local addTimer = Turbine.UI.Lotro.Button()
    addTimer:SetParent(OptionsBackground)
    addTimer:SetSize(100, 20)
    --addTimer:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    addTimer:SetPosition(5, 140)
    addTimer:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    addTimer:SetText("Add Timer") 

    -- Skill Menu

    local SelectionContainerPopOutBorder = Turbine.UI.Control()
    SelectionContainerPopOutBorder:SetParent(self)
    SelectionContainerPopOutBorder:SetPosition(width - 400, 20)
    SelectionContainerPopOutBorder:SetSize(400, 140)
    SelectionContainerPopOutBorder:SetMouseVisible(false)
    SelectionContainerPopOutBorder:SetVisible(true)
    SelectionContainerPopOutBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    SelectionContainerPopOutBorder:SetZOrder(100)

    local SelectionContainerPopOut = Turbine.UI.Control()
    SelectionContainerPopOut:SetParent(SelectionContainerPopOutBorder)
    SelectionContainerPopOut:SetPosition(5, 5)
    SelectionContainerPopOut:SetSize(400 - 10, 140 - 10)
    SelectionContainerPopOut:SetMouseVisible(true)
    SelectionContainerPopOut:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    SelectionContainerPopOut:SetZOrder(100)

    local PopOoutContainer = Turbine.UI.ListBox()
    PopOoutContainer:SetParent(SelectionContainerPopOut)
    PopOoutContainer:SetSize(380, 130)
    PopOoutContainer:SetPosition(0, 0)
    PopOoutContainer:SetVisible(true)
    --PopOoutContainer:SetBackColor(GetRandomColour())
    PopOoutContainer:SetOrientation( Turbine.UI.Orientation.Vertical )

    local ScrollbarBackground = Turbine.UI.Control()
    ScrollbarBackground:SetParent( SelectionContainerPopOut )
    ScrollbarBackground:SetPosition( 380, 0 )
    ScrollbarBackground:SetSize( 10, 130)
    ScrollbarBackground:SetMouseVisible(false)
    ScrollbarBackground:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

    local PopOoutContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    PopOoutContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    PopOoutContainerScrollbar:SetParent( SelectionContainerPopOut )
    PopOoutContainerScrollbar:SetPosition( 380, 0 )
    PopOoutContainerScrollbar:SetSize( 10, 130)
    PopOoutContainerScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    PopOoutContainer:SetVerticalScrollBar( PopOoutContainerScrollbar )


    local sortedKeys = {}
    for key, value in pairs(SkillsByNames) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )
    
    for key, name in pairs(sortedKeys) do
        local item = SkillsByNames[name]
        local menuItem = Turbine.UI.MenuItem( name )

        local ListItem = Turbine.UI.Control()
        ListItem:SetSize(380, 34)
        ListItem:SetMouseVisible(true)
        ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

        local BackGroundControl = Turbine.UI.Control()
        BackGroundControl:SetParent(ListItem)
        BackGroundControl:SetSize(380, 30)
        BackGroundControl:SetPosition(0, 2)
        BackGroundControl:SetMouseVisible(false)
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(ListItem)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        NameLabel:SetSize(380, 30)
        NameLabel:SetPosition(0, 2)
        NameLabel:SetMouseVisible(false)
        NameLabel:SetText(name)
        
        ListItem.MouseClick = function()
            skillSelectedLabel:SetText(name)
            self.selectedSkill = name
             --SelectionContainerPopOutBorder:SetVisible(false)
        end

        ListItem.MouseEnter = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
        end

        ListItem.MouseLeave = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
        end

        PopOoutContainer:AddItem(ListItem)
    end

    -- Timer List
    local ListContainter = Turbine.UI.Control()
    ListContainter:SetParent(self)
    ListContainter:SetPosition(20, 280)
    ListContainter:SetSize(710, 200)
    ListContainter:SetMouseVisible(false)
    ListContainter:SetVisible(true)
    ListContainter:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local ListScrollbarBackground = Turbine.UI.ListBox()
    ListScrollbarBackground:SetParent( ListContainter )
    ListScrollbarBackground:SetPosition( 5, 5 )
    ListScrollbarBackground:SetSize( 700, 190)
    ListScrollbarBackground:SetMouseVisible(false)
    ListScrollbarBackground:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

    local ListPopOoutContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    ListPopOoutContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    ListPopOoutContainerScrollbar:SetParent( ListContainter )
    ListPopOoutContainerScrollbar:SetPosition( 695, 5 )
    ListPopOoutContainerScrollbar:SetSize( 10, 190)
    ListPopOoutContainerScrollbar:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))
    ListScrollbarBackground:SetVerticalScrollBar( ListPopOoutContainerScrollbar )

    self.AddToTimerBox = function(name, data)
        local item = SkillsByNames[name]
        local menuItem = Turbine.UI.MenuItem( name )

        local ListItem = Turbine.UI.Control()
        ListItem:SetSize(700, 44)
        ListItem:SetMouseVisible(true)
        ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

        local BackGroundControl = Turbine.UI.Control()
        BackGroundControl:SetParent(ListItem)
        BackGroundControl:SetSize(695, 40)
        BackGroundControl:SetPosition(0, 2)
        BackGroundControl:SetMouseVisible(false)
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(ListItem)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        NameLabel:SetSize(400, 20)
        NameLabel:SetPosition(10, 0)
        NameLabel:SetMouseVisible(false)
        NameLabel:SetText(name)

        local valueLabel = Turbine.UI.Label()
        valueLabel:SetParent(ListItem)
        valueLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        valueLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
        valueLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        valueLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        valueLabel:SetSize(400, 20)
        valueLabel:SetPosition(10, 20)
        valueLabel:SetMouseVisible(false)

        local informationText = nil
        if data[3] then informationText = "yes" else informationText = "no" end

        valueLabel:SetText("Timer: " .. data[1] .. " Max stacks: " .. data[2] .. " Get name from target: " .. informationText)

        local removeButton = Turbine.UI.Lotro.Button()
        removeButton:SetParent(ListItem)
        removeButton:SetSize(150, 20)
        --addTimer:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
        removeButton:SetPosition(540, 10)
        removeButton:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        removeButton:SetText("Remove Timer") 

        removeButton.Click = function()
            SkillUsageTracker:RemoveFromTable(name)
            ListScrollbarBackground:RemoveItem(ListItem)
        end

        ListItem.MouseEnter = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.25, 0.25, 0.25))
        end

        ListItem.MouseLeave = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
        end

        ListScrollbarBackground:AddItem(ListItem)
    end

    for key, value in pairs(SkillUsageTracker:GetTimers()) do
        self.AddToTimerBox(key, value)
    end

    addTimer.Click = function()
        if self.selectedSkill ~= nil and tonumber(timerBox:GetText()) ~= nil and tonumber(stackBox:GetText()) ~= nil then
            SkillUsageTracker:AddTimerToTable(self.selectedSkill, {tonumber(timerBox:GetText()), tonumber(stackBox:GetText()), Targetting:IsChecked()} )
            self.AddToTimerBox(self.selectedSkill, {tonumber(timerBox:GetText()), tonumber(stackBox:GetText()), Targetting:IsChecked()})
        end
    end

    local MoveBackground = Turbine.UI.Control()
    MoveBackground:SetParent(self)
    MoveBackground:SetPosition(20, 220)
    MoveBackground:SetSize(190, 40)
    MoveBackground:SetMouseVisible(false)
    MoveBackground:SetVisible(true)
    MoveBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local removeButton = Turbine.UI.Lotro.Button()
    removeButton:SetParent(MoveBackground)
    removeButton:SetSize(150, 20)
    --addTimer:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    removeButton:SetPosition(20, 10)
    removeButton:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    removeButton:SetText("Move Window") 

    removeButton.Click = function()
        SkillUsageTracker:ToggleMove()
    end

    local WidthBackground = Turbine.UI.Control()
    WidthBackground:SetParent(self)
    WidthBackground:SetPosition(220, 220)
    WidthBackground:SetSize(90, 40)
    WidthBackground:SetMouseVisible(false)
    WidthBackground:SetVisible(true)
    WidthBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local timerBox = Turbine.UI.Lotro.TextBox()
    timerBox:SetParent(WidthBackground)
    timerBox:SetSize(50, 20)
    timerBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    timerBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    timerBox:SetPosition(15, 0)
    timerBox:SetText(Settings.STSWidth)

    local sizeButton = Turbine.UI.Lotro.Button()
    sizeButton:SetParent(WidthBackground)
    sizeButton:SetSize(80, 20)
    sizeButton:SetPosition(5, 20)
    sizeButton:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    sizeButton:SetText("Set Width") 

    sizeButton.Click = function()
        Settings.STSWidth = tonumber(timerBox:GetText())
        ChatOutput("Changed skill tracker width to" .. tonumber(timerBox:GetText()))
    end


local WidthBackground = Turbine.UI.Control()
    WidthBackground:SetParent(self)
    WidthBackground:SetPosition(400, 150)
    WidthBackground:SetSize(400, 200)
    WidthBackground:SetMouseVisible(false)
    WidthBackground:SetVisible(true)
    --WidthBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local timerBox = Turbine.UI.Lotro.TextBox()
    timerBox:SetParent(WidthBackground)
    timerBox:SetSize(50, 20)
    timerBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    timerBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    timerBox:SetPosition(225, 10)
    timerBox:SetText(Settings.SPWidth2)
    
    self.colourScheme = {Turbine.UI.Color(0,0,0), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0,170/255,170/255), Turbine.UI.Color(1,1,1), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0.5,0,0), Settings.SkillTrackersFrontTexture, Settings.SkillTrackersBackTexture, Settings.SkillTrackersFrontOpacity, Settings.SkillTrackersBackOpacity}
    self.ExampleTimer = EffectTimer(WidthBackground, Settings.SPWidth2, 20, nil, "Test",  Settings.SPNewFont, self.colourScheme, true, nil, 20, 0x411172A2)
    self.ExampleTimer:SetPosition(130, 60)
    self.duration = 20

    
    self.ExecuteUpdate = function(delta)
        self.duration = self.duration - delta

        if self.duration < 2 then 
            self.duration = 20 
            self.ExampleTimer:ChangeDuration(self.duration)
        end
        self.ExampleTimer:UpdateText(delta)
    end

    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end


    local sizeButton = Turbine.UI.Lotro.Button()
    sizeButton:SetParent(WidthBackground)
    sizeButton:SetSize(80, 20)
    sizeButton:SetPosition(215, 30)
    sizeButton:SetText("Set Width") 

    sizeButton.Click = function()
        Settings.SPWidth2 = tonumber(timerBox:GetText())
        ChatOutput("Changed skill timer width to " .. tonumber(timerBox:GetText()))
    end

    local opacityBox = Turbine.UI.Lotro.TextBox()
    opacityBox:SetParent(WidthBackground)
    opacityBox:SetSize(50, 20)
    opacityBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    opacityBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    opacityBox:SetPosition(105,10)
    opacityBox:SetText(Settings.SkillTrackersFrontOpacity)

    local opacityButton = Turbine.UI.Lotro.Button()
    opacityButton:SetParent(WidthBackground)
    opacityButton:SetSize(120, 20)
    opacityButton:SetPosition(90, 30)
    opacityButton:SetText("Set Front Opacity") 

    opacityButton.Click = function()
        Settings.SkillTrackersFrontOpacity = tonumber(opacityBox:GetText())
        ChatOutput("Changed skill timer bar opacity to " .. tonumber(opacityBox:GetText()))
        self.ExampleTimer:ChangeFrontOpacity(Settings.SkillTrackersFrontOpacity)
    end

    local opacityBackBox = Turbine.UI.Lotro.TextBox()
    opacityBackBox:SetParent(WidthBackground)
    opacityBackBox:SetSize(50, 20)
    opacityBackBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    opacityBackBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    opacityBackBox:SetPosition(15, 40)
    opacityBackBox:SetText(Settings.SkillTrackersBackOpacity)

    local opacityButtonBack = Turbine.UI.Lotro.Button()
    opacityButtonBack:SetParent(WidthBackground)
    opacityButtonBack:SetSize(120, 20)
    opacityButtonBack:SetPosition(0, 60)
    opacityButtonBack:SetText("Set Back Opacity") 

    opacityButtonBack.Click = function()
        Settings.SkillTrackersBackOpacity = tonumber(opacityBackBox:GetText())
        ChatOutput("Changed skill timer bar back opacity to " .. tonumber(opacityBackBox:GetText()))
        self.ExampleTimer:ChangeBackOpacity(Settings.SkillTrackersBackOpacity)
    end

    local frontbutton = Turbine.UI.Lotro.Button()
    frontbutton:SetParent(WidthBackground)
    frontbutton:SetPosition(0, 80)
    frontbutton:SetSize(150,15)
    frontbutton:SetText("Timer Texture")
    frontbutton:SetVisible(true)

    -- [[
    local sortedNames1 = {}
    for key, value in pairs(BackgroundHandler:GetBarTextureData()) do table.insert( sortedNames1, key ) end
    table.sort( sortedNames1 )
    
    self.frontmenu = Turbine.UI.ContextMenu()
    self.frontmenuItems = self.frontmenu:GetItems()

    self.frontBar = nil

    for key, value in pairs(sortedNames1) do
        local frontmenuItem = Turbine.UI.MenuItem( value )
        frontmenuItem.Click = function()
            self.frontBar = value
            Settings.SkillTrackersFrontTexture = self.frontBar 
            self.ExampleTimer:ChangeFrontTexture(Settings.SkillTrackersFrontTexture)
        end
        self.frontmenuItems:Add(frontmenuItem)
    end

    local frontmenuItemNil = Turbine.UI.MenuItem( "None" )
    frontmenuItemNil.Click = function()
        Settings.SkillTrackersFrontTexture = nil
        self.ExampleTimer:ChangeFrontTexture(Settings.SkillTrackersFrontTexture)
    end
    self.frontmenuItems:Add(frontmenuItemNil)
        --]]




    frontbutton.Click = function()
        self.frontmenu:ShowMenu()
    end

    local backbutton = Turbine.UI.Lotro.Button()
    backbutton:SetParent(WidthBackground)
    backbutton:SetPosition(0, 100)
    backbutton:SetSize(150,15)
    backbutton:SetText("Background Texture")
    backbutton:SetVisible(true)


    self.backbar = nil
    -- [[
    self.backmenu = Turbine.UI.ContextMenu()
    self.backmenuItems = self.backmenu:GetItems()

    local sortedNames2 = {}
    for key, value in pairs(BackgroundHandler:GetBarTextureData()) do table.insert( sortedNames2, key ) end
    table.sort( sortedNames2 )

    for key, value in pairs(sortedNames2) do
        local backmenuItem = Turbine.UI.MenuItem( value )
        backmenuItem.Click = function()
            self.backbar = value
            Settings.SkillTrackersBackTexture = self.backbar
            self.ExampleTimer:ChangeBackTexture(Settings.SkillTrackersBackTexture)
        end
        self.backmenuItems:Add(backmenuItem)
    end
    local backmenuItemNil = Turbine.UI.MenuItem( "None" )
    backmenuItemNil.Click = function()
        Settings.SkillTrackersBackTexture = nil
        self.ExampleTimer:ChangeBackTexture(Settings.SkillTrackersBackTexture)
    end
    self.backmenuItems:Add(backmenuItemNil)
        --]]

    backbutton.Click = function()
        self.backmenu:ShowMenu()
    end
end