SoundPlayer = class(Turbine.UI.Control)
function SoundPlayer:Constructor()
    Turbine.UI.Control.Constructor(self)
    self.PlaySound = Settings.Sound

    self.soundEffects = {
        ["Horn"] = "alarmbuzzer",
        ["Hornq"] = "alarmbuzzer_quiet",
        ["Horns"] = "alarmbuzzer_soft",
        ["Alarm"] = "alarmbuzz",
        ["Alarms"] = "alarmbuzz_soft",
        ["Alarmq"] = "alarmbuzz_quiet",
        ["Beep"] = "alarmbeep",
        ["Beeps"] = "alarmbeep_soft",
        ["Beepq"] = "alarmbeep_quiet",
        ["Double"] = "alarmdouble",
        ["Doubles"] = "alarmdouble_soft",
        ["Doubleq"] = "alarmdouble_quiet",
        ["Rc"] = "readycheck",
        ["Spread"] = "Spread",
        ["1"] = "1",
        ["2"] = "2",
        ["3"] = "3",
        ["4"] = "4",
        ["5"] = "5",
        ["6"] = "6",
        ["7"] = "7",
        ["8"] = "8",
        ["9"] = "9",
        ["10"] = "10",
        ["Run"] = "runaway",
        ["DontDie"] = "dontdie",
        ["AHorn"] = "AirHorn",
        ["Adds"] = "Adds",
        ["Left"] = "Left",
        ["Right"] = "Right",
        ["Stack"] = "Stack",
        ["Switch"] = "Switch",
        ["Test"] = "Test",
        ["Victory"] = "Victory",
        ["GO"] = "Go", --"gunshot",
        ["Appl"] = "Applause",
        ["Amazing"] = "Amazing",
        ["Ping"] = "Info",
        ["aoe"] = "aesoon",
        ["hide"] = "findshelter",
        ["runout"] = "runout",
        ["tauntBoss"] = "tauntboss",
        ["Defensive"] = "defensive",
        ["Interrupt"] = "kickcast",
    }
    
    local tempTable = self.soundEffects
    
    self.soundEffects = LoadTable(Turbine.DataScope.Account, "PrimeSoundEffects")
    if self.soundEffects == nil then self.soundEffects = {} end
    for key, value in pairs(tempTable) do
        if self.soundEffects[key] == nil then
            self.soundEffects[key] = value
        end
    end
end

function SoundPlayer:PlaySoundEffect(name)
    if self.PlaySound then 
        if name then
            DirectChatOutput(string.format("X Play Sound Effect: %s", tostring(name)) )
        else
            ChatOutput("No SoundEffect name Specified")
        end
    end
end

function SoundPlayer:GetSoundList()
    return self.soundEffects
end