
SoundOptions = class(Turbine.UI.Control)
function SoundOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(0,-20)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10 - 2, 10 - 2)
    SingleBackground:SetSize(730 + 4, 450 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10, 10)
    SingleBackground:SetSize(730, 450)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local nameLabel = Turbine.UI.Label()
    nameLabel:SetParent(SingleBackground)
    nameLabel:SetSize(200, 20)
    nameLabel:SetPosition(10, 80)
    nameLabel:SetMouseVisible(false)
    nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    nameLabel:SetMultiline(false)
    nameLabel:SetText("Current Sound Effects")

    local container = Turbine.UI.ListBox()
    container:SetParent(SingleBackground)
    container:SetSize(200, 240)
    container:SetPosition(10, 100)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)
    --container:SetBackColor(GetRandomColour())

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( SingleBackground )
    containerScrollbar:SetPosition( 210, 100 )
    containerScrollbar:SetSize( 10, 240 )
    containerScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    container:SetVerticalScrollBar( containerScrollbar )

    self.createSkillBar = function(name)

        local pluginBar = Turbine.UI.Control()
        pluginBar:SetSize(200, 40)
        pluginBar:SetBackColor(Turbine.UI.Color(0, 0, 0))

        local backgroundBar = Turbine.UI.Control()
        backgroundBar:SetSize(200, 38)
        backgroundBar:SetPosition(0, 1)
        backgroundBar:SetParent(pluginBar)
        backgroundBar:SetMouseVisible(false)
        backgroundBar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
        --pluginBar:SetBackColor(GetRandomColour())

        local nameLabel = Turbine.UI.Label()
        nameLabel:SetParent(pluginBar)
        nameLabel:SetSize(200, 20)
        nameLabel:SetPosition(0, 10)
        nameLabel:SetMouseVisible(false)
        nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
        nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        nameLabel:SetMultiline(false)
        nameLabel:SetText(name)

        return pluginBar
    end

    for key, value in spairs(Sounds:GetSoundList(), function(t,a,b) return t[a] < t[b] end) do 
        container:AddItem(self.createSkillBar(key))
    end

    local inforLabel = Turbine.UI.Label()
    inforLabel:SetParent(SingleBackground)
    inforLabel:SetSize(400, 150)
    inforLabel:SetPosition(280, 80)
    inforLabel:SetMouseVisible(false)
    inforLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    inforLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    inforLabel:SetText("To add your sound effects add the name of the file to here. The sound player only supports wav sounds. The correct place for the sound files is in ..\\Plugins\\PrimePlugins\\RaidTools\\SoundEffects. The prime sound player executable needs to be running to play sounds. For more information check the lotrointerface page for the prime sound player. The plugin needs to reloaded to load new soundeffects in its tools.")

    local soundBox = Turbine.UI.Lotro.TextBox()
    soundBox:SetParent(SingleBackground)
    soundBox:SetSize(400, 20)
    soundBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    soundBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    soundBox:SetPosition(280, 230)

    local addButton = Turbine.UI.Lotro.Button()
    addButton:SetParent(SingleBackground)
    addButton:SetSize(200, 20)
    addButton:SetPosition(280, 250)
    addButton:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    addButton:SetText("Add SoundEffect") 

    addButton.Click = function()
        local name = tostring(soundBox:GetText())
        if Sounds:GetSoundList()[name] then
            ChatOutput("SoundEffect key already exists")
        else
            Sounds:GetSoundList()[name] = name
            ChatOutput("Added new soundeffect")
        end
    end
end