Stats = class(Turbine.UI.Lotro.Window)
function Stats:Constructor()
    local width = 1100
    local height = 750
    local x = math.floor(Turbine.UI.Display.GetWidth() / 2 - (width /2))
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(x,y)
    self:SetWantsKeyEvents(true)
    self:SetText("Stats")
    self:SetVisible(true)

    local CharStats, AccountStats = StatEventHandling:GetData()

    local charKBs = 0

    for key, value in pairs(CharStats["KB"]) do charKBs = charKBs + value end

    local accKBs = 0

    for key, value in pairs(AccountStats["KB"]) do accKBs = accKBs + value end

    self.CreateCharStatLabels = function()
        local charItems = Turbine.UI.Control()
        charItems:SetParent(self)
        charItems:SetVisible(true)
        charItems:SetSize( 500, 400 )
        charItems:SetPosition(0, 0)
        charItems:SetMouseVisible(false)

        GetStatLabel(charItems, 20, 30, "Character stats:")
        GetStatLabel(charItems, 20, 50, "Uptime: " .. Round(CharStats["Time"]/3600, 1) .. "h")
        GetStatLabel(charItems, 20, 70, "Reloads: " .. CharStats["Reload"])
        GetStatLabel(charItems, 20, 90, "Deaths: " .. CharStats["Death"])
        GetStatLabel(charItems, 20, 110, "Misadventure Deaths: " .. CharStats["MisadventureDeaths"])
        GetStatLabel(charItems, 20, 130, "Killing Blows: " .. charKBs)
        GetStatLabel(charItems, 20, 170, "Character PVMP Stats")
        GetStatLabel(charItems, 20, 190, "Killing Blows: " .. CharStats["PVPKB"])
        GetStatLabel(charItems, 20, 210, "Deaths: " .. CharStats["PVPDeath"])
        GetStatLabel(charItems, 20, 230, "Highest Daily Killing Blows: " .. CharStats["HighestDailyKBs"])
        GetStatLabel(charItems, 20, 250, "Highest Daily Deaths: " .. CharStats["HighestDailyDeaths"])
        GetStatLabel(charItems, 20, 270, "Highest Killstreak: " .. CharStats["HighestKillStreak"])
        GetStatLabel(charItems, 20, 290, "Highest Multi-Kill: " .. CharStats["HighestKillCombo"])
        GetStatLabel(charItems, 20, 310, "Tracks: " .. CharStats["Tracks"])
    end

    self.CreateAccountStatLabels = function()
        local accItems = Turbine.UI.Control()
        accItems:SetParent(self)
        accItems:SetVisible(true)
        accItems:SetSize( 500, 400 )
        accItems:SetPosition(0, 310)
        accItems:SetMouseVisible(false)


        GetStatLabel(accItems, 20, 30, "Account stats:")
        GetStatLabel(accItems, 20, 50, "Uptime: " .. Round(AccountStats["Time"]/3600, 1) .. "h")
        GetStatLabel(accItems, 20, 70, "Reloads: " .. AccountStats["Reload"])
        GetStatLabel(accItems, 20, 90, "Deaths: " .. AccountStats["Death"])
        GetStatLabel(accItems, 20, 110, "Misadventure Deaths: " .. AccountStats["MisadventureDeaths"])
        GetStatLabel(accItems, 20, 130, "Killing Blows: " .. accKBs)
        GetStatLabel(accItems, 20, 170, "Account PVMP stats: ")
        GetStatLabel(accItems, 20, 190, "Killing Blows: " .. AccountStats["PVPKB"])
        GetStatLabel(accItems, 20, 210, "Deaths: " .. AccountStats["PVPDeath"])
        GetStatLabel(accItems, 20, 230, "Highest Daily Killing Blows: " .. AccountStats["HighestDailyKBs"])
        GetStatLabel(accItems, 20, 250, "Highest Daily Deaths: " .. AccountStats["HighestDailyDeaths"])
        GetStatLabel(accItems, 20, 270, "Highest Killstreak: " .. AccountStats["HighestKillStreak"])
        GetStatLabel(accItems, 20, 290, "Highest Multi-Kill: " .. AccountStats["HighestKillCombo"])
        GetStatLabel(accItems, 20, 310, "Creep Deaths: " .. AccountStats["CreepDeaths"])
        GetStatLabel(accItems, 20, 330, "Creep Killing Blows: " .. AccountStats["CreepKBs"])
        GetStatLabel(accItems, 20, 350, "Freep Deaths: " .. AccountStats["FreepDeaths"])
        GetStatLabel(accItems, 20, 370, "Freep Killing Blows: " .. AccountStats["FreepKBs"])
        GetStatLabel(accItems, 20, 390, "Tracks: " .. AccountStats["Tracks"])
    end

    self.CreateCharStatLabels()
    self.CreateAccountStatLabels()

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(250, 35)
    DescriptionLabel:SetText("Character KBs")

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(200, height - 100)
    container:SetPosition(250, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( self )
    containerScrollbar:SetPosition( 450 - 10, 50 )
    containerScrollbar:SetSize( 10, height - 100 )
    container:SetVerticalScrollBar( containerScrollbar )

    local SortedEffects = {}
    for key, value in pairs(CharStats["KB"]) do table.insert( SortedEffects, key ) end
    table.sort( SortedEffects )

    for _, value in pairs(SortedEffects) do
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 200, 15 )
        listItem:SetMouseVisible(true)
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 15)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        NameLabel:SetMultiline(false)
        NameLabel:SetTop(2)
        NameLabel:SetText(CharStats["KB"][value] .. " - " .. value)
    
        container:AddItem( listItem )
    end

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(450, 35)
    DescriptionLabel:SetText("Account KBs")

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(200, height - 100)
    container:SetPosition(450, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( self )
    containerScrollbar:SetPosition( 650 - 10, 50 )
    containerScrollbar:SetSize( 10, height - 100 )
    container:SetVerticalScrollBar( containerScrollbar )

    local SortedEffects = {}
    for key, value in pairs(AccountStats["KB"]) do 
        if value ~= 0 then
            table.insert( SortedEffects, key ) 
        else
            AccountStats["KB"][key] = nil
        end
    end
    table.sort( SortedEffects )

    for _, value in pairs(SortedEffects) do
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 200, 15 )
        listItem:SetMouseVisible(true)
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 15)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        NameLabel:SetMultiline(false)
        NameLabel:SetTop(2)
        NameLabel:SetText(AccountStats["KB"][value] .. " - " .. value)
    
        container:AddItem( listItem )
    end

    -- Char Deahts

    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(650, 35)
    DescriptionLabel:SetText("Character Deaths")

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(200, height - 100)
    container:SetPosition(650, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( self )
    containerScrollbar:SetPosition( 850 - 10, 50 )
    containerScrollbar:SetSize( 10, height - 100 )
    container:SetVerticalScrollBar( containerScrollbar )

    local SortedEffects = {}
    for key, value in pairs(CharStats["KilledBy"]) do table.insert( SortedEffects, key ) end
    table.sort( SortedEffects )

    for _, value in pairs(SortedEffects) do
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 200, 15 )
        listItem:SetMouseVisible(true)
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 15)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        NameLabel:SetMultiline(false)
        NameLabel:SetTop(2)
        NameLabel:SetText(CharStats["KilledBy"][value] .. " - " .. value)
    
        container:AddItem( listItem )
    end

    --Char Deaths
    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(self)
    DescriptionLabel:SetSize(200, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(850, 35)
    DescriptionLabel:SetText("Account Deaths")

    local container = Turbine.UI.ListBox()
    container:SetParent(self)
    container:SetSize(200, height - 100)
    container:SetPosition(850, 50)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar()
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    containerScrollbar:SetParent( self )
    containerScrollbar:SetPosition( 1050 - 10, 50 )
    containerScrollbar:SetSize( 10, height - 100 )
    container:SetVerticalScrollBar( containerScrollbar )

    local SortedEffects = {}
    for key, value in pairs(AccountStats["KilledBy"]) do table.insert( SortedEffects, key ) end
    table.sort( SortedEffects )

    for _, value in pairs(SortedEffects) do
        local listItem = Turbine.UI.Control()
        listItem:SetVisible(true)
        listItem:SetSize( 200, 15 )
        listItem:SetMouseVisible(true)
    
        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(listItem)
        NameLabel:SetSize(200, 15)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetMouseVisible(false)
        NameLabel:SetMultiline(false)
        NameLabel:SetTop(2)
        NameLabel:SetText(AccountStats["KilledBy"][value] .. " - " .. value)
    
        container:AddItem(listItem)
    end
end

function GetStatLabel(parent, x, y, text)
    local DescriptionLabel = Turbine.UI.Label()
    DescriptionLabel:SetParent(parent)
    DescriptionLabel:SetSize(250, 15)
    DescriptionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DescriptionLabel:SetMouseVisible(false)
    --NameLabel:SetMultiline(false)
    DescriptionLabel:SetPosition(x, y)
    DescriptionLabel:SetText(text) 
end
