SwapWeapons = LoadTable(Turbine.DataScope.Character, "PrimeSwapData")

SwapWarner = class(Turbine.UI.Window)
function SwapWarner:Constructor()
    local width = 750
    local height = 125
    local x = math.floor(Turbine.UI.Display.GetWidth() / 2 - (width/2))
    local y = math.floor(Turbine.UI.Display.GetHeight() / 3 + 100)
    Turbine.UI.Window.Constructor(self)
    self:SetSize(width, height)
    self:SetPosition(x, y)
    self:SetZOrder(1)

    local Scale = Settings.Scale

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.equipment = self.player:GetEquipment()
    self.callback = {}
  
    self:SetWantsKeyEvents(false)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetBackColor(GetRandomColour())
    --self:SetWantsUpdates(true)
    --self:SetOpacity(0.3)

    self.SwapCount = 0

    self.SwapWeapons = SwapWeapons

    if Settings.SwapToken == 1 then
        SwapWeapons = {}
        self.SwapWeapons = {}
        Settings.SwapToken = 999999
    end

    if self.SwapWeapons == nil then
        self.SwapWeapons = {}
    end

    self.SwapWindows = {}

    self.messageBox = Turbine.UI.Label()
    self.messageBox:SetParent(self)
    self.messageBox:SetSize(width,height)
    self.messageBox:SetPosition(0,0)
    self.messageBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.messageBox:SetFont(Settings.EFont)
    self.messageBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.messageBox:SetVisible(false)
    self.messageBox:SetMarkupEnabled(true)
    self.messageBox:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.messageBox:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.messageBox:SetMouseVisible(false)
    self.messageBox:SetText("Swap equipped!")

    self.MakeSwapWindow = function(key, value)
        local Item = ItemShowCase(true, value[4], value[5])
        Item:SetIcon(value[1])
        Item:SetBackground(value[2])
        self.SwapWindows[key] = {Item, value[3]}
        if value[3] then
            Item:SetVisible(false)
        else
            Item:SetOpacity(0.3)
        end
    end

    self.HandleText = function()
        self.messageBox:SetVisible(self.SwapCount > 0)
    end

    for key, value in pairs(self.SwapWeapons) do
        self.MakeSwapWindow(key, value)
    end

    for i = 1, self.equipment:GetSize(), 1 do
        local item = self.equipment:GetItem(i)
        if item ~= nil then  
            --ChatOutput(item:GetName()) 
            local itemName = item:GetName()     
            if self.SwapWeapons[itemName] then
                if self.SwapWindows[itemName][2] then
                    self.SwapWindows[itemName][1]:SetVisible(true)
                else
                    self.SwapWindows[itemName][1]:SetOpacity(1)
                end
                if self.SwapWeapons[itemName][6] then
                    self.SwapCount = self.SwapCount + 1
                end
            end
        end	          
    end
    self.HandleText()

    if Tablelength(self.SwapWeapons) > 0 then
        self.callback["ItemEquipped"] = AddCallback(self.equipment, "ItemEquipped", function(sender, args)
            --self:SetVisible(true)
            local item = self.equipment:GetItem(args.Index)
            if item ~= nil then 
                local itemName = item:GetName()
                if self.SwapWindows[itemName] then
                    if self.SwapWindows[itemName][2] then
                        self.SwapWindows[itemName][1]:SetVisible(true)
                    else
                        self.SwapWindows[itemName][1]:SetOpacity(1)
                    end
                    if self.SwapWeapons[itemName][6] then
                        self.SwapCount = self.SwapCount + 1
                    end
                end
            end	
            self.HandleText()
        end)

        self.callback["ItemUnequipped"] = AddCallback(self.equipment, "ItemUnequipped", function(sender, args)
            --self:SetVisible(false)
            local item = self.equipment:GetItem(args.Index)
            if item ~= nil then    
                local itemName = item:GetName()    
                if self.SwapWindows[itemName] then
                    if self.SwapWindows[itemName][2] then
                        self.SwapWindows[itemName][1]:SetVisible(false)
                    else
                        self.SwapWindows[itemName][1]:SetOpacity(0.3)
                    end
                    if self.SwapWeapons[itemName][6] then
                        self.SwapCount = self.SwapCount - 1
                    end
                end
            end	
            self.HandleText()
        end)
    end

    self.SaveData = function()
        self:GetPositions()
        SaveTable(Turbine.DataScope.Character, "PrimeSwapData", self.SwapWeapons)
    end

    self.ListEquipment = function()
        self.equipment = self.player:GetEquipment()
        for i = 1, self.equipment:GetSize(), 1 do
            local item = self.equipment:GetItem(i)
            if item ~= nil then  
                ChatOutput(item:GetName())      
            end	          
        end
    end

    --self:SetVisible(true)
end

function SwapWarner:RemoveCallbacks()
    if tablelength(self.callback) > 0 then
        RemoveCallback(self.equipment, "ItemEquipped", self.callback["ItemEquipped"])
        RemoveCallback(self.equipment, "ItemUnequipped", self.callback["ItemUnequipped"])
    end
end

function SwapWarner:AddSwapWeapon(name, icon, background, hide, text)
    if self.SwapWeapons[name] then
        return false
    else
        self.SwapWeapons[name] = {icon, background, hide, 0, 0, text}
        SwapWeapons[name] = {icon, background, hide, 0, 0, text}
        self.MakeSwapWindow(name, {icon, background, hide, 0, 0, text})
        ChatOutput("Added swap: " .. name)
        return true
    end
end

function SwapWarner:PrintSwaps()
    ChatOutput("<rgb=#0071b8>Swap Data for " .. self.player:GetName())
    for key, value in pairs(self.SwapWeapons) do
        ChatOutput("<rgb=#004d00>".. key .. " Icon: " .. value[1] .. " Background: " .. value[2])-- .. " X: " .. x .. " Y:" .. y)
    end
end

function SwapWarner:RemoveSwapWeapon(name)
    self.SwapWindows[name][1]:SetVisible(false)
    self.SwapWindows[name][1]:SetParent(nil)
    self.SwapWindows[name] = nil
    self.SwapWeapons[name] = nil
    ChatOutput("Removed swap: " .. name)
end

function SwapWarner:GetPositions()
    for key, value in pairs(self.SwapWindows) do
        self.SwapWeapons[key][4] = value[1]:GetLeft()
        self.SwapWeapons[key][5] = value[1]:GetTop()
    end
end

function SwapWarner:MoveWindow(name)
    self.SwapWindows[name][1]:ToggleMove()
    local x, y = self.SwapWindows[name][1]:GetPosition()
    local tempItem = self.SwapWeapons[name]
    self.SwapWeapons[name] = { tempItem[1], tempItem[2], tempItem[3], x, y, tempItem[6] }
end

function SwapWarner:MoveAll()
    for key, value in pairs(self.SwapWindows) do
        self:MoveWindow(key)
    end
end

function SwapWarner:AddNewWindow(key, value)
    self.MakeSwapWindow(key, value)
end

function SwapWarner:SetWindowVisible(name)
    self.SwapWindows[name][1]:SetVisible(true)
end

ItemShowCase = class(Turbine.UI.Window)
function ItemShowCase:Constructor(parent, x, y, scale)
    local width = 32
    local height = 32
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Window.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    if parent ~= true then
        self:SetParent(parent)
    end
    self:SetPosition(x,y)
    self:SetVisible(true)

    self.Background = nil
    self.Icon = nil

    if scale then
        self.scale = scale
    else
        self.scale = Settings.SwapScale
    end

    self.Visible = nil

    self.BackgroundLabel = Turbine.UI.Label()
    self.BackgroundLabel:SetParent(self)
    self.BackgroundLabel:SetSize(32, 32)
    self.BackgroundLabel:SetStretchMode(1)
    --BackgroundLabel:SetBackground()

    self.IconLabel = Turbine.UI.Label()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(32, 32)
    self.IconLabel:SetStretchMode(1)
    --self.IconLabel:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    --self.IconLabel:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    --ShowLabel:SetBackground()

    self.moveBox = MoveBox(self, width, height, "")
end

function ItemShowCase:SetBoth(background, icon)
    self:SetBackground(background)
    self:SetIcon(icon)

    --ChatOutput(background)
    --ChatOutput(icon)
end

function ItemShowCase:SetBackground(background)
    self.Background = background
    self.BackgroundLabel:SetBackground(background)
    self.BackgroundLabel:SetSize(32 * self.scale, 32 * self.scale)
    
end

function ItemShowCase:SetIcon(icon)
    self.Icon = icon
    self.IconLabel:SetBackground(icon)
    self.IconLabel:SetSize(32 * self.scale, 32 * self.scale)
end

function ItemShowCase:GetIcon()
    return(self.Icon)
end

function ItemShowCase:GetBackground()
    return(self.Background)
end

function ItemShowCase:ToggleMove()
    self.moveBox:ToggleMove()
end

--[[
Backgrounds = {
    ["3rd age"] = 1091472970,
    ["1st age"] = 1091472984,
    ["Teal"] = 1090519044,
    ["Purple"] = 1090519043,
    --["Store"] = 1091424047,
    ["Gray"] = 1090519041,
    ["Green"] = 1090519042,
    ["Gold"] = 1090519045,
    ["Furniture"] = 1091424047,
    ["Normal"] = 1090531524,
    ["Cosmetic"] = 1091424691,
    ["Store"] = 1091591349,

}
]]
