function SetEffects()
    local TargetWindowEffects = {  
        -- Test
        --["Defiant Challenge"] = "Test message",
        --["Conviction"] = "Test message",
        --["In the Fray"] = true,
        --["Assailment"] = true,
        --["Man-form"] = true,
        --["Hearten"] = true,
        --["Blood of Fire"] = true,
        --["Mending Verse"] = true,
        --
        -- Shelob
        ["Pained Determination"] = true,
        --["Wilful Determination"] = "Phial",
    
        -- Thossulun
        ["Penetrated Shell"] = true,
    
        -- Shadowed King
        ["Shadow's Protection"] = true,
        ["Crushed"] = true,
    
        -- Rift
        ["Vulnerable"] = true,
    
        -- DN
        ["Vigor"] = true,
        ["Frenzy"] = true,
    
        -- Class Freep
        ["Ancient Craft"] = true,
        ["Oathbreaker's Shame"] = true,
        ["Oaths Fulfilled"] = true,
        ["Grievous Wounds"] = true,
        ["Moving Target"] = true,
        ["Field Promotion"] = true,
        ["Knives Out"] = true,
        ["Shield of the Dúnedain"] = true,
        ["Last Stand"] = true,
        ["Our Fates Entwined"] = true,
        ["Subtle Stab"] = true,
        ["Do Not Fall This Day"] = true,
        ["Clinging Webs"] = true,
        ["Entangling Web"] = true,
        ["Venomous Haze"] = true,
        ["Essence of Winter"] = true,
    
        -- Class Creep
        ["Toxic Carapace"] = true,
        ["Sprint"] = true,
        ["Blight"] = true,
        ["Festering Wound"] = true,
        ["Blessing of Darkness"] = true,
        --["Blinding Dust"] = true,
        ["Sundering Blow"] = true,
        ["Hamstrung"] = true,
        ["Blade Toss"] = true,
        ["Devastating Strike"] = true,
    
    
        -- CC immunities
        ["Daze and Stun Immunity"] = true,
        ["Root Immunity"] = true,
        ["Fear Immunity"] = true,
        ["Immunity"] = true,
        ["Temporary State Immunity"] = true,
        ["Continuous Blood Rage"] = true,
        ["Juggernaut"] = true,
        ["Tactically Sound"] = true,
    
        --PVP Server
        ["Invulnerable"] = true,
        --["Fire"]
    
        -- Hiddenhoard
        ["Guardian's Defiance"] = true,
        ["Retaliation"] = true,
    }

    local Player = Turbine.Gameplay.LocalPlayer.GetInstance()
    local PlayerClass = Player:GetClass() 
    -- Freeps
    if PlayerClass == Turbine.Gameplay.Class.Beorning then
        TargetWindowEffects["Defensive Blow"] = true
        TargetWindowEffects["Debilitating Bees"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.Burglar then
        TargetWindowEffects["Reveal Weakness"] = true 
    elseif PlayerClass == Turbine.Gameplay.Class.Captain then
        TargetWindowEffects["Armour Rend"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.Guardian then
        TargetWindowEffects["Fire-lore"] = true
        TargetWindowEffects["Frost-lore"] = true
        --TargetWindowEffects["Disable"]
    elseif PlayerClass == Turbine.Gameplay.Class.LoreMaster then
        TargetWindowEffects["Fire-lore"] = true
        TargetWindowEffects["Frost-lore"] = true
        TargetWindowEffects["Shatter Arms"] = true
        TargetWindowEffects["Ranged Critical Chance"] = true
        TargetWindowEffects["Nature's Light"] = true
        TargetWindowEffects["Benediction of the Raven"] = true
        TargetWindowEffects["Charged Air"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.RuneKeeper then
        TargetWindowEffects["Writ of Lightning"] = true
    elseif PlayerClass == Turbine.Gameplay.Class.Warden then
        TargetWindowEffects["Low Bleed - Quick Sweep"] = true
        TargetWindowEffects["Medium Bleed - Quick Sweep"] = true
        TargetWindowEffects["Marked Target"] = true
        TargetWindowEffects["Diminished Target"] = true
        TargetWindowEffects["Hampering Javelin"] = true
    -- Creeps
    elseif PlayerClass == Turbine.Gameplay.Class.BlackArrow then
        TargetWindowEffects["Hindering Shot"] = true
    end

    local StackingTargetEffects = {
        -- Rukhor
        ["Blood-Infused - "] = 10,
        ["Blood Drain - "] = 10,
        -- Shelob
        ["Impenetrable Webs - "] = 120,
        -- Guruthang of the Queensbrood.
        ["Elusive - "] = 5,
        --["Coward's Fate "] = 5,
    
        -- Bukky
        ["Warlord's Wrath - "] = 10,
    }
    
    for key, value in pairs(StackingTargetEffects) do
        for i = 1, value do 
            TargetWindowEffects[key .. i] = true
        end
    end
    
    local RemovedBasicEffects = LoadTable(Turbine.DataScope.Character, "PrimeRemovedTargetEffects")
    local AddedCharEffects = LoadTable(Turbine.DataScope.Character, "PrimeAddedTargetEffects")
    
    if AddedCharEffects ~= nil then
        for key, _ in pairs(AddedCharEffects) do
            TargetWindowEffects[key] = true
        end
    else
        AddedCharEffects = {}
    end
    
    if RemovedBasicEffects ~= nil then
        for key, _ in pairs(RemovedBasicEffects) do
            TargetWindowEffects[key] = nil
        end
    else
        RemovedBasicEffects = {}
    end

    return TargetWindowEffects
end