TargetWindowOptionsNew = class(Turbine.UI.Control)
function TargetWindowOptionsNew:Constructor(parent)
    local width = Settings.LOWidth
    local height = 550
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width,height)
    self:SetPosition(0, 0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local optionsHeight = 0
    local listboxHeight = height - 20 - 50

    self.effectNameBox = Turbine.UI.Lotro.TextBox()
    self.effectNameBox:SetParent(self)
    self.effectNameBox:SetSize(300, 20)
    self.effectNameBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.effectNameBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.effectNameBox:SetMouseVisible(false)
    self.effectNameBox:SetPosition(0, optionsHeight)
    self.effectNameBox:SetMultiline(false)
    self.effectNameBox:SetText("Effect Name")
    
    self.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    self.addTriggerEntryButton:SetParent(self)
    self.addTriggerEntryButton:SetSize(100, 20)
    self.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.addTriggerEntryButton:SetPosition(300, optionsHeight)
    self.addTriggerEntryButton:SetText("Add")

    self.addTriggerEntryButton.Click = function()
        self.AddListboxItem(self.effectNameBox:GetText())
        Settings.NewTargetWindowEffects[self.effectNameBox:GetText()] = true
    end

    self.effectBrowseButton = Turbine.UI.Lotro.Button()
    self.effectBrowseButton:SetParent(self)
    self.effectBrowseButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.effectBrowseButton:SetPosition(400, optionsHeight)
    self.effectBrowseButton:SetText("Browse Encountered Effects")
    self.effectBrowseButton:SetSize(500, 20)

    self.effectBrowseButton.Click = function()
        if not(self.effectWindow) then self.effectWindow = ClassSpecificTools.HistoricalEffectOverview() end
        self.effectWindow:SetVisible(true) 
        self.effectWindow:Register(self.effectNameBox)
    end

    optionsHeight = optionsHeight + 25

    self.listbox = Turbine.UI.ListBox()
    self.listbox:SetParent(self)
    self.listbox:SetSize(300, listboxHeight)
    self.listbox:SetPosition(0, 20)
    self.listbox:SetBackColor(Turbine.UI.Color.Gold)

    self.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    self.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.Scrollbar:SetParent(self)
    self.Scrollbar:SetPosition(300, 20)
    self.Scrollbar:SetSize(10, listboxHeight)
    self.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    self.listbox:SetVerticalScrollBar(self.Scrollbar)

    self.AddListboxItem = function(effectName)
        local listBoxItem = Turbine.UI.Control()
        listBoxItem:SetSize(300, 20)
        listBoxItem:SetBackColor(Turbine.UI.Color.Black)

        listBoxItem.innerBox = Turbine.UI.Control()
        listBoxItem.innerBox:SetParent(listBoxItem)
        listBoxItem.innerBox:SetSize(300 - 2, 20 - 2)
        listBoxItem.innerBox:SetPosition(1, 1)
        listBoxItem.innerBox:SetBackColor(Turbine.UI.Color.DarkSlateGray)

        listBoxItem.effectLabel = Turbine.UI.Label()
        listBoxItem.effectLabel:SetParent(listBoxItem.innerBox)
        listBoxItem.effectLabel:SetSize(300 - 2 - 50, 20 - 2)
        listBoxItem.effectLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
        listBoxItem.effectLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        listBoxItem.effectLabel:SetOutlineColor(Turbine.UI.Color.Black)
        listBoxItem.effectLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        listBoxItem.effectLabel:SetText(effectName)

        listBoxItem.removeButton = Turbine.UI.Control()
        listBoxItem.removeButton:SetParent(listBoxItem.innerBox)
        listBoxItem.removeButton:SetSize(14, 14)
        listBoxItem.removeButton:SetPosition(300 - 1 - 14, 3)
        listBoxItem.removeButton:SetBackground(BackgroundHandler:GetBackground(0x41005F0A))
        listBoxItem.removeButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
        listBoxItem.removeButton.MouseClick = function()
            self.listbox:RemoveItem(listBoxItem)
            Settings.NewTargetWindowEffects[effectName] = nil
        end
        self.listbox:AddItem(listBoxItem)
    end

    if Settings.NewTargetWindowEffects then
        for key, value in spairs(Settings.NewTargetWindowEffects, function(t, a, b) return a < b end) do
            self.AddListboxItem(key)
        end
    end

    self.toggleBox = Turbine.UI.Lotro.CheckBox()
    self.toggleBox:SetParent(self)
    self.toggleBox:SetPosition(320 , 50)
    self.toggleBox:SetSize(300, 20)
    self.toggleBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.toggleBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.toggleBox:SetOutlineColor(Turbine.UI.Color.Black)
    self.toggleBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.toggleBox:SetChecked(Settings.TEnabled)
    self.toggleBox:SetText("Targetwindow Enabled")
    self.toggleBox:SetVisible(true)

    self.toggleBox.CheckedChanged = function(sender,args)
        Settings.TEnabled = self.toggleBox:IsChecked()
    end

    self.effectTrackingBox = Turbine.UI.Lotro.CheckBox()
    self.effectTrackingBox:SetParent(self)
    self.effectTrackingBox:SetPosition(320, 70)
    self.effectTrackingBox:SetSize(300, 20)
    self.effectTrackingBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.effectTrackingBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.effectTrackingBox:SetOutlineColor(Turbine.UI.Color.Black)
    self.effectTrackingBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.effectTrackingBox:SetChecked(Settings.TEffects)
    self.effectTrackingBox:SetText("Effect Tracking")
    self.effectTrackingBox:SetVisible(true)

    self.effectTrackingBox.CheckedChanged = function(sender,args)
        Settings.TEffects = self.effectTrackingBox:IsChecked()
    end

    self.allEffectTrackingBox = Turbine.UI.Lotro.CheckBox()
    self.allEffectTrackingBox:SetParent(self)
    self.allEffectTrackingBox:SetPosition(320 , 90)
    self.allEffectTrackingBox:SetSize(300, 20)
    self.allEffectTrackingBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.allEffectTrackingBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.allEffectTrackingBox:SetOutlineColor(Turbine.UI.Color.Black)
    self.allEffectTrackingBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.allEffectTrackingBox:SetChecked(Settings.TShowAll)
    self.allEffectTrackingBox:SetText("Track All Effects")
    self.allEffectTrackingBox:SetVisible(true)

    self.allEffectTrackingBox.CheckedChanged = function(sender,args)
        Settings.TShowAll = self.allEffectTrackingBox:IsChecked()
    end

    self.oldWindowBox = Turbine.UI.Lotro.CheckBox()
    self.oldWindowBox:SetParent(self)
    self.oldWindowBox:SetPosition(320 , 110)
    self.oldWindowBox:SetSize(300, 20)
    self.oldWindowBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.oldWindowBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.oldWindowBox:SetOutlineColor(Turbine.UI.Color.Black)
    self.oldWindowBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.oldWindowBox:SetChecked(Settings.TargetEffectsOld)
    self.oldWindowBox:SetText("Use Old TargetWindow")
    self.oldWindowBox:SetVisible(true)

    self.oldWindowBox.CheckedChanged = function(sender,args)
        Settings.TargetEffectsOld = self.oldWindowBox:IsChecked()
    end

    self.widtTextBox = Turbine.UI.Lotro.TextBox()
    self.widtTextBox:SetParent(self)
    self.widtTextBox:SetPosition(320 , 130)
    self.widtTextBox:SetSize(100, 20)
    self.widtTextBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.widtTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.widtTextBox:SetOutlineColor(Turbine.UI.Color.Black)
    self.widtTextBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.widtTextBox:SetText(Settings.TWidth)
    self.widtTextBox:SetVisible(true)

    self.widthButton = Turbine.UI.Lotro.Button()
    self.widthButton:SetParent(self)
    self.widthButton:SetSize(100, 20)
    self.widthButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.widthButton:SetPosition(420, 130)
    self.widthButton:SetText("Set Width")

    self.widthButton.Click = function()
        Settings.TWidth = tonumber(self.widtTextBox:GetText()) or Settings.TWidth
        ChatOutput("Set width to: " .. (tonumber(self.widtTextBox:GetText()) or Settings.TWidth) .. ". Changes will appear on reload!")
    end
end