
-- Boss cds
BossTimerSettings = class(Turbine.UI.Control)
function BossTimerSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    local height = 0

    -- SkillCounter (Enemies)
    local SkillCounterLabel = GetLabelUI(self, "Timer Settings:", height)

    local SkillCounterTestButton = Turbine.UI.Lotro.Button()
    SkillCounterTestButton:SetParent(self)
    SkillCounterTestButton:SetPosition(220, height)
    SkillCounterTestButton:SetSize(100,15)
    SkillCounterTestButton:SetText("Test timer")
    SkillCounterTestButton:SetVisible(true)

    SkillCounterTestButton.Click = function()
        local skillCounters = EventWindows:GetTimerWindow()
        if skillCounters then
            skillCounters:NewTimer(math.random(10, 50), "Test")
        end
    end

    local FontMenuSkillCounter = GetFontMenu(self, height + 130, FontsLUTR[Settings.SNewFont]) 
    for i = 1, FontMenuSkillCounter.menuItems:GetCount() do
        local menuItem = FontMenuSkillCounter.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.SNewFont = FontsLUT[sender:GetText()]
            MasterOptions:ChangesMade()
        end
    end

    local WidthBackground = Turbine.UI.Control()
    WidthBackground:SetParent(self)
    WidthBackground:SetPosition(20, 330)
    WidthBackground:SetSize(300, 200)
    WidthBackground:SetMouseVisible(false)
    WidthBackground:SetVisible(true)
    --WidthBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local timerBox = Turbine.UI.Lotro.TextBox()
    timerBox:SetParent(WidthBackground)
    timerBox:SetSize(50, 20)
    timerBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    timerBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    timerBox:SetPosition(15, 0)
    timerBox:SetText(Settings.SNewWidth)
    
    self.colourScheme = {Turbine.UI.Color(0.8,0,0,0), Turbine.UI.Color(0.8,0,0,0), Turbine.UI.Color(0,0.5,0), Turbine.UI.Color(1,1,1), Turbine.UI.Color(0,0,0), Turbine.UI.Color(0.6,0.5,0,0), Settings.BossTimersFrontTexture, Settings.BossTimersBackTexture, Settings.BossTimersFrontOpacity, Settings.BossTimersBackOpacity}
    self.ExampleTimer = EffectTimer(WidthBackground, Settings.SPWidth2, 20, nil, "Test",  Settings.SPNewFont, self.colourScheme, true, nil, 20, 0x411172A2)
    self.ExampleTimer:SetPosition(130, 60)
    self.duration = 20

    self.ExecuteUpdate = function(delta)
        self.duration = self.duration - delta
    
        if self.duration < 2 then 
            self.duration = 20 
            self.ExampleTimer:ChangeDuration(self.duration)
        end
        self.ExampleTimer:UpdateText(delta)
    end

    self.callback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate)


    local sizeButton = Turbine.UI.Lotro.Button()
    sizeButton:SetParent(WidthBackground)
    sizeButton:SetSize(80, 20)
    sizeButton:SetPosition(5, 20)
    sizeButton:SetText("Set Width") 

    sizeButton.Click = function()
        Settings.SNewWidth = tonumber(timerBox:GetText())
        ChatOutput("Changed skill timer width to " .. tonumber(timerBox:GetText()))
    end

    local opacityBox = Turbine.UI.Lotro.TextBox()
    opacityBox:SetParent(WidthBackground)
    opacityBox:SetSize(50, 20)
    opacityBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    opacityBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    opacityBox:SetPosition(105, 0)
    opacityBox:SetText(Settings.BossTimersFrontOpacity)

    local opacityButton = Turbine.UI.Lotro.Button()
    opacityButton:SetParent(WidthBackground)
    opacityButton:SetSize(120, 20)
    opacityButton:SetPosition(90, 20)
    opacityButton:SetText("Set Front Opacity") 

    opacityButton.Click = function()
        Settings.BossTimersFrontOpacity = tonumber(opacityBox:GetText())
        ChatOutput("Changed skill timer bar opacity to " .. tonumber(opacityBox:GetText()))
        self.ExampleTimer:ChangeFrontOpacity(Settings.BossTimersFrontOpacity)
    end

    local opacityBackBox = Turbine.UI.Lotro.TextBox()
    opacityBackBox:SetParent(WidthBackground)
    opacityBackBox:SetSize(50, 20)
    opacityBackBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    opacityBackBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    opacityBackBox:SetPosition(15, 40)
    opacityBackBox:SetText(Settings.BossTimersBackOpacity)

    local opacityButtonBack = Turbine.UI.Lotro.Button()
    opacityButtonBack:SetParent(WidthBackground)
    opacityButtonBack:SetSize(120, 20)
    opacityButtonBack:SetPosition(0, 60)
    opacityButtonBack:SetText("Set Back Opacity") 

    opacityButtonBack.Click = function()
        Settings.BossTimersBackOpacity = tonumber(opacityBackBox:GetText())
        ChatOutput("Changed skill timer bar back opacity to " .. tonumber(opacityBackBox:GetText()))
        self.ExampleTimer:ChangeBackOpacity(Settings.BossTimersBackOpacity)
    end

    local frontbutton = Turbine.UI.Lotro.Button()
    frontbutton:SetParent(WidthBackground)
    frontbutton:SetPosition(0, 80)
    frontbutton:SetSize(150,15)
    frontbutton:SetText("Timer Texture")
    frontbutton:SetVisible(true)

    -- [[
    local sortedNames1 = {}
    for key, value in pairs(BackgroundHandler:GetBarTextureData()) do table.insert( sortedNames1, key ) end
    table.sort( sortedNames1 )
    
    self.frontmenu = Turbine.UI.ContextMenu()
    self.frontmenuItems = self.frontmenu:GetItems()

    self.frontBar = nil

    for key, value in pairs(sortedNames1) do
        local frontmenuItem = Turbine.UI.MenuItem( value )
        frontmenuItem.Click = function()
            self.frontBar = value
            Settings.BossTimersFrontTexture = self.frontBar 
            self.ExampleTimer:ChangeFrontTexture(Settings.BossTimersFrontTexture)
        end
        self.frontmenuItems:Add(frontmenuItem)
    end

    local frontmenuItemNil = Turbine.UI.MenuItem( "None" )
    frontmenuItemNil.Click = function()
        Settings.BossTimersFrontTexture = nil
        self.ExampleTimer:ChangeFrontTexture(Settings.BossTimersFrontTexture)
    end
    self.frontmenuItems:Add(frontmenuItemNil)
        --]]




    frontbutton.Click = function()
        self.frontmenu:ShowMenu()
    end

    local backbutton = Turbine.UI.Lotro.Button()
    backbutton:SetParent(WidthBackground)
    backbutton:SetPosition(0, 100)
    backbutton:SetSize(150,15)
    backbutton:SetText("Background Texture")
    backbutton:SetVisible(true)


    self.backbar = nil
    -- [[
    self.backmenu = Turbine.UI.ContextMenu()
    self.backmenuItems = self.backmenu:GetItems()

    local sortedNames2 = {}
    for key, value in pairs(BackgroundHandler:GetBarTextureData()) do table.insert( sortedNames2, key ) end
    table.sort( sortedNames2 )

    for key, value in pairs(sortedNames2) do
        local backmenuItem = Turbine.UI.MenuItem( value )
        backmenuItem.Click = function()
            self.backbar = value
            Settings.BossTimersBackTexture = self.backbar
            self.ExampleTimer:ChangeBackTexture(Settings.BossTimersBackTexture)
        end
        self.backmenuItems:Add(backmenuItem)
    end
    local backmenuItemNil = Turbine.UI.MenuItem( "None" )
    backmenuItemNil.Click = function()
        Settings.BossTimersBackTexture = nil
        self.ExampleTimer:ChangeBackTexture(Settings.BossTimersBackTexture)
    end
    self.backmenuItems:Add(backmenuItemNil)
        --]]

    backbutton.Click = function()
        self.backmenu:ShowMenu()
    end
end