CombatWindow = class(Turbine.UI.Window)
function CombatWindow:Constructor(reloadData)
    Turbine.UI.Window.Constructor(self)

    self.width = Settings.CTWidth
    local height = Settings.CTHeight
    local x = Settings.CTX
    local y = Settings.CTY
    local cooldownTimer = 0
    self.combat = nil

    self.CombatStartTime = 0
    self.CombatDrop = 0

    self.RaidMode = false
    self:SetRotation(0.4)

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.callback = {}

    self.onlyInCombat = Settings.CTInCombat

    self:SetSize(self.width,height)
    self:SetPosition(x,y)
    --self:SetZOrder(1)

    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(false)
    self:SetVisible(true)

    self.combatWindow = Turbine.UI.Label()
    self.combatWindow:SetParent(self)
    self.combatWindow:SetSize(self.width, 40)
    self.combatWindow:SetPosition(0, height - 40)
    self.combatWindow:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter)
    --1107296276
    --Turbine.UI.Lotro.Font.TrajanProBold36
    self.combatWindow:SetFont(Settings.CTFont)
    self.combatWindow:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.combatWindow:SetMouseVisible(false)
    self.combatWindow:SetText("0:00")
    self.combatWindow:SetVisible(true)
    --self.combatWindow:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.combatWindow:SetMouseVisible(false)

    self.oldCombatWindowWindow = Turbine.UI.Window()
    self.oldCombatWindowWindow:SetParent(self)
    self.oldCombatWindowWindow:SetSize(self.width, height - 40)
    self.oldCombatWindowWindow:SetPosition(0, 0)
    self.oldCombatWindowWindow:SetOpacity(0.5)
    --self.oldCombatWindowWindow:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    self.oldCombatWindowWindow:SetVisible(true)
    self.oldCombatWindowWindow:SetMouseVisible(false)

    self.oldCombatWindow = Turbine.UI.ListBox()
    self.oldCombatWindow:SetParent(self.oldCombatWindowWindow)
    self.oldCombatWindow:SetSize(self.width, height - 40)
    self.oldCombatWindow:SetPosition(0, 0)
    --self.oldCombatWindow:SetReverseFill(true)
    self.oldCombatWindow:SetVisible(true)
    self.oldCombatWindow:SetMouseVisible(false)

    self.scrollbar = Turbine.UI.Lotro.ScrollBar()
    self.scrollbar:SetParent(self)
    self.scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.scrollbar:SetSize(12,height - 40)
    --self.scrollbar:SetPosition(self.messageBox:GetLeft() + self.messageBox:GetWidth(),self.messageBox:GetTop())
    self.scrollbar:SetPosition(self.width - 12, 0)
    self.scrollbar:SetVisible(false)
    self.oldCombatWindow:SetVerticalScrollBar(self.scrollbar)

    self.oldCombatWindow:SetOpacity(0)   
    self.oldCombatWindowWindow:SetOpacity(0) 

    self.combatWindow.MouseEnter = function()
        self.oldCombatWindow:SetOpacity(1)
        self.oldCombatWindowWindow:SetOpacity(1)
    end

    self.combatWindow.MouseLeave = function()
        self.oldCombatWindow:SetOpacity(0)   
        self.oldCombatWindowWindow:SetOpacity(0) 
    end
  
    local moveBox = MoveBox(self, self.width, height, "Combat Timer")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    if self.onlyInCombat then
        self:SetVisible(self.player:IsInCombat())
    end

    self.CombatChanged = function()
        if self.player:IsInCombat() then
            self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate)
        elseif not(self.RaidMode) and not(self.fightStatus)  then
            if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
            self.updateCallback = nil
        end

        if self.onlyInCombat then
            self:SetVisible(self.player:IsInCombat())
        end

        if self.RaidMode then return end
        if self.player:IsInCombat() then
            if Turbine.Engine.GetGameTime() - self.CombatDrop > 1 then 
                self.CombatStartTime = Turbine.Engine.GetGameTime()
            end
        else
            self.CombatDrop = Turbine.Engine.GetGameTime()
        end
    end

    self.callback["InCombatChanged"] = AddCallback(self.player, "InCombatChanged", function()
        self.CombatChanged()
    end)

    self.fightStatus = false

    if self.RaidMode then
        self.fightEventStartCallbacks = AddCallback(InstanceController, "FightEventStart", function(args)
            self.fightStatus = true

        end)

        self.fightEventEndCallbacks = AddCallback(InstanceController, "FightEventEnd", function(args)
            self.fightStatus = false
            if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
            self.updateCallback = nil
        end)
    end

    self.ExecuteUpdate = function()
        self.combatWindow:SetText(self:FormatString(Turbine.Engine.GetGameTime() - self.CombatStartTime))
    end

    if self.player:IsInCombat() then
        self.CombatStartTime = Turbine.Engine.GetGameTime()
        self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate)
    end

    if reloadData.CombatTimer then
        self.CombatStartTime = reloadData.CombatTimer
    end
end

function CombatWindow:RemoveCallbacks()
    RemoveCallback(self.player, "InCombatChanged", self.callback["InCombatChanged"])
    if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end
end

function CombatWindow:ChangeMode(mode)
    if Settings.CTOverride then
        self.CombatStartTime = Turbine.Engine.GetGameTime()
        self.RaidMode = mode
    end
end

function CombatWindow:GetTime()
    return self.CombatStartTime
end

function CombatWindow:FormatString(time)
    return string.format("%01d:%02d", math.floor(time / 60), math.floor(time % 60))
end
