
-- Combat timer
CombatTimerSettings = class(Turbine.UI.Control)
function CombatTimerSettings:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(10,30)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    local height = 0

    -- Combat timer window
    local CombatTimerLabel = GetLabelUI(self, "Combat timer window Settings:", height)

    local CombatTimerCheckBox = GetCheckUI(self, height + 40, "Combat timer enabled", Settings.CTEnabled)
    CombatTimerCheckBox.cBox.CheckedChanged = function(sender,args)
        Settings.CTEnabled = CombatTimerCheckBox.cBox:IsChecked()
        MasterOptions:ChangesMade()
    end

    local CombatTimerWindowOptions = GetWindowUI(self, " Width| Height", height + 70, Settings.CTWidth, Settings.CTHeight)
    CombatTimerWindowOptions.button.Click = function()
        Settings.CTWidth = CombatTimerWindowOptions.windowX:GetText()
        Settings.CTHeight = CombatTimerWindowOptions.windowY:GetText()
        MasterOptions:ChangesMade()
    end

    local FontMenuCombatTimer = GetFontMenu(self, height + 110, FontsLUTR[Settings.CTFont]) 
    for i = 1, FontMenuCombatTimer.menuItems:GetCount() do
        local menuItem = FontMenuCombatTimer.menuItems:Get(i)

        menuItem.Click = function(sender, args)
            Settings.CTFont = FontsLUT[sender:GetText()]
            MasterOptions:ChangesMade()
        end
    end

    local EffectBox1 = Turbine.UI.Lotro.CheckBox()
    EffectBox1:SetParent(self)
    EffectBox1:SetPosition(50, 400)
    EffectBox1:SetSize(400,20)
    EffectBox1:SetChecked(Settings.CTInCombat)
    EffectBox1:SetText("Only show in combat")
    EffectBox1:SetVisible(true)


    EffectBox1.CheckedChanged = function()
        Settings.CTInCombat = EffectBox1:IsChecked()
        MasterOptions:ChangesMade()
    end
end