AchievementWindow = class(Turbine.UI.Window)
function AchievementWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetPosition(500, 500)
    self:SetMouseVisible(true)
    self:SetBackground("PrimePlugins/RaidTools/Images/AchievementFrame.tga")
    self:SetVisible(true)
    self:SetStretchMode(2)
    self:SetSize(self:GetWidth(), self:GetHeight())

    self.MouseInFrame = false

    self.MouseEnter = function()
        self.MouseInFrame = true
    end

    self.MouseLeave = function()
        self.MouseInFrame = false
    end

    self.numberLabel = Turbine.UI.Label()
    self.numberLabel:SetParent(self)
    self.numberLabel:SetMouseVisible(false)
    self.numberLabel:SetSize(40, 40)
    self.numberLabel:SetPosition(244, 34)
    --self.numberLabel:SetBackColor(Turbine.UI.Color.Black)
    self.numberLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.numberLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.numberLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.numberLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.numberLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18)
    self.numberLabel:SetText("100")

    self.imageFrame = Turbine.UI.Label()
    self.imageFrame:SetParent(self)
    self.imageFrame:SetSize(45, 45)
    self.imageFrame:SetPosition(13, 30)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetSize(170, 40)
    self.textLabel:SetPosition(65, 40)
    --self.textLabel:SetBackColor(Turbine.UI.Color.Black)
    self.textLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua18)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18)
    self.textLabel:SetForeColor(Turbine.UI.Color.PaleGoldenrod)
    self.textLabel:SetText("This is a lot of text to test the achievement")

    self.titleLabel = Turbine.UI.Label()
    self.titleLabel:SetParent(self)
    self.titleLabel:SetMouseVisible(false)
    self.titleLabel:SetSize(180, 20)
    self.titleLabel:SetPosition(65, 24)
    --self.titleLabel:SetBackColor(Turbine.UI.Color.Black)
    self.titleLabel:SetForeColor(Turbine.UI.Color.Gainsboro)
    self.titleLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.titleLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.titleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.titleLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    --self.titleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18)
    self.titleLabel:SetText("Achievement Title")

    self.headerLabel = Turbine.UI.Label()
    self.headerLabel:SetParent(self)
    self.headerLabel:SetSize(180, 20)
    self.headerLabel:SetPosition(60, 2)
    self.headerLabel:SetMouseVisible(false)
    --self.headerLabel:SetBackColor(Turbine.UI.Color.Black)
    self.headerLabel:SetForeColor(Turbine.UI.Color.Gold)
    self.headerLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.headerLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.headerLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.headerLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    --self.headerLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18)
    self.headerLabel:SetText("Achievement Earned")

    self:SetImage("PrimePlugins/RaidTools/Images/Rolo.tga")
end

function AchievementWindow:SetImage(imagePath)
    self.imageFrame:SetStretchMode(nil)
    self.imageFrame:SetBackground(imagePath)
    self.imageFrame:SetStretchMode(2)
    self.imageFrame:SetSize(self.imageFrame:GetWidth(), self.imageFrame:GetHeight())
    self.imageFrame:SetStretchMode(1)
    self.imageFrame:SetSize(45, 45)
end

function AchievementWindow:SetData(imagePath, headerText, titleText, achievementText, points)
    self:SetImage(imagePath or "PrimePlugins/RaidTools/Images/Rolo.tga")
    self.headerLabel:SetText(headerText or "Achievement Earned")
    self.titleLabel:SetText(titleText or "Achievement Title")
    if achievementText then
        if string.len(achievementText) > 50 then
            self.textLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua14)
        else
            self.textLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua18)
        end
    end
    self.textLabel:SetText(achievementText or "This is a lot of text to test the achievement")
    self.numberLabel:SetText(points or "")
end

AchievementListBox = class(Turbine.UI.Window)
function AchievementListBox:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    self:SetSize(307, 1000)
    self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - self:GetWidth() / 2, 20)
    --self:SetBackColor(Turbine.UI.Color.Black)

    self.listBox = Turbine.UI.ListBox()
    self.listBox:SetParent(self)
    self.listBox:SetMouseVisible(false)
    self.listBox:SetVisible(true)
    self.listBox:SetSize(307, 1000)
    --self.listBox:SetBackColor(Turbine.UI.Color.Black)

    self.items = {}
    self.updateCount = 0

    self.updateCallback = function(delta)
        for key, value in pairs(self.items) do
            if not(self.items[key][1].MouseInFrame) then
                self.items[key][2] = self.items[key][2] - delta
                if self.items[key][2] <= 3 then
                    self.items[key][1]:SetOpacity(self.items[key][2] / 3)
                    self.items[key][1].imageFrame:SetOpacity(self.items[key][2] / 3)
                end
                if self.items[key][2] <= 0 then
                    self.listBox:RemoveItem(self.items[key][1])
                    self.items[key][1]:SetParent(nil) 
                    self.items[key] = nil
                    self.updateCount = self.updateCount - 1
                end
            else
                self.items[key][1]:SetOpacity(1)
                self.items[key][1].imageFrame:SetOpacity(1)
            end
        end

        if self.updateCount == 0 then
            RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) 
        end
    end
end

function AchievementListBox:AddItem(imagePath, headerText, titleText, achievementText, points)
    local frame = AchievementWindow()
    frame:SetData(imagePath, headerText, titleText, achievementText, points)
    self.listBox:AddItem(frame)
    table.insert(self.items, {frame, 7})

    if self.updateCount == 0 then
        AddCallback(Updater, "ExecuteUpdate", self.updateCallback)
    end

    self.updateCount = self.updateCount + 1
end