CircleTimer = class(Turbine.UI.Window)
function CircleTimer:Constructor(parent, ringColour, rotationColour, textFont, timerFont, clockwise, showTimer, scale)
    Turbine.UI.Window.Constructor(self)
    self:SetParent(parent)
    self.ringColour = ringColour or Turbine.UI.Color(0.5, 1, 1, 1)
    --self.rotationColour = Turbine.UI.Color(1, 1, 153/255, 0)
    self.rotationColour = rotationColour or Turbine.UI.Color(1, 0, 0.3, 0)
    self.backgroundRingOpacity = 1
    self.rotationRingOpacity = 1
    self.scale = scale or 1

    self.quarterTexture = BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/Ring_10pxhalfquarter.tga")
    self.quarterFullTexture = BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/Ring_10pxhalfquarter.tga")
    self.fullTexture = BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/Ring_10pxhalf.tga")
    self.outerSize = 128--132
    self.size = 128
    self.spacing = (self.outerSize - self.size) / 2
    self.textHeight = 40
    self.textSpacing = 5
    self.textFont = textFont or Turbine.UI.Lotro.Font.VerdanaBold16
    self.timerFont = timerFont or Turbine.UI.Lotro.Font.FixedSys15
    self.clockwise = clockwise
    self.showTimer = showTimer
    self.textFunction = StringifyDuration

    --self:SetPosition(900, 500)
    self:SetSize(self.outerSize, self.outerSize + self.textHeight + self.textSpacing)
    --self:SetBackColor(Turbine.UI.Color(0,0,0))
    self:SetVisible(false)
    self:SetMouseVisible(false)

    self.ring = Turbine.UI.Window()
    self.ring:SetParent(self)
    self.ring:SetVisible(true)
    self.ring:SetMouseVisible(false)
    self.ring:SetSize(self.outerSize, self.outerSize)
    self.ring:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ring:SetBackColor(self.ringColour)
    self.ring:SetOpacity(self.backgroundRingOpacity)
    self.ring:SetBackground(self.fullTexture)
    if self.scale ~= 1 then
        self.ring:SetStretchMode(1)
        self.ring:SetSize(self.outerSize * self.scale, self.outerSize * self.scale)
    end

    self.ringCovera = Turbine.UI.Window()
    self.ringCovera:SetParent(self)
    self.ringCovera:SetVisible(not(self.clockwise))
    self.ringCovera:SetMouseVisible(false)
    self.ringCovera:SetSize(self.outerSize, self.outerSize)
    --self.ringCovera:SetBlendMode(4)
    self.ringCovera:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ringCovera:SetBackColor(self.ringColour)
    self.ringCovera:SetOpacity(self.backgroundRingOpacity)
    self.ringCovera:SetBackground(self.quarterFullTexture)
    if self.scale ~= 1 then
        self.ringCovera:SetStretchMode(1)
        self.ringCovera:SetSize(self.outerSize * self.scale, self.outerSize * self.scale)
    end

    self.ringRotation = Turbine.UI.Window()
    self.ringRotation:SetParent(self)
    self.ringRotation:SetVisible(true)
    self.ringRotation:SetMouseVisible(false)
    self.ringRotation:SetSize(self.size, self.size)
    self.ringRotation:SetPosition(self.spacing, self.spacing)
    --self.ringRotation:SetBlendMode(4)
    self.ringRotation:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ringRotation:SetBackColor(self.rotationColour)
    self.ringRotation:SetOpacity(self.rotationRingOpacity)
    self.ringRotation:SetBackground(self.quarterTexture)
    self.ringRotation:SetRotation({x=0, y=0, z=270})
    if self.scale ~= 1 then
        self.ringRotation:SetStretchMode(1)
        self.ringRotation:SetSize(self.size * self.scale, self.size * self.scale)
    end

    self.ringRotation2 = Turbine.UI.Window()
    self.ringRotation2:SetParent(self)
    self.ringRotation2:SetVisible(true)
    self.ringRotation2:SetMouseVisible(false)
    self.ringRotation2:SetSize(self.size, self.size)
    self.ringRotation2:SetPosition(self.spacing, self.spacing)
    --self.ringRotation2:SetBlendMode(4)
    self.ringRotation2:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ringRotation2:SetBackColor(self.rotationColour)
    self.ringRotation2:SetOpacity(self.rotationRingOpacity)
    self.ringRotation2:SetBackground(self.quarterTexture)
    self.ringRotation2:SetRotation({x=0, y=0, z=270})
    if self.scale ~= 1 then
        self.ringRotation2:SetStretchMode(1)
        self.ringRotation2:SetSize(self.size * self.scale, self.size * self.scale)
    end

    self.ringCover = Turbine.UI.Window()
    self.ringCover:SetParent(self)
    self.ringCover:SetVisible(not(self.clockwise))
    self.ringCover:SetMouseVisible(false)
    self.ringCover:SetSize(self.outerSize, self.outerSize)
    --self.ringCover:SetBlendMode(4)
    self.ringCover:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ringCover:SetBackColor(self.ringColour)
    self.ringCover:SetOpacity(self.backgroundRingOpacity)
    self.ringCover:SetBackground(self.quarterFullTexture)
    if self.scale ~= 1 then
        self.ringCover:SetStretchMode(1)
        self.ringCover:SetSize(self.outerSize * self.scale, self.outerSize * self.scale)
    end

    self.ring1 = Turbine.UI.Window()
    self.ring1:SetParent(self)
    self.ring1:SetVisible(self.clockwise)
    self.ring1:SetMouseVisible(false)
    self.ring1:SetSize(self.size, self.size)
    self.ring1:SetPosition(self.spacing, self.spacing)
    --self.ring1:SetBlendMode(4)
    self.ring1:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ring1:SetBackColor(self.rotationColour)
    self.ring1:SetOpacity(self.rotationRingOpacity)
    self.ring1:SetBackground(self.quarterTexture)
    if self.scale ~= 1 then
        self.ring1:SetStretchMode(1)
        self.ring1:SetSize(self.size * self.scale, self.size * self.scale)
    end

    self.ring1a = Turbine.UI.Window()
    self.ring1a:SetParent(self)
    self.ring1a:SetVisible(self.clockwise)
    self.ring1a:SetMouseVisible(false)
    self.ring1a:SetSize(self.size, self.size)
    self.ring1a:SetPosition(self.spacing, self.spacing)
    --self.ring1a:SetBlendMode(4)
    self.ring1a:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ring1a:SetBackColor(self.rotationColour)
    self.ring1a:SetOpacity(self.rotationRingOpacity)
    self.ring1a:SetBackground(self.quarterTexture)
    if self.scale ~= 1 then
        self.ring1a:SetStretchMode(1)
        self.ring1a:SetSize(self.size * self.scale, self.size * self.scale)
    end


    self.ring2 = Turbine.UI.Window()
    self.ring2:SetParent(self)
    self.ring2:SetVisible(self.clockwise)
    self.ring2:SetMouseVisible(false)
    self.ring2:SetSize(self.size, self.size)
    self.ring2:SetPosition(self.spacing, self.spacing)
    --self.ring2:SetBlendMode(4)
    self.ring2:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ring2:SetBackColor(self.rotationColour)
    self.ring2:SetOpacity(self.rotationRingOpacity)
    self.ring2:SetBackground(self.quarterTexture)
    if self.scale ~= 1 then
        self.ring2:SetStretchMode(1)
        self.ring2:SetSize(self.size * self.scale, self.size * self.scale)
    end

    self.ring2a = Turbine.UI.Window()
    self.ring2a:SetParent(self)
    self.ring2a:SetVisible(self.clockwise)
    self.ring2a:SetMouseVisible(false)
    self.ring2a:SetSize(self.size, self.size)
    self.ring2a:SetPosition(self.spacing, self.spacing)
    --self.ring2:SetBlendMode(4)
    self.ring2a:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ring2a:SetBackColor(self.rotationColour)
    self.ring2a:SetOpacity(self.rotationRingOpacity)
    self.ring2a:SetBackground(self.quarterTexture)
    if self.scale ~= 1 then
        self.ring2a:SetStretchMode(1)
        self.ring2a:SetSize(self.size * self.scale, self.size * self.scale)
    end
    

    self.ring3 = Turbine.UI.Window()
    self.ring3:SetParent(self)
    self.ring3:SetVisible(self.clockwise)
    self.ring3:SetMouseVisible(false)
    --self.ring3:SetStretchMode(1)
    self.ring3:SetSize(self.size, self.size)
    self.ring3:SetPosition(self.spacing, self.spacing)
    --self.ring3:SetBlendMode(4)
    self.ring3:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ring3:SetBackColor(self.rotationColour)
    self.ring3:SetOpacity(self.rotationRingOpacity)
    self.ring3:SetBackground(self.quarterTexture)
    if self.scale ~= 1 then
        self.ring3:SetStretchMode(1)
        self.ring3:SetSize(self.size * self.scale, self.size * self.scale)
    end

    self.ring3a = Turbine.UI.Window()
    self.ring3a:SetParent(self)
    self.ring3a:SetVisible(self.clockwise)
    self.ring3a:SetMouseVisible(false)
    --self.ring3:SetStretchMode(1)
    self.ring3a:SetSize(self.size, self.size)
    self.ring3a:SetPosition(self.spacing, self.spacing)
    --self.ring3:SetBlendMode(4)
    self.ring3a:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.ring3a:SetBackColor(self.rotationColour)
    self.ring3a:SetOpacity(self.rotationRingOpacity)
    self.ring3a:SetBackground(self.quarterTexture)
    if self.scale ~= 1 then
        self.ring3a:SetStretchMode(1)
        self.ring3a:SetSize(self.size * self.scale, self.size * self.scale)
    end

    if self.clockwise then
        self.rotationFunctions = {
            [270] = function()
                self.ring1:SetVisible(false)
                self.ring1a:SetVisible(false)
    
                self.ring2:SetVisible(false)
                self.ring2a:SetVisible(false)
    
                self.ring3:SetVisible(false)
                self.ring3a:SetVisible(false)
            end,
            [0] = function()
                self.ring1:SetVisible(false)
                self.ring1a:SetVisible(false)
            end,
            [90] = function()
                self.ring2:SetVisible(false)
                self.ring2:SetOpacity(self.rotationRingOpacity)
    
                self.ring2a:SetVisible(false)
                self.ring2a:SetOpacity(self.rotationRingOpacity)
            end,
            [180] = function()
                self.ring3:SetVisible(false)
                self.ring3:SetOpacity(self.rotationRingOpacity)
    
                self.ring3a:SetVisible(false)
                self.ring3a:SetOpacity(self.rotationRingOpacity)

                self.ringCover:SetVisible(true)
                self.ringCover:SetRotation({x=0, y=0, z=270})
                self.ringCover:SetOpacity(self.backgroundRingOpacity)
    
                self.ringCovera:SetVisible(true)
                self.ringCovera:SetRotation({x=0, y=0, z=270})
                self.ringCovera:SetOpacity(self.backgroundRingOpacity)
            end,
        }
    else
        self.rotationFunctions = {
            [270] = function()
                self.ring1:SetVisible(false)
                self.ring1a:SetVisible(false)
    
                self.ring2:SetVisible(false)
                self.ring2a:SetVisible(false)
    
                self.ring3:SetVisible(false)
                self.ring3a:SetVisible(false)
    
                self.ringCover:SetVisible(true)
                self.ringCover:SetRotation({x=0, y=0, z=270})
                self.ringCover:SetOpacity(self.backgroundRingOpacity)
    
                self.ringCovera:SetVisible(true)
                self.ringCovera:SetRotation({x=0, y=0, z=270})
                self.ringCovera:SetOpacity(self.backgroundRingOpacity)
            end,
            [0] = function()
                self.ring1:SetVisible(true)
                self.ring1a:SetVisible(true)
    
                self.ringCover:SetVisible(false)
                self.ringCovera:SetVisible(false)
            end,
            [90] = function()
                self.ring2:SetVisible(true)
                self.ring2:SetRotation({x=0, y=0, z=90})
                self.ring2:SetOpacity(self.rotationRingOpacity)
    
                self.ring2a:SetVisible(true)
                self.ring2a:SetRotation({x=0, y=0, z=90})
                self.ring2a:SetOpacity(self.rotationRingOpacity)
            end,
            [180] = function()
                self.ring3:SetVisible(true)
                self.ring3:SetRotation({x=0, y=0, z=180})
                self.ring3:SetOpacity(self.rotationRingOpacity)
    
                self.ring3a:SetVisible(true)
                self.ring3a:SetRotation({x=0, y=0, z=180})
                self.ring3a:SetOpacity(self.rotationRingOpacity)
            end,
        }

    end

    self.time = 0
    self.rotation = 269
    self.rotationStep = 0

    if self.clockwise then
        self.updateSteps = {[0] = 270, [1] = 180, [2] = 90, [3] = 0}
    else
        self.updateSteps = {[0] = 270, [1] = 0, [2] = 90, [3] = 180}
    end
    
    self.updateToken = 1
    self.lastUpdateRotation = 269

    self.ExecuteUpdate = function(delta)
        --self:SetStretchMode(0)
        --self:SetSize(self.outerSize, self.outerSize + self.textHeight + self.textSpacing)
        self.time = self.time - delta
        if self.time < 0 then
            if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
            self.updateCallback = nil
            self:SetVisible(false)
            if self.callbackFunction then
                self.callbackFunction()
            end
            return
        end
        if self.time < 5 then
            self.countdownLabel:SetText(self.textFunction(self.time, 1))
        else
            self.countdownLabel:SetText(self.textFunction(self.time))
        end
        if self.clockwise then
            self.rotation = (self.rotation - self.rotationStep * delta) % 360
        else
            self.rotation = (self.rotation + self.rotationStep * delta) % 360
        end
        if self.rotationFunctions[self.rotation] then
            self.rotationFunctions[self.rotation]()
        end
        if math.abs(self.lastUpdateRotation - self.rotation) > 90 then
            self.rotationFunctions[self.updateSteps[self.updateToken]]()
            self.lastUpdateRotation = self.rotation
            self.updateToken = (self.updateToken + 1) % 4
        end
        self.ringRotation:SetRotation({x=0, y=0, z=self.rotation})
        self.ringRotation2:SetRotation({x=0, y=0, z=self.rotation})
    end

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(self.outerSize * self.scale, self.textHeight  * self.scale)
    self.textLabel:SetPosition(0, self.outerSize * self.scale)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.textLabel:SetFont(self.textFont)
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetVisible(false)

    self.countdownLabel = Turbine.UI.Label()
    self.countdownLabel:SetParent(self)
    self.countdownLabel:SetSize(self.outerSize * self.scale, self.outerSize * self.scale)
    self.countdownLabel:SetPosition(0, 0)
    self.countdownLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.countdownLabel:SetFont(self.timerFont)
    self.countdownLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.countdownLabel:SetMouseVisible(false)
    self.countdownLabel:SetVisible(self.showTimer)

    
    --self:SetStretchMode(1)
    --self:SetSize(self.outerSize * 0.5, (self.outerSize + self.textHeight + self.textSpacing) * 0.5)

    --self:StartTimer(5, "Test")
end

function CircleTimer:StartTimer(time, text, callbackFunction)
    self.callbackFunction = callbackFunction
    self:SetVisible(true)
    self.time = time
    self.rotationStep = 360 / time
    self.updateToken = 1
    self.lastUpdateRotation = 270
    self.rotation = 270
    self.rotationFunctions[270]()
    if self.clockwise then
        self.ring1:SetVisible(true)
        self.ring1a:SetVisible(true)

        self.ring2:SetVisible(true)
        self.ring2:SetRotation({x=0, y=0, z=90})
        self.ring2:SetOpacity(self.rotationRingOpacity)

        self.ring2a:SetVisible(true)
        self.ring2a:SetRotation({x=0, y=0, z=90})
        self.ring2a:SetOpacity(self.rotationRingOpacity)
        self.ring3:SetVisible(true)
        self.ring3:SetRotation({x=0, y=0, z=180})
        self.ring3:SetOpacity(self.rotationRingOpacity)

        self.ring3a:SetVisible(true)
        self.ring3a:SetRotation({x=0, y=0, z=180})
        self.ring3a:SetOpacity(self.rotationRingOpacity)
    end
    if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end

    if text then
        self.textLabel:SetText(text)
        self.textLabel:SetVisible(true)
    else
        self.textLabel:SetVisible(false)
    end
end

function CircleTimer:Unload()
    if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
    self.updateCallback = nil
    self:SetVisible(false)
    
    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end

    self:SetParent(nil)
end

function CircleTimer:Clear()
    if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
    self.updateCallback = nil
    self:SetVisible(false)
end