MouseDecoy = class(Turbine.UI.Window)
function MouseDecoy:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(Turbine.UI.Display.GetWidth(), Turbine.UI.Display.GetHeight())
    self:SetVisible(true)

    local mousePosX, mousePosY = self:GetMousePosition()
    local selfPosX, selfPosY = self:GetPosition()

    self.MousePositionX = mousePosX + selfPosX
    self.MousePositionY = mousePosY + selfPosY

    self.endTime = Turbine.Engine.GetGameTime() + 10

    self.Update = function()
        if Turbine.Engine.GetGameTime() > self.endTime then
            self:Unload()
        end
    end

    self:SetWantsUpdates(true)

    self.mouses = {}

    for i = 1, 1000 do
        local mouse = Turbine.UI.Window()
        mouse:SetVisible(true)
        mouse:SetMouseVisible(false)
        mouse:SetPosition(math.random(0, Turbine.UI.Display.GetWidth()), math.random(0, Turbine.UI.Display.GetHeight()))
        mouse:SetSize(32, 32)
        mouse:SetBackground(BackgroundHandler:GetBackground(0x41007DC7))
        mouse.ChangePosition = function(sender, deltaX, deltaY)
            local X, Y = mouse:GetPosition()
            X = X + deltaX 
            Y = Y + deltaY

            if X < 0 then
                X = Turbine.UI.Display.GetWidth() - 1
            end

            if Y < 0 then
                Y = Turbine.UI.Display.GetHeight() - 1
            end

            X = X % Turbine.UI.Display.GetWidth()
            Y = Y % Turbine.UI.Display.GetHeight()

            mouse:SetPosition(X, Y)
        end

        self.mouses[i] = mouse
    end

    self.MouseMove = function(sender, args)

        local deltaX = args.X - self.MousePositionX
        local deltaY = args.Y - self.MousePositionY

        self.MousePositionX = args.X
        self.MousePositionY = args.Y

        for _, value in pairs(self.mouses) do
            value:ChangePosition(deltaX, deltaY)
        end
    end
end

function MouseDecoy:Unload()
    for _, value in pairs(self.mouses) do
        value:SetVisible(false)
        value:SetParent(nil)
    end

    self:SetVisible(false)

    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    self:SetParent(nil)
end

FlashBang = class(Turbine.UI.Window)
function FlashBang:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(Turbine.UI.Display.GetWidth(), Turbine.UI.Display.GetHeight() * 2)
    self:SetVisible(true)
    self:SetWantsUpdates(true)
    self:SetBackColor(Turbine.UI.Color(0.5, 0, 0, 0))
    self:SetMouseVisible(false)
    self:SetPosition(0, -Turbine.UI.Display.GetHeight() * 2)

    self.textLabelWindow = Turbine.UI.Window()
	self.textLabelWindow:SetSize(500, 40)
    self.textLabelWindow:SetVisible(true)
	self.textLabelWindow:SetPosition(Turbine.UI.Display.GetWidth() / 2 - 250, Turbine.UI.Display.GetHeight() / 2 - 20)

    self.label = Turbine.UI.Label()
	self.label:SetParent(self.textLabelWindow)
	self.label:SetSize(500, 40)
	self.label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.label:SetPosition(0, 0)
    self.label:SetText("Sunglass mode enabled")


    self.endTime = Turbine.Engine.GetGameTime() + 10

    self.Update = function()
        self:SetOpacity((self.endTime - Turbine.Engine.GetGameTime())/5)
        self.textLabelWindow:SetOpacity((self.endTime - Turbine.Engine.GetGameTime())/10)
        if self:GetTop() < 0 then
            self:SetTop(self:GetTop() + 3)
        end
        if Turbine.Engine.GetGameTime() > self.endTime then
            self:Unload()
        end
    end
end

function FlashBang:Unload()
    self:SetVisible(false)

    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    self.label:SetParent(nil)
    self.textLabelWindow:SetParent(nil)
    self:SetParent(nil)
end

Wink = class(Turbine.UI.Window)
function Wink:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    self:SetWantsUpdates(true)
    self:SetBackground("PrimePlugins/RaidTools/Images/Rolo.tga")
    self.width = 400
    self.height = 498
    self:SetSize(self.width, self.height)
    self.scale = 1
    self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - self:GetWidth() / 2, Turbine.UI.Display.GetHeight() / 2 - self:GetHeight() / 2)
    self:SetMouseVisible(false)


    self.endTime = Turbine.Engine.GetGameTime() + 7.15
    self.startTime = Turbine.Engine.GetGameTime()

    self.Update = function()
        self:SetStretchMode(nil)
        self:SetStretchMode(1)
        self.scale = 1 * (Turbine.Engine.GetGameTime() - self.startTime)/7.15
        self:SetSize(self.width * self.scale, self.height * self.scale)
        self:SetRotation({x=0, y=0, z=(Turbine.Engine.GetGameTime() - self.startTime) * 200})        
        if Turbine.Engine.GetGameTime() > self.endTime then
            self:Unload()
        end
    end
end

function Wink:Unload()
    self:SetVisible(false)

    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    self:SetParent(nil)
end

Peekaboo = class(Turbine.UI.Window)
function Peekaboo:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    self:SetWantsUpdates(true)
    self:SetBackground("PrimePlugins/RaidTools/Images/Rolo.tga")
    self.width = 400
    self.height = 498
    self:SetSize(self.width, self.height)
    self.scale = 1
    self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - self:GetWidth() / 2, Turbine.UI.Display.GetHeight())
    self:SetMouseVisible(false)


    self.endTime = Turbine.Engine.GetGameTime() + 3
    self.startTime = Turbine.Engine.GetGameTime()

    self.Update = function()
        if self:GetTop() > Turbine.UI.Display.GetHeight() - self.height/2 then
            self:SetTop(self:GetTop() - 0.25)
        end
        if Turbine.Engine.GetGameTime() > self.endTime then
            self:Unload()
        end
    end
end

function Peekaboo:Unload()
    self:SetVisible(false)

    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    self:SetParent(nil)
end

DriveBy = class(Turbine.UI.Window)
function DriveBy:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    self:SetWantsUpdates(true)
    self:SetBackground("PrimePlugins/RaidTools/Images/Rolo2.tga")
    self.width = 180
    self.height = 213
    self:SetSize(self.width, self.height)
    self.scale = 1
    self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - self:GetWidth() / 2, Turbine.UI.Display.GetHeight() / 2 - self:GetHeight() / 2)
    self:SetMouseVisible(false)


    self.endTime = Turbine.Engine.GetGameTime() + 7.15
    self.startTime = Turbine.Engine.GetGameTime()

    self.Update = function()
        self:SetStretchMode(nil)
        self:SetStretchMode(1)
        self.scale = 1 * (Turbine.Engine.GetGameTime() - self.startTime)/7.15
        self:SetSize(self.width * self.scale, self.height * self.scale)
        self:SetRotation({x=0, y=0, z=(Turbine.Engine.GetGameTime() - self.startTime) * 200})        
        if Turbine.Engine.GetGameTime() > self.endTime then
            self:Unload()
        end
    end
end

function DriveBy:Unload()
    self:SetVisible(false)

    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    self:SetParent(nil)
end

TrainBy = class(Turbine.UI.Window)
function TrainBy:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    self:SetWantsUpdates(true)
    self:SetBackground("PrimePlugins/RaidTools/Images/Train.tga")
    self.width = 1559
    self.height = 524
    self:SetSize(self.width, self.height)
    self:SetStretchMode(1)
    self.scale = Turbine.UI.Display.GetHeight()/524
    self:SetSize(self.width * self.scale, self.height * self.scale)
    self:SetPosition(Turbine.UI.Display.GetWidth(), 0)
    self:SetMouseVisible(false)


    self.endTime = Turbine.Engine.GetGameTime() + 15

    self.Update = function()
        self:SetLeft(self:GetLeft() - 3)
        if Turbine.Engine.GetGameTime() > self.endTime then
            self:Unload()
        end
    end
end

function TrainBy:Unload()
    self:SetVisible(false)

    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    self:SetParent(nil)
end

MakeItRain = class(Turbine.UI.Window)
function MakeItRain:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    self:SetWantsUpdates(true)
    self:SetSize(Turbine.UI.Display.GetWidth(), Turbine.UI.Display.GetHeight())
    self:SetPosition(0, 0)
    self:SetMouseVisible(false)


    self.endTime = Turbine.Engine.GetGameTime() + 10

    self.Update = function()
        if Turbine.Engine.GetGameTime() > self.endTime then
            self:Unload()
        end

        if Turbine.Engine.GetGameTime() < self.endTime - 3 then
            local face = Turbine.UI.Window()
            face:SetParent(self)
            face:SetVisible(true)
            face:SetMouseVisible(false)
            face:SetBackground(BackgroundHandler:GetBackground("PrimePlugins/RaidTools/Images/Rolo2.tga"))
            face:SetStretchMode(2)
            face:SetPosition(math.random(0, Turbine.UI.Display.GetWidth()), 0)
            face:SetWantsUpdates(true)
    
            face.Update = function(sender, args)
                face:SetTop(face:GetTop() + 5)
                if face:GetTop() < 0 then
                    face:SetParent(nil)
                end
            end
        end
    end
end

function MakeItRain:Unload()
    self:SetVisible(false)

    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    self:SetParent(nil)
end