function TextInput(width, text, currentValue, func)
    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 20)
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
    --valuebar:SetBackColor(GetRandomColour())

    valuebar.label = Turbine.UI.Label()
	valuebar.label:SetParent(valuebar)
	valuebar.label:SetSize(200, 20)
	valuebar.label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.label:SetPosition(0, 0)
    valuebar.label:SetText(text)

    valuebar.searchBar = Turbine.UI.Lotro.TextBox()
	valuebar.searchBar:SetParent(valuebar)
	valuebar.searchBar:SetSize(100, 20)
	valuebar.searchBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.searchBar:SetPosition(width - 120, 0)
    valuebar.searchBar:SetText(currentValue)

    valuebar.searchBar.TextChanged = function()
        func(tostring(valuebar.searchBar:GetText()))
    end

    return valuebar
end

function BoolInput(width, text, currentValue, func)
    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 30)
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
    --valuebar:SetBackColor(GetRandomColour())

    valuebar.checkBox = Turbine.UI.Lotro.CheckBox()
	valuebar.checkBox:SetParent(valuebar)
	valuebar.checkBox:SetSize(width - 150, 20)
	valuebar.checkBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.checkBox:SetPosition(5, 5)
    valuebar.checkBox:SetText(text)
    valuebar.checkBox:SetChecked(currentValue)

    valuebar.checkBox.CheckedChanged = function()
        func(valuebar.checkBox:IsChecked())
    end

    return valuebar
end

function FontInput(width, text, currentValue, func)

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 50)
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
    --valuebar:SetBackColor(GetRandomColour())

    valuebar.label = Turbine.UI.Label()
	valuebar.label:SetParent(valuebar)
	valuebar.label:SetSize(150, 40)
	valuebar.label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	valuebar.label:SetPosition(0, 0)
    valuebar.label:SetText(text)

    local menu = Turbine.UI.ContextMenu()
    local menuItems = menu:GetItems()

    local sortedKeys = {}
    for key, value in pairs(Turbine.UI.Lotro.Font) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )

    valuebar.Button = Turbine.UI.Lotro.Button()
    valuebar.Button:SetParent(valuebar)
    valuebar.Button:SetSize(140, 100)
    valuebar.Button:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    valuebar.Button:SetMouseVisible(false)
    valuebar.Button:SetPosition(5, 30)
    valuebar.Button:SetText(currentValue)

        
    for key, name in pairs(sortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            valuebar.Button:SetText(name)
            func(name)
        end
        
        menuItems:Add(menuItem)
    end

    valuebar.Button.Click = function()
        menu:ShowMenu()
    end

    return valuebar
end

function TextAlignmentInput(width, text, currentValue, func)

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 40)
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
    --valuebar:SetBackColor(GetRandomColour())

    valuebar.label = Turbine.UI.Label()
	valuebar.label:SetParent(valuebar)
	valuebar.label:SetSize(width, 20)
	valuebar.label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	valuebar.label:SetPosition(0, 0)
    valuebar.label:SetText(text)

    local menu = Turbine.UI.ContextMenu()
    local menuItems = menu:GetItems()

    local sortedKeys = {}
    for key, value in pairs(Turbine.UI.ContentAlignment) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )

    valuebar.Button = Turbine.UI.Lotro.Button()
    valuebar.Button:SetParent(valuebar)
    valuebar.Button:SetSize(width - 10, 100)
    valuebar.Button:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    valuebar.Button:SetMouseVisible(false)
    valuebar.Button:SetPosition(5, 20)
    valuebar.Button:SetText(currentValue)

        
    for key, name in pairs(sortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            valuebar.Button:SetText(name)
            func(name)
        end
        
        menuItems:Add(menuItem)
    end

    valuebar.Button.Click = function()
        menu:ShowMenu()
    end

    return valuebar
end

function InfoButton(parent, width, text, infoWindow)
    local SelectButton = Turbine.UI.Control()
	SelectButton:SetParent(parent)
	SelectButton:SetSize(16, 16)
    --SelectButton:SetBackColor(GetRandomColour())
    SelectButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SelectButton:SetBackground(BackgroundHandler:GetBackground(0x41168DAC))
	SelectButton:SetPosition(width - 16, 5)
    SelectButton.Text = text

    SelectButton.MouseEnter = function()
        infoWindow:View(SelectButton.Text)
    end

    SelectButton.MouseLeave = function()
        infoWindow:SetVisible(false)
    end
end

function ListBoxBorder(width)
    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 7)
    valuebar:SetMouseVisible(false)
    valuebar:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar:SetBackground(BackgroundHandler:GetBackground(0x4110CD4D))

    return valuebar
end

function SingleColourOptions(width, text, currentValue, func)
    local valuebar = Turbine.UI.TreeNode()
    --valuebar:SetParent(parent)
    valuebar:SetSize(width, 160)
    valuebar:SetMouseVisible(false)
    valuebar.name = text
   --valuebar:SetBackColor(GetRandomColour())

    valuebar.label = Turbine.UI.Label()
	valuebar.label:SetParent(valuebar)
	valuebar.label:SetSize(150, 40)
	valuebar.label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.label:SetPosition(0, 20)
    valuebar.label:SetText(text)

    valuebar.currentLabel = Turbine.UI.Label()
	valuebar.currentLabel:SetParent(valuebar)
	valuebar.currentLabel:SetSize(120, 20)
	valuebar.currentLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.currentLabel:SetPosition(0, 130)
    valuebar.currentLabel:SetText("Current Colour:")

    valuebar.Current = Turbine.UI.Control()
    valuebar.Current:SetParent(valuebar)
    valuebar.Current:SetSize(32, 32)
    valuebar.Current:SetMouseVisible(false)
    valuebar.Current:SetPosition(115, 126)
    valuebar.Current:SetBackColor(Turbine.UI.Color(currentValue[1], currentValue[2], currentValue[3], currentValue[4]))

    valuebar.newLabel = Turbine.UI.Label()
	valuebar.newLabel:SetParent(valuebar)
	valuebar.newLabel:SetSize(100, 20)
	valuebar.newLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.newLabel:SetPosition(155, 130)
    valuebar.newLabel:SetText("New Colour:")

    valuebar.Example = Turbine.UI.Control()
    valuebar.Example:SetParent(valuebar)
    valuebar.Example:SetSize(32, 32)
    valuebar.Example:SetMouseVisible(false)
    valuebar.Example:SetPosition(250, 126)
    valuebar.Example:SetBackColor(Turbine.UI.Color(currentValue[1], currentValue[2], currentValue[3], currentValue[4]))

    -- 1
    valuebar.scrollbar1 = Turbine.UI.Lotro.ScrollBar()
	valuebar.scrollbar1:SetParent(valuebar)
    valuebar.scrollbar1:SetValue(currentValue[1] * 100)
	valuebar.scrollbar1:SetSize(250, 10)
    valuebar.scrollbar1:SetOrientation(Turbine.UI.Orientation.Horizontal)
	valuebar.scrollbar1:SetPosition(150, 20)

    valuebar.scrollbar1label = Turbine.UI.Label()
	valuebar.scrollbar1label:SetParent(valuebar)
	valuebar.scrollbar1label:SetSize(150, 20)
	valuebar.scrollbar1label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.scrollbar1label:SetPosition(400, 15)
    valuebar.scrollbar1label:SetText("A: " .. tostring(currentValue[1]))

    -- 2
    valuebar.scrollbar2 = Turbine.UI.Lotro.ScrollBar()
	valuebar.scrollbar2:SetParent(valuebar)
	valuebar.scrollbar2:SetSize(250, 10)
    valuebar.scrollbar2:SetOrientation(Turbine.UI.Orientation.Horizontal)
	valuebar.scrollbar2:SetPosition(150, 40)
    valuebar.scrollbar2:SetValue(currentValue[2] * 100)

    valuebar.scrollbar2label = Turbine.UI.Label()
	valuebar.scrollbar2label:SetParent(valuebar)
	valuebar.scrollbar2label:SetSize(150, 20)
	valuebar.scrollbar2label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.scrollbar2label:SetPosition(400, 35)
    valuebar.scrollbar2label:SetText("R: " .. tostring(currentValue[2]))
    
    -- 3
    valuebar.scrollbar3 = Turbine.UI.Lotro.ScrollBar()
	valuebar.scrollbar3:SetParent(valuebar)
	valuebar.scrollbar3:SetSize(250, 10)
    valuebar.scrollbar3:SetOrientation(Turbine.UI.Orientation.Horizontal)
	valuebar.scrollbar3:SetPosition(150, 60)
    valuebar.scrollbar3:SetValue(currentValue[3] * 100)

    valuebar.scrollbar3label = Turbine.UI.Label()
	valuebar.scrollbar3label:SetParent(valuebar)
	valuebar.scrollbar3label:SetSize(150, 20)
	valuebar.scrollbar3label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	valuebar.scrollbar3label:SetPosition(400, 55)
    valuebar.scrollbar3label:SetText("G: " .. tostring(currentValue[3]))

    -- 4
    valuebar.scrollbar4 = Turbine.UI.Lotro.ScrollBar()
    valuebar.scrollbar4:SetParent(valuebar)
    valuebar.scrollbar4:SetSize(250, 10)
    valuebar.scrollbar4:SetOrientation(Turbine.UI.Orientation.Horizontal)
    valuebar.scrollbar4:SetPosition(150, 80)
    valuebar.scrollbar4:SetValue(currentValue[4] * 100)

    valuebar.scrollbar4label = Turbine.UI.Label()
    valuebar.scrollbar4label:SetParent(valuebar)
    valuebar.scrollbar4label:SetSize(150, 20)
    valuebar.scrollbar4label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.scrollbar4label:SetPosition(400, 75)
    valuebar.scrollbar4label:SetText("B: " .. tostring(currentValue[4]))

    valuebar.scrollbar1.ValueChanged = function()
        valuebar.scrollbar1label:SetText("A:  " .. valuebar.scrollbar1:GetValue() / 100)
        valuebar.Example:SetBackColor(Turbine.UI.Color(valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100))
    end

    valuebar.scrollbar2.ValueChanged = function()
        valuebar.scrollbar2label:SetText("R:  " .. valuebar.scrollbar2:GetValue() / 100)
        valuebar.Example:SetBackColor(Turbine.UI.Color(valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100))
    end

    valuebar.scrollbar3.ValueChanged = function()
        valuebar.scrollbar3label:SetText("G:  " .. valuebar.scrollbar3:GetValue() / 100)
        valuebar.Example:SetBackColor(Turbine.UI.Color(valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100))
    end


    valuebar.scrollbar4.ValueChanged = function()
        valuebar.scrollbar4label:SetText("B:  " .. valuebar.scrollbar4:GetValue() / 100)
        valuebar.Example:SetBackColor(Turbine.UI.Color(valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100))
    end

    valuebar.Button = Turbine.UI.Lotro.Button()
    valuebar.Button:SetParent(valuebar)
    valuebar.Button:SetSize(150, 100)
    valuebar.Button:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    valuebar.Button:SetMouseVisible(false)
    valuebar.Button:SetPosition(300, 130)
    valuebar.Button:SetText("Change colour")

    valuebar.Button.Click = function()
        valuebar.Current:SetBackColor(Turbine.UI.Color(valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100))
        func({valuebar.scrollbar1:GetValue() / 100, valuebar.scrollbar2:GetValue() / 100, valuebar.scrollbar3:GetValue() / 100, valuebar.scrollbar4:GetValue() / 100})
    end

    return valuebar
end

function ColourTupleToTurbineColour(tuple)
    if tuple then
        if type(tuple[1]) == "table" then
            local colourTable = {}
            for key, value in pairs(tuple) do
                if value then
                    colourTable[key] = Turbine.UI.Color(value[1], value[2], value[3], value[4])
                else
                    colourTable[key] = nil
                end
            end

            return colourTable
        else
            return Turbine.UI.Color(tuple[1], tuple[2], tuple[3], tuple[4])
        end
    else
        return Turbine.UI.Color(0,0,0,0)
    end
end

InfoWindow = class(Turbine.UI.Window)
function InfoWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(400, 100)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.TextBox = Turbine.UI.Label()
    self.TextBox:SetParent(self)
    self.TextBox:SetSize(200, 20)
    self.TextBox:SetPosition(3, 3)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    self.TextBox:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    --self.TextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TextBox:SetMouseVisible(false)
    self.TextBox:SetBackColor(Turbine.UI.Color(0.8, 0.125, 0.125, 0.125))
end

function InfoWindow:View(Text)
    self:SetVisible(true)
    local x, y = self:GetMousePosition()
    local oldX, oldY = self:GetPosition()
    self:SetPosition((x + oldX) - 200, y + oldY + 5)
    self:SetZOrder(1)
    self.TextBox:SetText(Text or "No info text available.")
    local length = Text and math.ceil(string.len(Text) / 70) + 1 or 1
    self:SetSize(400, length * 22)
    self.TextBox:SetSize(400 - 6, length * 22 - 6)
end

function GetNiceTreeNode(width, name, func)
    local SourceNode = Turbine.UI.TreeNode()
    SourceNode:SetSize(width - 10, 20 + 2)

    SourceNode.SourceLabel = Turbine.UI.Label()
    SourceNode.SourceLabel:SetParent(SourceNode)
    SourceNode.SourceLabel:SetPosition(1,1)
    SourceNode.SourceLabel:SetSize(width - 10- 2, 20)
    SourceNode.SourceLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.SourceLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    SourceNode.SourceLabel:SetMouseVisible(true)

    SourceNode.LefLabel = Turbine.UI.Label()
    SourceNode.LefLabel:SetParent(SourceNode)
    SourceNode.LefLabel:SetPosition(0, 0)
    SourceNode.LefLabel:SetSize(30, 20)
    SourceNode.LefLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
    SourceNode.LefLabel:SetMouseVisible(false)

    SourceNode.RigthLabel = Turbine.UI.Label()
    SourceNode.RigthLabel:SetParent(SourceNode)
    SourceNode.RigthLabel:SetPosition(width - 157, 0)
    SourceNode.RigthLabel:SetSize(147, 20)
    SourceNode.RigthLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
    SourceNode.RigthLabel:SetMouseVisible(false)

    SourceNode.MidLabel = Turbine.UI.Label()
    SourceNode.MidLabel:SetParent(SourceNode)
    SourceNode.MidLabel:SetPosition(30, 0)
    SourceNode.MidLabel:SetSize(width - 70, 20)
    SourceNode.MidLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D201))
    SourceNode.MidLabel:SetMouseVisible(false)

    SourceNode.textLabel = Turbine.UI.Label()
    SourceNode.textLabel:SetParent(SourceNode)
    SourceNode.textLabel:SetPosition(1,1)
    SourceNode.textLabel:SetSize(width - 10- 2, 20)
    SourceNode.textLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.textLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SourceNode.textLabel:SetMouseVisible(false)
    SourceNode.textLabel:SetText(name)

    SourceNode.SourceLabel.MouseEnter = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FB))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FB))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D202))
    end

    SourceNode.SourceLabel.MouseLeave = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D201))
    end

    SourceNode.SourceLabel.MouseDown = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FC))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FC))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D203))
    end

    SourceNode.SourceLabel.MouseUp = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D201))
    end

    SourceNode.SourceLabel.MouseClick = function()
        func()
    end

    return SourceNode
end