WindowOptionsPage = class(Turbine.UI.Control)
function WindowOptionsPage:Constructor(parent)
    local width = Settings.LOWidth
    local height = 550
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetSize(width,height)
    self:SetPosition(0, 0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local optionsHeight = 0
    local listboxHeight = height - 50

    self.listbox = Turbine.UI.ListBox()
    self.listbox:SetParent(self)
    self.listbox:SetSize(300, listboxHeight)
    self.listbox:SetPosition(0, 0)
    self.listbox:SetBackColor(Turbine.UI.Color.Gold)

    self.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    self.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.Scrollbar:SetParent(self)
    self.Scrollbar:SetPosition(300, 0)
    self.Scrollbar:SetSize(10, listboxHeight)
    self.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    self.listbox:SetVerticalScrollBar(self.Scrollbar)

    self.AddListboxItem = function(effectName)
        local listBoxItem = Turbine.UI.Control()
        listBoxItem:SetSize(300, 20)
        listBoxItem:SetBackColor(Turbine.UI.Color.Black)

        listBoxItem.innerBox = Turbine.UI.Control()
        listBoxItem.innerBox:SetParent(listBoxItem)
        listBoxItem.innerBox:SetSize(300 - 2, 20 - 2)
        listBoxItem.innerBox:SetPosition(1, 1)
        listBoxItem.innerBox:SetBackColor(Turbine.UI.Color.DarkSlateGray)

        listBoxItem.effectLabel = Turbine.UI.Label()
        listBoxItem.effectLabel:SetParent(listBoxItem.innerBox)
        listBoxItem.effectLabel:SetSize(300 - 2 - 50, 20 - 2)
        listBoxItem.effectLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
        listBoxItem.effectLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        listBoxItem.effectLabel:SetOutlineColor(Turbine.UI.Color.Black)
        listBoxItem.effectLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        listBoxItem.effectLabel:SetText(effectName)

        self.listbox:AddItem(listBoxItem)
    end

    local windows, handlers, tools = WindowsHandlerController:GetActiveTables()
    self.AddListboxItem("Windows")
    self.AddListboxItem("")
    for key, value in spairs(windows, function(t, a, b) return a < b end) do
        self.AddListboxItem(key)
    end

    self.AddListboxItem("")
    self.AddListboxItem("Handlers")
    self.AddListboxItem("")
    for key, value in spairs(handlers, function(t, a, b) return a < b end) do
        self.AddListboxItem(key)
    end

    self.AddListboxItem("")
    self.AddListboxItem("Tools")
    self.AddListboxItem("")
    for key, value in spairs(tools, function(t, a, b) return a < b end) do
        self.AddListboxItem(key)
    end
end