PlayerOptionsWindow = class(Turbine.UI.Control)
function PlayerOptionsWindow:Constructor(parent)
    local width = 750
    local height = 500
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(25 - 2, 15 - 2)
    SingleBackground:SetSize(700 + 4, 450 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(25, 15)
    SingleBackground:SetSize(700, 450)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    self.infoWindow = PrimePlugins.RaidTools.UI.InfoWindow()

    self.optionInfoText = {}

    self.frameSettings = FrameHandlerObject:GetSettings()

    self.numberTreeview = Turbine.UI.TreeView()
    self.numberTreeview:SetParent(SingleBackground)
    self.numberTreeview:SetPosition(0, 18)
    self.numberTreeview:SetSize(300, height - 50 - 18)
    self.numberTreeview:SetIndentationWidth(0)

    self.numberContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.numberContainerScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.numberContainerScrollbar:SetParent(SingleBackground)
    self.numberContainerScrollbar:SetPosition(300 - 10, 18)
    self.numberContainerScrollbar:SetSize(10, height - 50 - 18)
    self.numberTreeview:SetVerticalScrollBar(self.numberContainerScrollbar)

    self.numberTreeviewNodes = self.numberTreeview:GetNodes()

    for key, value in PrimePlugins.RaidTools.spairs(self.frameSettings, function(t, a, b) return a < b end) do
        if PrimePlugins.RaidTools.IsNumber(value) then
            local numberInput = PrimePlugins.RaidTools.UI.TextInput(290, key, value,function(text) 
                local number = tonumber(text)
                if number then
                    self.frameSettings[key] = number

                    FrameHandlerObject:Reload(self.frameSettings)
                end
            end)
            PrimePlugins.RaidTools.UI.InfoButton(numberInput, 290, self.optionInfoText[key], self.infoWindow)
            self.numberTreeviewNodes:Add(numberInput)
            self.numberTreeviewNodes:Add(PrimePlugins.RaidTools.UI.ListBoxBorder(290))
            
        end
    end

    self.borderNumberControl = Turbine.UI.Control()
	self.borderNumberControl:SetParent(SingleBackground)
	self.borderNumberControl:SetSize(3, height)
    self.borderNumberControl:SetBackColor(Turbine.UI.Color(0,0,0))
	self.borderNumberControl:SetPosition(300, 0)

    self.settingsTreeview = Turbine.UI.TreeView()
    self.settingsTreeview:SetParent(SingleBackground)
    self.settingsTreeview:SetPosition(300, 18)
    self.settingsTreeview:SetSize(250, height - 50 - 18)
    self.settingsTreeview:SetIndentationWidth(0)

    self.settingsContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.settingsContainerScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.settingsContainerScrollbar:SetParent(SingleBackground)
    self.settingsContainerScrollbar:SetPosition(550 - 10, 18)
    self.settingsContainerScrollbar:SetSize(10, height - 50 - 18)
    self.settingsTreeview:SetVerticalScrollBar(self.settingsContainerScrollbar)

    self.settingsTreeviewNodes = self.settingsTreeview:GetNodes()

    for key, value in PrimePlugins.RaidTools.spairs(self.frameSettings, function(t, a, b) return a < b end) do
        if value == true or value == false then
            local settingsInput = PrimePlugins.RaidTools.UI.BoolInput(width, key, value, (function(bool) 
                self.frameSettings[key] = bool
                
                FrameHandlerObject:Reload(self.frameSettings)
            end))
            PrimePlugins.RaidTools.UI.InfoButton(settingsInput, 240, self.optionInfoText[key], self.infoWindow)
            self.settingsTreeviewNodes:Add(settingsInput)
            self.settingsTreeviewNodes:Add(PrimePlugins.RaidTools.UI.ListBoxBorder(240))
            
        end
    end

    self.borderSettingsControl = Turbine.UI.Control()
	self.borderSettingsControl:SetParent(SingleBackground)
	self.borderSettingsControl:SetSize(3, height)
    self.borderSettingsControl:SetBackColor(Turbine.UI.Color(0,0,0))
	self.borderSettingsControl:SetPosition(550, 0)

    self.fontTreeview = Turbine.UI.TreeView()
    self.fontTreeview:SetParent(SingleBackground)
    self.fontTreeview:SetPosition(550, 18)
    self.fontTreeview:SetSize(150, height)
    self.fontTreeview:SetIndentationWidth(0)

    self.fontTreeviewNodes = self.fontTreeview:GetNodes()

    for key, value in PrimePlugins.RaidTools.spairs(self.frameSettings, function(t, a, b) return a < b end) do
        if string.find(key, "Alignment") then
            local settingsInput = PrimePlugins.RaidTools.UI.TextAlignmentInput(140, key, value, (function(bool) 
                self.frameSettings[key] = bool
                
                FrameHandlerObject:Reload(self.frameSettings)
            end))
            PrimePlugins.RaidTools.UI.InfoButton(settingsInput, 140, self.optionInfoText[key], self.infoWindow)
            self.fontTreeviewNodes:Add(settingsInput)
            self.fontTreeviewNodes:Add(PrimePlugins.RaidTools.UI.ListBoxBorder(140))
            
        end
    end

    for key, value in PrimePlugins.RaidTools.spairs(self.frameSettings, function(t, a, b) return a < b end) do
        if string.find(key, "Font") then
            local settingsInput = PrimePlugins.RaidTools.UI.FontInput(width, key, value, (function(bool) 
                self.frameSettings[key] = bool
                
                FrameHandlerObject:Reload(self.frameSettings)
            end))
            PrimePlugins.RaidTools.UI.InfoButton(settingsInput, 140, self.optionInfoText[key], self.infoWindow)
            self.fontTreeviewNodes:Add(settingsInput)
            self.fontTreeviewNodes:Add(PrimePlugins.RaidTools.UI.ListBoxBorder(140))
            
        end
    end
end

function GetBigPreset()
    local frameSettings = {}

    frameSettings.FrameX = 500
    frameSettings.FrameY = 500
    frameSettings.EffectVersion = 1
    frameSettings.ShowPowerNumbers = false
    frameSettings.ShowName = true
    frameSettings.OnlyShowCurrent = true

    frameSettings.ColourMode = 1

    -- Resource
    frameSettings.ResourceText = true

    -- Effects
    frameSettings.BuffTracking = true
    frameSettings.DebuffTracking = true
    frameSettings.IconScale = 1.33
    frameSettings.ShowCountdown = false

    frameSettings.DebuffBoxHeight = 160
    frameSettings.DebuffBoxX = 0
    frameSettings.DebuffBoxY = 0

    frameSettings.BuffBoxHeight =  246
    frameSettings.BuffBoxX = 0
    frameSettings.BuffBoxY = 242

    -- Healthbar
    frameSettings.ColourChanging = true
    frameSettings.VitalWidth = 254
    frameSettings.VitalHeight = 61

    frameSettings.HealthWidth = 254
    frameSettings.HealthHeight = 60

    frameSettings.HealthBorder = 2

    frameSettings.HealthY = 160

    frameSettings.HealthFont = "BookAntiquaBold19"
    frameSettings.HealthAlignment = "BottomCenter"
    frameSettings.HealthText = true
    frameSettings.HealthTextX = 0
    frameSettings.HealthTextY = 160

    -- Power Bar
    frameSettings.PowerWidth = 254
    frameSettings.PowerHeight = 24
    frameSettings.PowerX = 0
    frameSettings.PowerY = 218

    -- Resource
    frameSettings.ResourceEnabled = true
    frameSettings.ResourceHeight = 9
    frameSettings.ResourceX = 0
    frameSettings.ResourceY = 219
    frameSettings.ResourceWidth = 250


    -- Percentage
    frameSettings.PercentageShown = true

    -- Aura
    frameSettings.Aura = true

    -- Name Text
    frameSettings.NameFont = "BookAntiquaBold19"
    frameSettings.NameX = 0
    frameSettings.NameY = 160
    frameSettings.NameAlignment = "TopCenter"

    -- Colour
    frameSettings.UseBaseColour = false
    frameSettings.BackgroundOpacity = 0.5

    frameSettings.UseBackground = true

    -- Scale
    frameSettings.Scale = 1

    return frameSettings
end

function GetSlimPreset()
    local frameSettings = {}

    frameSettings.FrameX = 500
    frameSettings.FrameY = 500
    frameSettings.EffectVersion = 1
    frameSettings.ShowPowerNumbers = false
    frameSettings.ShowName = true
    frameSettings.OnlyShowCurrent = true

    frameSettings.ColourMode = 1

    -- Resource
    frameSettings.ResourceText = true

    -- Effects
    frameSettings.BuffTracking = true
    frameSettings.DebuffTracking = true
    frameSettings.IconScale = 1.33
    frameSettings.ShowCountdown = false
    frameSettings.DebuffBoxHeight = 160
    frameSettings.BuffBoxHeight =  221

    -- Healthbar
    frameSettings.ColourChanging = true
    frameSettings.VitalWidth = 254
    frameSettings.VitalHeight = 61

    frameSettings.HealthHeight = 50

    frameSettings.HealthBorder = 2

    frameSettings.HealthY = 160

    frameSettings.HealthFont = "BookAntiquaBold19"
    frameSettings.HealthAlignment = "BottomRight"
    frameSettings.HealthText = true

    -- Percentage
    frameSettings.PercentageShown = true

    -- Aura
    frameSettings.Aura = true

    -- Name Text
    frameSettings.NameFont = "BookAntiquaBold19"
    frameSettings.NameX = 0
    frameSettings.NameY = 0
    frameSettings.NameAlignment = "TopCenter"

    return frameSettings
end

function GetSlimSplitPreset()
    local frameSettings = {}

    frameSettings.FrameX = 500
    frameSettings.FrameY = 500
    frameSettings.EffectVersion = 1
    frameSettings.ShowPowerNumbers = false
    frameSettings.ShowName = true
    frameSettings.OnlyShowCurrent = true

    frameSettings.ColourMode = 1

    -- Resource
    frameSettings.ResourceText = true

    -- Effects
    frameSettings.BuffTracking = true
    frameSettings.DebuffTracking = true
    frameSettings.IconScale = 1.33
    frameSettings.ShowCountdown = false
    frameSettings.DebuffBoxHeight = 150
    frameSettings.DebuffBoxX = 0
    frameSettings.DebuffBoxY = 0

    frameSettings.BuffBoxHeight =  221
    frameSettings.BuffBoxX = 0
    frameSettings.BuffBoxY = 218

    frameSettings.EffectFont = "TrajanPro13"

    -- Healthbar
    frameSettings.ColourChanging = true

    frameSettings.VitalWidth = 254
    frameSettings.VitalHeight = 61

    frameSettings.HealthWidth = 254
    frameSettings.HealthHeight = 40

    frameSettings.HealthBorder = 2

    frameSettings.HealthY = 160

    frameSettings.HealthFont = "BookAntiquaBold19"
    frameSettings.HealthAlignment = "BottomRight"
    frameSettings.HealthText = true
    frameSettings.HealthTextX = -5
    frameSettings.HealthTextY = 177

    -- Powerbar
    frameSettings.PowerWidth = 124
    frameSettings.PowerHeight = 14
    frameSettings.PowerX = 0
    frameSettings.PowerY = 203

    -- Resource
    frameSettings.ResourceEnabled = true
    frameSettings.ResourceHeight = 9
    frameSettings.ResourceX = 0
    frameSettings.ResourceY = 190
    frameSettings.ResourceWidth = 250

    -- Percentage
    frameSettings.PercentageShown = true

    -- Aura
    frameSettings.Aura = true

    -- Name Text
    frameSettings.NameFont = "BookAntiquaBold22"
    frameSettings.NameX = 3
    frameSettings.NameY = 145
    frameSettings.NameAlignment = "TopLeft"

    -- Colour
    frameSettings.UseBaseColour = false
    frameSettings.BackgroundOpacity = 0.5

    frameSettings.UseBackground = true

    -- Scale
    frameSettings.Scale = 1

    return frameSettings
end