ClassicWindow = class( Turbine.UI.Window)
function ClassicWindow:Constructor()
    Turbine.UI.Window.Constructor( self )
	
    --self.layout = Turbine.UI.HorizontalLayout.LeftToRight
    
    local width = 254
    local height = 160 + 160 + 86

    local vitalWidth = 250 + 4
    local vitalHeight = 80 + 4
	
	self:SetPosition( Settings.FrameX, Settings.FrameY )
    self:SetSize(273, 124)
    self:SetVisible(true)
    self:SetMouseVisible(false)
    --self:SetBackColorBlendMode(Turbine.UI.BlendMode.Multipl)
    --self:SetBackColor(Turbine.UI.Color(1,0,0))

    self.playerCallbacks = {}

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.ClassAttr = self.player:GetClassAttributes()
    self.ClassType = self.player:GetClass()
    self.effectList = self.player:GetEffects()
    self.attrCallbacks = {}
    self.effectCallbacks = {}

    self.debuffCount = 0

    
    if Settings.Aura then
        self.aura = Aura()
    end

    self.BuffBoxes = {}
    self.DebuffBoxes = {}

    self.IconScale = Settings.IconScale
    self.IconSize = 16 * self.IconScale
    self.IconRow = 8

    self.BuffResort = true
    self.DebuffResort = true

    self.oldGameTime = 0--Turbine.Engine.GetGameTime()

    self.barBackdrop = Turbine.UI.Control()
    self.barBackdrop:SetParent(self)
    self.barBackdrop:SetBackColor(Turbine.UI.Color( 0.5, 0, 0, 0 ))
    self.barBackdrop:SetSize(165, 30)
    self.barBackdrop:SetPosition(96, 43)

    self.tempBar = Turbine.UI.Control()
    self.tempBar:SetParent(self)
	self.tempBar:SetBackground("PrimePlugins/Vitals/Images/Bar.tga")
	self.tempBar:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
    self.tempBar:SetBackColor(Turbine.UI.Color( 1, 0.7, 0, 0.85 ))
    self.tempBar:SetSize(self.player:GetTemporaryMorale()/(self.player:GetMaxMorale()+self.player:GetTemporaryMorale()) * 165, 12)
    self.tempBar:SetPosition(96 + self.player:GetMorale()/(self.player:GetMaxMorale()+self.player:GetTemporaryMorale()) * 165, 43)
    
    self.moraleBar = Turbine.UI.Control()
    self.moraleBar:SetParent(self)
	self.moraleBar:SetBackground("PrimePlugins/Vitals/Images/Bar.tga")
	self.moraleBar:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
    self.moraleBar:SetBackColor(Turbine.UI.Color( 1, 0.1, 1, 0.1 ))
    self.moraleBar:SetSize(self.player:GetMorale()/(self.player:GetMaxMorale()+self.player:GetTemporaryMorale()) * 165, 12)
    self.moraleBar:SetPosition(96, 43)

    self.moraleText = Turbine.UI.Label()
    self.moraleText:SetParent(self)
    self.moraleText:SetSize(165, 12)
    self.moraleText:SetPosition(96, 43)
    self.moraleText:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.moraleText:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.moraleText:SetForeColor(Turbine.UI.Color(0.9, 0.9, 0.9))
    self.moraleText:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.moraleText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self:SetMoraleText()

    self.powerBar = Turbine.UI.Control()
    self.powerBar:SetParent(self)
	self.powerBar:SetBackground("PrimePlugins/Vitals/Images/Bar.tga")
	self.powerBar:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
    if self.ClassType == Turbine.Gameplay.Class.Beorning then
        self.powerBar:SetBackColor(Turbine.UI.Color( 1,  1, 0.4, 0 ))
    else
        self.powerBar:SetBackColor(Turbine.UI.Color( 1, 0.1, 0.5, 1 ))
    end
    self.powerBar:SetSize(self.player:GetPower()/self.player:GetMaxPower() * 165, 12)
    self.powerBar:SetPosition(96, 55)

    self.powerText = Turbine.UI.Label()
    self.powerText:SetParent(self)
    self.powerText:SetSize(165, 12)
    self.powerText:SetPosition(96, 55)
    self.powerText:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.powerText:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.powerText:SetForeColor(Turbine.UI.Color(0.9, 0.9, 0.9))
    self.powerText:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.powerText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self:SetPowerText()

    self.vitalBackground = Turbine.UI.Control()
    self.vitalBackground:SetParent(self)
    self.vitalBackground:SetSize(273, 124)
    self.vitalBackground:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.vitalBackground:SetBackground("PrimePlugins/Vitals/Images/Vitals/" .. Backgrounds[Settings.ClassicBackground])

    self.vitalCoverBackground = Turbine.UI.Control()
    self.vitalCoverBackground:SetParent(self)
    self.vitalCoverBackground:SetSize(69, 69)
    self.vitalCoverBackground:SetPosition(20, 19)
    self.vitalCoverBackground:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.vitalCoverBackground:SetBackground("PrimePlugins/Vitals/Images/Vitals/background.tga")

    self.vitalCover = Turbine.UI.Control()
    self.vitalCover:SetParent(self)
    self.vitalCover:SetSize(63, 63)
    self.vitalCover:SetPosition(23, 22)
    self.vitalCover:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.vitalCover:SetBackground("PrimePlugins/Vitals/Images/Vitals/" .. Covers[Settings.ClassicCover])

    self.levelLabel = Turbine.UI.Label()
    self.levelLabel:SetParent(self)
    self.levelLabel:SetSize(40, 20)
    self.levelLabel:SetPosition(32, 81)
    self.levelLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    self.levelLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.levelLabel:SetForeColor(Turbine.UI.Color(0.8, 0.8, 0.8))
    self.levelLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.levelLabel:SetMultiline(false)
    self.levelLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.levelLabel:SetText(self.player:GetLevel())

    self.nameLabel = Turbine.UI.Label()
    self.nameLabel:SetParent(self)
    self.nameLabel:SetSize(200, 20)
    self.nameLabel:SetPosition(95, 10)
    self.nameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
    self.nameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.nameLabel:SetForeColor(Turbine.UI.Color(200/255, 190/255, 121/255))
    self.nameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.nameLabel:SetMultiline(false)
    self.nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.nameLabel:SetText(self.player:GetName())

    self.rankIcon = Turbine.UI.Control()
    self.rankIcon:SetParent(self)
    self.rankIcon:SetSize(32, 32)
    self.rankIcon:SetPosition(0, 0)
    self.rankIcon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    if Settings.ClassicPVP ~= "None" then
        self.rankIcon:SetBackground("PrimePlugins/Vitals/Images/PvPIcons/" .. PvpIcons[Settings.ClassicPVP])
    end

    if Settings.Aura then
        self.playerCallbacks["MoraleChanged"] = AddCallback(self.player, "MoraleChanged", function(sender, args) 
            self.moraleBar:SetSize(sender:GetMorale()/sender:GetMaxMorale() * 165, 12) 
            self.aura:Adjust(sender:GetMorale() / sender:GetMaxMorale())
            self:SetMoraleText()
        end)
    else
        self.playerCallbacks["MoraleChanged"] = AddCallback(self.player, "MoraleChanged", function(sender, args) self:SetMoraleBar(); self:SetMoraleText(); end)
    end
    self.playerCallbacks["MaxMoraleChanged"] = AddCallback(self.player, "MaxMoraleChanged", function(sender, args) self:SetMoraleBar(); self:SetMoraleText();  end)
    self.playerCallbacks["TemporaryMoraleChanged"] = AddCallback(self.player, "TemporaryMoraleChanged", function(sender, args) self:SetTemporaryMoraleBar(); self:SetMoraleText() end)

    if self.ClassType == Turbine.Gameplay.Class.Beorning then
        
        self.attrCallbacks["WrathChanged"] = AddCallback(self.ClassAttr, "WrathChanged", function(sender, args) self.powerBar:SetCurrentValue( sender:GetWrath() ) end)

    else
        self.playerCallbacks["PowerChanged"] = AddCallback(self.player, "PowerChanged", function(sender, args) self.powerBar:SetSize(self.player:GetPower()/self.player:GetMaxPower() * 165, 12); self:SetPowerText() end)
        self.playerCallbacks["MaxPowerChanged"] = AddCallback(self.player, "MaxPowerChanged", function(sender, args) self.powerBar:SetSize(self.player:GetPower()/self.player:GetMaxPower() * 165, 12); self:SetPowerText() end)
        self.playerCallbacks["BaseMaxPowerChanged"] = AddCallback(self.player, "BaseMaxPowerChanged", function(sender, args) self.powerBar:SetSize(self.player:GetPower()/self.player:GetMaxPower() * 165, 12); self:SetPowerText() end)
    end

    self.E = Turbine.UI.Lotro.EntityControl()
    self.E:SetParent (self)
    self.E:SetVisible (true)
    self.E:SetSize(300, 120)
    self.E:SetEntity(self.player)

    self.buffBox = Turbine.UI.Control()
    self.buffBox:SetParent(self)
    self.buffBox:SetSize(160, 20)
    self.buffBox:SetMouseVisible(false)	
    self.buffBox:SetPosition(92, 73)

    self.debuffBox = Turbine.UI.Control()
    self.debuffBox:SetParent(self)
    self.debuffBox:SetSize(160, 20)
    self.debuffBox:SetMouseVisible(false)
    self.debuffBox:SetPosition(92, 73)

    self.effectCallbacks["EffectRemoved"] = AddCallback(self.effectList, "EffectRemoved", function(sender, args)
        if args.Effect then 
            local ID = args.Effect:GetID()
            if self.BuffBoxes[ID] then 
                self.BuffBoxes[ID]:SetVisible(false) 
                self.BuffBoxes[ID]:SetParent(nil) 
                self.BuffBoxes[ID] = nil
                self.BuffResort = true
            end
            if self.DebuffBoxes[ID] then 
                self.DebuffBoxes[ID]:SetVisible(false)
                self.DebuffBoxes[ID]:SetParent(nil)  
                self.DebuffBoxes[ID] = nil
                self.DebuffResort = true
            end
        end
    end)

    self.effectCallbacks["EffectAdded"] = AddCallback(self.effectList, "EffectAdded", function(sender, args)
        local effect = sender:Get(args.Index)
        if effect:IsDebuff() then
            self.DebuffBoxes[effect:GetID()] = EffectBox(self.debuffBox, effect, self.IconSize, self.UpdateCountdown)
            self.DebuffResort = true
        elseif not(effect:IsDebuff()) then
            self.BuffBoxes[effect:GetID()] = EffectBox(self.buffBox, effect, self.IconSize, self.UpdateCountdown)
            self.BuffResort = true
        end
    end)

    for i = 1, self.effectList:GetCount(), 1 do
        local effect =  self.effectList:Get(i)

        if effect:IsDebuff() then
            self.DebuffBoxes[effect:GetID()] = EffectBox(self.debuffBox, effect, self.IconSize, self.UpdateCountdown)
            self.debuffCount = self.debuffCount + 1
        elseif not(effect:IsDebuff()) then
            self.BuffBoxes[effect:GetID()] = EffectBox(self.buffBox, effect, self.IconSize, self.UpdateCountdown)
        end
    end 

    self.Update = function()
        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == self.oldGameTime then
            return(true)
        end
        local delta = currentGameTime - self.oldGameTime

        for key, value in pairs(self.DebuffBoxes) do
            value:UpdateText(delta)
        end

        for key, value in pairs(self.BuffBoxes) do
            value:UpdateText(delta)
        end

        if self.BuffResort or self.DebuffResort then self.ResortList() end

        self.oldGameTime = currentGameTime
    end

    self.TimerCompare = function(t, a, b)
        if t[b]:GetValue() == t[a]:GetValue() then
            if  t[b]:GetApplicationTime() == t[a]:GetApplicationTime() then
                return t[b]:GetName() > t[a]:GetName()
            else
                return t[b]:GetApplicationTime() > t[a]:GetApplicationTime()
            end
        else
            return t[b]:GetValue() < t[a]:GetValue()
        end
    end

    self.ResortList = function()
        local buffCounter = 0
        local debuffCounter = 0
        if self.DebuffResort then
            local debuffCounter = 0
            for _,v in spairs(self.DebuffBoxes, self.TimerCompare) do
                v:SetPosition((debuffCounter % self.IconRow) * self.IconSize,  math.floor(debuffCounter / self.IconRow) * self.IconSize) 
                debuffCounter = debuffCounter + 1
            end
            self.debuffCount = debuffCounter
            self.debuffBox:SetHeight(math.ceil(debuffCounter /self.IconRow) * 20)
            self.DebuffResort = false
        end

        if self.BuffResort then
            for _,v in spairs(self.BuffBoxes, self.TimerCompare) do
                v:SetPosition((buffCounter % self.IconRow) * self.IconSize, math.floor(buffCounter / self.IconRow) * self.IconSize)
                buffCounter = buffCounter + 1
            end
            self.buffBox:SetHeight(math.ceil(buffCounter /self.IconRow) * 20)
            self.buffBox:SetTop(73 + math.ceil(self.debuffCount /self.IconRow) * 20)
            self.BuffResort = false
        end

    end

    self.moveBox = PrimePlugins.RaidTools.MoveBox(self, width, height, "Vital Frame")

    self:ResortList()
    self:SetWantsUpdates(true)
end

function ClassicWindow:RemoveCallbacks()
    for key, value in pairs(self.playerCallbacks) do
        RemoveCallback(self.player, key, value)
    end

    for key, value in pairs(self.effectCallbacks) do
        RemoveCallback(self.effectList, key, value)
    end

    for key, value in pairs(self.attrCallbacks) do
        RemoveCallback(self.ClassAttr, key, value)
    end
end

function ClassicWindow:SetMoraleText()
    if self.player:GetTemporaryMorale() > 0 then
        self.moraleText:SetText(self:SetComma(math.round(self.player:GetMorale())).."/".. self:SetComma(math.round(self.player:GetMaxMorale())) .. "(" .. self:SetComma(math.round(self.player:GetTemporaryMorale())) .. ")")
    else
        self.moraleText:SetText(self:SetComma(math.round(self.player:GetMorale())).."/".. self:SetComma(math.round(self.player:GetMaxMorale())))
    end
end

function ClassicWindow:SetPowerText()
    self.powerText:SetText(self:SetComma(math.round(self.player:GetPower())).."/"..self:SetComma(math.round(self.player:GetMaxPower())))
end

function ClassicWindow:SetMoraleBar()
    self.moraleBar:SetWidth(self.player:GetMorale()/(self.player:GetMaxMorale()+self.player:GetTemporaryMorale()) * 165)
end

function ClassicWindow:SetTemporaryMoraleBar()
    self:SetMoraleBar()
    self.tempBar:SetSize(self.player:GetTemporaryMorale()/(self.player:GetMaxMorale()+self.player:GetTemporaryMorale()) * 165, 12)
    self.tempBar:SetPosition(96 + self.player:GetMorale()/(self.player:GetMaxMorale()+self.player:GetTemporaryMorale()) * 165, 43)
end

function ClassicWindow:SetComma(number)
    local left,num,right = string.match(number,'^([^%d]*%d)(%d*)(.-)$')
	return left..(num:reverse():gsub('(%d%d%d)','%1,'):reverse())..right
end

function ClassicWindow:ToggleMove()
    self.moveBox:ToggleMove()
end

function ClassicWindow:Unload()
    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end

    self:SetParent(nil)
end