ClassColourOptionsWindow = class(Turbine.UI.Control)
function ClassColourOptionsWindow:Constructor(parent)
    local width = 750
    local height = 500
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    self.infoWindow = PrimePlugins.RaidTools.UI.InfoWindow()

    self.optionInfoText = {}

    self.ColourSettings = FrameHandlerObject:GetColourSettings()

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(25 - 2, 15 - 2)
    SingleBackground:SetSize(700 + 4, 450 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(25, 15)
    SingleBackground:SetSize(700, 450)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    self.classObjectToName = {
        [Turbine.Gameplay.Class.Burglar] = "Burglar",
        [Turbine.Gameplay.Class.Captain] = "Captain",
        [Turbine.Gameplay.Class.Champion] = "Champion",
        --[Turbine.Gameplay.Class.Corsair] = "Corsair",
        [Turbine.Gameplay.Class.Guardian] = "Guardian",
        [Turbine.Gameplay.Class.Hunter] = "Hunter",
        [Turbine.Gameplay.Class.LoreMaster] = "LoreMaster",
        [Turbine.Gameplay.Class.Minstrel] = "Minstrel",
        [Turbine.Gameplay.Class.RuneKeeper] = "RuneKeeper",
        [Turbine.Gameplay.Class.Warden] = "Warden",
        [Turbine.Gameplay.Class.Beorning] = "Beorning",
        [Turbine.Gameplay.Class.Brawler] = "Brawler",
        [Turbine.Gameplay.Class.BlackArrow] = "BlackArrow",
        [Turbine.Gameplay.Class.Defiler] = "Defiler",
        [Turbine.Gameplay.Class.Reaver] = "Reaver",
        [Turbine.Gameplay.Class.Stalker] = "Stalker",
        [Turbine.Gameplay.Class.WarLeader] = "WarLeader",
        [Turbine.Gameplay.Class.Weaver] = "Weaver",

        [Turbine.Gameplay.Class.Troll] = "Troll",
        [Turbine.Gameplay.Class.Ranger] = "Ranger",
        [Turbine.Gameplay.Class.Chicken] = "Chicken",
    } 

    self.classTreeview = Turbine.UI.TreeView()
    self.classTreeview:SetParent(SingleBackground)
    self.classTreeview:SetPosition(0, 18)
    self.classTreeview:SetSize(500, 430)
    self.classTreeview:SetIndentationWidth(0)

    self.classTreeviewScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.classTreeviewScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.classTreeviewScrollbar:SetParent(SingleBackground)
    self.classTreeviewScrollbar:SetPosition(500, 20)
    self.classTreeviewScrollbar:SetSize(10, 430)
    self.classTreeview:SetVerticalScrollBar(self.classTreeviewScrollbar)

    self.classTreeviewNodes = self.classTreeview:GetNodes()

    self.filtering = false

    self.filterFunction = function(object)
        if self.filtering then 
            return not(string.find(string.lower(object.name), string.lower(self.filterKey)))
        else
            return false
        end
    end

    self.sortFunction = function(object1, object2)
        if object1.name >= object2.name then 
            return 1
        else
            return -1
        end
    end

    for key, value in PrimePlugins.RaidTools.spairs(self.ColourSettings, function(t, a, b) return tostring(a) < tostring(b) end) do
        local numberInput = PrimePlugins.RaidTools.UI.SingleColourOptions(500, self.classObjectToName[key] or key, value,function(colour) 
            if colour then
                self.ColourSettings[key] = colour
                
                FrameHandlerObject:Reload(nil, self.ColourSettings)
            end
        end)
        PrimePlugins.RaidTools.UI.InfoButton(numberInput, 500, self.optionInfoText[key], self.infoWindow)
        self.classTreeviewNodes:Add(numberInput)
        self.classTreeviewNodes:Add(PrimePlugins.RaidTools.UI.ListBoxBorder(500))
    end
end

function GetColourPreset()
    return {
        [Turbine.Gameplay.Class.BlackArrow] = {[1] = 1, [2] = 102/255, [3] = 0, [4] = 0}, -- Turbine.UI.Color(102/255, 0, 0),
        [Turbine.Gameplay.Class.Beorning] = {[1] = 1, [2] = 255/255, [3] = 102/255, [4] = 0}, --Turbine.UI.Color(255/255, 102/255, 0/255), --Yellow
        [Turbine.Gameplay.Class.Brawler] = {[1] = 1, [2] = 0, [3] = 255/255, [4] = 152/255}, --Turbine.UI.Color(0, 255/255, 152/255), 
        [Turbine.Gameplay.Class.Burglar] = {[1] = 1, [2] = 255/255, [3] = 244/255, [4] = 104/255}, --Turbine.UI.Color(255/255, 244/255, 104/255), --Yellow
        [Turbine.Gameplay.Class.Captain] = {[1] = 1, [2] = 244/255, [3] = 140/255, [4] = 186/255}, --Turbine.UI.Color(244/255, 140/255, 186/255), --Pink
        [Turbine.Gameplay.Class.Champion] = {[1] = 1, [2] = 198/255, [3] = 155/255, [4] = 109/255}, --Turbine.UI.Color(198/255, 155/255, 109/255), --Brownrgb(204, 153, 102)
        --[Turbine.Gameplay.Class.Corsair] = {[1] = 1, [2] = 198/255, [3] = 155/255, [4] = 109/255}, --Turbine.UI.Color(198/255, 155/255, 109/255), --Brownrgb(204, 153, 102)
        [Turbine.Gameplay.Class.Chicken] = {[1] = 1, [2] = 102/255, [3] = 0, [4] = 0}, --Turbine.UI.Color(102/255, 0, 0),
        [Turbine.Gameplay.Class.Defiler] = {[1] = 1, [2] = 102/255, [3] = 0, [4] = 0}, --Turbine.UI.Color(102/255, 0, 0),
        [Turbine.Gameplay.Class.Guardian] = {[1] = 1, [2] = 100/255, [3] = 0, [4] = 0}, --Red
        [Turbine.Gameplay.Class.Hunter] = {[1] = 1, [2] = 170/255, [3] = 211/255, [4] = 114/255}, --Turbine.UI.Color(170/255, 211/255, 114/255), --{Turbine.UI.Color(51/255, 102/255, 0)
        [Turbine.Gameplay.Class.LoreMaster] = {[1] = 1, [2] = 135/255, [3] = 136/255, [4] = 238/255}, --Turbine.UI.Color(135/255, 136/255, 238/255), --Purple
        [Turbine.Gameplay.Class.Minstrel] = {[1] = 1, [2] = 0, [3] = 60/255, [4] = 200/255}, --Turbine.UI.Color(0, 60/255, 200/255), --Light green
        [Turbine.Gameplay.Class.Ranger] = {[1] = 1, [2] = 102/255, [3] = 0, [4] = 0},
        [Turbine.Gameplay.Class.Reaver] = {[1] = 1, [2] = 102/255, [3] = 0, [4] = 0},
        [Turbine.Gameplay.Class.RuneKeeper] = {[1] = 1, [2] = 63/255, [3] = 199/255, [4] = 235/255}, --Turbine.UI.Color(63/255, 199/255, 235/255), --Red--Turbine.UI.Color(0, 191/255, 1), --{Turbine.UI.Color(0, 115/255, 153/255),
        [Turbine.Gameplay.Class.Stalker] = {[1] = 1, [2] = 102/255, [3] = 0, [4] = 0},
        [Turbine.Gameplay.Class.Troll] = {[1] = 1, [2] = 102/255, [3] = 0, [4] = 0},
        [Turbine.Gameplay.Class.Warden] = {[1] = 1, [2] = 163/255, [3] = 48/255, [4] = 201/255}, --Turbine.UI.Color(163/255, 48/255, 201/255), --DH?
        [Turbine.Gameplay.Class.WarLeader] = {[1] = 1, [2] = 102/255, [3] = 0, [4] = 0},
        [Turbine.Gameplay.Class.Weaver] = {[1] = 1, [2] = 102/255, [3] = 0, [4] = 0}, --Turbine.UI.Color(102/255, 0, 0),
        ["Base"] = {[1] = 1, [2] = 0, [3] = 50/255, [4] = 1/255},
        ["Temporary Morale"] = {[1] = 1, [2] = 179/255, [3] = 0, [4] = 224/255},
        ["Power Background"] =  {[1] = 1, [2] = 0.1, [3] = 0.4, [4] = 0.4},
        ["Power"] =  {[1] = 1, [2] = 0.1, [3] = 0.1, [4] = 0.4}, 
        ["Wrath"] =  {[1] = 1, [2] = 100/255, [3] = 0, [4] = 0},
        ["Wrath Background"] = {[1] = 1, [2] = 40/255, [3] = 0, [4] = 0},
        ["Fervour Colour"] = {[1] = 1, [2] = 153/255, [3] = 0, [4] = 0},
        ["Mettle Colour"] = {[1] = 1, [2] = 153/255, [3] = 0, [4] = 0},
        ["Focus Colour"] = {[1] = 1, [2] = 153/255, [3] = 0, [4] = 0},
        ["Offensive Attunement Colour"] = {[1] = 1, [2] = 153/255, [3] = 0, [4] = 0},
        ["Defensive Attunement Colour"] = {[1] = 1, [2] = 0, [3] = 102/255, [4] = 0}, 
    }
end