EffectBox = class(Turbine.UI.Control)
function EffectBox:Constructor(parent, effect, size, text, font)
    Turbine.UI.Control.Constructor( self )
    self:SetSize(size, size)
    self:SetParent(parent)

    self.text = text

    self.name = effect:GetName()

    self.applicationTime = Turbine.Engine.GetGameTime()

    self.duration = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())

    self.iconLabel = Turbine.UI.Lotro.EffectDisplay()
    self.iconLabel:SetEffect(effect)
    self.iconLabel:SetParent(self)
    --self.iconLabel:SetPosition(1,1)
    self.iconLabel:SetSize(size, size)
    self.iconLabel:SetMouseVisible(false)
    self.iconLabel:SetVisible(true)

    self.CountDownLabel = Turbine.UI.Label()
    self.CountDownLabel:SetParent(self)
    self.CountDownLabel:SetSize(size, size)
    self.CountDownLabel:SetMouseVisible(false)
    self.CountDownLabel:SetVisible(true)
    self.CountDownLabel:SetStretchMode(1)
    self.CountDownLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.CountDownLabel:SetFont(font)
    self.CountDownLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.CountDownLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.CountDownLabel:SetMultiline(false)

    self.lastDuration = math.ceil(self.duration)
end

function EffectBox:UpdateText(delta)
    if self.duration > 999999 then return end
    self.duration = self.duration - delta

    if self.text then
        if self.lastDuration <= self.duration then return end

        self.lastDuration = math.floor(self.duration)

        self.CountDownLabel:SetStretchMode(nil)
        self.CountDownLabel:SetStretchMode(1)

        if self.duration > 3600 then
            self.CountDownLabel:SetText(math.floor(self.duration /3600) .. "h")
        elseif self.duration > 120 then
            self.CountDownLabel:SetText(math.floor(self.duration / 60) .. "m")
        elseif self.duration >= 0 then
            self.CountDownLabel:SetText(math.floor(self.duration))
        elseif self.duration < 0 then
            self.CountDownLabel:SetText("")
        end
    end
end

function EffectBox:GetValue()
    return self.duration
end

function EffectBox:GetName()
    return self.name
end

function EffectBox:GetApplicationTime()
    return self.applicationTime
end

function EffectBox:Unload()
    self:SetVisible(false)
    self:SetParent(nil)
end