Settings = LoadTable(Turbine.DataScope.Character, "PrimeVitalsSettings")

function GetDefaultSettings()
    Settings = {}

    Settings.Version = PluginVersion

    -- Vitals
    Settings.FrameX = 500
    Settings.FrameY = 500
    Settings.EffectVersion = 1
    Settings.ShowPowerNumbers = false
    Settings.ShowName = true
    Settings.OnlyShowCurrent = true
    Settings.IconScale = 1.33
    Settings.ShowCountdown = false
    Settings.ColourMode = 1
    Settings.Layout = 3
    Settings.Text = 1
    Settings.ResourceText = true
    Settings.BuffTracking = true
    Settings.DebuffTracking = true
    Settings.ColourChanging = true

    -- Target
    Settings.TargetEnabled = false
    Settings.TargetX = 1000
    Settings.TargetY = 500
    Settings.TargetBuffTracking = false
    Settings.BuffTracking = true
    Settings.DebuffTracking = true

    -- Classic
    Settings.ClassicEnabled = false
    Settings.ClassicOnlyShowCurrent = false
    Settings.ClassicPercentage = false
    Settings.ClassicPVP = "None"
    Settings.ClassicBackground = "Normal"
    Settings.ClassicCover = "Normal"

    -- Global
    Settings.NumberMethod = 2
    Settings.PercentageShown = true
    Settings.Aura = true

end

if Settings == nil or Settings.Reload == true then
    GetDefaultSettings()
end

function UpdateSettings()
    local tempSettings = Settings
    GetDefaultSettings()
    for key, value in pairs(tempSettings) do
        if Settings[key] ~=  nil then
            Settings[key] = value
        end
    end
    if plugin:GetVersion() ~= tempSettings.Version then
        Settings.FirstTime = true
    end
    Settings.Version = plugin:GetVersion()
end



function SaveData()
    Settings.FrameX, Settings.FrameY = Vital:GetPosition()

    if TargetVital then Settings.TargetX, Settings.TargetY = TargetVital:GetPosition() end

    SaveTable(Turbine.DataScope.Character, "PrimeVitalsSettings", Settings)
end

ClassColours = {
    [Turbine.Gameplay.Class.BlackArrow] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Beorning] = Turbine.UI.Color(77/255, 38/255, 0), --Yellow
    [Turbine.Gameplay.Class.Brawler] = Turbine.UI.Color(0, 255/255, 152/255), 
    [Turbine.Gameplay.Class.Burglar] = Turbine.UI.Color(255/255, 244/255, 104/255), --Yellow
    [Turbine.Gameplay.Class.Captain] = Turbine.UI.Color(244/255, 140/255, 186/255), --Pink
    [Turbine.Gameplay.Class.Champion] = Turbine.UI.Color(198/255, 155/255, 109/255), --Brownrgb(204, 153, 102)
    --[Turbine.Gameplay.Class.Corsair] = Turbine.UI.Color(198/255, 155/255, 109/255), --Brownrgb(204, 153, 102)
    [Turbine.Gameplay.Class.Chicken] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Defiler] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Guardian] = Turbine.UI.Color(100/255, 0/255, 0/255), --Red
    [Turbine.Gameplay.Class.Hunter] = Turbine.UI.Color(170/255, 211/255, 114/255), --{Turbine.UI.Color(51/255, 102/255, 0)
    [Turbine.Gameplay.Class.LoreMaster] = Turbine.UI.Color(135/255, 136/255, 238/255), --Purple
    [Turbine.Gameplay.Class.Minstrel] = Turbine.UI.Color(0, 60/255, 200/255), --Light green
    [Turbine.Gameplay.Class.Ranger] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Reaver] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.RuneKeeper] = Turbine.UI.Color(63/255, 199/255, 235/255), --Red--Turbine.UI.Color(0, 191/255, 1), --{Turbine.UI.Color(0, 115/255, 153/255),
    [Turbine.Gameplay.Class.Stalker] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Troll] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Warden] = Turbine.UI.Color(255/255, 102/255, 0/255), --Orange
    [Turbine.Gameplay.Class.WarLeader] = Turbine.UI.Color(102/255, 0, 0),
    [Turbine.Gameplay.Class.Weaver] = Turbine.UI.Color(102/255, 0, 0),
}

ClassColoursBackground = {
    [Turbine.Gameplay.Class.BlackArrow] = Turbine.UI.Color(0.5, 102/255, 0, 0),
    [Turbine.Gameplay.Class.Beorning] = Turbine.UI.Color(0.5, 77/255, 38/255, 0), --Yellow
    [Turbine.Gameplay.Class.Brawler] = Turbine.UI.Color(0.5, 0, 255/255, 152/255), 
    [Turbine.Gameplay.Class.Burglar] = Turbine.UI.Color(0.3, 255/255, 244/255, 104/255), --Yellow
    [Turbine.Gameplay.Class.Captain] = Turbine.UI.Color(0.5, 244/255, 140/255, 186/255), --Pink
    [Turbine.Gameplay.Class.Champion] = Turbine.UI.Color(0.5, 198/255, 155/255, 109/255), --Brownrgb(0.5, 204, 153, 102)
    --[Turbine.Gameplay.Class.Corsair] = Turbine.UI.Color(0.5, 198/255, 155/255, 109/255), --Brownrgb(0.5, 204, 153, 102)
    [Turbine.Gameplay.Class.Chicken] = Turbine.UI.Color(0.5, 102/255, 0, 0),
    [Turbine.Gameplay.Class.Defiler] = Turbine.UI.Color(0.5, 102/255, 0, 0),
    [Turbine.Gameplay.Class.Guardian] = Turbine.UI.Color(0.5, 100/255, 0/255, 0/255), --Red
    [Turbine.Gameplay.Class.Hunter] = Turbine.UI.Color(0.5, 170/255, 211/255, 114/255), --{Turbine.UI.Color(0.5, 51/255, 102/255, 0)
    [Turbine.Gameplay.Class.LoreMaster] = Turbine.UI.Color(0.5, 135/255, 136/255, 238/255), --Purple
    [Turbine.Gameplay.Class.Minstrel] = Turbine.UI.Color(0.5, 0, 60/255, 200/255), --Light green
    [Turbine.Gameplay.Class.Ranger] = Turbine.UI.Color(0.5, 102/255, 0, 0),
    [Turbine.Gameplay.Class.Reaver] = Turbine.UI.Color(0.5, 102/255, 0, 0),
    [Turbine.Gameplay.Class.RuneKeeper] = Turbine.UI.Color(0.5, 63/255, 199/255, 235/255), --Red--Turbine.UI.Color(0.5, 0, 191/255, 1), --{Turbine.UI.Color(0.5, 0, 115/255, 153/255),
    [Turbine.Gameplay.Class.Stalker] = Turbine.UI.Color(0.5, 102/255, 0, 0),
    [Turbine.Gameplay.Class.Troll] = Turbine.UI.Color(0.5, 102/255, 0, 0),
    [Turbine.Gameplay.Class.Warden] = Turbine.UI.Color(0.5, 255/255, 102/255, 0/255), --Orange
    [Turbine.Gameplay.Class.WarLeader] = Turbine.UI.Color(0.5, 102/255, 0, 0),
    [Turbine.Gameplay.Class.Weaver] = Turbine.UI.Color(0.5, 102/255, 0, 0),
}

PvpIcons = {
    ["R1"] = "icon_pvp_rank_1_32.tga",
    ["R2"] = "icon_pvp_rank_11_32.tga",
    ["R3"] = "icon_pvp_rank_111_32.tga",
    ["R4"] = "icon_pvp_rank_2_32.tga",
    ["R5"] = "icon_pvp_rank_22_32.tga",
    ["R6"] = "icon_pvp_rank_222_32.tga",
    ["R7"] = "icon_pvp_rank_3_32.tga",
    ["R8"] = "icon_pvp_rank_33_32.tga",
    ["R9"] = "icon_pvp_rank_333_32.tga",
    ["R10"] = "icon_pvp_rank_4_32.tga",
    ["R11"] = "icon_pvp_rank_44_32.tga",
    ["R12"] = "icon_pvp_rank_444_32.tga",
    ["R13"] = "icon_pvp_rank_5_32.tga",
    ["R14"] = "icon_pvp_rank_55_32.tga",
    ["R15"] = "icon_pvp_rank_555_32.tga",

    ["R1M"] = "icon_pvp_rank_1_monsterplayer_32.tga",
    ["R2M"] = "icon_pvp_rank_11_monsterplayer_32.tga",
    ["R3M"] = "icon_pvp_rank_111_monsterplayer_32.tga",
    ["R4M"] = "icon_pvp_rank_2_monsterplayer_32.tga",
    ["R5M"] = "icon_pvp_rank_22_monsterplayer_32.tga",
    ["R6M"] = "icon_pvp_rank_222_monsterplayer_32.tga",
    ["R7M"] = "icon_pvp_rank_3_monsterplayer_32.tga",
    ["R8M"] = "icon_pvp_rank_33_monsterplayer_32.tga",
    ["R9M"] = "icon_pvp_rank_333_monsterplayer_32.tga",
    ["R10M"] = "icon_pvp_rank_4_monsterplayer_32.tga",
    ["R11M"] = "icon_pvp_rank_44_monsterplayer_32.tga",
    ["R12M"] = "icon_pvp_rank_444_monsterplayer_32.tga",
    ["R13M"] = "icon_pvp_rank_5_monsterplayer_32.tga",
    ["R14M"] = "icon_pvp_rank_55_monsterplayer_32.tga",
    ["R15M"] = "icon_pvp_rank_555_monsterplayer_32.tga",

    ["None"] = "",
}

Backgrounds = {
    ["Normal"] = "player_vitals_backdrop.tga",
    
    ["Year 1"] = "player_vitals_backdrop_1_year.tga",
    ["Year 2"] = "player_vitals_backdrop_2_years.tga",
    ["Year 3"] = "player_vitals_backdrop_3_years.tga",
    ["Year 4"] = "player_vitals_backdrop_4_years.tga",
    ["Year 5"] = "player_vitals_backdrop_5_years.tga",
    ["Year 6"] = "player_vitals_backdrop_6_years.tga",
    ["Year 7"] = "player_vitals_backdrop_7_years.tga",
    ["Year 8"] = "player_vitals_backdrop_8_years.tga",
    ["Year 9"] = "player_vitals_backdrop_9_years.tga",
    ["Year 10"] = "player_vitals_backdrop_10_years.tga",
    ["Year 11"] = "player_vitals_backdrop_11_years.tga",
    ["Year 12"] = "player_vitals_backdrop_12_years.tga",

    ["Year 1M"] = "player_vitals_backdrop_1_year_mp.tga",
    ["Year 2M"] = "player_vitals_backdrop_2_years_mp.tga",
    ["Year 3M"] = "player_vitals_backdrop_3_years_mp.tga",
    ["Year 4M"] = "player_vitals_backdrop_4_years_mp.tga",
    ["Year 5M"] = "player_vitals_backdrop_5_years_mp.tga",
    ["Year 6M"] = "player_vitals_backdrop_6_years_mp.tga",
    ["Year 7M"] = "player_vitals_backdrop_7_years_mp.tga",
    ["Year 8M"] = "player_vitals_backdrop_8_years_mp.tga",
    ["Year 9M"] = "player_vitals_backdrop_9_years_mp.tga",
    ["Year 10M"] = "player_vitals_backdrop_10_years_mp.tga",
    ["Year 11M"] = "player_vitals_backdrop_11_years_mp.tga",
    ["Year 12M"] = "player_vitals_backdrop_12_years_mp.tga",

    ["Moria Dwarf"] = "player_vitals_backdrop_legendary_moria_dwarf.tga",
    ["Moria Elf"] = "player_vitals_backdrop_legendary_moria_elf.tga",

    ["Legendary 1"] = "player_vitals_backdrop_legendary_server_account.tga",
    ["Legendary 2"] = "player_vitals_backdrop_legendary_server_endgame.tga",
    ["Legendary 3"] = "player_vitals_backdrop_legendary_server_instance.tga",

    ["Mordor"] = "player_vitals_backdrop_mordor_10_years.tga",

    ["North Ithilien"] = "player_vitals_backdrop_northithilien_flora.tga",

    ["Rhosgobel"] = "player_vitals_backdrop_rhosgobel_animal.tga",

    ["VIP"] = "player_vitals_backdrop_VIP.tga",
    ["VIPM"] = "player_vitals_backdrop_VIP_mp.tga",

    ["Isengard"] = "player_vitals_legendary_isengard.tga",

    ["Dagorlad"] = "player_vitals_backdrop_dagorlad_flora.tga",

    ["Avenger"] = "opponent_vitals_backdrop_avenger_good_mp.tga",
    ["Elite Master"] = "opponent_vitals_backdrop_elitemaster_mp.tga",
    ["Hero"] = "opponent_vitals_backdrop_hero_good_mp.tga",
    ["Master Defender"] = "opponent_vitals_backdrop_master_defender_good_mp.tga",
    ["Signature"] = "opponent_vitals_backdrop_signature_good_mp.tga",

    ["Winter"] = "player_vitals_winter_festival.tga",
}

Covers = {
    ["Clown"] = "clown.tga",
    ["Rolo"] = "face.tga",
    ["Normal"] = "player_vitals_lowrescover.tga",
    ["Wink"] = "rolo.tga",
    ["Fuck Lotro"] = "fuck lotro.tga",
    ["Fuck Hunter"] = "fuck hunter.tga",
    ["Fellowship Manoeuvre"] = "cj.tga",
    ["KEKW"] = "risitas.tga",
    ["Sadge"] = "sadge.tga",
    ["Omegalul"] = "omegalul.tga",
    ["4Head"] = "4head.tga",
    ["PogChamp"] = "PogChamp.tga",
    ["Joy"] = "joy.tga",
    ["Sauron"] = "sauron.tga"

}

