TargetWindow = class( Turbine.UI.Window)
function TargetWindow:Constructor()
    Turbine.UI.Window.Constructor( self )
	
    --self.layout = Turbine.UI.HorizontalLayout.LeftToRight

    Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Target, false )

    local width = 254
    local height = 160 + 160 + 86

    local vitalWidth = 250 + 4
    local vitalHeight = 80 + 4
	
	self:SetPosition(Settings.TargetX, Settings.TargetY )
    self:SetSize( width, height)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    --self:SetBackColor(Turbine.UI.Color(0,0,0))

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.BuffBoxes = {}
    self.DebuffBoxes = {}
    self.EffectBoxes = {}

    self.UpdateDelay = 0.2

    self.playerTargeted = false

    self.targetCallbacks = {}
    self.playerCallbacks = {}
    self.playerTargetCallbacks = {}
    self.effectCallback = nil

    self.targetEffectsID = {}

    self.BuffTracking = Settings.TargetBuffTracking
    self.Buffs = Settings.BuffTracking
    self.Debuffs = Settings.DebuffTracking

    self.BuffResort = true
    self.DebuffResort = true

    self.textSettings = Settings.Text

    self.Layout = 3 --Settings.Layout

    self.IconScale = Settings.IconScale
    self.IconSize = 16 * self.IconScale

    self.debuffHeight = 180

    if self.Layout == 3 then self.debuffHeight = 150 elseif self.Layout == 2 then self.debuffHeight = 160 end
    self.IconRow = 0
    self.IconRowHeight = self.debuffHeight - self.IconSize

    self.EffectPosition = Settings.EffectVersion

    self.oldGameTime = Turbine.Engine.GetGameTime()

    self.targetTime = 0

    self.checkDelay = 1.0

    self.Target = nil

    local offset = 20

    if self.Layout > 1 then offset = 0 end

    --[[
	self.nameLabel = Turbine.UI.Label()
	self.nameLabel:SetParent( self )
	self.nameLabel:SetPosition( 60, 3 )
	self.nameLabel:SetSize( 160, 12 )
	self.nameLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
	self.nameLabel:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) )
	self.nameLabel:SetMouseVisible( false )
    --]]
    
	self.vitalsFrame = Turbine.UI.Control()
	self.vitalsFrame:SetParent( self )
	--self.vitalsFrame:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
	self.vitalsFrame:SetPosition( 2, 2 )
	self.vitalsFrame:SetSize( width, 86 );	
    self.vitalsFrame:SetMouseVisible( false );	
    self.vitalsFrame:SetPosition(0, offset + 160)
    --self.vitalsFrame:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125))

    self.E = Turbine.UI.Lotro.EntityControl()
    self.E:SetParent (self.vitalsFrame)
    self.E:SetVisible (true)
    if self.Layout == 1 then
        self.E:SetSize(width, 86)
    elseif self.Layout == 2 then 
        self.E:SetSize(width, 66)
    elseif self.Layout == 3 then
        self.E:SetSize(width, 66)
    end
	
	-- Construct the morale bar.
    local alignment = nil
    if self.textSettings == 1 then
        alignment = Turbine.UI.ContentAlignment.BottomCenter
    elseif self.textSettings == 2 then
        alignment = Turbine.UI.ContentAlignment.MiddleLeft        
    end

    if self.Layout == 1 then
        self.moraleBar = VitalBar(vitalWidth, vitalHeight - 20, true, alignment, nil, nil, colourChanging)
    elseif self.Layout == 2 then 
        self.moraleBar = VitalBar(vitalWidth, vitalHeight - 30, true, alignment, nil, nil, colourChanging)
    elseif self.Layout == 3 then
        self.moraleBar = VitalBar(vitalWidth, vitalHeight - 40, true, Turbine.UI.ContentAlignment.MiddleLeft, self, 190, colourChanging, true)
    end


	--self.moraleBar = VitalBar(vitalWidth, vitalHeight - 20, true)
    self.moraleBar:SetParent( self.vitalsFrame )
    --self.moraleBar:SetPosition(2, 2)
    local colour = nil
    local backgroundColor = nil
    if Settings.ColourMode == 1 or Settings.ColourMode == 2 then 
        colour = Turbine.UI.Color(150/255, 1/255, 1/255)
        backgroundColor = Turbine.UI.Color(0.6, 150/255, 1/255, 1/255)
    elseif Settings.ColourMode == 3 then
        colour = Turbine.UI.Color(0.8, 0,  0, 0)
        backgroundColor = Turbine.UI.Color(0.3, 0.08, 0.08, 0.08)
    end
    self.moraleBar:SetColours(backgroundColor, colour, Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
	--self.moraleBar:SetColor( Turbine.UI.Color( 1, 0.1, 1, 0.1 ) )
	--self.moraleBar:SetBuffColor( Turbine.UI.Color( 1, 0.3, 0.7, 1 ) )
	--self.moraleBar:SetDebuffColor( Turbine.UI.Color( 1, 1.0, 0.4, 0 ) )
	--self.moraleBar:SetPosition( 60, 19 )
	self.moraleBar:SetMouseVisible( false )
	--self.moraleBar:SetShowPercentage( true )
    --self.moraleBar:SetHorizontalLayout( Turbine.UI.HorizontalLayout.RightToLeft )
	
    --self.SetText( self.moraleBar, "This is a really bad thing to be doing. I'm passing the wrong type of control..." )

	
    -- Construct the power bar.
    if self.Layout == 1 then
        self.powerBar = VitalBar(vitalWidth, vitalHeight - 60, Settings.ShowPowerNumbers, Turbine.UI.ContentAlignment.MiddleCenter)
        self.powerBar:SetPosition( 0, 64 - 2 )
    elseif self.Layout == 2 then 
        self.powerBar = VitalBar(vitalWidth, vitalHeight - 70, false, nil)
        self.powerBar:SetPosition( 0, 49 - 2 )
    elseif self.Layout == 3 then
        self.powerBar = VitalBar(vitalWidth - 130, vitalHeight - 73, false, nil)
        self.powerBar:SetPosition( 130, 49 - 2 )
    end
	self.powerBar:SetParent( self.vitalsFrame )
    self.powerBar:SetZOrder( 100 )
    local powerBackground = Turbine.UI.Color(0.1, 0.4, 0.4)
    local powerColour = Turbine.UI.Color(0.1, 0.1, 0.4)

    if Settings.ColourMode == 3 then
        powerColour = Turbine.UI.Color(0.2, 0.2, 0.2)
        powerBackground = Turbine.UI.Color(0.25, 0.25, 0.25)
        self.powerBar:SetBackColor(Turbine.UI.Color(0.08, 0.08, 0.08))
    end
    self.powerBar:SetColours(powerBackground, powerColour, Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
	--self.powerBar:SetColor( Turbine.UI.Color( 1, 0.1, 0.5, 1 ) )
	--self.powerBar:SetPosition( 0, 64 - 2 )
    self.powerBar:SetMouseVisible( false )

    if Settings.ShowName then
        self.text = Turbine.UI.Label()
        self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1, 1 ) )
        self.text:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
        self.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
        self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold19 )
        if self.Layout == 1 then
            self.text:SetSize(vitalWidth, vitalHeight - 20)
        elseif self.Layout == 2 then
            self.text:SetSize(vitalWidth, vitalHeight - 30)
        elseif self.Layout == 3 then
            self.text:SetSize(width, 30)
            self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold22 )
        end

        self.text:SetZOrder( 100 )
        self.text:SetParent( self.moraleBar )

        if self.Layout == 3 then
            self.text:SetTextAlignment( Turbine.UI.ContentAlignment.TopRight )
            self.text:SetPosition(-5, 145)
            self.text:SetParent( self )
        elseif self.textSettings == 1 then
            self.text:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter )
        elseif self.textSettings == 2 then
            self.text:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight )
            self.text:SetPosition(-10, 0)
        end

        self.text:SetMouseVisible(false)
    end

    self.healthText = Turbine.UI.Label()
    self.healthText:SetParent(self)
    self.healthText:SetForeColor(Turbine.UI.Color(1, 1, 1, 1))
    self.healthText:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0))
    self.healthText:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.healthText:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    self.healthText:SetSize(width, 60)
    self.healthText:SetMouseVisible(false)
    self.healthText:SetTextAlignment(Turbine.UI.ContentAlignment.BottomLeft)
    self.healthText:SetPosition(3, offset + 160)
    self.healthText:SetZOrder(100)
    --self.healthText:SetText("DDDDDDDDDD")

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.Update = function()
         -- What is the time?
        local currentGameTime = Turbine.Engine.GetGameTime()

        -- Get time passed since last handled update
        local delta = currentGameTime - self.oldGameTime

        if delta < self.UpdateDelay then return end

        if not(self.informationGathered) and self.Target and self.Target.GetMorale and self.Target:GetMorale() > 0 then
            self:AddTargetInfo()

            if not(self.BuffTracking) then self:SetWantsUpdates(false) end
        end

        if self.BuffTracking then

            self:UpdateEffects()
            --if self.targetTime < Turbine.Engine.GetGameTime() then self:SetWantsUpdates(false) end

            for key, value in pairs(self.EffectBoxes) do
                self.EffectBoxes[key] = {value[1] - delta, value[2]}
                if value[1] < 0 then
                    if value[2] == 1 then
                        self.DebuffBoxes[key]:SetVisible(false)
                        self.DebuffBoxes[key]:SetParent(nil)
                        self.DebuffBoxes[key] = nil
                        self.DebuffResort = true
                    else
                        self.BuffBoxes[key]:SetVisible(false)
                        self.BuffBoxes[key]:SetParent(nil)
                        self.BuffBoxes[key] = nil
                        self.BuffResort = true
                    end
                    self.EffectBoxes[key] = nil
                end
            end
            if self.BuffResort or self.DebuffResort then self.ResortList() end
            self.oldGameTime = currentGameTime
        end
    end
    self:SetWantsUpdates(true)

    self.playerCallbacks["TargetChanged"] = AddCallback(self.player, "TargetChanged", 
    function(sender, args) 
        if self.Target then self:RemoveTargetCallbacks() end
        self:Clear()
        self.Target = self.player:GetTarget()
        --if self.Target then ChatOutput(self.Target:GetName()) end
        self:SetupBars()
        self.targetTime = Turbine.Engine.GetGameTime() + 5
        self.informationGathered = false
    end)

    self.Target = self.player:GetTarget()
    self:SetupBars()
    
    local effectPos = 0
    if self.Layout > 1 then effectPos = 22 end

    self.debuffEffectBox = Turbine.UI.Control()
    self.debuffEffectBox:SetParent( self )
    --self.debuffEffectBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
    self.debuffEffectBox:SetPosition( 2, 2 )
    self.debuffEffectBox:SetSize( width, 160 );	
    self.debuffEffectBox:SetMouseVisible( false );	
    self.debuffEffectBox:SetPosition(0, offset + 160 + 86 - effectPos)
    --self.debuffEffectBox:SetBackColor(Turbine.UI.Color(0,0,0))

    self.IconRow = math.floor(width / self.IconSize)

    self.buffEffectBox = Turbine.UI.Control()
	self.buffEffectBox:SetParent( self )
	--self.buffEffectBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
	self.buffEffectBox:SetPosition( 2, 2 )
	self.buffEffectBox:SetSize( width, 180 );	
    self.buffEffectBox:SetMouseVisible( false );	
    self.buffEffectBox:SetPosition(0, 0)
    --self.buffEffectBox:SetBackColor(Turbine.UI.Color(0,0,0))

    --self:SetWantsUpdates(true)

    
    self.ResortList = function()
        if self.BuffResort then
            local counter = 0
            for _,v in spairs(self.BuffBoxes, function(t,a,b) return t[b]:GetValue() < t[a]:GetValue() end) do
                v:SetPosition((counter % self.IconRow) * self.IconSize, self.IconRowHeight - math.floor(counter / self.IconRow) * self.IconSize) 
                counter = counter + 1
            end
            self.BuffResort = false
        end

        if self.DebuffResort then
            local counter = 0
            for _,v in spairs(self.DebuffBoxes, function(t,a,b) return t[b]:GetValue() > t[a]:GetValue() end) do
                v:SetPosition((counter % self.IconRow) * self.IconSize, math.floor(counter / self.IconRow) * self.IconSize)
                counter = counter + 1
            end
            self.DebuffResort = false
        end
    end

    self.moveBox = PrimePlugins.RaidTools.MoveBox(self, width, height, "Target Frame")
end

function TargetWindow:SetTargetCallbacks()
    if self.Target:GetName() == self.player:GetName() then
        --[[
        ChatOutput("Y") 
        self.playerTargetCallbacks["MoraleChanged"] = AddCallback(self.player, "MoraleChanged", function(sender, args) self.moraleBar:SetCurrentValue( sender:GetMorale() ) end)
        self.playerTargetCallbacks["MaxMoraleChanged"] = AddCallback(self.player, "MaxMoraleChanged", function(sender, args) self.moraleBar:SetMaxValue( sender:GetMaxMorale() ) end)
        self.playerTargetCallbacks["TemporaryMoraleChanged"] = AddCallback(self.player, "TemporaryMoraleChanged", function(sender, args) self.moraleBar:SetTempValue(sender:GetTemporaryMorale()) end)
        self.playerTargetCallbacks["PowerChanged"] = AddCallback(self.player, "PowerChanged", function(sender, args)self.powerBar:SetCurrentValue( sender:GetPower() ) end)
        self.playerTargetCallbacks["MaxPowerChanged"] = AddCallback(self.player, "MaxPowerChanged", function(sender, args) self.powerBar:SetMaxValue( sender:GetMaxPower() ) end)

        self.playerTargeted = true
        --]]
        self.Target = nil 
        collectgarbage()
        --ChatOutput("Cleaned")
        return 
    else
        self.targetCallbacks["MoraleChanged"] = AddCallback(self.Target, "MoraleChanged", function(sender, args) 
            self.moraleBar:SetCurrentValueImmediate(self.Target:GetMorale())
            self:CreateHealthString(self.Target:GetMorale(), self.Target:GetMaxMorale(), self.Target:GetTemporaryMorale()) 
        end)
        self.targetCallbacks["MaxMoraleChanged"] = AddCallback(self.Target, "MaxMoraleChanged", function(sender, args) 
            self.moraleBar:SetMaxValue(self.Target:GetMaxMorale())
            self:CreateHealthString(self.Target:GetMorale(), self.Target:GetMaxMorale(), self.Target:GetTemporaryMorale()) 
        end)
        self.targetCallbacks["TemporaryMoraleChanged"] = AddCallback(self.Target, "TemporaryMoraleChanged", function(sender, args) 
            self.moraleBar:SetTempValue(self.Target:GetTemporaryMorale())
            self:CreateHealthString(self.Target:GetMorale(), self.Target:GetMaxMorale(), self.Target:GetTemporaryMorale()) 
        end)
        self.targetCallbacks["PowerChanged"] = AddCallback(self.Target, "PowerChanged", function(sender, args)
            self.powerBar:SetCurrentValue(self.Target:GetPower())
        end)
        self.targetCallbacks["MaxPowerChanged"] = AddCallback(self.Target, "MaxPowerChanged", function(sender, args) 
            self.powerBar:SetMaxValue(self.Target:GetMaxPower())
        end)

        self:CreateHealthString(self.Target:GetMorale(), self.Target:GetMaxMorale(), self.Target:GetTemporaryMorale())
        self.moraleBar:SetCurrentValueImmediate(self.Target:GetMorale())
        self.moraleBar:SetMaxValue(self.Target:GetMaxMorale())
        self.moraleBar:SetTempValue(self.Target:GetTemporaryMorale()) 
        self.powerBar:SetCurrentValueImmediate(self.Target:GetPower()) 
        self.powerBar:SetMaxValue(self.Target:GetMaxPower()) 
        --[[
        if self.targetEffects then
            self.effectCallback = AddCallback(self.targetEffects, "EffectAdded", function(sender, args) self.Target:GetName() end)
        end
        --]]
        --self.playerTargeted = false
    end

    --ChatOutput("BB")
end

function TargetWindow:RemoveTargetCallbacks()
    for key, value in pairs(self.targetCallbacks) do
        RemoveCallback(self.Target, key, value)
    end

    --if self.effectCallback then  RemoveCallback(self.targetEffects, "EffectAdded", self.effectCallback) end

    self.playerTargeted = false
    collectgarbage()

end

function TargetWindow:AddTargetInfo()
    if self.Target.GetMorale and self.Target:GetMorale() > 0 and not(self.informationGathered) then
        --self.moraleBar:SetCurrentValueImmediate( 0)
        --self.moraleBar:SetMaxTempValue(self.Target:GetMaxTemporaryMorale())
        --self.powerBar:SetCurrentValueImmediate( 0 )

       -- if self.Target == self.player then ChatOutput("DDDDDDDDDDDDDD") end

        --self.moraleBar:SetTextVisible(true)
        --self.powerBar:SetTextVisible(true)

        if self.BuffTracking then self.targetEffects = self.Target:GetEffects() end

        self.moraleBar:SetMaxValue(1) 
        self.moraleBar:SetCurrentValueImmediate(1) 
        self.powerBar:SetCurrentValueImmediate(1) 
        self.powerBar:SetMaxValue(1)

        self:SetTargetCallbacks()

        self.informationGathered = true

        --ChatOutput("Setup Bars")
    else
        --self.moraleBar:SetTextVisible(false)
        --self.powerBar:SetTextVisible(false)
        self.moraleBar:SetMaxValue(1) 
        self.moraleBar:SetCurrentValueImmediate(1) 
        self.powerBar:SetCurrentValueImmediate(1) 
        self.powerBar:SetMaxValue(1)
    end
end

function TargetWindow:SetupBars()
    if self.Target then

        self.text:SetVisible(true)
        self.text:SetText(self.Target:GetName())
        --ChatOutput(self.Target:GetName())
        self:AddTargetInfo()
        self:SetWantsUpdates(true)
        self:SetVisible(true)
        self.E:SetEntity(self.Target)
        self.oldGameTime = Turbine.Engine.GetGameTime()
    else
        self:SetVisible(false)
        self:SetWantsUpdates(false)
    end
end

function TargetWindow:Clear()
    for key, value in pairs(self.BuffBoxes) do
        self.BuffBoxes[key]:SetVisible(nil)
        self.BuffBoxes[key]:SetParent(nil)
    end

    for key, value in pairs(self.DebuffBoxes) do
        self.DebuffBoxes[key]:SetVisible(nil)
        self.DebuffBoxes[key]:SetParent(nil)
    end

    self.Target = nil
    self.DebuffBoxes = {}
    self.targetEffectsID = {}
    self.BuffBoxes = {}
    self.EffectBoxes = {}
    self.E:SetEntity(nil)
    collectgarbage()

end

function TargetWindow:UpdateEffects()
    if self.targetEffects == nil then return end

    for i = 1, self.targetEffects:GetCount() do

        -- Filter already handled IDs
        local currentEffect = self.targetEffects:Get(i)
        local id = currentEffect:GetID()
        if true then --self.targetEffectsID[id] == nil then

            -- Only add id if not permanent effect
            --[[
            if currentEffect:GetDuration() < 999999 then 
                self.targetEffectsID[id] = true 
            else
                --]]
            if self.EffectBoxes[id] then
                self.EffectBoxes[id] = {self.checkDelay,  self.EffectBoxes[id][2]}
            else
                if currentEffect:IsDebuff() and self.Debuffs then
                    -- Check if we should add timer
                    if not(self.DebuffBoxes[id]) then
                        self.DebuffBoxes[id] = EffectBox(self.debuffEffectBox, currentEffect, self.IconSize)
                        self.EffectBoxes[id] = {self.checkDelay, 1}
                        self.DebuffResort = true
                    end

                else

                    -- Check if we should add timer
                    if not(self.BuffBoxes[id]) and self.Buffs then
                        self.BuffBoxes[id] = EffectBox(self.buffEffectBox, currentEffect, self.IconSize)
                        self.EffectBoxes[id] = {self.checkDelay, 2}
                        self.BuffResort = true
                    end
                    
                end
            end
        end
    end
end

function TargetWindow:ToggleMove()
    self.moveBox:ToggleMove()
end


function TargetWindow:CreateHealthString(current, max, temp) 
    if current == 0 and max == 0 and temp == 0 then return end

    local currentString = ""

    currentString = FormatBigNumber(math.floor( current + 0.5 ))


    local tempString = ""

    if temp > 0 then
        tempString = string.format(" (%s)", tostring(FormatBigNumber(math.ceil(temp))))
    end

    local percentageString = ""

    percentageString = " - " .. math.floor(current / max * 100) .. "%"

    self.healthText:SetText(string.format("%s%s%s", tostring(currentString), tostring(tempString), tostring(percentageString)))
end