VitalBar = class( Turbine.UI.Control )
function VitalBar:Constructor(width, height, showText, textAlignment, parent, y, colourChange, useTexture)
    Turbine.UI.Control.Constructor( self )
    
    self:SetSize(width, height)
    self:SetZOrder(100)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.8, 0, 0, 0))

    --self.MaxValue = 100
    --self.CurrentValue = 0
    self.TempValue = 0
    self.MaxTempValue = 0
    self.DreadValue = 0

    self.NumberMethod = Settings.NumberMethod
    self.PercentageShown = Settings.PercentageShown
    self.OnlyShowCurrent = Settings.OnlyShowCurrent
    self.showText = showText

    self.CurrentImmediate = 0
    self.CurrentValue = Turbine.Animation.LerpValue()
	self.MaxValue = 0--Turbine.Animation.LerpValue()
    self.baseMax = 0--Turbine.Animation.LerpValue()

    self.colourChange = colourChange
    self.backcolour = nil
    self.warningColour = Turbine.UI.Color(0.7, 0.1, 0.1)
    
    Background = "PrimePlugins/Vitals/Images/FittedSmooth.tga"

    --self:SetBackColor( Turbine.UI.Color( 1, 1, 0, 0 ) )
    --ChatOutput(width .. " " .. height)
    -- The background bar that contains all other bars
    self.TotalBar = Turbine.UI.Control()
    self.TotalBar:SetParent(self)
    --self.TotalBar:SetSize(256, 32)
    --self.TotalBar:SetStretchMode(1)
    self.TotalBar:SetPosition(2, 2)
    if useTexture then 
        self.TotalBar:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
        self.TotalBar:SetBackground(Background) 
    end
    self.TotalBar:SetSize(width - 4, height - 4)
    self.TotalBar:SetMouseVisible(false)

    -- The current value of the display
    self.CurrentBar = Turbine.UI.Control()
    self.CurrentBar:SetPosition(2, 2)
    
    self.CurrentBar:SetParent(self)
    if useTexture then 
        self.CurrentBar:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply)
        self.CurrentBar:SetBackground(Background) 
    end
    self.CurrentBar:SetSize(0, height - 4)
    self.CurrentBar:SetMouseVisible(false)

    -- Indicating morale loss/gain
    self.MoveBar = Turbine.UI.Control()
    --self.MoveBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.MoveBar:SetParent(self)
    self.MoveBar:SetSize(0, 0)
    self.MoveBar:SetMouseVisible(false)

    -- Bar to show temporary effects (bubbles)
    self.TemporaryBar = Turbine.UI.Control()
    self.TemporaryBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.TemporaryBar:SetParent(self)
    self.TemporaryBar:SetSize(0, height)
    self.TemporaryBar:SetMouseVisible(false)

	--self.horizontalLayout = Turbine.UI.HorizontalLayout.LeftToRight
	self.showPercentage = false

	self.lastUpdate = 0
end

function VitalBar:SetColours(BackColour, BarColour, TempColour)
    self.TotalBar:SetBackColor(BackColour)
    self.CurrentBar:SetBackColor(BarColour)
    self.backcolour = BarColour
    self.TemporaryBar:SetBackColor(TempColour)
end

function VitalBar:SetMaxValue(value)
    self.MaxValue = value
    self.CurrentValue:SetRate( self.MaxValue / self:GetWidth() * 200 )
end

function VitalBar:SetCurrentValue(value)
    self.CurrentValue:SetValue(value)

    if ( self.CurrentValue:NeedsUpdate() ) then
		self:SetWantsUpdates( true )
	end
end

function VitalBar:SetCurrentValueImmediate(value)
    self.CurrentValue:SetValueImmediate(value)

    --if ( self.CurrentValue:NeedsUpdate() ) then
		self:SetWantsUpdates( true )
	--end
end

function VitalBar:SetTempValue(value)
    self.TempValue = value
    self:AdjustBars()
end

function VitalBar:SetMaxTempValue(value)
    self.MaxTempValue = value
    --self:AdjustBars()
end

function VitalBar:GetMaxValue(value)
    return self.MaxValue
    --self:AdjustBars()
end

function VitalBar:SetDreadValue(value)
    self.DreadValue = value
end

function VitalBar:Update( args )
	local delta = 0
	local currentTime = Turbine.Engine.GetGameTime()

	if ( self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate
	end

	self.lastUpdate = currentTime

	self.CurrentValue:Update( delta )
	--self.MaxValue:Update( delta )
	--self.baseMax:Update( delta )

        --[[
	local current = math.floor( self.CurrentValue:GetValue() + 0.5 ) 
	local max = math.floor( self.MaxValue:GetValue() + 0.5 ) 
    local baseMax = math.floor( self.baseMax:GetValue() + 0.5 ) 
    
	if ( self.showPercentage ) then
		local percentage = math.floor( ( current / max * 100 ) + 0.5 )
		self.text:SetText( percentage .. "%" )
	else
		self.text:SetText( current .. "/" .. max )
    end
    

	self:PerformLayout()

    --]]
	if not(self.CurrentValue:NeedsUpdate()) then
		self:SetWantsUpdates( false )
		self.lastUpdate = 0
    end
    
    self:AdjustBars()
end

function VitalBar:AdjustBars()

    local value = self.CurrentValue:GetValue()
    local totalWidth, currentHeight = self.TotalBar:GetSize()
    local totalHealthValue = self.MaxValue + self.TempValue
    local currentWidth = value / totalHealthValue * totalWidth

    self.CurrentBar:SetWidth(math.ceil(currentWidth))

    if self.colourChange then
        local colourValue = 1 - value / self.MaxValue
        self.CurrentBar:SetBackColor(Turbine.UI.Color(
            self.backcolour.R + (self.warningColour.R - self.backcolour.R) * colourValue, 
            self.backcolour.G + (self.warningColour.G - self.backcolour.G) * colourValue, 
            self.backcolour.B + (self.warningColour.B - self.backcolour.B) * colourValue))
    end

    --self.CurrentBar:SetBackColor(Turbine.UI.Color(0.4 + 0.6 - 0.6 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.5, 0.1))
    --self.TotalBar:SetBackColor(Turbine.UI.Color(0.4 + 0.6 - 0.6 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.7 - 0.3 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.1))

    --if self.TempValue > 0 then 
        self.TemporaryBar:SetWidth(math.ceil(self.TempValue / totalHealthValue * totalWidth))
        self.TemporaryBar:SetPosition(2 + currentWidth, 0)
    --end
end
