FrameHandler = class()
function FrameHandler:Constructor()
    self.settings = LoadTable(Turbine.DataScope.Character, "PrimeVitalsFrameSettings") or GetSlimSplitPreset()
    self.colourSettings =  LoadTable(Turbine.DataScope.Character, "PrimeVitalsColourSettings") or GetColourPreset()
    self:Load()
end

function FrameHandler:Reload(newData, newColour)
    self:Unload()
    collectgarbage()
    if newData then
        self.settings = newData
    end
    if newColour then
        self.colourSettings = newColour
    end
    self:Load()
end

function FrameHandler:Unload()
    if Vital then
        Vital:Unload()
        Vital = nil
    end
end

function FrameHandler:Load()
    if Settings.ClassicEnabled then
        Vital = ClassicWindow()
    else
        Vital = VitalWindow(self.settings, self.colourSettings)
    end
end

function FrameHandler:GetSettings()
    return self.settings
end

function FrameHandler:GetColourSettings()
    return self.colourSettings
end

function FrameHandler:SaveData()
    self.settings.FrameX, self.settings.FrameY = Vital:GetPosition()
    SaveTable(Turbine.DataScope.Character, "PrimeVitalsFrameSettings", self.settings)
    SaveTable(Turbine.DataScope.Character, "PrimeVitalsColourSettings", self.colourSettings)
end